package com.urovo.wgmf.db.dao.dao;

import android.database.Cursor;

import com.urovo.wgmf.db.dao.entitys.BarcodeScanDb;
import com.urovo.wugumofang.system.BaseAppManager;

/**
 * 对数据库的增，删，改，查操作
 *
 * @author Administrator
 */
public class BarcodeScanDbOperate {

    public static String getFirstScanRule() {
//        "select ScanRule from barcode_scan Limit 1"
        String scanRule = "";
        Cursor cursor = null;
        String sql = "select ScanRule from barcode_scan Limit 1";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                scanRule = cursor.getString(cursor.getColumnIndex("ScanRule"));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取一条扫描条码列表规则发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return scanRule;

    }

    public static BarcodeScanDb getScanRuleInfo(String barcode) {
//        " select t1.Barcode,t1.ScanRule, t2.ItemName   from  barcode_scan t1, item001 t2 where t1.itemId=t2.itemId and t1.Barcode = '2290782'"
//        "select t1.Barcode,t1.ScanRule, t2.ItemName  from  barcode_scan t1 join item001 t2 on t1.itemId =t2.itemId  where t1.Barcode = '2290782'"
//        select b1.* ,b2.itemName as ItemName,b2.KCUom as KCUom,b2.normrprice as Price from barcode_scan b1 join item001 b2 on b1.itemId =b2.Itemid  where b1.barcode = ?
        Cursor cursor = null;
        BarcodeScanDb model = null;

//        String sql = "select t1.ScanRule,t1.barcodelens,t2.ITEMNAME from barcode_scan t1 join item001 t2 on t1.itemId = t2.itemId where t1.Barcode =?";
        String sql = "select t1.*,t2.ITEMNAME as ItemName,t2.KCUom as Unit,t2.normrprice as Price from barcode_scan t1 join item001 t2 on t1.itemId = t2.itemId where t1.Barcode = ?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{barcode});
            while (cursor.moveToNext()) {
                model = new BarcodeScanDb();
                model.setScanRule(cursor.getString(cursor.getColumnIndex("ScanRule")));
                model.setBarcodelens(cursor.getString(cursor.getColumnIndex("barcodelens")));
                model.setItemName(cursor.getString(cursor.getColumnIndex("ItemName")));
                model.setBarType(cursor.getString(cursor.getColumnIndex("BarType")));
                model.setItemId(cursor.getString(cursor.getColumnIndex("ItemId")));
                model.setUnit(cursor.getString(cursor.getColumnIndex("Unit")));
                model.setPrice(cursor.getString(cursor.getColumnIndex("Price")));
                return model;
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取扫描条码列表发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return model;
    }


    /**
     * 删除所有数据
     */
    public static Boolean deleteAll(String sql) {
        Boolean result = false;
        String sqlStr = "Delete from barcode_scan ";
        if(sql != null) {
            sqlStr += sql;
        }
        try {
            BaseAppManager.database().execSQL(sqlStr);
            result = true;
        }
        catch (Exception e) {
            BaseAppManager.loger().info("BarcodeScanDbOperate.deleteAll " + e);

            result = false;
        }
        finally {
        }
        return result;
    }

}
