package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.CanCheckRes;
import com.urovo.wgmf.db.dao.entitys.CanCheckRes3;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class CheckDetailDbOperate {

	private static DBTool dbTool;

	public CheckDetailDbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from CHECKDETAIL ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[CheckDetailDbOperate.deleteAllGoods]" + e);

			result = false;
		}
		finally {
		}
		return result;
	}

	/**
	 * 保存盘点单明细数据到本地数据库
	 *
	 * @param bill
	 * @param list
	 * @return
	 */
	public static boolean SavePanDianDetail(String bill,String remark,String url, List<CanCheckRes3.ResultInfo.DetailList> list) {
		String sql = "insert into CHECKDETAIL(" +
									"BILL,REMARK,URL,PRO_CODE,PRO_PRICE,PD_QTY,PD_AMOUNT,PD_BILLCODE," +
										"PRO_NAME,STOCK_QTY,DIFF_QTY,DIFF_AMOUNT,PRO_ID,LOCATION_ID," +
											"PD_ALTER_NUM,PD_ID,PRO_UNIT,PRO_UNIT_ID,STORE_ID,TYPE,PD_USER_NO," +
												"PD_STATUS) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		try {
			BaseAppManager.database().beginTransaction();
			for (CanCheckRes3.ResultInfo.DetailList p : list) {
				BaseAppManager.database().execSQL(sql, new Object[]{ bill,remark,url, p.getProCode(), p.getProPrice(), p.getPdQty(), p.getPdAmount(),p.getPdBillCode(),
						p.getProName(),p.getStockQty(),p.getDiffQty(),p.getDiffAmount(),p.getProId(),p.getLocationId(),
							p.getPdAlterNum(),p.getPdId(),p.getProUnit(),p.getProUnitId(),p.getStoreId(),p.getType(), p.getPdUserNo(),
								p.getPdStatus() });
			}
			BaseAppManager.database().setTransactionSuccessful();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存盘点单明细表发生异常:" + e);
			return false;
		}
		finally {
			BaseAppManager.database().endTransaction();
		}
		return true;
	}

	/**
	 * 根据盘点单据号获取产品明细
	 *
	 * @param bill
	 * @return
	 */
	public static List<CanCheckRes.Product> GetBillDetail(String bill) {
		Cursor cursor = null;
		List<CanCheckRes.Product> list = new ArrayList<>();
		String sql = "select BILL,REMARK,URL,PRO_CODE,PRO_PRICE,PD_QTY,PD_AMOUNT,PD_BILLCODE"+
				",PRO_NAME,STOCK_QTY,DIFF_QTY,DIFF_AMOUNT,PRO_ID,LOCATION_ID"+
					",PD_ALTER_NUM,PD_ID,PRO_UNIT,PRO_UNIT_ID,STORE_ID,TYPE,PD_USER_NO,PD_STATUS"+
						" from CHECKDETAIL "
							+ " where bill='" + bill + "'";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				CanCheckRes.Product ent = new CanCheckRes.Product();
				ent.setProCode(cursor.getString(cursor.getColumnIndex("PRO_CODE")));
				ent.setProPrice(cursor.getDouble(cursor.getColumnIndex("PRO_PRICE")));
				ent.setPdQty(cursor.getInt(cursor.getColumnIndex("PD_QTY")));
				ent.setPdAmount(cursor.getDouble(cursor.getColumnIndex("PD_AMOUNT")));
				ent.setPdBillCode(cursor.getString(cursor.getColumnIndex("PD_BILLCODE")));
				ent.setProName(cursor.getString(cursor.getColumnIndex("PRO_NAME")));
				ent.setStockQty(cursor.getInt(cursor.getColumnIndex("STOCK_QTY")));
				ent.setDiffQty(cursor.getInt(cursor.getColumnIndex("DIFF_QTY")));
				ent.setDiffAmount(cursor.getDouble(cursor.getColumnIndex("DIFF_AMOUNT")));
				ent.setProId(cursor.getInt(cursor.getColumnIndex("PRO_ID")));
				ent.setLocationId(cursor.getInt(cursor.getColumnIndex("LOCATION_ID")));
				ent.setPdAlterNum(cursor.getInt(cursor.getColumnIndex("PD_ALTER_NUM")));
				ent.setPdId(cursor.getInt(cursor.getColumnIndex("PD_ID")));
				ent.setProUnit(cursor.getString(cursor.getColumnIndex("PRO_UNIT")));
				ent.setProUnitId(cursor.getInt(cursor.getColumnIndex("PRO_UNIT_ID")));
				ent.setStoreId(cursor.getInt(cursor.getColumnIndex("STORE_ID")));
				ent.setType(cursor.getString(cursor.getColumnIndex("TYPE")));
				ent.setPdUserNo(cursor.getString(cursor.getColumnIndex("PD_USER_NO")));
				ent.setPdStatus(cursor.getString(cursor.getColumnIndex("PD_STATUS")));
				list.add(ent);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("根据门店订货单号获取产品明细发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}
}
