package com.urovo.wgmf.db.dao.dao;

import android.database.Cursor;

import com.urovo.wgmf.db.dao.entitys.ClassdaDb;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class ClassdaDbOperate {

	/**
	 * 插入数据
	 */
	public static Boolean insert(ClassdaDb classda) {
		Cursor cursor = null;
		try {
			String sql = "insert into classda(classID,classdp,classlv,locID,fatherID,comm) values(?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ classda.getClassID(), classda.getClassdp(), classda.getClasslv() + "", classda.getLocID(), classda.getFatherID(), classda.getComm() });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("ClassdaDbOperate.insert" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<ClassdaDb> selectBy(String sql) {
		List<ClassdaDb> list = new ArrayList<ClassdaDb>();
		Cursor cursor = null;
		String sqlStr = "select * from classda ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				ClassdaDb model = new ClassdaDb();
				model.setClassID(cursor.getString(cursor.getColumnIndex("classID")));
				model.setClassdp(cursor.getString(cursor.getColumnIndex("classdp")));
				model.setClasslv(cursor.getString(cursor.getColumnIndex("classlv")));
				model.setLocID(cursor.getString(cursor.getColumnIndex("locID")));
				model.setFatherID(cursor.getString(cursor.getColumnIndex("fatherID")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				if(model.getClassID() != null && model.getClassID().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("ClassdaDbOperate.selectBy" + e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from classda ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("ClassdaDbOperate.deleteAllGoods" + e);

			result = false;
		}
		finally {
		}
		return result;
	}
}
