package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.DeptcsdaDb;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class DeptcsdaDbOperate {

	private static DBTool dbTool;

	public DeptcsdaDbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(DeptcsdaDb deptscda) {
		Cursor cursor = null;
		try {
			String sql = "insert into deptcsda(deptcsID,deptcsdp,deptcslv,locID,fatherID,comm) values(?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ deptscda.getDeptcsID(), deptscda.getDeptcsdp(), deptscda.getDeptcslv(), deptscda.getLocID(), deptscda.getFatherID(), deptscda.getComm() });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[DeptcsdaDbOperate.Insert]" + e);

			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<DeptcsdaDb> selectBy(String sql) {
		List<DeptcsdaDb> list = new ArrayList<DeptcsdaDb>();
		Cursor cursor = null;
		String sqlStr = "select * from deptcsda ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				DeptcsdaDb model = new DeptcsdaDb();
				model.setDeptcsID(cursor.getString(cursor.getColumnIndex("DEPTCSID")));
				model.setDeptcsdp(cursor.getString(cursor.getColumnIndex("DEPTCSDP")));
				model.setDeptcslv(cursor.getString(cursor.getColumnIndex("DEPTCSLV")));
				model.setLocID(cursor.getString(cursor.getColumnIndex("LOCID")));
				model.setFatherID(cursor.getString(cursor.getColumnIndex("FATHERID")));
				model.setComm(cursor.getString(cursor.getColumnIndex("COMM")));
				if(model.getDeptcsID() != null && model.getDeptcsID().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[DeptcsdaDbOperate.selectBy]" + e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 根据id获取名称
	 */
	public static String getNameforId(String id) {

		try {
			String sql = "where deptcsId=" + "'" + id + "'";
			List<DeptcsdaDb> de = selectBy(sql);
			if(null != de && de.size() > 0)
				return de.get(0).getDeptcsdp();
			else
				return "";
		}
		catch (Exception e) {

			BaseAppManager.loger().info("DeptcsdaDbOperate+getNameforId" + e);
			return "";
		}
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from deptcsda ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[DeptcsdaDbOperate.deleteAllGoods]" + e);

			result = false;
		}
		finally {
		}
		return result;
	}
}
