package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.DingHuoEntity;
import com.urovo.wgmf.db.dao.entitys.Djbh001Db;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djbh001DbOperate {

	private static DBTool dbTool;

	public Djbh001DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public synchronized static void Insert(Djbh001Db djbh001) {
		try {
			String sql = "insert into djbh001(bill,storeID,stwhsID,psstoreID,udate,bhmode,bhtype,bhsys,status,oper_lr,lr_name,wdate,oper_sh,sh_name,bdate,comm,yn_tx,isup) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djbh001.getBill(), djbh001.getStoreID(), djbh001.getStwhsID(), djbh001.getPsstoreID(), djbh001.getUdate(), djbh001.getBhmode(), djbh001.getBhtype(), djbh001.getBhsys(), djbh001.getStatus(), djbh001.getOper_lr(), djbh001.getLr_name(),
					djbh001.getWdate(), djbh001.getOper_sh(), djbh001.getSh_name(), djbh001.getBdate(), djbh001.getComm(), djbh001.getYn_tx(), djbh001.getIsup() + "" });
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbh001DbOperate.Insert]" + e);
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djbh001Db> selectBy(String sql) {
		List<Djbh001Db> list = new ArrayList<Djbh001Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djbh001 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djbh001Db model = new Djbh001Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("BILL")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("STOREID")));
				model.setStwhsID(cursor.getString(cursor.getColumnIndex("STWHSID")));
				model.setPsstoreID(cursor.getString(cursor.getColumnIndex("PSSTOREID")));
				model.setUdate(cursor.getString(cursor.getColumnIndex("UDATE")));
				model.setBhmode(cursor.getString(cursor.getColumnIndex("BHMODE")));
				model.setBhtype(cursor.getString(cursor.getColumnIndex("BHTYPE")));
				model.setBhsys(cursor.getString(cursor.getColumnIndex("BHSYS")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("STATUS")));
				model.setOper_lr(cursor.getString(cursor.getColumnIndex("OPER_LR")));
				model.setLr_name(cursor.getString(cursor.getColumnIndex("LR_NAME")));
				model.setWdate(cursor.getString(cursor.getColumnIndex("WDATE")));
				model.setOper_sh(cursor.getString(cursor.getColumnIndex("OPER_SH")));
				model.setSh_name(cursor.getString(cursor.getColumnIndex("SH_NAME")));
				model.setBdate(cursor.getString(cursor.getColumnIndex("BDATE")));
				model.setComm(cursor.getString(cursor.getColumnIndex("COMM")));
				model.setYn_tx(cursor.getString(cursor.getColumnIndex("YN_TX")));
				model.setIsup(cursor.getInt(cursor.getColumnIndex("IsUp")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[Djbh001DbOperate.selectBy]" + e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djbh001 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbh001DbOperate.deleteAllGoods]" + e);

			result = false;
		}
		finally {
		}
		return result;
	}

	public static int GetUnUploadCount() {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from djbh001 where IsUp=0";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取未上传订货单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

	/**
	 * 获取未上传的门店订货单据主表
	 * 
	 * @return
	 */
	public static List<DingHuoEntity> GetUnUpload() {
		Cursor cursor = null;
		List<DingHuoEntity> list = new ArrayList<DingHuoEntity>();
		Date date = new Date();
		String sql = "select  BILL,STOREID,STWHSID,PSSTOREID,UDATE,BHMODE,BHTYPE,BHSYS,STATUS,OPER_LR,LR_NAME,WDATE,OPER_SH,SH_NAME,BDATE,COMM,YN_TX " + " from djbh001 where IsUp=0 limit 20";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				DingHuoEntity ent = new DingHuoEntity();
				ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
				ent.setPsStoreId(cursor.isNull(3) ? Store001DbOprate.GetGCID(SystemHelper.LoginOrganId) : cursor.getString(3));
				ent.setUDate(cursor.isNull(4) ? DateUtil.getDate(date) : cursor.getString(4));
				String oper_lr = cursor.isNull(9) ? SystemHelper.LoginUserId : cursor.getString(9);
				ent.setOper_Lr(TextUtils.isEmpty(oper_lr) ? SystemHelper.LoginUserId : oper_lr);
				String lr_name = cursor.isNull(10) ? SystemHelper.LoginUserName : cursor.getString(10);
				ent.setLr_Name(TextUtils.isEmpty(lr_name) ? SystemHelper.LoginUserName : lr_name);
				ent.setWDate(cursor.isNull(11) ? DateUtil.getDate(date) : cursor.getString(11));
				ent.setOper_Sh(ent.getOper_Lr());
				ent.setSh_Name(ent.getLr_Name());
				ent.setBDate(cursor.isNull(14) ? DateUtil.getDate(date) : cursor.getString(14));
				ent.setComm(cursor.isNull(15) ? "" : cursor.getString(15));
				list.add(ent);
			}

		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传门店订货单主表发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 获取未上传的门店订货单据主表
	 * 
	 * @return
	 */
	public static List<DingHuoEntity> GetAllUnUpload() {
		Cursor cursor = null;
		List<DingHuoEntity> list = new ArrayList<DingHuoEntity>();
		Date date = new Date();
		String sql = "select  BILL,STOREID,STWHSID,PSSTOREID,UDATE,BHMODE,BHTYPE,BHSYS,STATUS,OPER_LR,LR_NAME,WDATE,OPER_SH,SH_NAME,BDATE,COMM,YN_TX " + " from djbh001 where IsUp=0 ";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				DingHuoEntity ent = new DingHuoEntity();
				ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
				ent.setPsStoreId(cursor.isNull(3) ? Store001DbOprate.GetGCID(SystemHelper.LoginOrganId) : cursor.getString(3));
				ent.setUDate(cursor.isNull(4) ? DateUtil.getDate(date) : cursor.getString(4));
				String oper_lr = cursor.isNull(9) ? SystemHelper.LoginUserId : cursor.getString(9);
				ent.setOper_Lr(TextUtils.isEmpty(oper_lr) ? SystemHelper.LoginUserId : oper_lr);
				String lr_name = cursor.isNull(10) ? SystemHelper.LoginUserName : cursor.getString(10);
				ent.setLr_Name(TextUtils.isEmpty(lr_name) ? SystemHelper.LoginUserName : lr_name);
				ent.setWDate(cursor.isNull(11) ? DateUtil.getDate(date) : cursor.getString(11));
				ent.setOper_Sh(ent.getOper_Lr());
				ent.setSh_Name(ent.getLr_Name());
				ent.setBDate(cursor.isNull(14) ? DateUtil.getDate(date) : cursor.getString(14));
				ent.setComm(cursor.isNull(15) ? "" : cursor.getString(15));
				list.add(ent);
			}

		}
		catch (Exception e) {

			BaseAppManager.loger().info("获取未上传门店订货单主表发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}



	/**
	 * 保存订货单主表到本地数据库
	 */
	public static boolean SaveDingHuo(DingHuoEntity bll) {
		String sql = "insert into DJBH001(BILL,STOREID,STWHSID,PSSTOREID,UDATE,BHMODE,BHTYPE," + "BHSYS,STATUS,OPER_LR,LR_NAME,WDATE,OPER_SH,SH_NAME,BDATE,COMM,YN_TX,IsUp) " + " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) ";
		try {
			BaseAppManager.database().execSQL(
					sql,
					new Object[]{ bll.getBill(), bll.getStoreId(), bll.getSTWHSID(), bll.getPsStoreId(), bll.getUDate(), bll.getBHMode(), bll.getBHType(), bll.getBHSys(), bll.getStatus(), bll.getOper_Lr(), bll.getLr_Name(), bll.getWDate(), bll.getOper_Sh(), bll.getSh_Name(), bll.getBDate(),
							bll.getComm(), bll.getYN_TX(), 0 });
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存订货单主表发生异常:" + e);
			return false;
		}
		return true;
	}

	/**
	 * 更新上传信息
	 *
	 * @param bill
	 */
	public static void UpdateBillState(String bill) {
		String sqlCommand = "update djbh001 set IsUp=1 where bill=?";
		try {
			BaseAppManager.database().execSQL(sqlCommand, new String[]{ bill });
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("更新订货单据" + bill + "上传状态发生异常:" + ex);
		}
	}

	/**
	 * 获取今日某门店订货单据总数
	 * 
	 * @param bill
	 * @return
	 */
	public static int getStoreTodayOrderCount(String bill) {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from djbh001 where bill like'" + bill + "%'";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取今日某门店订货单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

}