package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djcj001Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djcj001DbOperate {

	private static DBTool dbTool;

	public Djcj001DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djcj001Db djcj001) {
		Cursor cursor = null;
		try {
			String sql = "insert into djcj001(bill,storeID,stwhsID,yngc,oper_lr,lr_name,wdate,status,comm,isup) values(?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djcj001.getBill(), djcj001.getStoreID(), djcj001.getStwhsID(), djcj001.getYngc(), djcj001.getOper_lr(), djcj001.getLr_name(), djcj001.getWdate(), djcj001.getStatus(), djcj001.getComm(), djcj001.getIsup() + "" });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbs001DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djcj001Db> selectBy(String sql) {
		List<Djcj001Db> list = new ArrayList<Djcj001Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djcj001 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djcj001Db model = new Djcj001Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setStwhsID(cursor.getString(cursor.getColumnIndex("stwhsID")));
				model.setYngc(cursor.getString(cursor.getColumnIndex("yngc")));
				model.setOper_lr(cursor.getString(cursor.getColumnIndex("oper_lr")));
				model.setLr_name(cursor.getString(cursor.getColumnIndex("lr_name")));
				model.setWdate(cursor.getString(cursor.getColumnIndex("wdate")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setIsup(cursor.getInt(cursor.getColumnIndex("isup")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[Djbs001DbOperate.selectBy]" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djcj001 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djbs001DbOperate.deleteAllGoods]" + e);
			result = false;
		}
		finally {
		}
		return result;
	}

	public static int GetUnUploadCount() {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from djcj001 where IsUp=0";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取未上传冲顶单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

	public static List<Djcj001Db> GetUnUpload() {
		String sql = "where IsUp=0";
		return selectBy(sql);
	}

	/**
	 * 更新冲顶加工
	 * 
	 * @param bill
	 */
	public static void UpdateBillState(String bill) {

		String sqlCommand = "update djcj001 set IsUp=1 where bill=?";
		try {
			BaseAppManager.database().execSQL(sqlCommand, new String[]{ bill });
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("更新考勤单据" + bill + "上传状态发生异常:" + ex);
		}

	}
}