package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djdbsh002Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djdbsh002DbOperate {

	private static DBTool dbTool;

	public Djdbsh002DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djdbsh002Db djdbsh002) {
		Cursor cursor = null;
		try {
			String sql = "insert into djdbsh002(bill,itemID,pack,unit,sqty,tqty,price,comm,seq_NO) values(?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djdbsh002.getBill(), djdbsh002.getItemID(), djdbsh002.getPack() + "", djdbsh002.getUnit() + "", djdbsh002.getSqty() + "", djdbsh002.getTqty() + "", djdbsh002.getPrice() + "", djdbsh002.getComm(), djdbsh002.getSeq_NO() + "", });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdbsh002DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djdbsh002Db> selectBy(String sql) {
		List<Djdbsh002Db> list = new ArrayList<Djdbsh002Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djdbsh002";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djdbsh002Db model = new Djdbsh002Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setPack(cursor.getInt(cursor.getColumnIndex("pack")));
				model.setUnit(cursor.getInt(cursor.getColumnIndex("unit")));
				model.setSqty(cursor.getInt(cursor.getColumnIndex("sqty")));
				model.setTqty(cursor.getInt(cursor.getColumnIndex("tqty")));
				model.setPrice(cursor.getInt(cursor.getColumnIndex("price")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setSeq_NO(cursor.getInt(cursor.getColumnIndex("seq_NO")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdbsh002DbOperate.selectBy]" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djdbsh002";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djdbsh002DbOperate.deleteAllGoods]" + e);
			result = false;
		}
		finally {
		}
		return result;
	}
}
