package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djsc001Db;
import com.urovo.wgmf.db.dao.entitys.ShiChiEntity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 *
 * @author Administrator
 */
public class Djsc001DbOperate {

    private static DBTool dbTool;

    public Djsc001DbOperate(Context context) {
        super();
        dbTool = DBTool.getInstance(context);
    }

    /**
     * 插入数据
     */
    public static Boolean Insert(Djsc001Db djsc001) {
        Cursor cursor = null;
        try {
            String sql = "insert into djsc001(bill,storeID,stwhsID,yngc,oper_lr,lr_name,wdate,status,comm,isup) values(?,?,?,?,?,?,?,?,?,?)";
            BaseAppManager.database().execSQL(sql, new String[]{djsc001.getBill(), djsc001.getStoreID(), djsc001.getStwhsID(), djsc001.getYngc(), djsc001.getOper_lr(), djsc001.getLr_name(), djsc001.getWdate(), djsc001.getStatus(), djsc001.getComm(), djsc001.getIsup() + ""});
            return true;
        } catch (Exception e) {
            BaseAppManager.loger().info("[Djsc001DbOperate.Insert]" + e);

            return false;
        } finally {
            // database.close();
            if (cursor != null)
                cursor.close();
        }
    }

    /**
     * 查询方法的基方法，代码的复用，万精油
     *
     * @param sql
     * @return
     */
    public static List<Djsc001Db> selectBy(String sql) {
        List<Djsc001Db> list = new ArrayList<Djsc001Db>();
        Cursor cursor = null;
        String sqlStr = "select * from djsc001";
        if (sql != null)
            sqlStr += sql;
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                Djsc001Db model = new Djsc001Db();
                model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
                model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
                model.setStwhsID(cursor.getString(cursor.getColumnIndex("stwhsID")));
                model.setYngc(cursor.getString(cursor.getColumnIndex("yngc")));
                model.setOper_lr(cursor.getString(cursor.getColumnIndex("oper_lr")));
                model.setLr_name(cursor.getString(cursor.getColumnIndex("lr_name")));
                model.setWdate(cursor.getString(cursor.getColumnIndex("wdate")));
                model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
                model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
                model.setIsup(cursor.getInt(cursor.getColumnIndex("isup")));
                if (model.getBill() != null && model.getBill().length() > 0) {
                    list.add(model);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 删除所有数据
     */
    public static Boolean deleteAllGoods(String sql) {
        Boolean result = false;
        String sqlStr = "Delete from djsc001";
        if (sql != null) {
            sqlStr += sql;
        }
        try {
            BaseAppManager.database().execSQL(sqlStr);
            result = true;
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            result = false;
        } finally {
        }
        return result;
    }

    public static int GetUnUploadCount() {
        int total = 0;
        Cursor cursor = null;
        String sql = "select count(bill) from djsc001 where IsUp=0";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            if (cursor.moveToNext()) {
                total = cursor.getInt(0);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取未上传试吃单据总数发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return total;
    }

    /**
     * 获取未上传的试吃单据主表
     *
     * @return
     */
    public static List<ShiChiEntity> GetUnUpload() {
        Cursor cursor = null;
        List<ShiChiEntity> list = new ArrayList<ShiChiEntity>();
        Date date = new Date();
        String sql = "select bill,storeid,stwhsid,yngc,oper_lr,lr_name,wdate,status,comm from djsc001 where IsUp=0 limit 20";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ShiChiEntity ent = new ShiChiEntity();
                ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
                ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
                String oper_lr = cursor.isNull(4) ? SystemHelper.LoginUserId : cursor.getString(4);
                ent.setOper_Lr(TextUtils.isEmpty(oper_lr) ? SystemHelper.LoginUserId : oper_lr);
                String lr_name = cursor.isNull(5) ? SystemHelper.LoginUserName : cursor.getString(5);
                ent.setLr_Name(TextUtils.isEmpty(lr_name) ? SystemHelper.LoginUserName : lr_name);
                ent.setWDate(cursor.isNull(6) ? DateUtil.getDate(date) : cursor.getString(6));
                ent.setComm(cursor.isNull(8) ? "" : cursor.getString(8));
                list.add(ent);
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取未上传试吃单主表发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 获取未上传的试吃单据主表
     *
     * @return
     */
    public static List<ShiChiEntity> GetAllUnUpload() {
        Cursor cursor = null;
        List<ShiChiEntity> list = new ArrayList<ShiChiEntity>();
        Date date = new Date();
        String sql = "select bill,storeid,stwhsid,yngc,oper_lr,lr_name,wdate,status,comm from djsc001 where IsUp=0 ";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ShiChiEntity ent = new ShiChiEntity();
                ent.setBill(cursor.isNull(0) ? "" : cursor.getString(0));
                ent.setStoreId(cursor.isNull(1) ? "" : cursor.getString(1));
                String oper_lr = cursor.isNull(4) ? SystemHelper.LoginUserId : cursor.getString(4);
                ent.setOper_Lr(TextUtils.isEmpty(oper_lr) ? SystemHelper.LoginUserId : oper_lr);
                String lr_name = cursor.isNull(5) ? SystemHelper.LoginUserName : cursor.getString(5);
                ent.setLr_Name(TextUtils.isEmpty(lr_name) ? SystemHelper.LoginUserName : lr_name);
                ent.setWDate(cursor.isNull(6) ? DateUtil.getDate(date) : cursor.getString(6));
                ent.setComm(cursor.isNull(8) ? "" : cursor.getString(8));
                list.add(ent);
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取未上传试吃单主表发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 更新上传信息
     *
     * @param bill
     */
    public static void UpdateBillState(String bill) {

        String sqlCommand = "update djsc001 set IsUp=1 where bill=?";
        try {
            BaseAppManager.database().execSQL(sqlCommand, new String[]{bill});
        } catch (Exception ex) {
            BaseAppManager.loger().info("更新试吃数据" + bill + "上传状态发生异常:" + ex);
        }

    }

    /**
     * 保存试吃单主表到本地数据库
     */
    public static void SaveShiChi(ShiChiEntity bll) {
        String sql = "insert into DJSC001(BILL,STOREID,STWHSID,YNGC,OPER_LR,LR_NAME,WDATE,STATUS,COMM,IsUp) " + " values(?,?,?,?,?,?,?,?,?,?)";
        try {
            BaseAppManager.database().execSQL(sql, new Object[]{bll.getBill(), bll.getStoreId(), bll.getSTWHSID(), bll.getYNGC(), bll.getOper_Lr(), bll.getLr_Name(), bll.getWDate(), bll.getStatus(), bll.getComm(), "0"});
        } catch (Exception e) {

            BaseAppManager.loger().info("保存试吃单主表发生异常:" + e);
        }
    }
}