package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djsc002Db;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 *
 * @author Administrator
 *
 */
public class Djsc002DbOperate {

	private static DBTool dbTool;

	public Djsc002DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djsc002Db djsc002) {
		Cursor cursor = null;
		try {
			String sql = "insert into djsc002(bill,itemID,pack,unit,sqty,tqty,price,comm,seq_NO) values(?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djsc002.getBill(), djsc002.getItemID(), djsc002.getPack() + "", djsc002.getUnit() + "", djsc002.getSqty() + "", djsc002.getTqty() + "", djsc002.getPrice() + "", djsc002.getComm(), djsc002.getSeq_NO() + "", });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djsc002DbOperate.Insert]" + e);

			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 *
	 * @param sql
	 * @return
	 */
	public static List<Djsc002Db> selectBy(String sql) {
		List<Djsc002Db> list = new ArrayList<Djsc002Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djsc002";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djsc002Db model = new Djsc002Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setPack(cursor.getInt(cursor.getColumnIndex("pack")));
				model.setUnit(cursor.getInt(cursor.getColumnIndex("unit")));
				model.setSqty(cursor.getInt(cursor.getColumnIndex("sqty")));
				model.setTqty(cursor.getInt(cursor.getColumnIndex("tqty")));
				model.setPrice(cursor.getInt(cursor.getColumnIndex("price")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setSeq_NO(cursor.getInt(cursor.getColumnIndex("seq_NO")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djsc002";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
			result = false;
		}
		finally {
		}
		return result;
	}

	/**
	 * 保存试吃单明细数据到本地数据库
	 *
	 * @param bill
	 * @param list
	 */
	public static void SaveShiChiDetail(String bill, List<ProductEntity> list) {
		String sql = "insert into DJSC002(BILL,ITEMID,PACK,UNIT,SQTY,TQTY,PRICE,COMM,SEQ_NO) values(?,?,?,?,?,?,?,?,?)";
		try {
			BaseAppManager.database().beginTransaction();
			for (ProductEntity p : list) {
				BaseAppManager.database().execSQL(sql, new Object[]{ bill, p.getItemId(), p.getTQTY(), 1, 0, p.getTQTY(), p.getPrice(), "", p.getSeq_No() });
			}
			BaseAppManager.database().setTransactionSuccessful();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存试吃单明细表发生异常:" + e);
		}
		finally {
			BaseAppManager.database().endTransaction();
		}
	}

	public static List<HashMap<String, String>> findTodayShiChi(String bill) {
		Cursor cursor = null;
		String sql = "select BILL,TQTY from DJSC002 where bill like'%" + bill + "%'";
		ArrayList<HashMap<String, String>> list = new ArrayList<HashMap<String, String>>();
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				HashMap<String, String> map = new HashMap<String, String>();
				String time = cursor.getString(cursor.getColumnIndex("BILL"));
				StringBuffer sb = new StringBuffer(time.substring(13, 17));
				sb.insert(2, ":");
				double count = cursor.getDouble(cursor.getColumnIndex("TQTY"));
				map.put("time", sb.toString());
				map.put("count", StringUtils.formatDouble(count, "0.##"));
				list.add(map);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null)
				cursor.close();
		}
		return list;
	}

	/**
	 * 根据试吃单据号获取产品明细
	 *
	 * @param bill
	 * @return
	 */
	public static List<ProductEntity> GetBillDetail(String bill) {
		List<ProductEntity> list = new ArrayList<ProductEntity>();
		Cursor cursor = null;
		String sql = "select itemid,pack,unit,sqty,tqty,price,comm,seq_no from djsc002 where bill='" + bill + "'";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				ProductEntity ent = new ProductEntity();
				ent.setItemId(cursor.isNull(0) ? "" : cursor.getString(0));
				ent.setTQTY(cursor.isNull(4) ? 0.0 : cursor.getDouble(4));
				ent.setPrice(cursor.isNull(5) ? 0.0 : cursor.getDouble(5));
				ent.setComm(cursor.isNull(6) ? "" : cursor.getString(6));
				ent.setSeq_No(cursor.isNull(7) ? Arith.add(list.size(), 1) : cursor.getDouble(7));
				ent.setAmount(Arith.mul(ent.getTQTY(), ent.getPrice()));
				list.add(ent);
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info("根据试吃单号获取产品明细发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}
}
