package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.entitys.Djxs002Db;
import com.urovo.wgmf.db.dao.entitys.OrderReqBean;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.XiaoShouEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.MoneyUtils;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.system.BaseAppManager;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 *
 * @author Administrator
 */
public class Djxs002DbOperate {

    private static DBTool dbTool;

    public Djxs002DbOperate(Context context) {
        super();
        dbTool = DBTool.getInstance(context);
    }

    /**
     * 插入数据
     */
    public static Boolean Insert(Djxs002Db djxs002) {
        Cursor cursor = null;
        try {
            String sql = "insert into djxs002(bill,NO,itemID,barcode,itemmode,saleqty,orprice,zkyhje,zkftje,net,sxprice) values(?,?,?,?,?,?,?,?,?,?,?)";
            BaseAppManager.database().execSQL(sql, new String[]{djxs002.getBill(), djxs002.getNO() + "", djxs002.getItemID(), djxs002.getBarcode(), djxs002.getItemmode(), djxs002.getSaleqty() + "", djxs002.getOrprice() + "", djxs002.getZkyhje() + "", djxs002.getZkftje() + "", djxs002.getNet() + "",
                    djxs002.getSxprice() + ""});
            return true;
        } catch (Exception e) {
            BaseAppManager.loger().info("[Djxs002DbOperate.Insert]" + e);

            return false;
        } finally {
            // database.close();
            if (cursor != null)
                cursor.close();
        }
    }

    /**
     * 查询方法的基方法，代码的复用，万精油
     *
     * @param sql
     * @return
     */
    public static List<Djxs002Db> selectBy(String sql) {
        List<Djxs002Db> list = new ArrayList<Djxs002Db>();
        Cursor cursor = null;
        String sqlStr = "select * from djxs002";
        if (sql != null)
            sqlStr += sql;
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                Djxs002Db model = new Djxs002Db();
                model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
                model.setNO(cursor.getInt(cursor.getColumnIndex("NO")));
                model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
                model.setBarcode(cursor.getString(cursor.getColumnIndex("barcode")));
                model.setItemmode(cursor.getString(cursor.getColumnIndex("itemmode")));
                model.setSaleqty(cursor.getInt(cursor.getColumnIndex("saleqty")));
                model.setOrprice(cursor.getInt(cursor.getColumnIndex("orprice")));
                model.setZkyhje(cursor.getInt(cursor.getColumnIndex("zkyhje")));
                model.setZkftje(cursor.getInt(cursor.getColumnIndex("zkftje")));
                model.setNet(cursor.getInt(cursor.getColumnIndex("net")));
                model.setSxprice(cursor.getInt(cursor.getColumnIndex("sxprice")));
                if (model.getBill() != null && model.getBill().length() > 0) {
                    list.add(model);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 删除所有数据
     */
    public static Boolean deleteAllGoods(String sql) {
        Boolean result = false;
        String sqlStr = "Delete from djxs002";
        if (sql != null) {
            sqlStr += sql;
        }
        try {
            BaseAppManager.database().execSQL(sqlStr);
            result = true;
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            result = false;
        } finally {
        }
        return result;
    }

    /**
     * 保存销售单明细数据到本地数据库
     */
    public static boolean SaveXiaoShouDetail(XiaoShouEntity bll, List<ProductEntity> list) {
        boolean resault = true;
        String sql = "insert into DJXS002(bill,no,itemid,barcode,itemmode,saleqty,orprice,zkyhje,zkftje,net,sxprice ) " + " values(?,?,?,?,?,?,?,?,?,?,?)";
        try {
            BaseAppManager.database().beginTransaction();
            for (ProductEntity p : list) {
                BaseAppManager.database().execSQL(sql, new Object[]{bll.getBill(), p.getSeq_No(), p.getItemId(), p.getBarcode(), p.getItemMode(), p.getTQTY(), p.getPrice(), 0, 0, p.getAmount(), p.getPrice()});
            }
            BaseAppManager.database().setTransactionSuccessful();
        } catch (Exception e) {

            resault = false;
            BaseAppManager.loger().info("保存销售单明细表发生异常:" + e);
        } finally {
            BaseAppManager.database().endTransaction();
        }
        return resault;
    }

    /**
     * 3.0之后的保存订单
     *
     * @return
     */
    public static boolean saveSaleOrderDetail(String billId, List<OrderReqBean.ProductDetailsBean> list) {
        boolean resault = true;
        //String sql = "insert into DJXS002(bill,no,itemid,barcode,itemmode,saleqty,orprice,zkyhje,zkftje,net,sxprice ) " + " values(?,?,?,?,?,?,?,?,?,?,?)";
        //new Object[]{ bll.getBill(), p.getSeq_No(), p.getItemId(), p.getBarcode(), p.getItemMode(), p.getTQTY(), p.getPrice(), 0, 0, p.getAmount(), p.getPrice() });
        String sql = "insert into DJXS002(bill,itemid,barcode,itemmode,saleqty,orprice,net,sxprice,specialPrice,brandType,isDecimal,groupId,proportRelation) " + " values(?,?,?,?,?,?,?,?,?,?,?,?,?)";
        try {
            BaseAppManager.database().beginTransaction();
            for (OrderReqBean.ProductDetailsBean p : list) {
                BaseAppManager.database().execSQL(sql, new Object[]{billId, p.getItemId(), p.getBarcode(), p.getItemMode(), p.getTQTY(), p.getPrice(), p.getAmount(), p.getPrice(), p.getSpecialPrice(), p.getBrandType(),p.getIsDecimal(),p.getGroupId(),p.getProportRelation()});
            }
            BaseAppManager.database().setTransactionSuccessful();
        } catch (Exception e) {

            resault = false;
            BaseAppManager.loger().info("保存销售单明细表发生异常:" + e);
        } finally {
            BaseAppManager.database().endTransaction();
        }
        return resault;
    }

    /**
     * 3.0之后的查询订单
     *
     * @return ...
     */
    public static List<OrderReqBean.ProductDetailsBean> selectOrderDetail(String billId) {
        List<OrderReqBean.ProductDetailsBean> productDetailsBeans = new ArrayList<>();
        Cursor cursor = null;
        //String sql = "insert into DJXS002(bill,itemid,barcode,itemmode,saleqty,orprice,net,sxprice,specialPrice) " + " values(?,?,?,?,?,?,?,?,?)";
        String sql = "select t1.no,t1.itemid,t1.barcode,t1.itemmode,t1.saleqty,t1.net,t1.sxprice,t1.specialPrice,t1.brandType,t1.isDecimal, t1.groupId,t1.proportRelation,t2.itemname,t2.kcuom,t2.brand "
                + " from djxs002 t1 join item001 t2 on t1.itemid=t2.itemid where t1.bill=? ";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{billId});
            while (cursor.moveToNext()) {
                OrderReqBean.ProductDetailsBean productDetailsBean = new OrderReqBean.ProductDetailsBean();
                productDetailsBean.setSpecialPrice(Double.valueOf(MoneyUtils.twolastDF(cursor.getDouble(cursor.getColumnIndex("specialPrice")))));
                productDetailsBean.setBarcode(cursor.getString(cursor.getColumnIndex("BARCODE")));
                productDetailsBean.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                productDetailsBean.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                productDetailsBean.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                productDetailsBean.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                productDetailsBean.setTQTY(cursor.getDouble(cursor.getColumnIndex("SALEQTY")));
                productDetailsBean.setPrice(Double.valueOf(MoneyUtils.twolastDF(cursor.getDouble(cursor.getColumnIndex("SXPRICE")))));
                SYLoger.print("条码打印 保存页面 产品详细表单：setPrice -- " + Double.valueOf(MoneyUtils.twolastDF(cursor.getDouble(cursor.getColumnIndex("SXPRICE")))));
                SYLoger.print("条码打印 保存页面 产品详细表单：setPrice -- " + cursor.getDouble(cursor.getColumnIndex("SXPRICE")));
                productDetailsBean.setUnit(cursor.getDouble(cursor.getColumnIndex("ITEMID")));
//        productDetailsBean.setAmount(Double.valueOf(MoneyUtils.twolastDF(cursor.getDouble(cursor.getColumnIndex("NET")))));
                productDetailsBean.setAmount(Double.valueOf(MoneyUtils.twolastDF(cursor.getDouble(cursor.getColumnIndex("NET")))));
                SYLoger.print("条码打印 保存页面 产品详细表单：setAmount-- " + Double.valueOf(MoneyUtils.twolastDF(cursor.getDouble(cursor.getColumnIndex("NET")))));
                SYLoger.print("条码打印 保存页面 产品详细表单：setAmount-- " + cursor.getDouble(cursor.getColumnIndex("NET")));
                productDetailsBean.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                //活动时品牌区别标记
                productDetailsBean.setBrandType(cursor.getString(cursor.getColumnIndex("brandType")));
                String isDecimalStr = cursor.getString(cursor.getColumnIndex("isDecimal"));//还是做一个防空吧。。。
                productDetailsBean.setIsDecimal((isDecimalStr != null && isDecimalStr.equals("Y"))? true : false);
                productDetailsBean.setGroupId(cursor.getInt(cursor.getColumnIndex("groupId")));
                productDetailsBean.setProportRelation(cursor.getInt(cursor.getColumnIndex("proportRelation")));
                productDetailsBeans.add(productDetailsBean);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("查询销售单明细表发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return productDetailsBeans;
    }

    /**
     * 根据销售单据号查询该单据的产品明细
     *
     * @param bill
     * @param saleBack
     * @return
     */
    public static List<ProductEntity> QueryXiaoShouDetail(String bill, boolean saleBack) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "select t1.no,t1.itemid,t1.barcode,t1.itemmode,t1.saleqty,t1.sxprice,t1.net,t2.itemname,t2.kcuom " + " from djxs002 t1 join item001 t2 on t1.itemid=t2.itemid "
                + "join djxs001 t3 on t1.bill = t3.bill join store001 t4 on t3.storeid = t4.storeid and t4.cpbill = t2.itemgx  where t1.bill=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{bill});
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                double no = cursor.getDouble(cursor.getColumnIndex("NO"));
                p.setSeq_No(no == 0 ? (list.size() + 1) : no);
                String itemid = cursor.getString(cursor.getColumnIndex("ITEMID"));
                p.setItemId(StringUtils.isEmpty(itemid) ? itemid : "");
                String barcode = cursor.getString(cursor.getColumnIndex("BARCODE"));
                p.setBarcode(StringUtils.isEmpty(barcode) ? barcode : p.getItemId());
                String itemmode = cursor.getString(cursor.getColumnIndex("ITEMMODE"));
                p.setItemMode(StringUtils.isEmpty(itemmode) ? itemmode : "P");
                p.setTQTY(cursor.getDouble(cursor.getColumnIndex("SALEQTY")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("SXPRICE")));
                double net = cursor.getDouble(cursor.getColumnIndex("NET"));
                if (!DalCommon.CanEditAmount(p.getItemId())) {

                    p.setAmount(net == 0 ? (Arith.mul(p.getTQTY(), p.getPrice())) : net); // 对于不可修改金额的产品：金额=单价*数量
                } else {
                    p.setAmount(net == 0 ? (p.getTQTY() > 0 ? p.getPrice() : Math.abs(p.getPrice())) : net); // 对于可修改金额的产品:金额=单价
                }
                // 如果是退货，数量和金额以负数显示
                //				if(saleBack) {
                //					p.setTQTY(Arith.mul(Math.abs(p.getTQTY()), -1));
                //					p.setAmount(Arith.mul(Math.abs(p.getAmount()), -1));
                //				}
                String itemname = cursor.getString(cursor.getColumnIndex("ITEMNAME"));
                p.setItemName(StringUtils.isEmpty(itemname) ? itemname : "");
                String kcuom = cursor.getString(cursor.getColumnIndex("KCUOM"));
                p.setKCUom(StringUtils.isEmpty(kcuom) ? kcuom : "");
                list.add(p);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("查询销售明细发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        cursor = null;
        String sql2 = "select t1.no,t1.itemid,t1.barcode,t1.itemmode,t1.saleqty,t1.sxprice,t1.net,t2.itemname,t2.kcuom " + " from djxs002 t1 join item001 t2 on t1.itemid=t2.itemid "
                + "join djxs001 t3 on t1.bill = t3.bill join store001 t4 on t3.storeid = t4.storeid and t4.cpbill != t2.itemgx and t1.ORPRICE ==0 and t1.SXPRICE ==0 where t1.bill=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql2, new String[]{bill});
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                double no = cursor.getDouble(cursor.getColumnIndex("NO"));
                p.setSeq_No(no == 0 ? (list.size() + 1) : no);
                String itemid = cursor.getString(cursor.getColumnIndex("ITEMID"));
                p.setItemId(StringUtils.isEmpty(itemid) ? itemid : "");
                String barcode = cursor.getString(cursor.getColumnIndex("BARCODE"));
                p.setBarcode(StringUtils.isEmpty(barcode) ? barcode : p.getItemId());
                String itemmode = cursor.getString(cursor.getColumnIndex("ITEMMODE"));
                p.setItemMode(StringUtils.isEmpty(itemmode) ? itemmode : "P");
                p.setTQTY(cursor.getDouble(cursor.getColumnIndex("SALEQTY")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("SXPRICE")));
                double net = cursor.getDouble(cursor.getColumnIndex("NET"));
                if (!DalCommon.CanEditAmount(p.getItemId())) {

                    p.setAmount(net == 0 ? (Arith.mul(p.getTQTY(), p.getPrice())) : net); // 对于不可修改金额的产品：金额=单价*数量
                } else {
                    p.setAmount(net == 0 ? (p.getTQTY() > 0 ? p.getPrice() : Math.abs(p.getPrice())) : net); // 对于可修改金额的产品:金额=单价
                }
                String itemname = cursor.getString(cursor.getColumnIndex("ITEMNAME"));
                p.setItemName(StringUtils.isEmpty(itemname) ? itemname : "");
                String kcuom = cursor.getString(cursor.getColumnIndex("KCUOM"));
                p.setKCUom(StringUtils.isEmpty(kcuom) ? kcuom : "");
                if (!list.contains(p)) {
                    list.add(p);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("查询赠品明细发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }
}
