package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djzs001Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djzs001DbOperate {

	private static DBTool dbTool;

	public Djzs001DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djzs001Db djzs001) {
		Cursor cursor = null;
		try {
			String sql = "insert into djzs001(bill,storeID,stwhsID,yngc,cphone,oper_lr,lr_name,wdate,status,comm,isup) values(?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djzs001.getBill(), djzs001.getStoreID(), djzs001.getStwhsID(), djzs001.getYngc(), djzs001.getCphone(), djzs001.getOper_lr(), djzs001.getLr_name(), djzs001.getWdate(), djzs001.getStatus(), djzs001.getComm(), djzs001.getIsup() + "" });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djzs001DbOperate.Insert]" + e);

			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djzs001Db> selectBy(String sql) {
		List<Djzs001Db> list = new ArrayList<Djzs001Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djzs001";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djzs001Db model = new Djzs001Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setStoreID(cursor.getString(cursor.getColumnIndex("storeID")));
				model.setStwhsID(cursor.getString(cursor.getColumnIndex("stwhsID")));
				model.setYngc(cursor.getString(cursor.getColumnIndex("yngc")));
				model.setCphone(cursor.getString(cursor.getColumnIndex("cphone")));
				model.setOper_lr(cursor.getString(cursor.getColumnIndex("oper_lr")));
				model.setLr_name(cursor.getString(cursor.getColumnIndex("lr_name")));
				model.setWdate(cursor.getString(cursor.getColumnIndex("wdate")));
				model.setStatus(cursor.getString(cursor.getColumnIndex("status")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setIsup(cursor.getInt(cursor.getColumnIndex("isup")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djzs001";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
			result = false;
		}
		finally {
		}
		return result;
	}

	public static int GetUnUploadCount() {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from djzs001 where IsUp=0";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取未上传赠送单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

	public static List<Djzs001Db> GetUnUpload() {
		String sql = "where IsUp=0";
		return selectBy(sql);
	}

	/**
	 * 更新上传信息
	 * 
	 * @param bill
	 */
	public static void UpdateBillState(String bill) {

		String sqlCommand = "update djzs001 set IsUp=1 where bill=?";
		try {
			BaseAppManager.database().execSQL(sqlCommand, new String[]{ bill });
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("更新赠送上传单据" + bill + "上传状态发生异常:" + ex);
		}

	}
}