package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Djzs002Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Djzs002DbOperate {

	private static DBTool dbTool;

	public Djzs002DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Djzs002Db djzs002) {
		Cursor cursor = null;
		try {
			String sql = "insert into djzs002(bill,itemID,pack,unit,sqty,tqty,price,comm,seq_NO) values(?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ djzs002.getBill(), djzs002.getItemID(), djzs002.getPack() + "", djzs002.getUnit() + "", djzs002.getSqty() + "", djzs002.getTqty() + "", djzs002.getPrice() + "", djzs002.getComm(), djzs002.getSeq_NO() + "", });
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Djzs002DbOperate.Insert]" + e);

			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Djzs002Db> selectBy(String sql) {
		List<Djzs002Db> list = new ArrayList<Djzs002Db>();
		Cursor cursor = null;
		String sqlStr = "select * from djzs002";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Djzs002Db model = new Djzs002Db();
				model.setBill(cursor.getString(cursor.getColumnIndex("bill")));
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setPack(cursor.getInt(cursor.getColumnIndex("pack")));
				model.setUnit(cursor.getInt(cursor.getColumnIndex("unit")));
				model.setSqty(cursor.getInt(cursor.getColumnIndex("sqty")));
				model.setTqty(cursor.getInt(cursor.getColumnIndex("tqty")));
				model.setPrice(cursor.getInt(cursor.getColumnIndex("price")));
				model.setComm(cursor.getString(cursor.getColumnIndex("comm")));
				model.setSeq_NO(cursor.getInt(cursor.getColumnIndex("seq_NO")));
				if(model.getBill() != null && model.getBill().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from djzs002";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
			result = false;
		}
		finally {
		}
		return result;
	}
}
