package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Item001Db;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 *
 * @author Administrator
 */
public class Item001DbOperate {

    private static DBTool dbTool;

    public Item001DbOperate(Context context) {
        super();
        dbTool = DBTool.getInstance(context);
    }

    /**
     * 插入数据
     */
    public static Boolean Insert(Item001Db item001) {
        Cursor cursor = null;
        try {
            String sql = "insert into item001(itemID,itemname,itemmode,classID,itemtype,itemgx," + "xsgrpID,sortNO,kcuom,qtyinteger,dhpack,unit,normrprice) values(?,?,?,?,?,?,?,?,?,?,?,?,?)";
            BaseAppManager.database().execSQL(
                    sql,
                    new String[]{item001.getItemID(), item001.getItemname(), item001.getItemmode(), item001.getClassID(), item001.getItemtype(), item001.getItemgx() + "", item001.getXsgrpID(),
                            item001.getSortNO() + "", item001.getKcuom(), item001.getQtyinteger(), item001.getDhpack() + "", item001.getUnit() + "", item001.getNormrprice() + ""});
            return true;
        } catch (Exception e) {
            BaseAppManager.loger().info("[Item001DbOperate.Insert]" + e);

            return false;
        } finally {
            // database.close();
            if (cursor != null)
                cursor.close();
        }
    }

    /**
     * 查询方法的基方法，代码的复用，万精油
     *
     * @param sql
     * @return
     */
    public static List<Item001Db> selectBy(String sql) {
        List<Item001Db> list = new ArrayList<Item001Db>();
        Cursor cursor = null;
        String sqlStr = "select * from item001";
        if (sql != null)
            sqlStr += sql;
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                Item001Db model = new Item001Db();
                model.setItemID(cursor.getString(cursor.getColumnIndex("ITEMID")));
                model.setItemname(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                model.setItemmode(cursor.getString(cursor.getColumnIndex("itemmode")));
                model.setClassID(cursor.getString(cursor.getColumnIndex("classID")));
                model.setItemtype(cursor.getString(cursor.getColumnIndex("itemtype")));
                model.setItemgx(cursor.getString(cursor.getColumnIndex("itemgx")));
                model.setXsgrpID(cursor.getString(cursor.getColumnIndex("xsgrpID")));
                model.setSortNO(cursor.getInt(cursor.getColumnIndex("sortNO")));
                model.setKcuom(cursor.getString(cursor.getColumnIndex("kcuom")));
                model.setQtyinteger(cursor.getString(cursor.getColumnIndex("qtyinteger")));
                model.setDhpack(cursor.getInt(cursor.getColumnIndex("dhpack")));
                model.setUnit(cursor.getInt(cursor.getColumnIndex("unit")));
                model.setNormrprice(cursor.getInt(cursor.getColumnIndex("normrprice")));
                model.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                if (model.getItemID() != null && model.getItemID().length() > 0) {
                    list.add(model);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 查询item001表中某列的内容的集合(去重和空)
     *
     * @param columnName 列名
     * @return 查询的列的内容的集合
     */
    public static List<String> queryColumn(String columnName) {
        String column = "";
        List<String> list = new ArrayList<>();
        Cursor cursor = null;
//        SELECT DISTINCT BRAND FROM item001 WHERE BRAND is not null and BRAND !=''
        String sqlStr = "SELECT DISTINCT " + columnName + " FROM item001 WHERE " + columnName + " is not null and " + columnName + " !=''";
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                column = cursor.getString(0);
                list.add(column);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 查询子品牌 鲜稻研
     *
     * @return ...
     */
    public static String querySubBrand() {
        HashMap<String, String> brandMap = new HashMap<>();
        String brand = "";
        Cursor cursor = null;
//        SELECT DISTINCT BRAND FROM item001 WHERE BRAND is not null and BRAND !=''and BRAND!='五谷磨房'
        String sqlStr = "SELECT DISTINCT BRAND,BRANDID FROM item001 WHERE BRAND is not null and BRAND !='' and BRAND !='" + SystemHelper.MemGoodsBrand + "' and BRAND !='五谷磨房'";
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                brandMap.put(cursor.getString(cursor.getColumnIndex("BRANDID")),
                        cursor.getString(cursor.getColumnIndex("BRAND")));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }

        if (!TextUtils.isEmpty(SystemHelper.LoginUserBrandList) && brandMap.keySet().size() > 0) {
            for (String key : brandMap.keySet()) {
                if (SystemHelper.LoginUserBrandList.contains(key)) {
                    brand = brandMap.get(key);
                    break;
                }
            }
        }
        return brand;
    }

    /**
     * 是否有 会员商品
     *
     * @return
     */
    public static boolean hasMemGoods() {
        Cursor cursor = null;
        String sqlStr = "SELECT DISTINCT BRAND,BRANDID FROM item001 WHERE BRAND is not null  and BRANDID ='" + SystemHelper.MemGoodsBrand_Id + "'";
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            return cursor.moveToNext();
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return false;
    }


    /**
     * 查找会员商品品牌名
     *
     * @return
     */
    public static String queryMemGoodsBrand() {
        Cursor cursor = null;
        String sqlStr = "SELECT DISTINCT BRAND,BRANDID FROM item001 WHERE BRAND is not null  and BRANDID ='" + SystemHelper.MemGoodsBrand_Id + "'";
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
            while (cursor.moveToNext()) {
                return cursor.getString(cursor.getColumnIndex("BRAND"));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return "";
    }

    /**
     * 根据产品id来查出对应的包装单位（罐、包、袋……）
     */
    public static String getKCUomById(String proId) {
        String kcuom = "";
        Cursor cursor = null;
        String sqlStr = "select kcuom from item001 where itemid = ?";
        try {
            cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{proId});
            while (cursor.moveToNext()) {
                kcuom = cursor.getString(0);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return kcuom;
    }

    /**
     * 删除所有数据
     */
    public static Boolean deleteAllGoods(String sql) {
        Boolean result = false;
        String sqlStr = "Delete from item001";
        if (sql != null) {
            sqlStr += sql;
        }
        try {
            BaseAppManager.database().execSQL(sqlStr);
            result = true;
        } catch (Exception e) {

            result = false;
            BaseAppManager.loger().info(e);
        } finally {
        }
        return result;
    }

    /**
     * 根据产品编码来获取该条码代表的产品信息,获取成功返回一个product实体，否则返回null
     *
     * @param itemId
     * @return
     */
    public static ProductEntity GetCanSaleProductByItemId(String itemId, String storeId) {
        ProductEntity p = null;
        Cursor cursor = null;
        String sql = "select t1.itemid ,t1.itemname ,t1.itemmode ,t1.itemtype ,t1.kcuom ,t1.qtyinteger ,t1.dhpack ,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid  "
                + " from item001 t1 join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill where t3.XSGRPID !='999'  and t3.bill in (select cpbill from store001 "
                + " where storeid= '" + storeId + "') and t1.itemid = '" + itemId + "' order by t3.sortno ";

        try {
            //cursor = BaseAppManager.database().rawQuery(sql, new String[]{ storeId });
            cursor = BaseAppManager.database().rawQuery(sql, null);
            if (cursor.moveToNext()) {
                p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setBarcode(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
            }
        } catch (Exception e) {
            p = null;
            BaseAppManager.loger().info("根据产品编码查询产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return p;
    }

    /**
     * 获取所有的品牌信息
     *
     * @return
     */
    public static String getBrands() {
//        List<String> list = new ArrayList<String>();
        String brands = "";
        Cursor cursor = null;
        String sql = "select distinct brand from item001";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
//                list.add(cursor.getString(0));
                brands += cursor.getString(0);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取品牌信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return brands;
    }

    /**
     * 自己造一个9.8888的实体，并补到item001表里。。。
     * 因为有时候item001表里并没有这个
     *
     * @return
     */
    public static ProductEntity insertGiftProductEntity() {
        Item001Db item = new Item001Db();
        item.setItemID("9.8888");
        item.setItemname("折扣产品");
        item.setItemmode("P");
        item.setItemtype("0");
        item.setItemgx("0");
        item.setSortNO(0);
        item.setKcuom("件");
        item.setQtyinteger("y");
        item.setDhpack(1);
        item.setUnit(1);
        item.setNormrprice(-1);
        Insert(item);

        ProductEntity entity = new ProductEntity();
        entity.setItemId("9.8888");
        entity.setBarcode("9.8888");
        entity.setItemName("折扣产品");
        entity.setItemMode("P");
        entity.setItemType("0");
        entity.setKCUom("件");
        entity.setQtyInteger("y");
        entity.setDHPack(1);
        entity.setUnit(1);
        entity.setPrice(-1);
        entity.setTQTY(1);
        entity.setAmount(entity.getPrice() * 1);
        return entity;
    }

    /**
     * 根据产品id判断品牌是什么
     *
     * @param itemId 要查询的产品id
     * @return
     */
    public static String getBrandById(String itemId) {
        String brand = "";
        Cursor cursor = null;
        String sql = "select brand from  item001 where itemid = ?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{itemId});
            if (cursor.moveToNext()) {
                return cursor.getString(cursor.getColumnIndex("BRAND"));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("根据产品编码查询产品信息发生异常:" + e);
            e.printStackTrace();
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return brand;
    }

    /**
     * 根据产品编码来获取该条码代表的产品信息,获取成功返回一个product实体，否则返回null
     *
     * @param itemId
     * @return
     */
    public static ProductEntity GetProductByBarcode(String itemId) {
        ProductEntity p = null;
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + " where t1.itemid=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{itemId});
            if (cursor.moveToNext()) {
                p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setBarcode(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
            }
        } catch (Exception e) {
            p = null;
            BaseAppManager.loger().info("根据产品编码查询产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        //如果是折扣产品，不要只生一个就完事了，生完要再填到item001表里才行！
        // 因为后面很多地方都会通过item001来查，到时候还会又查不到。
        if (p == null && itemId.equals("9.8888")) {
            return insertGiftProductEntity();
        } else {
            return p;
        }
    }

    /**
     * 根据产品编码来获取该条码代表的产品信息,获取成功返回一个product实体，否则返回null
     *
     * @param itemId
     * @return
     */
    public static ProductEntity GetProductByBarcodeBanShiChu(String itemId, String storeId) {
        ProductEntity p = null;
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + " where t1.itemid=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{itemId});
            if (cursor.moveToNext()) {
                p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));

                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
            }
        } catch (Exception e) {
            p = null;
            BaseAppManager.loger().info("根据产品编码查询产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return p;
    }

    /**
     * 通过品牌查询有哪些classId的种类，并按classidorder升序排列
     *
     * @param brand
     * @return
     */
    public static List<String> getClassIdsByOrder(String brand) {
        List<String> classIds = new ArrayList<>();
        Cursor cursor = null;
        String sql = "select distinct classId from item001 where brand = '" + brand + "'order by classidorder asc";

        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                String classId = cursor.getString(cursor.getColumnIndex("CLASSID"));
                if (!TextUtils.isEmpty(classId)) {
                    classIds.add(classId);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取所有可销售产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return classIds;
    }

    /**
     * 通过品牌来过滤 已获取的可销售产品信息
     *
     * @param storeId       门店号
     * @param userBrandList 用户可销售的产品品牌
     * @return
     */
    public static List<ProductEntity> GetCanXiaoShouByUserBrandList(String storeId, String userBrandList) {
        List<ProductEntity> list = GetCanXiaoShouProducts(storeId, " and brandid in (" + userBrandList + ")");
        if (list != null && list.size() > 0) {
            Iterator<ProductEntity> p = list.iterator();
            while (p.hasNext()) {
                //如果该产品没品牌信息（为空）  或者  品牌信息不匹配，那就删掉
                ProductEntity entity = p.next();
                if (TextUtils.isEmpty(entity.getBrand())) {
                    p.remove();
                }
            }
        }
        return list;
    }

    /**
     * 获取所有可销售产品信息
     *
     * @param storeId 门店id
     * @param str     查询条件，需要在前面加and
     * @return
     */
    public static List<ProductEntity> GetCanXiaoShouProducts(String storeId, String str) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql;
        if (!TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t1.classidorder,t3.sortno,t3.isdecimal,t1.brandid from  item001 t1 " + " join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill"
                    + " where t3.XSGRPID !='999' and t1.itemid != '9.8888' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "')" + str + " order by t3.sortno";
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t1.classidorder,t3.sortno,t3.isdecimal,t1.brandid from  item001 t1 " + " join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill" + " where t3.XSGRPID !='999' and t1.itemid != '9.8888' " + str
                    + " order by t3.sortno";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setBarcode(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setSortNo(cursor.getDouble(cursor.getColumnIndex("SORTNO")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setClassidorder(cursor.getInt(cursor.getColumnIndex("CLASSIDORDER")));
                p.setDecimal("Y".equals(cursor.getString(cursor.getColumnIndex("ISDECIMAL"))));
                p.setTQTY(1.0);
                p.setAmount(p.getPrice());
                p.setBrandId(cursor.getInt(cursor.getColumnIndex("BRANDID")));
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取所有可销售产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 1);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 1);
                    }
                }
            }
        }
        return list;
    }


    /**
     * 获取ItemId可销售产品信息
     *
     * @param storeId 门店id
     * @param itemId 产品Id
     * @return ProductEntity
     */
    public static List<ProductEntity> GetCanXiaoShouProductsByItemId(String storeId, String itemId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql;
        if (!TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t1.classidorder,t3.sortno,t3.isdecimal,t1.brandid from  item001 t1 " +
                    " join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill where t3.XSGRPID !='999' and t1.itemid != '9.8888' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') and t1.itemid='" + itemId + "' order by t3.sortno";
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom,  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t1.classidorder," +
                    "t3.sortno,t3.isdecimal,t1.brandid from  item001 t1  join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill  where t3.XSGRPID !='999' and t1.itemid != '9.8888' and t1.itemid='" + itemId + "' order by t3.sortno";
        }

        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setBarcode(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setSortNo(cursor.getDouble(cursor.getColumnIndex("SORTNO")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setClassidorder(cursor.getInt(cursor.getColumnIndex("CLASSIDORDER")));
                p.setDecimal("Y".equals(cursor.getString(cursor.getColumnIndex("ISDECIMAL"))));
                p.setTQTY(1.0);
                p.setAmount(p.getPrice());
                p.setBrandId(cursor.getInt(cursor.getColumnIndex("BRANDID")));
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取所有可销售产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 1);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 1);
                    }
                }
            }
        }
        return list;
    }

    /**
     * 获取所有可销售产品信息
     */
    public static List<ProductEntity> GetCanXiaoShouProducts(String storeId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql;
        if (!TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t3.sortno from  item001 t1 " + " join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill"
                    + " where t3.XSGRPID !='999' and t1.itemid != '9.8888' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "')" + " order by t3.sortno";
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t3.sortno from  item001 t1 " + " join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill" + " where t3.XSGRPID !='999' and t1.itemid != '9.8888' "
                    + " order by t3.sortno";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setBarcode(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setSortNo(cursor.getDouble(cursor.getColumnIndex("SORTNO")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1.0);
                p.setAmount(p.getPrice());
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有可销售产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 1);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 1);
                    }
                }
            }
        }
        return list;
    }

    /**
     * 根据关键字模糊查询查询产品信息
     *
     * @param info
     * @return
     */
    public static ArrayList<ProductEntity> likeQuery(String info) {
        ArrayList<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 ,cpbill002 t3 " + " where t1.itemid=t3.itemid and t1.itemgx= t3.bill" + " and t1.itemid like '%" + info + "%' or t1.itemname like '%" + info
                + "%'" + " or kcuom like '%" + info + "%'";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("根据关键字模糊查询查询产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }


    /**
     * 查询顾问品牌全部产品信息
     *
     * @return
     */
    public static ArrayList<ProductEntity> GetCanGuWenBrandProducts() {
        ArrayList<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;

        StringBuilder sql = new StringBuilder("select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " +
                "t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t3.isdecimal from  item001 t1 join cpbill002 t3 on t1.itemid=t3.itemid");

        String loginUserBrandList = SystemHelper.LoginUserBrandList;
        if (!TextUtils.isEmpty(loginUserBrandList)) {
            //sql += " where t1.brandid in (" + loginUserBrandList + ")";
            String[] conditionArrays = loginUserBrandList.split(",");
            sql.append(" where");
            for (int i = 0; i < conditionArrays.length; i++) {
                if (i == 0) {
                    sql.append(" t1.brandid = ").append(conditionArrays[i]);
                } else {
                    sql.append(" or t1.brandid = ").append(conditionArrays[i]);
                }
            }
        }

        try {
            cursor = BaseAppManager.database().rawQuery(sql.toString(), null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setDecimal("Y".equals(cursor.getString(cursor.getColumnIndex("ISDECIMAL"))));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                list.add(p);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("查询全部产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 根据关键字模糊查询可销售产品信息
     *
     * @param storeId 门店编号
     * @param info    关键字
     * @return
     */
    public static ArrayList<ProductEntity> likeQueryCanXiaoShou(String storeId, String info) {
        ArrayList<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1,cpbill002 t3 " + " where t1.itemid=t3.itemid and t1.itemgx= t3.bill"
                + " and t3.XSGRPID !='999' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "')" + " and (t1.itemid like '%" + info + "%' or t1.itemname like '%" + info + "%'" + " or kcuom like '%" + info + "%')";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                list.add(p);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("根据关键字模糊查询可销售产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 查询全部产品信息
     *
     * @return
     */
    public static ArrayList<ProductEntity> GetAll() {
        ArrayList<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid,t3.isdecimal from  item001 t1 join cpbill002 t3 on t1.itemid=t3.itemid ";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setDecimal("Y".equals(cursor.getString(cursor.getColumnIndex("ISDECIMAL"))));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                list.add(p);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("查询全部产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }


    /**
     * 检查是否含有isDecimal==Y 的产品 （散装）
     *
     * @return
     */
    public static boolean hasDecimalPro() {
        boolean hasDecimalPro = false;
        Cursor cursor = null;
        String sql = "select t1.itemid from  item001 t1 join cpbill002 t2 on t1.itemid=t2.itemid  and t2.isdecimal='Y'";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            hasDecimalPro = cursor.moveToNext();
        } catch (Exception e) {
            e.printStackTrace();
            BaseAppManager.loger().info("查询是否有散装发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return hasDecimalPro;
    }

    /**
     * 获取所有可试吃
     *
     * @return
     */
    public static List<ProductEntity> GetCanShiChiProducts() {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + " join cpbill002 t3 on t1.itemid=t3.itemid and t1.itemgx= t3.bill" + " where t3.SCSTAT ='Y'"; // 产品目录子表
        // 试吃状态
        // 字段为'Y'
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有可试吃产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 1);
                }
            }
        }
        return list;
    }

    /**
     * 获取产品辅助信息（名称、模式、单位、规格）
     */
    public static void GetProductDetail(ProductEntity p) {
        Cursor cursor = null;
        String sql = "select itemname,itemmode,kcuom,dhpack,proarea,prosupplier,brand from item001 where itemid=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{p.getItemId()});
            if (cursor.moveToNext()) {
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")) == null ? "" : cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")) == null ? "P" : cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")) == null ? "" : cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取产品辅助信息（名称、模式、单位、规格）异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
    }

    /**
     * 根据编号获取产品辅助信息（名称、模式、单位、规格）
     */
    public static ProductEntity GetProductDetail2(String itemid) {
        Cursor cursor = null;
        ProductEntity p = new ProductEntity();
        String sql = "select itemname,itemmode,kcuom,dhpack,proarea,prosupplier,brand from item001 where itemid=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{itemid});
            if (cursor.moveToNext()) {
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")) == null ? "" : cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")) == null ? "P" : cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")) == null ? "" : cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取产品辅助信息（名称、模式、单位、规格）异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return p;
    }

    /**
     * 根据编号获取产品名称
     */
    public static String GetProductName(String itemid) {
        Cursor cursor = null;
        String name = "";
        String sql = "select itemname from item001 where itemid=?";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, new String[]{itemid});
            if (cursor.moveToNext()) {
                name = cursor.getString(0) == null ? "" : cursor.getString(0);
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("根据编号获取产品名称异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return name;
    }

    /**
     * 获取所有可盘点产品信息
     */
    public static ProductEntity GetCanPanDianProductsForNew(String itemId, String storeId) {
        ProductEntity p = null;
        Cursor cursor = null;
        String sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 "
                + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
                + "  where t3.PDSTAT ='Y' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') and t1.itemid = '" + itemId + "'";

        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setBarcode(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
            }
        } catch (Exception e) {
            BaseAppManager.loger().info("获取所有可盘产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return p;
    }

//    /**
//     * 获取所有可盘点产品信息
//     */
//    public static PrinterUtil.PrinterRule GetCanPanDianProductsForNewPrint(String itemId, PrinterUtil.PrinterRule printerRule) {
//        Cursor cursor = null;
//        String sql = "select t1.itemid,t1.INGREDIENT,t1.SAVECONDITION,t2.BarType,t2.Barcode,t1.proarea,t1.prosupplier "
//                + " from item001 t1,cpbarbill002 t2 where t1.itemId = t2.itemId "
//                + " and t1.itemid = '" + itemId + "'";
//        try {
//            cursor = BaseAppManager.database().rawQuery(sql, null);
//            while (cursor.moveToNext()) {
//                printerRule.mType = cursor.getString(cursor.getColumnIndex("BarType"));
//                printerRule.mCode = cursor.getString(cursor.getColumnIndex("Barcode"));
//                printerRule.mIngredient = cursor.getString(cursor.getColumnIndex("INGREDIENT"));
//                printerRule.mSaveCondition = cursor.getString(cursor.getColumnIndex("SAVECONDITION"));
//                printerRule.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
//                printerRule.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
//            }
//        } catch (Exception e) {
//            BaseAppManager.loger().info("获取所有可盘产品信息发生异常:" + e);
//        } finally {
//            if (cursor != null) {
//                cursor.close();
//            }
//        }
//        return printerRule;
//    }

    /**
     * 获取所有可盘点产品信息
     *
     * @param storeId
     * @return
     */
    public static List<ProductEntity> GetCanPanDianProducts(String storeId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "";
        if (TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill " + "    where t3.PDSTAT ='Y'"; // 产品目录子表
            // 盘点状态
            // 字段为'Y'
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
                    + "  where t3.PDSTAT ='Y' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') " + "  order by t1.itemid";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(0);
                p.setAmount(0);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有可盘产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 0);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 0);
                    }
                }
            }
        }
        return list;
    }

    /**
     * 获取所有可订货产品信息
     *
     * @param storeId
     * @return
     */
    public static List<ProductEntity> GetCanDingHuoProducts(String storeId, String type) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "";
        /*
         * if (TextUtils.isEmpty(storeId)){ sql =
         * "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, "
         * +"  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice from  item001 t1 "
         * +
         * "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
         * +"    where t3.DHSTAT ='Y' and t1.itemtype ='"+type+"'"; //产品目录子表
         * 订货状态 字段为'Y' } else{ sql =
         * "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, "
         * +"  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice from  item001 t1 "
         * +
         * "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
         * +"  where t3.DHSTAT ='Y' and t1.itemtype= '"+type+
         * "' and t3.bill in (select cpbill from store001 where storeid='"
         * +storeId+"') " +"  order by t1.itemid"; }
         */
        if (TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.classid,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.lastmonth_qty,t1.stock_qty,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
                    + "    where t3.DHSTAT ='Y' and t1.classid ='" + type + "'"; // 产品目录子表
            // 订货状态
            // 字段为'Y'
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.classid,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.lastmonth_qty,t1.stock_qty,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill " + "  where t3.DHSTAT ='Y' and t1.classid= '"
                    + type + "' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') " + "  order by t1.itemid";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                // p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setLastMonth_qty(cursor.getString(cursor.getColumnIndex("LASTMONTH_QTY")));
                p.setStock_Qty(cursor.getString(cursor.getColumnIndex("STOCK_QTY")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1.0);
                p.setAmount(p.getPrice());
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有订货产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 1);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 1);
                    }
                }
            }
        }
        return list;
    }

    /**
     * 获取所有可订货产品信息
     *
     * @param storeId
     * @return
     */
    public static List<ProductEntity> GetCanDingHuoProducts(String storeId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "";
        if (TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.lastmonth_qty,t1.stock_qty,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill " + "    where t3.DHSTAT ='Y'"; // 产品目录子表
            // 订货状态
            // 字段为'Y'
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.lastmonth_qty,t1.stock_qty,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
                    + "  where t3.DHSTAT ='Y'  and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') " + "  order by t1.itemid";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setLastMonth_qty(cursor.getString(cursor.getColumnIndex("LASTMONTH_QTY")));
                p.setStock_Qty(cursor.getString(cursor.getColumnIndex("STOCK_QTY")));
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(1.0);
                p.setAmount(p.getPrice());
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有订货产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 1);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 1);
                    }
                }
            }
        }
        return list;
    }

    public static List<ProductEntity> GetAllCanDingHuoProducts(String storeId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql = "";
        if (TextUtils.isEmpty(storeId)) {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.lastmonth_qty,t1.stock_qty,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill " + "    where t3.DHSTAT ='Y'"; // 产品目录子表
            // 订货状态
            // 字段为'Y'
        } else {
            sql = "select t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + "  t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t1.lastmonth_qty,t1.stock_qty,t1.proarea,t1.prosupplier,t1.brand,t1.classid from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
                    + "  where t3.DHSTAT ='Y'  and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') " + "  order by t1.itemid";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                String LastMonth_qty = cursor.getString(cursor.getColumnIndex("LASTMONTH_QTY"));
                p.setLastMonth_qty(TextUtils.isEmpty(LastMonth_qty) ? "0" : LastMonth_qty);
                String Stock_Qty = cursor.getString(cursor.getColumnIndex("STOCK_QTY"));
                p.setStock_Qty(TextUtils.isEmpty(Stock_Qty) ? "0" : Stock_Qty);
                p.setProArea(cursor.getString(cursor.getColumnIndex("PROAREA")));
                p.setProSupplier(cursor.getString(cursor.getColumnIndex("PROSUPPLIER")));
                p.setBrand(cursor.getString(cursor.getColumnIndex("BRAND")));
                p.setClassid(cursor.getString(cursor.getColumnIndex("CLASSID")));
                p.setTQTY(0.0);
                p.setAmount(0.0);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有订货产品信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        if (!SystemHelper.IsAdmin) {
            for (ProductEntity p : list) {
                // 是否有调价
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId, 0);
                }
            }
        } else {
            if (!TextUtils.isEmpty(storeId)) {
                for (ProductEntity p : list) {
                    if (p != null) {
                        Item005DbOperate.GetTiaoJia(p, storeId, 0);
                    }
                }
            }
        }
        return list;
    }

    /**
     * 根据itemId获取包装规格
     *
     * @param itemid
     * @return
     */
    public static double GetProductPack(String itemid) {
        double DHPack = 0;
        Cursor cursor = null;
        String sql = "select dhpack from item001 where itemid='" + itemid + "'";
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            if (cursor.moveToNext()) {
                DHPack = cursor.isNull(0) ? 0 : cursor.getDouble(0);
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("根据itemId获取包装规格异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return DHPack;
    }

    /**
     * 获取所有可订货产品类型
     *
     * @param storeId
     * @return
     */
    public static List<String> GetCanDingHuoProductsType(String storeId) {
        List<String> list = new ArrayList<String>();
        Cursor cursor = null;
        String sql = "";
        /*
         * if (TextUtils.isEmpty(storeId)){ sql =
         * "select t1.ITEMTYPE from  item001 t1 "
         * +"  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
         * +"    where t3.DHSTAT ='Y' group by t1.ITEMTYPE"; } else{ sql =
         * "select t1.ITEMTYPE " +"   from  item001 t1 "
         * +"  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill "
         * +
         * "  where t3.DHSTAT ='Y' and t3.bill in (select cpbill from store001 where storeid='"
         * +storeId+"') " +"  group by t1.ITEMTYPE"; }
         */
        if (TextUtils.isEmpty(storeId)) {
            sql = "select t1.CLASSID from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill " + "    where t3.DHSTAT ='Y' group by t1.CLASSID";
        } else {
            sql = "select t1.CLASSID " + "   from  item001 t1 " + "  join cpbill002 t3 on t1.itemid=t3.itemid  and t1.itemgx= t3.bill " + "  where t3.DHSTAT ='Y' and t3.bill in (select cpbill from store001 where storeid='" + storeId + "') " + "  group by t1.CLASSID";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                list.add(cursor.getString(0));
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有订货产品类别发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }
}