package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Item004Db;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 对数据库的增，删，改，查操作
 * 
 * @author Administrator
 * 
 */
public class Item004DbOperate {

	private static DBTool dbTool;

	public Item004DbOperate(Context context) {
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入数据
	 */
	public static Boolean Insert(Item004Db item004) {
		Cursor cursor = null;
		try {
			String sql = "insert into item004(itemID,bartype,mainbar,barcode) values(?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ item004.getItemID(), item004.getBartype(), item004.getMainbar(), item004.getBarcode() });
			return true;
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[Item004DbOperate.Insert]" + e);
			return false;
		}
		finally {
			// database.close();
			if(cursor != null)
				cursor.close();
		}
	}

	/**
	 * 查询方法的基方法，代码的复用，万精油
	 * 
	 * @param sql
	 * @return
	 */
	public static List<Item004Db> selectBy(String sql) {
		List<Item004Db> list = new ArrayList<Item004Db>();
		Cursor cursor = null;
		String sqlStr = "select * from item004 ";
		if(sql != null)
			sqlStr += sql;
		try {
			cursor = BaseAppManager.database().rawQuery(sqlStr, new String[]{});
			while (cursor.moveToNext()) {
				Item004Db model = new Item004Db();
				model.setItemID(cursor.getString(cursor.getColumnIndex("itemID")));
				model.setBartype(cursor.getString(cursor.getColumnIndex("comm")));
				model.setMainbar(cursor.getString(cursor.getColumnIndex("bartype")));
				model.setBarcode(cursor.getString(cursor.getColumnIndex("barcode")));
				if(model.getBarcode() != null && model.getBarcode().length() > 0) {
					list.add(model);
				}
			}
		}
		catch (Exception e) {

			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除所有数据
	 */
	public static Boolean deleteAllGoods(String sql) {
		Boolean result = false;
		String sqlStr = "Delete from item004 ";
		if(sql != null) {
			sqlStr += sql;
		}
		try {
			BaseAppManager.database().execSQL(sqlStr);
			result = true;
		}
		catch (Exception e) {

			result = false;
			BaseAppManager.loger().info(e);
		}
		finally {
		}
		return result;
	}
}
