package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Jfdh001Db;
import com.urovo.wgmf.db.dao.entitys.JiFenDuiHuanUploadEntity;
import com.urovo.wgmf.db.dao.entitys.LPItem;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 积分兑换结果表中间表
 * 
 * @author Administrator
 *
 */
public class Jfdh001DbOperate {
	public static DBTool dbTool;

	public Jfdh001DbOperate(Context context) {
		
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入方法
	 */
	public static Boolean Insert(Jfdh001Db jfModel) {
		Boolean result = false;
		try {
			String strSql = "insert into JFDH001(Bill,StoreID,StwhsID,PosID,Dhdate,Dhtime," + "DhNO,CustID,SkyID,ItemID,Itemmode,Dhqty,Price,Kcjf,Isup,Yxjf,LpitemID)" + "values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			BaseAppManager.database().execSQL(strSql, new String[]{ jfModel.getBill(), jfModel.getStoreID(), jfModel.getStwhsID(), jfModel.getPosID(), jfModel.getDhdate(), jfModel.getDhtime(), jfModel.getDhNO() + "", jfModel.getCustID(), jfModel.getSkyID(), jfModel.getItemID(), jfModel.getItemmode(),
					jfModel.getDhqty() + "", jfModel.getPrice() + "", jfModel.getKcjf() + "", jfModel.getIsup() + "", jfModel.getYxjf() + "", jfModel.getLpitemID() });
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[Jfdh001DbOperate.Insert]" + e);

		}
		return result;
	}

	/**
	 * 删除方法
	 */
	public static Boolean deleteBy(String sql) {
		Boolean result = false;
		try {
			String strSql = "delete from JFDH001";
			if(sql != null) {
				strSql += sql;
			}
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {

			BaseAppManager.loger().info(e);
		}
		return result;
	}

	/**
	 * 查询方法
	 */
	public static List<Jfdh001Db> selectBy(String sql) {
		List<Jfdh001Db> list = new ArrayList<Jfdh001Db>();
		Cursor cursor = null;
		try {
			String strSql = "select * from JFDH001 ";
			if(sql != null) {
				strSql += sql;
			}
			cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
			while (cursor.moveToNext()) {
				Jfdh001Db jfModel = new Jfdh001Db();
				jfModel.setBill(cursor.getString(cursor.getColumnIndex("BILL")));
				jfModel.setStoreID(cursor.getString(cursor.getColumnIndex("STOREID")));
				jfModel.setStwhsID(cursor.getString(cursor.getColumnIndex("STWHSID")));
				jfModel.setPosID(cursor.getString(cursor.getColumnIndex("POSID")));
				jfModel.setDhdate(cursor.getString(cursor.getColumnIndex("DHDATE")));
				jfModel.setDhtime(cursor.getString(cursor.getColumnIndex("DHTIME")));
				jfModel.setDhNO(cursor.getInt(cursor.getColumnIndex("DHNO")));
				jfModel.setCustID(cursor.getString(cursor.getColumnIndex("CUSTID")));
				jfModel.setSkyID(cursor.getString(cursor.getColumnIndex("SKYID")));
				jfModel.setItemID(cursor.getString(cursor.getColumnIndex("ITEMID")));
				jfModel.setItemmode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
				jfModel.setDhqty(cursor.getInt(cursor.getColumnIndex("DHQTY")));
				jfModel.setPrice(cursor.getInt(cursor.getColumnIndex("PRICE")));
				jfModel.setKcjf(cursor.getInt(cursor.getColumnIndex("KCJF")));
				jfModel.setIsup(cursor.getInt(cursor.getColumnIndex("IsUp")));
				jfModel.setYxjf(cursor.getInt(cursor.getColumnIndex("YXJF")));
				if(jfModel.getBill() != null && jfModel.getBill().length() > 0) {
					list.add(jfModel);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null)
				cursor.close();
		}
		return list;
	}

	/**
	 * 保存兑换单明细数据到本地数据库
	 */
	public static void SaveJiFenDuiHuan(JiFenDuiHuanUploadEntity ent, List<LPItem> list) {
		String sql = "insert into JFDH001(bill,storeid,stwhsid,posid,dhdate,dhtime,dhno,custid," + " skyid,itemid,itemmode,dhqty,price,kcjf,yxjf,lpitemid,isup ) " + " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		try {
			BaseAppManager.database().beginTransaction();
			for (LPItem p : list) {
				BaseAppManager.database()
						.execSQL(
								sql,
								new Object[]{ ent.getBill(), ent.getStoreId(), ent.getSTWHSID(), ent.getPOSID(), ent.getDHDate(), ent.getDHTime(), p.getSeq_No(), ent.getCUSTID(), ent.getSkyId(), p.getItemId(), p.ItemMode, p.getQuantity(), p.getPrice(), p.getTotalUseJF(), ent.getYXJF(),
										p.getLPItemId(), "0" });
			}
			BaseAppManager.database().setTransactionSuccessful();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("保存积分兑换数据发生异常:" + e);
		}
		finally {
			BaseAppManager.database().endTransaction();
		}
	}

	public static List<JiFenDuiHuanUploadEntity> GetUnUpload() {
		Cursor dr = null;
		List<JiFenDuiHuanUploadEntity> list = new ArrayList<JiFenDuiHuanUploadEntity>();
		String sqlCommand = "select bill,storeid,dhdate,dhtime,custid,skyid,yxjf,dhno from jfdh001 where IsUp=0 limit 1 ";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{});
			if(dr != null) {
				while (dr.moveToNext()) {
					JiFenDuiHuanUploadEntity ent = new JiFenDuiHuanUploadEntity();
					ent.setBill(dr.isNull(0) ? "" : dr.getString(0));
					ent.setStoreId(dr.isNull(1) ? "" : dr.getString(1));
					ent.setDHDate(dr.isNull(2) ? DateUtil.formatDate(curDate) : dr.getString(2));
					ent.setDHTime(dr.isNull(3) ? DateUtil.format(curDate, "HHmmss") : dr.getString(3));
					ent.setCUSTID(dr.isNull(4) ? "" : dr.getString(4));
					ent.setSkyId(dr.isNull(5) ? "" : dr.getString(5));
					ent.setYXJF(dr.isNull(6) ? 0 : dr.getDouble(6));
					ent.setDHNo(dr.isNull(7) ? list.size() + 1 : (int) (dr.getInt(7)));
					list.add(ent);
				}
			}
			for (JiFenDuiHuanUploadEntity ent : list) {
				List<LPItem> lists = GetBillDetail(ent.getBill());
				LPItem[] lps = new LPItem[lists.size()];
				lists.toArray(lps);
				ent.setLPItemDetails(lps);
			}
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("获取未上传积分兑换主表发生异常:" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return list;
	}

	/**
	 * 获取全部未上传数据
	 * 
	 * @return
	 */
	public static List<JiFenDuiHuanUploadEntity> GetAllUnUpload() {
		Cursor dr = null;
		List<JiFenDuiHuanUploadEntity> list = new ArrayList<JiFenDuiHuanUploadEntity>();
		String sqlCommand = "select bill,storeid,dhdate,dhtime,custid,skyid,yxjf,dhno from jfdh001 where IsUp=0 ";
		try {
			Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
			dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{});
			if(dr != null) {
				while (dr.moveToNext()) {
					JiFenDuiHuanUploadEntity ent = new JiFenDuiHuanUploadEntity();
					ent.setBill(dr.isNull(0) ? "" : dr.getString(0));
					ent.setStoreId(dr.isNull(1) ? "" : dr.getString(1));
					ent.setDHDate(dr.isNull(2) ? DateUtil.formatDate(curDate) : dr.getString(2));
					ent.setDHTime(dr.isNull(3) ? DateUtil.format(curDate, "HHmmss") : dr.getString(3));
					ent.setCUSTID(dr.isNull(4) ? "" : dr.getString(4));
					ent.setSkyId(dr.isNull(5) ? "" : dr.getString(5));
					ent.setYXJF(dr.isNull(6) ? 0 : dr.getDouble(6));
					ent.setDHNo(dr.isNull(7) ? list.size() + 1 : (int) (dr.getInt(7)));
					list.add(ent);
				}
			}
			/*
			 * for (JiFenDuiHuanEntity ent : list) { List<LPItem> lists =
			 * GetBillDetail(ent.getBill()); LPItem[] lps = new
			 * LPItem[lists.size()]; lists.toArray(lps);
			 * ent.setLPItemDetails(lps); }
			 */
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("获取未上传积分兑换主表发生异常:" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return list;
	}

	public static List<LPItem> GetBillDetail(String bill) {
		Cursor dr = null;
		List<LPItem> list = new ArrayList<LPItem>();
		String sqlCommand = "select itemid,dhqty,price,kcjf,lpitemid from jfdh001 where bill='" + bill + "'";
		try {
			dr = BaseAppManager.database().rawQuery(sqlCommand, null);
			if(dr != null) {
				while (dr.moveToNext()) {
					LPItem ent = new LPItem();
					ent.setItemId(dr.isNull(0) ? "" : dr.getString(0));
					ent.setQuantity(dr.isNull(1) ? 0 : dr.getDouble(1));
					ent.setTotalUseJF(dr.isNull(3) ? 0 : dr.getDouble(3));
					ent.setLPItemId(dr.isNull(4) ? "" : dr.getString(4));

					// 获取ehdkg
					ent.setEHD_KG(GetEHD_KG(ent.getLPItemId()));

					// 取价格
					ent.setPrice(dr.isNull(2) ? 0 : dr.getDouble(2));

					list.add(ent);
				}
			}
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("根据兑换单号获取兑换礼品明细发生异常:" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return list;
	}

	public static double GetEHD_KG(String lpitemid) {
		double ehdkg = 1;
		Cursor dr = null;
		try {
			String sql = "select ehd_kg from t_dhlpitem where lpitemid='" + lpitemid + "'";
			dr = BaseAppManager.database().rawQuery(sql, null);
			if(dr != null) {
				if(dr.moveToNext()) {
					ehdkg = dr.isNull(0) ? 1 : dr.getDouble(0);
				}
			}

		}
		catch (Exception ex) {
			BaseAppManager.loger().info("根据礼品编号获取ehdkg发生异常:" + ex);
		}
		finally {
			if(dr != null) {
				dr.close();
			}
		}
		return ehdkg;
	}

	public static int GetUnUploadCount() {
		int total = 0;
		Cursor cursor = null;
		String sql = "select count(bill) from jfdh001 where IsUp=0";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			if(cursor.moveToNext()) {
				total = cursor.getInt(0);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info("获取未上传积分兑换单据总数发生异常:" + e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return total;
	}

	/*
	 * public static List<Jfdh001Db> GetUnUpload() { String
	 * sql=" where IsUp='0'"; return selectBy(sql); }
	 */

	/**
	 * 更新上传信息
	 * 
	 * @param bill
	 */
	public static void UpdateBillState(String bill) {

		String sqlCommand = "update jfdh001 set IsUp='1' where bill=?";
		try {
			BaseAppManager.database().execSQL(sqlCommand, new String[]{ bill });
		}
		catch (Exception ex) {
			BaseAppManager.loger().info("更新积分兑换上传单据" + bill + "上传状态发生异常:" + ex);
		}

	}

}
