package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.Pdaparam;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

public class PdaparamOperate {
	public static DBTool dbTool;

	public PdaparamOperate(Context context) {
		
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入方法
	 */
	public static Boolean Insert(Pdaparam model) {
		Boolean result = false;
		try {
			String sql = "Insert into PDAParam(ParamID,Paramname,Paramvalue,Paramdesc)" + "values(?,?,?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ model.getParamId(), model.getParamName(), model.getParamValue(), model.getParamDesc() });
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[PdaparamOperate.Insert]" + e);

		}
		return result;
	}

	/**
	 * 删除方法
	 */
	public static Boolean deleteBy(String sql) {
		Boolean result = false;
		try {
			String strSql = "delete from PDAParam";
			if(sql != null) {
				strSql += sql;
			}
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		return result;
	}

	/**
	 * 查询方法
	 */
	public static List<Pdaparam> selectBy(String sql) {
		List<Pdaparam> list = new ArrayList<Pdaparam>();
		Cursor cursor = null;
		try {
			String strSql = "select * from PDAParam";
			if(sql != null) {
				strSql += sql;
			}
			cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
			while (cursor.moveToNext()) {
				Pdaparam pdModel = new Pdaparam();
				pdModel.setParamId(cursor.getString(cursor.getColumnIndex("ParamID")));
				pdModel.setParamName(cursor.getString(cursor.getColumnIndex("Paramname")));
				pdModel.setParamValue(cursor.getString(cursor.getColumnIndex("Paramvalue")));
				pdModel.setParamDesc(cursor.getString(cursor.getColumnIndex("Paramdesc")));
				if(pdModel.getParamId() != null && pdModel.getParamId().length() > 0) {
					list.add(pdModel);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null)
				cursor.close();
		}
		return list;
	}

	public static void UpdatePDAParam(Pdaparam ent) {
		String sql = "update PDAParam set paramValue=?,paramName=?,paramDesc=? where paramId=?";
		try {
			BaseAppManager.database().execSQL(sql, new Object[]{ ent.getParamValue(), ent.getParamName(), ent.getParamDesc(), ent.getParamId() });
		}
		catch (Exception e) {
			BaseAppManager.loger().info("保存终端配置参数发生异常:" + e);
		}
	}
}
