package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.LPItem;
import com.urovo.wgmf.db.dao.entitys.T_dhlpitemDb;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class T_dhlpitemDbOperate {
    public static DBTool dbTool;

    public T_dhlpitemDbOperate(Context context) {

        super();
        dbTool = DBTool.getInstance(context);
    }

    /**
     * 插入方法
     */
    public static Boolean Insert(T_dhlpitemDb model) {
        Boolean result = false;
        try {
            String sql = "insert into t_dhlpitem(lpitemid,lpitemname,lpuom,dhusejf,dhdates,dhdatee,Ehd_kg,ItemID)" + "values(?,?,?,?,?,?,?,?)";
            BaseAppManager.database().execSQL(sql, new String[]{model.getLpitemID(), model.getLpitemname(), model.getLpuom(), model.getDhusejf() + "", model.getDhdates(), model.getDhdatee(), model.getEhd_kg() + "", model.getItemID()});
            result = true;
        } catch (Exception e) {

            BaseAppManager.loger().info("[T_dhlpitemDbOperate.Insert]" + e);

        }
        return result;
    }

    /**
     * 查询方法
     */
    public static List<T_dhlpitemDb> selectBy(String sql) {
        List<T_dhlpitemDb> list = new ArrayList<T_dhlpitemDb>();
        Cursor cursor = null;
        try {
            String strSql = "select * from t_dhlpitem";
            if (sql != null) {
                strSql += sql;
            }
            cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
            while (cursor.moveToNext()) {
                T_dhlpitemDb tModel = new T_dhlpitemDb();
                tModel.setLpitemID(cursor.getString(cursor.getColumnIndex("lpitemid")));
                tModel.setLpitemname(cursor.getString(cursor.getColumnIndex("lpitemname")));
                tModel.setLpuom(cursor.getString(cursor.getColumnIndex("lpuom")));
                tModel.setDhusejf(cursor.getInt(cursor.getColumnIndex("dhusejf")));
                tModel.setDhdates(cursor.getString(cursor.getColumnIndex("dhdates")));
                tModel.setEhd_kg(cursor.getInt(cursor.getColumnIndex("ehd_kg")));
                tModel.setItemID(cursor.getString(cursor.getColumnIndex("itemid")));
                if (tModel.getLpitemID() != null && tModel.getLpitemID().length() > 0) {
                    list.add(tModel);
                }
            }
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;
    }

    /**
     * 根据门店号获得礼品信息
     *
     * @param storeId 门店ID号，为空表示门店模式
     * @return
     */
    public static List<LPItem> GetLPItems(String storeId) {
        List<LPItem> list = new ArrayList<LPItem>();
        LPItem p = null;
        Cursor dr = null;
        try {
            Date curDate = new Date(System.currentTimeMillis());// 获取当前时间
            String sqlCommand = "select t1.lpitemid,t1.lpitemname,t1.lpuom,t1.dhusejf,t1.dhdates,t1.dhdatee,t1.itemid,t1.ehd_kg,t2.normrprice from t_dhlpitem t1 " +
                    "								left join item001 t2 on t1.itemid=t2.itemid" + " where t1.dhdates <=? and t1.dhdatee>=? ";
            if (!TextUtils.isEmpty(storeId)) {
                sqlCommand += " and storeid=?";
                dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{DateUtil.format(curDate, "yyyy-MM-dd 00:00:00"), DateUtil.format(curDate, "yyyy-MM-dd 23:59:59"), storeId});
            } else {
                dr = BaseAppManager.database().rawQuery(sqlCommand, new String[]{DateUtil.format(curDate, "yyyy-MM-dd 00:00:00"), DateUtil.format(curDate, "yyyy-MM-dd 23:59:59")});
            }

            if (dr != null) {
                while (dr.moveToNext()) {
                    p = new LPItem();
                    p.setLPItemId(dr.isNull(0) ? "" : dr.getString(0));
                    p.setLPItemName(dr.isNull(1) ? "" : dr.getString(1));
                    p.setLPUom(dr.isNull(2) ? "" : dr.getString(2));
                    p.setUseJF(dr.isNull(3) ? 0 : dr.getDouble(3));
                    p.setDHDateS(dr.isNull(4) ? DateUtil.formatDate(curDate) : dr.getString(4));
                    p.setDHDateE(dr.isNull(5) ? DateUtil.formatDate(curDate) : dr.getString(5));
                    p.setItemId(dr.isNull(6) ? "" : dr.getString(6));
                    p.setEHD_KG(dr.isNull(7) ? 1 : dr.getDouble(7));

                    p.setQuantity(1);
                    p.setTotalUseJF(Arith.mul(p.getUseJF(), p.getQuantity()));
                    p.setPrice(dr.isNull(8) ? 0 : dr.getDouble(8));
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有积分兑换礼品信息发生异常:" + e);
        } finally {
            if (dr != null) {
                dr.close();
            }
        }
        if (!TextUtils.isEmpty(storeId)) {
            for (LPItem l : list) {
                if (p != null) {
                    Item005DbOperate.GetTiaoJia(p, storeId);
                }
            }
        }
        return list;
    }

    /**
     * 删除方法
     */
    public static Boolean deleteBy(String sql) {
        Boolean result = false;
        try {
            String strSql = "delete from t_dhlpitem";
            if (sql != null) {
                strSql += sql;
            }
            BaseAppManager.database().execSQL(strSql);
            result = true;
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

        }
        return result;
    }
}
