package com.urovo.wgmf.db.dao.dao;

import android.content.Context;
import android.database.Cursor;

import com.urovo.wgmf.db.dao.DBTool;
import com.urovo.wgmf.db.dao.entitys.BsyyEntity;
import com.urovo.wgmf.db.dao.entitys.UserdtrDb;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

public class UserdtrDbOperate {
	public static DBTool dbTool;

	public UserdtrDbOperate(Context context) {
		
		super();
		dbTool = DBTool.getInstance(context);
	}

	/**
	 * 插入语句
	 */
	public static Boolean Insert(UserdtrDb userModel) {
		Boolean result = false;
		try {
			String sql = "insert into USERDTR(userId,userName)values(?,?)";
			BaseAppManager.database().execSQL(sql, new String[]{ userModel.getUserID(), userModel.getUsername() });
			result = true;
		}
		catch (Exception e) {

			BaseAppManager.loger().info("[UserdtrDbOperate.Insert]" + e);

		}
		return result;
	}

	/**
	 * 查询方法
	 */
	public static List<UserdtrDb> selectBy(String sql) {
		List<UserdtrDb> list = new ArrayList<UserdtrDb>();
		String strSql = "select * from USERDTR";
		if(sql != null) {
			strSql += sql;
		}
		Cursor cursor = null;
		try {
			cursor = BaseAppManager.database().rawQuery(strSql, new String[]{});
			while (cursor.moveToNext()) {
				UserdtrDb userModel = new UserdtrDb();
				userModel.setUserID(cursor.getString(cursor.getColumnIndex("userId")));
				userModel.setUsername(cursor.getString(cursor.getColumnIndex("userName")));
				if(userModel.getUserID() != null && userModel.getUserID().length() > 0) {
					list.add(userModel);
				}
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

	/**
	 * 删除方法
	 */
	public static Boolean deleteBy(String sql) {
		Boolean result = false;
		try {
			String strSql = "delete from USERDTR";
			BaseAppManager.database().execSQL(strSql);
			result = true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		return result;
	}

	public static List<BsyyEntity> GetBsyy() {
		Cursor cursor = null;
		List<BsyyEntity> list = new ArrayList<BsyyEntity>();
		String sql = "select userid,username from userdtr where userid not in('08','09')";
		try {
			cursor = BaseAppManager.database().rawQuery(sql, null);
			while (cursor.moveToNext()) {
				BsyyEntity ent = new BsyyEntity();
				ent.id = cursor.getString(cursor.getColumnIndex("USERID"));
				ent.name = cursor.getString(cursor.getColumnIndex("USERNAME"));
				list.add(ent);
			}
		}
		catch (Exception e) {
			BaseAppManager.loger().info(e);
		}
		finally {
			if(cursor != null) {
				cursor.close();
			}
		}
		return list;
	}

}
