package com.urovo.wgmf.db.dao.dao;

import android.database.Cursor;
import android.text.TextUtils;

import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.XBZPFEntity;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

public class XbzpfDbOperate {

    /**
     * 删除所有数据
     */
    public static Boolean deleteAllGoods(String sql) {
        Boolean result = false;
        String sqlStr = "Delete from Xbzpf ";
        if (sql != null) {
            sqlStr += sql;
        }
        try {
            BaseAppManager.database().execSQL(sqlStr);
            result = true;
        } catch (Exception e) {
            BaseAppManager.loger().info(e);

            result = false;
        } finally {
        }
        return result;
    }

    /**
     * 根据门店获取十方产品
     */
    public static List<ProductEntity> GetShiFangItems(String storeId) {
        List<ProductEntity> list = new ArrayList<ProductEntity>();
        Cursor cursor = null;
        String sql;
        if (!TextUtils.isEmpty(storeId)) {
            // sql = "select distinct t1.itemid,t2.itemname,t3.sortno"
            // +" from xbzpf t1,item001 t2"
            // +" join cpbill002 t3 on t1.itemid=t3.itemid "
            // +" where t3.bill in (select cpbill from store001 where storeid='"+storeId+"')"
            // +" and t1.itemid=t2.itemid "
            // +" order by t3.sortno";

            sql = "select distinct t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t3.sortno " + " from item001 t1,xbzpf t2,cpbill002 t3 " + " where t3.XSGRPID !='999' and t3.bill in" + " (select cpbill from store001 where storeid='"
                    + storeId + "')" + " and t1.itemid=t2.itemid and t1.itemid=t3.itemid" + " order by t3.sortno";
        } else {
            sql = "select distinct t1.itemid,t1.itemname,t1.itemmode,t1.itemtype,t1.kcuom, " + " t1.qtyinteger,t1.dhpack,t1.unit,t1.normrprice,t3.sortno" + " from item001 t1,xbzpf t2 join cpbill002 t3 on t2.itemid=t3.itemid" + " where t1.itemid=t2.itemid " + " order by t3.sortno";
        }

        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                ProductEntity p = new ProductEntity();
                p.setItemId(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                p.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                p.setItemType(cursor.getString(cursor.getColumnIndex("ITEMTYPE")));
                p.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                p.setQtyInteger(cursor.getString(cursor.getColumnIndex("QTYINTEGER")));
                p.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
                p.setUnit(cursor.getDouble(cursor.getColumnIndex("UNIT")));
                p.setPrice(cursor.getDouble(cursor.getColumnIndex("NORMRPRICE")));
                p.setSortNo(cursor.getDouble(cursor.getColumnIndex("SORTNO")));
                p.setTQTY(1);
                p.setAmount(p.getPrice() * 1);
                boolean exist = false;
                for (ProductEntity ent : list) {
                    if (p.getItemId().equals(ent.getItemId())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取所有十方信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        // if(!SystemHelper.IsAdmin){
        // for(ProductEntity p : list){
        // //是否有调价
        // if (p != null) {
        // Item005DbOperate.GetTiaoJia(p, SystemHelper.LoginOrganId);
        // }
        // }
        // }else{
        // if(StringUtils.isEmpty(storeId)){
        // for(ProductEntity p : list){
        // if(p != null){
        // Item005DbOperate.GetTiaoJia(p, storeId);
        // }
        // }
        // }
        // }
        return list;

    }

    // region 获取产品辅助信息（名称、模式、单位、规格）
    public static ProductEntity GetProductDetail(String itemId) {
        Cursor cursor = null;
        String sql = null;
        ProductEntity entity = null;
        try {
            sql = "select itemname,itemmode,kcuom,dhpack from item001 where itemid='" + itemId + "'";
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                entity = new ProductEntity();
                // p.setItemName(cursor.getString(cursor.getColumnIndex("ITEMNAME")));
                entity.setItemMode(cursor.getString(cursor.getColumnIndex("ITEMMODE")));
                entity.setKCUom(cursor.getString(cursor.getColumnIndex("KCUOM")));
                entity.setDHPack(cursor.getDouble(cursor.getColumnIndex("DHPACK")));
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取产品辅助信息发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return entity;
    }

    /**
     * 根据十方组合编码获得成分信息
     */
    public static List<XBZPFEntity> GetShiFangDetail(String ItemId) {
        List<XBZPFEntity> list = new ArrayList<XBZPFEntity>();
        Cursor cursor = null;
        String sql = null;
        if (!TextUtils.isEmpty(ItemId)) {
            sql = "select t1.*,t2.itemname,t3.itemname as THENAME " + " from xbzpf t1,item001 t2 left join item001 t3 on t1.itemid=t3.itemid" + " where t1.itemid='" + ItemId + "'" + " and t1.xbzid=t2.itemid";
        }
        try {
            cursor = BaseAppManager.database().rawQuery(sql, null);
            while (cursor.moveToNext()) {
                XBZPFEntity p = new XBZPFEntity();
                p.setITEMNAME(cursor.getString(cursor.getColumnIndex("THENAME")));
                p.setITEMID(cursor.getString(cursor.getColumnIndex("ITEMID")));
                p.setXBZID(cursor.getString(cursor.getColumnIndex("XBZID")));
                p.setWEIGHT(cursor.getDouble(cursor.getColumnIndex("WEIGHT")));
                p.setBZQTY(cursor.getDouble(cursor.getColumnIndex("BZQTY")));
                p.setSJQTY(cursor.getDouble(cursor.getColumnIndex("SJQTY")));
                p.setBZPRICE(cursor.getDouble(cursor.getColumnIndex("BZPRICE")));
                p.setSJPRICE(cursor.getDouble(cursor.getColumnIndex("SJPRICE")));
                p.setXBZNAME(cursor.getString(cursor.getColumnIndex("ITEMNAME")));

                boolean exist = false;
                for (XBZPFEntity ent : list) {
                    if (p.getXBZID().equals(ent.getXBZID())) {
                        exist = true;
                        break;
                    }
                }
                if (!exist) {
                    list.add(p);
                }
            }
        } catch (Exception e) {

            BaseAppManager.loger().info("获取十方详情发生异常:" + e);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
        return list;

    }
}
