package com.urovo.wgmf.db.dao.entitys;

import android.text.TextUtils;

import com.urovo.wugumofang.response.Base3Response;

import java.io.Serializable;
import java.util.List;

/**
 * Created by Sasuke on 2017/4/20.
 * 就是配送收货左边标签的那个请求的返回。
 */

public class PeiSongBillRes extends Base3Response {

    private List<itemBill> resultInfo;

    public List<itemBill> getResultInfo() {
        return resultInfo;
    }

    public void setResultInfo(List<itemBill> resultInfo) {
        this.resultInfo = resultInfo;
    }

    public static class itemBill implements Serializable{
        /**
         * dispatchBill : 991703140001
         * boxReceivedNum : 0
         * boxUnreceivedNum : 0
         * dispatchDate : 2017-03-14
         * dispatchType : 主动配送
         * dispatchPerson : 冯军烈
         * dispatchId : 1639852
         * dispatchStatus : 0
         * receivedDate : null
         * receivedUserNo : null
         * storeNo : 1810110
         * initiativeList : [{"proName":"耗费品-八珍1KG","proCode":"2.40019","proQty":1,"proAmount":0}]
         * passiveList : [{"boxCode":"99006088399","boxPack":"辅料","boxAmount":0,"boxQty":0,"boxId":3701560,"boxStatus":"1","detailList":[{"proName":"价格贴","proCode":"--","proQty":0,"proAmount":0}]},{"boxCode":"99006088417","boxPack":"辅料","boxAmount":0,"boxQty":0,"boxId":3701578,"boxStatus":"1","detailList":[{"proName":"价格贴","proCode":"--","proQty":0,"proAmount":0}]},{"boxCode":"99006088446","boxPack":"整箱","boxAmount":596,"boxQty":20,"boxId":3701607,"boxStatus":"1","detailList":[{"proName":"提子燕麦片","proCode":"2.40045","proQty":20,"proAmount":596}]},{"boxCode":"99006088447","boxPack":"整箱","boxAmount":691.2,"boxQty":12,"boxId":3701608,"boxStatus":"1","detailList":[{"proName":"提子燕麦片(560g)","proCode":"2.40143","proQty":12,"proAmount":691.2}]},{"boxCode":"99006088448","boxPack":"整箱","boxAmount":1428,"boxQty":6,"boxId":3701609,"boxStatus":"1","detailList":[{"proName":"植物益生元八珍","proCode":"2.40142","proQty":6,"proAmount":1428}]},{"boxCode":"99006088449","boxPack":"整箱","boxAmount":1428,"boxQty":6,"boxId":3701610,"boxStatus":"1","detailList":[{"proName":"植物益生元八珍","proCode":"2.40142","proQty":6,"proAmount":1428}]},{"boxCode":"99006088450","boxPack":"整箱","boxAmount":1008,"boxQty":6,"boxId":3701611,"boxStatus":"1","detailList":[{"proName":"益元八珍彩包版","proCode":"2.40141","proQty":6,"proAmount":1008}]},{"boxCode":"99006088451","boxPack":"整箱","boxAmount":1008,"boxQty":6,"boxId":3701612,"boxStatus":"1","detailList":[{"proName":"益元八珍彩包版","proCode":"2.40141","proQty":6,"proAmount":1008}]},{"boxCode":"99006088456","boxPack":"散装","boxAmount":510,"boxQty":50,"boxId":3701617,"boxStatus":"1","detailList":[{"proName":"红小豆","proCode":"2.20033","proQty":10,"proAmount":78},{"proName":"黑芝麻(80g)","proCode":"2.20037","proQty":20,"proAmount":156},{"proName":"山药","proCode":"2.20042","proQty":20,"proAmount":276},{"proName":"价格贴","proCode":"--","proQty":0,"proAmount":0}]},{"boxCode":"99006088467","boxPack":"散装","boxAmount":344,"boxQty":45,"boxId":3701628,"boxStatus":"1","detailList":[{"proName":"燕麦","proCode":"2.20030","proQty":10,"proAmount":68},{"proName":"红枣干","proCode":"2.20043","proQty":20,"proAmount":276},{"proName":"五谷伴侣集锦装3+3","proCode":"2.40174","proQty":10,"proAmount":0},{"proName":"植物益生元八珍套装3+3","proCode":"2.40175","proQty":5,"proAmount":0}]},{"boxCode":"99006088475","boxPack":"散装","boxAmount":672,"boxQty":40,"boxId":3701636,"boxStatus":"1","detailList":[{"proName":"薏米","proCode":"2.20035","proQty":20,"proAmount":276},{"proName":"核桃仁(70g)","proCode":"2.20051","proQty":20,"proAmount":396}]}]
         * storeName : 北京华联甘肃临夏店
         */
        private int brandId;//品牌类型id
        private String brandName;//品牌名
        private String dispatchBill;//配送单号
        private int boxReceivedNum;//未收箱数量（界面上只用显示未收箱数就行了）
        private int boxUnreceivedNum;//已收箱数量
        private String dispatchFactory;//配送工厂
        private String dispatchDate;//配送时间
        private String dispatchType;//配送类型("主动配送"，"被动配送"，"配送返仓"，"配送红冲")
        private String dispatchPerson;//制单人员
        private String dispatchReason;//配送原因
        private int dispatchId;//配送id
        private String dispatchStatus;//配送状态
        private String receivedDate;//收货日期
        private String receivedUserNo;//收货人工号
        private String storeNo;//门店号
        private String storeName;//门店名
        private List<InitiativeListBean> initiativeList;//主动收货列表
        private List<PassiveListBean> passiveList;//被动收货列表

        //如果那什么和为0，说明要强转成主动配送
        public void force2ActiveType(){
            if ( boxReceivedNum + boxUnreceivedNum == 0 ){
                dispatchType = "主动配送";//如果和为0，那就要把type重新赋为 主动配送。
            }
        }

        /**是否显示配送原因（主动配送、配送返仓、配送红冲 需要显示配送原因，被动配送隐藏原因）*/
        public boolean isShowDispatchReason(){
            return "主动配送、配送返仓、配送红冲".contains(getDispatchType());
        }

        public String getBrandName() {
            if (brandName == null){
                return "";
            }
            return brandName;
        }

        public boolean isPassiveListNull(){
            return getPassiveList() == null || getPassiveList().size() == 0;
        }

        public boolean isInitiativeListNull(){
            return getInitiativeList() == null || getInitiativeList().size() == 0;
        }


        public String getDispatchFactory() {
            return dispatchFactory;
        }

        public String getDispatchBill() {
            return dispatchBill;
        }

        public void setDispatchBill(String dispatchBill) {
            this.dispatchBill = dispatchBill;
        }

        public int getBoxReceivedNum() {
            return boxReceivedNum;
        }

        public void setBoxReceivedNum(int boxReceivedNum) {
            this.boxReceivedNum = boxReceivedNum;
        }

        public int getBoxUnreceivedNum() {
            return boxUnreceivedNum;
        }

        public void setBoxUnreceivedNum(int boxUnreceivedNum) {
            this.boxUnreceivedNum = boxUnreceivedNum;
        }

        public String getDispatchDate() {
            return dispatchDate;
        }

        public void setDispatchDate(String dispatchDate) {
            this.dispatchDate = dispatchDate;
        }

        public String getDispatchType() {
            return dispatchType;
        }

        public void setDispatchType(String dispatchType) {
            this.dispatchType = dispatchType;
        }

        /**配送原因*/
        public String getDispatchReason() {
            return TextUtils.isEmpty(dispatchReason)? "" : dispatchReason;
        }

        public String getDispatchPerson() {
            return dispatchPerson;
        }

        public void setDispatchPerson(String dispatchPerson) {
            this.dispatchPerson = dispatchPerson;
        }

        public int getDispatchId() {
            return dispatchId;
        }

        public void setDispatchId(int dispatchId) {
            this.dispatchId = dispatchId;
        }

        public String getDispatchStatus() {
            return dispatchStatus;
        }

        public void setDispatchStatus(String dispatchStatus) {
            this.dispatchStatus = dispatchStatus;
        }

        public String getReceivedDate() {
            return receivedDate;
        }

        public void setReceivedDate(String receivedDate) {
            this.receivedDate = receivedDate;
        }

        public String getReceivedUserNo() {
            return receivedUserNo;
        }

        public void setReceivedUserNo(String receivedUserNo) {
            this.receivedUserNo = receivedUserNo;
        }

        public String getStoreNo() {
            return storeNo;
        }

        public void setStoreNo(String storeNo) {
            this.storeNo = storeNo;
        }

        public String getStoreName() {
            return storeName;
        }

        public void setStoreName(String storeName) {
            this.storeName = storeName;
        }

        public List<InitiativeListBean> getInitiativeList() {
            return initiativeList;
        }

        public void setInitiativeList(List<InitiativeListBean> initiativeList) {
            this.initiativeList = initiativeList;
        }

        public List<PassiveListBean> getPassiveList() {
            return passiveList;
        }

        public void setPassiveList(List<PassiveListBean> passiveList) {
            this.passiveList = passiveList;
        }

        public static class InitiativeListBean implements Serializable{
            /**
             * proName : 耗费品-八珍1KG
             * proCode : 2.40019
             * proQty : 1
             * proAmount : 0
             */

            private String proName;//产品名
            private String proCode;//产品编码
            private double proQty;//产品数量
            private double proAmount;//产品价格

            public String getProName() {
                return proName;
            }

            public void setProName(String proName) {
                this.proName = proName;
            }

            public String getProCode() {
                return proCode;
            }

            public void setProCode(String proCode) {
                this.proCode = proCode;
            }

            public double getProQty() {
                return proQty;
            }

            public void setProQty(double proQty) {
                this.proQty = proQty;
            }

            public double getProAmount() {
                return proAmount;
            }

            public void setProAmount(double proAmount) {
                this.proAmount = proAmount;
            }
        }

        public static class PassiveListBean implements Serializable{
            /**
             * boxCode : 99006088399
             * boxPack : 辅料
             * boxAmount : 0
             * boxQty : 0
             * boxId : 3701560
             * boxStatus : 1
             * detailList : [{"proName":"价格贴","proCode":"--","proQty":0,"proAmount":0}]
             */

            private String boxCode;//装箱单号
            private String boxPack;//包装方式
            private double boxAmount;//箱子中产品金额
            private double boxQty;//箱子中产品数量
            private int boxId;//箱子id
            private String boxStatus;//箱子状态 2：正常 3：破损     ---》后面这个老规则不用了//箱子状态,1：未到； 2：正常  3：差异
            private List<DetailListBean> detailList;//箱子中产品明细
            public boolean isVerify = false;//是否有处理（接口就没这字段，自己加了做个标记，）

            public String getBoxCode() {
                return boxCode;
            }

            public void setBoxCode(String boxCode) {
                this.boxCode = boxCode;
            }

            public String getBoxPack() {
                return boxPack;
            }

            public void setBoxPack(String boxPack) {
                this.boxPack = boxPack;
            }

            public double getBoxAmount() {
                return boxAmount;
            }

            public void setBoxAmount(double boxAmount) {
                this.boxAmount = boxAmount;
            }

            public double getBoxQty() {
                return boxQty;
            }

            public void setBoxQty(double boxQty) {
                this.boxQty = boxQty;
            }

            public int getBoxId() {
                return boxId;
            }

            public void setBoxId(int boxId) {
                this.boxId = boxId;
            }

            public String getBoxStatus() {
                return boxStatus;
            }

            public void setBoxStatus(String boxStatus) {
                this.boxStatus = boxStatus;
            }

            public List<DetailListBean> getDetailList() {
                return detailList;
            }

            public void setDetailList(List<DetailListBean> detailList) {
                this.detailList = detailList;
            }

            public static class DetailListBean implements Serializable {
                /**
                 * proName : 价格贴
                 * proCode : --
                 * proQty : 0
                 * proAmount : 0
                 */

                private String proName;
                private String proCode;
                private double proQty;
                private double proAmount;

                public String getProName() {
                    return proName;
                }

                public void setProName(String proName) {
                    this.proName = proName;
                }

                public String getProCode() {
                    return proCode;
                }

                public void setProCode(String proCode) {
                    this.proCode = proCode;
                }

                public double getProQty() {
                    return proQty;
                }

                public void setProQty(double proQty) {
                    this.proQty = proQty;
                }

                public double getProAmount() {
                    return proAmount;
                }

                public void setProAmount(double proAmount) {
                    this.proAmount = proAmount;
                }
            }
        }
    }
}
