package com.urovo.wugumofang.base;


import com.urovo.wugumofang.net.ApiException;

import io.reactivex.functions.Consumer;


/**
 * @author chenji
 */
public abstract class AbstractFailureConsumer<T> implements Consumer<T> {
    /**
     * 失败
     *
     * @param errorMsg ...
     */
    protected abstract void onFailure(String errorMsg) throws Exception;

    @Override
    public void accept(T t) throws Exception {
        String error = ApiException.handleException((Throwable) t).getMessage();
        onFailure(error);
    }
}
