package com.urovo.wugumofang.base;

import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.app.AppCompatDelegate;

import android.text.TextUtils;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.umeng.analytics.MobclickAgent;
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate;
import com.urovo.wugumofang.base.mvp.AbsView;
import com.urovo.wugumofang.libutils.R;
import com.urovo.wugumofang.loader.PrivilegeDownloader;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.response.Base3Response;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.ui.DialogHelper.DialogResult;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.CommonTools;
import com.urovo.wugumofang.view.LoadWaitDominator;
import com.zsy.libcore.ui.act.SYActManager;

import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;

import cn.jpush.android.api.JPushInterface;
import kotlin.Unit;
import kotlin.jvm.functions.Function0;

/**
 * @author ...
 */
public class BaseActivity extends AppCompatActivity implements AbsView, DialogResult, AdapterResult {
    //解决smartRefreshLayout的【XML inflating error && vector矢量图资源not found】导致的崩溃问题（在POS机这种低版本安卓上出现 ）
    static {
        AppCompatDelegate.setCompatVectorFromResourcesEnabled(true);
    }

    private static final String TAG = BaseActivity.class.getName();
    protected RelativeLayout titile_bg;
    protected ImageButton back;
    protected TextView titleTextView;
    protected ImageButton settinButton;
    protected Button submit;
    protected Button complete;
    protected Boolean backFlag = false;
//    protected Boolean isClearScanCode = false;
    /**
     * 防止上传未完成时，上传按钮被狂点。(请求已经有全屏弹窗，加个双保险，让西门(ex:不需要管他了,都是离职的人了)放一万个心！)
     */
    public boolean mUpLoadFlag = true;
    private List<BasePresenter> mAllPresenters;

    protected Context mContext;

    /**
     * 加载状态类
     */
    private LoadWaitDominator mLoadWaitDominator;

    /**
     * 获取子类BasePresenter，多数情况下一个activity只有一个BasePresenter时复写该方法
     */
    protected BasePresenter addPresenter() {
        return null;
    }

    /**
     * 获取BasePresenter，一个activity有可能有多个BasePresenter时需要复写该方法
     */
    protected List<BasePresenter> getPresenters() {
        List<BasePresenter> presenters = new ArrayList<>();
        presenters.add(addPresenter());
        return presenters;
    }

    protected void addPresenter(BasePresenter basePresenter) {
        mAllPresenters.add(basePresenter);
    }

    private void addPresenters() {
        mAllPresenters = getPresenters();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED);
        super.onCreate(savedInstanceState);

        int rootId = addRootLayoutId();
        if (rootId > 0) {
            setContentView(rootId);
        }
        initPdaConfig();

        SYActManager.getInstance().addActivity(this);
        addPresenters();
        if (mAllPresenters != null) {
            for (BasePresenter presenter : mAllPresenters) {
                if (presenter != null) {
                    //presenter.onCreate();
                }
            }
        }

        mContext = this;
        ViewGroup root = rootViewGroup();
        if (root != null) {
            mLoadWaitDominator = new LoadWaitDominator(this, root);
        }

        //解决沉浸式下，有虚拟按键时，虚拟按键会遮挡布局的问题
//        if (AndroidWorkaround.checkDeviceHasNavigationBar(this)) {
//            AndroidWorkaround.assistActivity(findViewById(android.R.id.content));
//        }

//        if (mHttpUtils == null) {
//            mHttpUtils = new HttpUtils();
//            //请求头大概这么加
//            if (!NetParam.getNetHeaders().isEmpty()) {
//                for (String key : NetParam.getNetHeaders().keySet()) {
//                    mHttpUtils.getHttpClient().getParams().setParameter(key, NetParam.getNetHeaders().get(key));
//                }
//            }
//        }
        initViewNew();
        initDataNew();
    }

    public void displayResult(String tag, BaseResponse response) {
        try {
            if (null != response) {
                if (0 != ((Base3Response) response).msgCode) {
                    // showMsg(response.sysContent);
//                    showMsg("网络异常");
                    if (!TextUtils.isEmpty(response.msgInfo)) {
                        showMsg(response.msgInfo);
                    }
                    response = null;
                    // } else if (!response.msgCode.equals("0")) {
                    // showMsg(response.msgContent);
                    // response= null;
                    // return;
                }
            }
            SystemHelper.NewInterface = true;
        } catch (Exception e) {
            Log.d(TAG, "访问的是老接口-" + e.toString());
            SystemHelper.NewInterface = false;
        }
    }

    public void uploadFailed() {

    }

    public void initTitle() {
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
        titile_bg = findViewById(R.id.relativeLayout1);
        back = findViewById(R.id.back);
        titleTextView = findViewById(R.id.text_title);
        submit = findViewById(R.id.confirm);
        complete = findViewById(R.id.complete);
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (backFlag) {
                    DialogHelper.showBackDialog(BaseActivity.this);
                } else {
//                    if (isClearScanCode) {
//                        PreferHelper.getInstance().remove("scan");
//                    }
                    back();
                }
            }
        });
        settinButton = findViewById(R.id.settinButton);
    }

    protected int addRootLayoutId() {
        return -1;
    }

    /**
     * 初始化 initData
     * 临时使用方法
     */
    protected void initDataNew() {
    }

    /**
     * 初始化 initView
     * 临时使用方法
     */
    protected void initViewNew() {
    }

    /**
     * 容器 ViewGroup
     */
    protected ViewGroup rootViewGroup() {
        return null;
    }

    public void focus(View view) {
        view.setFocusable(true);
        view.setFocusableInTouchMode(true);
        view.requestFocus();
    }

    protected String getName() {
        return "none";
    }

    private String getPageName() {
        if (null != titleTextView) {
            String temp = titleTextView.getText().toString();
            if (temp.startsWith("产品销售查询")) {
                temp = "产品销售查询";
            }
            return temp;
        } else {
            return getName();
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        //依次调用IPresenter的onResume方法
        if (mAllPresenters != null) {
            for (BasePresenter presenter : mAllPresenters) {
                if (presenter != null) {
                    presenter.onResume();
                }
            }
        }

        initPdaConfig();
        MobclickAgent.onPageStart(getPageName());
        MobclickAgent.onResume(this);
        JPushInterface.onResume(this);//用于统计的API
        JPushInterface.requestPermission(this);//安卓6.0以上申请权限
        //隐藏虚拟按键
//        AndroidWorkaround.hideBottomUIMenu(this);
    }

    @Override
    protected void onPause() {
        super.onPause();
        if (mAllPresenters != null) {
            for (BasePresenter presenter : mAllPresenters) {
                if (presenter != null) {
                    presenter.onPause();
                }
            }
        }
        MobclickAgent.onPageEnd(getPageName());
        MobclickAgent.onPause(this);
        JPushInterface.onPause(this);
    }

    @Override
    protected void onStart() {
        super.onStart();
        if (mAllPresenters != null) {
            for (BasePresenter presenter : mAllPresenters) {
                if (presenter != null) {
                    presenter.onStart();
                }
            }
        }
    }

    @Override
    protected void onDestroy() {
        SYActManager.getInstance().finishActivity(this);
        ViewUtil.dismissProgress();
        super.onDestroy();
        dismissLoading();
        if (mAllPresenters != null) {
            for (BasePresenter presenter : mAllPresenters) {
                if (presenter != null) {
                    presenter.onDestroy();
                }
            }
        }
    }

    private void initPdaConfig() {
        SystemHelper.LoginOrganId = PdaMsgConfig.getLoginOrgID(BaseActivity.this);
        SystemHelper.IsAdmin = PdaMsgConfig.getIsAdmin(BaseActivity.this);
        SystemHelper.LoginOrganName = PdaMsgConfig.getLoginOrganName(BaseActivity.this);
        SystemHelper.LoginUserId = PdaMsgConfig.getLogUserId(BaseActivity.this);
        SystemHelper.LoginUserName = PdaMsgConfig.getLoginUserName(BaseActivity.this);
    }

    protected void back() {
        this.finish();
    }

    /**
     * Toast提示
     */
    public void showMsg(final String msg) {
        if (!isFinishing()) {
            runOnUiThread(() -> Toast.makeText(BaseActivity.this, msg, Toast.LENGTH_SHORT).show());
        }
    }

    /**
     * 子线程更新UI
     *
     * @param msg ...
     */
    protected void makeToastByHandlerPost(final Context context, final String msg) {
        runOnUiThread(() -> Toast.makeText(context, msg, Toast.LENGTH_SHORT).show());
    }

    protected void makeToastByHandlerPost(final Context context, final String msg, final int gravity) {
        runOnUiThread(() -> {
            Toast toast = Toast.makeText(context, msg, Toast.LENGTH_SHORT);
            toast.setGravity(gravity, 0, 0);
            toast.show();
        });
    }

    @Override
    public void onDialogResult(int tag) {
    }

    @Override
    public void doResult(int position) {

    }

    public void netError() {

    }

    public void displayNoNet(String tag) {
    }

    /**
     * 刷新权限状态
     * PS:权限下载失败的状态和网络在线的状态同时存在才刷新(保证权限变化是从默认的刷新转换到在线的)
     */
    protected void refreshPrivilege() {
        if (!PrivilegeDbOperate.Companion.isPrivilegeDownSuccess() && NetHelper.IsHaveInternet(this)) {
            new PrivilegeDownloader(BaseActivity.this,
                    SystemHelper.LoginUserId,
                    SystemHelper.LoginOrganId,
                    new Function0<Unit>() {
                        @Override
                        public Unit invoke() {
                            afterRefreshPrivilege();
                            return null;
                        }
                    }).
                    setIsShowProgress(false).download();
        }
    }

    /**
     * 权限刷新后有操作重写此方法
     */
    public void afterRefreshPrivilege() {
    }

    /**
     * 打卡完成后的操作（弹窗提示）
     */
    public void afterSignInAndOut() {

    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
//        finish();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (event.getAction() == 0) {
            if (keyCode == KeyEvent.KEYCODE_BACK) {
                finish();
                return true;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    protected void gotoHomeTab(Class<?> cls) {
        this.finish();
        Intent intent = new Intent();
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        intent.setClass(this, cls);
        startActivity(intent);
    }

    /**
     * 权限弹窗提示，让用户手动去设置页面设置必要的权限。
     */
    protected void permissionDialog(CharSequence message) {
        DialogHelper.onAlertDialog(BaseActivity.this, message, null, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
//                            startActivity(new Intent(Settings.ACTION_SETTINGS));
                CommonTools.INSTANCE.startAppSettings(BaseActivity.this);
            }
        });
    }

    /**
     * 统一处理
     */
    protected void permissionDialog() {
        permissionDialog(getResources().getString(R.string.string_help_text));
    }

    @Override
    public void showToast(@Nullable String msg) {
        if (!isFinishing()) {
            runOnUiThread(() -> Toast.makeText(BaseActivity.this, msg, Toast.LENGTH_SHORT).show());
        }
    }

    @Override
    public void showToast(int resId) {
        showToast(getString(resId));
    }

    @Override
    public void showTipDialog(String msg) {
        if (!TextUtils.isEmpty(msg)) {
            ViewUtil.showProgress(this, "请稍等", msg);
        }
    }

    @Override
    public void showTipDialog(int resId) {
        if (resId > 0) {
            ViewUtil.showProgress(this, "请稍等", getString(resId));
        }
    }

    @Override
    public void dismissDialog() {
        ViewUtil.dismissProgress();
    }


    @Override
    public void showIsLoading() {
        if (mLoadWaitDominator != null) {
            mLoadWaitDominator.show(LoadWaitDominator.LOADING);
        }
    }

    public void setStatusBackgroundColor(int color) {
        if (mLoadWaitDominator != null) {
            mLoadWaitDominator.setBackgroundColor(color);
        }
    }

    public void setStatusImg(int resId) {
        if (mLoadWaitDominator != null) {
            mLoadWaitDominator.setStatusImg(resId);
        }
    }

    @Override
    public void showError(String msg) {
        if (mLoadWaitDominator != null) {
            if (TextUtils.isEmpty(msg)) {
                mLoadWaitDominator.show("netError");
            } else {
                mLoadWaitDominator.show(msg);
            }
        }
    }

    @Override
    public void showError(int resId) {
        if (mLoadWaitDominator != null) {
            if (resId > 0) {
                mLoadWaitDominator.show(getString(resId));
            } else {
                mLoadWaitDominator.show("netError");
            }
        }
    }

    /**
     * 显示无数据文案
     */
    public void showNoData(int message, int target, View.OnClickListener listener) {
        mLoadWaitDominator.showNoData(message, target, listener);
    }


    @Override
    public void showState(int state) {
        if (mLoadWaitDominator != null) {
            mLoadWaitDominator.show(state);
        }
    }


    @Override
    public void dismissLoading() {
        if (mLoadWaitDominator != null) {
            mLoadWaitDominator.dismissLoading();
        }
    }

    @Override
    public Resources getResources() {
        Resources res = super.getResources();
        Configuration config = new Configuration();
        config.setToDefaults();
        res.updateConfiguration(config, res.getDisplayMetrics());
        return res;
    }


    @Override
    public void dismissAllState() {
        if (mLoadWaitDominator != null) {
            mLoadWaitDominator.dismissAll();
        }
    }
}
