package com.urovo.wugumofang.base.mvp

import com.urovo.wugumofang.base.BasePresenter
import io.reactivex.disposables.CompositeDisposable
import io.reactivex.disposables.Disposable

/**
 * @author LW
 */
abstract class AbsPresenter : BasePresenter {

    protected val mDisposable: CompositeDisposable = CompositeDisposable()

    override fun onStart() {

    }

    override fun onResume() {
    }

    override fun onPause() {
    }

    override fun onDestroy() {
        clearDisposable()
    }

    protected fun addDisposable(disposable: Disposable?) {
        mDisposable.add(disposable)
    }

    protected fun removeDisposable(disposable: Disposable?) {
        mDisposable.remove(disposable)
    }

    protected fun clearDisposable() {
        mDisposable.clear()
    }

    protected fun isEmpty(str: CharSequence?): Boolean {
        return str == null || str.length == 0 || "null" == str
    }
}