package com.urovo.wugumofang.constants

import com.urovo.wgmf.db.dao.dao.AppRetcodeDbOperate

/**
 * @author LW
 * 网络请求错误码/状态码，映射成后台给的对应的提示信息
 */

object AppRetCodeMap {

    @JvmStatic
    fun statusDbMap(status: String): String {
        return AppRetcodeDbOperate.getInfoByStatusCode(status)
    }

    /**
     * 传入一个defaultStatus，如果调上面的statusDbMap返回为空，就把这个默认的status给返回去
     */
    @JvmStatic
    fun statusDbMap(status: String, defaultStatus: String): String {
        return statusDbMap(status).takeIf { it.isNotEmpty() }?.run { this } ?: defaultStatus
    }
}