package com.urovo.wugumofang.constants;

import android.content.Context;
import android.os.Environment;
import android.text.TextUtils;

import com.urovo.wugumofang.libutils.BuildConfig;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.DeviceHelper;

import java.io.File;
import java.io.FilenameFilter;

public class Files {
    public static String fileProviderAuth = "com.urovo.wugumofang.fileprovider";//注：PackageUtil Line:100 引用不到这个变量。
    public static String photoPath = Environment.getExternalStorageDirectory() + "/wgmf/photo/";
    public static String tempPicture = Environment.getExternalStorageDirectory() + "/wgmf/pictures/";
    public static String logfile = Environment.getExternalStorageDirectory() + "/wgmf/log/";
    public static String errfile = Environment.getExternalStorageDirectory() + "/wgmf/err/";
    public static String downfile = Environment.getExternalStorageDirectory() + "/wgmf/upg/";
    public static String upgname = "update.zip";
    public static String apkDataPath = "/data/data/" + BuildConfig.APPLICATION_ID;
    //public static String apkDataPath = "/data/data/" + BuildConfig.LIBRARY_PACKAGE_NAME;
    public static String apkBakPath = Environment.getExternalStorageDirectory() + "/wgmf/app";
    public static String apkBakPath2 = Environment.getExternalStorageDirectory() + "/wgmf/app";

    /**
     * 私有目录下的Files目录，用来缓存signinAndout
     */
    public static String priPhotoPath = BaseAppManager.appContext().getFilesDir().getAbsolutePath() + "/signInAndOut/";

    /**
     * 把图片的url按MD5转成文件名
     */
    public static String transUrl2Filename(String url) {
        String subffix = "";
        if (url.endsWith(".jpg")) {
            subffix = ".jpg";
        } else if (url.endsWith(".jpeg")) {
            subffix = ".jpeg";
        } else if (url.endsWith(".png")) {
            subffix = ".png";
        } else if (url.endsWith(".bmp")) {
            subffix = ".bmp";
        } else if (url.endsWith(".gif")) {
            subffix = ".gif";
        } else if (url.endsWith(".webp")) {
            subffix = ".webp";
        } else if (url.endsWith(".mp4")) {
            subffix = ".mp4";
        } else if (url.endsWith(".avi")) {
            subffix = ".avi";
        } else if (url.endsWith(".flv")) {
            subffix = ".flv";
        } else if (url.endsWith(".mkv")) {
            subffix = ".mkv";
        }
        return DeviceHelper.getMD5Str(url) + subffix;
    }

    /***
     * 离线打卡情况下，缓存照片，自动上传时从这里拿图片上传。
     *
     * 如果要返回父文件夹，就 fun("")[0]
     * 如果要返回一个照片缓存数组，就直接 fun("XXX")
     *
     * 注：如果图片名以下划线开头，则说明还未加上打卡单号
     * @return
     */
    public static File[] getSignInAndOutPhotoCache(String billtag) {
        File homeDir = new File(BaseAppManager.appContext().getExternalFilesDir(null), "sign_in_and_out_photo/");
        homeDir.mkdirs();
//        File photoFile = new File(homeDir,billtag +".cache");
        if (TextUtils.isEmpty(billtag)) {
            File[] folder = new File[]{homeDir};
            return folder;
        } else {
            return homeDir.listFiles(new FilenameFilter() {
                @Override
                public boolean accept(File dir, String name) {
                    return name.startsWith(billtag);
                }
            });
        }
    }


    /**
     * 拼接出 [ 验证门店接口缓存文件 ] 的文件名
     *
     * @param storeId
     * @return
     */
    public static File getCheckStoreCache(String storeId) {
        File homeDir = new File(BaseAppManager.appContext().getCacheDir(), "check_store_cache");
        homeDir.mkdirs();
        return TextUtils.isEmpty(storeId) ? homeDir : new File(homeDir, "checkstore_" + storeId + ".cache");
    }

    /**
     * 拼接出 [ 下载基础资料接口缓存文件 ] 的文件名
     *
     * @param storeId
     * @return
     */
    public static File getBasicDataCache(String storeId) {
        File homeDir = new File(BaseAppManager.appContext().getCacheDir(), "basic_data_cache");
        homeDir.mkdirs();
        return TextUtils.isEmpty(storeId) ? homeDir : new File(homeDir, "basicdata_" + storeId + ".cache");
    }

    /*
     * 创建文件夹
     */
    public static void createFile(Context context) {
        try {
            if (!Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {// 判断是否有sd卡
                String interPath = DeviceHelper.getInterPath(context);
                photoPath = interPath + "/wgmf/photo/";
                tempPicture = interPath + "/wgmf/pictures/";
                logfile = interPath + "/wgmf/log/";
                errfile = interPath + "/wgmf/err/";
                downfile = interPath + "/../";
            } else {
                String sdcard = DeviceHelper.getSDPath();
                photoPath = sdcard + "/wgmf/photo/";
                tempPicture = sdcard + "/wgmf/pictures/";
                logfile = sdcard + "/wgmf/log/";
                errfile = sdcard + "/wgmf/err/";
                downfile = sdcard + "/wgmf/upg/";
            }
            File files = new File(logfile);
            File errfiles = new File(errfile);
            File pohoFiles = new File(photoPath);
            File nomediaFile = new File(photoPath + ".nomedia");
            File nomediaFile2 = new File(tempPicture + ".nomedia");
            File pictureFiles = new File(tempPicture);
            if (!files.exists()) {
                files.mkdirs();
            }
            if (!errfiles.exists()) {
                errfiles.mkdirs();
            }
            if (!pohoFiles.exists()) {
                pohoFiles.mkdirs();
            }
            if (!nomediaFile.exists()) {
                nomediaFile.createNewFile();
            }
            if (nomediaFile2.exists()) {
                nomediaFile2.delete();
            }
            if (!pictureFiles.exists()) {
                pictureFiles.mkdirs();
            }
            String cmd = "chmod 777 " + files.getAbsolutePath();
            String cmd2 = "chmod 777 " + errfiles.getAbsolutePath();
            String cmd3 = "chmod 777" + pohoFiles.getAbsolutePath();
            String cmd4 = "chmod 777" + pictureFiles.getAbsolutePath();

            Runtime.getRuntime().exec(cmd);
            Runtime.getRuntime().exec(cmd2);
            Runtime.getRuntime().exec(cmd3);
            Runtime.getRuntime().exec(cmd4);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static String getLogfile() {
        return logfile;
    }

    public static void setLogfile(String logfile) {
        Files.logfile = logfile;
    }

    public static String getPhotoPath() {
        return photoPath;
    }

    public static void setPhotoPath(String photoPath) {
        Files.photoPath = photoPath;
    }

    public static String getDownfile() {
        return downfile;
    }

    public static void setDownfile(String downfile) {
        Files.downfile = downfile;
    }
}
