package com.urovo.wugumofang.data;

import com.urovo.wugumofang.data.PreferHelper;

/**
 * Created by Sasuke on 2017/4/5.
 * 在Pref存一个maxNum长度个元素的历史记录
 */

public class PrefHistoryUtil {
    /**
     * 存maxNum个元素的历史记录
     *
     * @param key
     * @param newItem
     * @param maxNum
     */
    public static void saveHistory(String key, String newItem, int maxNum) {
        String history = PreferHelper.getInstance().getString(key);
        if (history.contains(newItem)) {//如果已经保存过该记录，那就不用执行后面了。
            return;
        }
        String[] array = history.split(",");
        StringBuffer sb = new StringBuffer(newItem);
        int num = array.length < maxNum ? array.length : maxNum - 1;
        for (int i = 0; i < num; i++) {//只添加array前4个
            sb.append("," + array[i]);
        }
        PreferHelper.getInstance().setString(key, sb.toString());
    }

    /***
     * 从历史记录中删除一项
     *
     * @param key
     * @param goal
     */
    public static void deleteHistory(String key, String goal) {
        String history = PreferHelper.getInstance().getString(key);
        if (!history.contains(goal)) {//如果没找到，那就不用删了。
            return;
        }
        history = history.replace(goal, "");
        history = history.replace(",,", ",");
        if (history.startsWith(",")) {
            history = history.substring(1);
        }
        if (history.endsWith(",")) {
            history = history.substring(0, history.length() - 1);
        }
        PreferHelper.getInstance().setString(key, history);
    }

    public static void clear(String key) {
        PreferHelper.getInstance().setString(key, "");
    }
}


