package com.urovo.wugumofang.net;

import android.text.TextUtils;
import android.util.Log;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.ProtocolVersion;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.scheme.LayeredSocketFactory;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.scheme.SocketFactory;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.URL;
import java.net.UnknownHostException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.TrustManager;
import javax.net.ssl.TrustManagerFactory;
import javax.net.ssl.X509TrustManager;

public class HttpUtil {
    private static HttpClient httpClient;
    // 最大连接数
    public final static int MAX_CONNECTION_NUMBER = 800;
    // 版本
    public final static ProtocolVersion VERSION = HttpVersion.HTTP_1_1;
    // 设置连接超时时间
    public final static int MAX_TIME_OUT = 30000;// 1分钟
    // 设置获取连接的最大等待时间
    public final static int WAIT_TIME_OUT = 10000;// 1分钟
    public final static int READ_TIME_OUT = 30000;

    public static String appVersion = "";//app版本号
    public static String androidVersion = "";//安卓系统版本号

    /**
     * 为了解藕，把这个单独拉出来，放到登陆里面传值。
     *
     * @param appVersion
     * @param androidVersion
     */
    public static void setVersionInfo(String appVersion, String androidVersion) {
        HttpUtil.appVersion = appVersion;
        HttpUtil.androidVersion = androidVersion;
    }

    static {
        HttpParams params = new BasicHttpParams();
        // 版本
        HttpProtocolParams.setVersion(params, VERSION);
        // 用户代理
        HttpProtocolParams.setUserAgent(params, "shengYiGuanJiaApp/" + appVersion + " (Android; Android " + androidVersion + ");");
        // 编码
        HttpProtocolParams.setContentCharset(params, HTTP.DEFAULT_CONTENT_CHARSET);
        // 最大连接数
        ConnManagerParams.setMaxTotalConnections(params, MAX_CONNECTION_NUMBER);
        // 设置获取连接的最大等待时间
        ConnManagerParams.setTimeout(params, WAIT_TIME_OUT);
        // 设置连接超时时间
        HttpConnectionParams.setConnectionTimeout(params, MAX_TIME_OUT);
        // 设置读取超时时间
        HttpConnectionParams.setSoTimeout(params, READ_TIME_OUT);
        // 计划注册,可以注册多个计划
        SchemeRegistry schReg = new SchemeRegistry();
        schReg.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
        schReg.register(new Scheme("https", new MySSLSocketFactory(), 443));
        ClientConnectionManager conMgr = new ThreadSafeClientConnManager(params, schReg);
        httpClient = new DefaultHttpClient(conMgr, params);
    }

    static HashMap<String, String> myHeaders = new HashMap<>();

    /**
     * 设置统一的请求头
     *
     * @param myHeaders NetParam里面有
     */
    public static void setHeaders(HashMap<String, String> myHeaders) {
        HttpUtil.myHeaders = myHeaders;
    }

    static public class MyHostnameVerifier implements HostnameVerifier {

        @Override
        public boolean verify(String hostname, SSLSession session) {

            return true;
        }
    }

    static public class MySSLSocketFactory implements SocketFactory, LayeredSocketFactory {

        private SSLContext sslcontext = null;

        private static SSLContext createEasySSLContext() throws IOException {
            try {
                SSLContext context = SSLContext.getInstance("TLS");
                context.init(null, new TrustManager[]{new MyX509TrustManager(null)}, null);
                return context;
            } catch (Exception e) {
                throw new IOException(e.getMessage());
            }
        }

        private SSLContext getSSLContext() throws IOException {
            if (this.sslcontext == null) {
                this.sslcontext = createEasySSLContext();
            }
            return this.sslcontext;
        }

        public Socket connectSocket(Socket sock, String host, int port, InetAddress localAddress, int localPort, HttpParams params) throws IOException, UnknownHostException, ConnectTimeoutException {
            int connTimeout = HttpConnectionParams.getConnectionTimeout(params);
            int soTimeout = HttpConnectionParams.getSoTimeout(params);

            InetSocketAddress remoteAddress = new InetSocketAddress(host, port);
            SSLSocket sslsock = (SSLSocket) ((sock != null) ? sock : createSocket());

            if ((localAddress != null) || (localPort > 0)) {
                // we need to bind explicitly
                if (localPort < 0) {
                    localPort = 0; // indicates "any"
                }
                InetSocketAddress isa = new InetSocketAddress(localAddress, localPort);
                sslsock.bind(isa);
            }

            sslsock.connect(remoteAddress, connTimeout);
            sslsock.setSoTimeout(soTimeout);
            return sslsock;

        }

        public Socket createSocket() throws IOException {
            return getSSLContext().getSocketFactory().createSocket();
        }

        public boolean isSecure(Socket socket) throws IllegalArgumentException {
            return true;
        }

        public Socket createSocket(Socket socket, String host, int port, boolean autoClose) throws IOException, UnknownHostException {
            return getSSLContext().getSocketFactory().createSocket(socket, host, port, autoClose);
        }

        // -------------------------------------------------------------------
        // javadoc in org.apache.http.conn.scheme.SocketFactory says :
        // Both Object.equals() and Object.hashCode() must be overridden
        // for the correct operation of some connection managers
        // -------------------------------------------------------------------

        public boolean equals(Object obj) {
            return ((obj != null) && obj.getClass().equals(MySSLSocketFactory.class));
        }

        public int hashCode() {
            return MySSLSocketFactory.class.hashCode();
        }
    }

    static public class MyX509TrustManager implements X509TrustManager {

        private X509TrustManager standardTrustManager = null;

        public MyX509TrustManager(KeyStore keystore) throws NoSuchAlgorithmException, KeyStoreException {
            super();
            TrustManagerFactory factory = TrustManagerFactory.getInstance(TrustManagerFactory.getDefaultAlgorithm());
            factory.init(keystore);
            TrustManager[] trustmanagers = factory.getTrustManagers();
            if (trustmanagers.length == 0) {
                throw new NoSuchAlgorithmException("no trust manager found");
            }
            this.standardTrustManager = (X509TrustManager) trustmanagers[0];
        }

        public void checkClientTrusted(X509Certificate[] certificates, String authType) throws CertificateException {
            standardTrustManager.checkClientTrusted(certificates, authType);
        }

        public void checkServerTrusted(X509Certificate[] certificates, String authType) throws CertificateException {
            if ((certificates != null) && (certificates.length == 1)) {
                certificates[0].checkValidity();
            } else {
                standardTrustManager.checkServerTrusted(certificates, authType);
            }
        }

        public X509Certificate[] getAcceptedIssuers() {
            return this.standardTrustManager.getAcceptedIssuers();
        }
    }

    static public interface downFileProgress {
        void onStart(int total);

        boolean onProgress(int total, int pro);

        void onFinish(int total, int pro);
    }

    public static void downloadFile(String url, String filePath, downFileProgress l) {
        File ZipFile = new File(filePath);
        if (ZipFile.exists()) {
            ZipFile.delete();
        }
        downloadFile(url, ZipFile, l);
    }

    public static void downloadFile(String url, File ZipFile, downFileProgress l) {
        if (null == url || TextUtils.isEmpty(url)) {
            return;
        }
        HttpURLConnection connect;
        InputStream is = null;
        FileOutputStream fos = null;
        try {
            if (url.startsWith("https")) {
                SSLContext sc = SSLContext.getInstance("TLS");
                sc.init(null, new TrustManager[]{new MyX509TrustManager(null)}, new SecureRandom());
                HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
                HttpsURLConnection.setDefaultHostnameVerifier(new MyHostnameVerifier());
                HttpsURLConnection conn = (HttpsURLConnection) new URL(url).openConnection();
                conn.setDoOutput(true);
                conn.setRequestProperty("Content-Type", "application/zip");
                conn.setDoInput(true);
                connect = conn;
            } else {
                connect = (HttpURLConnection) new URL(url).openConnection();
            }
            connect.connect();
            fos = new FileOutputStream(ZipFile);
            is = connect.getInputStream();
            int total = connect.getContentLength();
            if (null != l) {
                l.onStart(total);
            }
            int count = 0;
            byte buf[] = new byte[1024];
//            GlobalApp.loger.info("请求下载" + "URL:" + url + " FILE:" + ZipFile.getName() + " total:" + total);
//             Log.i();
            Log.i("Log", "请求下载" + "URL:" + url + " FILE:" + ZipFile.getName() + " total:" + total);//好烦啊用GlobalApp打日志，不好解藕
            do {
                int numread = is.read(buf);
                count += numread;
                if (null != l) {
                    if (l.onProgress(total, count)) {
                        break;
                    }
                }
                if (numread <= 0) {
                    if (null != l) {
                        l.onFinish(total, count);
                    }
                    break;
                }
                fos.write(buf, 0, numread);
            }
            while (true);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (null != is)
                    is.close();
                if (null != fos)
                    fos.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 添加请求头
     *
     * @param post 要给谁添加请求头
     */
    private static void addHeaderForPost(HttpPost post) {
        if (!myHeaders.isEmpty()) {
            for (String key : myHeaders.keySet()) {
                post.addHeader(key, myHeaders.get(key));
            }
        }
    }

    /**
     * @param url 发送请求的URL
     * @return 服务器响应字符串
     * @throws Exception
     */
    public static String getRequest(final String url) throws Exception {
        httpClient.getParams().setIntParameter("http.socket.timeout", READ_TIME_OUT);
        httpClient.getParams().setIntParameter("http.connection.timeout", MAX_TIME_OUT);
        // 创建HttpGet对象。
        HttpGet get = new HttpGet(url);
        // 发送GET请求
        HttpResponse httpResponse = httpClient.execute(get);
        // 如果服务器成功地返回响应
        if (httpResponse.getStatusLine().getStatusCode() == 200) {

            // 获取服务器响应字符串
            String result = EntityUtils.toString(httpResponse.getEntity());
            return result;
        }
        return null;
    }

    /**
     * @return 服务器响应字符串
     * @throws Exception
     */
    public static int getReadTimeOut() {
        return httpClient.getParams().getIntParameter("http.socket.timeout", -1);
    }

    public static int getConnectTimeOut() {
        return httpClient.getParams().getIntParameter("http.connection.timeout", -1);
    }

    public static String postRequest(final String url, final Map<String, String> rawParams, int sotimeout, int timeout) throws Exception {

        httpClient.getParams().setIntParameter("http.socket.timeout", sotimeout);
        httpClient.getParams().setIntParameter("http.connection.timeout", timeout);

        // 创建HttpPost对象。
        HttpPost post = new HttpPost(url);
        addHeaderForPost(post);//添加统一请求头
        // 如果传递参数个数比较多的话可以对传递的参数进行封装
        List<NameValuePair> params = new ArrayList<NameValuePair>();
        for (String key : rawParams.keySet()) {
            // 封装请求参数
            params.add(new BasicNameValuePair(key, rawParams.get(key)));
        }
        // 设置请求参数
        post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));

        // post.setHeader("Connection", "Keep-Alive");
        // post.addHeader("Accept-Encoding", "gzip");

        // 发送POST请求
        HttpResponse httpResponse = httpClient.execute(post);

        // 如果服务器成功地返回响应
        if (httpResponse.getStatusLine().getStatusCode() == 200) {
            // 获取服务器响应字符串
            return EntityUtils.toString(httpResponse.getEntity());
        }
        return null;
    }

    public static String postRequest(final String url, final Map<String, String> rawParams) throws Exception {
        httpClient.getParams().setIntParameter("http.socket.timeout", READ_TIME_OUT);
        httpClient.getParams().setIntParameter("http.connection.timeout", MAX_TIME_OUT);
        // 创建HttpPost对象。
        HttpPost post = new HttpPost(url);
        addHeaderForPost(post);//添加统一请求头
        //如果键值对长度为1，并且其键为空，那传的就不是键值对，而是json字符串]
        String firstKey="";
        if(rawParams.size()>=1) {
           firstKey = Objects.requireNonNull(rawParams.keySet().toArray())[0].toString();
        }
        if (rawParams.size() == 1&&TextUtils.isEmpty(firstKey)) {
                //添加http头信息
                post.addHeader("Authorization", "日了狗"); //认证token
                post.addHeader("Content-Type", "application/json");
                post.addHeader("User-Agent", "imgfornote");
                post.setEntity(new StringEntity(rawParams.get(firstKey)));
        } else {//一般情况，即如果键值不为空
            // 如果传递参数个数比较多的话可以对传递的参数进行封装
            List<NameValuePair> params = new ArrayList<NameValuePair>();
            for (String key : rawParams.keySet()) {
                // 封装请求参数
                params.add(new BasicNameValuePair(key, rawParams.get(key)));
            }
            // 设置请求参数
            post.setEntity(new UrlEncodedFormEntity(params, "UTF-8"));
        }

        // post.setHeader("Connection", "Keep-Alive");
        // post.addHeader("Accept-Encoding", "gzip");
        // 发送POST请求
        HttpResponse httpResponse = httpClient.execute(post);
        // 如果服务器成功地返回响应
        if (httpResponse.getStatusLine().getStatusCode() == 200) {
            // 获取服务器响应字符串
            return EntityUtils.toString(httpResponse.getEntity());
        }
        return null;
    }

    public static String postRequestForType(final String url, String params) throws Exception {
        httpClient.getParams().setIntParameter("http.socket.timeout", READ_TIME_OUT);
        httpClient.getParams().setIntParameter("http.connection.timeout", MAX_TIME_OUT);
        // 创建HttpPost对象。
        HttpPost post = new HttpPost(url);
        addHeaderForPost(post);//添加统一请求头
        StringEntity stringEntity = new StringEntity(params.toString(), HTTP.UTF_8);
        stringEntity.setContentType("application/json");
//		UrlEncodedFormEntity tempUrlEncodedFormEntity = new UrlEncodedFormEntity(params, "UTF-8");
//		tempUrlEncodedFormEntity.setContentEncoding("UTF-8");
//		tempUrlEncodedFormEntity.setContentType("application/json");
        post.setEntity(stringEntity);
        // 发送POST请求
        HttpResponse httpResponse = httpClient.execute(post);
        // 如果服务器成功地返回响应
        if (httpResponse.getStatusLine().getStatusCode() == 200) {
            // 获取服务器响应字符串
            return EntityUtils.toString(httpResponse.getEntity());
        }
        return null;
    }

}
