package com.urovo.wugumofang.net;

import android.text.TextUtils;
import android.util.Log;

import com.urovo.wugumofang.data.GZIPUtils;

import org.apache.http.conn.ConnectTimeoutException;

import java.net.SocketTimeoutException;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class ResultTool {
    protected static final String TAG = ResultTool.class.getName();

    /**
     * @return ...
     */
    public static String access(String Url, String action, String method, String content) {
        String result = null;
        Map<String, String> params = new HashMap<String, String>();
        Log.i("Log", "请求报文" + "URL:" + Url + "\n" + "action:" + action + "\n" + "method:" + method + "\n" + "content:" + content);
        params.put("action", action);
        params.put("method", method);
        params.put("content", content);
        try {
            result = HttpUtil.postRequest(Url, params);
            Log.i("Log", "响应报文" + result);
        } catch (ConnectTimeoutException e) {
            Log.i("Log", "[ResultTool.access ConnectTimeout:]" + HttpUtil.getConnectTimeOut() + e);
        } catch (SocketTimeoutException e) {

            Log.i("Log", "[ResultTool.access ReadTimeout:]" + HttpUtil.getReadTimeOut() + e);
        } catch (Exception e) {
            Log.i("Log", "[ResultTool.access]" + e);
        }
        return result;
    }

    public static String access(String Url, Map<String, String> params) {
        String result = null;
        try {
            if (params.size() == 1) {//如果key为空，则传的不是键值对而是json
                String firstKey = Objects.requireNonNull(params.keySet().toArray())[0].toString();
                Log.i("Log", "请求报文" + "URL:" + Url + "\n" + params.get(firstKey));
            } else {
                Log.i("Log", "请求报文" + "URL:" + Url + "\n" + params.toString());
            }

            result = HttpUtil.postRequest(Url, params);
            Log.i("Log", "响应报文" + result);
            if (result != null && !result.startsWith("{") && !result.endsWith("}")) {//如果不是JSON，那就尝试用GZIPUtils转个码试试。
                result = GZIPUtils.unzip(result);
//              result =  GZIPUtils.uncompressToString(result.getBytes("utf-8"));
                Log.i("Log", "基础资料用GZIPUtils转为：" + result);
            }

        } catch (ConnectTimeoutException e) {
            Log.i("Log", "[ResultTool.access ConnectTimeout:]" + HttpUtil.getConnectTimeOut() + e);
        } catch (SocketTimeoutException e) {
            Log.i("Log", "[ResultTool.access ReadTimeout:]" + HttpUtil.getReadTimeOut() + e);
        } catch (Exception e) {
            Log.i("Log", "[ResultTool.access]" + e);
        }
        return result;
    }

    public static String access(String Url, Map<String, String> params, int sotimeout, int timeout) {
        String result = null;
        Log.i("Log", "请求报文" + "URL:" + Url + "\n" + params.toString());
        try {
            result = HttpUtil.postRequest(Url, params, sotimeout, timeout);
            Log.i("Log", "响应报文" + result);
        } catch (ConnectTimeoutException e) {
            Log.i("Log", "[ResultTool.access ConnectTimeout:]" + HttpUtil.getConnectTimeOut() + e);
        } catch (SocketTimeoutException e) {

            Log.i("Log", "[ResultTool.access ReadTimeout:]" + HttpUtil.getReadTimeOut() + e);
        } catch (Exception e) {

            Log.i("Log", "[ResultTool.access]" + e);
        }
        return result;
    }

    /**
     * 用于生意管家项目中格式请求
     *
     * @param Url
     * @param params
     * @return
     */
    public static String accessForType(String Url, String params) {
        String result = null;
        Log.i("Log", "请求报文" + "URL:" + Url + "\n" + params.toString());
        try {
            result = HttpUtil.postRequestForType(Url, params);
            Log.i("Log", "响应报文" + result);
        } catch (ConnectTimeoutException e) {
            Log.i("Log", "[ResultTool.access ConnectTimeout:]" + HttpUtil.getConnectTimeOut() + e);
        } catch (SocketTimeoutException e) {

            Log.i("Log", "[ResultTool.access ReadTimeout:]" + HttpUtil.getReadTimeOut() + e);
        } catch (Exception e) {

            Log.i("Log", "[ResultTool.access]" + e);
        }
        return result;
    }
}
