package com.urovo.wugumofang.receiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;

import com.urovo.wugumofang.base.BaseTabAct;
import com.urovo.wugumofang.net.NetHelper;

/**
 * 自定义检查手机网络状态是否切换的广播接受器
 *
 * @author chenji
 * @date 2017/10/16
 */

public class NetBroadcastReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        // 如果相等的话就说明网络状态发生了变化
        if (intent.getAction().equals(ConnectivityManager.CONNECTIVITY_ACTION)) {
            int netWorkState = NetHelper.getNetWorkState(context);
            // 接口回调传过去状态的类型
            if (BaseTabAct.mEvent != null) {
                BaseTabAct.mEvent.onNetChange(netWorkState);
            }
        }
    }

    /**
     * 定义个实时网络监听器
     */
    public interface NetEvent {
        /**
         * 网络状态的实时变化
         *
         * @param netMobile -1：无网络；0：移动网络；1：无线网络
         */
        void onNetChange(int netMobile);
    }
}
