package com.urovo.wugumofang.system;

import android.content.Context;
import android.content.pm.ApplicationInfo;

/**
 * @author SASUKE on 2018/4/21.
 * 用来替代那个BuildConfig.DEBUG标记。。。。那个在多Module时不准确
 *
 * 食用方法：
 * 先在Application的初始化里执行syncIsDebug（）
 * 然后再在需要判断标记的地方调用isDebug（）就可以了
 */
public class DebuggableCheck {
    private static Boolean isDebug = null;

    public static boolean isDebug() {
        return isDebug == null ? false : isDebug.booleanValue();
    }
    public static void syncIsDebug(Context context) {
        if (isDebug == null) {
            isDebug = context.getApplicationInfo() != null &&
                    (context.getApplicationInfo().flags & ApplicationInfo.FLAG_DEBUGGABLE) != 0;
        }
    }
}
