package com.urovo.wugumofang.system;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Environment;
import android.util.Log;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class DeviceHelper {
    private static final String TAG = "DeviceHelper";

    /**
     * 获取当前版本号
     *
     * @param context
     * @return
     */
    public static String getVersion(Context context) {
        String versionName = null;
        try {
            PackageInfo info;
            info = context.getPackageManager().getPackageInfo(context.getPackageName(), 0);
            versionName = info.versionName;
        } catch (NameNotFoundException e) {

        }
        return versionName;
    }

    public static int getVersionCode(Context context) {
        int versionCode = 0;
        try {
            PackageInfo info;
            info = context.getPackageManager().getPackageInfo(context.getPackageName(), 0);
            versionCode = info.versionCode;
        } catch (NameNotFoundException e) {

        }
        return versionCode;
    }

    /**
     * 获取包名
     *
     * @param context
     * @return
     */
    public static String getPackageName(Context context) {
        String packageName = null;
        try {
            PackageInfo info;
            info = context.getPackageManager().getPackageInfo(context.getPackageName(), 0);
            packageName = info.packageName;
        } catch (NameNotFoundException e) {

        }
        return packageName;
    }

    // /**
    // * 设置当前时间
    // *
    // * @param when
    // * @return
    // */
    // public static boolean setCurrentTime(long when) {
    // boolean status = true;
    // try {
    // DeviceManager deviceManager = new DeviceManager();
    // status = deviceManager.setCurrentTime(when);
    // } catch (Exception e) {
    //
    //
    // }
    //
    // return status;
    // }
    //
    // /**
    // * 屏蔽home键
    // *
    // * @param enable
    // * true 锁
    // */
    // public static void switchHomeKey(Context context, boolean enable) {
    // // try {
    // // Intent it = new Intent();
    // // it.setAction(LOCKHOME);
    // // it.putExtra(LOCK_FLAG, enable);// true -- Lock
    // // context.sendBroadcast(it);
    // // } catch (Exception e) {
    // //
    // //
    // // }
    // DeviceManager deviceManager=new DeviceManager();
    // deviceManager.enableHomeKey(enable);
    //
    //
    //
    // }
    //
    // /**
    // * 下拉栏屏蔽
    // *
    // * @param enable
    // * true 锁
    // */
    // public static void switchStatusBar(Context context, boolean enable) {
    // // try {
    // // Intent it = new Intent();
    // // it.setAction(LOCKSTATUSBAR);
    // // it.putExtra(LOCK_FLAG, enable);// true -- Lock
    // // context.sendBroadcast(it);
    // // } catch (Exception e) {
    // //
    // //
    // // }
    // DeviceManager deviceManager=new DeviceManager();
    // deviceManager.enableStatusBar(enable);
    // }

    public static String getDeviceType() {
        // return android.os.Build.MODEL;
        return "6200S";

    }

    /**
     * MD5加密
     */
    public static String getMD5Str(String str) {
        MessageDigest messageDigest = null;

        try {
            messageDigest = MessageDigest.getInstance("MD5");

            messageDigest.reset();

            messageDigest.update(str.getBytes("UTF-8"));
        } catch (NoSuchAlgorithmException e) {
//            GlobalApp.loger.error("NoSuchAlgorithmException caught!");
            Log.e(TAG, "NoSuchAlgorithmException caught!");
            System.exit(-1);
        } catch (UnsupportedEncodingException e) {

        }

        byte[] byteArray = messageDigest.digest();

        StringBuffer md5StrBuff = new StringBuffer();

        for (int i = 0; i < byteArray.length; i++) {
            if (Integer.toHexString(0xFF & byteArray[i]).length() == 1)
                md5StrBuff.append("0").append(Integer.toHexString(0xFF & byteArray[i]));
            else
                md5StrBuff.append(Integer.toHexString(0xFF & byteArray[i]));
        }
        // 16位加密，从第9位到25位
        return md5StrBuff.substring(8, 24).toString();
    }

    public static String getInterPath(Context context) {
        return context.getPackageResourcePath();
    }

    public static String getSDPath() {
        File sdDir = null;
        boolean sdCardExist = Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED); // 判断sd卡是否存在
        if (sdCardExist) {
            sdDir = Environment.getExternalStorageDirectory();// 获取跟目录
        }
        return sdDir.toString();

    }
}
