package com.urovo.wugumofang.system;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.widget.Toast;

import com.urovo.wugumofang.constants.AppConstants;
import com.zsy.libcore.ui.act.SYActManager;

import java.io.Serializable;
import java.util.Timer;
import java.util.TimerTask;

public class ToActivity {
    public static String LOGIN_ORGAN_ID = "LOGIN_ORGAN_ID";
    public static String LOGIN_USER_NAME = "LOGIN_USER_NAME";
    public static String LOGIN_USER_ID = "LOGIN_USER_ID";

    /**
     * 为了给新进程里跑的Activity传值。
     *
     *  activitiyType: 用于进行后台配置的内部跳转时，对共用页面的跳转分支。
     */
    public static void toActivity(Context context, Class<?> class1, String organId, String userName, String userId,String activitiyType) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        intent.putExtra(LOGIN_ORGAN_ID, organId);
        intent.putExtra(LOGIN_USER_NAME, userName);
        intent.putExtra(LOGIN_USER_ID, userId);
        if (!TextUtils.isEmpty(activitiyType)){
            intent.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, activitiyType);
        }
        context.startActivity(intent);
    }


    /**
     * 【不带activitiyType版】为了给新进程里跑的Activity传值。
     *
     */
    public static void toActivity(Context context, Class<?> class1, String organId, String userName, String userId) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        intent.putExtra(LOGIN_ORGAN_ID, organId);
        intent.putExtra(LOGIN_USER_NAME, userName);
        intent.putExtra(LOGIN_USER_ID, userId);
        context.startActivity(intent);
    }

    public static void toActivity(Context context, Class<?> class1) {
        context.startActivity(new Intent(context, class1));

//        Intent intent = new Intent();
//        intent.setClass(context, class1);
//        context.startActivity(intent);
    }

    // 传递一个参数
    public static void toActivity(Context context, Class<?> class1, String str) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        intent.putExtra("str", str);
        context.startActivity(intent);
    }

    public static void toActivity(Context context, Class<?> class1, String name, boolean value) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        intent.putExtra(name, value);
        context.startActivity(intent);
    }

    // 传递一个参数
    public static void toActivity(Context context, Class<?> class1, String name, int value) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        intent.putExtra(name, value);
        context.startActivity(intent);
    }

    // 传递二个参数
    public static void toActivity(Context context, Class<?> class1, String str, String str1) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        intent.putExtra("str", str);
        intent.putExtra("str1", str1);
        context.startActivity(intent);
    }

    /**
     * 传递二个参数
     *
     * @param context ...
     * @param clz     ...
     * @param name1   ...
     * @param value1  ...
     * @param name2   ...
     * @param value2  ...
     */
    public static void toActivity(Context context, Class<?> clz, String name1, boolean value1, String name2, String value2) {
        Intent intent = new Intent();
        intent.setClass(context, clz);
        intent.putExtra(name1, value1);
        intent.putExtra(name2, value2);
        context.startActivity(intent);
    }

    public static void toActivity(Context context, Class<?> clz, String name1, boolean value1, String... info) {
        Intent intent = new Intent();
        intent.setClass(context, clz);
        intent.putExtra(name1, value1);
        intent.putExtra(info[0], info[1]);
        intent.putExtra(info[2], info[3]);
        context.startActivity(intent);
    }

    // 传递一个对象
    public static void toActivity(Context context, Class<?> class1, Object object) {
        Intent intent = new Intent();
        intent.setClass(context, class1);
        Bundle bundle = new Bundle();
        bundle.putSerializable("object", (Serializable) object);
        intent.putExtras(bundle);
        context.startActivity(intent);
    }

    public static boolean dispatchKeyEvent(Activity context, KeyEvent event) {
        if (event.getKeyCode() == KeyEvent.KEYCODE_BACK
                && event.getAction() == KeyEvent.ACTION_DOWN
                && event.getRepeatCount() == 0) {
            exitBy2Click(context);
            return false;
        }
        return false;
    }

    private static Boolean isExit = false;

    public static void exitBy2Click(Context context) {
        Timer tExit;
        if (!isExit) {
            isExit = true; // 准备退出
//            MyToast.show(this, "再按一次退出程序", Toast.LENGTH_SHORT);
            Toast.makeText(context, "再按一次退出程序", Toast.LENGTH_SHORT).show();
            tExit = new Timer();
            tExit.schedule(new TimerTask() {
                @Override
                public void run() {
                    isExit = false; // 取消退出
                }
            }, 2000); // 如果2秒钟内没有按下返回键，则启动定时器取消掉刚才执行的任务

        } else {
            SYActManager.getInstance().AppExit();
        }
    }
}
