@file:JvmName("AnimeUtil")
package com.urovo.wugumofang.ui

import android.animation.ObjectAnimator
import android.view.View
import android.view.animation.AccelerateDecelerateInterpolator
import android.view.animation.Animation
import android.view.animation.TranslateAnimation
import android.widget.TextView

/**
 * Created by Sasuke on 2017/7/4.
 * 动画全家桶
 */

/**
 * 文字渐变改变。先透明掉，再换成别的文字，再渐显出来（其实感觉也没什么卵用）
 */
fun setTextAlpha(tv: TextView, msg: String?){
    ObjectAnimator.ofFloat(tv, "alpha", 1f, 0f).setDuration(1000).start()
    tv.setText(msg)
    ObjectAnimator.ofFloat(tv, "alpha", 0f, 1f).setDuration(1000).start()
}

/***
 * 渐隐渐现呼吸效果
 */
fun runViewAlpha(view: View){
    ObjectAnimator.ofFloat(view, "alpha", 1f, 0.5f).setDuration(1000).start()
    ObjectAnimator.ofFloat(view, "alpha", 0.5f, 1f).setDuration(1000).start()
}

/**
 * 抖动动画，可参见Beta版下更多界面顶部的那个反馈建议入口文字抖动效果。
 */
fun vibrate(view : View) {
    val alphaAnimation2 = TranslateAnimation(-25f, 25f, 0f, 0f)
    alphaAnimation2.duration = 100
    alphaAnimation2.repeatCount = 4
    alphaAnimation2.interpolator = AccelerateDecelerateInterpolator()
    alphaAnimation2.repeatMode = Animation.REVERSE
    view.startAnimation(alphaAnimation2)
//    alphaAnimation2.start()
//    view.performClick()
}