package com.urovo.wugumofang.ui;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.view.View;
import android.widget.DatePicker;
import android.widget.TextView;
import android.widget.TimePicker;

import com.urovo.wugumofang.libutils.R;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

/**
 * @author ...
 */
public class DialogHelper {

    /**
     * 选择日期的对话框
     */
    @SuppressWarnings("unused")
    public static void AlertDate(Context ctx, CharSequence title, CharSequence message) {
        View layout = View.inflate(ctx, R.layout.store_manager_cancel_datedialog, null);
        final DatePicker datePicker = layout.findViewById(R.id.date_picker);
        Calendar cal = Calendar.getInstance();
        cal.setTimeInMillis(System.currentTimeMillis());
        datePicker.init(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH), cal.get(Calendar.DAY_OF_MONTH), null);
        AlertDialog.Builder builder = createDialogDate(ctx, title, message, layout);
        builder.setNegativeButton("取消(Esc)", null);
        builder.setPositiveButton("确定(Enter)", new OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {

                new StringBuffer().append(String.format(Locale.CHINA, "%d-%02d-%02d",
                        datePicker.getYear(),
                        datePicker.getMonth() + 1,
                        datePicker.getDayOfMonth()));
                // storeManagerCancel.date.setText(sb);
            }
        });
        builder.create().show();
    }

    /**
     * 选择日期的对话框
     */
    private static AlertDialog.Builder createDialogDate(Context ctx, CharSequence title, CharSequence message, View layout) {
        AlertDialog.Builder builder = new Builder(ctx);
        builder.setMessage(message);
        builder.setTitle(title);
        builder.setView(layout);
        return builder;
    }

    public static AlertDialog EmptyAlert(Context ctx, View layout) {
        AlertDialog alertDialog = createEmptyDialogDIY(ctx, false, layout).create();
        alertDialog.show();
        return alertDialog;
    }

    public static void onBaseDialog(Context ctx, CharSequence title, CharSequence message, View layout, CharSequence text, OnClickListener oclt) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, false, layout);
        builder.setPositiveButton(text, oclt).create();
        builder.show();
    }

    public static void onBaseDialog(Context ctx, CharSequence title, CharSequence message, View layout, CharSequence leftText, CharSequence rightText,
                                    OnClickListener oclt, OnClickListener cle) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, false, layout);
        builder.setNegativeButton(leftText, oclt);
        builder.setPositiveButton(rightText, cle);
        builder.create().show();
    }


    public static void onAlertDialog(Context ctx, CharSequence message, View layout, OnClickListener oclt) {
        onBaseDialog(ctx, "提示", message, layout, "我知道了", oclt);
    }


    public static void onAlertDialog(Context ctx, CharSequence message, View layout, CharSequence leftText,
                                     CharSequence rightText, OnClickListener oclt, OnClickListener cle) {
        onBaseDialog(ctx, "提示", message, layout, leftText, rightText, oclt, cle);
    }

    public static void onAlertDialog(Context ctx, CharSequence title, CharSequence message, View layout, CharSequence leftText,
                                     CharSequence rightText, OnClickListener oclt, OnClickListener cle) {
        onBaseDialog(ctx, title, message, layout, leftText, rightText, oclt, cle);
    }


    public static AlertDialog Alert(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, false, layout);
        builder.setPositiveButton("确定", oclt);
        AlertDialog alertDialog = builder.create();
        alertDialog.show();
        return alertDialog;
    }

    public static void Alert(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt, OnClickListener cle) {
        Builder builder = createDialogDIY(ctx, title, message, false, layout);
        builder.setPositiveButton("确定", oclt);
        builder.setNegativeButton("取消", cle);
        builder.create().show();
    }

    public static Dialog AlertNotCanceable(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setPositiveButton("确定", oclt);
        Dialog dialog = builder.create();
        dialog.setCancelable(false);
        dialog.setCanceledOnTouchOutside(false);
        dialog.show();
        return dialog;
    }

    public static void Alert2NotCanceable(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt, OnClickListener cle) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setPositiveButton("确定", oclt);
        builder.setNegativeButton("退出", cle);
        Dialog dialog = builder.create();
        dialog.setCancelable(false);
        dialog.setCanceledOnTouchOutside(false);
        dialog.show();
    }

    public static void Alert2(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt) {
        baseAlert2(ctx, title, message, layout, oclt, true);
    }

    public static void baseAlert2(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt, boolean isCancelable) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setPositiveButton("确定", oclt);
        builder.setNegativeButton("取消", null);
        builder.setCancelable(isCancelable);
        builder.create().show();
    }

    public static void Alert3R(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt, OnClickListener oclt2) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setPositiveButton("取消", oclt2);
        builder.setNegativeButton("确定", oclt);
        builder.create().show();
    }

    @SuppressWarnings("unused")
    public static void Alert3(Context ctx, CharSequence title, CharSequence message, View layout, OnClickListener oclt, OnClickListener oclt2) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setPositiveButton("确定", oclt);
        builder.setNegativeButton("取消", oclt2);
        builder.create().show();
    }

    public static void AlertDIY(Context ctx, CharSequence title, CharSequence message, View layout, final DialogResult oclt, final int tag) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setNegativeButton("取消", null);
        builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {

                oclt.onDialogResult(tag);

            }
        });
        builder.create().show();
    }

    private static AlertDialog.Builder createDialogDIY(Context ctx, CharSequence title, CharSequence message, View layout) {
        AlertDialog.Builder builder = new Builder(ctx);
        builder.setMessage(message);
        builder.setTitle(title);
        builder.setView(layout);
        return builder;
    }

    @SuppressWarnings("all")
    public static Builder createDialogDIY(Context ctx, CharSequence title, CharSequence message, boolean isCancelable, View layout) {
        return new Builder(ctx)
                .setMessage(message)
                .setTitle(title)
                .setCancelable(isCancelable)
                .setView(layout);
    }

    private static Builder createEmptyDialogDIY(Context ctx, boolean isCancelable, View layout) {
        return new Builder(ctx)
                .setCancelable(isCancelable)
                .setView(layout);
    }

    public static DatePickerDialog alertDatePicker(final Context context, final TextView textView) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog.OnDateSetListener dateListener = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                String month;
                String day;
                if (monthOfYear + 1 < 10) {
                    month = "0" + (monthOfYear + 1);
                } else {
                    month = "" + (monthOfYear + 1);
                }
                if (dayOfMonth < 10) {
                    day = "0" + dayOfMonth;
                } else {
                    day = "" + dayOfMonth;
                }
                textView.setText(year + "-" + month + "-" + day);
            }
        };
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, dateListener, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH));
        datePickerDialog.show();
        return datePickerDialog;
    }

    public static DatePickerDialog alertDatePicker(final DialogResult oclt, final Context context, final TextView textView) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog.OnDateSetListener dateListener = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                String month;
                String day;
                if (monthOfYear + 1 < 10) {
                    month = "0" + (monthOfYear + 1);
                } else {
                    month = "" + (monthOfYear + 1);
                }
                if (dayOfMonth < 10) {
                    day = "0" + dayOfMonth;
                } else {
                    day = "" + dayOfMonth;
                }
                textView.setText(year + "-" + month + "-" + day);
                oclt.onDialogResult(6);
            }
        };
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, dateListener, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH));
        datePickerDialog.show();
        return datePickerDialog;
    }

    public static DatePickerDialog alertDateMonthPicker(final DialogResult oclt, final Context context, final TextView textView) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog.OnDateSetListener dateListener = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                String month;
                String day;
                if (monthOfYear + 1 < 10) {
                    month = "0" + (monthOfYear + 1);
                } else {
                    month = "" + (monthOfYear + 1);
                }
                textView.setText(year + "-" + month);
                oclt.onDialogResult(7);
            }
        };
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, dateListener, c.get(Calendar.YEAR), c.get(Calendar.MONTH), 1);
        datePickerDialog.show();
        return datePickerDialog;
    }

    public static void AlertTimePicker(final Context context, final TextView textView) {
        Calendar c = Calendar.getInstance();
        TimePickerDialog.OnTimeSetListener onTimeSetListener = new TimePickerDialog.OnTimeSetListener() {

            @Override
            public void onTimeSet(TimePicker view, int hourOfDay, int minute) {

                String hour;
                String minu;
                if (hourOfDay < 10) {
                    hour = "0" + (hourOfDay);
                } else {
                    hour = "" + (hourOfDay);
                }
                if (minute < 10) {
                    minu = "0" + minute;
                } else {
                    minu = "" + minute;
                }
                textView.setText(hour + ":" + minu + ":00");
            }

        };
        TimePickerDialog timePickerDialog = new TimePickerDialog(context, onTimeSetListener, c.get(Calendar.HOUR_OF_DAY), c.get(Calendar.MINUTE), true);
        timePickerDialog.show();
    }

    /**
     * @param activity ...
     */
    public static void showBackDialog(final Activity activity) {
        AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        builder.setTitle("返回提示");
        builder.setMessage("您还没有保存修改信息，确定要返回吗？");
        builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int whichButton) {
                dialog.dismiss();
                activity.finish();
            }
        });
        builder.setNegativeButton("取消", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int whichButton) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }


    /**
     * 提示框点击按钮接口
     *
     * @author Administrator
     */
    public interface DialogResult {
        /**
         * 点击按钮执行动作 tag：用来区分多个dialog的点击按钮执行动作
         */
        void onDialogResult(int tag);
    }
}
