package com.urovo.wugumofang.ui

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import com.bumptech.glide.Glide
import com.urovo.wugumofang.libutils.R
import com.urovo.wugumofang.view.CustomPopupWindow

/**
 * @author Sasuke on 2019-05-08 0008.
 * 预览大图工具
 */
class PhotoPreviewDominator(val view: View, var url: String?, val delCallback: (() -> Unit)?) {
    var previewPop: CustomPopupWindow? = null

    init {
        if (url?.startsWith("/storage/") ?: false) {
            url = "file://${url}"
        }
    }

    fun showPreview(): PhotoPreviewDominator {
        Glide.with(view.context).load(url)
//                    .resize(getGoalSizes(mActivity, photoPath)[0], getGoalSizes(mActivity, photoPath)[1])
                .placeholder(R.drawable.progress_animation_small)
                .into(getPreviewPop(view.context).getItemView(R.id.photoPreviewIv) as ImageView)
        getPreviewPop(view.context).showAtLocation(view, Gravity.LEFT, 0, 0)

        getPreviewPop(view.context).getItemView(R.id.popupFab).visibility = if (delCallback == null) View.INVISIBLE else View.VISIBLE
        return this
    }

    /***
     * 是否显示删除按钮
     */
    fun isShowDelBtn(isShow: Boolean): PhotoPreviewDominator {
        getPreviewPop(view.context).getItemView(R.id.popupFab).visibility = if (isShow) View.VISIBLE else View.INVISIBLE
        return this
    }


    private fun getPreviewPop(context: Context): CustomPopupWindow {
        if (previewPop == null) {
            previewPop = CustomPopupWindow.Builder(context)
                    .setwidth(ViewGroup.LayoutParams.MATCH_PARENT)
                    .setheight(ViewGroup.LayoutParams.MATCH_PARENT)
                    .setContentView(com.urovo.wugumofang.libutils.R.layout.photo_preview_pop_ll) //设置布局文件
                    .builder()
            previewPop?.getItemView(R.id.popupRoot)!!.setOnClickListener { previewPop?.dismiss() }
            previewPop?.getItemView(R.id.popupFab)!!.visibility = if (delCallback == null) View.GONE else View.VISIBLE
        }
        //挂载删除图片监听
        previewPop?.getItemView(R.id.popupFab)!!.setOnClickListener {
            previewPop?.dismiss()
            delCallback?.invoke()
        }
        return previewPop!!
    }
}