package com.urovo.wugumofang.ui;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.provider.MediaStore;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

public class PictureUtil {
    public static boolean saveImageToGallery(Context context, String path, String fileName) {
        boolean resault = true;
        File file = new File(path +File.separator +  fileName);
        // 其次把文件插入到系统图库
        try {
            MediaStore.Images.Media.insertImage(context.getContentResolver(), file.getAbsolutePath(), fileName, null);
            resault = true;
        } catch (FileNotFoundException e) {

            resault = false;
        }
        // 最后通知图库媒体库更新【注：这里可能将来会有问题，参考一下这个 https://juejin.im/post/5ae0541df265da0b9d77e45a#heading-5
        // 好像是说一定要传ExternalXXXXX开头的绝对路径才行，但目前来看好像还能用，先用着吧。】
//        context.sendBroadcast(new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE, Uri.parse("file://" + file.getAbsolutePath())));
        context.sendBroadcast(new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE, Uri.fromFile(file)));
        return resault;
    }

    //还是别用这个方法了，不知道为什么有时候会报空指针，但明明也没什么地方有传空啊，除了那个描述，
    // 但改成“”也一样报错啊。。。解决不了，不要用这种方法
//    public static boolean saveBmpToGallery(Context context, Bitmap bmp, String fileName) {
//        boolean resault = true;
////        File file = new File(path +File.separator +  fileName);
//        // 其次把文件插入到系统图库
//        MediaStore.Images.Media.insertImage(context.getContentResolver(), bmp, fileName, null);
//        resault = true;
//        // 最后通知图库媒体库更新
////        context.sendBroadcast(new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE, Uri.parse("file://" + file.getAbsolutePath())));
//        return resault;
//    }

    //位图bitmap保存到本地文件
    public static File saveBitmapFile(Bitmap bitmap, String path, String fileName) {
        File file = new File(path);// 将要保存图片的路径
        file.mkdirs();// 创建文件夹
        try {
            FileOutputStream fos = new FileOutputStream(path + File.separator + fileName);
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
            fos.flush();
            fos.close();
        } catch (IOException e) {

        }
        return file;
    }

    public static void deleteFileIfExists(Context context,String path, String fileName){
        File file = new File(path +File.separator +  fileName);
        if (file.exists()){
            file.delete();
            context.getContentResolver().delete(MediaStore.Images.Media.EXTERNAL_CONTENT_URI,
                    MediaStore.Images.Media.DATA + "=?",
                    new String[]{
                       file.getAbsolutePath()
                    });
            Intent intent = new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE);
            intent.setData(Uri.fromFile(file));
            context.sendBroadcast(intent);
        }
    }
}
