package com.urovo.wugumofang.ui;

import android.graphics.Rect;
import android.view.View;

import androidx.recyclerview.widget.RecyclerView;

public class SpacesItemDecoration extends RecyclerView.ItemDecoration {
    private final int mColumnCount;
    private final int mSpace;
    private boolean mShowBorder = false;

    public SpacesItemDecoration(int space, int columnCount) {
        this.mSpace = space;
        this.mColumnCount = columnCount;
    }

    public SpacesItemDecoration(int space, int columnCount, boolean showBorder) {
        this.mSpace = space;
        this.mColumnCount = columnCount;
        this.mShowBorder = showBorder;
    }

    @Override
    public void getItemOffsets(Rect outRect, View view, RecyclerView parent, RecyclerView.State state) {
        outRect.bottom = mSpace;
        if (parent.getChildLayoutPosition(view) == mColumnCount - 1) {
            if (mShowBorder) {
                outRect.bottom = mSpace;
            } else {
                outRect.bottom = 0;
            }
        } else {
            outRect.bottom = mSpace / 2;
        }
        if (parent.getChildLayoutPosition(view) == 0) {
            if (mShowBorder) {
                outRect.top = mSpace;
            } else {
                outRect.top = 0;
            }
        } else {
            outRect.top = mSpace / 2;
        }
    }
}
