package com.urovo.wugumofang.ui;

import android.text.SpannableString;
import android.text.Spanned;
import android.text.style.BackgroundColorSpan;
import android.text.style.ForegroundColorSpan;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by Sasuke on 2017/3/9.
 * 用来批量改变字符中关键词颜色的，用在文章关键词搜索结果高亮显示那里。
 */

public class TextColorDominator {
    public static SpannableString textColorChange(int foregroundColor, int backgroundColor, String sourceText, String keyword){
        SpannableString span = new SpannableString(sourceText);

        Pattern pattern = Pattern.compile(keyword);
        Matcher matcher = pattern.matcher(span);

        while (matcher.find()) {
            int start = matcher.start();
            int end = matcher.end();
            if(foregroundColor != 0){
                span.setSpan(new ForegroundColorSpan(foregroundColor), start, end, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
            }
            if(backgroundColor != 0){
                span.setSpan(new BackgroundColorSpan(backgroundColor), start, end, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
            }
        }
        return span;
    }
}
