package com.urovo.wugumofang.ui;

import android.content.Context;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.widget.ScrollView;

/**
 * @author Sasuke on 2020-4-22 0022.
 *
 * 竖向ScrollView嵌套横向滑动布局冲突
 *
 * 原文：https://blog.csdn.net/QiY6010/article/details/78653340
 */
public class VerticalScrollView extends ScrollView {
    private float xDistance, yDistance, xLast, yLast;

    public VerticalScrollView(Context context) {
        super(context);
    }

    public VerticalScrollView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public VerticalScrollView(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
    }


    @Override
    public boolean onInterceptTouchEvent(MotionEvent ev) {
        switch (ev.getAction()) {
            case MotionEvent.ACTION_DOWN:
                xDistance = yDistance = 0f;
                xLast = ev.getX();
                yLast = ev.getY();
                break;
            case MotionEvent.ACTION_UP:
                break;
            case MotionEvent.ACTION_MOVE:
                final float curX = ev.getX();
                final float curY = ev.getY();

                xDistance += Math.abs(curX - xLast);
                yDistance += Math.abs(curY - yLast);
                xLast = curX;
                yLast = curY;

                //为支持嵌入PinchImageView缩放图片，两指以上情况不做滑动
                if (xDistance > yDistance || ev.getPointerCount() > 1) {
                    return false;
                }
                break;
        }
        return super.onInterceptTouchEvent(ev);
    }
}
