package com.urovo.wugumofang.utils;

import android.app.Activity;
import android.content.Context;

import com.urovo.wugumofang.view.LoadingDialog;

/**
 * 加载弹窗工具类
 *
 * @author chenji
 * @date 2018/6/21
 */
public class LoadingDialogUtil {
    private static LoadingDialog mBuilder;
//    private static ScanCodeListUtil mInstance;
//    public static ScanCodeListUtil getInstance() {
//        if (mInstance == null) {
//            synchronized (ScanCodeListUtil.class) {
//                if (mInstance == null) {
//                    mInstance = new ScanCodeListUtil();
//                }
//            }
//        }
//        return mInstance;
//    }
    public static void showProgress(Context context, String message) {
        mBuilder = new LoadingDialog
                .Builder(context)
                .setMessage(message)
                .setCancelable(true)
                .create();

        show(context, mBuilder);
    }

    public static void showProgress(Context context, String message, boolean isShowMes) {
        mBuilder = new LoadingDialog
                .Builder(context)
                .setMessage(message)
                //设置是否隐藏弹窗文字
                .setShowMessage(isShowMes)
                //设置边沿触碰是否取消弹窗
                .setCancelOutside(false)
                //设置是否物理按键返回取消弹窗
                .setCancelable(false)
                .create();

        show(context, mBuilder);
    }

    private static void show(Context con, LoadingDialog dialog) {
        if (con instanceof Activity) {
            if (!((Activity) con).isFinishing()) {
                dialog.show();
            }
        } else {
            dialog.show();
        }
    }

    public static void dismiss() {
        if (mBuilder != null) {
            mBuilder.dismiss();
        }
    }
}
