package com.urovo.wugumofang.view.baseWebViewAct;

import android.app.ProgressDialog;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;
import android.webkit.WebSettings;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.umeng.socialize.Config;
import com.umeng.socialize.ShareAction;
import com.umeng.socialize.UMShareListener;
import com.umeng.socialize.bean.SHARE_MEDIA;
import com.umeng.socialize.media.UMImage;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.libutils.R;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.Calendar;
import java.util.HashMap;


/**
 * 通用WebViewAct
 * Created by Sasuke on 2016/11/21.
 */

public class WebViewAct extends BaseActivity implements View.OnClickListener {
    public static final int DEFAULT = 0;//默认窗口
    public static final int SHARE_WEIXIN = 1;//带微信分享底栏
    public static final int SHARE_BAR_NEW = 2;//新版分享底栏
    /**
     * 显示右上按钮
     */
    public final static String SHOW_RIGHT_BUTTON = "SHOW_RIGHT_BUTTON";
    public final static String TITLE = "title";
    public final static String URL = "url";
    public final static String OPTION = "option";
    public final static String USERID = "uesrId";
    public final static String PAGE_ID = "page_id";//该url页面id标记，用于上传标记
    public final static String LOAD_NO_CACHE = "loadNoCache";//返回上一网页时是否重新刷新载入。
    TextView titleTextView;
    ImageButton back;
    Button confirm;
    private TextView mTvTitle;
    private BaseWebView mWebView;
    private LinearLayout share_bar;//底栏分享按钮
    private LinearLayout share_bar2;//新版底栏分享
    private LinearLayout share_to_friends;
    private LinearLayout share_to_group;
    private LinearLayout shareFriends;//新版分享给朋友
    private LinearLayout copyLink;//拷贝链接
    private String mTitle = "";
    private String mUrl = "";
    private int mOption;
    private boolean mLoadNoCache = false;//返回上一网页时是否重新刷新。
    private String mLoginUserId = "";//员工工号
    // （之所以不用SystemHelper.loginUserId，因为这个是在新进程里跑的，可能会出现刚启动进程时SystemHelper报空的问题）
    private UMShareListener umShareListener = new UMShareListener() {
        @Override
        public void onResult(SHARE_MEDIA platform) {
            showMsg("分享成功");
        }

        @Override
        public void onError(SHARE_MEDIA platform, Throwable t) {
            showMsg("分享失败");
        }

        @Override
        public void onCancel(SHARE_MEDIA platform) {
            showMsg("分享取消");
        }
    };

    public static void launch(Context context, String userId, String title, String url) {
        Intent intent = new Intent(context, WebViewAct.class);
        intent.putExtra(TITLE, TextUtils.isEmpty(title) ? "Loading..." : title);
        intent.putExtra(URL, url);
        intent.putExtra(USERID,userId);
        context.startActivity(intent);
    }

    /**
     * 打开WebView
     */
    public static void launch(Context context, String userId, String title, String url, int option) {
        Intent intent = new Intent(context, WebViewAct.class);
        intent.putExtra(TITLE, TextUtils.isEmpty(title) ? "Loading..." : title);
        intent.putExtra(URL, url);
        intent.putExtra(OPTION, option);
        intent.putExtra(USERID,userId);
        context.startActivity(intent);
    }

    /**
     * 打开WebView并传入可变参数（自定义intent）
     */
    public static void launch(Context context, String userId, String title, String url, Intent intent) {
//        Intent intent = new Intent(context,WebViewAct.class);
        intent.putExtra(TITLE, TextUtils.isEmpty(title) ? "Loading..." : title);
        intent.putExtra(URL, url);
        intent.putExtra(USERID,userId);
        intent.setClass(context, WebViewAct.class);
        context.startActivity(intent);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
        setContentView(R.layout.base_webview_act);
        initView();
        initData();
    }

    private void initView() {
        share_bar = (LinearLayout) findViewById(R.id.share_bar);
        share_bar2 = (LinearLayout) findViewById(R.id.share_bar2);
        shareFriends = (LinearLayout) findViewById(R.id.shareFriends);
        copyLink = (LinearLayout) findViewById(R.id.copyLink);
        share_to_friends = (LinearLayout) share_bar.findViewById(R.id.share_to_friends);
        share_to_group = (LinearLayout) share_bar.findViewById(R.id.share_to_group);
        shareFriends.setOnClickListener(this);
        copyLink.setOnClickListener(this);
        share_to_friends.setOnClickListener(this);
        share_to_group.setOnClickListener(this);

        back = (ImageButton) findViewById(R.id.back);
        confirm = (Button) findViewById(R.id.confirm);
        titleTextView = (TextView) findViewById(R.id.text_title);

        mWebView = (BaseWebView) findViewById(R.id.wv_loading);
        mWebView.addProgressBar();
        mWebView.putTitleView(titleTextView);//把这个Act里的标题组件丢给WebView，WebView加载成功时，自动改标题

        back.setOnClickListener(this);
        if (!TextUtils.isEmpty(getIntent().getStringExtra(SHOW_RIGHT_BUTTON))) {
            confirm.setVisibility(View.VISIBLE);
            confirm.setText(getIntent().getStringExtra(SHOW_RIGHT_BUTTON));
            confirm.setOnClickListener(this);
        }
    }

    private void initData() {
        mTitle = getIntent().getStringExtra(TITLE);
        mUrl = getIntent().getStringExtra(URL);
        if (!TextUtils.isEmpty(getIntent().getStringExtra(USERID))){
            mLoginUserId = getIntent().getStringExtra(USERID);
        }
        mLoadNoCache = getIntent().getBooleanExtra(LOAD_NO_CACHE, false);
        if (mLoadNoCache) {
            mWebView.getSettings().setCacheMode(WebSettings.LOAD_NO_CACHE);//返回上一页时让它重新刷新。
        }
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            mWebView.getSettings().setMixedContentMode(WebSettings.MIXED_CONTENT_ALWAYS_ALLOW);
        }
        if (!mUrl.startsWith("https://") && !mUrl.startsWith("http://")) {
            mUrl = "http://" + mUrl;
        }
        mOption = getIntent().getIntExtra(OPTION, 0);

        share_bar.setVisibility(mOption == SHARE_WEIXIN? View.VISIBLE : View.GONE);
        share_bar2.setVisibility(mOption == SHARE_BAR_NEW? View.VISIBLE : View.GONE);
//        switch (mOption) {
//            case SHARE_WEIXIN://显示微信分享底栏
//                share_bar.setVisibility(View.VISIBLE);
//                break;
//            case SHARE_BAR_NEW:
//                share_bar2.setVisibility(View.VISIBLE);
//                break;
//            default://默认窗口
//                share_bar.setVisibility(View.GONE);
//                share_bar2.setVisibility(View.GONE);
//                break;
//        }

        mWebView.loadMessageUrl(mUrl,mLoginUserId);
        BaseAppManager.loger().info("报文：" + mUrl);
        titleTextView.setText(mTitle);

        /**
         * 对该url阅读记数
         */
        if(! TextUtils.isEmpty(getIntent().getStringExtra(PAGE_ID))){
            HashMap<String,String> param = new HashMap<>(2);
            param.put("id",getIntent().getStringExtra(PAGE_ID));
            param.put("staffId",mLoginUserId);
            OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.ADD_PROBLEM_READ_COUNT, param, null);
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        mWebView.destroyWebView();
    }

    @Override
    public void onClick(View v) {
        int rId = v.getId();
        //module里竟然不能在switch case里用R.id。。。编译不通过
        if (rId == R.id.back) {
            onBackPressed();
        } else if (rId == R.id.confirm) {
            mWebView.reload();
        } else if (rId == R.id.share_to_friends || rId == R.id.shareFriends) {
            shareWeiXin(SHARE_MEDIA.WEIXIN);
        } else if (rId == R.id.share_to_group) {
            shareWeiXin(SHARE_MEDIA.WEIXIN_CIRCLE);
        } else if(rId == R.id.copyLink){
            ClipboardManager cmb = (ClipboardManager)getSystemService(Context.CLIPBOARD_SERVICE);
            ClipData mClipData = ClipData.newRawUri(String.valueOf(Calendar.getInstance().getTimeInMillis()), Uri.parse(mUrl));
            cmb.setPrimaryClip(mClipData);
            showMsg("链接已复制");
        }
    }

    private void shareWeiXin(SHARE_MEDIA type) {
        showDialog();
        UMImage image = new UMImage(this, BitmapFactory.decodeResource(getResources(), R.drawable.wgmf_logo));
        new ShareAction(this).setPlatform(type).setCallback(umShareListener)
                .withMedia(image)
                .withText(/*getData().getContent()*/ " ")
                .withTitle(mTitle)
                .withTargetUrl(mUrl + (mUrl.contains("?") ? "&" : "?") + "time=" + Calendar.getInstance().getTimeInMillis() + "&userName=" + mLoginUserId)
                .share();
    }

    private void showDialog() {
        ProgressDialog dialog = new ProgressDialog(this);
        dialog.setTitle("启动分享中");
        dialog.setMessage("请稍等.....");
        Config.dialog = dialog;
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //拦截返回键
        if (event.getKeyCode() == KeyEvent.KEYCODE_BACK){
            //判断触摸UP事件才会进行返回事件处理
            if (event.getAction() == KeyEvent.ACTION_UP) {
                onBackPressed();
            }
            //只要是返回事件，直接返回true，表示消费掉
            return true;
        }
        return super.dispatchKeyEvent(event);
    }


    /**
     * 按返回键时， 不退出程序而是返回WebView的上一页面
     */
    @Override
    public void onBackPressed() {
        //修复微信网页重定向导致的退出不了浏览器。("请在微信端打开网页")
//        if(mWebView.getUrl().contains("wechat_redirect")){
//            finish();
//            return;
//        }
        if (mWebView.canGoBack()) {
            mWebView.goBack();
        } else {
            super.onBackPressed();
        }
        //如果不要缓存，那返回的时候就重新刷一次
        if (mLoadNoCache) {
            new Handler().postDelayed(new Runnable() {
                @Override
                public void run() {
                    mWebView.reload();
                }
            }, 200);
        }
    }
}
