package com.zsy.libcore;

import android.app.Application;

import com.zsy.libcore.common.CrashHandler;
import com.zsy.libcore.common.other.PackageUtil;
import com.zsy.libcore.config.LibCoreConfig;
import com.zsy.libcore.ui.act.SYActManager;

import java.util.HashMap;
import java.util.Map;

/**
 * 全局
 *
 * @author samy
 * @description：SYAppliction公共类
 * @date 2015-1-29 下午12:36:44
 */
public abstract class LibCoreApp extends Application {
    private static LibCoreApp instance;
    public static int SCREEN_WIDTH;
    public static int SCREEN_HEIGHT;
    public static float SCREEN_DENSITY;
    public static String PACKAGE_NAME;
    /**
     * 利用全局内存进行变量传递
     */
    private Map<String, Object> libAppMap = new HashMap<>();

    public static LibCoreApp getInstance() {
        return instance;
    }

    @Override
    public void onCreate() {
        super.onCreate();
        // if (this.getPackageName().equals(SystemTool.getCurrProcName(this))) {
        CrashHandler.create(this, "wgmf");
        instance = this;
        SCREEN_WIDTH = getResources().getDisplayMetrics().widthPixels;
        SCREEN_HEIGHT = getResources().getDisplayMetrics().heightPixels;
        SCREEN_DENSITY = getResources().getDisplayMetrics().density;
        PACKAGE_NAME = PackageUtil.getAppPackageName(this);
        initLib();
        initLibExt();
        // }
    }

    protected void initLib() {
        LibCoreConfig.API_URL = "";
        LibCoreConfig.DB_NAME = "";
    }

    protected abstract void initLibExt();

    /**
     * @description：清空全局变量数据
     * @author samy
     * @date 2015-1-29 下午3:36:33
     */
    private void cleanMap() {
        if (!libAppMap.isEmpty()) {
            libAppMap.clear();
        }
    }

    @Override
    public void onTerminate() {
        SYActManager.getInstance().AppExit();
        super.onTerminate();
    }
}
