package com.zsy.libcore.model.data.net.interceptor;

import java.io.IOException;
import okhttp3.Headers;
import okhttp3.HttpUrl;
import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * 公共参数

 可能接口有某些参数是公共的
 * Created by samy on 16/8/21.
 */

public class CommonInterceptor implements Interceptor {

  @Override
  public Response intercept(Chain chain) throws IOException {
    Request originalRequest = chain.request();
    Request request;
    String method = originalRequest.method();
    Headers headers = originalRequest.headers();
    HttpUrl modifiedUrl = originalRequest.url().newBuilder()
        // Provide your custom parameter here
        .addQueryParameter("platform", "android")
        .addQueryParameter("version", "1.0.0")
        .build();
    request = originalRequest.newBuilder().url(modifiedUrl).build();
    return chain.proceed(request);
  }
}
