package com.zsy.libcore.ui.ada.quickadapter;

import com.zsy.libcore.ui.ada.helper.ViewHelper;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

public class BaseAdapterHelper {
	private int position;
	private int layoutId;
	private ViewHelper mViewHelper;

	public BaseAdapterHelper(ViewGroup parent, int layoutId, int mPosition) {
		super();
		this.position = mPosition;
		this.layoutId = layoutId;
		View root = LayoutInflater.from(parent.getContext()).inflate(layoutId, parent, false);
		root.setTag(this);
		mViewHelper = new ViewHelper(root);
	}

	public static BaseAdapterHelper get(View convertView, ViewGroup parent, int layoutId) {
		return get(convertView, parent, layoutId, -1);
	}

	public static BaseAdapterHelper get(View convertView, ViewGroup parent, int layoutId, int position) {
		if (convertView == null) { return new BaseAdapterHelper(parent, layoutId, position); }

		// Retrieve the existing helper and update its position
		BaseAdapterHelper existingHelper = (BaseAdapterHelper) convertView.getTag();

		if (existingHelper.layoutId != layoutId) { return new BaseAdapterHelper(parent, layoutId, position); }
		// RatingBar
		existingHelper.position = position;
		return existingHelper;
	}

	public Context getContext() {
		return mViewHelper.getContext();
	}

	public int getPosition() {
		return position;
	}

	public int getLayoutId() {
		return layoutId;
	}

	public ViewHelper getViewHelper() {
		return mViewHelper;
	}
}
