package com.zsy.libext.ui.fra;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;

import com.zsy.libcore.ui.fra.BaseAppCompatFra;
import com.zsy.libcore.view.BaseView;
import com.zsy.libext.ui.act.BaseAct;
import com.zsy.libext.widgets.loading.impl.VaryViewHelperController;

import androidx.annotation.Nullable;

/**
 * @author samy(hongfeiliuxing@gmail.com)
 * @datetime 2015-08-22 20:19
 */
public abstract class BaseFra<P> extends BaseAppCompatFra implements BaseView<P>, View.OnClickListener {

    protected BaseAct baseAct;
    protected VaryViewHelperController mVaryViewHelperController;

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        baseAct = (BaseAct) getActivity();
    }
//    Unbinder unbinder;
    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
//        unbinder = ButterKnife.bind(this, view);
        // 暂时先现在这里初始化，后期考虑到Fragment的特殊化，不应该在这里初始化
        //initPresenter();
        if (null != getLoadingTargetView()) {
            mVaryViewHelperController = new VaryViewHelperController(getLoadingTargetView());
        }
        // 注意这里getLoadingTargetView要先初始化，可见这里要处理ButterKnife处理；
        initWidgetsAndEvents(view);
    }

    // @Override
    // protected void onFirstUserVisible() {
    // super.onFirstUserVisible();
    // initPresenter();
    // }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        unbinder.unbind();
//        ButterKnife.unbind(this);
    }


    @Override
    public void showLoading(String s) {
        toggleShowLoading(true, s);
    }

    @Override
    public void hideLoading() {
        toggleShowLoading(false, "");
    }

    @Override
    public void showEmpty(String msg, View.OnClickListener onClickListener) {
        toggleShowEmpty(true, msg, onClickListener);
    }

    @Override
    public void showEmpty(String msg, View.OnClickListener onClickListener, int imageId) {
        toggleShowEmpty(true, msg, imageId, onClickListener);
    }

    @Override
    public void showError(String msg, View.OnClickListener onClickListener) {
        toggleShowError(true, msg, onClickListener);
    }

    @Override
    public void showNetError(View.OnClickListener onClickListener) {
        toggleShowError(true, onClickListener);
    }

    protected void toggleShowLoading(boolean toggle, String msg) {
        if (null == mVaryViewHelperController) {
            throw new IllegalArgumentException("You must return a right target view for loading");
        }

        if (toggle) {
            mVaryViewHelperController.showLoading(msg);
        } else {
            mVaryViewHelperController.restore();
        }
    }

    protected void toggleShowEmpty(boolean toggle, String msg, View.OnClickListener onClickListener) {
        if (null == mVaryViewHelperController) {
            throw new IllegalArgumentException("You must return a right target view for loading");
        }

        if (toggle) {
            mVaryViewHelperController.showEmpty(msg, -1, onClickListener);
        } else {
            mVaryViewHelperController.restore();
        }
    }

    protected void toggleShowEmpty(boolean toggle, String msg, int img, View.OnClickListener onClickListener) {
        if (null == mVaryViewHelperController) {
            throw new IllegalArgumentException("You must return a right target view for loading");
        }

        if (toggle) {
            mVaryViewHelperController.showEmpty(msg, img, onClickListener);
        } else {
            mVaryViewHelperController.restore();
        }
    }

    protected void toggleShowError(boolean toggle, String msg, View.OnClickListener onClickListener) {
        if (null == mVaryViewHelperController) {
            throw new IllegalArgumentException("You must return a right target view for loading");
        }

        if (toggle) {
            mVaryViewHelperController.showError(msg, false, onClickListener);
        } else {
            mVaryViewHelperController.restore();
        }
    }

    protected void toggleShowError(boolean toggle, View.OnClickListener onClickListener) {
        if (null == mVaryViewHelperController) {
            throw new IllegalArgumentException("You must return a right target view for loading");
        }

        if (toggle) {
            mVaryViewHelperController.showError("", true, onClickListener);
        } else {
            mVaryViewHelperController.restore();
        }
    }

    protected abstract void initWidgetsAndEvents(View rootView);

    protected abstract View getLoadingTargetView();

    public void widgetsClick(View v) {
    }

    @Override
    public void onClick(View v) {
        widgetsClick(v);
    }

    @Override
    public boolean isActive() {
        return isAdded();
    }
}
