package com.zsy.libext.widgets.dialog.effectsdialog.effects;

import android.view.View;

import com.nineoldandroids.animation.AnimatorSet;
import com.nineoldandroids.view.ViewHelper;

/**
 * Created by lee on 2014/7/30.
 *
 *
 * The MIT License (MIT)
 *
 * Copyright (c) 2014 daimajia
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * Acknowledgements daimajia
 * https://github.com/daimajia
 */
public abstract class BaseEffects {

  private static final int DURATION = 1 * 700;

  protected long mDuration = DURATION;

  private AnimatorSet mAnimatorSet;

  {
    mAnimatorSet = new AnimatorSet();
  }

  protected abstract void setupAnimation(View view);

  public void start(View view) {
    reset(view);
    setupAnimation(view);
    mAnimatorSet.start();
  }

  public void reset(View view) {
    ViewHelper.setPivotX(view, view.getMeasuredWidth() / 2.0f);
    ViewHelper.setPivotY(view, view.getMeasuredHeight() / 2.0f);
  }

  public AnimatorSet getAnimatorSet() {
    return mAnimatorSet;
  }

  public void setDuration(long duration) {
    this.mDuration = duration;
  }
}
