package com.urovo.wugumofang.membermodule.ent;

import com.chad.library.adapter.base.entity.MultiItemEntity;

import java.util.List;

/**
 * @author chenji
 */
public class MultipleItem<T> implements MultiItemEntity {
    /**
     * 不用布局的type类型
     */
    public static final int
            TEXT_0 = 0,
            TEXT_1 = 1,
            IMG_TEXT = 2,
            IMG_TEXT_IMG = 3,
            HORIZONTAL_LINE = 4,
            HEAD_HORIZONTAL_LINE = 5,
            BODY_HORIZONTAL_LINE = 6,
            IMG_TEXT_EMPTY = 7,
            TEXT_FOOT_TIPS = 8;
    /**
     * 一行中item占用的总列数,如果等于最先设定的上限列数,则说明该item是铺满一行的
     */
    public static final int
            TEXT_SPAN_SIZE = 3,
            IMG_TEXT_IMG_SPAN_SIZE = 3,
            HORIZONTAL_LINE_SPAN_SIZE = 3,
            IMG_TEXT_SPAN_SIZE = 1;

    private int itemType;
    private int spanSize;
    private String content;
    private List<T> list;
    private String[] str;
    private T t;
    private boolean b;
    private int position;
    private int id;
    private String name;
    private String linkType;
    private String linkUrl;
    private String itemPrivilegeId;

    public MultipleItem(int itemType, int spanSize, int position, int id, String name) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.position = position;
        this.id = id;
        this.name = name;
    }

    public MultipleItem(int itemType, int spanSize, int id, String name, String linkType, String linkUrl,String itemPrivilegeId) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.id = id;
        this.name = name;
        this.linkType = linkType;
        this.linkUrl = linkUrl;
        this.itemPrivilegeId=itemPrivilegeId;
    }

    public MultipleItem(int itemType, int spanSize, String[] str) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.str = str;
    }

    public MultipleItem(int itemType, int spanSize, String linkType, String linkUrl, String[] str) {
        this.itemType = itemType;
        this.spanSize = spanSize;
        this.linkType = linkType;
        this.linkUrl = linkUrl;
        this.str = str;
    }

    public MultipleItem(int itemType, int spanSize) {
        this.itemType = itemType;
        this.spanSize = spanSize;
    }

    public int getSpanSize() {
        return spanSize;
    }

    public void setSpanSize(int spanSize) {
        this.spanSize = spanSize;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public List<T> getList() {
        return list;
    }

    public void setList(List<T> list) {
        this.list = list;
    }

    public String[] getStringArray() {
        return str;
    }

    public void setStringArray(String[] str) {
        this.str = str;
    }

    public T getT() {
        return t;
    }

    public void setT(T t) {
        this.t = t;
    }

    public int getPosition() {
        return position;
    }

    public void setPosition(int position) {
        this.position = position;
    }

    public boolean isBoolean() {
        return b;
    }

    public void setBoolean(boolean b) {
        this.b = b;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getLinkType() {
        return linkType;
    }

    public void setLinkType(String linkType) {
        this.linkType = linkType;
    }

    public String getLinkUrl() {
        return linkUrl;
    }

    public void setLinkUrl(String linkUrl) {
        this.linkUrl = linkUrl;
    }

    @Override
    public int getItemType() {
        return itemType;
    }


    public String getItemPrivilegeId() {
        return itemPrivilegeId;
    }

    public void setItemPrivilegeId(String itemPrivilegeId) {
        this.itemPrivilegeId = itemPrivilegeId;
    }
}
