package com.urovo.activity.MemberList.ui;

import android.app.Activity;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.urovo.activity.MemberList.model.MemberListEntity;
import com.urovo.wugumofang.R;

import java.util.List;

/**
 * Created by Sasuke on 2016/5/17.
 */
public class MemberListAdapter extends BaseAdapter{
    List<MemberListEntity> mList;
    class ViewHolder {
        TextView customerName;//客户名
        TextView buyTime;//购买时间
        ImageView huifangIcon;//是否回访
        //ImageView toupiaoIcon;//微信投票
    }
    Activity activity;

    public MemberListAdapter(Activity activity, List<MemberListEntity> mList) {
        this.mList = mList;
        this.activity = activity;
    }

    @Override
        public int getCount() {
            return mList.size();
        }

        @Override
        public Object getItem(int position) {

            return position;
        }

        @Override
        public long getItemId(int position) {

            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ViewHolder holder = new ViewHolder();
            if (convertView == null) {
                LayoutInflater inflater = activity.getLayoutInflater();
                convertView = inflater.inflate(R.layout.jifenguoqi_list_item, null);
                holder.customerName = (TextView) convertView.findViewById(R.id.customerName);
                holder.buyTime = (TextView) convertView.findViewById(R.id.buy_time);
                holder.huifangIcon = (ImageView) convertView.findViewById(R.id.is_huifang);
                convertView.setTag(holder);
            } else {
                holder = (ViewHolder) convertView.getTag();
            }

            MemberListEntity cell = mList.get(position);
            String customerName = cell.customerName;
            //设置会员名
            if (TextUtils.isEmpty(customerName)) {
                holder.customerName.setText("会员");
            } else {
                holder.customerName.setText(cell.customerName);
            }
            //设置购买时间
            holder.buyTime.setText("最近购买时间:"+cell.getBuyDate());

            //设置回访标识
            //if (cell.getPhoneCare() == 1 || cell.getSmsCare() == 1 || cell.getWechatCare() == 1 || !TextUtils.isEmpty(cell.shareCare)&&cell.shareCare.equals("1") ) {
            if (cell.hasCommunication.equals("1") ) {
                holder.huifangIcon.setImageResource(R.drawable.mark_callback_ed);
            } else {
                holder.huifangIcon.setImageResource(R.drawable.mark_callback_not);
            }
            return convertView;
        }

}
