package com.urovo.activity.MemberProfile.ui;

import android.app.AlertDialog;
import android.content.ClipboardManager;
import android.content.Context;
import android.graphics.drawable.BitmapDrawable;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/5/19.
 */
public class HuaShuPopup extends PopupWindow implements View.OnClickListener {
    Context context;
    View viewDismiss;
    Button copyHuashu;
    TextView titleText;
    TextView contentText;
    View contentView;

    public HuaShuPopup(Context context) {
        this(context, null);
    }

    public HuaShuPopup(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.context = context;
        findViews();
        setListeners();
        setProperties();
    }

    public void findViews() {
        contentView = (LinearLayout) LayoutInflater.from(context).inflate(R.layout.ll_huashu_dialog, null);
        this.setContentView(contentView);
        viewDismiss = contentView.findViewById(R.id.view_dismiss);
        copyHuashu = (Button) contentView.findViewById(R.id.copy_huashu_btn);
        titleText = (TextView) contentView.findViewById(R.id.huashu_title);
        contentText = (TextView) contentView.findViewById(R.id.huashu_content);
        contentText.setTextIsSelectable(true);
    }

    public void setListeners() {
        viewDismiss.setOnClickListener(this);
        copyHuashu.setOnClickListener(this);
        contentView.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View v, int keyCode, KeyEvent event) {
                if (event.getAction() == KeyEvent.ACTION_DOWN && keyCode == KeyEvent.KEYCODE_BACK)
                    HuaShuPopup.this.dismiss();
                return true;
            }
        });
    }

    public void setProperties() {
        this.setWidth(ViewGroup.LayoutParams.MATCH_PARENT);
        this.setHeight(ViewGroup.LayoutParams.MATCH_PARENT);
        this.setAnimationStyle(R.style.alpha_animation);//填0是无动画
        this.setOutsideTouchable(true);
        this.setBackgroundDrawable(new BitmapDrawable());
    }


    public void show(View anchor) {
        showAsDropDown(anchor);
    }


    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.view_dismiss://最下方透明鸡肋View
                viewDismiss.setVisibility(View.INVISIBLE);
                this.dismiss();
                break;
            case R.id.copy_huashu_btn://拷贝参考话术按钮（右上角）
                if(!TextUtils.isEmpty(contentText.getText().toString())){
                    ClipboardManager cm = (ClipboardManager) context.getSystemService(Context.CLIPBOARD_SERVICE);
                    cm.setText(contentText.getText().toString());
                    new AlertDialog.Builder(context).
                            setMessage("参考话术复制成功!").setPositiveButton("确定",null)
                            .create().show();
                }
                break;
        }
    }

    public void setTitle(String title){
        if(!TextUtils.isEmpty(title)){
            titleText.setText(title);
        }
    }

    public void setContent(String content){
        if(!TextUtils.isEmpty(content)) {
            contentText.setText(content);
        }
    }
}
