package com.urovo.activity.MemberProfile.ui;

import android.content.Context;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.slidemenu.HuiYuanYouHuiQuanEntity;
import com.urovo.wugumofang.R;

import java.util.ArrayList;

/**
 * 优惠券列表的Adapter
 * Created by Sasuke on 2016/5/16.
 */
public class YouHuiAdapter extends BaseAdapter{
    Context context;
    ArrayList<HuiYuanYouHuiQuanEntity> youhuiList;
    public YouHuiAdapter(Context context,ArrayList<HuiYuanYouHuiQuanEntity> youhuiList) {
        this.context = context;
        this.youhuiList = youhuiList;
    }

    @Override
    public int getCount() {
        return youhuiList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        YouhuiViewHolder holder = new YouhuiViewHolder();
        if (convertView == null) {
            LayoutInflater inflater = LayoutInflater.from(context);
            convertView = (LinearLayout) inflater.inflate(R.layout.listview_item_youhuiquan, null);
            holder.actBanner = (ImageView) convertView.findViewById(R.id.act_banner);
            holder.actType = (TextView) convertView.findViewById(R.id.act_type);
            holder.actName = (TextView) convertView.findViewById(R.id.act_name);
            holder.actContent = (TextView) convertView.findViewById(R.id.act_content);
            holder.actOverdue = (TextView) convertView.findViewById(R.id.act_overdue);
            holder.tongyong = (TextView) convertView.findViewById(R.id.tongyong);
            holder.useLabel = (ImageView) convertView.findViewById(R.id.use_label);

            convertView.setTag(holder);
        } else {
            holder = (YouhuiViewHolder) convertView.getTag();
        }
        HuiYuanYouHuiQuanEntity cell = youhuiList.get(position);

        //设置顶栏+标签
           /* if (cell.act_type == 1 || cell.act_type == 2 || cell.act_type == 8 || cell.act_type == 10) {//积分券
                holder.actType.setText("积分券");
            } else if (cell.act_type == 3 || cell.act_type == 4 || cell.act_type == 5 || cell.act_type == 6
                    || cell.act_type == 7 || cell.act_type == 9 || cell.act_type == 11) {//优惠券
                holder.actType.setText("积分优惠兑");
            }*/

        switch(cell.act_type){
            case 1:
                holder.actType.setText("买送活动");
                break;
            case 2:
                holder.actType.setText("满赠活动");
                break;
            case 3:
                holder.actType.setText("满减活动");
                break;
            case 4:
                holder.actType.setText("满折活动");
                break;
            case 5:
                holder.actType.setText("买兑活动");
                break;
            case 6:
                holder.actType.setText("满兑活动");
                break;
            case 7:
                holder.actType.setText("积分兑活动");
                break;
            case 8:
                holder.actType.setText("免费赠送活动");
                break;
            case 9:
                holder.actType.setText("特价活动");
                break;
            case 10:
                holder.actType.setText("以老带新");
                break;
            case 11:
                holder.actType.setText("积分抵扣券");
                break;
        }

        //标签蓝与橙色根据元素位置的奇偶交替
        if (position % 2 != 0) {
            holder.actBanner.setImageResource(R.drawable.youhui_blue_top);
            holder.actType.setBackgroundResource(R.drawable.label_blue_background);
        } else {
            holder.actBanner.setImageResource(R.drawable.youhui_orange_top);
            holder.actType.setBackgroundResource(R.drawable.label_orange_background);
        }

        //设置活动名
        if (!TextUtils.isEmpty(cell.act_name)) {
            holder.actName.setText(cell.act_name);
        }
        //设置活动内容
        if (!TextUtils.isEmpty(cell.act_content)) {
            holder.actContent.setText("内容：" + cell.act_content);
        }
        //设置活动到期时间
        if (!TextUtils.isEmpty(cell.validtime)) {
            String validtime = cell.validtime.substring(0,10);
            holder.actOverdue.setText("到期时间：" + validtime);//这里不能直接传substring(),否则魅族机显示不出来
        }
        //设置活动使用状态印章
        if (cell.codestatus == 1) {//已过期
            holder.useLabel.setVisibility(View.VISIBLE);
            holder.useLabel.setImageResource(R.drawable.youhui_overdue);
        } else if (cell.codestatus == 3) {//未使用
            holder.useLabel.setVisibility(View.VISIBLE);
            holder.useLabel.setImageResource(R.drawable.youhui_not_used);
        } else if (cell.codestatus == 4 || cell.codestatus == 2) {//已使用
            holder.useLabel.setVisibility(View.VISIBLE);
            holder.useLabel.setImageResource(R.drawable.youhui_used);
        } else if(cell.codestatus == 5){//无兑换码
            holder.useLabel.setVisibility(View.INVISIBLE);
        }
        return convertView;
    }


    class YouhuiViewHolder {
        ImageView actBanner;//就是卡片上方那个横条
        TextView actType;//活动标签（活动类型）
        TextView actName;//活动名
        TextView actContent;//活动内容
        TextView actOverdue;//到期时间
        TextView tongyong;//所有五谷磨房门店通用（写死）
        ImageView useLabel;//使用状态印章
    }
}
