package com.sibyl.addsellactivity.presenter

import android.app.Fragment
import com.urovo.activity.addsellactivity.presenter.AddSellMainPre
import com.urovo.wgmf.base.BasePresenter
import com.urovo.wgmf.base.BaseView
import com.urovo.wgmf.db.dao.entitys.ProductEntity

/**
 * @author Sasuke on 2018/1/2.
 */
interface AddSellContract {
    interface mainView: BaseView<mainPre> {
        fun init()

        fun refreshShow()//刷新底栏总价显示

        fun packAll()//打包所有已选数据

        fun loadWaitDismiss()//隐藏掉加载圆圈，隐藏掉错误信息

        fun loadWaitError(error: String)//报错显示

        fun refreshStockSuccess()//刷新库存成功，接着执行更新列表UI显示，还有下拉刷新头的状态显示

        fun refreshStockFailed()//刷新库存失败，更新下拉刷新头状态显示即可
    }

    interface fraView: BaseView<pre> {
        fun loadData(mainPre: AddSellMainPre, filter: String): Fragment//初始化的时候根据条件（其实就是标签名字）来拷贝数据表（浅拷贝）

        fun notifyMainShow()//当其它地方改变了allList数据时，对应的Fragment的表也跟着刷新，在onResume(）里调吧

    }


    //给主界面用的
    interface mainPre: BasePresenter{
        fun initAllList(storeId: String, intentSelected: List<ProductEntity>?, actListIds: List<String>?, phoneNum: String?,isMemGoods: Boolean)

        fun refreshAmount()//刷新

        fun packAll(): List<ProductEntity>//打包所有数据
    }

    //给Fragment们用的
    interface pre: BasePresenter {
        //（用毛线，Fragment只负责更改allList的数据，又不需要干嘛）
    }

}