package com.urovo.activity.addsellactivity.ui

import android.content.Context
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.RecyclerView
import com.urovo.wgmf.db.dao.entitys.ProductEntity
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.AppConstants.Printer.maxCount
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.data.MoneyUtils
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.view.NumberKeyboard
import java.text.NumberFormat

/**
 * @author Sasuke on 2018/1/4.
 */
class XdyAda(val context: Context, val proList: List<ProductEntity>, val notifyMain: () -> Unit) : RecyclerView.Adapter<ViewHolderXdy>() {
    var posTmp: Int = -1
    var tv_kgTmp: TextView? = null
    var et_xcountTmp: EditText? = null
    //var keyboard: NumberKeyboard? = null
    val keyboard: NumberKeyboard by lazy {
        NumberKeyboard.newInstance(null)
    }


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderXdy {
        return ViewHolderXdy(LayoutInflater.from(context).inflate(R.layout.listview_pro_item_xdy, parent, false))
    }

    override fun onBindViewHolder(holder: ViewHolderXdy, pos: Int) {
        val view: View
        holder.apply {
            stockTv.visibility = View.GONE//鲜稻研不需要显示库存
            tv_after_name.text = proList[pos].itemName
            tv_after_danwei.text = "(${proList[pos].kcUom})"
            tv_after_bianma.text = "${proList[pos].price.toString()}元/${proList[pos].kcUom}"
            tv_item_id.text = proList[pos].itemId

            rl_count_item_click.setOnClickListener {
                when (cb_pro.isChecked) {
                    true -> if (proList[pos].minCount > 0) MyToast.show("该产品为活动产品，不可以取消") else proList[pos].isChecked = false
                    false -> {
                        proList[pos].apply {
                            isChecked = true
                            tqty = if (isChecked && isDecimal) 0.0 else 1.0//默认数量为0
                            amount = Arith.mul(price, tqty)//默认总金额为0
                        }
//                        SetFocusUtil.focus(et_xcount2)
                    }
                }
                notifyDataSetChanged()
                notifyMain.invoke()
            }

            et_xcount2.tag = pos
            et_xcount2.setText(MoneyUtils.twolastDF(proList[pos].amount))//金额
            et_xcount.setText(MoneyUtils.nolastDF(proList[pos].tqty))//个数

            tv_kg.text = "×${MoneyUtils.twolastDF(proList[pos].tqty)}"//重量
            tv_kg.visibility = if (proList[pos].isChecked && proList[pos].isDecimal) View.VISIBLE else View.GONE

            cb_pro.isChecked = proList[pos].isChecked
            ll_btns2.visibility = if (proList[pos].isChecked && proList[pos].isDecimal) View.VISIBLE else View.GONE//整个按钮区的显隐
            ll_btns.visibility = if (proList[pos].isChecked && !proList[pos].isDecimal) View.VISIBLE else View.GONE

            if (proList[pos].amount == 0.0) et_xcount2.setText("")//如果金额为0，就把输入框置空

            ll_btns2.setOnClickListener { v ->
                keyboard.show(et_xcount2, (context as AppCompatActivity).supportFragmentManager) {
                    if (proList[pos].isChecked) {
                        val ptn = holder.et_xcount2.tag as Int
                        val amountStr = it//现在这里不是数量，而是金额，金额是用来输入的
                        val price = proList[pos].price

                        var kg: Double = 0.00
                        var amount: Double = 0.0
                        var minCount = proList[ptn].minCount.toDouble()//这里是重量？
                        if (minCount == 0.00) {
                            minCount = 0.00
                        }

                        //用来避免科学计数法显示大数
                        val numberFormat = NumberFormat.getInstance().apply {
                            isGroupingUsed = false//禁止科学计数法
                            maximumFractionDigits = 10//小数位
                        }

                        if (!amountStr.isNullOrEmpty()) {
                            amount = amountStr?.toDouble() ?: 0.00//获得金额

                            if (amount < minCount * price) {
                                amount = minCount * price
                                holder.et_xcount2.setText(amount.toString() + "")
                            } else if (amount === minCount!! * price) {
                            } else if (amount >= 10000000) {//最大只能输入百万级总价
                                numberFormat.format(amount).let { it.substring(0, it.length - 1) }.run {
                                    holder.et_xcount2.text = this
                                    amount = this.toDouble()
                                }
                            } else if (amount > maxCount * price) {
                                amount = java.lang.Double.valueOf(maxCount * price)
                                holder.et_xcount2.setText(amount.toString() + "")
                            } else if (amount == maxCount.toDouble()) {
                            } else {
                            }
                        } else {
                            amount = 0.0
                        }
                        //通过以上的限制，把amount回复到规定范围，变化完成，接下来改变金额
                        kg = Arith.div(amount, price)//先不保留两位小数，待最后打包数据上传的时候再保留，否则跳到MemberSalesFra页面显示时，总价显示会有误差
                        val p = proList[ptn]
                        if (kg !== p.tqty) {
                            p.tqty = kg
                            p.amount = amount
                            //下面这两位一起改变数值
                            notifyMain.invoke()
                            holder.tv_kg.setText("×${MoneyUtils.twolastDF(proList[pos].tqty)}")//重量
                        }
                    }
                }.setDecimal(2)
            }

            //以下是从wgmfAda挪过来的========================
            et_xcount.tag = pos

            ibtn_xjian.setOnClickListener {
                var i = et_xcount.getText().toString().toInt()
                i--
                et_xcount.setText(i.toString())
                val ptn = et_xcount.getTag() as Int
                afterChangeWork(ptn, holder, et_xcount.text.toString())
            }

            ibtn_xjia.setOnClickListener {
                var i = et_xcount.getText().toString().toInt()
                i++
                et_xcount.setText(i.toString())
                val ptn = et_xcount.getTag() as Int
                afterChangeWork(ptn, holder, et_xcount.text.toString())
            }



            et_xcount.setOnClickListener { v ->
                keyboard.show(v as TextView, (context as AppCompatActivity).supportFragmentManager) {
                    val ptn = et_xcount.getTag() as Int
                    afterChangeWork(ptn, holder, it)
                }.selectAll()
            }
//            et_xcount2.setOnFocusChangeListener { v, hasFocus ->
//                if(hasFocus){
//                    posTmp = pos
//                    et_xcountTmp = et_xcount2
//                    tv_kgTmp = tv_kg
//                }
//            }
//            et_xcount2.addTextChangedListener(object: TextWatcher{
//                override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
//                }
//
//                override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
//                }
//                override fun afterTextChanged(p0: Editable?) {
//                    if (!proList[pos].isChecked) return
//                    val ptn = holder.et_xcount2.tag as Int
//                    val amountStr = holder.et_xcount2.text.toString()//现在这里不是数量，而是金额，金额是用来输入的
//                    val price = proList[pos].price
//
//                    var kg: Double = 0.00
//                    var amount: Double = 0.0
//                    var minCount = proList[ptn].minCount.toDouble()//这里是重量？
//                    if (minCount == 0.00) {
//                        minCount = 0.00
//                    }
//
//                    if (!TextUtils.isEmpty(amountStr)) {
//                        amount = java.lang.Double.parseDouble(amountStr)//获得金额
//
//                        if (amount < minCount * price) {
//                            amount = minCount * price
//                            holder.et_xcount2.setText(amount.toString() + "")
//                            //                            holder.ibtn_xjian.setEnabled(false);
//                            //                            holder.ibtn_xjia.setEnabled(true);
//                        } else if (amount === minCount!! * price) {
//                            //                            holder.ibtn_xjian.setEnabled(false);
//                            //                            holder.ibtn_xjia.setEnabled(true);
//                        } else if (amount > maxCount * price) {
//                            amount = java.lang.Double.valueOf(maxCount * price)
//                            holder.et_xcount2.setText(amount.toString() + "")
//                            //                            holder.ibtn_xjia.setEnabled(false);
//                            //                            holder.ibtn_xjian.setEnabled(true);
//                        } else if (amount == maxCount.toDouble()) {
//                            //                            holder.ibtn_xjia.setEnabled(false);
//                            //                            holder.ibtn_xjian.setEnabled(true);
//                        } else {
//                            //                            holder.ibtn_xjian.setEnabled(true);
//                            //                            holder.ibtn_xjia.setEnabled(true);
//                        }
//                    } else {
//                        //                        amount = minCount * price;
//                        //                        holder.et_xcount2.setText(amount + "");
//                        amount = 0.0
//                    }
//                    //通过以上的限制，把amount回复到规定范围，变化完成，接下来改变金额
//                    kg = Arith.div(amount, price)//先不保留两位小数，待最后打包数据上传的时候再保留，否则跳到MemberSalesFra页面显示时，总价显示会有误差
//                    val p = proList[ptn]
//                    if (kg !== p.tqty) {
//                        p.tqty = kg
//                        p.amount = amount
//
//                        //下面这两位一起改变数值
//                        notifyMain.invoke()
//                        holder.tv_kg.setText("×${MoneyUtils.twolastDF(proList[pos].tqty)}kg")//重量
//                    }
//
//                }
//            })
        }

    }

    fun afterChangeWork(ptn: Int, holder: ViewHolderXdy, str: String?) {
        if (proList[ptn].isChecked) {
            val str: String = str ?: "0"

            var count = 1
            var minCount = proList[ptn].minCount
            if (minCount == 0) {
                minCount = 1
            }
            if (str.isNotEmpty()) {
                count = str.toInt()

                if (count < minCount) {
                    count = minCount
                    holder.et_xcount.setText(count.toString())
                    holder.ibtn_xjian.setEnabled(false)
                    holder.ibtn_xjia.setEnabled(true)
                } else if (count == minCount) {
                    holder.ibtn_xjian.setEnabled(false)
                    holder.ibtn_xjia.setEnabled(true)
                } else if (count > AppConstants.Printer.maxCount) {
                    count = AppConstants.Printer.maxCount
                    holder.et_xcount.setText(count.toString())
                    holder.ibtn_xjia.setEnabled(false)
                    holder.ibtn_xjian.setEnabled(true)
                } else if (count == AppConstants.Printer.maxCount) {
                    holder.ibtn_xjia.setEnabled(false)
                    holder.ibtn_xjian.setEnabled(true)
                } else {
                    holder.ibtn_xjian.setEnabled(true)
                    holder.ibtn_xjia.setEnabled(true)
                }
            } else {
                count = minCount
                holder.et_xcount.setText(minCount.toString())
            }

            val p = proList[ptn]

            if (count.toDouble() != p.tqty) {
                p.tqty = count.toDouble()
                p.amount = Arith.mul(count.toDouble(), p.getPrice())
                notifyMain.invoke()
            }

        }
    }


    override fun onViewDetachedFromWindow(holder: ViewHolderXdy) {
        super.onViewDetachedFromWindow(holder)
//        holder?.et_xcount2?.apply {
//            clearFocus()
//            removeTextChangedListener(textWatcher) }
    }

    override fun onViewAttachedToWindow(holder: ViewHolderXdy) {
        super.onViewAttachedToWindow(holder)
//        holder?.et_xcount2?.apply {
//            addTextChangedListener(textWatcher)
//            if (posTmp == holder.getAdapterPosition()){
//                requestFocus()
//                setSelection(text.length)
//            }
//        }

    }

    override fun getItemCount(): Int {
        return proList.size
    }


    var textWatcher: TextWatcher = object : TextWatcher {
        override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {
        }

        override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {
        }

        override fun afterTextChanged(s: Editable) {
            if (!proList[posTmp].isChecked) return
            val amountStr = et_xcountTmp?.text.toString()//现在这里不是数量，而是金额，金额是用来输入的
            val price = proList[posTmp].price

            var kg: Double = 0.00
            var amount: Double = 0.0
            var minCount = proList[posTmp].minCount.toDouble()//这里是重量？
            if (minCount == 0.00) {
                minCount = 0.00
            }

            if (!TextUtils.isEmpty(amountStr)) {
                amount = amountStr.toDouble()//获得金额

                if (amount < minCount * price) {
                    amount = minCount * price
                    et_xcountTmp?.setText(amount.toString() + "")
                    //                            holder.ibtn_xjian.setEnabled(false);
                    //                            holder.ibtn_xjia.setEnabled(true);
                } else if (amount === minCount!! * price) {
                    //                            holder.ibtn_xjian.setEnabled(false);
                    //                            holder.ibtn_xjia.setEnabled(true);
                } else if (amount > maxCount * price) {
                    amount = java.lang.Double.valueOf(maxCount * price)
                    et_xcountTmp?.setText(amount.toString() + "")
                    //                            holder.ibtn_xjia.setEnabled(false);
                    //                            holder.ibtn_xjian.setEnabled(true);
                } else if (amount == maxCount.toDouble()) {
                    //                            holder.ibtn_xjia.setEnabled(false);
                    //                            holder.ibtn_xjian.setEnabled(true);
                } else {
                    //                            holder.ibtn_xjian.setEnabled(true);
                    //                            holder.ibtn_xjia.setEnabled(true);
                }
            } else {
                //                        amount = minCount * price;
                //                        holder.et_xcount2.setText(amount + "");
                amount = 0.0
            }
            //通过以上的限制，把amount回复到规定范围，变化完成，接下来改变金额
            //信了你的邪，有的产品价格还会配成0
            kg = if (price == 0.0) 0.0 else Arith.div(amount, price)//不保留两位小数，免得后台校验的时候价格对不上
            val p = proList[posTmp]
            if (kg !== p.tqty) {
                p.tqty = kg
                p.amount = amount

                //下面这两位一起改变数值
                notifyMain.invoke()
                tv_kgTmp?.setText("×${MoneyUtils.twolastDF(proList[posTmp].tqty)}")//重量
            }
        }
    }
}


class ViewHolderXdy(view: View) : RecyclerView.ViewHolder(view) {
    var cb_pro: CheckBox
    //
    var ll_btns: LinearLayout
    var ll_btns2: LinearLayout

    var rl_count_item_click: RelativeLayout
    var tv_after_name: TextView
    var tv_after_bianma: TextView
    var tv_after_danwei: TextView
    var tv_item_id: TextView//产品编码
    var tv_kg: TextView//重量

    var ibtn_xjian: ImageButton
    var et_xcount: TextView
    var et_xcount2: TextView
    var ibtn_xjia: ImageView
    var stockTv: TextView

    init {
        cb_pro = view.findViewById(R.id.cb_pro) as CheckBox
        rl_count_item_click = view.findViewById(R.id.rl_count_item_click) as RelativeLayout
        tv_after_name = view.findViewById(R.id.tv_after_name) as TextView
        tv_after_danwei = view.findViewById(R.id.tv_after_danwei) as TextView
        tv_after_bianma = view.findViewById(R.id.tv_after_bianma) as TextView
        tv_kg = view.findViewById(R.id.tv_kg) as TextView
        tv_item_id = view.findViewById(R.id.tv_item_id) as TextView
        ll_btns = view.findViewById(R.id.ll_btns) as LinearLayout
        ll_btns2 = view.findViewById(R.id.ll_btns2) as LinearLayout
        ibtn_xjian = view.findViewById(R.id.ibtn_xjian) as ImageButton
        et_xcount = view.findViewById(R.id.et_xcount) as TextView
        et_xcount2 = view.findViewById(R.id.et_xcount2) as TextView
        ibtn_xjia = view.findViewById(R.id.ibtn_xjia) as ImageView
        stockTv = view.findViewById(R.id.stockTv) as TextView
    }
}