package com.sibyl.addsellactivity.view

import android.annotation.SuppressLint
import android.app.AlertDialog
import android.content.Intent
import android.graphics.drawable.BitmapDrawable
import android.os.Bundle
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ListView
import android.widget.RadioButton
import android.widget.RadioGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager.widget.ViewPager
import com.sibyl.addsellactivity.presenter.AddSellContract
import com.urovo.activity.addsellactivity.presenter.AddSellMainPre
import com.urovo.activity.addsellactivity.ui.*
import com.urovo.activity.sell.ProductIdComparator
import com.urovo.wgmf.adapter.MyPagerAdapter
import com.urovo.wgmf.db.dao.entitys.ActionFreshBtnBean
import com.urovo.wgmf.db.dao.entitys.ProductEntity
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivityTap
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.data.MoneyUtils
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.view.CustomPopupWindow
import com.urovo.wugumofang.view.LoadWaitDominator
import com.urovo.wugumofang.view.indexBar.IndexbarConfig
import com.wgmf.trade.model.bean.MemberAction
import com.wgmf.trade.ui.fra.index.MemberSalesFra
import kotlinx.android.synthetic.main.select_product_new.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import org.jetbrains.anko.dip
import org.jetbrains.anko.doAsync
import org.jetbrains.anko.find
import org.jetbrains.anko.uiThread
import java.io.Serializable

/**
 * @author Sasuke on 2018/1/2.
 * 常规销售 添加产品主界面 （重构自 AddSellActivity.class  1270lines->227lines  -82.1%）
 */
class AddSellAct : BaseActivityTap(), AddSellContract.mainView {

    //品牌
    var intentBrand: String? = ""
    var phoneNum: String? = ""
    var selectTime: String? = ""
    var isRegularSales: Boolean? = false

    //是不是销售补录
    var isAdditionalRecord: Boolean? = false

    //是不是到家订单
    var is2Home: Boolean? = false

    //活动ID？？？别问我，反正是用来过滤的
    var actListIds: List<String>? = listOf()
    var intentSelected: List<ProductEntity>? = listOf()

    //根据不同品牌来采用不同的Frag
    val storeId = SystemHelper.LoginOrganId

    lateinit var mainPre: AddSellMainPre
    lateinit var wgmfPager: View
    lateinit var xdyPager: View
    var tapBtnLeft: RadioButton? = null
    var tapBtnRight: RadioButton? = null
    var tapRadio: RadioGroup? = null
    var loadWait: LoadWaitDominator? = null

    val pagerList = mutableListOf<View>()

    /**
     * 注：新增会员商品主要影响以下几个分支：
     *  标题
     *  数据List过滤
     *  拉刷新开关
     *  子标签Labels
     *  adapter
     */

    val isMemGoodsBrand
        get() = SystemHelper.isMemGoodsBrand(intent?.getStringExtra(AppConstants.ExtraKeys.ADD_SELL_BRAND))

    //五谷磨房标签开关
    val WGMF_LABEL_POWER
        get() = (SystemHelper.hasWgmf() && "8" in SystemHelper.LoginUserBrandList)
                || isMemGoodsBrand

    //散装标签开关
    val XDY_LABEL_POWER
        get() = SystemHelper.hasXdy() && ("13" in SystemHelper.LoginUserBrandList || "15" in SystemHelper.LoginUserBrandList)
                && !isMemGoodsBrand

    private fun getIntents() {
        //品牌
        intentBrand = intent?.getStringExtra(AppConstants.ExtraKeys.ADD_SELL_BRAND)
        phoneNum = intent.getStringExtra(AppConstants.ExtraKeys.PHONE_NUM)
        isRegularSales = intent?.getBooleanExtra(AppConstants.ExtraKeys.REGULAR_SALES, false)
        isAdditionalRecord = intent?.getBooleanExtra(AppConstants.ExtraKeys.IS_ADDITIONAL_RECORD, false)
        is2Home = intent?.getBooleanExtra(AppConstants.ExtraKeys.IS_2_HOME, false)
        if (isAdditionalRecord == null) isAdditionalRecord = false
        selectTime = intent?.getStringExtra(AppConstants.ExtraKeys.SELECT_TIME)
        //活动ID，据说是为了防止从活动进来选产品的时候，选了与活动重复的产品，所以要用它过滤
        actListIds = intent?.getSerializableExtra("actListIds") as List<String>?
        intentSelected = (intent?.getSerializableExtra("sales") as List<ProductEntity>?)
                ?.filter { it.tqty != 0.0 }//保留数量不为0的
                ?.apply { forEach { it.isChecked = true } }//为每个元素设为“已选
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.select_product_new)
        EventBus.getDefault().register(this)
        getIntents()//这个必须是第一位的
        initTitle()
        AddSellMainPre(this)
        mainPre.start()
    }

    /**
     * 离线模式下，在下载基础资料网络超时之前进入到此页面时，还没来得及加载缓存
     * 所以网络一超时，基础资料用缓存进行初始化后，就让它发一个EventBus到这里，重新刷新界面
     */
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onRefreshAddSell(btnBean: ActionFreshBtnBean) {
        //在没有数据的情况下才刷新
        mainPre?.takeIf { it.data.allList.isEmpty() }?.run {
            initTitle()
            mainPre.start()
        }
    }

    override fun initTitle() {
        super.initTitle()
        //初始化标题
        val isShowTapTitle = (XDY_LABEL_POWER && WGMF_LABEL_POWER)
        addSellTitle.find<RadioGroup>(R.id.tap_radio).visibility = if (isShowTapTitle) View.VISIBLE else View.GONE
        addSellTitle.find<TextView>(R.id.textTitle).run {
            visibility = if (isShowTapTitle) View.GONE else View.VISIBLE
            text = if (isMemGoodsBrand) SystemHelper.MemGoodsBrand else "选择产品"
        }
    }

    override fun init() {
        loadWait = LoadWaitDominator(this, container)
        loadWait?.show(LoadWaitDominator.LOADING)
        initViews()//初始化上方标签和Viewpager
        doAsync {
            mainPre.initAllList(storeId, intentSelected, actListIds, phoneNum, isMemGoodsBrand)//初始化产品总表数据
            uiThread {
                showLabels()
                refreshShow()//刷新总价显示
                //列表不显示的情况处理
                loadWaitDismiss()
                if (mainPre.data.originAllList.size == 0) {
                    loadWaitError("未找到门店可销售产品信息，先重新下载基础资料，还是为空的话再找销管部对接人去DRP维护门店资料！")
                    return@uiThread
                } else if (SystemHelper.LoginUserBrandList.isNullOrEmpty() || mainPre.data.allList.isEmpty()) {//没有员工品牌信息，或者有品牌信息但过滤之后没有符合的商品
                    loadWaitError("你的品牌信息有问题，先退出重新输入门店编码登录，还是为空的话再找文员去工资平台维护品牌信息！")
                    return@uiThread
                }
                //如果是会员商品，就请求库存，请求失败不让用
                if (isMemGoodsBrand) {
                    loadWait?.show(LoadWaitDominator.LOADING)
                    mainPre.queryStock()
                }
            }
        }
        btn_saveSell.setOnClickListener { packAll() }//保存按钮
        tv_count.setOnClickListener { popupSelectWin() }//已选产品弹窗

        swipeLayout.setEnableRefresh(isMemGoodsBrand)//只有会员商品才支持下拉刷新
        swipeLayout.setOnRefreshListener {
            it.finishRefresh(30_000)//30秒超时
            mainPre.queryStock()//请求库存
        }
    }


    private fun initViews() {
        //先初始化viewpager
        wgmfPager = LayoutInflater.from(this).inflate(R.layout.select_product_vp_item, null)
        xdyPager = LayoutInflater.from(this).inflate(R.layout.select_product_vp_item, null)
        pagerList.run {
            clear()
            if (WGMF_LABEL_POWER) add(wgmfPager)
            if (XDY_LABEL_POWER) add(xdyPager)
        }
        tapBtnLeft = addSellTitle.find<RadioButton>(R.id.tap_button_left).apply { text = if (isMemGoodsBrand) SystemHelper.MemGoodsBrand else SystemHelper.WgmfBrand }
        tapBtnRight = addSellTitle.find<RadioButton>(R.id.tap_button_right).apply { text = SystemHelper.XdyBrand }
        tapRadio = addSellTitle.find<RadioGroup>(R.id.tap_radio)
        //再初始化viewpager监听
        tapRadio?.setOnCheckedChangeListener { group, checkedId ->
            viewpager.setCurrentItem(when (checkedId) {
                R.id.tap_button_left -> 0
                R.id.tap_button_right -> 1
                else -> 0
            }, true)
        }
        //如果没有鲜稻研（第二品牌）那就删掉viewpager的第二个页面
        //其实这段前后就是先把整个ViewPager的Pagers们都一次性初始化，然后再根据实际品牌情况来把对应的pager从数据源删除掉。
        viewpager.adapter = MyPagerAdapter(this, ArrayList(pagerList))
        //页面滚动监听
        viewpager.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrollStateChanged(state: Int) {
            }

            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {
            }

            override fun onPageSelected(position: Int) {
                when (position) {
                    0 -> tapBtnLeft?.isChecked = true
                    1 -> tapBtnRight?.isChecked = true
                }
            }
        })
    }

    /**
     * 分类标签的数据已过滤完成，可以显示标签组件了
     */
    private fun showLabels() {
        val wgmfRadioGroup = AutoRadioGroup(wgmfPager.find(R.id.labelGroup))
        mainPre.data.wgmfLabels.forEach { labelText ->
            //以下三句：1、创建radioButton 2、在radioGroup里添加radioButton并创建监听，3、创建对应该radioButton的Fragment
            val radio: RadioButton = (layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton)
            wgmfRadioGroup.addView(radio, labelText) { pos -> refreshRv(if (isMemGoodsBrand) SystemHelper.MemGoodsBrand else SystemHelper.WgmfBrand, mainPre.data.wgmfLabels[pos]) { refreshShow() } }
        }
        wgmfRadioGroup.setChildChecked(0)

        val xdyRadioGroup = AutoRadioGroup(xdyPager.find(R.id.labelGroup))
        mainPre.data.xdyLabels.forEach { labelText ->
            val radio: RadioButton = (layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton)
            xdyRadioGroup.addView(radio, labelText) { pos -> refreshRv(SystemHelper.XdyBrand, mainPre.data.xdyLabels[pos]) { refreshShow() } }
        }
        xdyRadioGroup.setChildChecked(0)
    }

    override fun loadWaitDismiss() {
        loadWait?.dismissAll()
    }

    override fun loadWaitError(error: String) {
        loadWait?.show(error)
    }

    /**
     * 现在不用Fragment了，就直接刷新Rvr的adapter，如果为空就创建，否则notify
     */
    private fun refreshRv(brand: String, label: String, notifyMain: () -> Unit) {
        //这里的需求是：如果是“全部”标签，就需要把包括活动商品在内的所有可销售产品都列出来，但如果是普通标签，就过滤掉活动商品
        if (SystemHelper.isWgmf(brand) || SystemHelper.isMemGoodsBrand(brand)) {//如果是五谷磨房 或 会员商品（这俩位让他们共用算了。）
            mainPre.data.wgmfShowDatas = mainPre.getProByBrandLabel(brand, label).toMutableList()
            IndexbarConfig(this,
                    wgmfPager?.find(R.id.product_index_bar),
                    wgmfPager?.find(R.id.tvSideBarHint),
                    wgmfPager?.find(R.id.proLv),
                    mainPre.data.wgmfShowDatas).run {
                indexBar.setCustomComparator(ProductIdComparator())
                toggleShowIndexBar(label == "全部")
            }
//                configIndexbar(wgmfPager?.find(R.id.rvRoot)!!,label == "全部",mainPre.data.wgmfShowDatas)
            wgmfPager?.find<RecyclerView>(R.id.proLv)?.takeIf { it.adapter == null }?.run {
                adapter = if (label == "十方") ShiFangAda(this@AddSellAct, mainPre.data.wgmfShowDatas, notifyMain)
                else WgmfAda(this@AddSellAct, mainPre.data.wgmfShowDatas, isMemGoodsBrand, notifyMain)
            }
            wgmfPager?.find<RecyclerView>(R.id.proLv)?.adapter?.notifyDataSetChanged()
            //如果是第二品牌============================================
        } else {
            mainPre.data.xdyShowDatas = mainPre.getProByBrandLabel(brand, label).toMutableList()
            IndexbarConfig(this,
                    xdyPager?.find(R.id.product_index_bar),
                    xdyPager?.find(R.id.tvSideBarHint),
                    xdyPager?.find(R.id.proLv),
                    mainPre.data.xdyShowDatas).run {
                indexBar.setCustomComparator(ProductIdComparator())
                toggleShowIndexBar(label == "全部")
            }

            xdyPager?.find<RecyclerView>(R.id.proLv)?.takeIf { it.adapter == null }?.run {
                adapter = XdyAda(this@AddSellAct, mainPre.data.xdyShowDatas, notifyMain)
            }
            xdyPager?.find<RecyclerView>(R.id.proLv)?.adapter?.notifyDataSetChanged()
        }
    }

    /**刷新库存成功*/
    override fun refreshStockSuccess() {
        wgmfPager?.find<RecyclerView>(R.id.proLv)?.adapter?.notifyDataSetChanged()
        swipeLayout.finishRefresh(true)
    }

    /**刷新库存失败*/
    override fun refreshStockFailed() {
        swipeLayout.finishRefresh(false)
    }

    /**
     * 刷新底栏总价显示
     */
    @SuppressLint("SetTextI18n")
    override fun refreshShow() {
        //鲜稻研不需要显示数量，五谷磨房则相反
        tv_count.text = when (true) {
            !XDY_LABEL_POWER -> "查看已选(${mainPre.countProNum().toInt()})"
            else -> "查看已选"
        }
        val proAmount = mainPre.countProAmount()
        tv_result.text = "共${MoneyUtils.twolastDF(proAmount)}元"
        btn_saveSell.isEnabled = if (proAmount == 0.00) false else true
    }


    /**
     * 打包所有已选产品数据
     */
    override fun packAll() {
        val selectedList = mainPre.packAll()
        selectedList.forEach {
            if (it.isOverMemStock(it.tqty)) {//如果数量超过了库存
                AlertDialog.Builder(this).setMessage("${it.itemName} 的录入数量超过了库存数量")
                        .setPositiveButton("我知道了", null)
                        .show()
                return
            }
        }
        val data = Intent().apply {
            putExtra(AppConstants.ExtraKeys.ADD_SELL_SELECT_LIST, selectedList as Serializable)
            putExtra("BRAND", intentBrand)
        }
        setResult(150, data)

        if (isRegularSales == true) {
            //组装待显示的常规销售列表
            val memberAction = MemberAction().apply {
                content = "常规销售"
                name = "常规销售"
                actType = 2//AppConstants.ExtraKeys.REGULAR_SALES 不打算用这个来判断。直接用这个地段；
                rule = MemberAction.RuleBean().apply { productInfo = MemberSalesFra.changeOldToNewModels(selectedList) }
                arriveHome = if (is2Home!!) 1 else 0//是否到家服务，1是  0不是
            }
            MemberSalesFra.launch(this@AddSellAct, phoneNum, memberAction, isAdditionalRecord!!, selectTime, intentBrand)//isAdditionalRecord前面做了保险，绝不会为空
        }
        finish()
    }

    /**
     * 已选弹窗
     */
    val selectPop: CustomPopupWindow by lazy {
        CustomPopupWindow.Builder(this)
                .setContentView(R.layout.add_sell_pop_ll)
                .setFouse(true)
                .setOutSideCancel(true)
                .setAnimationStyle(R.style.add_sell_popup_anim_style)
                .setBackgroundDrawable(BitmapDrawable())
                .setwidth(ViewGroup.LayoutParams.MATCH_PARENT)
                .setheight(dip(320))
                .builder()
    }

    val bottomLocation: IntArray by lazy {
        intArrayOf(0, 0).apply { ll_re.getLocationOnScreen(this) }
    }

    /**
     * 弹出已选产品弹窗
     */
    fun popupSelectWin() {
        val selectedList = mainPre.packAll()
        if (selectedList.size == 0) return
        selectPop?.let {
            //只有为空的时候才实例化，不为空就直接show了
            (selectPop.getItemView(R.id.selectLv) as ListView).apply {
                adapter = WgmfSelectAda(this@AddSellAct, selectedList) { refreshShow() }
            }
        }
        selectPop.showAsLocation(ll_re, Gravity.NO_GRAVITY, bottomLocation[0], bottomLocation[1] - selectPop.height)
    }

    /**
     * 监听界面焦点变化，刷新列表
     */
    override fun onWindowFocusChanged(hasFocus: Boolean) {
        super.onWindowFocusChanged(hasFocus)
        if (hasFocus) {
            arrayOf(wgmfPager, xdyPager).forEach {
                it?.find<RecyclerView>(R.id.proLv)?.adapter?.notifyDataSetChanged()
            }
        }
    }

    override fun onDestroy() {
        EventBus.getDefault().unregister(this)
        super.onDestroy()
    }

    override fun setPresenter(pre: AddSellContract.mainPre?) {
        this.mainPre = pre as AddSellMainPre
    }
}