package com.urovo.activity.addsellactivity.view

import android.os.Bundle
import android.view.View
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.addsellactivity.net.ProShowRes
import com.urovo.activity.addsellactivity.ui.ProShowAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import kotlinx.android.synthetic.main.add_sell_pro_detail_act.*
import okhttp3.Request
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2019-7-15 0015.
 */
class AddSellProShowAct: BaseActivity() {

    val proId by lazy {
        intent.getStringExtra("PRO_ID")
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.add_sell_pro_detail_act)
        initTitle()
        init()
        query(proId)
    }

    fun init(){
        titleTextView.text = intent.getStringExtra("PRO_NAME")
    }

    fun query(proId: String?){
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.QUERY_PRO_DETAIL,
                mapOf("productId" to proId),object: OkHttpDominator.ResultCallback<ProShowRes>(){
            override fun onError(request: Request?, e: Exception?) {
                showMsg(e.toString())
            }

            override fun onResponse(res: ProShowRes?) {
                res?.resultInfo?.productDesc.let {
                    //顶部描述
                    noticeTv.visibility = if (it.isNullOrBlank()) View.GONE else View.VISIBLE
                    (noticeTv.find(R.id.more_not_upload_notice) as TextView).text = it
                }
                //显示图片列表
                res?.resultInfo?.productImages?.sortedBy { it.sortingOrder }?.map { it.imageUrl }.let { imgs ->
                    rV.run {
                        layoutManager = LinearLayoutManager(this@AddSellProShowAct)
                        adapter = ProShowAdapter(this@AddSellProShowAct,imgs)
                    }
                }
            }
        })
    }
}