package com.urovo.activity.appraise;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.KeyEvent;
import android.webkit.CookieManager;
import android.webkit.CookieSyncManager;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.net.CookieDominator;
import com.urovo.wugumofang.R;
import com.wgmf.trade.GlobalApp;

import java.util.HashMap;

/**
 * Created by Sasuke on 2016/3/24.
 */
public class AppraiseWebAct extends BaseActivity {
    String pageType;
    WebView webView;
    TextView title;
    WebViewClient client;
    String url;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.appraise_act_webview);
        initTitle();
        getView();
        setTitleAndUrl();
        setWebView();
        setCookies();

        webView.loadUrl(url);
    }



    /**
     * 设置Cookies
     */
    private void setCookies(){
        HashMap<String,String> params = new HashMap<>();
        params.put("userName",SystemHelper.LoginUserName);
        params.put("userId",SystemHelper.LoginUserId);
        params.put("mendianId",SystemHelper.LoginOrganId);
        params.put("mendianName",SystemHelper.LoginOrganName);
        CookieDominator.setCookie(GlobalApp.getInstance(),url,params);

//        try {
//            CookieSyncManager.createInstance(AppraiseWebAct.this);
//            CookieManager cookieManager = CookieManager.getInstance();
//            cookieManager.removeSessionCookie();
//            cookieManager.setAcceptCookie(true);
//            cookieManager.setCookie(url, "userName=" + URLEncoder.encode(SystemHelper.LoginUserName,"utf-8"));
//            cookieManager.setCookie(url, "userId=" + URLEncoder.encode(SystemHelper.LoginUserId,"utf-8"));
//            cookieManager.setCookie(url, "mendianId=" + URLEncoder.encode(SystemHelper.LoginOrganId,"utf-8"));
//            cookieManager.setCookie(url, "mendianName=" + URLEncoder.encode(SystemHelper.LoginOrganName,"utf-8"));
//            CookieSyncManager.getInstance().sync();
//        } catch (UnsupportedEncodingException e) {
//            e.printStackTrace();
//        }
    }



    /**
     * 对WebView进行一些基本设置
     */
    @SuppressLint("SetJavaScriptEnabled")
    private void setWebView(){
        client = new WebViewClient(){
            @Override
            public boolean shouldOverrideUrlLoading(WebView view, String url) {
                view.loadUrl(url);
                return true;
            }

            @Override
            public void onPageFinished(WebView view, String url) {
               super.onPageFinished(view, url);
            }
        };

        webView.setWebViewClient(client);
        webView.getSettings().setJavaScriptEnabled(true);
        webView.getSettings().setDomStorageEnabled(true);
        webView.getSettings().setSavePassword(false);//webview不要保存密码，官方未来会不支持保存密码
        webView.removeJavascriptInterface("searchBoxJavaBridge_");
        webView.removeJavascriptInterface("accessibility");
        webView.removeJavascriptInterface("accessibilityTraversal");
    }

    /**
     * 从Intent获取Title并设置title
     */
    private void setTitleAndUrl(){
        pageType = getIntent().getStringExtra("type");
        if(pageType.equals("detail")){
            title.setText("评价详情");
        }else if(pageType.equals("dataSearch")){
            title.setText("评价数据查询");
        }else if(pageType.equals("daShang")){
            title.setText("打赏数据");
        }
        url = getIntent().getStringExtra("URL");
    }

    /**
     * 得到组件
     */
    private void getView(){
        title = (TextView) findViewById(R.id.text_title);
        webView = (WebView)findViewById(R.id.web_view);

    }


    /**
     *  按返回键webView退回上一页，无上一页了就退出Activity
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if ((keyCode == KeyEvent.KEYCODE_BACK) && webView.canGoBack()) {
            webView.goBack();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }


    @Override
    protected void onDestroy() {
        CookieSyncManager.createInstance(this);  //Create a singleton CookieSyncManager within a context
        CookieManager cookieManager = CookieManager.getInstance(); // the singleton CookieManager instance
        cookieManager.removeAllCookie();// Removes all cookies.
        CookieSyncManager.getInstance().sync(); // forces sync manager to sync now

        webView.setWebChromeClient(null);
        webView.setWebViewClient(null);
        webView.clearCache(true);
        super.onDestroy();
    }
}
