package com.urovo.activity.attendancemanagement

import android.annotation.SuppressLint
import android.app.Activity
import android.app.AlertDialog
import android.content.DialogInterface
import android.content.Intent
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.Bundle
import android.provider.Settings
import android.util.Log
import android.view.View
import android.widget.Button
import com.amap.api.maps2d.LocationSource
import com.urovo.activity.attendancemanagement.signinandout.map.MapDominator
import com.urovo.activity.attendancemanagement.signinandout.presenter.SignInAndOutContract
import com.urovo.activity.attendancemanagement.signinandout.presenter.SignInAndOutPresenter
import com.urovo.wgmf.PosBaseActivity
import com.urovo.wgmf.db.dao.dao.Store001DbOprate
import com.urovo.wgmf.view.AdDialog
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.NetHelper
import com.urovo.wugumofang.system.BaseAppManager
import com.urovo.wugumofang.system.ToActivity
import com.urovo.wugumofang.ui.BitmapUtil
import com.urovo.wugumofang.ui.DialogHelper
import com.urovo.wugumofang.ui.PhotoPickDominator
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.utils.CommonTools
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra
import com.zsy.libcore.common.android.log.SYLoger
import com.zsy.libext.widgets.dialog.SelectRadioDialog
import kotlinx.android.synthetic.main.sign_in_out2.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import org.jetbrains.anko.dip
import org.jetbrains.anko.doAsync
import org.jetbrains.anko.uiThread
import java.io.File
import java.text.SimpleDateFormat
import java.util.*
import kotlin.concurrent.timerTask

/**
 * @author Sasuke on 2018-12-29.
 * 新签到签退
 * 【注意注意！！】这个Activity运行在单独进程，所以不要使用全局静态变量如SystemHelper之类的，进程不同步。
 */
class SignInAndOutActivity : PosBaseActivity(), SignInAndOutContract.view, LocationSource {

    companion object {
        /**拍照*/
        const val REQUEST_TAKEPHOTO = 1

        /**从相册中选择*/
        const val REQUEST_SCAN = 2

        /**照片的最大数量*/
        private val PHOTO_MAX_NUM = 6

        /**签到*/
        const val SIGN_IN_TYPE = "1"

        /**签退*/
        const val SIGN_OUT_TYPE = "2"

    }

    private var mTimer: Timer? = null
    private var mPre: SignInAndOutPresenter? = null

    private var mMapDominator: MapDominator? = null
    private var mIsFirstResume = true//是否第一次进入（避免onResume里的定位与地图初始化里的自动定位重复，造成两次定位）
    private var mIsShowLocateToast = true//定位信息显示计数
    private var mPicker: PhotoPickDominator? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.sign_in_out2)
        EventBus.getDefault().register(this)
        SignInAndOutPresenter(this).start()

        initMap(savedInstanceState)//初始化地图
    }

    override fun init() {
        initTitle()
        //清掉 下划线_ 开头的图片，因为可能是上次打卡失败时强退留下的，不清掉会对当次打卡造成干扰。
        Files.getSignInAndOutPhotoCache("_").forEach { it.delete() }
        titleTextView.text = "签到签退"
        mPre?.userId = intent?.getStringExtra(ToActivity.LOGIN_USER_ID)
        mPre?.userName = intent?.getStringExtra(ToActivity.LOGIN_USER_NAME)
        store_no.text = "门店编号：${
            if (!isPda()) {
                mPre?.storeNo = intent?.getStringExtra(ToActivity.LOGIN_ORGAN_ID); mPre?.storeNo
            } else ""
        }"
        store_name.text = "${Store001DbOprate.GetStoreName(mPre?.storeNo)}"
        people_name.text = mPre?.userName
        people_no.text = "工号：${mPre?.userId}"
        mapView.visibility = View.INVISIBLE

        addImage.setOnClickListener { showCamera() }
        //个人形象拍照标准参考
        userPhotoStdTv.setOnClickListener {
            BaseCookiesWebFra.launch(
                this,
                NetParam.userPhotoStdUrl,
                null,
                false
            )
        }
        //专柜卫生拍照标准参考
        zhuanguiPhotoStdTv.setOnClickListener {
            BaseCookiesWebFra.launch(
                this,
                NetParam.zhuanguiPhotoStdUrl,
                null,
                false
            )
        }
        //相片不合格示例
        notOkExampleTv.setOnClickListener {
            BaseCookiesWebFra.launch(
                this,
                NetParam.notOkExampleUrl,
                null,
                false
            )
        }
        //不断刷新当前时间的显示。
        mTimer = Timer().apply { schedule(timerTask { refreshTimeShow() }, 0, 500) }

        if (isPda()) {
            pdaGuide.visibility = View.VISIBLE
            signBtnGroup.visibility = View.GONE
            mapLayout.visibility = View.GONE
            photosLayout.visibility = View.GONE
        }

        /**签到签退监听*/
        arrayOf(signInBtn, signOutBtn).forEach {
            it.setOnClickListener {
                if (CommonTools.isOneClick()) {
                    when (it) {//点击的同时，马上把类型记录到mPre里。
                        signInBtn -> SIGN_IN_TYPE.apply { mPre?.signType = SIGN_IN_TYPE }
                        else -> SIGN_OUT_TYPE.apply { mPre?.signType = SIGN_OUT_TYPE }
                    }
                    //有网时才检查促销产品
                    //if (isHaveInternet()) {
                    //如果是签到，先查询接口是否已选择促销产品，返回ture弹窗提示选择促销产品
                    //    if (it == signInBtn) {
                    //        mPre?.querySignFlag(mPre?.userId, SIGN_IN_TYPE)
                    //        return@setOnClickListener
                    //    }
                    //}
                    //否则是签退，直接检查提交数据
                    checkInput(when (it) {//点击的同时，马上把类型记录到mPre里。
                        signInBtn -> SIGN_IN_TYPE.apply { mPre?.signType = SIGN_IN_TYPE }
                        else -> SIGN_OUT_TYPE.apply { mPre?.signType = SIGN_OUT_TYPE }
                    })
                }
            }
        }
        ViewUtil.showProgress(this, "提示", "正在获取您的地理信息...")
    }

    override fun showSignFlagDialog(signType: String, flag: String) {
        //打卡弹窗执行 true：弹窗，false不弹
        if ("true" == flag) {
            //弹窗需选择促销产品，再进入签到流程
            val builder = SelectRadioDialog.Builder(this)
            builder.setTitle("请确认")
            builder.setMessage("今天主管安排您在本店促销的产品为：")
            builder.setPositiveButton(
                R.string.sure,
                DialogInterface.OnClickListener { dialog, which ->
                    if (builder.getIsComplete() == null) {
                        showMsg("请选择促销产品！")
                        return@OnClickListener
                    }
                    dialog.dismiss()
                    //上传选择促销产品
                    mPre?.querySignForSaleData(mPre?.userId, builder.getIsComplete().toString())
                    checkInput(signType)
                }).create().show()
            return
        }
        //不弹窗直接进入签到流程
        checkInput(signType)
    }

    /**
     * 检查输入合法性
     */
    private fun checkInput(signType: String) {
        if (isPda()) {
            mPre?.Position_Valid = ""
            mPre?.submitSignData(signType)
        } else {
            val action = if (signType == SIGN_IN_TYPE) "签到" else "签退"
            if (mPre?.storeNo.isNullOrEmpty() && mPre?.data?.getPhotoList()?.size == 0) {
                DialogHelper.Alert(this, "提示", "请先扫描门店条码和拍照再进行$action", null, null)
            } else if (mPre?.storeNo.isNullOrEmpty()) {
                DialogHelper.Alert(this, "提示", "请先扫描门店条码再进行$action", null, null)
            } else if (mPre?.data?.getPhotoList()?.size == 0) {
                DialogHelper.Alert(this, "提示", "请先拍照再进行$action", null, null)
            } else if (mPre?.userId.isNullOrEmpty()) {
                DialogHelper.Alert(
                    this, "提示", "请重新登录，工号信息为空！",
                    null, null
                )
            } else {
                if (isHaveInternet()) {
                    confirmDialog(signType)
                } else {//离线
                    mPre?.Position_Valid = ""
                    mPre?.submitSignData(signType)
                }
            }
        }
    }

    private fun confirmDialog(signType: String) {
        if (0 != (mPre?.location?.errorCode ?: -1)) {
            DialogHelper.Alert(
                this, "错误提示：${
                    mPre?.location?.errorInfo
                        ?: ""
                }", "无法获取您的地理信息，点击确定可以打卡", null
            ) { dialog, which ->
                mPre?.Position_Valid = ""
                mPre?.submitSignData(signType)
            }
        } else {
            if (isHaveInternet()) {
                mPre?.checkCanKaoQin { msg, isCoutinueSubmit ->
                    DialogHelper.Alert(
                        this,
                        "提示： ",
                        "$msg  ",
                        null
                    ) { dialog, which -> if (isCoutinueSubmit) mPre?.submitSignData(signType) }
                }
                SYLoger.print("地理位置正确，一切正常，开始打卡")
            } else {
                SYLoger.print("地理位置正确，一切正常，开始离线打卡")
                mPre?.Position_Valid = ""
                mPre?.submitSignData(signType)
            }
        }
    }

    /**
     * 是否联网 或者 是否离线模式（注：在定位地理位置失败时，切入离线模式
     */
    override fun isHaveInternet(): Boolean {
        return NetHelper.IsHaveInternet(this) && !mPre!!.isOfflineMode
    }

    /**
     * 初始化地图
     */
    fun initMap(instanceState: Bundle?) {
        mMapDominator = MapDominator.MapBuilder(instanceState, this, mapView)
            .build()//这个只是用来实例化mapDominator，并没有初始化地图
        //一定要跟上面分开，要先build()，再执行 start()
        //这个才是真正的初始化地图参数，里面的 setLocationSource()方法会导致跳转到 activate()方法，激活地图
        mMapDominator?.start()?.setLocateButton(locateBtn)
    }

    /**
     * 开始拍照
     */
    private fun showCamera() {
        if (mPicker == null) {
            mPicker = PhotoPickDominator(this, mPre?.data?.getPhotoList())
        }
        if (mPre?.data?.getPhotoList()?.size ?: 0 < PHOTO_MAX_NUM) {
            mPre?.capture()
        } else {
            showMsg("最多只能上传" + PHOTO_MAX_NUM + "张图片!")
        }
    }

    /**
     * 停止定位
     */
    override fun deactivate() {
        mMapDominator?.deactivate()
    }

    override fun activate(listener: LocationSource.OnLocationChangedListener?) {
        mMapDominator?.activateMap(listener, successCallback = { location ->
            ViewUtil.dismissProgress()
            mapView.visibility = View.VISIBLE
            //只有在第0次的时候才弹定位信息Toast
            if (mIsShowLocateToast) showMsg("成功获取地理信息， 位置在: \n ${location.address}")
            mPre?.location = location
            mIsShowLocateToast = true
        }, failedCallback = { location ->
            ViewUtil.dismissProgress()
            mapView.visibility = View.INVISIBLE
            if (mIsShowLocateToast) {
                AlertDialog.Builder(this@SignInAndOutActivity)
                    .setMessage("获取地理信息失败，请检查设置定位权限")
                    .setNegativeButton("算了", null)
                    .setPositiveButton(
                        "去开启权限",
                        { dialogInterface, i -> startActivity(Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS)) })//跳转系统定位设置
                    .show()
            }
            mIsShowLocateToast = true
        })
    }

    private fun refreshTimeShow() {
        runOnUiThread {
            dateTv?.text = SimpleDateFormat("yyyy-MM-dd", Locale.CHINA).format(Date())
            timeTv?.text = SimpleDateFormat("HH:mm:ss", Locale.CHINA).format(Date())
        }
    }

    override fun setPresenter(presenter: SignInAndOutContract.presenter?) {
        this.mPre = presenter as SignInAndOutPresenter
    }

    override fun onDestroy() {
        super.onDestroy()
        EventBus.getDefault().unregister(this)
        PhotoPickDominator(this).deletePicCache()
        mTimer?.cancel()
        mTimer = null
        //在activity执行onDestroy时执行mMapView.onDestroy()，销毁地图
        mMapDominator?.onDestroy()
    }

    private var mHasShowDialog = false//是否已弹出了成功弹窗
    override fun afterSignInAndOut() {
        if (mHasShowDialog || isFinishing) return
        ViewUtil.dismissProgress()
        AdDialog(
            this,
            if (mPre?.signType == SIGN_IN_TYPE) R.mipmap.pop_clock_in else R.mipmap.pop_clock_out
        ).apply {
            setIsDIY(true)
            //点击空白区域能不能退出
            setCanceledOnTouchOutside(false)
            //按返回键能不能退出
            setCancelable(false)
            setDismissCallback(object : AdDialog.DismissCallback() {
                override fun run() {
                    finish()
                }
            })
        }.show()
        mHasShowDialog = true
    }

    override fun onResume() {
        super.onResume()
        if (!mIsFirstResume) {
            mIsShowLocateToast = false//为了实现onresume只在第一次弹Toast而手动定位每次都弹Toast
            mMapDominator?.startLocate()
        }//屏幕
        //在activity执行onResume时执行mMapView.onResume ()，重新绘制加载地图
        mMapDominator?.onResume()
        mIsFirstResume = false
    }

    override fun onPause() {
        super.onPause()
        //在activity执行onPause时执行mMapView.onPause ()，暂停地图的绘制
        mMapDominator?.onPause()
    }

    override fun onSaveInstanceState(outState: Bundle) {
        //在activity执行onSaveInstanceState时执行mMapView.onSaveInstanceState (outState)，保存地图当前的状态
        mMapDominator?.onSaveInstanceState(outState)
        outState.run {
            putString("storeNo", mPre?.storeNo)
            putString("userId", mPre?.userId)
            putString("userName", mPre?.userName)
            putString("storeNoTxt", store_no.text.toString())
            putString("storeNameTxt", store_name.text.toString())
            putString("userNoTxt", people_no.text.toString())
            putString("userNameTxt", people_name.text.toString())
        }
        super.onSaveInstanceState(outState)//保存时super最后执行
    }


    override fun onRestoreInstanceState(savedInstanceState: Bundle) {
        super.onRestoreInstanceState(savedInstanceState)//恢复时super最先执行
        savedInstanceState.run {
            mPre?.storeNo = getString("storeNo")
            mPre?.userId = getString("userId")
            mPre?.userName = getString("userName")
            store_no.text = getString("storeNoTxt")
            store_name.text = getString("storeNameTxt")
            people_no.text = getString("userNoTxt")
            people_name.text = getString("userNameTxt")
        }

    }

    /**
     * 处理请求地理位置时连接wifi/数据成功却没有网络的情况（或接口异常）
     * （我是没看明白这是在干嘛的。。。。那什么Task请求不是早就不用了吗。。。）
     *
     * @param event ...
     */
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onNetErrorEvent(event: NetErrorEvent?) {
        if (event != null && event.isOpenOfflineMode) {
            mPre?.submitSignData(mPre?.signType ?: "1")
        }
    }

    override fun onScaned(barcode: String?) {
        OnGetBarcode(barcode)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            // 当选择拍照时调用
            REQUEST_TAKEPHOTO -> if (resultCode == Activity.RESULT_OK) {
                try {
                    doAsync {
                        //从文件读出来的时候就要大压缩一次。。。这里占内存最多！
                        var bitmap: Bitmap? = BitmapFactory.decodeFile(
                            mPre?.savePhotoPath,
                            BitmapUtil.getDecodeOption(mPre?.savePhotoPath, 1080, 1080)
                        )
                        val degree = BitmapUtil.getBitmapDegree(mPre?.savePhotoPath)
                        //说明拍照后被系统旋转了,那我们就要把它转回来
                        if (degree != 0) {
                            bitmap = BitmapUtil.rotateBitmapByDegree(bitmap, degree)
                        }
                        //添加日期水印
                        val bmp = mPre?.drawDate(bitmap)
                        if (null != bmp) {
                            File(mPre?.compress2Local(bmp))
                            Log.e(
                                "bmp",
                                bmp.getWidth()
                                    .toString() + "----" + bmp.getHeight() + "----" + bmp.getByteCount()
                            )
                            bmp.recycle()
                            bitmap?.recycle()
                        }
                        uiThread {
                            mPicker?.addPhoto2Group(
                                mPre?.savePhotoPath,
                                dip(60f),
                                dip(60f),
                                photoGroup
                            )
                        }
                    }
                } catch (e: Exception) {
                    addImage.setImageResource(R.drawable.add_picture)
                    showMsg("获取图片失败：$e")
                    BaseAppManager.loger().info(e)
                }

            }
            // 当选择从相册中选取
            REQUEST_SCAN -> if (data != null) {
                val code = data.getStringExtra("code")
                OnGetBarcode(code)
            }
            else ->//如果requestCode!=REQUEST_TAKEPHOTO 说明相机调用失败，需要权限弹窗
                permissionDialog()
        }
    }

    /**
     * 刷新横向照片列表
     */
    fun refreshListView() {
        val hintVisibility =
            if (mPre?.data?.getPhotoList()?.size ?: 0 > 0) View.GONE else View.VISIBLE
        val listVisibility =
            if (mPre?.data?.getPhotoList()?.size ?: 0 > 0) View.VISIBLE else View.GONE
        addImage.visibility = hintVisibility
        if (mPre?.data?.getPhotoList()?.size == 0) {
            addImage.setImageResource(R.drawable.add_picture)
        }
        photoHint.visibility = hintVisibility
    }

    @SuppressLint("SetTextI18n")
    private fun OnGetBarcode(barcode: String?) {
        pdaGuide.text = "扫描结果：$barcode"
        //storeId = barcode.substring(3, barcode.length() - 3);
        //注：扫码会扫出 *** 4110014***这样带星号的，为了避免解析问题，以后直接读SystemHelper.LoginOrganId就行，不使用扫码的门店号
        mPre?.storeNo = intent?.getStringExtra(ToActivity.LOGIN_ORGAN_ID)
        val storeNameTxt =
            Store001DbOprate.GetStoreName(mPre?.storeNo).apply { store_name.text = this }
        store_no.text = "门店编号：${
            if (storeNameTxt.isNullOrEmpty()) {
                mPre?.storeNo = ""; ""
            } else mPre?.storeNo
        }"
        signBtnGroup.visibility = if (storeNameTxt.isNullOrEmpty()) View.GONE else View.VISIBLE
        if (storeNameTxt.isNullOrEmpty()) {
            showMsg("请获取正确的门店编号!")
        }
    }
}