package com.urovo.activity.attendancemanagement.attendancemanager.net;

import com.alibaba.fastjson.JSONArray;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.ShiftConfirmResponseEntity;
import com.urovo.activity.attendancemanagement.attendancemanager.ent.ShiftQueryEntity;
import com.urovo.wgmf.db.dao.entitys.StockSearchEntity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.Map;

import retrofit2.Call;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.QueryMap;

/**
 * @author chenji last on 2018/1/2 19:53
 */
public interface IAttendanceManagerNet {
    /**
     * 排班查询接口
     *
     * @param map 参数集合
     * @return ...
     */
    @GET(ApiUrls.YXGJ.SHIFT_QUERY)
    Call<ShiftQueryEntity> getShiftQueryList(@QueryMap Map<String, String> map);

    /**
     * 排班确认接口
     *
     * @param map ...
     * @return ...
     */
    @POST(ApiUrls.YXGJ.SHIFT_CONFIRM)
    Call<ShiftConfirmResponseEntity> getShiftConfirmList(@QueryMap Map<String, JSONArray> map);

    /**
     * 排班设置接口
     *
     * @param map ...
     * @return ...
     */
    @POST(ApiUrls.APP.POST_SHOW_SCHEDULE)
    Call<RequestResult<Boolean>> getShiftSettingFlag(@QueryMap Map<String, String> map);
}
