package com.urovo.activity.attendancemanagement.attendancemanager.pre

import android.content.Context
import com.urovo.activity.attendancemanagement.attendancemanager.ent.AttenHistoryRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.CommonController
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.CommonEntity
import com.urovo.wugumofang.ui.ViewUtil
import okhttp3.Request

/**
 * @author Sasuke on 2018/1/16.
 */
class AttenHistoryPre(val mView: CommonController.AttenHistoryView,var dataList: MutableList<AttenHistoryRes.ReturnBean>) : CommonController.AttenHisPre {
    lateinit var context: Context

    init {
        context = mView as Context
    }

    fun start() {
        mView.init()
    }

    /**
     * 网络请求考勤记录
     */
    fun queryWorkAttendance(beginTime: String, endTime: String, staffId: String) {
        ViewUtil.showProgress(context, "请稍等", "正在获取考勤记录")
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_WORK_ATTENDANCE,
                mapOf("beginTime" to beginTime,
                        "endTime" to endTime,
                        "staffId" to staffId),
                object : OkHttpDominator.ResultCallback<AttenHistoryRes>() {
                    override fun onError(request: Request?, e: Exception?) {
                        ViewUtil.dismissProgress()
                        mView.showMsg(e.toString())
                    }

                    override fun onResponse(res: AttenHistoryRes?) {
                        res?.returnBean?.let { dataList.apply { clear(); addAll(res.returnBean )} }
                        mView.notifyCalData( res?.returnBean?.flatMap { listOf(it.dataTime) } )
                    }
                }
        )
    }


    override fun onStart2requestData(params: MutableMap<Any?, Any?>?) {
    }

    override fun onResponseSuccess(resultInfo: CommonEntity<*>?) {
    }

    override fun onFailure(failInfo: String?) {
    }
}