package com.urovo.activity.attendancemanagement.attendancemanager.pre;

import com.urovo.activity.attendancemanagement.attendancemanager.ent.ShiftQueryEntity;
import com.urovo.activity.attendancemanagement.attendancemanager.net.AttendanceManagerNet;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.response.CommonEntity;

import java.util.Map;

/**
 * 排班查询pre
 *
 * @author chenji
 */
public class ShiftQueryAndConfirmPre implements CommonController.ShiftBasePre<ShiftQueryEntity.ResultBean> {
    private CommonController.ShiftBaseView<ShiftQueryEntity.ResultBean> mAttendanceManagerView;
    private AttendanceManagerNet mAttendanceManagerNet;

    public ShiftQueryAndConfirmPre(CommonController.ShiftBaseView<ShiftQueryEntity.ResultBean> attendanceManagerView) {
        this.mAttendanceManagerView = attendanceManagerView;
        this.mAttendanceManagerNet = new AttendanceManagerNet();
    }

    /**
     * 排班查询
     *
     * @param params ...
     */
    @Override
    public void onStart2requestData(Map<String, String> params) {
        mAttendanceManagerNet.start2ShiftQueryRequest(this, params);
    }

    /**
     * 排班确认
     *
     * @param params ...
     */
    public void onStart2ConfirmData(Map<String, String> params) {
        mAttendanceManagerNet.start2ShiftConfirmRequest(this, params);
    }

    @Override
    public void onResponseSuccess(CommonEntity<ShiftQueryEntity.ResultBean> resultInfo) {
        mAttendanceManagerView.onResponseSuccess(resultInfo);
    }

    @Override
    public void onConfirmResponseSuccess(String resultInfo) {
        mAttendanceManagerView.onConfirmResponseSuccess(resultInfo);
    }

    @Override
    public void onFailure(String failInfo) {
        mAttendanceManagerView.onFailure(failInfo);
    }
}
