package com.urovo.activity.attendancemanagement.signinandout.presenter

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.graphics.*
import android.os.Environment
import android.provider.MediaStore
import com.amap.api.location.AMapLocation
import com.urovo.activity.attendancemanagement.SignInAndOutActivity
import com.urovo.activity.attendancemanagement.signinandout.net.QueryFaceRes
import com.urovo.activity.qualityBackAct.model.QBackInput
import com.urovo.wgmf.AsyncTask.uploadcases.DismissProgressCase
import com.urovo.wgmf.AsyncTask.uploadcases.KaoqinUploadCase
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.BaseOldResponse
import com.urovo.wugumofang.response.BaseSimpleResponse
import com.urovo.wugumofang.system.BaseAppManager
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.BitmapUtil
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.utils.FuckGoogleAdaptUtil
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.utils.TaskEnqueueDominator
import com.urovo.wugumofang.utils.notNullAndEmpty
import com.zsy.libcore.common.android.log.SYLoger
import okhttp3.Request
import java.io.File
import java.io.FileNotFoundException
import java.io.FileOutputStream
import java.text.SimpleDateFormat
import java.util.*

/**
 * @author Sasuke on 2019-1-7.
 * 考勤签到签退
 */
class SignInAndOutPresenter(val mView: SignInAndOutContract.view) : SignInAndOutContract.presenter {
    var data: QBackInput = QBackInput()
    var savePhotoPath = ""
    var Position_Valid: String? = null

    @Volatile
    var isOfflineMode = false//是否离线模式
    var location: AMapLocation? = null

    @Volatile
    var isUploadCanceled = false//是否取消七牛上传图片
    var signType: String = "1"//”1“签到  ”2“签退
    var storeNo: String? = ""
        //门店号（这是之所以单独列出来存，是因为POS机的情况下会通过扫码来得到门店号，而不是让员工输什么就是什么。
        get() = if (field == null) "" else field
    var userId: String? = ""//工号
    var userName: String? = ""//员工姓名

    init {
        mView.setPresenter(this)
    }

    override fun start() {
        mView.init()
    }

    /**
     * 选择本地图片
     */
    fun localPick() {
        mView.startActivityForResult(Intent(Intent.ACTION_PICK, null).apply {
            setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, "image/*")
        }, QBackInput.PHOTO_REQUEST_GALLERY)
    }

    fun capture() {
        try {
            val cameraintent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
            val sdStatus = Environment.getExternalStorageState()
            if (sdStatus != Environment.MEDIA_MOUNTED) { // 检测sd是否可用
                //权限弹窗
                return
            }
            val file = File(Files.photoPath)
            if (!file.exists()) {
                file.mkdirs()// 创建文件夹
            }
            savePhotoPath = Files.getSignInAndOutPhotoCache("")[0].absolutePath +
                    "/_${userId}_${
                        DateUtil.formatDateByFormat(
                            Date(),
                            "yyyyMMddHHmmss"
                        )
                    }.jpg"// 图片路径
            val mUri = FuckGoogleAdaptUtil.android7AdaptUri(
                mView as Context,
                Files.fileProviderAuth,
                File(savePhotoPath)
            )
            cameraintent.putExtra(MediaStore.EXTRA_OUTPUT, mUri)
            cameraintent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
            mView.startActivityForResult(cameraintent, SignInAndOutActivity.REQUEST_TAKEPHOTO)
        } catch (e: java.lang.Exception) {
            mView.showMsg("调用相机拍照失败: " + e.toString())
            BaseAppManager.loger().info(e)
        }
    }

    /**
     * 查询地理信息是否正确
     */
    fun checkCanKaoQin(checkCallBack: (msg: String, isCoutinueSubmit: Boolean) -> Unit) {
        ViewUtil.showProgress(mView as Context, "请稍等", "正在验证地理位置...")
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.SIGN_IN_OR_OUT_LOCATION_CHECK,
            mapOf(
                "userId" to userId,
                "storeId" to storeNo,
                "requestType" to "1",
                "lng" to location?.longitude.toString(),
                "lat" to location?.latitude.toString(),
                "userType" to "2",
                "address" to location?.address,
                "type" to "1",
                "machine" to "1",
                "signTime" to ""
            ), object : OkHttpDominator.ResultCallback<BaseOldResponse>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    ViewUtil.dismissProgress()
                    MyToast.show("网络异常ERROR : SIGN_IN_OR_OUT_LOCATION_CHECK")
                    isOfflineMode = true
                    //请求超时，开始离线打卡
                    Position_Valid = ""
                    submitSignData(signType)
                    e?.printStackTrace()
                }

                override fun onResponse(res: BaseOldResponse?) {
                    ViewUtil.dismissProgress()
                    if (res == null) return
                    Position_Valid = res.msgCode
                    val msg = if (res.sysCode == "0") res.msgContent else res.sysContent
                    checkCallBack.invoke(msg, res.msgCode != "1001")//返回1001的情况下，不允许继续上传。
                }
            })
    }

    /**
     * 提交签到签退信息
     */
    fun submitSignData(signType: String) {
        if (storeNo.notNullAndEmpty() && userId.notNullAndEmpty()) {
            ViewUtil.showProgress(mView as SignInAndOutActivity, "正在上传考勤信息", "")
            val kaoqinCase = KaoqinUploadCase(
                mView as Activity,
                false,
                signType,
                storeNo!!,
                userId!!,
                data.photoList,
                location,
                isOfflineMode
            )
            TaskEnqueueDominator()
                .addPauseCase(kaoqinCase)
                .addPauseCase(kaoqinCase.createFromDbCase())
                .addCase(DismissProgressCase()).go()
        }
    }

    /**
     * 把压缩并加了水印的图片写入文件
     */
    fun compress2Local(mBitmap: Bitmap): String {
        val sdStatus = Environment.getExternalStorageState()
        // 检测sd是否可用
        if (sdStatus != Environment.MEDIA_MOUNTED) {
            return ""
        }
        var b: FileOutputStream? = null
        val file = File(Files.photoPath)
        if (!file.exists()) {
            // 创建文件夹
            val mkdirs = file.mkdirs()
            SYLoger.print("考勤：创建文件夹成功-->$mkdirs")
        }
        try {
            val photoFile = File(savePhotoPath)
            //缓存的图片可以删了
            val delete = photoFile.delete()
            SYLoger.print("考勤：缓存的图片删除了-->$delete")
            b = FileOutputStream(photoFile)
            //压缩到100KB以下
            val option = BitmapUtil.getCompressOption(mBitmap, 90)
            // 把数据写入文件
            mBitmap.compress(Bitmap.CompressFormat.JPEG, option, b)

        } catch (e: FileNotFoundException) {
            //
        } finally {
            try {
                // 关闭流
                if (null != b) {
                    b.flush()
                    b.close()
                }
            } catch (e: Exception) {
                BaseAppManager.loger().info(e)
            }

        }
        return savePhotoPath
    }

    /**
     * 添加日期水印
     */
    fun drawDate(bmp: Bitmap?): Bitmap? {
        if (bmp == null) return null
        var bmp = bmp
        val temp: Bitmap

        var newWidth = bmp.width.toFloat()
        var newHeight = bmp.height.toFloat()

        if (newWidth > 1080) {
            newHeight = newHeight / newWidth * 1080f
            newWidth = 1080f
        }

        if (newHeight > 1080) {
            newWidth = newWidth / newHeight * 1080f
            newHeight = 1080f
        }


        //189与252的倍数
        bmp = BitmapUtil.resizeTo(bmp, newWidth.toInt(), newHeight.toInt())
//        bmp.recycle()
        temp = Bitmap.createBitmap(bmp.width, bmp.height, Bitmap.Config.ARGB_8888)
        val canvas = Canvas(temp)
        // 建立画笔
        val paint = Paint()
        paint.isDither = true
        paint.isFilterBitmap = true
        val src = Rect(0, 0, bmp.width, bmp.height)
        val dst = Rect(0, 0, bmp.width, bmp.height)
        canvas.drawBitmap(bmp, src, dst, paint)

        val textPaint = Paint(Paint.ANTI_ALIAS_FLAG or Paint.DEV_KERN_TEXT_FLAG)
        textPaint.textSize = 60.0f
        // 采用默认的宽度
        textPaint.typeface = Typeface.DEFAULT_BOLD
        textPaint.color = Color.RED

        val now = Date()
        val sdf = SimpleDateFormat("yyyy/MM/dd-HH:mm:ss", Locale.CHINA)
        val str = sdf.format(now)
        val d = str.split("-".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()[0]
        val t = str.split("-".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()[1]
        val m = Rect()
        val c = Rect()
        textPaint.getTextBounds(d, 0, d.length - 1, m)
        textPaint.getTextBounds(t, 0, t.length - 1, c)
        canvas.drawText(
            d,
            (bmp.width - m.width() - 60).toFloat(),
            (bmp.height - 20).toFloat(),
            textPaint
        )
        canvas.drawText(
            t,
            (bmp.width - c.width() - 60).toFloat(),
            (bmp.height - 80).toFloat(),
            textPaint
        )
        canvas.save()
        canvas.restore()
        return temp
    }

    /**
     * 打卡弹窗执行 true：弹窗，false不弹
     */
    fun querySignFlag(staffId: String?, signType: String) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.SIGN_FLAG,
            mapOf("staffId" to staffId),
            object : OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {

                }

                override fun onResponse(res: BaseSimpleResponse?) {
                    res?.let {
                        if (!it.resultInfo.isNullOrEmpty()) {
                            mView.showSignFlagDialog(signType, it.resultInfo)
                        }
                    }
                }
            })
    }

    /**
     * 打卡确认当天促销的产品
     */
    fun querySignForSaleData(staffId: String?, signSale: String?) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.SIGN_FORSALE_DATA,
            mapOf("staffId" to staffId, "signSale" to signSale),
            object : OkHttpDominator.ResultCallback<QueryFaceRes>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {

                }

                override fun onResponse(res: QueryFaceRes?) {
                    res?.let {
                    }
                }
            })
    }
}