package com.urovo.activity.attendancemanagement.vacation;

import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.AbsenceEntity;
import com.urovo.wgmf.entity.response.QueryAbsenceResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import okhttp3.Request;

/**
 * Created by Sasuke on 2016/4/13.
 * 请假查询
 */
public class QueryAbsenceAct extends BaseActivity {
    ListView lv;
    MyAdapter listAdapter;
    List<AbsenceEntity> entities = new ArrayList<>();

    public static final int INTENT_QINGJIA = 0;//intent 请假

    public static final int INTENT_TIAOXIU = 1;//intent 调休

    int queryType = INTENT_QINGJIA;//默认请假

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ll_query_absence);
        initTitle();
        getView();
        init();
    }

    private void getView() {
        lv = (ListView) findViewById(R.id.lv_query_absence);
        listAdapter = new MyAdapter();
        lv.setAdapter(listAdapter);
    }

    private void init() {
        queryType = getIntent().getIntExtra("type",INTENT_QINGJIA);
        titleTextView.setText(queryType == INTENT_QINGJIA? "请假查询" : "调休查询");
        queryData();
    }

    private void queryData() {
        ViewUtil.showProgress(this,"请稍等","正在查询"+(queryType == INTENT_QINGJIA? "请假" : "调休") + "信息...");
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        HashMap<String, String> params = new HashMap();
//        params.put("endDate", format.format(DateUtil.getLastDayOfMonth(0)));
//        params.put("consultantId", SystemHelper.LoginUserId);
//        params.put("startDate", format.format(DateUtil.getFirstDayOfMonth(-1)));

//        new BaseDataServiceTask("query", QueryAbsenceResponse.class, this, "正在查询请假信息...",
//                true, "/userinformation/queryForLeave", params).execute("");
        params.put("staffId", SystemHelper.LoginUserId);
        params.put("startDate",format.format(DateUtil.getFirstDayOfMonth(-1)));
        params.put("endDate", format.format(DateUtil.getLastDayOfMonth(0)));
        if (queryType == INTENT_QINGJIA){
            params.put("ridType","1");
        }else if (queryType == INTENT_TIAOXIU){
            params.put("leaveType","8");
        }
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.QUERY_ABESNCE,
                params, new OkHttpDominator.ResultCallback<QueryAbsenceResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                    }

                    @Override
                    public void onResponse(QueryAbsenceResponse res) {
                        ViewUtil.dismissProgress();
                        if (isFinishing()) return;
                        if (null != res && res.msgCode == 0) {
                            entities = res.getResultInfo();
                            if (entities == null || entities.size() == 0) {
                                showMsg("近两个月无请假记录");
                                return;
                            }
                        }
                        listAdapter.notifyDataSetInvalidated();
                    }
                });


    }

    class ViewHolder {
        TextView shenheState;//审核状态
        LinearLayout failedReasonLayout;//审核不通过的原因布局
        TextView failedReason;//审核不通过的原因显示
        TextView userName;//申请人
        TextView qingjiaType;//请假类型
        TextView startTime;//起始时间
        TextView endTime;//结束时间
        TextView daysAmount;//请假天数
        TextView qingjiaReason;//请假原因
        TextView numTitle;//请假/调休天数 标题
    }

    class MyAdapter extends BaseAdapter {
        @Override
        public int getCount() {
            return entities.size();
        }

        @Override
        public Object getItem(int position) {
            return position;
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ViewHolder holder = new ViewHolder();
            if (convertView == null) {
                convertView = (LinearLayout) View.inflate(QueryAbsenceAct.this, R.layout.lv_item_query_absence, null);
                holder.failedReasonLayout = (LinearLayout) convertView.findViewById(R.id.failedReasonLayout);
                holder.failedReason = (TextView) convertView.findViewById(R.id.failedReason);
                holder.shenheState = (TextView) convertView.findViewById(R.id.shenhe_state);
                holder.userName = (TextView) convertView.findViewById(R.id.user_name);
                holder.qingjiaType = (TextView) convertView.findViewById(R.id.qingjia_type);
                holder.startTime = (TextView) convertView.findViewById(R.id.start_time);
                holder.endTime = (TextView) convertView.findViewById(R.id.end_time);
                holder.daysAmount = (TextView) convertView.findViewById(R.id.days_amount);
                holder.qingjiaReason = (TextView) convertView.findViewById(R.id.qingjia_reason);
                holder.numTitle = (TextView) convertView.findViewById(R.id.numTitle);
                convertView.setTag(holder);
            } else {
                holder = (ViewHolder) convertView.getTag();
            }

            AbsenceEntity entity = entities.get(position);
            //审核结果 0待审核  1已通过审核 2未通过审核
//            switch (entity.auditResult) {
//                case 0:
//                    holder.shenheState.setText("待上级审批");
//                    break;
//                case 1:
//                    holder.shenheState.setText("已通过");
//                    break;
//                case 2:
//                    holder.shenheState.setText("不通过");
//                    break;
//            }
            holder.shenheState.setText(entity.remark);
            holder.failedReasonLayout.setVisibility(entity.auditResult == 2? View.VISIBLE : View.GONE);
            holder.failedReason.setText(entity.getAuditDetail());

            //员工姓名
            holder.userName.setText(entity.staffName);
            //请假类型，1病假 2年假 3事假  4婚假 5产假 6丧假 7护理假 8调休 9哺乳假

            switch (entity.leaveType) {
                case "1":
                    holder.qingjiaType.setText("病假");
                    break;
                case "2":
                    holder.qingjiaType.setText("年假");
                    break;
                case "3":
                    holder.qingjiaType.setText("事假");
                    break;
                case "4":
                    holder.qingjiaType.setText("婚假");
                    break;
                case "5":
                    holder.qingjiaType.setText("产假");
                    break;
                case "6":
                    holder.qingjiaType.setText("丧假");
                    break;
                case "7":
                    holder.qingjiaType.setText("护理假");
                    break;
                case "8":
                    holder.qingjiaType.setText("调休");
                    break;
                case "9":
                    holder.qingjiaType.setText("哺乳假");
                    break;
                case "31":
                    holder.qingjiaType.setText("休假");
                    break;
            }
            //请假开始、结束时间
            holder.startTime.setText(entity.startTime);
            holder.endTime.setText(entity.endTime);
            //请假天数
            holder.daysAmount.setText(entity.leaveDateNum + (queryType == INTENT_QINGJIA? "天" : "小时"));
            holder.numTitle.setText(queryType == INTENT_QINGJIA? "请假天数：" : "调休时长：");
            holder.qingjiaReason.setText(entity.leaveReason);
            return convertView;
        }
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
//        if (tag.equals("query")) {
//            if (null != response && response.getRet().equals("0")) {
//                entities = ((QueryAbsenceResponse) response).getData();
//                if (entities == null || entities.size() == 0) {
//                    showMsg("近两个月无请假记录");
//                    return;
//                }
//                Collections.sort(entities, new Comparator<AbsenceEntity>() {//按开始时间排序，时间大的（最新的）排在前面
//                    @Override
//                    public int compare(AbsenceEntity lhs, AbsenceEntity rhs) {
//                        long lhsTime = DateUtil.String2Date(lhs.startTime, "yyyy-MM-dd").getTime();
//                        long rhsTime = DateUtil.String2Date(rhs.startTime, "yyyy-MM-dd").getTime();
//
//                        return (int) (rhsTime - lhsTime);
//                    }
//                });
//            }
//            listAdapter.notifyDataSetInvalidated();
//        }


    }
}
