package com.urovo.activity.attendancemanagement.vacation;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.user.AnnualVacationAct;
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.ToActivity;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 请假
 * （该功能是由后台接口控制显示加载，勿删！）
 *
 * @author chenji
 */
public class VacationAct extends BaseActivity {
    private String[] mFunctionName = {"请假申请", "请假查询", "年假查询","调休申请","调休查询"};
    /**
     * 请假列表item的权限
     */
    private String[] mFunctionPrivilege = {
            AppConstants.More.NATIVE_ASK_ABSENCE_ACT,
            AppConstants.More.NATIVE_QUERY_ABSENCE_ACT,
            AppConstants.More.NATIVE_ANNUAL_VACATION_ACT,
            AppConstants.More.NATIVE_ASK_ABSENCE_ACT2,
            AppConstants.More.NATIVE_QUERY_ABSENCE_ACT2,
    };
    private Unbinder mBind;
    @BindView(R.id.listview)
    ListView mListView;
    @BindView(R.id.empty_view_container)
    View mEmptyView;
    /**
     * 存储有权限的列表item
     */
    private List<String> mFunctionList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.staff_menu);
        mBind = ButterKnife.bind(this);
        initTitle();
        init();
    }

    private void init() {
        titleTextView.setText("请假调休");

        mFunctionList.clear();
        for (int i = 0; i < mFunctionName.length; i++) {
            if (PrivilegeDbOperate.checkUserPrivilege(mFunctionPrivilege[i])) {
                mFunctionList.add(mFunctionName[i]);
            }
        }

        if (mFunctionList.size() == 0) {
            mEmptyView.setVisibility(View.VISIBLE);
            ((TextView) mEmptyView.findViewById(R.id.empty_view)).setText("暂无权限！");
        } else {
            mEmptyView.setVisibility(View.GONE);
        }

        mListView.setAdapter(new MyAdapter());
        mListView.setOnItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                String itemName = ((TextView)view.findViewById(R.id.ItemText)).getText().toString();
                click(itemName);
            }
        });
    }

    public void click(String itemName) {
        if (itemName.equals(mFunctionName[0])){//请假申请
            ToActivity.toActivity(this, AskAbsenceAct.class,"type",AskAbsenceAct.INTENT_QINGJIA);

        }else if (itemName.equals(mFunctionName[1])){//请假查询
            ToActivity.toActivity(this, QueryAbsenceAct.class,"type",QueryAbsenceAct.INTENT_QINGJIA);

        }else if (itemName.equals(mFunctionName[2])){//年假查询
            ToActivity.toActivity(this, AnnualVacationAct.class);

        }else if (itemName.equals(mFunctionName[3])){//调休申请
            ToActivity.toActivity(this, AskAbsenceAct.class,"type",AskAbsenceAct.INTENT_TIAOXIU);

        }else if (itemName.equals(mFunctionName[4])){//调休查询
            ToActivity.toActivity(this, QueryAbsenceAct.class,"type",QueryAbsenceAct.INTENT_TIAOXIU);
        }

//        switch (itemName) {
//            //请假申请
//            case mFunctionName[0]:
//                break;
//            //请假查询
//            case 1:
//                break;
//            //年假查询
//            case 2:
//                break;
//            //调休申请
//            case 3:
//                break;
//             //调休查询
//            case 4:
//                break;
//            default:
//                break;
//        }
    }


    class MyAdapter extends BaseAdapter {
        @Override
        public int getCount() {
            return mFunctionList.size();
        }

        @Override
        public Object getItem(int position) {
            return position;
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ViewHolder viewHolder;
            if (convertView == null) {
                viewHolder = new ViewHolder();
                //加载布局
                convertView = LayoutInflater.from(VacationAct.this).inflate(R.layout.second_menu_item, parent, false);
//                viewHolder.text = (TextView) convertView.findViewById(R.id.ItemText);
                viewHolder.text = convertView.findViewById(R.id.ItemText);
                viewHolder.dividerView = convertView.findViewById(R.id.dividerView);
//                if ("".equals(mFunctionName[position])) {
//                    //填充灰色间隔
//                    convertView = View.inflate(AttendanceManagerMenu.this, R.layout.listview_item_data2, null);
//                    convertView.setClickable(false);
//                    return convertView;
//                }
                convertView.setTag(viewHolder);
            } else {
                viewHolder = (ViewHolder) convertView.getTag();
            }
            viewHolder.text.setText(mFunctionList.get(position));
            viewHolder.dividerView.setVisibility((position == 3 || position == 0) ? View.VISIBLE : View.GONE);

            return convertView;
        }
    }

    static class ViewHolder {
        TextView text;
        View dividerView;
    }

    @Override
    protected void onDestroy() {
        if (mBind != null) {
            mBind.unbind();
        }
        super.onDestroy();
    }
}
