package com.urovo.activity.betasuggestion.pre

import com.urovo.activity.betasuggestion.model.BetaSuggesData
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.BaseSimpleResponse
import okhttp3.Request

/**
 * Created by Sasuke on 2017/7/23.
 */
class BetaSuggesPre(view: BetaSuggestionCon.view) : BetaSuggestionCon.pre {
    //    val betaSuggesNet: BetaSuggesNet
    val data: BetaSuggesData = BetaSuggesData()

    var mView: BetaSuggestionCon.view

    init {
//        betaSuggesNet = RetrofitHelper.createApi(BetaSuggesNet::class.java)
        this.mView = view
        this.mView.setPresenter(this)
    }

    override fun start() {
        mView.init()
    }

    /**
     * 上传照片
     */
    fun uploadPhotos() {
        val paths = mView.packPhotoPaths()
        if (paths.isEmpty()) {
            uploadSuggestion(listOf())
            return
        }
        mView.showProgressBar("正在上传图片")
        QiNiuDominator.uploadImages(paths,
                QiNiuDominator.CompleteQiniu { qiniuUrl -> uploadSuggestion(qiniuUrl) },
                QiNiuDominator.FailureQiniu { str ->
                    mView.dismissProgressBar()
                    mView.showMsg(str)
                }, false)
    }

    /**
     * 上传反馈内容
     */
    fun uploadSuggestion(urls: List<String>?) {
        val param = mView.packSuggestions(urls)
        mView.showProgressBar("正在上传意见反馈")
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPMANAGE.BETA_FEED_BACK,
                param, object : OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
            override fun onResponse(res: BaseSimpleResponse?) {
                mView.dismissProgressBar()
                if(res != null) {
                    if (res.msgCode != 0) {
                        mView.showMsg(res.msgInfo)
                        return
                    } else when (param.get("switching")) {
                        "0" -> {//请求成功，但没有要求关闭白名单，就只退出当前界面就行。
                            mView.showMsg(res.msgInfo)
                            mView.finish()
                        }
                        "-1" -> {//如果请求成功，并且要求关闭白名单，就下载
                            mView.downloadApp(res.resultInfo)
                        }
                    }
                }else{
                    mView.showMsg("网络异常，上传失败")
                }
            }

            override fun onError(request: Request?, e: Exception?) {
                mView.dismissProgressBar()
                mView.showMsg("网络异常，上传失败")
            }
        })


//        betaSuggesNet.uploadSuggestion(data.userNo, data.appOs, data.switching, data.bugLevel, data.feedback, data.photoUrl).enqueue(object : Callback<BaseSimpleResponse> {
//            override fun onResponse(p0: Call<BaseSimpleResponse>?, p1: Response<BaseSimpleResponse>) {
//                mView.dismissProgressBar()
//                if (p1.isSuccessful && p1 != null) {
//                    var res = p1.body()
//                    if (res.msgCode != 0) {
//                        mView.showMsg(res.msgInfo)
//                        return
//                    } else when (data.switching) {
//                        "0" -> {//请求成功，但没有要求关闭白名单，就只退出当前界面就行。
//                            mView.showMsg(res.msgInfo)
//                            mView.finish()
//                        }
//                        "-1" -> {//如果请求成功，并且要求关闭白名单，就下载
//                            mView.downloadApp(res.resultInfo)
//                        }
//                    }
//                } else {
//                    mView.showMsg("网络异常，上传失败")
//                }
//            }
//
//            override fun onFailure(p0: Call<BaseSimpleResponse>?, p1: Throwable?) {
//                mView.dismissProgressBar()
//                mView.showMsg("网络异常，上传失败")
//            }
//        })
    }

}