package com.urovo.activity.careertraining.net

import com.urovo.wugumofang.response.Base3Response

/**
 * createTrainStaffId (string, optional):创建培训记录人工号 ,
createTrainStaffName (string, optional):创建培训记录人姓名 ,
ids (integer, optional),
itemContent (string, optional):导师评价内容 ,
itemEvaluatedTime (string, optional):评估时间 ,
managerEvaluation (string, optional):主管评价 ,
managerStaffId (string, optional):主管工号 ,
mentroEvaluationFlag (string, optional):导师评估标识：1已评估，0未评估 ,
officeEvaluatedTime (string, optional):经理评价时间 ,
officeEvaluation (string, optional):经理评价 ,
officeStaffId (string, optional):经理工号 ,
trainMentorStaffId (string, optional):培训导师工号 ,
trainMentorStaffName (string, optional):培训导师姓名 ,
trainSubmitFlag (string, optional):提交标识：0暂存，1保存 ,
userWeekList (Array[WorkerTrainUserWeek], optional):周 ,
workerEntryTime (string, optional):入职时间 ,
workerStaffId (string, optional):顾问工号 ,
workerStaffName (string, optional):顾问姓名 ,
workerTrainSubmitTime (string, optional):提交时间 ,
workerTrainUpdateTime (string, optional):修改时间
 */
data class TrainingPlanRes(var result: ResultInfo): Base3Response() {
    data class ResultInfo(var workerStaffId: String,//工号
                          var workerStaffName: String,//姓名
                          var workerEntryTime: String,//入职日期
                          var userWeekList: List<WeekPlans>) {//周计划
        data class WeekPlans(var trainWeekName: String,//周
                             var itemTrainShopId: String,//培训门店shopid
                             var itemTrainShopName: String,//培训门店名称
                             var titleTime: String,//培训主题时间
                             var trainItemTime: String,//项目培训时间
                             var trainMentorStaffId: String,//培训导师工号
                             var trainMentorStaffName : String,//培训导师姓名
                             var trainItemName: String,//项目名称
                             var trainItemContent: String,
                             var contentTitle: String,//标题
                             var content: String,//内容
                             var weekItemList: List<Plans>,//计划内容
                             var workerTrainContentM: PlanDetails
    ) {//计划详情
            data class Plans(var id: String,// id,提交评估时需要 ,
                             var trainItemTime: String,//项目时间
                             var trainItemName: String,//项目名称
                             var trainItemContent: String)//项目内容

            data class PlanDetails(var contentTitle: String,//标题
                                   var content: String)//内容
        }
    }
}