package com.urovo.activity.careertraining.ui

import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.careertraining.net.CareerEntryListRes
import com.urovo.activity.careertraining.view.CareerEvaluateAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.utils.MyToast
import org.jetbrains.anko.find

class CareerEntryListAdapter(val context: Context, val dataList: List<CareerEntryListRes.ResultInfo>) : RecyclerView.Adapter<CareerEntryListAdapter.CareerHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): CareerHolder {
        return CareerHolder(LayoutInflater.from(context).inflate(
                R.layout.career_evaluate_list_item,
                parent,
                false))
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: CareerHolder, position: Int) {
        holder.nameTv.text = dataList[position].staffName
        if (dataList[position].mentroEvaluationFlag.equals("0")) {
            holder.isEvaluateTv.text = "待评估"
            holder.isEvaluateTv.setTextColor(Color.parseColor("#ffb919"))
        } else {
            holder.isEvaluateTv.text = "已评估"
            holder.isEvaluateTv.setTextColor(Color.parseColor("#b2b2b2"))
        }
        holder.rootLayout.setOnClickListener {
            if (dataList[position].staffId.isNullOrBlank()){
                MyToast.show("工号为空")
                return@setOnClickListener
            }
            context.startActivity(Intent(context, CareerEvaluateAct::class.java).apply {
                putExtra("staffId",dataList[position].staffId)
                putExtra("staffName",dataList[position].staffName)
                putExtra("mentroEvaluationFlag",dataList[position].mentroEvaluationFlag)
            })
        }
    }

    class CareerHolder(view: View) : RecyclerView.ViewHolder(view) {
        var nameTv = view.find<TextView>(R.id.nameTv)
        var isEvaluateTv = view.find<TextView>(R.id.isEvaluatedTv)
        var rootLayout = view.find<LinearLayout>(R.id.careerRootLayout)
    }
}