package com.urovo.activity.careertraining.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.careertraining.net.TrainingPlanRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.CareerTrainingRvItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

class CareerTrainingAdapter(val context: Context,
                            val dataList: List<TrainingPlanRes.ResultInfo.WeekPlans>,
                            val submitCallback: (()->Unit)?) : RecyclerView.Adapter<ViewHolderX>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<CareerTrainingRvItemBinding>(
                LayoutInflater.from(context),
                R.layout.career_training_rv_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        val binding = DataBindingUtil.getBinding<CareerTrainingRvItemBinding>(holder.view)
        var dataItem = dataList[pos]
        binding?.run {
            evaluateItem = dataItem
        }
    }
}