package com.urovo.activity.checkGoodsTabAct.view

import android.graphics.drawable.BitmapDrawable
import android.os.Handler
import android.view.View
import android.view.WindowManager
import android.widget.*
import com.urovo.activity.checkGoodsTabAct.model.QueryCheckEntity
import com.urovo.activity.checkGoodsTabAct.presenter.CheckGoodsQueryContract
import com.urovo.activity.checkGoodsTabAct.presenter.CheckGoodsQueryPresenter
import com.urovo.activity.common.DatePickerYearMonthDialog
import com.urovo.activity.checkGoodsTabAct.view.adapter.CheckQueryListAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DialogHelper
import kotlinx.android.synthetic.main.check_goods_query_act.*
import org.jetbrains.anko.find
import java.text.MessageFormat
import java.util.*

/**
 * @author LW on 2022/8/18.
 * 盘点查询
 */
class CheckGoodsQueryActivity : BaseActivity(), CheckGoodsQueryContract.IView {

    override fun addRootLayoutId(): Int = R.layout.check_goods_query_act

    private var mCheckGoodsQueryPresenter: CheckGoodsQueryPresenter? = null

    private var mYear: Int = 0

    private var mMonth: Int = 0

    private var mIsFirst = true//第一次初始化界面

    override fun initTitle() {
        super.initTitle()
        titleTextView.text = getString(R.string.check_goods_qeury_title)
    }

    override fun initViewNew() {
        initTitle()

        listview_quire_resault2.viewTreeObserver.addOnGlobalLayoutListener {
            if (mIsFirst) {
                showPopWindow()
            }
            mIsFirst = false
        }
        result_tv.setOnClickListener { showPopWindow() }
    }

    override fun addPresenter(): BasePresenter {
        mCheckGoodsQueryPresenter = CheckGoodsQueryPresenter(this)
        return mCheckGoodsQueryPresenter!!
    }

    override fun refreshTransferCheckToView(response: List<QueryCheckEntity>) {
        if (isFinishing) return
        //产品编码过滤
        val filterCode = mPopupWindow.contentView.find<TextView>(R.id.order_num).text.toString()
        response.let { result ->//如果filterCode为空，那就不需要过滤了，所以用 或
            result.forEach {
                it.detailList =
                    it.detailList.filter { filterCode.isEmpty() || filterCode == it.proCode }
            }
//            result.detailList?.filter { filterCode.isNullOrEmpty() || filterCode == it.proCode }?.forEach {
//                it.pdAmount = if (!DalCommon.CanEditAmount(it.getProCode())) Arith.mul(it.getProPrice(), it.getPdQty()) else it.proPrice
//                showList.add(QueryEntity().apply {
//                    ItemId = it.proCode
//                    ItemName = it.proName
//                    KCUom = it.proUnit
//                    TQTY = MoneyUtils.dynamicLastDF(it.pdQty)
//                    Price = MoneyUtils.dynamicLastDF(it.proPrice)
//                    Amount = MoneyUtils.dynamicLastDF(it.pdAmount)
//                    PDDate = result.pdDate
//                    WDate = result.getCreateDate()
//                    Bill = result.getPdBillCode()
//                    Lr_Name = result.getPdUserName()
//                    Amount_Total_Diff = result.getDiffAmount().toString()
//                    KouFen = result.getPdKouFen().toString()
//                    currQty = it.getStockQty().toString()
//                    saleAmount = result.saleAmount
//                })
//            }
        }
//        showList.sortBy { it.ItemId }
        mCheckGoodsQueryPresenter?.hasQuery = true//做个标记，表示已经查询过了。
        result_tv.text = MessageFormat.format("{0},{1}年{2}月", SystemHelper.LoginOrganName, mYear, mMonth)
        if (response.flatMap { it.detailList }.isEmpty()/*showList.size == 0*/) {
            showDataType(1)
        } else {
            showDataType(0)
        }
        val panDianQueryAdapter = CheckQueryListAdapter(response, this@CheckGoodsQueryActivity)
        listview_quire_resault2.setAdapter(panDianQueryAdapter)
        listview_quire_resault2.setGroupIndicator(null)
        Handler().postDelayed({
            head_alert_tv.visibility = View.VISIBLE//显示置顶的说明文字
        }, 500)//延迟弹动画吧，更能引起用户的注意。
    }

    /**
     * 搜索弹窗
     */
    private val mPopupWindow by lazy {
        val view = layoutInflater.inflate(R.layout.checkgoods_quire, null)
        val showColor = view.find<View>(R.id.out_view)
        val orderdatefrom = view.find<TextView>(R.id.order_date_from)
        val orderNumPickLayout = view.find<LinearLayout>(R.id.orderNumPickLayout)
        val orderNum = view.find<TextView>(R.id.order_num)
        val now = Date()
        mYear = now.year + 1900
        mMonth = now.month
        if (0 == mMonth) {
            mMonth = 12
            mYear--
        }

        orderdatefrom.text = String.format(Locale.CHINA, "%d年%d月", mYear, mMonth)
        (view.find<TextView>(R.id.ordergoods_quire)).apply {
            text = MessageFormat.format("查询门店:{0}", SystemHelper.LoginOrganName)
        }
        val pw = PopupWindow(
            view,
            WindowManager.LayoutParams.MATCH_PARENT,
            WindowManager.LayoutParams.WRAP_CONTENT,
            true
        ).apply {
            isFocusable = false
            setBackgroundDrawable(BitmapDrawable())
            isOutsideTouchable = false
        }
        //查询按钮 点击监听
        pw.contentView.find<Button>(R.id.checkgoodsQueryBtn).setOnClickListener {
            mCheckGoodsQueryPresenter?.requestTransferCheck(mYear, mMonth)
        }
        //过滤日期 点击监听
        orderdatefrom.setOnClickListener {
            DatePickerYearMonthDialog(
                this
            ) { year, monthOfYear ->
                mYear = year
                mMonth = monthOfYear + 1
                orderdatefrom.text = String.format(Locale.CHINA, "%d年%d月", mYear, mMonth)
            }.show()
        }
        //过滤产品id 点击监听
        orderNumPickLayout.setOnClickListener {
            val editView = layoutInflater.inflate(R.layout.edittext_diy, null)
            val editText = editView.findViewById(R.id.edit) as EditText
            DialogHelper.Alert2(this, "请输入产品编号", null, editView) { dialog, which ->
                orderNum.text = editText.text.toString()
            }
        }

        showColor.setOnClickListener {
            if (mCheckGoodsQueryPresenter?.hasQuery != true) {
                return@setOnClickListener
            }
            if (pw.isShowing) {
                pw.dismiss()
            }
        }
        pw
    }

    override fun showDataType(type: Int) {
        if (mPopupWindow.isShowing) {
            mPopupWindow.dismiss()
        }
        when (type) {
            0 -> {
                no_data_text.visibility = View.INVISIBLE
                netErrorLayout.visibility = View.INVISIBLE
            }
            1 -> {
                no_data_text.visibility = View.VISIBLE
                netErrorLayout.visibility = View.INVISIBLE
            }
            2 -> {
                netErrorLayout.visibility = View.VISIBLE
            }
        }
    }

    /**
     * 弹出弹窗
     */
    override fun showPopWindow() {
        if (mCheckGoodsQueryPresenter?.hasQuery == true) {
            mPopupWindow.contentView.find<View>(R.id.out_view)
                .setBackgroundColor(getResources().getColor(R.color.result_view))
        }
        mPopupWindow.showAsDropDown(back)
    }

    override fun showTitleText(title: String) {
        result_tv.text = title
    }

}