    package com.urovo.activity.checkGoodsTabAct.view

import android.app.AlertDialog
import android.content.DialogInterface
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.checkGoodsTabAct.presenter.CheckGoodsSubmitContract
import com.urovo.activity.checkGoodsTabAct.presenter.CheckGoodsSubmitPresenter
import com.urovo.activity.checkGoodsTabAct.view.adapter.CheckSubmitAdapter2
import com.urovo.wgmf.adapter.PanDianDiffAdapter
import com.urovo.wgmf.db.dao.entitys.CanCheckRes3
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wgmf.view.PublicTipDialog
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.data.StringUtils
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DensityUtil
import com.urovo.wugumofang.ui.PhotoPickDominator
import com.urovo.wugumofang.ui.SpacesItemDecoration
import kotlinx.android.synthetic.main.check_goods_submit_act.*
import org.jetbrains.anko.find
import java.text.MessageFormat
import java.util.*

/**
 * @author LW on 2022-08-18
 * 盘点提交
 */
class CheckGoodsSubmitActivity : BaseActivity(), CheckGoodsSubmitContract.IView {

    override fun addRootLayoutId(): Int = R.layout.check_goods_submit_act

    private var mCheckGoodsSubmitPresenter: CheckGoodsSubmitPresenter? = null

    private var mCheckGoodsAdapter: CheckSubmitAdapter2? = null

    private var mPhotoPick: PhotoPickDominator? = null

    private var mType = 0//0:无需上传盘点表，1：需上传盘点表

    //以下是弹窗编辑器的各组件
    //private var mTvGoodsName: TextView? = null
    //private var mTvGoodsDhPack: TextView? = null
    //private var mEtPdcount: EditTextDecimal? = null
    //private var mTvNext: TextView? = null
    //private var mTvCancel: TextView? = null

    //private var mIsPopShow = false

    companion object {
        const val INTENT_RESULTLIST = "INTENT_RESULTLIST"

        /**照片的最大数量*/
        private const val PHOTO_MAX_NUM = 5
    }

    override fun initViewNew() {
        initTitle()
        titleTextView.text = getString(R.string.check_goods_submit_title)

        mCheckGoodsSubmitPresenter?.mResultInfo =
            intent.getSerializableExtra(INTENT_RESULTLIST) as CanCheckRes3.ResultInfo

        find<TextView>(R.id.ordergoods_quire).text =
            MessageFormat.format("盘点门店:{0}", SystemHelper.LoginOrganName)


        find<TextView>(R.id.table_title).run { text = "提交盘点表"; }
        find<ImageButton>(R.id.table_back).setOnClickListener {
            list_content.visibility = View.VISIBLE
            ll_table.visibility = View.GONE
        }
        find<ImageButton>(R.id.cameraAdd).setOnClickListener {
            showCamera()
        }
        find<RadioButton>(R.id.otherCheck).setOnCheckedChangeListener { btn, isChecked ->
            if (isChecked) {
                otherCheckEt.isEnabled = true
                otherCheckEt.isFocusable = true
                otherCheckEt.isClickable = true
                otherCheckEt.visibility = View.VISIBLE
            } else {
                otherCheckEt.isEnabled = false
                otherCheckEt.isFocusable = false
                otherCheckEt.isClickable = false
                otherCheckEt.visibility = View.GONE
            }
        }
        if (otherCheck.isChecked) {
            otherCheckEt.isEnabled = true
            otherCheckEt.isFocusable = true
            otherCheckEt.isClickable = true
            otherCheckEt.visibility = View.VISIBLE
        }
        //弹窗组件初始化
        //mTvGoodsName = find(R.id.goods_name)
        //mTvGoodsDhPack = find(R.id.goods_dhpack)
        //mEtPdcount = find(R.id.edit_pdcount)
        //mTvNext = find(R.id.tv_next)
        //mTvCancel = find(R.id.tv_cancel)

        botton_layout.visibility = View.GONE//底栏
        //提交监听
        find<Button>(R.id.submit).setOnClickListener {
            mCheckGoodsSubmitPresenter?.checkListCorrectAndSubmit()
        }
        find<Button>(R.id.submitBtn).setOnClickListener {
            showTipDialog("正在提交盘点数据...")
            if (mType == 0) {
                if (newCheck.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = "新店"
                } else if (delCheck.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = "撤店"
                } else if (pauseCheck.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = "暂停营业"
                } else if (otherCheck.isChecked) {
                    mCheckGoodsSubmitPresenter?.mRemarkText = otherCheckEt.text.toString()
                } else {
                    mCheckGoodsSubmitPresenter?.mRemarkText = ""
                }
                mCheckGoodsSubmitPresenter?.saveAndSubmit()
            } else {
                //盘点图片增加最少需上传2张的限制
                val mySize = mCheckGoodsSubmitPresenter?.mBackInput?.photoList?.size ?: 0
                if (mySize < 2) {
                    dismissDialog()
                    showToast("请至少上传2张盘点表图片！")
                } else {
                    QiNiuDominator.uploadImages(
                        mCheckGoodsSubmitPresenter?.mBackInput?.photoList,
                        { qiniuUrl ->
                            //照片七牛url组装
                            var packUrls = ""
                            qiniuUrl.forEach { packUrls += "${it}," }
                            if (packUrls.isNotEmpty()) packUrls =
                                packUrls.substring(0, packUrls.length - 1)
                            mCheckGoodsSubmitPresenter?.mUrlImage = packUrls
                            mCheckGoodsSubmitPresenter?.saveAndSubmit()
                        },
                        { str ->
                            showToast(str)
                        }, false
                    )
                }

            }
        }

        refreshRecyclerView()
        refreshDataToView(mCheckGoodsSubmitPresenter?.mResultInfo)

        if (mCheckGoodsSubmitPresenter?.includeSpecialProduct() == true) {
            showSpecialProductTipDialog()
        }
    }

    override fun addPresenter(): BasePresenter {
        mCheckGoodsSubmitPresenter = CheckGoodsSubmitPresenter(this)
        return mCheckGoodsSubmitPresenter!!
    }

    fun showSpecialProductTipDialog() {
        val builder = PublicTipDialog.Companion.Builder(mContext)
        builder.setMessage(R.string.check_goods_special_product_code_tip)
        builder.setTitle(R.string.hint)
        builder.setNegativeButton(listener = DialogInterface.OnClickListener { dialog, which -> dialog.dismiss() })
        if (!this.isFinishing) {
            builder.create().show()
        }
    }

    override fun showAlertDialog(zeroCount: Boolean, info: String, save2DB: () -> Boolean) {
        val builder = AlertDialog.Builder(this)
        builder.setTitle("重要提示").setMessage(info).setNegativeButton("确定") { dialog, which ->
            if (SystemHelper.LoginOrganName.contains("办事处")) {//当门店名称含有“办事处”字样时，无需提交盘点表，也不用说明原因，直接提交盘点数据
                if (save2DB.invoke()) {//组装数据&&保存到数据库成功，那就网络提交
                    showTipDialog("正在提交盘点数据...")
                    mCheckGoodsSubmitPresenter?.submit()
                }
            } else {
                list_content.visibility = View.GONE
                ll_table.visibility = View.VISIBLE
                if (zeroCount) {//当门店的盘点库存录入的产品数量全部为“0”，无需提交盘点表图片，但需说明原因
                    // 备注
                    reasonLl.visibility = View.VISIBLE
                    photoGroupHs.visibility = View.GONE
                    mType = 0
                } else {
                    // 图片
                    reasonLl.visibility = View.GONE
                    photoGroupHs.visibility = View.VISIBLE
                    mType = 1
                }
            }
        }.setPositiveButton("取消", null).create().show()
    }

    override fun savePanDianDataToDbAndSubmit(callback: () -> Boolean) {
        if (callback.invoke()) {//组装数据&&保存到数据库成功，那就网络提交
            showTipDialog("正在提交盘点数据...")
            mCheckGoodsSubmitPresenter?.submit()
        }
    }

    /**
     * 复位界面
     */
    override fun resetDataToView() {
        if (isFinishing) return
        botton_layout.visibility = View.GONE

        total_count.text = StringUtils.formatDouble(0.0, "0.00")
        total_price.text = StringUtils.formatDouble(0.0, "0.00")
    }

    /**
     * 弹出盘点差异弹窗
     */
    override fun showPanDianDiffDialog(diffList: List<PanDianDiffAdapter.Diff>) {
        val diffAdapter = PanDianDiffAdapter(this, diffList)
        val view = LayoutInflater.from(this).inflate(R.layout.list_pandian_diff, null)
        (view.findViewById(R.id.diff_all_num) as TextView).text =
            MessageFormat.format("{0}", mCheckGoodsSubmitPresenter?.mAllDiffNum)//显示差异总数量的绝对值之和

        val allAmountStr =
            String.format(Locale.CHINA, "%.2f", mCheckGoodsSubmitPresenter?.mAllDiffAmount)
        (view.findViewById(R.id.diff_all_amount) as TextView).text = allAmountStr//显示差异总价

        if (diffList.isEmpty()) {//如果比较之后并没有什么差异
            (view.findViewById(R.id.no_diff_icon) as ImageView).visibility =
                View.VISIBLE//并没有差异嘛，显示一个绿勾
        } else {
            (view.findViewById(R.id.no_diff_icon) as ImageView).visibility = View.GONE
        }
        (view.findViewById(R.id.diff_list) as ListView).adapter = diffAdapter
        AlertDialog.Builder(this).setTitle("差异信息确认")
            .setView(view)
            .setCancelable(false)
            .setPositiveButton("确认") { dialog, which -> finish() }.create().show()
    }

    /**
     * 根据点击的标签不同，来刷新不同的列表
     */
    private fun refreshRecyclerView() {
        if (mCheckGoodsAdapter == null) {
            mCheckGoodsAdapter =
                CheckSubmitAdapter2(mCheckGoodsSubmitPresenter?.mResultInfo?.detailList ?: listOf(),
                    object : CheckSubmitAdapter2.ModifyNumClickListener {
                        override fun onModifyNumClickListener(list: List<CanCheckRes3.ResultInfo.DetailList>?) {
                            computeDataToView(list)
                        }
                    })
            rv_check_goods_list?.apply {
                layoutManager = LinearLayoutManager(mContext)
                adapter = mCheckGoodsAdapter
                addItemDecoration(SpacesItemDecoration(20, adapter!!.itemCount, true))
            }
        } else {
            mCheckGoodsAdapter?.notifyDataSetChanged()
        }
    }


    /**
     * 主要是用来刷adapter，还有别忘了标题的品牌分类也是根据后台返回的
     */
    override fun refreshDataToView(resultInfo: CanCheckRes3.ResultInfo?) {
        if (isFinishing || resultInfo?.detailList?.size == 0) return
        botton_layout.visibility = View.VISIBLE//底栏

        //ll_dismiss.setOnClickListener { it.visibility = View.GONE }
        //刷新价格&&数量 显示
        computeDataToView(resultInfo?.detailList)
        //列表点击监听
        //rv_check_goods_list.setOnItemClickListener { adapterView, view, pos, id ->
        //showCheckGoodsDialog(pos)
        //  }
    }


    /**
     * 刷新价格&&数量显示
     */
    private fun computeDataToView(proList: List<CanCheckRes3.ResultInfo.DetailList>?) {
        var count = 0.0
        var countPrice = 0.0
        proList?.forEach {
            if (it.pdAlterNum != null) {
                count = Arith.add(count, it.pdAlterNum!!)
                countPrice = Arith.add(countPrice, Arith.mul(it.pdAlterNum!!, it.proPrice ?: 0.0))
            } else {
                count = Arith.add(count, it.pdQty ?: 0.0)
                countPrice = Arith.add(countPrice, Arith.mul(it.pdQty ?: 0.0, it.proPrice ?: 0.0))
            }
        }

        total_count.text = StringUtils.formatDouble(count, "0.00")
        total_price.text = StringUtils.formatDouble(countPrice, "0.00")
    }


    /**
     * 弹出盘点编辑小弹窗

    private fun showCheckGoodsDialog(position: Int) {
    val ent = mCheckGoodsAdapter?.list?.get(position)
    ll_dismiss.visibility = View.VISIBLE

    val name = ent?.proName + " " + ent?.proCode
    mTvGoodsName?.text = name
    mTvGoodsDhPack?.text = MessageFormat.format("单位:{0}", ent?.proUnit)

    mTvCancel?.setOnClickListener {
    //点取消不需要刷新数量和显示
    ll_dismiss.visibility = View.GONE
    val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
    imm.hideSoftInputFromWindow(mEtPdcount?.getWindowToken(), 0)
    }
    mTvNext?.setOnClickListener {
    val count = mEtPdcount?.text.toString().trim { it <= ' ' }
    mCheckGoodsSubmitPresenter?.writeEnt(count, ent)//把新数据写入到ent里，并更新isPanDian为true标记
    listview_checkgoods.smoothScrollToPosition(position)
    //刷新底栏价格&&数量显示
    refreshCount(mCheckGoodsSubmitPresenter?.resultInfo?.detailList ?: listOf())
    mCheckGoodsAdapter?.notifyDataSetChanged()
    //如果到了当前列表的最后一项
    if ((position + 1 >= (mCheckGoodsAdapter?.list?.size ?: 0))) {
    ll_dismiss.visibility = View.GONE
    val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
    imm.hideSoftInputFromWindow(mEtPdcount?.getWindowToken(), 0)
    showToast("没有下一个产品了")
    } else {
    showCheckGoodsDialog(position + 1)
    }
    }

    mIsPopShow = true
    //如果不支持两位小数,就设置自定义editText小数位为0
    mEtPdcount?.setDecimal(if (ent?.isDecimal ?: true) 2 else 0)
    mEtPdcount?.setText(
    StringUtils.formatDouble(
    ent?.pdQty
    ?: 0.00, mCheckGoodsAdapter?.getProQtyFormatByDecimal(ent)
    )
    )//弹窗的输入框
    mEtPdcount?.setSelectAllOnFocus(true)
    mEtPdcount?.selectAll()
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
    if (keyCode == KeyEvent.KEYCODE_BACK) {
    if (mIsPopShow) {
    mIsPopShow = false
    ll_dismiss.visibility = View.GONE
    mCheckGoodsAdapter?.notifyDataSetChanged()
    return true
    } else {
    return super.onKeyDown(keyCode, event)
    }
    }
    return super.onKeyDown(keyCode, event)
    }
     */

    /**
     * 相册选择和拍照
     */
    private fun showCamera() {
        if (mPhotoPick == null) {
            mPhotoPick =
                PhotoPickDominator(this, mCheckGoodsSubmitPresenter?.mBackInput?.getPhotoList())
        }
        if (mCheckGoodsSubmitPresenter?.mBackInput?.getPhotoList()?.size ?: 0 < PHOTO_MAX_NUM) {
            mPhotoPick?.showDialog()
        } else {
            showToast("最多只能上传" + PHOTO_MAX_NUM + "张图片!")
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        val photoPath = mPhotoPick?.onPhotoPathResult(this, requestCode, resultCode, data);
        mPhotoPick?.addPhoto2Group(
            photoPath,
            DensityUtil.dip2px(this, 60f),
            DensityUtil.dip2px(this, 60f),
            photoGroups
        )
    }
}
