package com.urovo.activity.checkGoodsTabAct.view

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.ConstantParams
import com.zsy.libcore.ui.ada.helper.DividerItemDecoration
import kotlinx.android.synthetic.main.check_goods_entry_ll.*
import org.jetbrains.anko.find

/**
 * @author LW on 2022/8/18.
 * 门店盘点查询
 */
class CheckGoodsTabMenu : BaseActivity() {


    override fun addRootLayoutId(): Int = R.layout.check_goods_entry_ll

    override fun initTitle() {
        super.initTitle()
        titleTextView.text = getString(R.string.stock_check_title)
    }

    override fun initViewNew() {
        initTitle()
        val list = listOf(
            mContext.getString(R.string.check_goods_submit_title),
            mContext.getString(R.string.check_goods_qeury_title)
        )

        checkGoodsEntryRv.run {
            layoutManager = LinearLayoutManager(this@CheckGoodsTabMenu)
            addItemDecoration(
                DividerItemDecoration(
                    this@CheckGoodsTabMenu,
                    DividerItemDecoration.VERTICAL_LIST,
                    1,
                    ContextCompat.getColor(this@CheckGoodsTabMenu, R.color.pop_query_devider)
                )
            )
            adapter = CheckGoodsMenuAdapter(this@CheckGoodsTabMenu, list)
        }
    }

    class CheckGoodsMenuAdapter(private val context: Context, private var items: List<String>) :
        RecyclerView.Adapter<CheckGoodsMenuAdapter.CheckGoodsMenuHolder>() {
        override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): CheckGoodsMenuHolder {
            return CheckGoodsMenuHolder(
                LayoutInflater.from(context).inflate(R.layout.second_menu_item, parent, false)
            )
        }

        override fun getItemCount(): Int {
            return items.size
        }

        override fun onBindViewHolder(holder: CheckGoodsMenuHolder, position: Int) {
            holder.run {
                itemName.text = items[position]
                dividerView.visibility = View.GONE
                root.setOnClickListener {
                    when (position) {
                        ConstantParams.CONSTANT_STARTS_0 -> context.startActivity(
                            Intent(
                                context,
                                CheckGoodsSubmitListActivity::class.java
                            )
                        )
                        ConstantParams.CONSTANT_STARTS_1 -> context.startActivity(
                            Intent(
                                context,
                                CheckGoodsQueryActivity::class.java
                            )
                        )
                    }
                }
            }
        }

        class CheckGoodsMenuHolder(view: View) : RecyclerView.ViewHolder(view) {
            var itemName: TextView
            var dividerView: View
            var root: LinearLayout

            init {
                root = view.find(R.id.root)
                itemName = view.find(R.id.ItemText)
                dividerView = view.find(R.id.dividerView)
            }
        }
    }

}