package com.urovo.activity.checkGoodsTabAct.view

import android.app.Activity
import android.app.ActivityManager
import android.app.AlertDialog
import android.content.Context
import android.content.Intent
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.net.Uri
import android.os.Bundle
import android.provider.MediaStore
import android.view.KeyEvent
import android.widget.Toast
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.ViewModelProviders
import com.urovo.activity.machinerepairact.model.MachineEngineerFactory
import com.urovo.activity.machinerepairact.model.MachineEngineerModel
import com.urovo.activity.machinerepairact.repository.MachineCallRepo
import com.urovo.activity.tabMenu.util.JPush.JPushBindDominator
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.data.FileCache
import com.urovo.wugumofang.databinding.MachineEngineerActBinding
import com.urovo.wugumofang.system.BasePackageUtil
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.PictureUtil
import com.urovo.wugumofang.utils.FuckGoogleAdaptUtil
import com.urovo.wugumofang.utils.MyToast
import com.zsy.libcore.ui.act.SYActManager
import java.io.File
import java.util.*

/**
 * @author LW on 2022-08-18
 * 盘点表图片/备注提交
 */
class CheckGoodsTableActivity : BaseActivity() {
    val binding by lazy {
        DataBindingUtil.setContentView<MachineEngineerActBinding>(this, R.layout.machine_engineer_act)
    }

    val engineerModel by lazy {
        ViewModelProviders.of(this, MachineEngineerFactory(MachineCallRepo())).get(MachineEngineerModel::class.java)
    }


    private var head: Bitmap? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        bind()
        setListener()
        bindJPush()
        engineerModel.getUserPic(SystemHelper.LoginUserId)
        engineerModel.queryUnDealRepair()
        engineerModel.queryMyStores()
        engineerModel.queryLightProblem()
    }

    /**
     * 绑定极光推送
     */
    fun bindJPush() {
        JPushBindDominator(this, SystemHelper.LoginUserId).run {
            setJPushAliasAndTag(SystemHelper.IsAdmin)
        }
    }

    fun bind() {
        binding.run {
            model = engineerModel
            storeName = SystemHelper.LoginOrganName
            userName = SystemHelper.LoginUserName
            picUrl = engineerModel.picUrl
        }
//        engineerModel.isRefreshing.observe(this, Observer {
//            if (!it) {//it == false
//                binding.refreshLayout.isRefreshing = false
//            }
//        })
    }

    fun setListener() {
        binding.refreshLayout.setOnRefreshListener {
            engineerModel.queryUnDealRepair()
            engineerModel.queryMyStores()
            engineerModel.queryLightProblem()
        }
        //设置头像
        binding.memberIconIv.setOnClickListener {
            val items = arrayOf<CharSequence>("拍照", "从相册选取", "取消")
            val builder = AlertDialog.Builder(this)
            builder.setTitle("更换头像").setItems(items) { dialog, item ->
                when (item) {
                    // 调用相机拍照
                    0 -> {
                        val intent1 = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                        val file = File(Files.tempPicture, SystemHelper.LoginUserId + ".jpg")
                        var uri = FuckGoogleAdaptUtil.android7AdaptUri(this, Files.fileProviderAuth, file)
                        intent1.putExtra(MediaStore.EXTRA_OUTPUT, uri)
                        intent1.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                        intent1.addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)
                        startActivityForResult(intent1, 1)// 采用ForResult打开
                    }
                    // 从相册里面取照片
                    1 -> {
                        val intent2 = Intent(Intent.ACTION_PICK, null)
                        intent2.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, "image/*")
                        intent2.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                        intent2.addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)
                        startActivityForResult(intent2, 2)
                    }
                    else -> {
                    }
                }
            }
            val alert = builder.create()
            alert.show()
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            // 调用相机拍照
            1 -> if (resultCode == Activity.RESULT_OK) {
                PictureUtil.saveImageToGallery(this@CheckGoodsTableActivity, Files.tempPicture, SystemHelper.LoginUserId + ".jpg")
                val temp = File(Files.tempPicture + SystemHelper.LoginUserId + ".jpg")
                cropPhoto(FuckGoogleAdaptUtil.android7AdaptUri(this, Files.fileProviderAuth, temp))//裁剪图片
            }
            // 从相册里面取照片
            2 -> if (resultCode == Activity.RESULT_OK) {
                // 裁剪图片
                cropPhoto(data!!.data)

            }
            //剪裁
            3 -> if (data != null /*&& data.extras != null*/) {
                if (data.extras != null) {
                    head = data.extras!!.get("data") as Bitmap?
                }
                if (head == null && data.data != null) {
                    head = BitmapFactory.decodeStream(getContentResolver().openInputStream(data.data!!))
                }
                if (head != null) {
                    FileCache.saveBitmap(head, Files.tempPicture + SystemHelper.LoginUserId + ".jpg")
                    QiNiuDominator.uploadImages(mutableListOf(Files.tempPicture + SystemHelper.LoginUserId + ".jpg"), QiNiuDominator.CompleteQiniu {
                        engineerModel.uploadUserPic(SystemHelper.LoginUserId, it[0])
                        engineerModel.picUrl.set(it[0])
                    })
                }
            }
            else -> {
            }
        }
    }


    override fun onResume() {
        super.onResume()
        engineerModel.queryUnDealRepair()
        engineerModel.queryMyStores()
        engineerModel.queryLightProblem()
    }

    override fun dispatchKeyEvent(event: KeyEvent): Boolean {
        if (event.keyCode == KeyEvent.KEYCODE_BACK
                && event.action == KeyEvent.ACTION_DOWN
                && event.repeatCount == 0) {
            exitBy2Click()
            return false
        }
        return super.dispatchKeyEvent(event)
    }

    private var isExit: Boolean? = false
    private fun exitBy2Click() {
        var tExit: Timer? = null
        if (isExit == false) {
            isExit = true // 准备退出
            MyToast.show(this, "再按一次退出程序", Toast.LENGTH_SHORT)
            //Toast.makeText(this, "再按一次退出程序", Toast.LENGTH_SHORT).show();
            tExit = Timer()
            tExit.schedule(object : TimerTask() {
                override fun run() {
                    isExit = false // 取消退出
                }
            }, 2000) // 如果2秒钟内没有按下返回键，则启动定时器取消掉刚才执行的任务

        } else {
            // PollingTool.stopPollingService(TabMenuActivity.this,
            // PollingService.class, PollingService.ACTION);
            //要杀掉第二进程
            (getSystemService(Context.ACTIVITY_SERVICE) as ActivityManager).killBackgroundProcesses(BasePackageUtil.getAppPackageName(this))
            SYActManager.getInstance().AppExit()
        }
    }

    /**
     * 调用系统的裁剪
     *
     * @param uri ...
     */
    fun cropPhoto(uri: Uri?) {
        val intent = Intent("com.android.camera.action.CROP").apply {
            setDataAndType(uri, "image/*")
            putExtra("crop", "true")
            // aspectX aspectY 是宽高的比例
            putExtra("aspectX", 1)
            putExtra("aspectY", 1)
            // outputX outputY 是裁剪图片宽高
            putExtra("outputX", 100)
            putExtra("outputY", 100)
            putExtra("return-data", true)
            addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
            addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)
        }
        startActivityForResult(intent, 3)
    }
}