package com.urovo.activity.checkGoodsTabAct.view.adapter;

import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.R;

import java.util.List;

public class CheckSubmitAdapter extends BaseAdapter {
    private List<ProductEntity> list;
    private BaseActivity context;

    public CheckSubmitAdapter(List<ProductEntity> list, BaseActivity context) {
        this.list = list;
        this.context = context;

    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_checkgoodsmenu_new_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView.findViewById(R.id.check_name);
            viewHolder.count = (TextView) convertView.findViewById(R.id.count);
            viewHolder.kcuom = (TextView) convertView.findViewById(R.id.kcuom);
            viewHolder.price = (TextView) convertView.findViewById(R.id.price);
            viewHolder.amount = (TextView) convertView.findViewById(R.id.amount);
            viewHolder.pdCount = (EditText) convertView.findViewById(R.id.pd_count);
            viewHolder.isPD = (LinearLayout) convertView.findViewById(R.id.is_pandian);
            viewHolder.add = (ImageButton) convertView.findViewById(R.id.pd_plus);
            viewHolder.reduce = (ImageButton) convertView.findViewById(R.id.pd_decrease);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final ProductEntity ent = list.get(position);
        viewHolder.pdCount.setTag(position);
        viewHolder.name.setText(ent.getItemName());
        viewHolder.kcuom.setText("(" + ent.getKCUom() + ")");
        viewHolder.price.setText(StringUtils.formatDouble(ent.getPrice(), "0.00"));
        viewHolder.pdCount.setText(StringUtils.formatDouble(ent.getTQTY(), "1"));
        if (ent.getTQTY() == 0) {
            viewHolder.reduce.setEnabled(false);
        } else {
            viewHolder.reduce.setEnabled(true);
        }
        viewHolder.count.setText(StringUtils.formatDouble(ent.getTQTY(), "0.##"));
        viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
        viewHolder.add.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                // ent.setTQTY(Arith.add(ent.getTQTY(), 1.0));
                // ent.setAmount(Arith.mul(ent.getTQTY(), ent.getPrice()));
                // viewHolder.pdCount.setText(StringUtils.formatDouble(Arith.add(ent.getTQTY(),
                // 1.0), "0"));
                // viewHolder.count.setText(StringUtils.formatDouble(ent.getTQTY(),
                // "0.00"));
                // viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(),
                // "0.00"));
                // if(ent.getTQTY() > 0){
                // viewHolder.reduce.setEnabled(true);
                // }
                int i = (int) Double.parseDouble(viewHolder.pdCount.getText().toString());
                i++;
                viewHolder.pdCount.setText(i + "");
            }
        });
        viewHolder.reduce.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                // ent.setTQTY(Arith.sub(ent.getTQTY(),1.0));
                // ent.setAmount(Arith.mul(ent.getTQTY(), ent.getPrice()));
                // viewHolder.pdCount.setText(StringUtils.formatDouble(Arith.sub(ent.getTQTY(),1.0),
                // "0"));
                // viewHolder.count.setText(StringUtils.formatDouble(ent.getTQTY(),
                // "0.00"));
                // viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(),
                // "0.00"));
                // if(ent.getTQTY() == 0){
                // viewHolder.reduce.setEnabled(false);
                // }
                int i = (int) Double.parseDouble(viewHolder.pdCount.getText().toString());
                i--;
                viewHolder.pdCount.setText(i + "");
            }
        });
        viewHolder.pdCount.setSelectAllOnFocus(true);
        viewHolder.pdCount.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                viewHolder.pdCount.setText(viewHolder.pdCount.getText().toString());
                viewHolder.pdCount.selectAll();
            }
        });

        viewHolder.pdCount.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {

                int ptn = (Integer) viewHolder.pdCount.getTag();
                String str = viewHolder.pdCount.getText().toString();
                if (str.equals(StringUtils.formatDouble(list.get(ptn).getTQTY(), "0.##"))) {
                    return;
                }
                double count = 1.0;
                if (!TextUtils.isEmpty(str)) {
                    count = Double.parseDouble(str);
                } else {
                    count = 0.0;
                    // viewHolder.pdCount.setText(0+"");
                }
                // ProductEntity p = list.get(ptn);
                // p.setTQTY(count);
                // p.setAmount(Arith.mul(count, ent.getPrice()));
                list.get(ptn).setTQTY(count);
                list.get(ptn).setAmount(Arith.mul(count, list.get(ptn).getPrice()));

                viewHolder.count.setText(StringUtils.formatDouble(list.get(ptn).getTQTY(), "0.##"));
                viewHolder.amount.setText(StringUtils.formatDouble(list.get(ptn).getAmount(), "0.00"));
                // viewHolder.count.setText(StringUtils.formatDouble(p.getTQTY(),
                // "0"));
                // viewHolder.amount.setText(StringUtils.formatDouble(p.getAmount(),
                // "0.00"));
                if (count == 0) {
                    viewHolder.reduce.setEnabled(false);
                } else {
                    viewHolder.reduce.setEnabled(true);
                }
                context.doResult(position);
            }

        });
        // viewHolder.pdCount.setText(StringUtils.formatDouble(list.get(position).getTQTY(),
        // "0"));
        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView count;
        TextView kcuom;
        TextView price;
        TextView amount;
        EditText pdCount;
        LinearLayout isPD;
        ImageButton add, reduce;

    }

}
