package com.urovo.activity.combineResult.presenter;

import com.google.gson.Gson;
import com.urovo.activity.combineResult.model.ResultData;
import com.urovo.activity.combineResult.net.CombineRes;
import com.urovo.activity.combineResult.net.JsonItem;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Sasuke on 2016/9/17.
 */
public class CombineResultPresenter implements CombineContract.Presenter{
    CombineContract.View mView;
    ResultData data;
    public CombineResultPresenter(CombineContract.View mView) {
        this.mView = mView;
        this.data = new ResultData();
    }

    public ResultData getData(){
        if(data == null){
            data = new ResultData();
        }
        return data;
    }

    public void queryCombineResult(){
        List<JsonItem> jsonItems = new ArrayList<>();
        for(ProductEntity entity : getData().getSelectList()){
            JsonItem item = new JsonItem();
            item.setItemId(entity.getItemId());
            item.setTQTY(String.format("%.0f",entity.getTQTY()) + "");
            jsonItems.add(item);
        }
        Map<String,String > params = new HashMap<String, String>();
        params.put("json",new Gson().toJson(jsonItems));
        //要传的值
        //selectedList.get(position).getTQTY()//已选的数量
        //selectedList.get(position).getItemId()//产品ID
        new BaseAppServerTask("getCombineResult",CombineRes.class,
                (BaseActivity)mView,"正在获取搭配详情...",true,"/customer/getAlimSuggest",params).execute("");
    }

    @Override
    public void start() {
        mView.init();
    }
}
