package com.urovo.activity.common;

import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.urovo.activity.common.MyCalendar.OnDaySelectListener;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.R;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class SelectDatePop implements OnDaySelectListener {
	LinearLayout ll;
	MyCalendar c1;
	Calendar calDate;
	String nowday;
	long nd = 1000 * 24L * 60L * 60L;// 一天的毫秒数
	SimpleDateFormat simpleDateFormat, sd1, sd2;

	private int iFirstDayOfWeek = Calendar.MONDAY;
	private int iMonthViewCurrentMonth = 0;
	private int iMonthViewCurrentYear = 0;

	private String inday, outday;
	Button btnToday;
	private Context context;
	private PopupWindow popupWindow;

	public SelectDatePop(final Context context, final onDateSelectedListener dateSelectedListener) {
		this.context = context;
		this.dateSelectedListener = dateSelectedListener;
		LayoutInflater inflater = LayoutInflater.from(context);
		View view = inflater.inflate(R.layout.select_date, null);
		calDate = Calendar.getInstance();// 当前时间
		simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
		nowday = simpleDateFormat.format(new Date());
		sd1 = new SimpleDateFormat("yyyy");
		sd2 = new SimpleDateFormat("dd");
		btnToday = (Button) view.findViewById(R.id.btnToday);
		ImageButton btnPrev = (ImageButton) view.findViewById(R.id.btnPrev);
		ImageButton btnNext = (ImageButton) view.findViewById(R.id.btnNext);
		btnPrev.setOnClickListener(new OnClickListener() {
			public void onClick(View arg0) {
				setPrevViewItem();
			}
		});
		btnToday.setOnClickListener(new OnClickListener() {
			public void onClick(View arg0) {
				setTodayViewItem();
				String s = calDate.get(Calendar.YEAR) + "年" + (calDate.get(Calendar.MONTH) + 1 + "月");
				btnToday.setText(s);
			}
		});
		btnNext.setOnClickListener(new OnClickListener() {
			public void onClick(View arg0) {
				setNextViewItem();
			}
		});
		view.findViewById(R.id.dismiss_view).setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				popupWindow.dismiss();
			}
		});
		ll = (LinearLayout) view.findViewById(R.id.ll);
		popupWindow = new PopupWindow(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT);
		popupWindow.setContentView(view);
	}

	public void showWindow(View view) {
		if(popupWindow == null)
			return;
		popupWindow.setFocusable(true);
		popupWindow.setOutsideTouchable(true);
		ColorDrawable cd = new ColorDrawable(-0000);
		popupWindow.setBackgroundDrawable(cd);
		popupWindow.showAtLocation(view, Gravity.CENTER, 0, 0);
		updateCalendar();
	}

	private void updateCalendar() {
		ll.removeAllViews();
		LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT);
		c1 = new MyCalendar(context);
		c1.setLayoutParams(params);
		Date date = calDate.getTime();
		if(!"".equals(inday)) {
			c1.setInDay(inday);
		}
		if(!"".equals(outday)) {
			c1.setOutDay(outday);
		}
		c1.setTheDay(date);
		c1.setOnDaySelectListener(this);
		ll.addView(c1);

		String s = calDate.get(Calendar.YEAR) + "年" + (calDate.get(Calendar.MONTH) + 1 + "月");
		btnToday.setText(s);
	}

	@Override
	public void onDaySelectListener(View view, String date) {

		String dateDay = date.split("-")[2];
		if(Integer.parseInt(dateDay) < 10) {
			dateDay = date.split("-")[2].replace("0", "");
		}
		TextView textDayView = (TextView) view.findViewById(R.id.tv_calendar_day);
		TextView textView = (TextView) view.findViewById(R.id.tv_calendar);
		view.setBackgroundColor(Color.parseColor("#33B5E5"));
		textDayView.setTextColor(Color.WHITE);
		try {
			if(null == inday || inday.equals("")) {
				if(null != outday && !outday.equals("") && simpleDateFormat.parse(date).getTime() > simpleDateFormat.parse(outday).getTime()) {
					clearnColor(2);
					textDayView.setText(dateDay);
					view.setBackgroundColor(Color.parseColor("#33B5E5"));
					textView.setText("结束");
					outday = date;
					c1.viewOut = view;
					// 选定结束日期之后直接返回
					popupWindow.dismiss();
					dateSelectedListener.onDateSelect(inday, outday);
				}
				else
					if(null != outday && !outday.equals("") && simpleDateFormat.parse(date).getTime() == simpleDateFormat.parse(outday).getTime()) {
						view.setBackgroundColor(Color.WHITE);
						textDayView.setText(dateDay);
						textDayView.setTextColor(Color.BLACK);
						textView.setText("");
						outday = "";
					}
					else {
						clearnColor(1);
						textDayView.setText(dateDay);
						textView.setText("开始");
						c1.viewIn = view;
						view.setBackgroundColor(Color.parseColor("#33B5E5"));
						inday = date;
					}
			}
			else {
				if(inday.equals(date)) {
					view.setBackgroundColor(Color.WHITE);
					textDayView.setText(dateDay);
					textDayView.setTextColor(Color.BLACK);
					textView.setText("");
					inday = "";
				}
				else
					if(simpleDateFormat.parse(date).getTime() < simpleDateFormat.parse(inday).getTime()) {
						clearnColor(1);
						textDayView.setText(dateDay);
						textView.setText("开始");
						MyToast.show(context, "开始时间重新设定为：" + date, 2000);
						inday = date;
						c1.viewIn = view;
					}
					else
						if(null != outday && !outday.equals("") && simpleDateFormat.parse(date).getTime() == simpleDateFormat.parse(outday).getTime()) {
							view.setBackgroundColor(Color.WHITE);
							textDayView.setText(dateDay);
							textDayView.setTextColor(Color.BLACK);
							textView.setText("");
							outday = "";
						}
						else {
							clearnColor(2);
							textDayView.setText(dateDay);
							textView.setText("结束");
							view.setBackgroundColor(Color.parseColor("#33B5E5"));
							outday = date;
							c1.viewOut = view;
							// 选定结束日期之后直接返回
							popupWindow.dismiss();
							dateSelectedListener.onDateSelect(inday, outday);
						}
			}
		}
		catch (ParseException e) {

		}
	}

	private void clearnColor(int type) {
		if(type == 1 && c1.viewIn != null) {
			c1.viewIn.setBackgroundColor(Color.WHITE);
			((TextView) c1.viewIn.findViewById(R.id.tv_calendar_day)).setTextColor(Color.BLACK);
			((TextView) c1.viewIn.findViewById(R.id.tv_calendar)).setText("");
		}
		else
			if(type == 2 && c1.viewOut != null) {
				c1.viewOut.setBackgroundColor(Color.WHITE);
				((TextView) c1.viewOut.findViewById(R.id.tv_calendar_day)).setTextColor(Color.BLACK);
				((TextView) c1.viewOut.findViewById(R.id.tv_calendar)).setText("");
			}
	}

	public String getMon(int mon) {
		String month = "";
		if(mon < 10) {
			month = "0" + mon;
		}
		else {
			month = "" + mon;
		}
		return month;
	}

	private void setPrevViewItem() {
		iMonthViewCurrentMonth = calDate.get(Calendar.MONTH);
		iMonthViewCurrentYear = calDate.get(Calendar.YEAR);

		iMonthViewCurrentMonth--;
		if(iMonthViewCurrentMonth == -1) {
			iMonthViewCurrentMonth = 11;
			iMonthViewCurrentYear--;
		}
		calDate.set(Calendar.DAY_OF_MONTH, 1);
		calDate.set(Calendar.MONTH, iMonthViewCurrentMonth);
		calDate.set(Calendar.YEAR, iMonthViewCurrentYear);
		updateCalendar();
	}

	private void setTodayViewItem() {
		calDate.setTimeInMillis(System.currentTimeMillis());
		calDate.setFirstDayOfWeek(iFirstDayOfWeek);
		updateCalendar();
	}

	private void setNextViewItem() {
		iMonthViewCurrentMonth = calDate.get(Calendar.MONTH);
		iMonthViewCurrentYear = calDate.get(Calendar.YEAR);

		iMonthViewCurrentMonth++;
		if(iMonthViewCurrentMonth == 12) {
			iMonthViewCurrentMonth = 0;
			iMonthViewCurrentYear++;
		}
		calDate.set(Calendar.DAY_OF_MONTH, 1);
		calDate.set(Calendar.MONTH, iMonthViewCurrentMonth);
		calDate.set(Calendar.YEAR, iMonthViewCurrentYear);
		updateCalendar();
	}

	private onDateSelectedListener dateSelectedListener;

	public interface onDateSelectedListener {
		public void onDateSelect(String startDay, String endDay);
	}
}
