package com.urovo.activity.common;

import android.app.DatePickerDialog;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.view.Display;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.view.WindowManager.LayoutParams;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListPopupWindow;
import android.widget.PopupWindow;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.activity.common.SelectDatePop.onDateSelectedListener;
import com.urovo.wgmf.db.dao.dao.Czyda001DbOperate;
import com.urovo.wgmf.db.dao.entitys.CZYDA;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.zsy.libcore.common.android.log.SYLoger;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;


public class StoreDateSelectorPop implements OnClickListener, RadioGroup.OnCheckedChangeListener {
    public static final int STORE_DATE_FROMTO = 0;
    public static final int STORE_DATE_MONTH = 1;
    public static final int STORE_DATE_INFO = 2;
    public static final int STORE_DATE_MIX = 3;
    public static final int STORE_DATE_MIX_USER = 4;
    public static final int STORE_DATE_FROMTO_USER = 5;//新客微会员数据,当前月份
    public static final int STORE_DATE_SANXIANGPAO_DATA = 6;//三响炮数据专用自定义
    public static final int STORE_DATE_LAST_MONTH = 7;//上个月
    public static final int STORE_DATE_GUEST_FOLIO = 8;//客单数查询
    public static final int STORE_DATE_GOODS_INOUT_STOCK = 9;//产品出入库（按月）查询
    public static final int STORE_DATE_QUERY_ON_SALE = 10;//产品月销售查询
    private boolean mIsAdmin;
    private int mMode;
    private StoreDateSelectorPopListener mStoreDateSelectorPopListener;
    private Context mContext;
    private String mStoreId;
    private String mMWStoreId;// 督导代门店id
    private String mStore;
    private String mUser;
    private String mDateFrom;
    private String mDateTo;
    private String mDateMonth;
    private String mQueryMonth;
    private String mToday = new SimpleDateFormat("yyyy-MM-dd").format(new Date());//缓存起始日期
    private View mViewParent;
    private PopupWindow mPopupWindow;

    private LinearLayout mLinearLayoutStore;
    private TextView mTextViewStore;
    private ImageView mImageViewStoreMore;

    private LinearLayout mLinearLayoutLoginName;
    private TextView mTextViewLoginName;
    private ImageView mImageViewLoginNameMore;

    private LinearLayout mLinearLayoutDateFT;
    private TextView mTextViewDateFrom;
    private TextView mTextViewDateTo;
    private ImageView mImageViewDateFTMore;

    private LinearLayout mLinearLayoutDateMonth;
    private TextView mTextViewDateMonth;
    private ImageView mImageViewDateMonthMore;

    private LinearLayout mLinearLayoutMix;
    private LinearLayout mLinearLayoutMixBegin;
    private LinearLayout mLinearLayoutMixEnd;
    private RelativeLayout mRelativeLayoutQueryMonth;
    private TextView mTextViewMixBegin;
    private TextView mTextViewMixEnd;
    private TextView mTvGoodsInOutStockDesc;

    private FrameLayout mFrameLayoutSearch;
    private Button mButtonSearch;
    private View mViewDismiss;

    private LinearLayout mLinearLayoutSwitch;//客单数查询专用布局
    private RadioGroup mRadios;//客单数查询切换查询模式的按钮
    private TextView mSwitchDateFrom;//客单数查询 起始日期
    private TextView mSwitchDateTo;//客单数查询  终止日期
    private TextView mToText;//"至"字
//       private LinearLayout mLinearLayoutSanXiangPao;//三响炮数据查询专用弹窗布局
//       private TextView mSanXiangPaoDateBegin;
//       private TextView mSanXiangPaoDateEnd;

    private ListPopupWindow mListPopupWindow;
    private List<String> mNames;
    private List<CZYDA> mListCzyda;
    private String mUserID = SystemHelper.LoginUserId;

//    private ImageView mDateFromArrow;//新客三响炮里的新界面，箭头是朝下的
//    private ImageView mDateToArrow;

    public StoreDateSelectorPop(final Context context) {
        this(context, LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT, null);
    }

    public StoreDateSelectorPop(final Context context, StoreDateSelectorPopListener listener, boolean admin, int mode) {
        this(context, LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT, listener, admin, mode);
    }

    public StoreDateSelectorPop(final Context context, final int width, final int height, StoreDateSelectorPopListener listener) {
        this(context, width, height, listener, false, STORE_DATE_FROMTO);
    }

    public StoreDateSelectorPop(final Context context, final int width, final int height, StoreDateSelectorPopListener listener, boolean admin, int mode) {
        mIsAdmin = admin;
        mMode = mode;
        mContext = context;
        mStoreDateSelectorPopListener = listener;
        LayoutInflater inflater = LayoutInflater.from(mContext);
        View v = inflater.inflate(R.layout.pop_store_data_query, null);

        mLinearLayoutStore = (LinearLayout) v.findViewById(R.id.linearLayoutStore);
        mTextViewStore = (TextView) v.findViewById(R.id.textViewStore);
        mImageViewStoreMore = (ImageView) v.findViewById(R.id.imageViewStoreMore);

        mLinearLayoutLoginName = (LinearLayout) v.findViewById(R.id.linearLayoutLoginName);
        mTextViewLoginName = (TextView) v.findViewById(R.id.textViewLoginName);
        mImageViewLoginNameMore = (ImageView) v.findViewById(R.id.imageViewLoginNameMore);

        mLinearLayoutDateFT = (LinearLayout) v.findViewById(R.id.linearLayoutDateFT);
        mTextViewDateFrom = (TextView) v.findViewById(R.id.textViewDateFrom);
        mTextViewDateTo = (TextView) v.findViewById(R.id.textViewDateTo);
        mImageViewDateFTMore = (ImageView) v.findViewById(R.id.imageViewDateFTMore);

        mLinearLayoutDateMonth = (LinearLayout) v.findViewById(R.id.linearLayoutDateMonth);//新客微会员日期
        mTextViewDateMonth = (TextView) v.findViewById(R.id.textViewDateMonth);
        mImageViewDateMonthMore = (ImageView) v.findViewById(R.id.imageViewDateMonthMore);

        mLinearLayoutMix = (LinearLayout) v.findViewById(R.id.linearLayoutMix);
        mTextViewMixBegin = (TextView) v.findViewById(R.id.textViewMixBegin);
        mTextViewMixEnd = (TextView) v.findViewById(R.id.textViewMixEnd);
        mLinearLayoutMixBegin = (LinearLayout) v.findViewById(R.id.linearLayoutMixBegin);
        mLinearLayoutMixEnd = (LinearLayout) v.findViewById(R.id.linearLayoutMixEnd);
        mTvGoodsInOutStockDesc = (TextView) v.findViewById(R.id.tvGoodsInOutStockDesc);
        mRelativeLayoutQueryMonth = (RelativeLayout) v.findViewById(R.id.rlQueryMonth);
        View mDate_line1 = v.findViewById(R.id.date_line1);
        View mDate_line2 = v.findViewById(R.id.date_line2);
        View mDate_line3 = v.findViewById(R.id.date_line3);

        //客单数查询专用布局
        mLinearLayoutSwitch = (LinearLayout) v.findViewById(R.id.linearLayoutSwitch);
        mLinearLayoutSwitch.setVisibility(View.GONE);//默认GONE
        mRadios = (RadioGroup) v.findViewById(R.id.switchRadios);
        mSwitchDateFrom = (TextView) v.findViewById(R.id.switchDate1);
        mSwitchDateTo = (TextView) v.findViewById(R.id.switchDate2);
        mToText = (TextView) v.findViewById(R.id.zhi);

        //三响炮数据查询专用布局
//       mLinearLayoutSanXiangPao = (LinearLayout)v.findViewById(R.id.linearLayoutSanXiangPao);
//       mLinearLayoutSanXiangPao.setVisibility(View.GONE);
//       mSanXiangPaoDateBegin = (TextView)v.findViewById(R.id.SanXiangPaoDateBegin);
//       mSanXiangPaoDateEnd = (TextView)v.findViewById(R.id.SanXiangPaoDateEnd);
//        mDateFromArrow = (ImageView) v.findViewById(R.id.date_from_arrow);
//        mDateToArrow = (ImageView) v.findViewById(R.id.date_to_arrow);

        mFrameLayoutSearch = (FrameLayout) v.findViewById(R.id.frameLayoutSearch);
        mButtonSearch = (Button) v.findViewById(R.id.buttonSearch);
        mViewDismiss = v.findViewById(R.id.viewDismiss);
        mViewDismiss.setBackgroundColor(Color.parseColor("#f1f1f1"));
//       if(mIsAdmin) {
//              mLinearLayoutStore.setOnClickListener(this);
//              mButtonSearch.setOnClickListener(this);
//       }
//       else {
        mImageViewStoreMore.setVisibility(View.GONE);
//              mFrameLayoutSearch.setVisibility(View.GONE);
        mButtonSearch.setOnClickListener(this);
//       }
        switch (mMode) {
            case STORE_DATE_FROMTO: {
                mLinearLayoutDateFT.setOnClickListener(this);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mLinearLayoutMix.setVisibility(View.GONE);
            }
            break;
            case STORE_DATE_LAST_MONTH:
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
            case STORE_DATE_MONTH: {
                mLinearLayoutDateMonth.setOnClickListener(this);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutMix.setVisibility(View.GONE);
            }
            break;
            //客单数查询 专用布局======================
            case STORE_DATE_GUEST_FOLIO:
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mLinearLayoutSwitch.setVisibility(View.VISIBLE);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutMix.setVisibility(View.GONE);
                mSwitchDateFrom.setOnClickListener(this);
                mSwitchDateTo.setOnClickListener(this);
                mRadios.setOnCheckedChangeListener(this);
                break;
            case STORE_DATE_INFO: {
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mLinearLayoutMix.setVisibility(View.GONE);
                mImageViewDateMonthMore.setVisibility(View.GONE);
                mFrameLayoutSearch.setVisibility(View.GONE);
            }
            break;
            case STORE_DATE_MIX: {
                mLinearLayoutMixBegin.setOnClickListener(this);
                mLinearLayoutMixEnd.setOnClickListener(this);
                mButtonSearch.setOnClickListener(this);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
            }
            break;
            case STORE_DATE_MIX_USER: {
                mLinearLayoutMixBegin.setOnClickListener(this);
                mLinearLayoutMixEnd.setOnClickListener(this);
                mLinearLayoutLoginName.setOnClickListener(this);
                mButtonSearch.setOnClickListener(this);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mLinearLayoutLoginName.setVisibility(View.VISIBLE);
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
            }
            break;
            case STORE_DATE_FROMTO_USER: {//新客微会员数据 营养顾问模式
                //mLinearLayoutMixBegin.setOnClickListener(this);
                //mLinearLayoutMixEnd.setOnClickListener(this);
                mLinearLayoutMix.setVisibility(View.GONE);
                mButtonSearch.setOnClickListener(this);
                mLinearLayoutStore.setVisibility(View.VISIBLE);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.VISIBLE);
                mLinearLayoutDateMonth.setOnClickListener(this);
                mImageViewLoginNameMore.setVisibility(View.GONE);
                mLinearLayoutLoginName.setVisibility(View.GONE);
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
                mTextViewLoginName.setText(SystemHelper.LoginUserName);
            }
            break;
            case STORE_DATE_SANXIANGPAO_DATA: {//三响炮数据查询专用弹窗
//              mTextViewStore.setTextColor(Color.parseColor("#c6c5c3"));//门店字是灰色的
//              mTextViewStore.setTextSize(18);//原来的字太大了，重新设个。
//              mTextViewStore.setTypeface(Typeface.DEFAULT,0);//不要粗体
//              mDateFromArrow.setImageResource(R.drawable.down_arrows);//向下箭头
//              mDateToArrow.setImageResource(R.drawable.down_arrows);
//              mLinearLayoutSanXiangPao.setVisibility(View.VISIBLE);
                mLinearLayoutMix.setVisibility(View.VISIBLE);
                mLinearLayoutMixBegin.setOnClickListener(this);
                mLinearLayoutMixEnd.setOnClickListener(this);
//              mSanXiangPaoDateBegin.setOnClickListener(this);
//              mSanXiangPaoDateEnd.setOnClickListener(this);
//              mButtonSearch.setOnClickListener(this);
//              mButtonSearch.setBackgroundResource(R.drawable.login_button_selector);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
            }
            break;
            case STORE_DATE_GOODS_INOUT_STOCK: { // 产品出入库的popwindow布局
                mRelativeLayoutQueryMonth.setOnClickListener(this);
                mLinearLayoutLoginName.setOnClickListener(this);
                mButtonSearch.setOnClickListener(this);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mLinearLayoutMixBegin.setVisibility(View.GONE);
                mLinearLayoutMixEnd.setVisibility(View.GONE);
                mLinearLayoutLoginName.setVisibility(View.VISIBLE);
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
                mRelativeLayoutQueryMonth.setVisibility(View.VISIBLE);
                mDate_line1.setVisibility(View.GONE);
                mDate_line2.setVisibility(View.GONE);
                mDate_line3.setVisibility(View.GONE);
            }
            break;
            case STORE_DATE_QUERY_ON_SALE: { //
                mRelativeLayoutQueryMonth.setOnClickListener(this);
                mLinearLayoutLoginName.setOnClickListener(this);
                mButtonSearch.setOnClickListener(this);
                mLinearLayoutDateFT.setVisibility(View.GONE);
                mLinearLayoutDateMonth.setVisibility(View.GONE);
                mLinearLayoutMixBegin.setVisibility(View.GONE);
                mLinearLayoutMixEnd.setVisibility(View.GONE);
                mLinearLayoutLoginName.setVisibility(View.VISIBLE);
                mFrameLayoutSearch.setVisibility(View.VISIBLE);
                mRelativeLayoutQueryMonth.setVisibility(View.VISIBLE);
                mDate_line1.setVisibility(View.GONE);
                mDate_line2.setVisibility(View.GONE);
                mDate_line3.setVisibility(View.GONE);
            }
            break;
            default:
                break;
        }

        mViewDismiss.setOnClickListener(this);

        // SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        // Date nowDate = new java.util.Date();
        // String nowDateStr = sdf.format(nowDate);
        // setMixBegin(nowDateStr);
        // setMixEnd(nowDateStr);
        // setDateMonth(nowDateStr);
        // setDateTo(nowDateStr);
        // nowDate.setDate(1);
        // setDateFrom(sdf.format(nowDate));

        mPopupWindow = new PopupWindow(v, width, height, true);
        mPopupWindow.setBackgroundDrawable(new BitmapDrawable());

        mListPopupWindow = new ListPopupWindow(mContext);
        // if (mIsAdmin) {// 督导模式，拿到门店id
        // if (null == mTextViewStore.getText().toString()
        // || mTextViewStore.getText().equals("全部")) {
        // mMWStoreId = "1";
        // } else {
        // mMWStoreId = Store001DbOprate.GetMenDianIDbyName(mTextViewStore
        // .getText().toString());
        // }
        // SystemHelper.LoginWMUserId = mMWStoreId;
        // mListCzyda = Czyda001DbOperate
        // .GetYingYangGuWen(SystemHelper.LoginWMUserId);
        // } else {
        // mListCzyda = Czyda001DbOperate
        // .GetYingYangGuWen(SystemHelper.LoginOrganId);
        // }
        mListCzyda = Czyda001DbOperate.GetYingYangGuWen(SystemHelper.LoginOrganId);
        mNames = new ArrayList<String>();
        mNames.add("全部");
        if (null != mListCzyda && mListCzyda.size() > 0) {
            for (CZYDA cell : mListCzyda) {
                mNames.add(cell.getOperateName());
            }
        }
        mListPopupWindow.setAdapter(new ArrayAdapter<String>(mContext, android.R.layout.simple_list_item_1, mNames));
        mListPopupWindow.setWidth(LayoutParams.FILL_PARENT);
        mListPopupWindow.setHeight(LayoutParams.WRAP_CONTENT);
        mListPopupWindow.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                String name = mNames.get(position);
                mTextViewLoginName.setText(name);
                mListPopupWindow.dismiss();
                if (position > 0) {
                    mUserID = mListCzyda.get(position - 1).getOperateId();
                } else {
                    if (SystemHelper.NewInterface) {
                        mStoreId = "1";
                        mUserID = null;
                    } else {
                        mStoreId = SystemHelper.LoginOrganId;
                        mUserID = null;
                    }
                }
            }
        });

    }

    /**
     * 一键设为默认值
     */
    public void setDefaultInfo() {
        setStore(SystemHelper.LoginOrganName);
        setStroreId(SystemHelper.LoginOrganId);
//       setDateFrom(mDateFrom);
//       setMixBegin(mDateFrom);
//       setDateTo(mDateTo);
//       setMixEnd(mDateTo);
//       setDateMonth(mDateMonth);
        mIsAdmin = false;
    }

    /**
     * 客单数查询里，起始时间是按月还是按日
     *
     * @return 返回起始时间的格式
     */
    protected String getSwitchDateFormat() {
        return mSwitchDateTo.getVisibility() == View.GONE ? "yyyy-MM" : "yyyy-MM-dd";
    }

    @Override
    public void onCheckedChanged(RadioGroup radioGroup, int i) {
        String fromStr = mSwitchDateFrom.getText().toString();
        String toStr = mSwitchDateTo.getText().toString();
        switch (i) {
            case R.id.radio_by_month://按月查询
                ((FolioTypeSetter) mContext).setFolioType(1);//同步查询方式type
                mSwitchDateTo.setVisibility(View.GONE);
                mToText.setVisibility(View.GONE);
                mSwitchDateFrom.setTag(fromStr);//临死前的挣扎，留下完整长度的日期存在tag里。
                mSwitchDateFrom.setText(fromStr.substring(0, 7));
                mSwitchDateTo.setTag(toStr);
                mSwitchDateTo.setText("");//请求的时候，会根据现有日期进行比较，有不超过31天的限制，为了避开比较，就把截止日期设为“”
                break;
            case R.id.radio_by_day://按天查询
                ((FolioTypeSetter) mContext).setFolioType(2);//同步查询方式type
                mSwitchDateTo.setVisibility(View.VISIBLE);
                mToText.setVisibility(View.VISIBLE);
                mSwitchDateFrom.setText(mSwitchDateFrom.getTag() == null ? mToday : mSwitchDateFrom.getTag().toString());//tag如果没有东西，那就显示今天的日期。
                mSwitchDateTo.setText(mSwitchDateTo.getTag() == null ? mToday : mSwitchDateTo.getTag().toString());
                break;
            default:
                break;
        }
    }

    public int getMode() {
        return mMode;
    }

    public String getStoreId() {
        return mStoreId;
    }

    public void setStroreId(String id) {
        mStoreId = id;
    }

    public boolean isShowing() {
        if (null == mPopupWindow)
            return false;
        return mPopupWindow.isShowing();
    }

    public void setMixBegin(String dateFrom) {
        try {
            String[] ss = dateFrom.split("-");
            mDateFrom = dateFrom;
            mTextViewMixBegin.setText(ss[0] + "年" + ss[1] + "月" + ss[2] + "日");
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            mTextViewMixBegin.setText("error");
        }
    }

    public void setMixEnd(String dateTo) {
        try {
            String[] ss = dateTo.split("-");
            mDateTo = dateTo;
            mTextViewMixEnd.setText(ss[0] + "年" + ss[1] + "月" + ss[2] + "日");
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            mTextViewMixEnd.setText("error");
        }
    }

    public String getStore() {
        return mStore;
    }

    public void setStore(String store) {
        mStore = store;
        mTextViewStore.setText(store);
    }

    public String getDateFrom() {
        return mDateFrom;
    }

    public void setDateFrom(String dateFrom) {
        try {
            String[] ss = dateFrom.split("-");
            mDateFrom = dateFrom;
            mTextViewDateFrom.setText(ss[1] + "月" + ss[2] + "日");
//              mSanXiangPaoDateBegin.setText(ss[0]+"年"+ss[1] + "月" + ss[2] + "日");
            String guestFolioDate = mSwitchDateTo.getVisibility() == View.GONE ? dateFrom.substring(0, 7) : dateFrom;
            mSwitchDateFrom.setText(guestFolioDate);
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            mTextViewDateFrom.setText("error");
//              mSanXiangPaoDateBegin.setText("error");
        }
    }

    public String getDateTo() {
        return mDateTo;
    }

    public void setDateTo(String dateTo) {
        try {
            String[] ss = dateTo.split("-");
            mDateTo = dateTo;
            mTextViewDateTo.setText(ss[1] + "月" + ss[2] + "日");
//              mSanXiangPaoDateEnd.setText(ss[0]+"年"+ss[1] + "月" + ss[2] + "日");
            mSwitchDateTo.setText(dateTo);//客单数查询截止日期
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            mTextViewDateTo.setText("error");
//              mSanXiangPaoDateEnd.setText("error");
        }
    }

    public String getDateMonth() {
        return mDateMonth;
    }

    public void setDateMonth(String dateMonth) {
        try {
            String[] ss = dateMonth.split("-");
            mDateMonth = ss[0] + "-" + ss[1];
            mTextViewDateMonth.setText(ss[0] + "年" + ss[1] + "月");
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            mTextViewDateMonth.setText("error");
        }
    }

    public String getQueryMonth() {
        return mQueryMonth;
    }

    /**
     * 产品出入库查询 日期格式转换
     *
     * @param date 。。。
     */
    public void setQueryMonth(String date) {
        try {
            String[] ss = date.split("-");
            mQueryMonth = date;
            mTvGoodsInOutStockDesc.setText(ss[0] + "年" + ss[1] + "月");
        } catch (Exception e) {
            BaseAppManager.loger().info(e);
            mTvGoodsInOutStockDesc.setText("error");
        }
    }

    private int getStatusBarHeight() {
        Resources resources = mContext.getResources();
        int resourceId = resources.getIdentifier("status_bar_height", "dimen", "android");
        return resources.getDimensionPixelSize(resourceId);
    }

    private int getScreenWidth() {
        WindowManager manager = (WindowManager) mContext.getSystemService(Context.WINDOW_SERVICE);
        Display display = manager.getDefaultDisplay();
        return display.getWidth();
    }

    private int getScreenHeight() {
        WindowManager manager = (WindowManager) mContext.getSystemService(Context.WINDOW_SERVICE);
        Display display = manager.getDefaultDisplay();
        return display.getHeight();
    }

    public void show(View parent) {
        int statusHeight = getStatusBarHeight();
        int height = getScreenHeight();
        int titleHeight = parent.getHeight();

        mPopupWindow.setWidth(LayoutParams.MATCH_PARENT);
        mPopupWindow.setHeight(height - statusHeight - titleHeight);
        showAtLocation(parent, Gravity.TOP, 0, statusHeight + titleHeight);
    }

    public void show(View parent, boolean flag) {
        int statusHeight = getStatusBarHeight();
        int height = getScreenHeight();
        int titleHeight = parent.getHeight();

        mPopupWindow.setWidth(LayoutParams.MATCH_PARENT);
        mPopupWindow.setHeight(height - statusHeight - titleHeight);
        mPopupWindow.setFocusable(flag);
        showAtLocation(parent, Gravity.TOP, 0, statusHeight + titleHeight);
    }

    public void showAtLocation(View parent, int gravity, int x, int y) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        mViewParent = parent;
        mPopupWindow.showAtLocation(parent, gravity, x, y);
    }

    public void dismiss() {
        if (null != mPopupWindow) {
            mPopupWindow.dismiss();
        }
        if (null != mListPopupWindow) {
            mListPopupWindow.dismiss();
        }
    }

    @Override
    public void onClick(View v) {
        if (v == mSwitchDateFrom) {
            switch (((FolioTypeSetter) mContext).getFolioType()) {
                case 1://按月查询
                    new DatePickerYearMonthDialog(mContext, new DatePickerYearMonthDialog.OnDateSetListener() {
                        @Override
                        public void onDateSet(int year, int monthOfYear) {
                            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM", Locale.CHINA);
                            if (DateUtil.compareDate(year + "-" + String.format(Locale.CHINA, "%02d", monthOfYear + 1), sdf.format(new Date())) > 0) {
                                ((BaseActivity) mContext).showMsg("查询时间截止到本月");
                                return;
                            }
                            mDateMonth = year + "-" + String.format(Locale.CHINA, "%02d", monthOfYear + 1);//这里月份要发送出去的，格式上要2位数
                            mSwitchDateFrom.setText(year + "-" + String.format(Locale.CHINA, "%02d", monthOfYear + 1));
                        }
                    }).show();
                    break;
                case 2://按天
                    DateUtil.pickDialog(mContext, mSwitchDateFrom, getSwitchDateFormat());
                    break;
                default:
                    break;
            }
        } else if (v == mSwitchDateTo) {
            DateUtil.pickDialog(mContext, mSwitchDateTo, "yyyy-MM-dd");
        } else if (v == mLinearLayoutStore) {
            if (null != mStoreDateSelectorPopListener) {
                mStoreDateSelectorPopListener.onChooseStore();
            }
        } else if (v == mLinearLayoutLoginName) {
            mListPopupWindow.setAnchorView(mViewParent);
            mListPopupWindow.show();
        } else if (v == mLinearLayoutDateFT) {
            new SelectDatePop(mContext, new onDateSelectedListener() {

                @Override
                public void onDateSelect(String startDay, String endDay) {

                    try {
                        String[] ss = startDay.split("-");
                        String[] es = endDay.split("-");
                        mTextViewDateFrom.setText(ss[1] + "月" + ss[2] + "日");
                        mTextViewDateTo.setText(es[1] + "月" + es[2] + "日");
                    } catch (Exception e) {

                        BaseAppManager.loger().warn(e.toString());
                        mTextViewDateFrom.setText("error");
                        mTextViewDateTo.setText("error");
                    }
                    mDateFrom = startDay;
                    mDateTo = endDay;
                    if (null != mStoreDateSelectorPopListener) {
                        mStoreDateSelectorPopListener.onChooseDate(mStoreId, mStore, mUserID, mDateMonth, mDateFrom, mDateTo);
                    }
                }
            }).showWindow(mViewParent);
        } else if (v == mLinearLayoutDateMonth) {
            new DatePickerYearMonthDialog(mContext, new DatePickerYearMonthDialog.OnDateSetListener() {
                @Override
                public void onDateSet(int year, int monthOfYear) {
//                                 SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
//                                 Date date = new Date();
//                                 date.setYear(year - 1900);
//                                 date.setMonth(monthOfYear);
//                                 mDateMonth = sdf.format(date);
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM", Locale.CHINA);
                    //如果选的日期比本来的日期大（需求是不让查未来的销售记录）
                    if (DateUtil.compareDate(year + "-" + String.format(Locale.CHINA, "%02d", monthOfYear + 1), sdf.format(new Date())) > 0) {
                        ((BaseActivity) mContext).showMsg("查询时间截止到本月");
                        return;
                    }
                    mDateMonth = year + "-" + String.format(Locale.CHINA, "%02d", monthOfYear + 1);//这里月份要发送出去的，格式上要2位数
                    mTextViewDateMonth.setText(year + "年" + String.format(Locale.CHINA, "%02d", monthOfYear + 1) + "月");
                    //mTextViewDateMonth.setText(mDateMonth+"");
//                                 if(null != mStoreDateSelectorPopListener && mButtonSearch.getVisibility() == View.VISIBLE)
//
//                                 {
//                                 //如果有查询按钮，选了日期就先不查询，选好后点查询按钮再让它查询
//                                 mStoreDateSelectorPopListener.onChooseDate(mStoreId, mStore, mUserID, mDateMonth, mDateFrom, mDateTo);
//                                 }
                }
            }).show();
        } else if (v == mLinearLayoutMixBegin) {
            Calendar c = Calendar.getInstance();
            new DatePickerDialog(mContext, new DatePickerDialog.OnDateSetListener() {

                @Override
                public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                    mTextViewMixBegin.setText(String.format("%04d年%02d月%02d日", year, monthOfYear + 1, dayOfMonth));
                    mDateFrom = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                }
            }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();

        } else if (v == mLinearLayoutMixEnd) {
            Calendar c = Calendar.getInstance();
            c.add(Calendar.DAY_OF_YEAR,-1);
            DatePickerDialog dialog = new DatePickerDialog(mContext, new DatePickerDialog.OnDateSetListener() {

                @Override
                public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                    mTextViewMixEnd.setText(String.format("%04d年%02d月%02d日", year, monthOfYear + 1, dayOfMonth));
                    mDateTo = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
                    //针对vivo手机会无视setMax()限制的漏洞，再做一层限制
                    if(DateUtil.compareDate(mDateTo,new SimpleDateFormat("yyyy-MM-dd").format(new Date())) >= 0){
                        MyToast.show("所选日期最大为昨天");
                        mDateTo = new SimpleDateFormat("yyyy-MM-dd").format(view.getMaxDate());
                        mTextViewMixEnd.setText(new SimpleDateFormat("yyyy年MM月dd日").format( view.getMaxDate()));
                    }
                }
            }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH));
            //据说是服务端sql语句太复杂，所以要求截止日期控制在只能选到昨天，免得服务器崩了
            dialog.getDatePicker().setMaxDate(c.getTimeInMillis());
            dialog.show();
        }
//                          else if(v == mSanXiangPaoDateBegin){
//                                 Calendar c = Calendar.getInstance();
//                                 new DatePickerDialog(mContext, new DatePickerDialog.OnDateSetListener() {
//                                 @Override
//                                 public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
//                                                                                Date date = new Date();
//                                                                                date.setYear(year - 1900);
//                                                                                date.setMonth(monthOfYear);
//                                                                                date.setDate(dayOfMonth);
//                                                                                SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
//                                                                                String pickedDate = format.format(date);
//                                                                                mDateFrom = pickedDate;//传值
//                                                                                SimpleDateFormat showSdf = new SimpleDateFormat("yyyy年MM月dd日");
//                                                                                String showDate = showSdf.format(date);//显示
//                                                                                mSanXiangPaoDateBegin.setText(showDate);
//                                 }
//                                 }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), 1).show();
//                          }else if(v == mSanXiangPaoDateEnd){
//                                 Calendar c = Calendar.getInstance();
//                                 new DatePickerDialog(mContext, new DatePickerDialog.OnDateSetListener() {
//                                 @Override
//                                 public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
//                                                                                Date date = new Date();
//                                                                                date.setYear(year - 1900);
//                                                                                date.setMonth(monthOfYear);
//                                                                                date.setDate(dayOfMonth);
//                                                                                SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
//                                                                                String pickedDate = format.format(date);
//                                                                                mDateTo = pickedDate;//用来传值的Date
//                                                                                SimpleDateFormat showSdf = new SimpleDateFormat("yyyy年MM月dd日");
//                                                                                String showDate = showSdf.format(date);
//                                                                                mSanXiangPaoDateEnd.setText(showDate);//用来展示的Date
//                                 }
//                                 }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
//                          }
        else if (v == mButtonSearch) {
            //dismiss();
            if (null != mStoreDateSelectorPopListener) {
//                                                                                if(mIsAdmin && mTextViewStore.getText().equals("全部")) {
//                                        if(SystemHelper.NewInterface) {
//                                               mStoreId = "1";
//                                        }
//                                        else {
//                                               mStoreId = SystemHelper.LoginOrganId;
//                                        }
//                                                                                }
                                        /*if(DateUtil.parseDate(mDateFrom).getShowTime() - DateUtil.parseDate(mDateTo).getShowTime() > 0){
                                            Toast.makeText(mContext,"开始时间不能大于结束时间！",Toast.LENGTH_LONG).show();
                                        Calendar c = Calendar.getInstance();
                                        Date date = new Date();
                                        date.setDate(1);
                                        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
                                        mDateFrom = format.format(date);
                                        date.setDate(c.get(Calendar.DAY_OF_MONTH));
                                        mDateTo = format.format(date);
                                        mSanXiangPaoDateBegin.setText(mDateFrom);
                                        mSanXiangPaoDateEnd.setText(mDateTo);
                                        return ;
                                                                                }*/
                if (mMode == STORE_DATE_GUEST_FOLIO) {//因为这里用的DateUtil.pickDialog（）选择日期，所以没能返回到mDateFrom，所以直接从界面获取
                    SYLoger.print("mMode");
                    mDateFrom = mSwitchDateFrom.getText().toString();
                    mDateTo = mSwitchDateTo.getVisibility() == View.VISIBLE ? mSwitchDateTo.getText().toString() : "";
                    mDateMonth = mDateFrom.substring(0, 7);
                }
                if (mMode == STORE_DATE_GOODS_INOUT_STOCK) {
                    mStoreDateSelectorPopListener.onStartSearch(mStoreId, mStore, mUserID, mDateMonth, mQueryMonth, "");// 暂时先这样传mQueryMonth，后面再整改,去掉""
                    return;
                }
//                if (mMode == STORE_DATE_FROMTO_USER) {
//                    mDateMonth = String.format("%s月\t,", mDateMonth.replace("-", "年"));
//                    mStoreDateSelectorPopListener.onStartSearch(mStoreId, mStore, mUserID, mDateMonth, "", "");
//                    return;
//                }
                mStoreDateSelectorPopListener.onStartSearch(mStoreId, mStore, mUserID, mDateMonth, mDateFrom, mDateTo);
            }
        } else if (v == mRelativeLayoutQueryMonth) { // 日历：开始日期修改为日期，查询天数改为查询月份
//            Calendar c = Calendar.getInstance();
//            new MonPickerDialog(mContext, 0, new MonPickerDialog.OnDateSetListener() {
//                @Override
//                public void onDateSet(DatePicker startDatePicker, int startYear, int startMonthOfYear,
//                                      int startDayOfMonth) {
//                    mTvGoodsInOutStockDesc.setText(String.format(Locale.CHINA, "%04d年%02d月", startYear, startMonthOfYear + 1));
//                    mQueryMonth = String.format(Locale.CHINA, "%04d-%02d", startYear, startMonthOfYear + 1);
//                }
//            }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DATE)).show();
            new DatePickerYearMonthDialog(mContext, new DatePickerYearMonthDialog.OnDateSetListener() {
                @Override
                public void onDateSet(int year, int monthOfYear) {
                    mTvGoodsInOutStockDesc.setText(String.format(Locale.CHINA, "%04d年%02d月", year, monthOfYear + 1));
                    mQueryMonth = String.format(Locale.CHINA, "%04d-%02d", year, monthOfYear + 1);
                }
            }).show();
        } else if (v == mViewDismiss) {
//            dismiss();
            if (null != mStoreDateSelectorPopListener) {
                mStoreDateSelectorPopListener.onDismiss();
            }
        }
    }

    public LinearLayout getLinearLayoutLoginName() {
        return mLinearLayoutLoginName;
    }

    public interface StoreDateSelectorPopListener {
        public void onChooseStore();// should has a argument like for store,but
        // for common component storeacticity;

        public void onChooseDate(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo);

        public void onStartSearch(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo);

        public void onDismiss();
    }

    /**
     * 用来把客单数查询的查询方式type传回DatabaseActivity
     */
    public interface FolioTypeSetter {
        int getFolioType();

        void setFolioType(int type);
    }
}
