package com.urovo.activity.customercare.ui

import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.customercare.net.CustomerCareRes
import com.urovo.activity.customercare.view.CustomerCareListDetailAct
import com.urovo.wugumofang.R
import org.jetbrains.anko.find

/**
 *  @author XP on 2019/8/22.
 */
class CustomerCareListAdapter(val context: Context, var dataList: List<CustomerCareRes.ResultInfo>?) : RecyclerView.Adapter<CustomerCareHolder>() {

    override fun onBindViewHolder(holder: CustomerCareHolder, pos: Int) {
        holder.apply {
            dataList?.get(pos)?.let {
                val item = it
                careName.apply { text = if (item.taskName != null) item.taskName.toString() else "--";setTextColor(Color.BLACK) }
                careNumber.apply { text = item.pendingCareCount.toString().plus("人待关怀");setTextColor(Color.GRAY) }

                rightArrow.visibility = View.VISIBLE
                itemRoot.setOnClickListener {
                    context.startActivity(Intent(context, CustomerCareListDetailAct::class.java).apply {
                        putExtra(CustomerCareListDetailAct.INTENT_ID, item.id.toString())
                    })
                }
            }
        }
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): CustomerCareHolder {
        return CustomerCareHolder(LayoutInflater.from(context).inflate(R.layout.ll_customer_care_list_item, parent, false))
    }
}

class CustomerCareHolder(view: View) : RecyclerView.ViewHolder(view) {
    var itemRoot: ViewGroup
    var careName: TextView
    var careNumber: TextView
    var rightArrow: ImageView

    init {
        itemRoot = view.find<ViewGroup>(R.id.itemRoot)
        careName = view.find<TextView>(R.id.careName)
        careNumber = view.find<TextView>(R.id.careNumber)
        rightArrow = view.find<ImageView>(R.id.rightArrow)
    }
}