package com.urovo.activity.customerlabel.presenter

import com.urovo.activity.customerlabel.model.CustomerLabelDetailEntity
import com.urovo.activity.customerlabel.model.CustomerLabelEntity
import com.urovo.activity.customerlabel.model.CustomerLabelSubmitEntity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.base.mvp.AbsView


interface CustomerLabelContract {

    interface IView : AbsView {
        /**
         * 标签信息表分页列表
         */
        fun labelListData(data: CustomerLabelEntity?) {}

        /**
         * 标签信息详情分页列表
         */
        fun labelListDetailData(data: CustomerLabelDetailEntity?) {}

        /**
         * 保存顾客标签状态
         */
        fun saveLabelDetailStatus(status: Boolean) {}
    }

    interface IPresenter : BasePresenter {
        /**
         * post /crm-api/label/page/list 获取标签信息表分页列表
         */
        fun requestLabelList(page: Int)

        /**
         * post /crm-api/labelDetail/page/list 获取标签信息详情分页列表
         */
        fun requestLabelDetailList(mobile: String?, page: Int)

        /**
         * post /exhibit/addSubmition 新增提报数据
         */
        fun requestSaveLabelDetail(customerLabelSubmitList: List<CustomerLabelSubmitEntity>)
    }
}

