package com.urovo.activity.customerlabel.service

import com.urovo.activity.customerlabel.model.*
import com.urovo.wugumofang.net.RetrofitHelper
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 * 顾客标签仓库
 * @author LW
 */
class CustomerLabelRepository {

    private val mApiService by lazy {
        RetrofitHelper.createNewApi(ApiService::class.java)
    }

    /**
     * 获取标签信息表分页列表
     * @param page Int 页码
     * @param size Int 页数
     */
    fun requestLabelList(page: Int, size: Int): Call<RequestResult<CustomerLabelEntity>> {
        return mApiService.labelList(CustomerLabelReqEntity(page, size))
    }

    /**
     * 获取标签信息详情分页列表
     * @param mobile String 手机号
     * @param page Int 页码
     * @param size Int 页数
     */
    fun requestLabelDetailList(
        mobile: String?,
        page: Int,
        size: Int
    ): Call<RequestResult<CustomerLabelDetailEntity>> {
        return mApiService.labelDetailList(CustomerLabelDetailReqEntity(mobile, page, size))
    }

    /**
     * 新增提报数据
     * @param data String
     */
    fun requestSaveLabelDetail(
        list: List<CustomerLabelSubmitEntity>?
    ): Call<RequestResult<Any>> {
        return mApiService.saveLabelDetail(list)
    }
}