package com.urovo.activity.data;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.wgmf.AsyncTask.QueryJiFenDuiHuanLiuShuiTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.entitys.JiFenDuiHuanLiuShuiEntity;
import com.urovo.wgmf.entity.response.JiFenDuiHuanLiuShuiResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;

import java.util.ArrayList;
import java.util.List;

/**
 * 积分兑换流水查询
 *
 * @author ...
 */
@Route(path = RouterParams.Member.QUERY_CREDIT_STATEMENT)
public class QueryCreditStatement extends DataBaseActivity {
    private List<BaseModel> mBaseModel = new ArrayList<BaseModel>();

    @Override
    protected BaseExpandableListAdapter newExpandableAdapter() {
        return null;
    }

    @Override
    protected boolean isExpandableList() {
        return false;
    }

    @Override
    protected String getTitleText() {

        return "积分兑换流水查询";
    }

    @Override
    protected int getPopupWindowMode() {

        return StoreDateSelectorPop.STORE_DATE_MIX;
    }

    @Override
    protected BaseAdapter newBaseAdapter() {

        return new MyAdapter(mBaseModel, this);
    }

    @Override
    protected void requestConnectTask() {

        // new QueryJiFenDuiHuanLiuShuiTask(this, "正在查询...", true,
        // mStoreId,mDateFrom,mDateTo).execute("");
    }

    @Override
    protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {

        if (null == dateFrom || null == dateTo) {
            return;
        }
        try {
            // mSql = id + ";";
            // mSql += dateFrom.replaceAll("-", "") + ";";
            // mSql += dateTo.replaceAll("-", "") + ";";
            // requestConnectTask();
            new QueryJiFenDuiHuanLiuShuiTask(this, "正在查询...", true, id, dateFrom, dateTo).execute("");
        } catch (Exception e) {
            showMsg("date or date format is wrong");
            //Toast.makeText(this, "date or date format is wrong", 1000).show();
            BaseAppManager.loger().info(e);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        mTextViewDate.setText(mDateTo + "至" + mDateTo);
        search(mStoreId, null, null, null, mDateTo, mDateTo);// for one day
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
        if (null != response) {
            JiFenDuiHuanLiuShuiResponse res = (JiFenDuiHuanLiuShuiResponse) response;
            if ("0".equals(res.getRet()) && res != null && res.getList() != null && res.getList().size() > 0) {

                List<JiFenDuiHuanLiuShuiEntity> entitys = res.getList();
                mBaseModel.clear();
                // if (null != entitys && entitys.size() > 0)
                // {
                for (int i = 0; i < entitys.size(); i++) {
                    JiFenDuiHuanLiuShuiEntity entity = entitys.get(i);
                    BaseModel cell = new BaseModel();
                    cell.mDate = entity.exchDate;
                    cell.mMember = entity.moblie;
                    cell.mStore = entity.storeName;
                    cell.mScore = entity.ptsNumber;
                    cell.mProduct = entity.prodName;
                    cell.mNums = entity.exchNumber;
                    mBaseModel.add(cell);
                }
                // }
            } else {
                mBaseModel.clear();
            }
            mMyAdapter.notifyDataSetInvalidated();
        }
    }

    private class BaseModel {
        String mDate;
        String mMember;
        String mStore;
        String mScore;
        String mProduct;
        String mNums;
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

            if (null == convertView) {
                convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_jifenliushui, null);
            }
            TextView date = (TextView) convertView.findViewById(R.id.textViewDate);
            TextView mem = (TextView) convertView.findViewById(R.id.textViewMember);
            TextView store = (TextView) convertView.findViewById(R.id.textViewStore);
            TextView score = (TextView) convertView.findViewById(R.id.textViewScore);
            TextView product = (TextView) convertView.findViewById(R.id.textViewProduct);
            TextView nums = (TextView) convertView.findViewById(R.id.textViewNums);
            BaseModel cell = mBaseModel.get(position);
            date.setText(cell.mDate);
            mem.setText(cell.mMember);
            store.setText(cell.mStore);
            score.setText(cell.mScore);
            product.setText(cell.mProduct);
            nums.setText(cell.mNums);
            return convertView;
        }

    }
}