package com.urovo.activity.data

import android.os.Bundle
import android.text.TextUtils
import android.view.View
import android.widget.RadioButton
import android.widget.RadioGroup
import android.widget.TextView
import com.urovo.activity.addsellactivity.ui.AutoRadioGroup
import com.urovo.activity.common.DatePickerYearMonthDialog
import com.urovo.wgmf.entity.response.KeDanShuChaXunResponse
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DialogHelper
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.android.synthetic.main.folio_act.*
import kotlinx.android.synthetic.main.folio_all_static_layout.*
import kotlinx.android.synthetic.main.folio_date_select_pop.*
import okhttp3.Request
import org.jetbrains.anko.find
import java.text.SimpleDateFormat
import java.util.*

/**
 * @author Sasuke on 2018-12-4.
 * 带标签分类的新 客单查询
 *
 * 算了就随便改改得了，快发版了，也懒得分什么模块了。
 */
class QueryGuestFolio : BaseActivity() {
    var radioGroup: AutoRadioGroup? = null
    var queryType: String = "1"//查询类型 0按天查询 1按月查询（默认按月查询）
    var brandType: String = "1"//品牌类型 0全部 1五谷 2散装

    val labels = arrayOf(LABEL_ALL, LABEL_WGMF, LABEL_SZ)
    var loadWait: LoadWaitDominator? = null

    companion object {
        const val LABEL_ALL = "全部"//全部标签
        const val LABEL_WGMF = "五谷磨房"//五谷磨房
        const val LABEL_SZ = "散装"//散装
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.folio_act)
        start()
    }

    fun start() {
        initTitle()
        titleTextView.text = "客单查询"
        loadWait = LoadWaitDominator(this, containerLayout)
        topDateLayout.setOnClickListener {
            folio_pop_view.visibility = View.VISIBLE
        }
        //主界面显示初始化
        dateTitleTv.text = SimpleDateFormat("yyyy-MM", Locale.CHINA).format(Date())
        storeNameTv.text = SystemHelper.LoginOrganName
        //弹窗显示初始化
        popStoreNameTv.text = SystemHelper.LoginOrganName
        switchDate1.text = SimpleDateFormat("yyyy-MM", Locale.CHINA).format(Date())
        //按月查询 和 按天查询 切换
        switchRadios.setOnCheckedChangeListener { group, checkedId ->
            when (checkedId) {
                R.id.radio_by_month -> {
                    queryType = "1"
                    zhi.visibility = View.GONE
                    switchDate2.visibility = View.GONE
                    switchDate2.tag = switchDate2.text.toString()
                    switchDate2.text = ""
                    switchDate1.tag = switchDate1.text.toString()
                    switchDate1.text = switchDate1.text.toString().substring(0, 7)
                }
                R.id.radio_by_day -> {
                    queryType = "0"
                    zhi.visibility = View.VISIBLE
                    switchDate2.visibility = View.VISIBLE
                    switchDate2.text = switchDate2.tag?.toString()
                            ?: SimpleDateFormat("yyyy-MM-dd", Locale.CHINA).format(Date())
                    switchDate1.text = switchDate1.tag?.toString()
                            ?: SimpleDateFormat("yyyy-MM-dd", Locale.CHINA).format(Date())
                }
            }
        }
        //选择起始日期
        switchDate1.setOnClickListener {
            if (radio_by_month.isChecked) {//按月查询
                DatePickerYearMonthDialog(this, DatePickerYearMonthDialog.OnDateSetListener { year, monthOfYear ->
                    val sdf = SimpleDateFormat("yyyy-MM", Locale.CHINA)
                    if (DateUtil.compareDate("${year}-${String.format(Locale.CHINA, "%02d", monthOfYear + 1)}", sdf.format(Date())) > 0) {
                        showMsg("查询时间截止到本月")
                        return@OnDateSetListener
                    }
                    switchDate1.text = "${year}-${String.format(Locale.CHINA, "%02d", monthOfYear + 1)}"//这里月份要发送出去的，格式上要2位数
                }).show()
            } else if (radio_by_day.isChecked) {//按天查询
//                DateUtil.pickDialog(this, switchDate1, "yyyy-MM-dd")
                DialogHelper.alertDatePicker(this, switchDate1).datePicker.maxDate = Calendar.getInstance().getTimeInMillis()
            }
        }
        //选择日期（按天查询）
        switchDate2.setOnClickListener {
//            DateUtil.pickDialog(this, switchDate2, "yyyy-MM-dd")
            DialogHelper.alertDatePicker(this, switchDate2).datePicker.maxDate = Calendar.getInstance().getTimeInMillis()
        }
        //弹窗点击搜索
        buttonSearch.setOnClickListener {
            if (checkDate()) {
                queryData(brandType, queryType)
                folio_pop_view.visibility = View.GONE
                refreshDateTitleShow()
            }
        }
        viewDismiss.setOnClickListener { folio_pop_view.visibility = View.GONE }

        //把品牌标签初始化放在最后做，因为里面涉及到网络请求。
        initLabelView()
    }

    fun refreshDateTitleShow() {
        dateTitleTv.text = when (queryType) {
            "0" -> "${switchDate1.text}至${switchDate2.text}"
            "1" -> switchDate1.text.toString()
            else -> ""
        }
    }

    //初始化标签栏
    fun initLabelView() {
        //初始化过滤标签容器
        radioGroup = AutoRadioGroup(filterLabelContainer)
        labels.forEach { labelText ->
            //以下三句：1、创建radioButton 2、在radioGroup里添加radioButton并创建监听，3、创建对应该radioButton的Fragment
            val radio: RadioButton = (layoutInflater.inflate(R.layout.final_sales_radio_button, filterLabelContainer, false) as RadioButton)
            radioGroup?.addViewWithLayoutParams(
                    radio,
                    labelText, arrayOf(4, 0, 4, 0),
                    RadioGroup.LayoutParams.WRAP_CONTENT,
                    RadioGroup.LayoutParams.WRAP_CONTENT, false) { pos ->
                brandType = pos.toString()
                queryData(brandType, queryType)
            }
        }
        (filterLabelContainer.getChildAt(1) as RadioButton).isChecked = true
    }


    /**
     * 校验选择的日期是否合法
     */
    fun checkDate(): Boolean {
        val dateFrom = switchDate1.text.toString()
        val dateTo = switchDate2.text.toString()
        if (radio_by_month.isChecked) {//按月就不用检查下面的了
            return true
        }

        if (!TextUtils.isEmpty(dateFrom) && !TextUtils.isEmpty(dateTo)) {
            if (DateUtil.parseDate(dateFrom).time - DateUtil.parseDate(dateTo).time > 0) {
                showMsg("开始时间不能大于结束时间！")
                return false
            }
            if (Math.abs(DateUtil.diffDate(DateUtil.parseDate(dateFrom), DateUtil.parseDate(dateTo))) > 31) {
                showMsg("时间段不能超过31天！")
                return false
            }
        }
        return true
    }


    /**
     * 查询
     * brandType: 品牌类型 0全部 1五谷 2食补集
     * queryType: 查询类型 0按天查询 1按月查询（默认按月查询）
     */
    fun queryData(brandType: String, queryType: String) {
        loadWait?.show(LoadWaitDominator.LOADING)
        val dateFrom = switchDate1.text.toString()
        val dateTo = switchDate2.text.toString()

        OkHttpDominator.postAsyn(NetParam.SALEKEDAN,
                mapOf("shopId" to SystemHelper.LoginOrganId,
                        "brandType" to brandType,//产品品牌过滤标签
                        "queryType" to queryType,//按月还是按天查询
                        "ym" to dateFrom,
                        "startDay" to dateFrom,//如果queryType是按月查，其它后面两个参数就没用了，所以可以随便传
                        "endDay" to dateTo), object : OkHttpDominator.ResultCallback<KeDanShuChaXunResponse>() {
            override fun onError(request: Request?, e: Exception?) {
                if (isFinishing) return
                loadWait?.show(LoadWaitDominator.NET_ERROR)
                e?.printStackTrace()
            }

            override fun onResponse(res: KeDanShuChaXunResponse?) {
                if (isFinishing) return
                loadWait?.dismissAll()
                if (res?.msgCode != 0) {
                    loadWait?.show(res?.msgInfo ?: "网络异常")
                }
                if (res?.resultInfo == null) {
                    loadWait?.show(LoadWaitDominator.NO_DATA)
                }

                inflateData(brandType, res?.resultInfo)
            }
        })

    }

    /**
     * 填充数据
     */
    fun inflateData(brandType: String, bean: KeDanShuChaXunResponse.Bean?) {
        when (brandType) {
            "0", "1" -> {//全部 或 五谷磨房
                arrayOf(oneTitle, twoTitle, threeTitle, fourTitle).forEach {
                    it.visibility = View.VISIBLE
                }

                oneOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "总客单数"; find<TextView>(R.id.unitData).text = bean?.totalConsumNum }
                oneTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "新会员客单数"; find<TextView>(R.id.unitData).text = bean?.newMemberNum }
                oneThree.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "老会员客单数"; find<TextView>(R.id.unitData).text = bean?.oldMemberNum }

                twoOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "同比增长率"; find<TextView>(R.id.unitData).text = bean?.consNumTongbi }
                twoTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "平均客单价"; find<TextView>(R.id.unitData).text = bean?.avgMoney }
                twoThree.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "30元以上新客加微"; find<TextView>(R.id.unitData).text = bean?.newWeiMemberNum30 }

                threeOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "客单数"; find<TextView>(R.id.unitData).text = bean?.lowMoneyNum }
                threeTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "同比增长率"; find<TextView>(R.id.unitData).text = bean?.lowMoneyNumTongbi }
//                threeThree.run { visibility = View.VISIBLE ; find<TextView>(R.id.unitTitle).text = "平均客单价"; find<TextView>(R.id.unitData).text = bean?.avgMoney}

//                folioHoriLine.visibility = View.VISIBLE

                fourOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "客单数"; find<TextView>(R.id.unitData).text = bean?.midMoneyNum }
                fourTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "同比增长率"; find<TextView>(R.id.unitData).text = bean?.midMoneyNumTongbi }

                fiveOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "客单数"; find<TextView>(R.id.unitData).text = bean?.highMoneyNum }
                fiveTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "同比增长率"; find<TextView>(R.id.unitData).text = bean?.highMoneyNumTongbi }
            }
            //散装===========================================
            else -> {
                arrayOf(oneTitle, twoTitle, threeTitle, fourTitle).forEach {
                    it.visibility = View.GONE
                }

                oneOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "总客单数"; find<TextView>(R.id.unitData).text = bean?.totalConsumNum }
                oneTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "平均客单价"; find<TextView>(R.id.unitData).text = bean?.avgMoney }
                oneThree.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "老会员客单数"; find<TextView>(R.id.unitData).text = bean?.oldMemberNum*/ }

                twoOne.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "客单数同比"; find<TextView>(R.id.unitData).text = bean?.consNumTongbi }
                twoTwo.run { visibility = View.VISIBLE; find<TextView>(R.id.unitTitle).text = "客单数环比"; find<TextView>(R.id.unitData).text = bean?.consNumHuanbi }
                twoThree.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "200元以上"; find<TextView>(R.id.unitData).text = bean?.highMoneyNum*/ }

                threeOne.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "客单数同比"; find<TextView>(R.id.unitData).text = bean?.consNumTongbi*/ }
                threeTwo.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "客单数环比"; find<TextView>(R.id.unitData).text = bean?.consNumHuanbi*/ }
//                threeThree.run { visibility = View.GONE ; /*find<TextView>(R.id.unitTitle).text = "平均客单价"; find<TextView>(R.id.unitData).text = bean?.avgMoney*/}

//                folioHoriLine.visibility = View.GONE

                fourOne.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "植物益生元八珍销售盒数"; find<TextView>(R.id.unitData).text = bean?.pushProductNum*/ }
                fourTwo.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "植物益生元八珍客单数"; find<TextView>(R.id.unitData).text = bean?.pushProductConsNum*/ }

                fiveOne.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "植物益生元八珍客单数占比"; find<TextView>(R.id.unitData).text = bean?.pushProductConsRate*/ }
                fiveTwo.run { visibility = View.GONE; /*find<TextView>(R.id.unitTitle).text = "伴侣客单数占比"; find<TextView>(R.id.unitData).text = bean?.withMateConsRate*/ }
            }
        }


    }

}