package com.urovo.activity.data;

import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.wgmf.AsyncTask.QueryHuiYuanXiaoShouZhanBiTask;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.HuiYuanXiaoShouZhanBiResponse;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 会员销售占比查询
 * @author ...
 */
@Route(path = RouterParams.Member.QUERY_MEMBER_SALES_COMPARED)
public class QueryMemberSalesCompared extends DataBaseActivity {
	private List<BaseModel> mBaseModel = new ArrayList<BaseModel>();
	private Map<String, String> params = new HashMap<String, String>();

	@Override
	protected BaseExpandableListAdapter newExpandableAdapter() {
		return null;
	}

	@Override
	protected boolean isExpandableList() {
		return false;
	}

	@Override
	protected String getTitleText() {

		return "会员销售占比查询";
	}

	@Override
	protected int getPopupWindowMode() {

		return StoreDateSelectorPop.STORE_DATE_MIX;
	}

	@Override
	protected BaseAdapter newBaseAdapter() {

		return new MyAdapter(mBaseModel, this);
	}

	@Override
	protected void requestConnectTask() {

		new QueryHuiYuanXiaoShouZhanBiTask(this, "正在查询...", true, params).execute("");
	}

	@Override
	protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {

		if(null == dateFrom || null == dateTo)
			return;
		if(!mIsAdmin) {
			params.put("organizationCode", null);
		}
		else {
			params.put("organizationCode", SystemHelper.LoginOrganId);
		}
		params.put("storeId", id);
		params.put("userId", SystemHelper.LoginUserId);
		params.put("startTimeStr", dateFrom);
		params.put("endTimeStr", dateTo);
		requestConnectTask();
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		search(mStoreId, mUserID, null, null, mDateFrom, mDateTo);
	}

	@Override
	public void displayResult(String tag, BaseResponse response) {

		super.displayResult(tag, response);
		if(null != response) {
			HuiYuanXiaoShouZhanBiResponse res = (HuiYuanXiaoShouZhanBiResponse) response;
			if (res.returnBean!=null){
				List<HuiYuanXiaoShouZhanBiResponse.HuiYuanXiaoShouZhanBiList> entity = res.returnBean.returnList;
				mBaseModel.clear();
				if(null != entity) {
					for (int i = 0; i < entity.size(); i++) {
						{
							BaseModel cell = new BaseModel();
							cell.mName = "新会员总金额";
							cell.mData = entity.get(i).newMemberConsumeAmount;
							mBaseModel.add(cell);
						}
						{
							BaseModel cell = new BaseModel();
							cell.mName = "老会员总金额";
							cell.mData = entity.get(i).oldMemberConsumeAmount;
							mBaseModel.add(cell);
						}
						{
							BaseModel cell = new BaseModel();
							cell.mName = "会员总金额";
							cell.mData = entity.get(i).allMemberConsumeAmount;
							mBaseModel.add(cell);
						}
						{
							BaseModel cell = new BaseModel();
							cell.mName = "新会员消费占比";
							cell.mData = entity.get(i).newMemberConsumeRate;
							mBaseModel.add(cell);
						}
						{
							BaseModel cell = new BaseModel();
							cell.mName = "老会员消费占比";
							cell.mData = entity.get(i).oldMemberConsumeRate;
							mBaseModel.add(cell);
						}
						{
							BaseModel cell = new BaseModel();
							cell.mName = "会员消费占比";
							cell.mData = entity.get(i).allMemberConsumeRate;
							mBaseModel.add(cell);
						}
					}
					mMyAdapter.notifyDataSetInvalidated();
				}
			}else {
				showEmpty();
				if(mBaseModel!=null){
					mBaseModel.clear();
				}
				if(mMyAdapter!=null) {
					mMyAdapter.notifyDataSetInvalidated();
				}
			}
		}
	}

	private class BaseModel {
		String mName;
		String mData;
	}

	private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
		public MyAdapter(List<BaseModel> lists, Context context) {
			super(lists, context);
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {

			if(null == convertView) {
				convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_kedan, null);
			}
			TextView name = (TextView) convertView.findViewById(R.id.textView1);
			TextView data = (TextView) convertView.findViewById(R.id.textView2);

			BaseModel cell = mBaseModel.get(position);
			name.setText(cell.mName);
			data.setText(cell.mData);
			return convertView;
		}
	}
}