package com.urovo.activity.data.queryfinalsales.net

import com.urovo.wugumofang.response.Base3Response


data class FinalSalesRes(val resultInfo: ResultInfo?) : Base3Response() {
    data class ResultInfo(
            var saleAllProducts: List<SaleAllProduct>?,//全部
            var saleWGProducts: List<SaleWGProduct>?,//磨粉产品
            var flowWGProducts: List<FlowWGProducts>?,//流量产品
            var saleXDYProducts: List<SaleXDYProduct>?,//鲜稻研
            var saleHYXSProducts: List<SaleXDYProduct>?//会员商品销售

    ) {
        open class FinalSaleProduct {
            var productId: String = ""//产品ID
            var productName: String = ""//产品名
            var productNum: Double? = 0.0//产品数量 or 重量
            var amount: Double? = 0.0//产品总价
            var amountRate: String? = ""//销售占比
            var tbRate: String? = ""//同比
            var hbRate: String? = ""//环比
            var brandId: Int? = -1//8五谷磨房， 13鲜稻研
            var list: Any? = null //据说不用管。。。。测试数据返回的全是null。。。

        }

        //磨粉产品
        class SaleWGProduct() : FinalSaleProduct()

        //流量产品
        class FlowWGProducts() : FinalSaleProduct()

        //鲜稻研
        class SaleXDYProduct() : FinalSaleProduct()

        //全部
        class SaleAllProduct() : FinalSaleProduct()
    }
}