package com.urovo.activity.data.queryfinalsales.presenter

import com.urovo.activity.data.QueryFinalProductSales
import com.urovo.activity.data.queryfinalsales.net.FinalSalesRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request
import java.text.SimpleDateFormat
import java.util.*

/**
 * @author Sasuke on 2018/6/7.
 */
class FinalSalesPre(var mView: FinalSalesContract.view) : FinalSalesContract.pre {

    /**暂存结果列表*/
    var listsetTmp: FinalSalesRes.ResultInfo? = null
    /**过滤标签*/
    var filterLabels: MutableSet<String>? = mutableSetOf(
            QueryFinalProductSales.ALL,
            QueryFinalProductSales.WGMF
            /*QueryFinalProductSales.XDY,
            QueryFinalProductSales.HYXS*/)


    init {
        mView.setPresenter(this)
    }

    override fun start() {
        mView.init()
        mView.query()
    }

    /**
     * 请求数据
     */
    fun queryData(startYmd: String, endYmd: String, shopId: String) {
        mView.showLoading()
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SALE_PRODUCT_DETAIL,
                mapOf("startYmd" to startYmd, "endYmd" to endYmd, "shopId" to shopId),
                object : OkHttpDominator.ResultCallback<FinalSalesRes>() {
                    override fun onError(request: Request?, e: Exception?) {
                        e?.printStackTrace()
                        mView.showNetError()
                    }

                    override fun onResponse(res: FinalSalesRes?) {
                        if (res == null || res.resultInfo == null) {
                            mView.showNoData()
                            return
                        }
                        listsetTmp = res.resultInfo//暂时存起来，然后切换标签的时候直接切换数据，不用请求。
                        mView.refreshShow(res.resultInfo)
                    }
                })
    }

    /**
     * 获取当前月第一天。
     */
    fun getMonthFirstDay(): String {
        return SimpleDateFormat("yyyy-MM-dd").format(DateUtil.getFirstDayOfMonth(0))
    }

    /**
     * 获取当前月最后一天。
     */
    fun getMonthLastDay(): String {
        return SimpleDateFormat("yyyy-MM-dd").format(DateUtil.getLastDayOfMonth(0))
    }

    /**
     * 获取当天
     */
    fun getToday(): String{
        return SimpleDateFormat("yyyy-MM-dd").format(Date())
    }

}