package com.urovo.activity.data.querymyweivip.view.activity;


import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.google.android.material.tabs.TabLayout;
import com.google.gson.Gson;
import com.lsjwzh.widget.recyclerviewpager.TabLayoutSupport;
import com.urovo.activity.data.querymyweivip.model.SweepCodeDetailListEntity;
import com.urovo.activity.data.querymyweivip.presenter.SweepCodeDetailPre;
import com.urovo.activity.data.querymyweivip.view.adapter.SweepCodeDetailViewPagerAda;
import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.view.ViewPager;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivityTap;
import com.urovo.wugumofang.data.ObjectSaveUtil;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.SpacesItemDecoration;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.CommonEntity;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * User: lemonade(823307073@qq.com)
 * Date: 2017/05/19
 * Time: 00:23
 * 查看扫码加粉明细 页面
 */
public class SweepCodeDetailAct extends BaseActivityTap implements CommonController.View {
    private final static int mToday = 0;
    private final static int mYestoday = -1;
    public SweepCodeDetailPre mSweepCodeDetailPre;
    @BindView(R.id.tap_button_left)
    RadioButton mTapButtonLeft;
    @BindView(R.id.tap_button_right)
    RadioButton mTapButtonRight;
    @BindView(R.id.tap_radio)
    RadioGroup mTapRadio;
    @BindView(R.id.viewpager)
    ViewPager mRecyclerView;
    @BindView(R.id.tabs)
    TabLayout mTabLayout;
    @BindView(R.id.tv_non_Match_reason)
    TextView mNonMatchReason;
    @BindView(R.id.tv_storesInfo)
    TextView mStoresInfo;
    @BindView(R.id.scd_loading_pb)
    ProgressBar mProgressBar;

    private Map<String, String> mParams = new HashMap<String, String>();
    private List<SweepCodeDetailListEntity.IsNewListEntity> conformity;//符合
    private List<SweepCodeDetailListEntity.IsNotNewListEntity> inconformity;//不符合
    private SweepCodeDetailViewPagerAda mAdapter;
    private SharedPreferences.Editor mEditor;
    Unbinder unbinder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_sweep_code_detail);
        unbinder = ButterKnife.bind(this);
        mSweepCodeDetailPre = new SweepCodeDetailPre(this);
        mSweepCodeDetailPre.start();//入口
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    /***
     * 模拟数据
     *
     * @param json ...
     */
    private void testRequestData(String json) {
        SweepCodeDetailListEntity mResultInfo = new Gson().fromJson(json, SweepCodeDetailListEntity.class);
        if (mResultInfo != null) {
            conformity = mResultInfo.isNewList;//符合
            inconformity = mResultInfo.isNotNewList;//不符合
            mEditor = ObjectSaveUtil.saveObject(SweepCodeDetailAct.this, mResultInfo);// 只有请求成功拿到数据才发送
        }
    }

    /**
     * 数据调用的入口（网络请求）
     */
    @Override
    public void requestData(int day) {
        if (mProgressBar != null) {
            mProgressBar.setVisibility(View.VISIBLE);
        }
        //请求参数
        mParams.put("staffId", SystemHelper.LoginUserId);
        mParams.put("shopId", SystemHelper.LoginOrganId);
        mParams.put("ymd", mSweepCodeDetailPre.sweepCodeDetailDate(day, "yyyy-MM-dd"));// 默认今天的日期（后台需要的日期格式）);
        mSweepCodeDetailPre.start2requestData(mParams);// 开始请求
    }

    /**
     * 默认初始化门店/日期信息（显示今天的日期和当前登录的门店地址）
     *
     * @param day 默认显示今天的日期，传值0 （0:今天 / 1：昨天）
     */
    @Override
    public void initStoresDateInfo(int day) {
        mStoresInfo.setText(
                String.format("%s\t,\t%s",
                        mSweepCodeDetailPre.sweepCodeDetailDate(day, "yyyy年MM月dd日"),// 默认今天的日期（页面需要显示的日期格式）
                        SystemHelper.LoginUserName
                ));
    }

    /**
     * 初始化标题tab
     */
    @Override
    public void initTitleTab() {
        super.initTitle();//返回键的设置

        mTapButtonLeft.setText("昨天");
        mTapButtonRight.setText("今天");
        mTapButtonRight.setTextColor(getResources().getColor(android.R.color.black));
        mTapButtonLeft.setChecked(false);
        mTapButtonRight.setChecked(true);

        mTapRadio.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, final int checkedId) {
                switch (checkedId) {
                    case R.id.tap_button_left://昨天
                        if (mEditor != null) {
                            mEditor.clear();// 每次刷新前清除数据
                        }
                        requestData(mYestoday);//正式数据
                        if (mTabLayout.getChildCount() > 1) {
                            mTabLayout.getTabAt(0).setText("符合新客进塘（" + conformity.size() + "）");
                            mTabLayout.getTabAt(1).setText("不符合新客进塘（" + inconformity.size() + "）");
                        }
                        mTapButtonLeft.setTextColor(getResources().getColor(android.R.color.black));
                        mTapButtonRight.setTextColor(getResources().getColor(android.R.color.white));
                        mRecyclerView.smoothScrollToPosition(0);
                        initStoresDateInfo(mYestoday);
                        mAdapter.notifyDataSetChanged();//刷新viewpager
                        break;

                    case R.id.tap_button_right://今天
                        if (mEditor != null) {
                            mEditor.clear();// 每次刷新前清除数据，默认第一次不清除
                        }
                        requestData(mToday);//正式数据
                        if (mTabLayout.getChildCount() > 1) {
                            mTabLayout.getTabAt(0).setText("符合新客进塘（" + conformity.size() + "）");
                            mTabLayout.getTabAt(1).setText("不符合新客进塘（" + inconformity.size() + "）");
                        }
                        mTapButtonLeft.setTextColor(getResources().getColor(android.R.color.white));
                        mTapButtonRight.setTextColor(getResources().getColor(android.R.color.black));
                        mRecyclerView.smoothScrollToPosition(0);
                        initStoresDateInfo(mToday);
                        mAdapter.notifyDataSetChanged();//刷新viewpager
                        break;
                }
            }
        });
    }

    @Override
    public void initViewPager() {
        LinearLayoutManager layout = new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false);
        mRecyclerView.setLayoutManager(layout);
        mAdapter = new SweepCodeDetailViewPagerAda(getSupportFragmentManager(), mTabLayout, conformity, inconformity);
        mRecyclerView.setAdapter(mAdapter);
        mRecyclerView.setHasFixedSize(true);
        mRecyclerView.setLongClickable(true);
        if (mRecyclerView.getAdapter() != null) {
            mRecyclerView.addItemDecoration(new SpacesItemDecoration(50, mRecyclerView.getAdapter().getItemCount()));
        }
        mRecyclerView.addOnPageChangedListener(new ViewPager.OnPageChangedListener() {
            @Override
            public void OnPageChanged(int oldPosition, int newPosition) {
                switch (newPosition) {
                    //符合
                    case 0:
                        mTabLayout.setTabTextColors(Color.BLACK, Color.parseColor("#ffb919"));
                        mNonMatchReason.setVisibility(View.GONE);
                        break;
                    //不符合
                    case 1:
                        mTabLayout.setTabTextColors(Color.BLACK, Color.parseColor("#ffb919"));
                        mNonMatchReason.setVisibility(View.VISIBLE);
                        break;
                    default:
                        break;
                }
            }
        });
    }

    @Override
    public void initTabLayout() {
        //添加tablayout 之间的分割线
        assert mTabLayout != null;
        LinearLayout linearLayout = (LinearLayout) mTabLayout.getChildAt(0);
        linearLayout.setShowDividers(LinearLayout.SHOW_DIVIDER_MIDDLE);
        linearLayout.setDividerDrawable(ContextCompat.getDrawable(this, R.drawable.layout_divider_vertical));
    }

    /**
     * 请求成功后回调的数据
     *
     * @param resultInfo ...
     */
    @Override
    public void onResponseSuccess(CommonEntity resultInfo) {
        if (resultInfo != null) {
            if (mProgressBar != null) {
                mProgressBar.setVisibility(View.GONE);
            }
            SweepCodeDetailListEntity sweepCodeDetailentity = resultInfo.sweepCodeDetailentity;
            conformity = sweepCodeDetailentity.isNewList;//符合
            inconformity = sweepCodeDetailentity.isNotNewList;//不符合
            mEditor = ObjectSaveUtil.saveObject(SweepCodeDetailAct.this, sweepCodeDetailentity);// 只有请求成功拿到数据才发送
            mAdapter.notifyDataSetChanged();// 拿到数据及时更新页面显示
            //给TabLayout增加Tab, 并关联ViewPager
            if (mTabLayout != null && mAdapter != null && mRecyclerView != null) {
                TabLayoutSupport.setupWithViewPager(mTabLayout, mRecyclerView, mAdapter);
            }
        }
    }

    @Override
    public void onFailure(String failInfo) {
        if (mProgressBar != null) {
            mProgressBar.setVisibility(View.GONE);
        }
        BaseAppManager.loger().error(failInfo);
        MyToast.show(failInfo);
        if (mEditor != null) {
            mEditor.clear();// 每次刷新前清除数据
        }
    }
}
