package com.urovo.activity.data.queryproductsales.view;

import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.fragment.app.Fragment;

import com.google.gson.Gson;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.data.NewDataBaseActivity;
import com.urovo.activity.data.queryproductsales.model.MonthSaleProductEntity;
import com.urovo.activity.data.queryproductsales.presenter.MonthSaleProductPre;
import com.urovo.wgmf.CommonController;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.wgmf.trade.model.bean.CommonEntity;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.HashMap;
import java.util.Map;

/**
 * @author chenji
 * @date 2017/6/23
 * 销售业绩----产品月销量查询
 */

public class MonthSaleProductAct extends NewDataBaseActivity implements CommonController.MonthSaleProductView {
    public MonthSaleProductFra mFragment;
    private MonthSaleProductPre mMonthSaleProductPre;
    private Map<String, String> mParams = new HashMap<>();
    /**
     * 月销售（MonthSaleAct）页面传递过来，只有两个，门店：0；会员商城：1；单独打开页面：-1
     */
    private int index;
    /**
     * 区别门店--》全部 五谷磨房 鲜稻研 会员商城 这四个类别
     */
    private String brand;
    /**
     * 月销售（MonthSaleAct）页面 的日期
     */
    @SuppressWarnings("all")
    private String currentDate;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        index = this.getIntent().getIntExtra("index", AppConstants.SalesPerformance.DEFAULT_STORE);
        brand = this.getIntent().getStringExtra("brand");
        currentDate = this.getIntent().getStringExtra("currentDate");

//      =================另外页面跳转过来需要的初始化数值==============
        if (index == AppConstants.SalesPerformance.DEFAULT_STORE) {
            index = AppConstants.SalesPerformance.STORE;
            brand = AppConstants.BRAND.ALL_PRO;
        } else {
            tempCurrentDate = currentDate;
            //初始化日历TextView，同步数据
            mCurrentDate.setText(tempCurrentDate);
        }
//      ==================另外页面跳转过来需要的初始化数值==============

        mMonthSaleProductPre = new MonthSaleProductPre(this, index, brand);
        mMonthSaleProductPre.start();
        //初始化 门店/会员商城按钮
        onChooseBtnColor(index, brand);
        if (index == AppConstants.SalesPerformance.STORE) {
            mHorizontalLine.setVisibility(View.VISIBLE);
            mBrandPro.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected String getTitleText() {
        return "产品月销量查询";
    }

    @Override
    protected int getPopupWindowMode() {
        return StoreDateSelectorPop.STORE_DATE_MONTH;
    }

    @Override
    protected void lastMonth() {
        PreferHelper.getInstance().remove(AppConstants.SalesPerformance.MONTH_SALE_PRODUCT_ACT);
        requestData(index, brand);
    }

    @Override
    protected void calendarDate() {
        PreferHelper.getInstance().remove(AppConstants.SalesPerformance.MONTH_SALE_PRODUCT_ACT);
        requestData(index, brand);
    }

    @Override
    protected void nextMonth() {
        PreferHelper.getInstance().remove(AppConstants.SalesPerformance.MONTH_SALE_PRODUCT_ACT);
        requestData(index, brand);
    }

    @Override
    protected void onDestroy() {
        PreferHelper.getInstance().remove(AppConstants.SalesPerformance.MONTH_SALE_PRODUCT_ACT);
        super.onDestroy();
    }

    @Override
    public void onResponseSuccess(CommonEntity resultInfo, int index, String brand) {
        ViewUtil.dismissProgress();
        if (resultInfo != null) {
            MonthSaleProductEntity entity = resultInfo.monthSaleProductEntity;
            SYLoger.print("wgmf--产品月销售查询--entity--" + entity);
            final String monthSaleProductEntity = new Gson().toJson(entity);
            PreferHelper.getInstance().setString(AppConstants.SalesPerformance.MONTH_SALE_PRODUCT_ACT, monthSaleProductEntity);
            mFragment = (MonthSaleProductFra) selectFragment(index, brand);
        }
    }

    @Override
    public void onFailure(String failInfo) {
        ViewUtil.dismissProgress();
        Log.e("wgmf--产品月销售查询:", "onFailure: " + failInfo);
    }

    @Override
    public void requestData(int index, String brand) {
        if (NetHelper.IsHaveInternet(this)) {
            ViewUtil.showProgress(this, "正在玩命加载...", "请稍等...");
            //当前的日期
            mParams.put("ym", tempCurrentDate);
            // 登录的门店ID
            mParams.put("shopId", SystemHelper.LoginOrganId);
            mParams.put("staffId", SystemHelper.LoginUserId);
            SYLoger.print("wgmf-->产品月销量查询: 当前日期--" + tempCurrentDate);
            mMonthSaleProductPre.start2requestData(mParams, index, brand);
            //插入需要切换的索引，请求成功后调用，选择是门店还是会员商城
//            mMonthSaleProductPre.insert(index);
        } else {
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
        }
    }

    /**
     * 门店/会员商城按钮颜色选择
     *
     * @param index ...
     */
    private void onChooseBtnColor(int index, String brand) {
        switch (index) {
            case AppConstants.SalesPerformance.STORE:
                onChooseColors(mSalesStoreBtn, mSalesVIPMallBtn);

                //初始化选中门店的全部按钮
                if (SystemHelper.isWgmf(brand)) {
                    mWgmfPro.setChecked(true);
                }
                else if (AppConstants.BRAND.BULK_PRO.equals(brand)) {
                    mXdyPro.setChecked(true);
                } else if (AppConstants.BRAND.ALL_PRO.equals(brand)) {
                    mAllPro.setChecked(true);
                } else {
                    SYLoger.print("品牌名配置有问题！");
                }
                break;
            case AppConstants.SalesPerformance.MENBER_MALL_STORE:
                if (brand.equals(AppConstants.BRAND.VIP_PRO)) {
                    onChooseColors(mSalesVIPMallBtn, mSalesStoreBtn);
                }
                break;
            default:
                break;
        }
    }

    /**
     * 打开fragment页面
     *
     * @param position ...
     * @return ...
     */
    public Fragment selectFragment(int position, String brand) {
        PreferHelper.getInstance().setInt(AppConstants.SalesPerformance.MONTH_SALE_INDEX, position);
        PreferHelper.getInstance().setString(AppConstants.SalesPerformance.MONTH_SALE_BRAND, brand);
        return this.showFragment(R.id.query_product_sales_container,
                MonthSaleProductFra.class);
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
        final int id = v.getId();
        switch (id) {
            //门店
            case R.id.query_product_sales_store:
                mBrandPro.setVisibility(View.VISIBLE);

                //index 设值 为了前后按钮同步数据
                onChooseBtnColor(index = AppConstants.SalesPerformance.STORE, TextUtils.isEmpty(brand) || AppConstants.BRAND.VIP_PRO.equals(brand) ? brand = AppConstants.BRAND.ALL_PRO : brand);
                if (mFragment != null) {
                    //切换Recycleview适配器，刷新数据,默认全部
                    mFragment.notifyDataSetChanged(index, brand);
                }
                break;
            //会员商品
            case R.id.query_product_sales_VIP_mall:
                mBrandPro.setVisibility(View.GONE);
                onChooseBtnColor(index = AppConstants.SalesPerformance.MENBER_MALL_STORE, brand = AppConstants.BRAND.VIP_PRO);
                if (mFragment != null) {
                    //切换Recycleview适配器，刷新数据
                    mFragment.notifyDataSetChanged(index, brand);
                }
                break;
            case R.id.all_pro:
                if (mFragment != null) {
                    //切换Recycleview适配器，刷新数据
                    mFragment.notifyDataSetChanged(AppConstants.SalesPerformance.STORE, brand = AppConstants.BRAND.ALL_PRO);
                }
                break;
            case R.id.wgmf_pro:
                if (mFragment != null) {
                    //切换Recycleview适配器，刷新数据
                    mFragment.notifyDataSetChanged(AppConstants.SalesPerformance.STORE, brand = "磨粉产品");
                }
                break;
                case R.id.flow_pro:
                if (mFragment != null) {
                    //切换Recycleview适配器，刷新数据
                    mFragment.notifyDataSetChanged(AppConstants.SalesPerformance.STORE, brand = "流量产品");
                }
                break;
            case R.id.xdy_pro:
                if (mFragment != null) {
                    //切换Recycleview适配器，刷新数据
                    mFragment.notifyDataSetChanged(AppConstants.SalesPerformance.STORE, brand = AppConstants.BRAND.BULK_PRO);
                }
                break;
            default:
                break;
        }
    }
}
