package com.urovo.activity.display.model


/**
 * 查询货架陈列上报任务明细
 *
RetInfo«ExhibitMissionDetail» {
msgCode (integer, optional): 状态码,状态码等于0说明成功 ,
msgInfo (string, optional): 状态说明 ,
resultInfo (ExhibitMissionDetail, optional): 结果集
}ExhibitMissionDetail {
audit (integer, optional): 审核（0：未审核，1：已审核） ,
ehqs (Array[ExhibitQuestions], optional): 问题列表 ,
ema (ExhibitMissionAudit, optional): 审核记录 ,
ems (ExhibitMissionSubmit, optional): 提交记录 ,
status (integer, optional): 状态（0：未提交，1：已提交） ,
type (integer, optional): 是否可整改(0：不可整改，1：可整改)
}ExhibitQuestions {
title (string, optional): 标题 ,
type (string, optional): 题目类型 ,
values (Array[string], optional): 选项
}ExhibitMissionAudit {
auditId (string, optional): 审核id ,
auditRemark (string, optional): 审核备注 ,
auditStatus (string, optional): 审核（0：未审核，1：已审核） ,
excepSpec (string, optional): 异常说明 ,
exportImages (Array[string], optional): 导出照片 ,
submitTime (string, optional): 提交时间 ,
wholeImages (Array[string], optional): 整体照片
}ExhibitMissionSubmit {
createTime (string, optional): 提交时间 ,
excepSpec (string, optional): 异常说明 ,
exportImages (Array[string], optional): 导出照片 ,
id (string, optional): id ,
list (Array[ExhibitMissionConfig], optional): 配置数据 ,
productInfo (string, optional): 产品明细/门店信息 ,
reportId (string, optional): reportId ,
reporterId (string, optional): 提交人工号 ,
reporterName (string, optional): 提交人姓名 ,
stockout (integer, optional): 缺货（0：不缺货，1：缺货） ,
stockoutInfo (string, optional): 缺货信息 ,
wholeImages (Array[string], optional): 整体照片
}ExhibitMissionConfig {
emcDescription (string, optional): 描述 ,
photoUrl (string, optional): 实例图片 ,
projectName (string, optional): 项目名称 ,
sortNo (string, optional): 序号
}
 */
data class DisplayReportDetailEntity(
    var audit: Int,
    var ehqs: List<Ehqs>?,
    var ema: Ema?,
    var ems: Ems?,
    var status: Int,
    var type: Int
) {
    data class Ehqs(
        var type: String,
        var title: String,
        var modelId: String,
        var content: String,
        var values: List<Option>?
    ) {
        data class Option(var checked:String,var value: String, var optId: String)
    }

    data class Ema(
        var auditId: String,
        var auditRemark: String,
        var auditStatus: String,
        var excepSpec: String,
        var exportImages: List<String>?,
        var submitTime: String,
        var wholeImages: List<String>?
    )

    data class Ems(
        var id: String,
        var reportId: String,
        var reporterId: String,
        var reporterName: String,
        var createTime: String,
        var list: List<EmaList>?,
        var productInfo: String,
        var stockout: Int,
        var stockoutInfo: String,
        var excepSpec: String,
        var wholeImages: List<String>?,
        var exportImages: List<String>?
    ) {
        data class EmaList(
            var sortNo: String,
            var projectName: String,
            var emcDescription: String,
            var photoUrl: String
        )
    }
}