package com.urovo.activity.display.model

import com.chad.library.adapter.base.entity.AbstractExpandableItem
import com.chad.library.adapter.base.entity.MultiItemEntity
import com.urovo.activity.display.view.adapter.DisplayReportAdapter
import java.io.Serializable

/**
 * 查询货架陈列上报任务
 *
RetInfo«List«ExhibitShop»» {
msgCode (integer, optional): 状态码,状态码等于0说明成功 ,
msgInfo (string, optional): 状态说明 ,
resultInfo (Array[ExhibitShop], optional): 结果集
}ExhibitShop {
shopId (string, optional): 门店号 ,
shopName (string, optional): 门店名称 ,
tasks (Array[ExhibitTask], optional): 任务列表
}ExhibitTask {
audit (integer, optional): 审核（0：未审核，1：已审核） ,
remark (string, optional): 前端展示直接用这个 ,
status (integer, optional): 状态（0：未提交，1：已提交） ,
taskId (string, optional): 任务id ,
taskName (string, optional): 任务名称 ,
type (integer, optional): 是否可整改(0：不可整改，1：可整改)
}
 */
data class DisplayReportEntity(
    var shopId: String,
    var shopName: String,
    var tasks: List<TasksBean>?
) {

    data class TasksBean(
        var audit: Int,
        var remark: String,
        var status: Int,
        var taskId: String,
        var taskName: String,
        var type: Int
    )
}


data class DisplayReportGroup(
    var shopId: String,
    var shopName: String
) : AbstractExpandableItem<TasksChild>(), MultiItemEntity {

    override fun getItemType(): Int = DisplayReportAdapter.TYPE_LEVEL_0

    override fun getLevel(): Int = 0
}

data class TasksChild(
    var shopId:String,
    var shopName: String,
    var audit: Int,
    var remark: String,
    var status: Int,
    var taskId: String,
    var taskName: String,
    var type: Int
) : MultiItemEntity,Serializable {
    override fun getItemType(): Int = DisplayReportAdapter.TYPE_LEVEL_1
}