package com.urovo.activity.display.model

import com.xp.pro.imagepickerlib.bean.ImageItem
import java.util.*
import kotlin.collections.ArrayList


/**
 * 查询门店陈列任务
 *
 * RetInfo«ExhibitMission» {
msgCode (integer, optional): 状态码,状态码等于0说明成功 ,
msgInfo (string, optional): 状态说明 ,
resultInfo (ExhibitMission, optional): 结果集
}ExhibitMission {
auditStatus (integer, optional): 审核状态, 1待提交、2待审核可修改、3已审核可整改、4整改后待审核、5整改后已审核、6免提交 ,
detailId (integer, optional): 门店任务id ,
endTime (string, optional): 结束时间 ,
isSpecial (integer, optional): 是否特殊，0否，1是 ,
missionName (string, optional): 任务名称 ,
missionRemark (string, optional): 任务备注 ,
missionType (integer, optional): 任务类别，1常规，2活动 ,
shopStatus (integer, optional): 门店状态, 1待提交、2待审核可修改、3已审核可整改、4可再次整改、5免提交、6已截止 ,
startTime (string, optional): 开始时间 ,
storeName (string, optional): 门店名称 ,
storeNo (string, optional): 门店号 ,
submitList (Array[ExhibitSubmit], optional)
}ExhibitSubmit {
detailId (integer, optional): 门店任务id ,
endTime (string, optional): 结束时间 ,
missionName (string, optional): 任务名称 ,
missionRemark (string, optional): 任务备注 ,
remark (string, optional): 提报说明 ,
shopStatus (integer, optional): 门店状态, 1待提交、2待审核可修改、3已审核可整改、4可再次整改、5免提交、6已截止 ,
submitId (integer, optional): 编号 ,
submitType (integer, optional): 提交类型，1提报，2整改 ,
updateTime (string, optional): 更新时间 ,
urls (Array[string], optional),
userName (string, optional): 名字 ,
userNo (string, optional): 工号
}
 */
data class InspectorDisplayEntity(
    var auditStatus: String,
    var detailId: String,
    var startTime: String,
    var endTime: String,
    var isSpecial: String,
    var missionName: String,
    var storeName: String,
    var storeNo: String,
    var shopStatus: String,
    var missionRemark: String?,
    var submitList: List<SubmitBean>?
) {

    data class SubmitBean(
        var detailId: String,
        var remark: String,
        var submitId: String,
        var submitType: String,
        var updateTime: String,
        var endTime: String?,
        var missionRemark: String?,
        var userNo: String,
        var userName: String,
        var missionName: String?,
        var shopStatus: String,
        var shopId: String,
        var shopName: String,
        var urls: List<String>?
    ) {
        constructor() : this(
            "", "", "", "", "", "",
            "", "", "", "", "", "", "", null
        )

        var storeImageSelectList: ArrayList<ImageItem> = ArrayList()
    }
}
