package com.urovo.activity.display.view.widget

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.urovo.activity.display.model.DisplayReportDetailEntity
import com.urovo.activity.display.model.DisplayReportSubmitEntity
import com.urovo.activity.display.view.holder.SingleChooseHolder
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.ConstantParams
import org.jetbrains.anko.find

/**
 * 单选选择View
 * @author LW
 */
class SingleChooseWidget {

    private var mOption: DisplayReportDetailEntity.Ehqs.Option? = null

    private var mEhqs: DisplayReportDetailEntity.Ehqs? = null

    private var mSelectView: View? = null

    /**
     * 获取单选数据
     * @return DisplayReportSubmitEntity.AnswersBean
     */
    fun getSingleChooseData(): DisplayReportSubmitEntity.AnswersBean? {
        if (mOption != null) {
            mEhqs?.let {
                if (mOption?.checked == ConstantParams.CONSTANT_PARAMS_1) {
                    return DisplayReportSubmitEntity.AnswersBean(
                        it.content, it.modelId,
                        listOf(mOption!!.optId), it.type
                    )
                }
            }
        }
        return null
    }

    fun init(
        context: Context,
        data: DisplayReportDetailEntity.Ehqs,
        listener: OnSingleChooseClickListener?
    ): View {
        this.mEhqs = data

        val singleChooseParent: View = LayoutInflater.from(context)
            .inflate(R.layout.list_item_display_single_choose, null, false)

        singleChooseParent.find<TextView>(R.id.item_display_title_tv)
            .apply {
                text = data.title
                tag = data.modelId
            }
        val containerLl =
            singleChooseParent.find<LinearLayout>(R.id.item_display_container_Ll)
        if (containerLl.childCount > 0) {
            containerLl.removeAllViews()
        }
        data.values?.forEachIndexed { index, value ->

            val singleChooseChild = LayoutInflater.from(context)
                .inflate(
                    R.layout.list_item_display_single_choose_child,
                    null,
                    false
                )

            singleChooseChild.tag = SingleChooseHolder().apply {

                chooseRbIv =
                    singleChooseChild.find<ImageView>(R.id.item_display_choose_rb_iv)
                        .apply {
                            if (value.checked == ConstantParams.CONSTANT_PARAMS_1) {
                                //选中
                                setBackgroundResource(R.drawable.circle_orange)
                                mOption = value
                                mSelectView = singleChooseChild
                            } else {
                                //未选中
                                setBackgroundResource(R.drawable.circle_gray)
                            }
                            tag = value
                        }
                chooseRbTv =
                    singleChooseChild.find<TextView>(R.id.item_display_choose_rb_tv)
                        .apply {
                            text = value.value
                        }

                singleChooseChild.setOnClickListener { view ->
                    if (mSelectView != view) {
                        mSelectView?.tag?.let {
                            (it as SingleChooseHolder).apply {
                                chooseRbIv?.setBackgroundResource(R.drawable.circle_gray)
                                (chooseRbIv?.tag as DisplayReportDetailEntity.Ehqs.Option)
                                    .checked=ConstantParams.CONSTANT_PARAMS_0
                            }
                        }
                    }
                    view.tag?.let {
                        (it as SingleChooseHolder).apply {
                            val option=chooseRbIv?.tag as DisplayReportDetailEntity.Ehqs.Option
                            if (option.checked == ConstantParams.CONSTANT_PARAMS_1) {
                                chooseRbIv?.setBackgroundResource(R.drawable.circle_gray)
                                option.checked = ConstantParams.CONSTANT_PARAMS_0

                                if (mSelectView == view) {
                                    mSelectView = null
                                    mOption=null
                                }
                            } else {
                                chooseRbIv?.setBackgroundResource(R.drawable.circle_orange)
                                option.checked = ConstantParams.CONSTANT_PARAMS_1

                                mSelectView = view
                                mOption=option
                            }
                            listener?.onSingleChooseClick(mOption)
                        }
                    }
                }
            }
            containerLl.addView(singleChooseChild)
        }
        return singleChooseParent
    }

    interface OnSingleChooseClickListener {
        fun onSingleChooseClick(option: DisplayReportDetailEntity.Ehqs.Option?)
    }
}