package com.urovo.activity.eatmanager.pre;

import com.urovo.wgmf.entity.response.ShiChiQueryResponse;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.net.RetrofitHelper;

import java.util.List;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * Created by Sasuke on 2017/6/26.
 */

public class EatManagerPre implements EatManagerCon.pre{
    EatManagerNet eatManagerNet;
    EatManagerCon.view mView;

    public EatManagerPre(EatManagerCon.view mView) {
        this.eatManagerNet = RetrofitHelper.createApi(EatManagerNet.class);
        this.mView = mView;
        this.mView.setPresenter(this);
    }

    @Override
    public void start() {

    }

    /**
     * 获取试吃数据
     */
    public void queryEat(String storeNo,String beginYMD,String endYMD){
        eatManagerNet.queryEat(storeNo,beginYMD,endYMD).enqueue(new Callback<ShiChiQueryResponse>() {
            @Override
            public void onResponse(Call<ShiChiQueryResponse> call, Response<ShiChiQueryResponse> response) {
                if(response.body() == null){
                    return;
                }
                ShiChiQueryResponse res = response.body();
                List<ShiChiQueryResponse.ResultInfoBean> list = res.getResultInfo();
                if (list == null || list.size() == 0) {
                    mView.showDataType(1);
                    mView.showMsg("无试吃数据");
                    return;
                } else {
                    mView.showDataType(0);
                }
                mView.setAdapter(list);
                double count = 0;
                for (int i = 0; i < list.size(); i++) {
                    double co = list.get(i).getTasteQty();
                    count = Arith.add(count, co);
                }
                mView.refreshEatCount(count);
            }

            @Override
            public void onFailure(Call<ShiChiQueryResponse> call, Throwable t) {

            }
        });

    }

    /**
     * 提交试吃数据
     */
    public void submitEat(){

    }
}
