package com.urovo.activity.goodsmanager;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.common.OrderGoodsChoseActivity;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.adapter.AllotGoodsAdapter;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.dao.Djdb001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djdb002DbOperate;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wgmf.db.dao.entitys.StoreOrderProduct;
import com.urovo.wgmf.db.dao.entitys.DiaoBoChuHuoEntity;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.R;

/**
 * 调入调出
 * 
 * @author Administrator
 *
 */
public class AllotGoodsActivity extends BaseActivity {

	private ListView listview;
	private ShopEntity inShopEntity;
	private ShopEntity outShopEntity;
	private TextView inStore;
	private TextView outSotre;
	private List<ProductEntity> list = new ArrayList<ProductEntity>(); // 保存调拨出货产品信息
	private AllotGoodsAdapter adapter;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.allotgoods_inout);
		init();
		initTitle();
		titleTextView.setText("调入调出");
	}

	private void init() {
		listview = (ListView) findViewById(R.id.listview);
		inStore = (TextView) findViewById(R.id.in_store);
		outSotre = (TextView) findViewById(R.id.out_store);
		adapter = new AllotGoodsAdapter(list, AllotGoodsActivity.this);
		listview.setAdapter(adapter);

	}

	public void storeSelectorIn(View view) {
		Intent intent = new Intent(AllotGoodsActivity.this, StoreSelectorActivity.class);
		startActivityForResult(intent, 1);
	}

	public void storeSelectorOut(View view) {
		Intent intent = new Intent(AllotGoodsActivity.this, StoreSelectorActivity.class);
		startActivityForResult(intent, 2);
	}

	public void transferOutSubmit(View view) {
		List<ProductEntity> choice = new ArrayList<ProductEntity>();
		for (ProductEntity p : list) {
			if(p.getTQTY() > 0) {
				choice.add(p);
			}
		}
		if(choice.size() <= 0) {
			showMsg("您没有选择任何调拨产品!");
			return;
		}
		if(outShopEntity == null) {
			showMsg("您没有选择调出门店!");
			return;
		}
		if(inShopEntity == null) {
			showMsg("您没有选择调入门店!");
			return;
		}
		Date date = new Date();
		DiaoBoChuHuoEntity ent = new DiaoBoChuHuoEntity();
		ent.setStoreId(outShopEntity.getShopId());
		ent.setTStoreId(inShopEntity.getShopId());
		ent.setBill(SystemHelper.LoginOrganId + DateUtil.format(date, "yyMMddHHmmss"));
		ent.setOper_Lr(SystemHelper.LoginUserId);
		ent.setLr_Name(SystemHelper.LoginUserName);
		ent.setWDate(DateUtil.getDateByFormat(date, "yyyy-MM-dd HH:mm:ss"));
		ent.setDBNum(choice.size());
		if(Djdb001DbOperate.SaveDiaoBoChuKu(ent) && Djdb002DbOperate.SaveDiaoBoChuKuDetail(ent.getBill(), choice)) {
			showMsg("保存调拨数据成功!");
		}
		else {
			showMsg("保存调拨数据失败!");
			return;
		}
		list.clear();
		adapter.notifyDataSetChanged();
	}

	public void goodsAllot(View view) {
		Intent intent = new Intent(AllotGoodsActivity.this, OrderGoodsChoseActivity.class);
		intent.putExtra(OrderGoodsChoseActivity.Search_type, OrderGoodsChoseActivity.type_Sale);
		startActivityForResult(intent, 1);
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {

		super.onActivityResult(requestCode, resultCode, data);
		switch (resultCode) {
		case StoreSelectorActivity.RESULTCODE:
			if(requestCode == 1) {
				inShopEntity = (ShopEntity) data.getSerializableExtra("store");
				if(inShopEntity != null) {
					inStore.setText(inShopEntity.getShopName());
				}
			}
			else {
				outShopEntity = (ShopEntity) data.getSerializableExtra("store");
				if(outShopEntity != null) {
					outSotre.setText(outShopEntity.getShopName());
				}
			}
			break;
		case OrderGoodsChoseActivity.activityResultCode:
			StoreOrderProduct sop = (StoreOrderProduct) data.getSerializableExtra(OrderGoodsChoseActivity.activityResultData);
			ProductEntity pe = new ProductEntity();
			pe.setAmount(sop.price * sop.qty);
			pe.setPrice(sop.price);
			pe.setItemId(sop.itemId);
			pe.setItemName(sop.itemName);
			pe.setKCUom(sop.unit);
			pe.setDHPack(sop.dpPack);
			CheckList(pe);
			break;
		default:
			break;
		}
	}

	private void CheckList(ProductEntity ent) {
		boolean exist = false;
		for (ProductEntity p : list) {
			if(p.getItemId().equals(ent.getItemId())) {
				exist = true;
				p.setTQTY(Arith.add(p.getTQTY(), 1));
				p.setAmount(Arith.add(p.getAmount(), ent.getAmount()));
				if(DalCommon.CanEditAmount(ent.getItemId())) {
					p.setPrice(Arith.add(p.getPrice(), ent.getPrice()));
				}
				break;
			}
		}
		if(!exist) {
			list.add(0, ent);
		}
		adapter.notifyDataSetChanged();
	}

}
