package com.urovo.activity.goodsmanager;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager.LayoutParams;
import android.widget.DatePicker;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.TextView;

import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.wgmf.adapter.AllotGoodsQueryAdapter;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wgmf.entity.response.DiaoBoQueryRes;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import okhttp3.Request;

/**
 * 调拨查询
 *
 * @author Administrator
 */
public class AllotGoodsActivityQuire extends BaseActivity {

    private LinearLayout storeSelector;
    private TextView storequire;
    private TextView texttitle;
    private TextView allotdatefrom;
    private TextView allotdateto;
    private RadioButton allotto;
    private RadioButton allotreceive;
    private TextView store;
    private String storeid;
    private String beginTime, endTime;
    private List<DiaoBoQueryRes.Bean> resultList = new ArrayList<>();
//    private List<DiaoBoQueryRes.Bean> listSH;
    private TextView resaulttext;
    private ListView resaultlist;
    private PopupWindow pw;
    private View showColor;
    private boolean hasQuery = false;
    private TextView noDataText;
    private LinearLayout noNetLayout;
    private AllotGoodsQueryAdapter adapter;
    public static int PRO_OUT = 0;//出库
    public static int PRO_IN = 1;//收货


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.normal2_quire_resault);
        initTitle();
        init();
    }

    private void init() {
        titleTextView.setText("调拨查询");
        resaulttext = (TextView) findViewById(R.id.result_tv);
        resaultlist = (ListView) findViewById(R.id.listview_quire_resault);
        noDataText = (TextView) findViewById(R.id.no_data_text);
        noNetLayout = (LinearLayout) findViewById(R.id.no_net_layout);
        adapter = new AllotGoodsQueryAdapter(this,resultList);
        resaultlist.setAdapter(adapter);
    }

    private void showPopWindow() {

        if (pw == null) {
            View v2 = getLayoutInflater().inflate(R.layout.allotgoods_quire, null);
            initWindow(v2);
            pw = new PopupWindow(v2, LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT, true);
            pw.setFocusable(false);
            pw.setBackgroundDrawable(new BitmapDrawable());
            pw.setOutsideTouchable(false);
            showColor.setOnClickListener(new OnClickListener() {

                @Override
                public void onClick(View v) {

                    if (!hasQuery) {
                        return;
                    }
                    if (pw != null && pw.isShowing()) {
                        pw.dismiss();
                    }
                }
            });
        } else {
            showColor.setBackgroundColor(AllotGoodsActivityQuire.this.getResources().getColor(R.color.result_view));
        }
        pw.showAsDropDown(titleTextView);
    }

    private void initWindow(View v) {
        storequire = (TextView) v.findViewById(R.id.ordergoods_quire);
        storequire.setText("查询门店:" + SystemHelper.LoginOrganName);
        storeid = SystemHelper.LoginOrganId;
        allotdatefrom = (TextView) v.findViewById(R.id.allot_date_from);
        allotdateto = (TextView) v.findViewById(R.id.allot_date_to);
        String date = DateUtil.getDate(new Date());
        beginTime = date;
        endTime = date;
        allotdatefrom.setText(beginTime);
        allotdateto.setText(endTime);
        allotto = (RadioButton) v.findViewById(R.id.allot_to);
        allotto.setChecked(true);
        allotreceive = (RadioButton) v.findViewById(R.id.allot_receive);
        showColor = v.findViewById(R.id.out_view);

    }

    public void allotQuire(View view) {
        query();
    }

    public void query() {
        resaultlist.setVisibility(View.GONE);
        HashMap param = new HashMap();
        param.put("storeNo",SystemHelper.LoginOrganId);
        param.put("beginDate",beginTime);
        param.put("endDate",endTime);
        ViewUtil.showProgress(this,"请稍等","正在查询调拨....");
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.ALLOT_GOODS_QUIRE,param,
                new OkHttpDominator.ResultCallback<DiaoBoQueryRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg("网络异常，查询失败");
                    }

                    @Override
                    public void onResponse(DiaoBoQueryRes res) {
                        ViewUtil.dismissProgress();
                        if(res == null){
                            showMsg("后台返回null");
                            return;
                        }
                        if(res.msgCode != 0){
                            showMsg(res.msgInfo);
                            return;
                        }
                        //如果有数据
                        resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
                        if (pw != null && pw.isShowing()) {
                            pw.dismiss();
                        }
                        resultList.clear();
                        resultList.addAll(res.getResultInfo());
                        int type = allotto.isChecked()?PRO_OUT : PRO_IN;
                        adapter.setType(type);
                        Iterator it = resultList.iterator();
                        //按选择的查询条件，把不需要的数据过滤掉。
                        while(it.hasNext()){
                            if((type == PRO_IN  && ((DiaoBoQueryRes.Bean)it.next()).getProInQty() == 0)
                                    || (type == PRO_OUT && ((DiaoBoQueryRes.Bean)it.next()).getProOutQty() == 0)){
                                it.remove();
                            }
                        }
                        resaultlist.setVisibility(View.VISIBLE);
                        adapter.notifyDataSetChanged();
                    }
                });
//        allotto.isChecked()// 调拨出库
//        String sql;
//        String outOrIn;
//        if (!allotto.isChecked()) {
//            outOrIn = "left join stock_location loc on loc.id=sw.lot_stock_id " + "left join stock_move m on loc.id = m.location_dest_id	" + "left join stock_warehouse sw1 on sw1.lot_stock_id = m.location_id ";
//        } else {
//            outOrIn = "left join stock_location loc on loc.id=sw.lot_stock_id " + "left join stock_move m on loc.id = m.location_id	" + "left join stock_warehouse sw1 on sw1.lot_stock_id = m.location_dest_id ";
//        }
//            sql = outOrIn + "left join sale_shop s1 on s1.warehouse_id = sw1.id " + "left join stock_picking pi on m.picking_id = pi.id " + "left join product_product p on m.product_id = p.id " + "left join res_users u on m.write_uid = u.id " + "left join res_partner pa on u.partner_id = pa.id "
//                    + " where s.stores_no='" + SystemHelper.LoginOrganId + "' and m.origin='DRDC' and to_char(m.date + interval '8 hour','yyyy-MM-dd') >= '" + beginTime + "' and to_char(m.date + interval '8 hour','yyyy-MM-dd') <= '" + endTime + "'";
//        if (allotto.isChecked()) { // 调拨出库
//            new QueryDiaoBoChuHuoTask(AllotGoodsActivityQuire.this, "正在查询调拨出货数据...", true, sql).execute("");
//        } else {
//            new QueryDiaoBoShouHuoTask(AllotGoodsActivityQuire.this, "正在查询调拨收货数据...", true, sql).execute("");
//        }
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
    }


//    private void toSecondView_backup(int type) {
//        hasQuery = true;
//        if (pw != null && pw.isShowing()) {
//            pw.dismiss();
//        }
//        resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
//        ArrayList<AllotGoodsQueryEntity> infoList = new ArrayList<AllotGoodsQueryEntity>();
//        if (type == 0) {
//            if (listCH != null && listCH.size() > 0) {
//                showDataType(0);
//                for (DiaoBoQueryRes.Bean dbC : listCH) {
//                    ProductEntity[] details = dbC.getProductDetails();
//                    for (ProductEntity pe : details) {
//                        if (!DalCommon.CanEditAmount(pe.getItemId())) {
//                            pe.setAmount(Arith.mul(pe.getPrice(), pe.getTQTY()));
//                        } else {
//                            pe.setAmount(pe.getPrice());
//                        }
//                        Item001DbOperate.GetProductDetail(pe);
//                        AllotGoodsQueryEntity agqe = new AllotGoodsQueryEntity();
//                        agqe.StoreFrom = dbC.getStoreName();
//                        agqe.StoreTo = dbC.getTStoreName();
//                        agqe.WDate = dbC.getWDate();
//                        agqe.DB_Bill = dbC.getBill();
//                        agqe.ItemId = pe.getItemId();
//                        agqe.ItemName = pe.getItemName();
//                        agqe.TQTY = StringUtils.formatDouble(pe.getTQTY(), "0");
//                        agqe.Amount = StringUtils.formatDouble(pe.getAmount(), "0.00");
//                        agqe.Price = StringUtils.formatDouble(pe.getPrice(), "0.00");
//                        agqe.Lr_Name = dbC.getLr_Name();
//                        infoList.add(agqe);
//                    }
//                }
//            } else {
//                showMsg("无调拨出货数据");
//                showDataType(1);
//            }
//        } else {
//            if (listSH != null && listSH.size() > 0) {
//                showDataType(0);
//                for (DiaoBoQueryRes.Bean dbS : listSH) {
//                    List<ProductEntity> details = dbS.getProductDetails();
//                    for (ProductEntity pe : details) {
//                        if (!DalCommon.CanEditAmount(pe.getItemId())) {
//                            pe.setAmount(Arith.mul(pe.getPrice(), pe.getTQTY()));
//                        } else {
//                            pe.setAmount(pe.getPrice());
//                        }
//                        Item001DbOperate.GetProductDetail(pe);
//                        AllotGoodsQueryEntity agqe = new AllotGoodsQueryEntity();
//                        agqe.StoreFrom = dbS.getstore();
//                        agqe.StoreTo = dbS.getFStoreName();
//                        agqe.WDate = dbS.getWDate();
//                        agqe.DB_Bill = dbS.getDB_Bill();
//                        agqe.ItemId = pe.getItemId();
//                        agqe.ItemName = pe.getItemName();
//                        agqe.TQTY = StringUtils.formatDouble(pe.getTQTY(), "0");
//                        agqe.Amount = StringUtils.formatDouble(pe.getAmount(), "0.00");
//                        agqe.Price = StringUtils.formatDouble(pe.getPrice(), "0.00");
//                        agqe.Lr_Name = dbS.getLr_Name();
//                        infoList.add(agqe);
//                    }
//                }
//            } else {
//                showMsg("无调拨收货数据");
//                showDataType(1);
//            }
//        }
//        AllotGoodsQueryAdapter adapter = new AllotGoodsQueryAdapter(infoList, AllotGoodsActivityQuire.this);
//        resaultlist.setAdapter(adapter);
//    }

	/*
     * public void allotDatePick(View view) { View contentView =
	 * LayoutInflater.from(this).inflate(R.layout.ordergoods_quire, null); new
	 * SelectDatePop(this, new onDateSelectedListener() {
	 *
	 * @Override public void onDateSelect(String startDay, String endDay) {
	 *
	 * allotdatefrom.setText(startDay); beginTime = startDay;
	 * allotdateto.setText(endDay); endTime = endDay; }
	 * }).showWindow(contentView); }
	 */

    public void orderDatePickFrom(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                allotdatefrom.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                beginTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    public void orderDatePickTo(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                allotdateto.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                endTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    public void reQuire(View view) {
        showPopWindow();
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case StoreSelectorActivity.RESULTCODE:
                ShopEntity shopEntity = (ShopEntity) data.getSerializableExtra("store");
                if (shopEntity != null) {
                    store.setText(shopEntity.getShopName());
                    storeid = shopEntity.getShopId();
                }
                break;

            default:
                break;
        }
    }

    public void storeSelector(View view) {
        Intent intent = new Intent(AllotGoodsActivityQuire.this, StoreSelectorActivity.class);
        intent.putExtra("store", "ALL");
        startActivityForResult(intent, 200);
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {

        super.onWindowFocusChanged(hasFocus);
        if (pw == null) {
            showPopWindow();
        }
    }

    private void showDataType(int type) {

        switch (type) {
            case 0:
                noDataText.setVisibility(View.INVISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 1:
                noDataText.setVisibility(View.VISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 2:
                noNetLayout.setVisibility(View.VISIBLE);
                break;
            default:
                break;
        }
    }

    public void againLoadData(View v) {

        query();
    }

    @Override
    public void displayNoNet(String tag) {

        super.displayNoNet(tag);
//        if (QueryDiaoBoChuHuoTask.TAG.equals(tag)) {
//            if (pw != null && pw.isShowing()) {
//                pw.dismiss();
//            }
//            showDataType(2);
//            hasQuery = true;
//            resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
//        }
    }
}
