package com.urovo.activity.goodsmanager;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.common.OrderGoodsChoseSingleActivity;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.data.GoodsInOutStockBaseAct;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.wgmf.trade.model.bean.GoodsInOutStockBean;
import com.wgmf.trade.model.bean.GoodsInOutStockItemDetailBean;
import com.wgmf.trade.presenter.GoodsInOutStockPre;
import com.wgmf.trade.ui.fra.more.productmanagement.GoodsInOutStockDetailFra;
import com.wgmf.trade.view.GoodsInOutStockCon;
import com.zsy.libcore.ui.ada.helper.ViewHelper;
import com.zsy.libcore.ui.ada.quickadapter.QuickAdapter;
import com.zsy.libcore.ui.fra.FragmentArgs;
import com.urovo.wugumofang.view.webview.FraContainerAct;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static com.urovo.activity.common.OrderGoodsChoseSingleActivity.Search_type;
import static com.urovo.activity.common.OrderGoodsChoseSingleActivity.type_goodsInOutStock;

/**
 * 产品出入库查询
 * 跟本机销售记录类似；
 * Created by samy on 17/1/6.
 */
public class GoodsInOutStockAct extends GoodsInOutStockBaseAct implements GoodsInOutStockCon.View {
    private TextView selectNameTv;
    private ProductEntity productEntity;
    private GoodsInOutStockBean goodsInOutStockBean;
    private GoodsInOutStockItemDetailBean goodsInOutStockItemDetailBean;

    //    List<GoodsInOutStockBean> goodsInOutStockBeanList = new ArrayList<>();
    private List<GoodsInOutStockBean.InOutListEntity> inOutList;
    private GoodsInOutStockPre goodsInOutStockPre;

    private TextView product_name_tv;
    private TextView product_unit_tv;
    private TextView product_stock_tv;
    private TextView product_beginning_stock_tv;
    private String beginDate, endDate;

    @Override
    protected boolean isExpandableList() {
        return false;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }

    /**
     * 初始化操作
     */
    private void init() {
        goodsInOutStockPre = new GoodsInOutStockPre(this);
        mListView.setVisibility(View.INVISIBLE);
        View headView = LayoutInflater.from(this).inflate(R.layout.view_head_goods_in_out_stock, null);
        mListView.addHeaderView(headView);
        product_name_tv = (TextView) headView.findViewById(R.id.product_name_tv);
        product_unit_tv = (TextView) headView.findViewById(R.id.product_unit_tv);
        product_stock_tv = (TextView) headView.findViewById(R.id.product_stock_tv);
        product_beginning_stock_tv = (TextView) headView.findViewById(R.id.product_beginning_stock_tv);


        mListView.setDivider(new ColorDrawable(0xFFAAAAAA));
        mListView.setBackgroundColor(0xf1f1f1);
        mListView.setDividerHeight(1);
        mListView.setOverScrollMode(View.OVER_SCROLL_NEVER);

        //int temp = DensityUtil.sp2px(this,30);
        //mListView.setPadding(temp,0,temp,0);

        //默认先选择
//    mTextViewDate.setText(setDefaultDate()+"至" + mDateTo);
        setQueryMonthDate(mDate);
    }

    @Override
    protected void showPopWindowDateStore() {
        super.showPopWindowDateStore();
        LinearLayout tempLinearLayout = mStoreDateSelectorPop.getLinearLayoutLoginName();
//    mStoreDateSelectorPop.setMixBegin(setDefaultDate());
        //if (tempLinearLayout!=null){
        //  tempLinearLayout.removeAllViews();
        //  //tempLinearLayout.addView();
        //}
        TextView nameDescTv = (TextView) tempLinearLayout.getChildAt(0);
        nameDescTv.setText("产品");
        selectNameTv = (TextView) tempLinearLayout.getChildAt(1);
        showSelectName();
        tempLinearLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //ToastMsg.showToastMsg(GoodsInOutStockAct.this,"new Click!!!");
                Intent intent = new Intent();
                intent.setClass(GoodsInOutStockAct.this, OrderGoodsChoseSingleActivity.class);
                intent.putExtra(Search_type, type_goodsInOutStock);
                intent.putExtra("storeid", SystemHelper.LoginOrganId);
                startActivityForResult(intent, 1);
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        //super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 1 && resultCode == OrderGoodsChoseSingleActivity.activityResultCode) {
            productEntity = (ProductEntity) data.getSerializableExtra(OrderGoodsChoseSingleActivity.activityResultData);
            showSelectName();
        }
    }

    protected String setDefaultDate() {
        Date dateBegin = new Date();
        dateBegin.setDate(1);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(dateBegin);
    }

    /**
     * 回调展示查询后的产品名称
     */
    private void showSelectName() {
        if (productEntity != null) {
            selectNameTv.setText(productEntity.getItemId() + " " + productEntity.getItemName());
        } else {
            selectNameTv.setText("请选择产品");
        }
    }

    @Override
    protected String getTitleText() {
        return "产品出入库查询";
    }

    @Override
    protected int getPopupWindowMode() {
//    return StoreDateSelectorPop.STORE_DATE_MIX_USER;
        return StoreDateSelectorPop.STORE_DATE_GOODS_INOUT_STOCK;
    }


    /**
     * 查询后的详情页的list列表的adapter
     *
     * @return BaseAdapter
     */
    @Override
    protected BaseAdapter newBaseAdapter() {
        //保证程序不会蹦
        if (null == inOutList) {
            inOutList = new ArrayList<>();
        }
        return new QuickAdapter<GoodsInOutStockBean.InOutListEntity>(R.layout.item_head_goods_in_out_stock, inOutList) {

            @Override
            protected void onBindData(Context context, int i, ViewHelper viewHelper, int i1,
                                      final GoodsInOutStockBean.InOutListEntity inOutListEntity) {
                viewHelper.setText(R.id.type_tv, inOutListEntity.proInOutType);
                viewHelper.setText(R.id.num_tv, inOutListEntity.proInOutNum + "");
                TextView detail_tv = viewHelper.getView(R.id.detail_tv);
                detail_tv.setText("查看明细");
                detail_tv.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                detail_tv.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        ViewUtil.showProgress(GoodsInOutStockAct.this,"请稍等...","正在加载明细");
                        goodsInOutStockPre.getItemDetail(SystemHelper.LoginOrganId, goodsInOutStockBean.proCode, beginDate, endDate, inOutListEntity.proInOutType);
                    }
                });
            }
        };
    }

    @Override
    protected BaseExpandableListAdapter newExpandableAdapter() {
        return null;
    }

    @Override
    protected void requestConnectTask() {

    }

    @Override
    protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
        ViewUtil.showProgress(this, "正在查询...", "请稍后...", false);
        showEmpty();//产品出入库查询 点击按钮后无数据界面的显示
        if (productEntity == null) {
            showMsg("请选择编号查询!");
            ViewUtil.dismissProgress();
            return;
        }
        goodsInOutStockPre.getDataList(SystemHelper.LoginOrganId, productEntity.getItemId(), dateFrom, dateTo);
        beginDate = dateFrom;
        endDate = dateTo;
    }

    /**
     * 网络请求接口后回调数据再通过fragment展示产品出入库明细的list列表数据
     *
     * @param goodsInOutStockBeanListTemp 网络请求接口后回调的数据
     */
    @SuppressLint("SetTextI18n")
    @Override
    public void showDataList(GoodsInOutStockBean goodsInOutStockBeanListTemp) {
        this.goodsInOutStockBean = goodsInOutStockBeanListTemp;
        inOutList = goodsInOutStockBean.inOutList;
        mMyAdapter = newBaseAdapter();
        mListView.setVisibility(View.VISIBLE);//查询后再显示list列表
        mListView.setAdapter(mMyAdapter);
        //mMyAdapter.notifyDataSetChanged();对比

        if (goodsInOutStockBean != null) {
            product_name_tv.setText(goodsInOutStockBean.proCode +"   "+ goodsInOutStockBean.proName);
            product_beginning_stock_tv.setText(
                    Html.fromHtml("月初库存：" + "<font color='#ffb919'>" + goodsInOutStockBean.proQCKCQty + "</font>"));
            product_stock_tv.setText(
                    Html.fromHtml("即时库存：" + "<font color='#ffb919'>" + goodsInOutStockBean.proKCQty + "</font>"));
            product_unit_tv.setText("单位:" + goodsInOutStockBean.proUOM);
        }
    }

    /**
     * 网络请求接口后回调数据再通过fragment展示产品出入库明细的list列表数据
     *
     * @param goodsInOutStockBeanList 网络请求接口后回调的数据
     */
    @Override
    public void showItemDetail(ArrayList<GoodsInOutStockItemDetailBean> goodsInOutStockBeanList) {
        if (goodsInOutStockBeanList != null) {
            FragmentArgs fragmentArgs = new FragmentArgs();
            fragmentArgs.add(AppConstants.ExtraKeys.GOODS_IN_OUT_STOCK_BEAN, goodsInOutStockBean);
            fragmentArgs.add(AppConstants.ExtraKeys.GOODS_IN_OUT_STOCK_BEAN_LIST, goodsInOutStockBeanList);
            FraContainerAct.launch(this, GoodsInOutStockDetailFra.class, fragmentArgs, false);
        }
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        if (mStoreDateSelectorPop == null) {
            showPopWindowDateStore();
        }
    }
}
