package com.urovo.activity.goodsmanager

import android.annotation.SuppressLint
import android.app.DatePickerDialog
import android.os.Bundle
import android.view.View
import com.urovo.wgmf.adapter.DingHuoQueryAdapter2
import com.urovo.wgmf.db.dao.entitys.DingHuoOplQtyEntity
import com.urovo.wgmf.entity.response.DingHuoQueryNewRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.system.SystemHelper
import com.wgmf.trade.presenter.OrderGoodPre
import com.wgmf.trade.view.OrderGoodCon
import kotlinx.android.synthetic.main.ordergoods_query_act.*
import kotlinx.android.synthetic.main.ordergoods_query_popup.*
import java.text.SimpleDateFormat
import java.util.*

/**
 * @author Sasuke on 2019/4/5.
 * 订货查询
 */
class OrderGoodsQueryAct : BaseActivity(), OrderGoodCon.View {
    var orderGoodPre: OrderGoodPre? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ordergoods_query_act)
        initTitle()
        init()
        orderGoodPre = OrderGoodPre(this)
        //一进来就请求一下吧
        orderGoodPre?.selectOrderedList(
            SystemHelper.LoginOrganId,
            order_date_from.text.toString(),
            order_date_to.text.toString()
        )
    }

    fun init() {
        titleTextView.text = getString(R.string.query_stores_title)
        initPopView()
        tvListHeader.text = String.format(
            getString(R.string.query_stores),
            SystemHelper.LoginOrganName,
            order_date_from.text.toString(),
            order_date_to.text.toString()
        )
        tvListHeader.setOnClickListener { showPopWindow(true) }
        queryBtn.setOnClickListener {
            orderGoodPre?.selectOrderedList(
                SystemHelper.LoginOrganId,
                order_date_from.text.toString(),
                order_date_to.text.toString()
            )
        }
    }

    /**
     * 显隐弹窗
     */
    private fun showPopWindow(isVisible: Boolean) {
        popLayout.run { visibility = if (isVisible) View.VISIBLE else View.GONE }
    }

    @SuppressLint("SimpleDateFormat")
    private fun initPopView() {
        popLayout.apply {
            out_view.setOnClickListener { showPopWindow(false) }
            ordergoods_quire.text = SystemHelper.LoginOrganName
            //开始日期
            order_date_from?.apply {
                text = SimpleDateFormat("yyyy-MM-dd").format(Date())
                setOnClickListener {
                    val c = Calendar.getInstance()
                    DatePickerDialog(
                        this@OrderGoodsQueryAct,
                        { view, year, monthOfYear, dayOfMonth ->
                            setText(
                                String.format(
                                    "%04d-%02d-%02d",
                                    year,
                                    monthOfYear + 1,
                                    dayOfMonth
                                )
                            )
                            tvListHeader.text = String.format(
                                getString(R.string.query_stores),
                                SystemHelper.LoginOrganName,
                                order_date_from.text.toString(),
                                order_date_to.text.toString()
                            )
//                    beginTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth)
                        },
                        c.get(Calendar.YEAR),
                        c.get(Calendar.MONTH),
                        c.get(Calendar.DAY_OF_MONTH)
                    ).show()

                }
            }

            //结束日期
            order_date_to?.apply {
                val c = Calendar.getInstance()
                text = SimpleDateFormat("yyyy-MM-dd").format(Date())
                setOnClickListener {
                    DatePickerDialog(
                        this@OrderGoodsQueryAct,
                        { view, year, monthOfYear, dayOfMonth ->
                            setText(
                                String.format(
                                    "%04d-%02d-%02d",
                                    year,
                                    monthOfYear + 1,
                                    dayOfMonth
                                )
                            )
                            tvListHeader.text = String.format(
                                getString(R.string.query_stores),
                                SystemHelper.LoginOrganName,
                                order_date_from.text.toString(),
                                order_date_to.text.toString()
                            )
//                    endTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth)
                        },
                        c.get(Calendar.YEAR),
                        c.get(Calendar.MONTH),
                        c.get(Calendar.DAY_OF_MONTH)
                    ).show()
                }
            }
        }
    }

    /**
     * 查询到的订货结果
     */
    override fun showOrderedList(res: DingHuoQueryNewRes?) {
        res?.let {
            showPopWindow(false)
            val filterStr = filterProIdTv?.text.toString()
            //过滤
            res.resultInfo.forEach {
                if (filterStr.isNotBlank()) {
                    it.goodDetailList = it.goodDetailList.filter { it.goodCode == filterStr }
                }
            }
            //把子产品表为空的父item干掉
            val resultInfo = res.resultInfo.filter { it.goodDetailList.isNotEmpty() }
            if (resultInfo.isEmpty()) {
                showMsg("无订货数据")
                orderGoodsQueryListView.setAdapter(DingHuoQueryAdapter2(listOf(), this))
                return
            }
            //开始加载Adapter
            orderGoodsQueryListView.setAdapter(DingHuoQueryAdapter2(resultInfo, this))
            orderGoodsQueryListView.showListHeaderView()
        }
    }

    override fun showCanOrdering(msgCode: Int, msgInfo: String?, isSubmitOrder: Boolean) {
    }

    override fun showOrderList(dingHuoOplQtyEntityList: DingHuoOplQtyEntity.ResultInfo?) {
    }

    override fun submitSuccess(msg: String?) {
    }

    override fun submitFailed(msg: String?) {
    }

    override fun showIsLoading() {
    }

    override fun showError(errorMsg: String?) {
    }

    override fun showState(loadWaitState: Int) {
    }

    override fun showDismissAll() {
    }
}