package com.urovo.activity.goodsmanager

import android.annotation.SuppressLint
import android.app.AlertDialog
import android.content.DialogInterface
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager.widget.ViewPager
import com.urovo.activity.addsellactivity.ui.AutoRadioGroup
import com.urovo.activity.goodsmanager.adapter.OrderGoodsTradeAdapter
import com.urovo.wgmf.adapter.MyPagerAdapter
import com.urovo.wgmf.db.dao.entitys.DingHuoOplQtyEntity
import com.urovo.wgmf.entity.response.DingHuoQueryNewRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivityTap
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.data.Arith
import com.urovo.wugumofang.data.StringUtils
import com.urovo.wugumofang.net.NetHelper
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DialogHelper
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.view.DividerUniteItemDecoration
import com.urovo.wugumofang.view.LoadWaitDominator
import com.urovo.wugumofang.view.indexBar.IndexbarConfig
import com.wgmf.trade.model.bean.OrderSubmitReqBean
import com.wgmf.trade.presenter.OrderGoodPre
import com.wgmf.trade.view.OrderGoodCon
import kotlinx.android.synthetic.main.member_title.*
import kotlinx.android.synthetic.main.ordergoods_submit_act.*
import kotlinx.android.synthetic.main.ordergoods_submit_act.containerLayout
import kotlinx.android.synthetic.main.ordergoods_submit_act.submitBtn
import kotlinx.android.synthetic.main.select_product_vp_item.view.*
import kotlinx.android.synthetic.main.shisan_report_act.*
import org.jetbrains.anko.find
import java.util.*
import kotlin.collections.ArrayList

/**
 * @author Sasuke on 2019/4/5.
 */
class OrderGoodsSubmitAct : BaseActivityTap(), OrderGoodCon.View {
    var mOrderGoodPre: OrderGoodPre? = null
    var mLoadWaitDominator: LoadWaitDominator? = null

    var mTitleContainer: LinearLayout? = null
    var mBrandRadioGroup: AutoRadioGroup? = null
    var mColRadioGroupList: MutableList<AutoRadioGroup> = mutableListOf()
    var mViewPagerList: MutableList<View> = mutableListOf()

    var mResultInfoCache: DingHuoOplQtyEntity.ResultInfo? = null

    companion object {
        const val WGMF_BRAND_ID = 8
        const val XDY_BRAND_ID = 15
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ordergoods_submit_act)
        mOrderGoodPre = OrderGoodPre(this)
        init()
    }

    fun init() {
        titleLayout.find<TextView>(R.id.text_title).text = "门店订货"
        initBack()

        mTitleContainer = tapLayout.find(R.id.title_container_ll)
        mBrandRadioGroup = AutoRadioGroup(mTitleContainer!!)

        mLoadWaitDominator = LoadWaitDominator(this, containerLayout)

        showIsLoading()
        mOrderGoodPre?.isCanOrdering(SystemHelper.LoginOrganId, SystemHelper.LoginUserId, false)
        submitBtn.setOnClickListener { checkBeforeSubmit() }
    }

    @SuppressLint("InflateParams")
    fun refreshUI(resultInfo: DingHuoOplQtyEntity.ResultInfo?) {
        //先存一份
        if (resultInfo?.list == null) return
        mResultInfoCache = resultInfo

        //初始化最顶栏
        resultInfo.brandPage?.let {
            if (it.size == 1) {
                //品牌大标签 只有一个品牌的情况
                titleLayout.find<TextView>(R.id.text_title).text = it.get(0)?.title
                titleLayout.visibility = View.VISIBLE
                tapLayout.visibility = View.GONE
            } else {
                titleLayout.visibility = View.GONE
                tapLayout.visibility = View.VISIBLE
            }
        }

        //先清一下（其实如果只走一遍好像也无所谓
        mBrandRadioGroup?.removeAllChild()
        mColRadioGroupList.forEach { it.removeAllChild() }
        viewpager.removeAllViews()
        mViewPagerList.clear()
        //初始化顶部品牌标签+内容页（循环）
        resultInfo.brandPage?.forEach { brandItem ->
            //品牌大标签显示
            val radio: RadioButton = (layoutInflater.inflate(
                R.layout.tap_title_radio_new_btn,
                mTitleContainer,
                false
            ) as RadioButton)
            mBrandRadioGroup?.addViewWithLayoutParams(
                view = radio, text = brandItem.title, paramWith = 0,
                paramheight = RadioGroup.LayoutParams.MATCH_PARENT
            ) { pos -> viewpager.currentItem = pos }
            //数据内容页显示
            mViewPagerList.add(LayoutInflater.from(this).inflate(R.layout.ordergoods, null).apply {
                find<TextView>(R.id.tvStore).apply {
                    text = "订货门店: ${SystemHelper.LoginOrganName}"
                }

                // val dataList = mutableListOf<DingHuoOplQtyEntity.DinghuoDetail>().apply { addAll(resultInfo.list.filter { it.brandId == brandItem.type }) }
                //分类标签(只有 五谷磨房 才有小分类)
                val labelGroup = find<LinearLayout>(R.id.labelGroup)
                val colRadioGroup = AutoRadioGroup(labelGroup)
                if (brandItem.type == WGMF_BRAND_ID) {
                    resultInfo.col.forEach { colItem ->
                        val radioButton = layoutInflater.inflate(
                            R.layout.add_sell_radio_button,
                            null
                        ) as RadioButton
                        colRadioGroup.addView(view = radioButton, text = colItem.title) { pos ->
                            refreshItemTitle(colItem)
                            refreshRvByLabel(brandItem.type, colItem.type)//各标签的点击监听。
                        }
                    }
                    //加一个“全部”标签（无论什么品牌都要加）
                    val radioButton =
                        layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
                    colRadioGroup.addView(view = radioButton, text = "全部") {
                        refreshItemTitle(null)
                        refreshRvByLabel(brandItem.type, -1)
                    }
                    labelGroup.visibility = View.VISIBLE
                } else {
                    //加一个“全部”标签（无论什么品牌都要加）
                    val radioButton =
                        layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
                    colRadioGroup.addView(view = radioButton, text = "全部") {
                        refreshItemTitle(null)
                        refreshRvByLabel(brandItem.type, 0)
                    }
                    labelGroup.visibility = View.INVISIBLE
                }


                mColRadioGroupList.add(colRadioGroup)

                if (resultInfo.col.isNotEmpty()) {
                    refreshItemTitle(resultInfo.col[0])
                } else {
                    refreshItemTitle(null)
                }
                //列表
                find<RecyclerView>(R.id.proLv).apply {
                    layoutManager = LinearLayoutManager(this@OrderGoodsSubmitAct)
                    addItemDecoration(
                        DividerUniteItemDecoration(
                            this@OrderGoodsSubmitAct,
                            DividerUniteItemDecoration.HORIZONTAL_LIST, 12, ContextCompat.getColor(
                                this@OrderGoodsSubmitAct, R.color.color_common_devider_line_one
                            )
                        )
                    )
                    adapter = OrderGoodsTradeAdapter(
                        this@OrderGoodsSubmitAct,
                        listOf()
                    ) { refreshPriceShow() }
                }
            })
        }

        viewpager.adapter = MyPagerAdapter(this, ArrayList(mViewPagerList))
        viewpager.setCurrentItem(0)
        viewpager.addOnPageChangeListener(
            object : ViewPager.OnPageChangeListener {
                override fun onPageScrollStateChanged(p0: Int) {}
                override fun onPageScrolled(p0: Int, p1: Float, p2: Int) {}
                override fun onPageSelected(pos: Int) {
                    mBrandRadioGroup?.setChildChecked(pos)
                }
            })
        mBrandRadioGroup?.setChildChecked(0)
        mColRadioGroupList.forEach { it.setChildChecked(0) }//要放在最后check，因为前面构造的时候，还没有添加到pager里面，直接check会崩。
        //每个pager都先定位到第一个分类
        //refreshRvByLabel(resultInfo.brandPage[0].type, if (brandItem.type != WGMF_BRAND_ID) -1 else resultInfo?.col[0].type)
    }

    private fun View.refreshItemTitle(label: DingHuoOplQtyEntity.Label?) {
        var titleList = Arrays.asList(*resources.getStringArray(R.array.goods_order_default_title))
        if (label?.type == AppConstants.PackType.ACCESSORIES_SUPPLIERS) {
            titleList = Arrays.asList(*resources.getStringArray(R.array.goods_order_other_title))
        }
        find<TextView>(R.id.tvName).apply {
            text = titleList[0]
        }
        find<TextView>(R.id.tvKucun).apply {
            text = titleList[1]
        }
        find<TextView>(R.id.tvQuantity).apply {
            text = titleList[2]
        }
        find<TextView>(R.id.tvQty).apply {
            text = titleList[3]
        }
        find<TextView>(R.id.tvCyl).apply {
            text = titleList[4]
        }
    }

    /**
     * 根据上面的标签分类来过滤显示对应的列表
     */
    fun refreshRvByLabel(brand: Int, type: Int) {
        val currentPager =
            mViewPagerList.get(mResultInfoCache?.brandPage?.indexOfFirst { it.type == brand }
                ?: 0)
        val currRv = currentPager.find<RecyclerView>(R.id.proLv)
        val adapter = currRv.adapter as OrderGoodsTradeAdapter
        adapter.notifyProByLabel(mResultInfoCache, brand, type)

        val indexbarConfig = IndexbarConfig(
            this,
            currentPager.find(R.id.product_index_bar),
            currentPager.find(R.id.tvSideBarHint),
            currRv,
            adapter.orderList
        ).configDefault()
        //        indexbarConfig.setCustomComparator(new OrderGoodsComparator());
        indexbarConfig.toggleShowIndexBar(type == -1)//-1表示“全部”标签
        refreshPriceShow()
        // listviewChange()
    }

    /**
     * 刷新价格显示
     */
    fun refreshPriceShow() {
        var invalidCount = 0
        var count = 0.0
        var countPrice = 0.0

        mResultInfoCache?.list?.forEach {
            if (it.isInvalid) invalidCount++
            count = Arith.add(count, it.getTQTY())
            countPrice = Arith.add(countPrice, it.getAmount())
        }
        totalCountTv.setText(StringUtils.formatDouble(count, "0.00"))
        totalPriceTv.setText(StringUtils.formatDouble(countPrice, "0.00"))
        if (invalidCount > 0) {
            submitBtn.isEnabled = false
            submitBtn.text = "您有 ${invalidCount} 条信息输入不合格,请重输！"
        } else {
            if (!submitBtn.isEnabled) {
                submitBtn.isEnabled = true
                submitBtn.text = "提交"
            }
        }
    }

    /**
     * 这个不需要了，这是订货查询里的，因为以前是[订货提交]和[订货查询]是在同一个大页面下。
     */
    override fun showOrderedList(dingHuoQueryResponse: DingHuoQueryNewRes?) {
    }

    /**
     * 请求是否能订货之后的回调
     */
    override fun showCanOrdering(msgCode: Int, msgInfo: String?, isSubmitOrder: Boolean) {
        if (isSubmitOrder) {
            if (msgCode >= 0) {
                submitBtn.isEnabled = false
                ViewUtil.showProgress(this, "请稍等", "正在提交订货数据...")
                mOrderGoodPre?.orderSubmit(packedSubmitData())
            } else {
                // Toast.makeText(LibCoreApp.getInstance(), msgInfo, Toast.LENGTH_SHORT).show()
                DialogHelper.Alert(this@OrderGoodsSubmitAct, "提示", msgInfo, null) { dialog, which ->
                    dialog.dismiss()
                }
            }
        } else {
            if (msgCode > 0) {
                DialogHelper.Alert3R(this@OrderGoodsSubmitAct, "提示", msgInfo, null,
                    { dialog, which ->
                        dialog.dismiss()
                        mOrderGoodPre?.getOrderList(
                            SystemHelper.LoginOrganId,
                            SystemHelper.LoginUserId,
                            SystemHelper.LoginUserBrandList
                        )
                    }, { dialog, which ->
                        dialog.dismiss()
                        this@OrderGoodsSubmitAct.finish()
                    })
            } else if (msgCode < 0) {
                submitBtn.isEnabled = false
                mLoadWaitDominator?.show("提示:$msgInfo")
            }
        }
    }

    override fun showOrderList(resultInfo: DingHuoOplQtyEntity.ResultInfo?) {
        if (isFinishing || resultInfo?.brandPage == null || resultInfo.brandPage.isEmpty()) return
        refreshUI(resultInfo)
    }

    /**
     * 提交成功
     */
    override fun submitSuccess(msg: String?) {
        if (isFinishing) return
        Toast.makeText(this, msg, Toast.LENGTH_SHORT).show()
        finish()
    }

    override fun submitFailed(msg: String?) {
        if (isFinishing) return
        showMsg(msg)
        submitBtn.isEnabled = true
        submitBtn.text = "提交"
    }

    /**
     * 提交前的校验
     */
    fun checkBeforeSubmit() {
        val choiceList = mResultInfoCache?.list?.filter { it.tqty > 0 } ?: listOf()
        val choiceWgmfList =
            mResultInfoCache?.list?.filter { it.tqty > 0 && it.brandId == WGMF_BRAND_ID }
                ?: listOf()
        val choiceXdyList =
            mResultInfoCache?.list?.filter { it.tqty > 0 && it.brandId == XDY_BRAND_ID }
                ?: listOf()
//        val listGroup
//                = mResultInfoCache?.list?.filter { it.tqty > 0 }?.groupBy { if ( it.brandId == WGMF_BRAND_ID) "WGMF" else "XDY" }

        if (!OrderGoodsCheckLiuFang.checkNumLimit(choiceList)) {
            AlertDialog.Builder(this)
                .setMessage("六方订货总量必须是6的整数倍，请调整数量后重新提交！")
                .setPositiveButton("我知道了", null)
                .create().show()
            return
        }
        if (choiceList.isEmpty()) {
            showMsg("您没有选择任何订货产品!")
            return
        }
        //订货周期第一次订货中，五谷磨房产品总价2000+才允许订货，如果不存在该类产品，则默认给个2001当作它通过校验
        if ((mResultInfoCache?.firstOrder ?: false)
            && (choiceWgmfList.sumByDouble { it.amount } < mResultInfoCache?.mainBrandLimit ?: 0.0)
            && (choiceXdyList.sumByDouble { it.amount } < mResultInfoCache?.mainBrandLimit ?: 0.0)
        ) {
            AlertDialog.Builder(this)
                .setMessage("本次订货单个品牌的金额必须达到${mResultInfoCache?.mainBrandLimit}元或以上，请调整后再提交！如有疑问，请咨询销管部。")
                .setPositiveButton("我知道了", null)
                .show()
            return
        }

        //真正提交
        val info = "请确认是否提交整单订货！"
        val builder = AlertDialog.Builder(this)
        builder.setTitle("重要提示").setMessage(info)
            .setNegativeButton("提交", DialogInterface.OnClickListener { dialog, which ->
                if (!NetHelper.IsHaveInternet(this@OrderGoodsSubmitAct)) {
                    showMsg("当前为离线模式，无法订货！")
                    return@OnClickListener
                }
                submitBtn.isEnabled = false
                mOrderGoodPre?.isCanOrdering(
                    SystemHelper.LoginOrganId,
                    SystemHelper.LoginUserId,
                    true
                )
            }).setPositiveButton("取消") { dialog, which -> submitBtn.isEnabled = true }.create()
            .show()
    }


    /**
     * 组装提交的数据
     */
    private fun packedSubmitData(): OrderSubmitReqBean {
        val date = Date()
        //    orderSubmitReqBean.setBillCode(SystemHelper.LoginOrganId + DateUtil.format(date, "yyMMddHHmmss"));
        /*新订单号规则：门店编号+顾问ID+时间戳到秒+2位随机数，例如：0110074+75598659+170301092423+12；
    顾问ID长度最多为8位，不够的前面补0；*/
        val orderSubmitReqBean = OrderSubmitReqBean().apply {
            billCode = SystemHelper.makeBillCode()
            storeNo = SystemHelper.LoginOrganId
            staffNo = SystemHelper.LoginUserId
            setBrands(SystemHelper.LoginUserBrandList)
            setFirstOrder(mResultInfoCache?.firstOrder ?: false)
        }

        val detailBeans = ArrayList<OrderSubmitReqBean.DetailsBean>()
        mResultInfoCache?.list?.filter { it.tqty > 0 }?.forEach { choice ->
            detailBeans.add(
                OrderSubmitReqBean.DetailsBean().apply {
                    proAmount = choice.getAmount().toString()
                    proBoxQty = choice.getBox_qty().toString()
                    proCode = choice.itemid
                    proDHQty = choice.getTQTY().toString()
                    proId = choice.oe_pro_id
                    proLastMonthQty = choice.lastMonth_qty
                    proMaxQty = choice.max_opl_qty.toString()
                    proName = choice.itemName
                    proOplQty = choice.opl_qty
                    proPrice = choice.itemPrice.toString()
                    proSYQty = choice.sy_opl_qty.toString()
                    proStockQty = choice.stock_Qty
                    proUOM = choice.itemUOM
                    proUOMID = choice.itemUOM_id
                    brandId = choice.brandId
                }
            )
        }

        orderSubmitReqBean.details = detailBeans
        return orderSubmitReqBean
    }

    fun initBack() {
        arrayOf(titleLayout.find<ImageButton>(R.id.back), tapLayout.find(R.id.back_ll)).forEach {
            it.setOnClickListener { finish() }
        }
    }

    override fun showIsLoading() {
        mLoadWaitDominator?.show(LoadWaitDominator.LOADING)
    }

    override fun showError(errorMsg: String?) {
        mLoadWaitDominator?.show(errorMsg ?: "netError")
    }

    override fun showState(loadWaitState: Int) {
        mLoadWaitDominator?.show(loadWaitState)
    }

    override fun showDismissAll() {
        mLoadWaitDominator?.dismissAll()
    }
}