package com.urovo.activity.goodsmanager.presenter

import com.urovo.wgmf.CommonController
import com.urovo.wgmf.db.dao.entitys.StockGoodsDetailEntity
import com.urovo.wgmf.net.CommonNet
import com.wgmf.trade.model.bean.CommonEntity

/**
 * 库存查询明细的pre （其实以前是StockGoodsPresenter.java，这里这个只是单纯改成Kotlin了，方便做一些集合处理）
 * @author Sasuke on 2018-11-10.
 */
class StockGoodsPresenter: CommonController.StockSearchPre<StockGoodsDetailEntity> {
    var mStockSearchView: CommonController.StockSearchView<StockGoodsDetailEntity>? = null
    var mCommonNet: CommonNet? = null
    var brandList: List<StockGoodsDetailEntity.BrandList>? = listOf()
    var detailList: List<StockGoodsDetailEntity.DetailList>? = listOf()

    constructor(stockSearchView: CommonController.StockSearchView<StockGoodsDetailEntity>, commonNet: CommonNet){
        this.mStockSearchView = stockSearchView
        this.mCommonNet = commonNet
    }

    override fun onStart2requestData(params: Map<String, String>) {
        mCommonNet?.start2requestStockGoodsDetail(this, params)
    }

    override fun onResponseSuccess(resultInfo: CommonEntity<StockGoodsDetailEntity>) {
        brandList = resultInfo?.stockGoodsDetailEntity?.brandList
        detailList = resultInfo?.stockGoodsDetailEntity?.detailList
        mStockSearchView?.onResponseSuccess(resultInfo)//其实感觉传不传resultInfo无所谓，Presenter里都已经有了，直接从Presenter里拿一还不是美滋滋？
    }

    /**
     * 校验是否有数据
     */
    fun checkHasData(): Boolean{
        return brandList != null && detailList != null && brandList?.size != 0 && detailList?.size != 0
    }

//    override fun onResponse(resultInfo: CommonEntity<StockGoodsDetailEntity>){
//        brandList = resultInfo.t.brandList
//        detailList = resultInfo.t.detailList
//        mStockSearchView?.onResponseSuccess(resultInfo)//其实感觉传不传resultInfo无所谓，Presenter里都已经有了，直接从Presenter里拿一还不是美滋滋？
//    }

    /**
     * 通过brandId来过滤产品表信息
     */
    fun filterByBrandId(brandId: Int): List<StockGoodsDetailEntity.DetailList>?{
        return detailList?.filter { it.brandId == brandId }
    }

    override fun onFailure(failInfo: String) {
        mStockSearchView?.onFailure(failInfo)
    }


}