package com.urovo.activity.goodsmanager.viewmodel

import android.app.Application
import android.content.Context
import androidx.lifecycle.AndroidViewModel
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.viewModelScope
import com.urovo.activity.goodsmanager.service.OrderGoodsRepository
import com.urovo.wugumofang.utils.MyToast
import kotlinx.coroutines.launch

class OrderGoodsViewModel(val repo: OrderGoodsRepository, val app: Application) :
    AndroidViewModel(app) {

    /**
     * 转圈圈弹窗
     */
    var progressBarText: MutableLiveData<String> = MutableLiveData()

    /**
     * 门店订货周期变更提醒
     */
    fun queryOrderGoodsTip(context: Context) = viewModelScope.launch {
        progressBarText.value = "正在查询报损数据...";
        try {
            repo.queryOrderGoodsTip(context)
        } catch (e: Exception) {
            MyToast.show(e.message)
        }
        progressBarText.value = ""
    }
}