package com.urovo.activity.home;

import android.app.DatePickerDialog;
import android.app.DatePickerDialog.OnDateSetListener;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wgmf.db.dao.entitys.HuiYuanJiChuXinXiEntity;
import com.urovo.wgmf.entity.response.HuiYuanJiChuXinXiResponse;
import com.urovo.wgmf.entity.response.VipResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


public class EditDetailActivity extends BaseActivity {

    private LinearLayout ll_member_detail;
    private ProgressBar pb_member_detail;

    private ImageButton back;
    private Button btn_save;
    private RelativeLayout rl_name;
    private TextView tv_name;
    private RelativeLayout rl_phone;
    private TextView tv_phone;
    private RelativeLayout rl_birthday;
    private TextView tv_birthday;

    private RadioGroup rg_sex;
    private RadioButton rb_female;
    private RadioButton rb_male;

    private String huiyuan = "";
    private boolean isVip = false;

    private Date date;

    private String name = "";
    private String mobile = "";
    private String sex = "";
    private String birthday = "";

    private VipResponse vipResponse;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.member_detail_edit);
        // ViewUtils.inject(this);
        back = (ImageButton) findViewById(R.id.goback);
        titleTextView = (TextView) findViewById(R.id.text_title);
        btn_save = (Button) findViewById(R.id.btn_save);
        rl_name = (RelativeLayout) findViewById(R.id.rl_name);
        tv_name = (TextView) findViewById(R.id.tv_name);
        rl_phone = (RelativeLayout) findViewById(R.id.rl_phone);
        tv_phone = (TextView) findViewById(R.id.tv_phone);
        rl_birthday = (RelativeLayout) findViewById(R.id.rl_birthday);
        tv_birthday = (TextView) findViewById(R.id.tv_birthday);

        rg_sex = (RadioGroup) findViewById(R.id.rg_sex);
        rb_female = (RadioButton) findViewById(R.id.rb_female);
        rb_male = (RadioButton) findViewById(R.id.rb_male);
        //rb_baomi = (RadioButton) findViewById(rb_baomi);

        ll_member_detail = (LinearLayout) findViewById(R.id.ll_member_detail);
        pb_member_detail = (ProgressBar) findViewById(R.id.pb_member_detail);

        titleTextView.setText("会员信息");
        back.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                finish();
            }
        });

        pb_member_detail.setVisibility(View.VISIBLE);
        ll_member_detail.setVisibility(View.INVISIBLE);

        Intent intent = getIntent();
        huiyuan = intent.getStringExtra("huiyuan");

        name = "";
        mobile = huiyuan;
        sex = "0";
        birthday = new SimpleDateFormat("yyyy-MM-dd").format(new Date());
        isVip = false;
        initData();

        if (null != huiyuan && !TextUtils.isEmpty(huiyuan)) {
            Map<String, String> p = new HashMap<String, String>();
            p.put("userId", SystemHelper.LoginUserId);
            p.put("customerMobile", huiyuan);
            new BaseAppServerTask("query_huiyuan", HuiYuanJiChuXinXiResponse.class, this, "正在查询会员基础信息...", true, "/information/getCustomerInfo", p).execute("");
        } else {
            btn_save.setEnabled(false);
            showMsg("该会员不存在或为空，无法修改！");
        }
    }

    private void initData() {
        ll_member_detail.setVisibility(View.VISIBLE);
        pb_member_detail.setVisibility(View.GONE);
        tv_name.setText(name);
        tv_phone.setText(mobile);
        tv_birthday.setText(birthday);
        if ("1".equals(sex)) {
            rb_male.setChecked(true);
            rb_female.setChecked(false);
            //rb_baomi.setChecked(false);
        } else if ("2".equals(sex)) {
            rb_female.setChecked(true);
            rb_male.setChecked(false);
        } else {
            rb_female.setChecked(false);
            rb_male.setChecked(false);
        }
        /*
        rl_name.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                // 创建一个显示意图开启第二个界面
                Intent intent = new Intent(EditDetailActivity.this, EditNameActivity.class);
                intent.putExtra("name", tv_name.getText().toString());
                // 开启一个新的界面,期待目标activity返回数据，设置了请求码
                startActivityForResult(intent, 1);
            }
        });
        */
        rl_phone.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
            }
        });

        /**
         * 保存会员编辑后的信息到数据库
         */
        btn_save.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                btn_save.setEnabled(false);
                String name = tv_name.getText().toString().trim();
                String mobile = tv_phone.getText().toString().trim();
                int id = rg_sex.getCheckedRadioButtonId();
                String sex = "";
                switch (id) {
                    case R.id.rb_female:
                        sex = "2";
                        break;
                    case R.id.rb_male:
                        sex = "1";
                        break;
                    default:
                        break;
                }
                save(name, sex, mobile);
            }
        });

        rl_birthday.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                // final Calendar ca = Calendar.getInstance();
                Date d = null;
                try {
                    d = DateUtil.String2Date(birthday, "yyyy-MM-dd");
                } catch (Exception e) {
                    d = null;
                    BaseAppManager.loger().info(e);
                }
                int year, month, day;
                if (null != d) {
                    // Date nowDate = new Date();
                    year = d.getYear() + 1900;
                    month = d.getMonth();
                    day = d.getDate();
                } else {
                    year = 1970;// ca.get(Calendar.YEAR);
                    month = 0;// ca.get(Calendar.MONTH);
                    day = 1;// ca.get(Calendar.DAY_OF_MONTH);
                }
                DatePickerDialog datePicker = new DatePickerDialog(EditDetailActivity.this, new OnDateSetListener() {
                    @Override
                    public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
                        date = new Date();
                        date.setYear(year - 1900);
                        date.setMonth(monthOfYear);
                        date.setDate(dayOfMonth);
                        tv_birthday.setText(year + "-" + (monthOfYear + 1) + "-" + dayOfMonth);
                    }
                }, year, month, day);
                datePicker.show();
            }
        });
    }

    private void save(String name, String sex, String mobile) {
        String bir = birthday;
        if (null != date) {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            bir = sdf.format(date);
        }
        Map<String, String> p = new HashMap<String, String>();
        p.put("userId", SystemHelper.LoginUserId);
        if (!SystemHelper.IsAdmin) p.put("storeId", SystemHelper.LoginOrganId);
        p.put("customerMobile", mobile);
        p.put("customerName", name);
        p.put("customerSex", sex);
        p.put("customerBirthday", bir);
        new BaseAppServerTask("update_huiyuan", BaseOldResponse.class, this, "正在更新会员基础信息...", true, "/information/modifyCustomerInfo", p).execute("");
    }

    @Override
    public void netError() {

        btn_save.setEnabled(true);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
        if ("query_huiyuan".equals(tag)) {
            if (null != response) {
                HuiYuanJiChuXinXiResponse res = (HuiYuanJiChuXinXiResponse) response;

                HuiYuanJiChuXinXiEntity huiYuanJiChuXinXiEntity = res.resultInfo;
                if (null != huiYuanJiChuXinXiEntity) {
                    if ("0".equals(huiYuanJiChuXinXiEntity.isMember)) {
                        name = huiYuanJiChuXinXiEntity.customerName;
                        mobile = huiYuanJiChuXinXiEntity.customerMobile;
                        sex = huiYuanJiChuXinXiEntity.customerSex;
                        birthday = huiYuanJiChuXinXiEntity.customerBirthday;
                        isVip = true;
                    } else {
                        mobile = huiyuan;
                        isVip = false;
                    }
                    initData();
                }
            }
        } else if ("update_huiyuan".equals(tag)) {
            btn_save.setEnabled(true);
            if (null != response) {
                showMsg(response.msgContent);
                if ("0".equals(response.sysCode) && "0".equals(((BaseOldResponse) response).msgCode)) {
                    finish();
                }
            }
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case 100:
                String name = data.getStringExtra("name");
                tv_name.setText(name);
                break;
            case 200:
                String phone = data.getStringExtra("phone");
                tv_phone.setText(phone);
                break;
        }

    }
}