package com.urovo.activity.home;

import java.util.ArrayList;
import java.util.List;

import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.HuiYuanKa;
import com.urovo.wgmf.zxing.ZxingCodeTool;
import com.urovo.wugumofang.R;

public class HuiYuanKaActivity extends BaseActivity {

	private ListView listView1;
	private List<HuiYuanKa> list;
	private String store = "--";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.huiyuanka);

		titleTextView = (TextView) findViewById(R.id.text_title);
		titleTextView.setText("发放电子会员卡");
		ImageButton goback = (ImageButton) findViewById(R.id.goback);
		goback.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finish();
			}
		});

		if(SystemHelper.IsAdmin) {
			store = "--";
		}
		else {
			store = Store001DbOprate.GetStoreName(SystemHelper.LoginOrganId);
			if(TextUtils.isEmpty(store)) {
				store = "--";
			}
		}

		list = new ArrayList<HuiYuanKa>();
		list.add(new HuiYuanKa("白羊座", store, R.drawable.bluebg_light, R.drawable.baiyang));
		list.add(new HuiYuanKa("金牛座", store, R.drawable.bluebg_deep, R.drawable.jinniu));
		list.add(new HuiYuanKa("双子座", store, R.drawable.greenbg, R.drawable.shuangzi));
		list.add(new HuiYuanKa("巨蟹座", store, R.drawable.bluebg_light, R.drawable.juxie));
		list.add(new HuiYuanKa("狮子座", store, R.drawable.bluebg_deep, R.drawable.shizi));
		list.add(new HuiYuanKa("处女座", store, R.drawable.greenbg, R.drawable.chunv));
		list.add(new HuiYuanKa("天秤座", store, R.drawable.bluebg_light, R.drawable.tiancheng));
		list.add(new HuiYuanKa("天蝎座", store, R.drawable.bluebg_deep, R.drawable.tianxie));
		list.add(new HuiYuanKa("射手座", store, R.drawable.greenbg, R.drawable.sheshou));
		list.add(new HuiYuanKa("摩羯座", store, R.drawable.bluebg_light, R.drawable.mojie));
		list.add(new HuiYuanKa("水瓶座", store, R.drawable.bluebg_deep, R.drawable.shuiping));
		list.add(new HuiYuanKa("双鱼座", store, R.drawable.greenbg, R.drawable.shuangyu));

		listView1 = (ListView) findViewById(R.id.lv_huiyuanka);
		listView1.setAdapter(new HuiYuanKaAdapter(this, list));
		listView1.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				AlertDialog.Builder builder = new AlertDialog.Builder(HuiYuanKaActivity.this);
				View v = View.inflate(HuiYuanKaActivity.this, R.layout.huiyuanka_erweima, null);
				LinearLayout ll_sendmsg_huiyuanka = (LinearLayout) v.findViewById(R.id.ll_sendmsg_huiyuanka);
				ImageView iv_ma = (ImageView) v.findViewById(R.id.iv_ma);
				Bitmap bit = ZxingCodeTool.create2DCode("xing", 700, 700);
				iv_ma.setImageBitmap(bit);
				final int ptn = position;
				ll_sendmsg_huiyuanka.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						Intent mIntent = new Intent(Intent.ACTION_VIEW);
						mIntent.putExtra("sms_body", list.get(ptn).getName());
						mIntent.setType("vnd.android-dir/mms-sms");
						startActivity(mIntent);
					}
				});
				builder.setView(v);
				AlertDialog alert = builder.create();
				alert.show();
			}
		});
		setListViewHeightBasedOnChildren(listView1);
	}

	private class HuiYuanKaAdapter extends MyBaseAdapter<HuiYuanKa, ListView> {

		public HuiYuanKaAdapter(Context context, List<HuiYuanKa> product) {
			super(product, context);
		}

		@Override
		public View getView(final int position, View convertView, ViewGroup parent) {
			View view;
			final ViewHolder holder;
			if(convertView == null) {
				view = View.inflate(context, R.layout.listview_item_huiyuanka, null);
				holder = new ViewHolder();
				holder.tv_xingzuo_name = (TextView) view.findViewById(R.id.tv_xingzuo_name);
				holder.tv_location_name = (TextView) view.findViewById(R.id.tv_location_name);
				holder.iv_xingzuo = (ImageView) view.findViewById(R.id.iv_xingzuo);
				holder.rl_back = (RelativeLayout) view.findViewById(R.id.rl_back);
				view.setTag(holder);
			}
			else {
				view = convertView;
				holder = (ViewHolder) view.getTag();
			}
			holder.tv_xingzuo_name.setText(lists.get(position).getName());
			holder.tv_location_name.setText(lists.get(position).getLocation());
			holder.iv_xingzuo.setImageResource(lists.get(position).getLogo());
			holder.rl_back.setBackgroundResource(lists.get(position).getBackground());
			return view;
		}
	}

	static class ViewHolder {
		public ImageView iv_xingzuo;
		public TextView tv_xingzuo_name;
		public TextView tv_location_name;
		public RelativeLayout rl_back;
	}

	/**
	 * 动态设置ListView的高度
	 * 
	 * @param listView
	 */
	public static void setListViewHeightBasedOnChildren(ListView listView) {
		if(listView == null)
			return;

		ListAdapter listAdapter = listView.getAdapter();
		if(listAdapter == null) {
			// pre-condition
			return;
		}

		int totalHeight = 0;
		for (int i = 0; i < listAdapter.getCount(); i++) {
			View listItem = listAdapter.getView(i, null, listView);
			listItem.measure(0, 0);
			totalHeight += listItem.getMeasuredHeight();
		}

		ViewGroup.LayoutParams params = listView.getLayoutParams();
		params.height = totalHeight + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
		listView.setLayoutParams(params);
	}
}
