package com.urovo.activity.labelprinter.net;

import com.urovo.activity.labelprinter.ent.LabelPrinterEnt;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.response.CommonEntity;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;

import java.util.List;
import java.util.Map;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 会员营销页面接口
 *
 * @author chenji last on 2018/1/2 19:51
 */

public class LabelPrinterNet {
    private ILabelPrinterNet mILabelPrinterNet;

    /**
     * retrofit的配置
     */
    public LabelPrinterNet() {
        mILabelPrinterNet = RetrofitHelper.createApi(ILabelPrinterNet.class);
    }

    /**
     * 标签打印页面
     *
     * @param presenter ...
     */
    public void start2request(final CommonController.BasePre<List<LabelPrinterEnt>> presenter, Map<String, String> params) {
        final Call<RequestResult<List<LabelPrinterEnt>>> call = mILabelPrinterNet.getLabelPrinterList(params);
        call.enqueue(new ResultCallback<List<LabelPrinterEnt>>() {
            @Override
            public void onResponse(Call<RequestResult<List<LabelPrinterEnt>>> call, Response<RequestResult<List<LabelPrinterEnt>>> response) {
                if (response.code() == 200) {
                    RequestResult<List<LabelPrinterEnt>> responseBody = response.body();
                    //请求失败
                    if (responseBody != null && responseBody.msgCode != 0) {
                        presenter.onFailure(responseBody.msgInfo);
                        SYLoger.print("wgmf --标签打印: " + responseBody.msgInfo);
                    } else {//请求成功
                        SYLoger.print("wgmf --标签打印: " + "onResponseSuccess--" + responseBody.resultInfo);
                        presenter.onResponseSuccess(new CommonEntity<>(responseBody.resultInfo));
                    }
                } else {
                    SYLoger.print("wgmf --标签打印: " + "标签打印页面异常");
                    if (presenter != null) {
                        presenter.onFailure("标签打印页面网络异常");
                    }
                }
            }
        });

//        call.enqueue(new ResultCallback<List<LabelPrinterEnt>>() {
//            @Override
//            protected void onResponseSuccess(RequestResult<List<LabelPrinterEnt>> responseBody) {
////                super.onResponseSuccess(responseBody);
//                SYLoger.print("wgmf --标签打印: " + "onResponseSuccess");
//                if (responseBody.msgCode == 0) {
//                    presenter.onResponseSuccess(new CommonEntity<>(responseBody.resultInfo));
//                    SYLoger.print("wgmf --标签打印: " + responseBody.resultInfo.toString());
//                } else {
//                    SYLoger.print("wgmf --标签打印: " + responseBody.msgInfo);
//                    presenter.onFailure("标签打印页面配置异常！");
//                }
//            }
//
//            @Override
//            public void onFailure(Call<RequestResult<List<LabelPrinterEnt>>> call, Throwable t) {
////                super.onFailure(call, t);
//                SYLoger.print("wgmf --标签打印: " + "onFailure--Throwable");
//                if (t instanceof SocketTimeoutException) {
//                    SYLoger.print("wgmf --标签打印: " + "网络请求超时");
//                }
//
//                if (presenter != null) {
//                    presenter.onFailure("标签打印页面异常：" + t);
//                }
//            }
//        });
    }
}
