package com.urovo.activity.learning;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.tencent.mm.sdk.openapi.IWXAPI;
import com.tencent.mm.sdk.openapi.WXAPIFactory;
import com.umeng.socialize.Config;
import com.umeng.socialize.UMShareListener;
import com.umeng.socialize.bean.SHARE_MEDIA;
import com.umeng.socialize.media.UMImage;
import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wgmf.entity.response.LearningCenterPageNoResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ShareDominator;
import com.urovo.wugumofang.view.baseWebViewAct.BaseWebView;
import com.urovo.wugumofang.view.baseWebViewAct.WebViewAct;

import java.util.HashMap;
import java.util.Map;

import okhttp3.Request;

public class LearningCenterDetailActivity extends BaseActivity implements
        OnClickListener {

    private BaseWebView mWebView;
    private LinearLayout share_weixin_ll;
    private LinearLayout share_friends_ll;
    private LinearLayout share_collect_ll;
    private ImageView share_collect_img;

    private TextView share_weixin_tv;
    private TextView share_friends_tv;
    private TextView share_collect_tv;
    private IWXAPI api;
    private String mDetailTag, mShareTitle, mSharePcUrl, mSharePcId, mIsNeedTest, mTestLink;
    private int mTypeTag;
    private boolean IS_FAVORITED_ARTICLE;
    boolean collectFlag = false;
    private LinearLayout favorite_and_read_ll;
    private TextView favorite_tv, read_num_tv, readed_tv, mExamTv;
    private LinearLayout share_and_favorite_ll, share_enterprise_weixin_ll;
    private int ARTICLE_READ_TIMES_COUNT;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_learning_detail);
        api = WXAPIFactory.createWXAPI(this, NetParam.WXAPP_ID);

        IS_FAVORITED_ARTICLE = getIntent().getBooleanExtra(AppConstants.ExtraKeys.IS_FAVORITED_ARTICLE, false);
        //如果ARTICLE_READ_TIMES_COUNT传进来的值是-1，那就要通过联网获取阅读数（极光推送时的情况）
        ARTICLE_READ_TIMES_COUNT = getIntent().getIntExtra(AppConstants.ExtraKeys.ARTICLE_READ_TIMES_COUNT, 0);

        mTypeTag = TextUtils.isEmpty(getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE)) ?
                1 : Integer.parseInt(getIntent().getStringExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE));
        mDetailTag = getIntent().getStringExtra("detailTag");
        mShareTitle = getIntent().getStringExtra("title");
        mSharePcUrl = getIntent().getStringExtra("articleUrl");
        mSharePcId = getIntent().getStringExtra("articleId");
        mIsNeedTest = getIntent().getStringExtra("isNeedTest");
        mTestLink = getIntent().getStringExtra("testLink");

		/*//临时添加for test
        new AlertDialog.Builder(this).setMessage("articleUrl值为："+mSharePcUrl).create().show();*/
        //Log.d("SasukeLog","articleUrl值为："+mSharePcUrl);
        initTitle();
        initContent();

        browsingHistory(mSharePcId);//更新阅读数
    }

    @SuppressLint("SetJavaScriptEnabled")
    @SuppressWarnings("unchecked")
    private void initContent() {
        titleTextView.setText(mShareTitle);
        share_weixin_ll = (LinearLayout) findViewById(R.id.share_weixin_ll);
        share_friends_ll = (LinearLayout) findViewById(R.id.share_friends_ll);
        share_collect_ll = (LinearLayout) findViewById(R.id.share_collect_ll);
        share_collect_img = (ImageView) findViewById(R.id.share_collect_img);
        share_weixin_tv = (TextView) findViewById(R.id.share_weixin_tv);
        share_friends_tv = (TextView) findViewById(R.id.share_friends_tv);
        share_collect_tv = (TextView) findViewById(R.id.share_collect_tv);
        share_enterprise_weixin_ll = findViewById(R.id.share_enterprise_weixin_ll);

        mWebView = (BaseWebView) findViewById(R.id.learning_detail_webview);
//        mWebView.removeJavascriptInterface("");
//        mWebView.removeJavascriptInterface("searchBoxJavaBridge_");
//        mWebView.removeJavascriptInterface("accessibility");
//        mWebView.removeJavascriptInterface("accessibilityTraversal");
        mWebView.addProgressBar();
        favorite_and_read_ll = (LinearLayout) findViewById(R.id.favorite_and_read_ll);
        favorite_tv = (TextView) findViewById(R.id.favorite_tv);
        read_num_tv = (TextView) findViewById(R.id.read_num_tv);
        readed_tv = (TextView) findViewById(R.id.readed_tv);
        mExamTv = findViewById(R.id.exam_tv);
        share_and_favorite_ll = (LinearLayout) findViewById(R.id.share_and_favorite_ll);
        share_weixin_ll.setOnClickListener(this);
        share_enterprise_weixin_ll.setOnClickListener(this);
        share_friends_ll.setOnClickListener(this);
        share_collect_ll.setOnClickListener(this);
        favorite_tv.setOnClickListener(this);
        mExamTv.setOnClickListener(this);
        if (mTypeTag == 1) {//学习中心
            favorite_and_read_ll.setVisibility(View.VISIBLE);
            share_and_favorite_ll.setVisibility(View.GONE);
            //在原来的数据上，默认+1
            read_num_tv.setText(ARTICLE_READ_TIMES_COUNT + 1 + "次");
            if (ARTICLE_READ_TIMES_COUNT == -1) {//如果是-1，说明是通过极光推送点击监听器传到这边来的，则重新联网获取阅读数
                Map<String, String> params = new HashMap<String, String>();
                params.put("empNo", SystemHelper.LoginUserId);
                params.put("articleId", mSharePcId);
                params.put("type", "1");
                new BaseAppSalerServerTask("getReadTimeAndStore", LearnReadTimeResponse.class, this,
                        "正在加载...", true, NetParam.LEARNINGCENTER_GET_READTIME_AND_STORE, params).execute("");
            }
        } else {//养生文库
            favorite_and_read_ll.setVisibility(View.GONE);
            share_and_favorite_ll.setVisibility(View.VISIBLE);

        }
        if ("1".equals(mIsNeedTest)&&!TextUtils.isEmpty(mTestLink)) {
            mExamTv.setVisibility(View.VISIBLE);
        } else {
            mExamTv.setVisibility(View.GONE);
        }


        showViewForIsFavorite(IS_FAVORITED_ARTICLE);

//        mWebView.getSettings().setJavaScriptEnabled(true);
//        mWebView.getSettings().setSavePassword(false);//webview不要保存密码，官方未来会不支持保存密码
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
//            mWebView.getSettings().setMixedContentMode(WebSettings.MIXED_CONTENT_ALWAYS_ALLOW);//解决不加载图片问题
//        }
//        mWebView.getSettings().setBlockNetworkImage(false);//解决不加载图片问题
//        mWebView.setWebViewClient(new WebViewClient() {
//            @Override
//            public boolean shouldOverrideUrlLoading(WebView view, String url) {
//                view.loadUrl(url);
//                return true;
//            }
//
//            @Override
//            public void onReceivedError(WebView view, int errorCode,
//                                        String description, String failingUrl) {
//
//            }
//        });
//        CookieDominator.setCommonCookie(mSharePcUrl);
//        mWebView.loadUrl(mSharePcUrl);
        if (!TextUtils.isEmpty(mSharePcUrl)) {
            mWebView.loadMessageUrl(mSharePcUrl, SystemHelper.LoginUserId);
        }

    }

    private void showViewForIsFavorite(boolean isFavorite) {
        Drawable drawable;
        IS_FAVORITED_ARTICLE = isFavorite;
        if (isFavorite) {
            share_collect_img.setImageResource(R.drawable.collected);
            share_collect_tv.setText("取消收藏");
            drawable = getResources().getDrawable(R.drawable.collected);
            favorite_tv.setText("取消收藏");
        } else {
            share_collect_img.setImageResource(R.drawable.collect);
            share_collect_tv.setText("收藏");
            drawable = getResources().getDrawable(R.drawable.collect);
            favorite_tv.setText("收藏");
        }
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        favorite_tv.setCompoundDrawables(null, drawable, null, null);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (!"0".equals(response.sysCode) || null == response) {
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
            return;
        } else if ("0".equals(((BaseOldResponse) response).msgCode)) {
            if ("collectTask".equals(tag)) {
                showMsg("已收藏");
                showViewForIsFavorite(true);
            } else if ("cancelCollectTask".equals(tag)) {
                showMsg("已取消收藏");
                showViewForIsFavorite(false);
            } else if ("getReadTimeAndStore".equals(tag)) {//获取阅读数之类的东西
                LearnReadTimeResponse entity = (LearnReadTimeResponse) response;
                if (entity != null && entity.getResultInfo() != null) {
                    if (entity.getResultInfo().getStore().equals("0")) {//是否已收藏，0未收藏，1已收藏 ,
                        showViewForIsFavorite(false);
                    } else {
                        showViewForIsFavorite(true);
                    }
                    read_num_tv.setText(entity.getResultInfo().getReadTimesCount() + "次");//这里是极光推送推过来的，已协商后台加1，所以我们这边不用手动加1了
                }
            }
        }
    }

    /**
     * 分享或收藏的目标场景，通过修改scene场景值实现。 发送到聊天界面——WXSceneSession
     * 发送到朋友圈——WXSceneTimeline 添加到微信收藏——WXSceneFavorite
     */
    @Override
    public void onClick(View view) {
        ProgressDialog dialog = new ProgressDialog(this);
        dialog.setTitle("启动分享中");
        dialog.setMessage("请稍等.....");
        Config.dialog = dialog;
        UMImage image = new UMImage(LearningCenterDetailActivity.this, BitmapFactory.decodeResource(getResources(), R.drawable.wgmf_logo));

        switch (view.getId()) {//链接后面的type，1是会员商品转发，2是养生文库
            case R.id.share_enterprise_weixin_ll://企业微信
                ShareDominator.doEnterpriseShare(mSharePcUrl, mShareTitle, mShareTitle, "", "2");
                buryPoint(2);//埋点
                break;
            case R.id.share_weixin_ll:// 微信好友（注：必须要用正式包的签名才能转发，否则就只会闪一下）
                ShareDominator.doFriendsShare(this, mSharePcUrl, mShareTitle, mShareTitle, image, "2");
                buryPoint(1);//埋点
//                String weixinUrl = mSharePcUrl + (mSharePcUrl.contains("?") ? "&" : "?") + "time=" + Calendar.getInstance().getTimeInMillis() + "&userName=" + SystemHelper.LoginUserId ;
//                new ShareAction(this).setPlatform(SHARE_MEDIA.WEIXIN)/*.setCallback(umShareListener)*/
//                        .withMedia(image)
//                        .withText(mShareTitle)
//                        .withTitle(mShareTitle)//因样式问题，这个不用title
//                        .withTargetUrl(NetParam.shareWeixinByRedirect(weixinUrl,SystemHelper.LoginOrganId,SystemHelper.LoginUserId ,"2"))
////                         .withTargetUrl(weixinUrl)
//                        .share();
                break;
            case R.id.share_friends_ll:// 微信朋友圈
                ShareDominator.doCircleWxShare(this, mSharePcUrl, mShareTitle, mShareTitle, image, "2");
                buryPoint(0);//埋点

//                String weixinUrl2 = mSharePcUrl + (mSharePcUrl.contains("?") ? "&" : "?") + "time=" + Calendar.getInstance().getTimeInMillis() + "&userName=" + SystemHelper.LoginUserId + "&type=2";
//                new ShareAction(this).setPlatform(SHARE_MEDIA.WEIXIN_CIRCLE)/*.setCallback(umShareListener)*/
//                        .withMedia(image)
//                        .withText(mShareTitle)
//                        .withTitle(mShareTitle)
//                        .withTargetUrl(NetParam.shareWeixinByRedirect(weixinUrl2,SystemHelper.LoginOrganId,SystemHelper.LoginUserId,"2"))
////                        .withTargetUrl(weixinUrl2)
//                        .share();
                break;
            case R.id.favorite_tv:
            case R.id.share_collect_ll:
                Map<String, String> params = new HashMap<String, String>();
                params.put("empNo", SystemHelper.LoginUserId);
                params.put("type", mTypeTag + "");
                if (IS_FAVORITED_ARTICLE) {
                    params.put("articleIds", mSharePcId);
                    new BaseAppSalerServerTask("cancelCollectTask",
                            BaseOldResponse.class, LearningCenterDetailActivity.this,
                            "", true, "/learn/cancelStoreLearnArticle", params)
                            .execute("");
                } else {
                    params.put("articleId", mSharePcId);
                    new BaseAppSalerServerTask("collectTask", BaseOldResponse.class,
                            LearningCenterDetailActivity.this, "", true,
                            "/learn/storeLearnArticle", params).execute("");
                }
                break;
            case R.id.exam_tv: //去考試
                if (!TextUtils.isEmpty(mTestLink)) {
                    WebViewAct.launch(LearningCenterDetailActivity.this,SystemHelper.LoginUserId,"去考试",mTestLink);
                }
                break;
            default:
                break;
        }
    }

    /**
     * 分享回调（并没有用。。。。用你打鬼。。。每次回调都是分享成功。。）
     */
    private UMShareListener umShareListener = new UMShareListener() {
        @Override
        public void onResult(SHARE_MEDIA platform) {
//			Log.d("plat", "platform" + platform);
            Intent intent = new Intent("com.urovo.wugumofang.MemberProfileAct.shareReceiver");
            intent.putExtra("TAG", "isShared");
            sendBroadcast(intent);
            showMsg("分享成功");
            //Toast.makeText(LearningCenterDetailActivity.this, "分享成功", Toast.LENGTH_SHORT).show();
            //埋点（只有是养生文库的时候，才进行分享埋点）
            if (mTypeTag == 2) {
                if (platform.name().equals("WEIXIN")) {//分享给朋友
                    buryPoint(1);
                } else if (platform.name().equals("WEIXIN_CIRCLE")) {//分享到朋友圈
                    buryPoint(0);
                }
            }
        }

        @Override
        public void onError(SHARE_MEDIA platform, Throwable t) {
            showMsg("分享失败");
            //Toast.makeText(LearningCenterDetailActivity.this, "分享失败", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onCancel(SHARE_MEDIA platform) {
            showMsg("分享取消");
            //Toast.makeText(LearningCenterDetailActivity.this, "分享取消", Toast.LENGTH_SHORT).show();
        }
    };

    /**
     * 分享成功 埋点
     * type  0:分享到朋友圈,1:分享给朋友 2:企业微信
     */
    public void buryPoint(int type) {
        HashMap<String, String> param = new HashMap<>();
        param.put("staffId", SystemHelper.LoginUserId);
        param.put("shopId", SystemHelper.LoginOrganId);
        param.put("type", type + "");
        param.put("articleId", mSharePcId);
        param.put("articleTitle", mShareTitle);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.MESSAGE_ARTICLE_BURYPOINT, param,
                new OkHttpDominator.ResultCallback<BaseSimpleResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(BaseSimpleResponse response) {

                    }
                });
    }

    /**
     * post /learn/updateReadTimesCount	 更新文章阅读次数
     */
    private void browsingHistory(String articleId) {
        Map<String, String> params = new HashMap<String, String>();
        String queryUrl = "/learn/updateReadTimesCount";
        params.put("articleId", articleId);
        params.put("stype", mTypeTag + "");
        params.put("empNo", SystemHelper.LoginUserId);
        params.put("shopId", SystemHelper.LoginOrganId);
        new BaseAppSalerServerTask("browsingHistory",
                LearningCenterPageNoResponse.class, this, "正在....", false,
                queryUrl, params).execute("");
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        mWebView.destroyWebView();
    }
}
