package com.urovo.activity.learningsearch.presenter;

import android.text.TextUtils;

import com.urovo.activity.learningsearch.model.SearchData;
import com.urovo.activity.learningsearch.net.LearnResultRes;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;

import java.util.HashMap;

import okhttp3.Request;

/**
 * Created by Sasuke on 2017/3/7.
 */

public class LearnSearchPresenter implements LearnSearchContract.presenter{
    LearnSearchContract.view mView;//Fragment
    SearchData data;
    public LearnSearchPresenter(LearnSearchContract.view mView) {
        this.mView = mView;
        this.mView.setPresenter(this);
    }

    public SearchData getData() {
        if(data == null){
            data = new SearchData();
        }
        return data;
    }

    @Override
    public void start() {
        mView.initUI();
    }

    /**
     * 请求搜索文章
     * @param keyWord
     */
    public void searchArticle(String keyWord){
        if(TextUtils.isEmpty(keyWord)){//空关键字不给搜索。
            return;
        }
        mView.showLoading();
//        getData().setKeyWord(keyWord);
        HashMap<String,String > params = new HashMap<>();
        params.put("keyWorld",keyWord);//擦。。。这个不是 关键世界？？？
        params.put("type",getData().getType() +"");
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.LEARN_FIND
                                                , params
                                                , new OkHttpDominator.ResultCallback<LearnResultRes>() {
                                                    @Override
                                                    public void onError(Request request, Exception e) {
                                                        mView.showAlert("网络异常");
                                                    }

                                                    @Override
                                                    public void onResponse(LearnResultRes response) {
                                                        //以下设置data的resultList
                                                        if(response == null || response.getResultList().size() == 0){
                                                            mView.showAlert("没有搜索到结果");
                                                        }else{
                                                            getData().setSearchList(response.getResultList());
                                                            mView.showResultList();
                                                        }
                                                    }
                                                });
    }
}
