package com.urovo.activity.learningsearch.ui;

import android.content.Context;
import android.graphics.Color;
import android.text.SpannableString;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.urovo.activity.learningsearch.model.SearchData;
import com.urovo.activity.learningsearch.net.LearnResultRes;
import com.urovo.wugumofang.ui.TextColorDominator;
import com.urovo.wugumofang.R;

import java.util.List;

/**
 * Created by Sasuke on 2017/3/8.
 */

public class ResultAdapter extends BaseAdapter {
    List<LearnResultRes.ResultListBean> resultList;
    SearchData data;
    Context context;

    public ResultAdapter(Context context, SearchData data) {
        this.context = context;
        this.data = data;
        this.resultList = data.getSearchList();
    }

    @Override
    public int getCount() {
        return resultList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        Holder holder;
        if (convertView == null) {
            holder = new Holder();
            convertView = LayoutInflater.from(context).inflate(R.layout.listview_item_message, null);
            holder.mTextViewContent = (TextView) convertView
                    .findViewById(R.id.textViewContent);
            holder.mTextViewDate = (TextView) convertView
                    .findViewById(R.id.textViewDate);
            //感觉就上面两个有用。
            holder.mImageViewNew = (ImageView) convertView
                    .findViewById(R.id.imageViewNew);
            holder.mTextViewLabel = (TextView) convertView
                    .findViewById(R.id.textViewLabel);
            holder.mTextViewTitle = (TextView) convertView
                    .findViewById(R.id.textViewTitle);
            holder.mImgState = (ImageView) convertView
                    .findViewById(R.id.ivActiveState);
            holder.mBtnMore = (Button) convertView
                    .findViewById(R.id.bt_more);
            convertView.setTag(holder);
        } else {
            holder = (Holder) convertView.getTag();
        }
        LearnResultRes.ResultListBean item = resultList.get(position);
        //搜索结果改变局部颜色
        holder.mTextViewContent.setText(item.getTitle());
        if (item.getTitle().contains(data.getKeyWord())){
            SpannableString span = TextColorDominator.textColorChange(0,Color.YELLOW,item.getTitle(),data.getKeyWord());
            holder.mTextViewContent.setText(span);
        }
        holder.mTextViewDate.setText(item.getCreateTime());
        holder.mImageViewNew.setVisibility(View.INVISIBLE);
        return convertView;
    }

    class Holder {
        ImageView mImageViewNew;
        TextView mTextViewLabel;
        TextView mTextViewTitle;
        TextView mTextViewContent;//卡片内容
        ImageView mImgState;
        TextView mTextViewDate;//卡片日期
        Button mBtnMore;
    }


}
