package com.urovo.activity.login.view

import android.annotation.SuppressLint
import android.app.AlertDialog
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.graphics.Paint
import android.graphics.drawable.BitmapDrawable
import android.os.Build
import android.os.Bundle
import android.text.Html
import android.text.TextUtils
import android.view.*
import android.widget.AdapterView
import android.widget.ArrayAdapter
import android.widget.ListView
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentTransaction
import cn.jpush.android.api.JPushInterface
import com.alibaba.android.arouter.facade.annotation.Route
import com.alibaba.android.arouter.launcher.ARouter
import com.taobao.sophix.SophixManager
import com.umeng.analytics.MobclickAgent
import com.urovo.activity.login.presenter.LoginContract
import com.urovo.activity.login.presenter.LoginPresenter
import com.urovo.activity.machinerepairact.view.MachineEngineerAct
import com.urovo.activity.systemsetting.SystemSettingPassword
import com.urovo.activity.tabMenu.view.SecondProcessAct
import com.urovo.wgmf.db.dao.bill.DalCommon
import com.urovo.wgmf.db.dao.dao.MsgOperate
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate
import com.urovo.wgmf.db.dao.dao.Store001DbOprate
import com.urovo.wgmf.db.dao.dao.Table_toposDbOperate
import com.urovo.wgmf.ext.afterTextChanged
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.RouterParams
import com.urovo.wugumofang.data.PreferHelper
import com.urovo.wugumofang.loader.PrivilegeDownloader
import com.urovo.wugumofang.net.HttpUtil
import com.urovo.wugumofang.response.BaseResponse
import com.urovo.wugumofang.system.*
import com.urovo.wugumofang.ui.DialogHelper
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.ui.vibrate
import com.urovo.wugumofang.utils.LogReaderUtil
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.view.CustomPopupWindow
import com.wgmf.trade.model.data.net.interactor.impl.EnvironmentSwitchIntImpl
import com.wgmf.trade.ui.fra.more.setting.EnvironmentSwitchFra
import com.zsy.libcore.common.android.log.SYLoger
import com.zsy.libext.support.DoubleClickExitHelper
import kotlinx.android.synthetic.main.login2.*
import java.io.Serializable

/**
 * Created by Sasuke on 2017/9/12.
 * 新版3.0登陆界面（只做两件事：1、刚进界面时验证APP版本  2、验证门店  3、验证用户账号密码）
 */
@Route(path = RouterParams.ORIGIN.LOGINACTIVITY)
class LoginActivity : BaseActivity(), LoginContract.view {
    lateinit var mPre: LoginPresenter
    val mDoubleClickExitHelper: DoubleClickExitHelper by lazy {
        DoubleClickExitHelper(this)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
//        SecondProcessAct.preLoadProcess(this)//预加载第二进程
        window.setBackgroundDrawable(null)
        SecondProcessAct.preLoadProcess(this)//预加载第二进程
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) window.addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
        super.onCreate(savedInstanceState)
        setContentView(R.layout.login2)
//        AccessibilityUtil.checkTopStackPermission(this,"请先开启生意管家考勤辅助功能：‘生意管家’-->‘开启服务’",TrackerService::class.java)
        mPre = LoginPresenter(this)
        mPre.requestPermissions()
        mPre.getRetCodeInfo()
        mPre.downloadBackground(backgroundImage)
        mPre.start()
        mPre.getServerVersion(PdaMsgConfig.getLogUserId(this))
        mPre.loginInfoRecord(PdaMsgConfig.getLogUserId(this))
        //验证是否需要打开欢迎界面（新版本前三天，每天第一次打开APP时进入欢迎界面，
        // 通过本地判断是否当天第一次打开&后台判断是否新版三天内）,
        mPre.checkIsShowWelcome()//是否显示新功能介绍
        mPre.checkIsShowAdPage()//是否显示广告页（职业宣言）
        if (BaseAppManager.isOpen2SophixFlag) {
            SophixManager.getInstance().queryAndLoadNewPatch()
        }// 热修复请求
//        loginBtn.setText("热修复成功啦！！！")
    }

    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        setIntent(intent)
        mPre.loginInfoRecord(PdaMsgConfig.getLogUserId(this))
    }

    override fun setPresenter(pre: LoginContract.presenter?) {
        mPre = pre as LoginPresenter
    }

    override fun getName(): String {
        return "登录"
    }

    @SuppressLint("HardwareIds")
    override fun init() {
        //初始化本地权限映射表
        PrivilegeDbOperate.initPrivilegeMap(this)
        PdaMsgConfig.setIsAdmin(false, this)
        SystemHelper.IsAdmin = PdaMsgConfig.getIsAdmin(this)
        val tm = getSystemService(Context.TELEPHONY_SERVICE) as android.telephony.TelephonyManager
        try {
            SystemHelper.Imei =
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) tm.getImei() else tm.getDeviceId()
        } catch (e: SecurityException) {
            SystemHelper.Imei = ""
            e.printStackTrace()
        }

        val wifi =
            BaseAppManager.appContext().applicationContext.getSystemService(Context.WIFI_SERVICE) as android.net.wifi.WifiManager
        SystemHelper.Mac = wifi.connectionInfo.macAddress
        SystemHelper.LoginOrganId = PdaMsgConfig.getLoginOrgID(this)
        SystemHelper.LoginOrganName = PdaMsgConfig.getLoginOrganName(this)
        //主管id 和主管Name
        SystemHelper.LoginZgId = Store001DbOprate.getZgNo(SystemHelper.LoginOrganId)
        SystemHelper.LoginZgName = Store001DbOprate.getZgName(SystemHelper.LoginOrganId)
        Table_toposDbOperate.markBrand()

        try {
            val info = packageManager.getPackageInfo(packageName, 0)
            SystemHelper.Version = info.versionName
        } catch (e: PackageManager.NameNotFoundException) {
            SystemHelper.Version = "null"
        }

        SystemHelper.AndroidVersion = android.os.Build.VERSION.RELEASE
        //据说这个是要设置什么用户代理用。。。
        HttpUtil.setVersionInfo(SystemHelper.Version, SystemHelper.AndroidVersion)

        //按住登陆键，往下滑，再松手，即可复制用GZIP压缩过的崩溃日志。用于反馈。
        loginBtn.setOnTouchListener { v, event ->
            when (event.action) {
                MotionEvent.ACTION_DOWN -> yPos0 = event.rawY
                MotionEvent.ACTION_MOVE -> yPosNew = event.rawY
                MotionEvent.ACTION_UP -> {
                    if (yPosNew > yPos0 && yPosNew - yPos0 > 300) {
                        LogReaderUtil.copyLog2Clipboard(this@LoginActivity)
                    }
                }
            }
            false
        }
    }

    var yPos0: Float = 0f
    var yPosNew: Float = 0f


    /**
     * 默认显示
     */
    override fun refreshUI() {
        //门店名显示
        orgNameEdittext.setText(Store001DbOprate.GetStoreName(SystemHelper.LoginOrganId))
        arrayOf(userNameEditText, orgIdEdittext).forEach { it ->
            when (it) {
                orgIdEdittext -> it.setText(SystemHelper.LoginOrganId)
                userNameEditText -> it.setText(PdaMsgConfig.getLogUserId(this@LoginActivity))
            }
            it.setSelection(it.text.toString().length)//光标定位到末端
            if (it.text.toString().isNullOrBlank()) focus(it)
        }
    }

    override fun initUI() {
        refreshUI()
        //记住密码
        passCheckBox.apply {
            isChecked = PreferHelper.getInstance()
                .getBoolean(AppConstants.PreKeys.IS_REMEMBER_PASSWORD, false)
            setOnCheckedChangeListener { buttonView, isChecked ->
                PreferHelper.getInstance()
                    .setBoolean(AppConstants.PreKeys.IS_REMEMBER_PASSWORD, isChecked)
            }
        }
        userNameEditText.apply {
            //用户工号输入框
            setSingleLine()
            setOnClickListener {
                rootScrollview.apply { smoothScrollTo(0, height) }//弹出键盘后都将界面移到最底下
                focus(userNameEditText)
            }
        }
        passEditText.apply {
            setText(if (passCheckBox.isChecked) PdaMsgConfig.getPassWord(this@LoginActivity) else "")
            setOnClickListener {
                rootScrollview.apply { smoothScrollTo(0, height) }//弹出键盘后都将界面移到最底下
                focus(passEditText)
            }
        }
        //历史门店记录
        moreOrgBtn.setOnClickListener { popupSavedOrgCodes() }
        //切换焦点时只验证不登陆
        orgIdEdittext.setOnFocusChangeListener { v, hasFocus ->
            if (!hasFocus) checkOrgId(
                orgIdEdittext.text.toString(),
                false
            )
        }
        //一边输入一边校验，并及时改变登陆按钮的状态
        arrayOf(orgIdEdittext, userNameEditText, passEditText).forEach {
            it.afterTextChanged { loginBtn.isEnabled = checkLoginBtnEnability() }
        }

        //忘记密码？
        resetPasswordTv.apply {
            //下划线
            paintFlags = Paint.UNDERLINE_TEXT_FLAG
            //抗锯齿
            paint.isAntiAlias = true
            setOnClickListener {
                ARouter.getInstance().build(RouterParams.ORIGIN.VERIFYACCOUNTACT)
                    .withString("userId", userNameEditText.getText().toString())
                    .navigation()
//                PhotoGalleryDominator.show(this@LoginActivity, null,0)
            }
        }
        loginBtn.setOnClickListener { login() }
        loginBtn.isEnabled = checkLoginBtnEnability()

        //环境显示
        val environmentSwitchInt = EnvironmentSwitchIntImpl()
        tips_login_tv.apply {
            //visibility =
            //    (if (environmentSwitchInt.envStatus != EnvironmentHelper.ENV_DEFAULT) View.VISIBLE else View.GONE)
            text = environmentSwitchInt.showEnvName(environmentSwitchInt.envStatus, true)
            setOnLongClickListener {
                val environmentSwitchFra = EnvironmentSwitchFra()
                val ft: FragmentTransaction = supportFragmentManager.beginTransaction()
                val fragment: Fragment? = supportFragmentManager.findFragmentByTag(environmentSwitchFra.getTag())
                if (null != fragment) {
                    ft.remove(fragment)
                }
                environmentSwitchFra.show(ft,environmentSwitchFra.tag)
                return@setOnLongClickListener false
            }
        }

        //极光推送 debug模式+通知栏自定义
        // You can enable debug mode in developing state. You should close debug mode when release.
        JPushInterface.setDebugMode(environmentSwitchInt.getEnvStatus() != EnvironmentHelper.ENV_DEFAULT)//极光推送在测试环境下给设成debugMode
        try {
            val version = "V" + packageManager.getPackageInfo(packageName, 0).versionName
            textViewVersion.text = version
            textViewVersion.setOnLongClickListener {
                showDialog()
            }
        } catch (e: PackageManager.NameNotFoundException) {
            textViewVersion.text = ""
        }
    }

    /**
     * 判断登陆按钮的enable状态（必须每栏都有填才能enable）
     */
    fun checkLoginBtnEnability(): Boolean {
        arrayOf(orgIdEdittext, userNameEditText, passEditText).forEach {
            if (it.text?.toString().isNullOrEmpty()) return false
        }
        return true
    }

    /**
     * 清除App所有数据
     */
    private fun showDialog(): Boolean {
        DialogHelper.Alert(this,
            Html.fromHtml("提示：<font color='#ff0000'><small>(需手动重启)</small></font>"),
            "请点击清除数据!",
            null,
            { _, _ ->
                //确认按钮
                BaseAppManager.getInstance().clearApplicationData()
                android.os.Process.killProcess(android.os.Process.myPid())
//            RestartApp.restart(this@LoginActivity)
            }) { _, _ ->
            //取消按钮
        }
        return false
    }

    /**
     * 兼容老的版本检测
     */
    override fun displayResult(tag: String?, response: BaseResponse?) {
        super.displayResult(tag, response)
    }

    val orgPop: CustomPopupWindow by lazy {
        CustomPopupWindow.Builder(this)
            .setContentView(R.layout.popup_list_ll)
            .setFouse(true)
            .setOutSideCancel(true)
            .setAnimationStyle(R.style.dropmenu_anim_style)
            .setBackgroundDrawable(BitmapDrawable())
            .setwidth(ViewGroup.LayoutParams.WRAP_CONTENT)
            .setheight(ViewGroup.LayoutParams.WRAP_CONTENT)
            .builder()
    }

    /**
     * 弹出保存的已登录过的门店号（预设最多5个，可在LoginData.class里修改）
     */
    protected fun popupSavedOrgCodes() {
        val array = mPre.orgsArray
        if (array.size == 1 && array[0].isNullOrBlank()) return
        orgPop?.let {
            (orgPop.getItemView(R.id.popup_list) as ListView?)?.apply {
                adapter = ArrayAdapter(this@LoginActivity, R.layout.text_view_layout, array)
                onItemClickListener =
                    AdapterView.OnItemClickListener { parent, view, position, id ->
                        orgIdEdittext.setText(array[position])
                        focus(orgIdEdittext)
                        orgIdEdittext.setSelection(orgIdEdittext.text.toString().length)//光标移到最后一位
                        orgPop.dismiss()
                    }
            }
        }
        orgPop?.showAsLocation(orgIdEdittext, Gravity.BOTTOM, 0, 0)
    }


    /**
     * 验证门店
     * isLogin: 是否验证完门店自动一并登陆（因为有时候是直接点击登陆按钮，而此时焦点未切换，门店未验证，所以这种验证门店的情况下，需要一并登陆）
     */
    fun checkOrgId(orgId: String, isLogin: Boolean) {
        if (orgId.isNullOrBlank()) {//输入为空
            orgIdEdittext.setText(SystemHelper.LoginOrganId)
            showMsg(
                if (!SystemHelper.LoginOrganId.isNullOrBlank())
                    "您未输入任何门店或机构号，系统自动使用上一次的门店或机构号！" else "请输入门店或机构号"
            )
            return
        }
        //输入不为空，是纯数字，或不是纯数字但长度为8
        if (!TextUtils.isDigitsOnly(orgId) && orgId.length != 8) {
            showMsg("请输入合法的门店或机构号")
            orgNameEdittext.setText("")
            return
        }
        //如果变换焦点时，门店被切换了，要把旧门店的基础资料的时间戳也清除掉。
        if (orgId != PdaMsgConfig.getLoginOrgID(this@LoginActivity)) {
            Table_toposDbOperate.deleteBy(null)
            MsgOperate.deleteBy(null)//切换门店时要把消息中心的“销售活动”和“通知公告”的数据库也删掉。避免重复。
            DalCommon.DeleteBaseData();//清除基础资料db，以便于切换门店后，如果新门店没有缓存，则老门店的缓存会残留 的漏洞。
        }
        mPre.checkStoreValid(orgId, isLogin)
    }

    /**
     *  恢复显示旧门店号
     */
    override fun resetOrgIdVibrate() {
        vibrate(orgIdEdittext)//摇一摇
        orgIdEdittext.setText(SystemHelper.LoginOrganId)
    }

    /**
     * 按下登陆按钮
     */
    override fun login() {
        val orgId = orgIdEdittext.text.toString().trim()
        if (orgId.isNullOrBlank()) {
            showMsg("登录前请输入合法的门店或机构号")
            return
        }

        //如果修改了门店号
        if (orgId != SystemHelper.LoginOrganId || orgNameEdittext.toString().isNullOrBlank()) {
            checkOrgId(orgId, true)//验证完门店后紧接着自动验证用户，一步到位。
            showMsg("正在切换至" + orgId + "门店机构！")
            return
        } else if (mPre.isStrongCheckStore(orgId)) {
            checkOrgId(orgId, true)
            showMsg("正在重新验证" + orgId + "门店机构！")
            return
        }
        //能通过上面的门店验证，才能进行下面的验证用户
        arrayOf(userNameEditText, passEditText).forEach { it ->
            if (it.text.toString().isNullOrBlank()) {
                showMsg("登陆${if (it == userNameEditText) "工号" else "密码"}不能为空！")
                return
            }
        }
        //验证用户
        val userId = userNameEditText.text.toString()
        val password = passEditText.text.toString()
        when (mPre.checkOffline(orgId, userId, password)) {
            false -> mPre.loginOnline(orgId, userId, password)//本地验证失败、那就远程验证
            true -> {//本地验证成功,离线
                SYLoger.print("兼职：离线（offline）验证登录")
//                PdaMsgConfig.setLoginUserRole(this,)
                mPre.initAfterLogin(
                    orgId,
                    userId,
                    password/*, PdaMsgConfig.getLoginUserRole(this)*/,
                    false
                )
                loginSuccessJump(userId, password)//验证成功了，跳啊！！
            }
        }
    }


    /**
     * 登陆成功后的跳转
     */
    override fun loginSuccessJump(userId: String, password: String) {
        mPre.getRetCodeInfo()
        when (true) {
            //跳转兼职人员页面
            SystemHelper.IsPartTimeStaff -> {
                startActivityAndFinish(PartTimeStaffAct::class.java, null); return
            }
            //跳转兼职销售人员页面
            SystemHelper.IsPartTimeSalesStaff -> {
                mPre.startActivityWithDeclaration(userId.trim()); return/*ToActivity.toActivity(this, PartTimeSalesStaffAct::class.java)*/
            }
            //跳转机修工程师页面
            SystemHelper.IsMachineRepairStaff -> {
                //要先跳个主页，因为主页有绑定极光推送的逻辑，还有基础资料下载需要
                startActivity(Intent(this@LoginActivity, MachineEngineerAct::class.java)); return
            }
        }

        //下载权限资料后再跳转主页
        PrivilegeDownloader(this, userId, orgIdEdittext.text.toString().trim()) {
            //跳转修改密码（兼职人员和兼职销售不需要改密码）
            if (userId.trim() == password) {
                startActivity(
                    Intent(
                        this@LoginActivity,
                        SystemSettingPassword::class.java
                    )
                )//账号密码相同，进入修改密码界面。
            } else {
                //跳转真正的主页
                startActivityAndFinish(null, RouterParams.ORIGIN.TABMENUACTIVITY)
            }
        }.download()

    }

    /**
     * 跳转修改密码界面
     */
    override fun popDialog2SettingPassword(msg: String?) {
        AlertDialog.Builder(this)
            .setMessage(msg)
            .setCancelable(false)
            .setPositiveButton("好的") {//传一个 （"extras","SttingMenu"）的Intent，表示从设置跳过来的，
                // 虽然不是真的从设置跳过来，但这样可以实现不自动跳转TabMenuActivity，毕竟从这里跳到主页，用户名都没初始完
                    dialog, which ->
                this@LoginActivity.startActivity(
                    Intent(
                        this@LoginActivity,
                        SystemSettingPassword::class.java
                    ).apply { putExtra("extras", "SttingMenu") })
            }.create().show()
    }

    /**
     * 跳转界面并关闭登陆界面
     */
    override fun startActivityAndFinish(activityClass: Class<*>?, routerAct: String?) {
        //跳转欢迎界面
        if (mPre.data.isShowGuidePage) {
            ARouter.getInstance().build(RouterParams.ORIGIN.NEWGUIDEACTIVITY)
                .withSerializable(AppConstants.PreKeys.NEW_GUIDE_FROM, this.javaClass)
                .withSerializable(
                    AppConstants.ExtraKeys.INTENT_SIGNALS,
                    mPre.getData().getGuideSignal()
                )
                .withSerializable(
                    AppConstants.ExtraKeys.INTENT_DECLARATION_TEXT,
                    mPre.getData().getDeclarationTexts() as Serializable
                )
                .withBoolean(AppConstants.ExtraKeys.PART_TIME_STAFF, SystemHelper.IsPartTimeStaff)
                .withBoolean(
                    AppConstants.ExtraKeys.PART_TIME_SALES_STAFF,
                    SystemHelper.IsPartTimeSalesStaff
                )
                .navigation()
            return
        }
        if (routerAct != null) {
            ARouter.getInstance().build(routerAct).navigation()
        } else if (activityClass != null) {
            ToActivity.toActivity(this, activityClass)
        }
    }

    /**
     * 按两次退出应用
     */
    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            return mDoubleClickExitHelper.onKeyDown(keyCode, event)
        }
        return super.onKeyDown(keyCode, event)
    }

    override fun onResume() {
        super.onResume()
        MobclickAgent.onEvent(this, "id_launcher")
    }

    override fun showProgress(title: String?, msg: String?) {
        ViewUtil.showProgress(this, title, msg)
    }

    override fun dismissProgress() {
        ViewUtil.dismissProgress()
    }

    /**
     * 门店验证失败后的弹窗
     */
    override fun storeCheckError() {
        AlertDialog.Builder(this).setMessage("门店验证失败，请检查网络设置")
            .setPositiveButton("我知道了", null)
            .create().show()
    }

    /**
     * 判断是否大屏，然后再取不同的URL地址下载图片
     */
    override fun isBigSceen(): Boolean {
        return resources.displayMetrics.widthPixels >= 1080
    }

    override fun showMsg(msg: String?) {
        if (!isFinishing) {
            MyToast(msg, 5000).show()
        }
    }
}