package com.urovo.activity.login.view;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.urovo.activity.learning.LearningCenterMenuActivity;
import com.urovo.activity.login.model.CommonItem;
import com.urovo.activity.login.view.adapter.PartTimeSalesStaffAda;
import com.urovo.activity.membererweima.view.MemberGoodsAct;
import com.urovo.activity.slidemenu.ui.LogisticsQueryAct;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;

import java.util.ArrayList;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

/**
 * @author chenji
 * @date 2017/12/05
 * 兼职销售用户专用界面
 */

public class PartTimeSalesStaffAct extends BaseActivity {
    private static final String[] TITLE_LIST = {"会员商品转发", "会员商城销售查询", "物流查询", "养生文库", "账户注销"};
    private ArrayList<CommonItem> mDataList;
    private RecyclerView mRecyclerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_part_time_staff);
        initView();
        initData();
        initAdapter();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("五谷磨房");
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ToActivity.exitBy2Click(PartTimeSalesStaffAct.this);
            }
        });
    }

    private void initView() {
        initTitle();
        mRecyclerView = (RecyclerView) findViewById(R.id.recyclerView);
        mRecyclerView.setLayoutManager(new GridLayoutManager(this, 1));
    }

    private void initData() {
        mDataList = new ArrayList<>();
        for (String title : TITLE_LIST) {
            final CommonItem roleItem = new CommonItem();
            roleItem.setText(title);
            mDataList.add(roleItem);
        }
    }

    private void initAdapter() {
        final PartTimeSalesStaffAda salesStaffAda = new PartTimeSalesStaffAda(R.layout.part_time_role_item_view, mDataList);
        salesStaffAda.openLoadAnimation();
        View top = getLayoutInflater().inflate(R.layout.top_view, (ViewGroup) mRecyclerView.getParent(), false);
        salesStaffAda.addHeaderView(top);
        salesStaffAda.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                switch (position) {
                    //会员商品转发
                    case 0:
                        Intent intent = new Intent(PartTimeSalesStaffAct.this, MemberGoodsAct.class);
                        startActivity(intent);
                        break;
                    //会员商城销售查询
                    case 1:
                        BaseCookiesWebFra.launch(PartTimeSalesStaffAct.this, String.format(NetParam.MEMBER_SALE, SystemHelper.LoginOrganName, SystemHelper.LoginUserId, SystemHelper.LoginUserName, SystemHelper.LoginOrganId), "", true);
                        break;
                    //物流查询
                    case 2:
                        Intent intent4 = new Intent(PartTimeSalesStaffAct.this, LogisticsQueryAct.class);
                        intent4.putExtra(LogisticsQueryAct.MEMBER_PHONE_NUM, "");
                        startActivity(intent4);
                        break;
                    //养生文库
                    case 3:
                        Intent intent3 = new Intent(PartTimeSalesStaffAct.this, LearningCenterMenuActivity.class);
                        intent3.putExtra(AppConstants.ExtraKeys.ACTIVITY_TYPE, "2");
                        startActivity(intent3);
                        break;
                    //账号注销
                    case 4:
                        DialogHelper.Alert2(PartTimeSalesStaffAct.this, "提示", "是否要注销?", null, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                Intent logoutIntent = new Intent(PartTimeSalesStaffAct.this, LoginActivity.class);
                                logoutIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
                                startActivity(logoutIntent);
                            }
                        });
                        break;
                    default:
                        break;
                }
            }
        });
        mRecyclerView.setAdapter(salesStaffAda);
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        return ToActivity.dispatchKeyEvent(this, event);
    }
}