package com.urovo.activity.login.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.urovo.activity.data.QueryFinalProductSales;
import com.urovo.activity.data.QueryGuestFolio;
import com.urovo.activity.data.queryproductsales.view.MonthSaleProductAct;
import com.urovo.activity.data.querysales.view.MonthSaleAct;
import com.urovo.activity.goodsmanager.GoodsManagerMenu;
import com.urovo.activity.login.model.CommonItem;
import com.urovo.activity.login.recyclerview.RecyclerViewAdapter;
import com.urovo.activity.salesdetailnet.view.QuerySalesDetailNet;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.system.ToActivity;

import java.util.ArrayList;
import java.util.Arrays;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

/**
 * @author chenji
 * @date 2017/8/22
 * 兼职人员专用界面
 */

public class PartTimeStaffAct extends BaseActivity {
    CommonItem[] mCommonItem = {
            new CommonItem(GoodsManagerMenu.class, "货品管理查询", R.drawable.btn_more_goods, "#09A9FF"),
            new CommonItem(QueryFinalProductSales.class, "产品销售查询", R.drawable.btn_sales_goods, "#3E51B1"),
            new CommonItem(QuerySalesDetailNet.class, "销售明细查询", R.drawable.btn_sales_details, "#673BB7"),
            new CommonItem(MonthSaleAct.class, "月销量查询", R.drawable.btn_sales_month, "#4BAA50"),
            new CommonItem(MonthSaleProductAct.class, "产品月销量查询", R.drawable.btn_sales_month_goods, "#F94336"),
            new CommonItem(QueryGuestFolio.class, "客单查询", R.drawable.btn_sales_guest_folio, "#0A9B88"),
    };
    private ArrayList<CommonItem> mDataList;
    private RecyclerView mRecyclerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_part_time_staff);
        initView();
        initData();
        initAdapter();
    }

    private void initAdapter() {
        BaseQuickAdapter partTimeStaffAdapter = new RecyclerViewAdapter(R.layout.recycler_view_item, mDataList);
        partTimeStaffAdapter.openLoadAnimation();
        View top = getLayoutInflater().inflate(R.layout.top_view, (ViewGroup) mRecyclerView.getParent(), false);
        partTimeStaffAdapter.addHeaderView(top);
        partTimeStaffAdapter.setOnItemClickListener(new BaseQuickAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(BaseQuickAdapter adapter, View view, int position) {
                Intent intent = new Intent(PartTimeStaffAct.this, mCommonItem[position].getActivity());
                startActivity(intent);
            }
        });

        mRecyclerView.setAdapter(partTimeStaffAdapter);
    }

    private void initData() {
        mDataList = new ArrayList<>();
        // 将元素一一添加到集合中
        mDataList.addAll(Arrays.asList(mCommonItem));
    }

    private void initView() {
        initTitle();
        mRecyclerView = (RecyclerView) findViewById(R.id.recyclerView);
        mRecyclerView.setLayoutManager(new GridLayoutManager(this, 3));
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("五谷磨房");
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ToActivity.exitBy2Click(PartTimeStaffAct.this);
            }
        });
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        return ToActivity.dispatchKeyEvent(this, event);
    }
}