package com.urovo.activity.machinerepairact.model

import android.content.Intent
import android.view.View
import androidx.databinding.ObservableArrayList
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.urovo.activity.machinerepairact.net.EngineerDetailRes
import com.urovo.activity.machinerepairact.net.UndealRepairRes
import com.urovo.activity.machinerepairact.repository.MachineCallRepo
import com.urovo.activity.machinerepairact.view.EngineerSubmitAct
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.coroutines.launch

/**
 * @author Sasuke on 2019-05-07 0007.
 */
class EngineerDetailModel(val repo: MachineCallRepo) : ViewModel() {
    val intentCache = MutableLiveData<UndealRepairRes.ResultPack.ResultInfo>()

    var loadWaitMessage = MutableLiveData<Int>().apply { value = -1 }

    var resCache = MutableLiveData<EngineerDetailRes.ResultInfo>()

    /**营养顾问的图片*/
    var beforePicListShow = ObservableArrayList<String>()

    /**施工后，即机修人员图片*/
    var afterPicListShow = ObservableArrayList<String>()

    /**
     * 获取工单详情
     */
    fun getBillDetail(mroId: Int?) = viewModelScope.launch {
        mroId?.let {
            try {
                loadWaitMessage.value = LoadWaitDominator.LOADING
                resCache.value = repo.queryRepairDetail(it).resultInfo
                loadWaitMessage.value = -1
            } catch (e: Exception) {
                MyToast.show(e.message)
                loadWaitMessage.value = LoadWaitDominator.NET_ERROR
            }
        }
    }

    /**
     * 去处理 按钮点击
     */
    fun onClickGoDeal(view: View) {
        view.context.run {
            startActivity(Intent(this, EngineerSubmitAct::class.java).apply {
                putExtra(EngineerSubmitAct.INTENT_STORE_NAME, resCache.value?.storeName)
                putExtra(EngineerSubmitAct.INTENT_STORE_LOCATION, resCache.value?.address)
                putExtra(EngineerSubmitAct.INTENT_MROID, resCache.value?.mroId)
            })
        }
    }
}