package com.urovo.activity.machinerepairact.ui

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.MachineBeforePicItemBinding
import com.urovo.wugumofang.ui.PhotoPreviewDominator
import com.urovo.wugumofang.view.CustomPopupWindow
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019/5/3.
 */
class MachinePhotoGridAdapter(val picUrls: List<String>?) : RecyclerView.Adapter<ViewHolderX>() {
    /**预览大图弹窗 */
    private var previewPop: CustomPopupWindow? = null
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        return ViewHolderX(DataBindingUtil.inflate<MachineBeforePicItemBinding>(
                LayoutInflater.from(parent.context),
                R.layout.machine_before_pic_item,
                parent,
                false).root)
    }

    override fun getItemCount(): Int {
        return picUrls?.size ?: 0
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<MachineBeforePicItemBinding>(holder.view)
        binding?.imageUrl = picUrls?.get(position)
        binding?.imageView?.setOnClickListener {
            PhotoPreviewDominator(holder.view,picUrls?.get(position),null).showPreview()
        }
        //下面这个是实验的，其实xml里面已经绑定了自定义属性了，不需要手动显式在这里设置
//        Picasso.with(holder.view.context)
//                .load(picUrls?.get(position))
//                .error(R.drawable.pop_hone_qgwsr_default)
//                .placeholder(R.drawable.pop_hone_qgwsr_default)
//                .into(binding?.imageView)
    }

}