package com.urovo.activity.machinerepairact.view

import android.graphics.Color
import android.graphics.drawable.StateListDrawable
import android.os.Bundle
import android.widget.RadioGroup
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProviders
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.machinerepairact.model.EngineerBillFactory
import com.urovo.activity.machinerepairact.model.EngineerBillModel
import com.urovo.activity.machinerepairact.repository.MachineCallRepo
import com.urovo.activity.machinerepairact.ui.EngineerBillAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivityTap
import com.urovo.wugumofang.databinding.EngineerBillActBinding
import com.urovo.wugumofang.view.DividerItemDecoration
import com.urovo.wugumofang.view.LoadWaitDominator
import kotlinx.android.synthetic.main.engineer_bill_act.*
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import org.jetbrains.anko.find



/**
 * @author Sasuke on 2019/5/6.
 */
class EngineerBillsAct : BaseActivityTap() {
    companion object {
        const val INTENT_RES = "INTENT_RES"
    }

    var loadWait: LoadWaitDominator? = null
    val engineerModel by lazy { ViewModelProviders.of(this, EngineerBillFactory(MachineCallRepo())).get(EngineerBillModel::class.java) }
    val engineerBinding by lazy { DataBindingUtil.setContentView<EngineerBillActBinding>(this, R.layout.engineer_bill_act) }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
//        EventBus.getDefault().register(this)
        bind()
        initTitle()
        init()
        engineerModel.run { queryAllBill(queryYm.get()!!) }//怎么会为空呢？不可能为空好嘛。
    }

    override fun onDestroy() {
        super.onDestroy()
//        EventBus.getDefault().unregister(this)
    }


    class EventChangeToDeal
    /**切换到已处理标签*/
//    @Subscribe(threadMode = ThreadMode.MAIN)
//    fun changeToDealTab(event: EventChangeToDeal){
//        engineerBinding.engineerTapTitle.tapButtonRight.isChecked = true
//        engineerModel.run { queryAllBill(queryYm.get()!!) }//请求
//    }

    fun init() {
        var tabPos = intent.getIntExtra("TO_TAB_POS",0)
        var isFromJpush = intent.getBooleanExtra("FROM_JPUSH",false)
        if (isFromJpush){//如果是从极光推送过来的
            engineerBinding.engineerTapTitle.tapButtonLeft.isChecked = true
        }
        engineerBinding.engineerTapTitle.tapButtonLeft.buttonDrawable = StateListDrawable()
        engineerBinding.engineerTapTitle.tapButtonRight.buttonDrawable = StateListDrawable()


        loadWait = LoadWaitDominator(this, engineerBinding.loadWaitContainer)
        //intent传值
//        engineerModel.unDealResCache.value = intent.getSerializableExtra(INTENT_RES) as UndealRepairRes
        //列表初始化
        engineerBinding.billRv.run {
            layoutManager = LinearLayoutManager(this@EngineerBillsAct)
            addItemDecoration(DividerItemDecoration(context, DividerItemDecoration.HORIZONTAL_LIST, 1, Color.parseColor("#BFBFBF")))
            adapter = EngineerBillAdapter(this@EngineerBillsAct, engineerModel.getListCache())
        }
        //顶标签切换监听
        engineerTapTitle.find<RadioGroup>(R.id.tap_radio).setOnCheckedChangeListener { group, checkedId ->
            engineerModel.hasDealed.set(when (checkedId) {
                R.id.tap_button_left -> false
                R.id.tap_button_right -> true
                else -> false
            })
            engineerBinding.billRv.adapter = EngineerBillAdapter(this@EngineerBillsAct, engineerModel.getListCache())
            engineerModel.run { loadWaitMsg.value = if (getListCache().isEmpty()) LoadWaitDominator.NO_DATA else -1 }
        }
//        Handler().postDelayed({        engineerBinding.engineerTapTitle.tapButtonRight.isChecked = true
//        },5000)

        if (tabPos == 1){//从后面页面提交成功之后，跳转回来，需要通过这个标记，来初始显示为右边的标签
            engineerBinding.engineerTapTitle.tapButtonRight.isChecked = true
        }
    }

    fun bind() {
        engineerBinding.tabTexts = listOf("待处理", "已处理")
        engineerBinding.model = engineerModel
        engineerBinding.ym = engineerModel.queryYm
        engineerBinding.hasDealed = engineerModel.hasDealed

        engineerModel.unDealResCache.observe(this@EngineerBillsAct, Observer {
            engineerBinding.billRv.adapter = EngineerBillAdapter(this@EngineerBillsAct, engineerModel.getListCache())
            engineerBinding.goodNum = it.resultInfo.goodNum.toString()
            engineerBinding.mediumNum = it.resultInfo.mediumNum.toString()
            engineerBinding.badNum = it.resultInfo.badNum.toString()
            engineerBinding.isShowNumTitle = it.resultInfo.showRatingNum
        })
        engineerModel.loadWaitMsg.observe(this, Observer {
            when (it) {
                -1 -> loadWait?.dismissAll()
                LoadWaitDominator.LOADING -> loadWait?.show(LoadWaitDominator.LOADING)
                LoadWaitDominator.NET_ERROR -> loadWait?.show(LoadWaitDominator.NET_ERROR)
                LoadWaitDominator.NO_DATA -> loadWait?.show(LoadWaitDominator.NO_DATA)
            }
        })

    }


}