package com.urovo.activity.machinetrip.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.machinetrip.view.MachineTripAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.utils.NumChineseDominator
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2019-10-30 0030.
 */
class MachineRecordChildAdapter(val context0: Context, val id: Int?, val dataList: List<String>?) : RecyclerView.Adapter<MachineRecordChildAdapter.RecordChildHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecordChildHolder {
        val view = LayoutInflater.from(context0).inflate(R.layout.engineer_trip_record_child_item, parent, false)
        return RecordChildHolder(view)
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onBindViewHolder(holder: RecordChildHolder, pos: Int) {
        holder.run {
            locationTv.text = "${if (pos + 1 < 10) "     " else ""}" +
                    "第${NumChineseDominator.trans2Ch(pos + 1)}站：   ${dataList?.get(pos) ?: ""}"
            locationTv.setOnClickListener {
                MachineTripAct.launchWithId(context0, id)
            }
        }

    }


    class RecordChildHolder(view: View) : RecyclerView.ViewHolder(view) {
        var locationTv = view.find<TextView>(R.id.locationTv)
    }
}