package com.urovo.activity.membererweima.ui;

import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;
import com.urovo.activity.memberGoodsShare.view.MemberGoodsQrCodeAct;
import com.urovo.activity.membererweima.net.MemGoodsExRes;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.ui.BitmapUtil;

import java.util.List;

import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;

/**
 * Created by Sasuke on 2017/3/18.
 */

public class MemGoodsListAdapter extends RecyclerView.Adapter<MemGoodsListAdapter.ViewHolder>{
    Context context;
    List<MemGoodsExRes.Data.PurchaseData.QrCodeInfo> productList;

    public MemGoodsListAdapter(Context context,List<MemGoodsExRes.Data.PurchaseData.QrCodeInfo> productList) {
        this.context = context;
        this.productList = productList;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return new ViewHolder(LayoutInflater.from(context).inflate(R.layout.ll_member_goods_list_item,parent,false));
    }

    @Override
    public void onBindViewHolder(final ViewHolder holder, final int pos) {
        final MemGoodsExRes.Data.PurchaseData.QrCodeInfo item = productList.get(pos);

        holder.memName.setText(item.getProductTemplateName());
        //如果写死成120*120好像有些图片会显示不出来。。。不知道为什么
        if(!TextUtils.isEmpty(item.getImageUrl())){//防空
            Picasso.with(context).load(item.getImageUrl())/*.resize(120,120)*/.into(holder.memImg);
        }else{
            holder.memImg.setImageResource(R.drawable.wgmf_logo);
        }

//        if(item.hasImage()){
//            holder.memImg.setImageBitmap(item.getImage());
//        }else{

//            Picasso.with(context).load(item.getImageUrl()).resize(250,250).into(new Target() {
//                @Override
//                public void onBitmapLoaded(final Bitmap bitmap, Picasso.LoadedFrom from) {
//                    item.setImage(bitmap);
//                    new Handler().post(new Runnable() {//为了解决：IllegalStateException: Cannot call this method while RecyclerView is computing a layout or scrolling
//                        @Override
//                        public void run() {
//                            MemGoodsListAdapter.this.notifyDataSetChanged();
//                        }
//                    });//用了Handler之后，把这个改变UI的任务扔进looper里，然后就会等RecyclerView 计算完layout再执行改变了。。。
//
//                }
//
//                @Override
//                public void onBitmapFailed(Drawable errorDrawable) {
//
//                }
//
//                @Override
//                public void onPrepareLoad(Drawable placeHolderDrawable) {
//
//                }
//            });
//        }
        holder.shareBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(context, MemberGoodsQrCodeAct.class);
                if(holder.memImg.getDrawable() != null){
                    productList.get(pos).setImage(BitmapUtil.imageView2Bitmap(holder.memImg));//把imageView的图存到list中传过去
                }
                intent.putExtra(MemberGoodsQrCodeAct.ENTITY, productList.get(pos));
                context.startActivity(intent);
            }
        });
    }

    @Override
    public int getItemCount() {
        return productList == null ? 0 : productList.size();
    }

    class ViewHolder extends RecyclerView.ViewHolder{
        @BindView(R.id.mem_goods_img) ImageView memImg;
        @BindView(R.id.mem_goods_name) TextView memName;
        @BindView(R.id.mem_goods_share) Button shareBtn;

        public ViewHolder(View view) {
            super(view);
            memImg = (ImageView)view.findViewById(R.id.mem_goods_img);
            memName = (TextView)view.findViewById(R.id.mem_goods_name);
            shareBtn = (Button)view.findViewById(R.id.mem_goods_share);
        }
    }
}
