package com.urovo.activity.memorderact.net

import com.urovo.wugumofang.response.Base3Response
import java.io.Serializable

/**
 * Created by Sasuke on 2019-07-21
 */
data class ReceiversInfosRes(var resultInfo: List<ResultInfo>) : Base3Response() {
    data class ResultInfo(var additional: String,// 详细地址（街道、房号等）
                          var addressStatus: Int,//地址状态（是否有效） ,
                          var city: WxRegion,//城市
                          var cityId: Int,//城市id
                          var createDate: String,//创建时间
                          var customerId: Int,//用户id
                          var district: WxRegion,//城区/县
                          var districtId: Int,//城区/县id
                          var id: Int,//id
                          var isDefault: Boolean,//是否是默认地址
                          var latitude: Int,//纬度
                          var longitude: Int,//经度
                          var openId: String,//用户openId
                          var province: WxRegion,//省份
                          var provinceId: Int,//省份id
                          var receiverName: String,//收货人姓名
                          var receiverPhone: String,//收货人电话
                          var zipcode: String /*邮编*/) : Serializable {
        /**获取完整地址*/
        fun getLongAddr(): String {
            return province.regionName + city.regionName + district.regionName + additional
        }

        data class WxRegion(var id: Int,
                            var regionName: String,//详细地址（街道、房号等） ,
                            var subRegions: Array<WxRegion>) : Serializable
    }
}