package com.urovo.activity.memorderact.ui

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import android.widget.TextView
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.memorderact.net.MemOrderListRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.MemOrderListItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2019-7-19 0019.
 */
class MemOrderAdapter(val context: Context, val dataList: List<MemOrderListRes.ResultInfo>, val onDelete: (id: Int) ->Unit,val onJumpSubmit: (order: MemOrderListRes.ResultInfo)->Unit/*val actModel: MemOrderListModel*/) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<MemOrderListItemBinding>(
                LayoutInflater.from(context),
                R.layout.mem_order_list_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        DataBindingUtil.getBinding<MemOrderListItemBinding>(holder.view)?.run {
            detailLv.adapter = MemOrderDetailAdapter(context, dataList[pos].details)
            model = dataList[pos]
            amoutLayout.run {
                find<TextView>(R.id.name).text = ""
                find<TextView>(R.id.count).text = "合计"
                find<TextView>(R.id.amount).text = "${dataList[pos].amount}元"
            }

            deleteBtn.setOnClickListener { onDelete(dataList[pos].id) }
            submitBtn.setOnClickListener { onJumpSubmit(dataList[pos]) }
        }
    }
}