package com.urovo.activity.messagecenter.model;

import com.urovo.activity.messagecenter.presenter.ELearningPresenter;
import com.urovo.activity.messagecenter.presenter.NoticePresenter;
import com.urovo.activity.messagecenter.presenter.SaleActivityPresenter;
import com.urovo.activity.messagecenter.presenter.SaleNewsPresenter;
import com.urovo.activity.messagecenter.presenter.SysMsgPresenter;
import com.urovo.activity.messagecenter.presenter.TodayTaskPresenter;
import com.urovo.activity.messagecenter.view.ELearningFra;
import com.urovo.activity.messagecenter.view.NoticeFra;
import com.urovo.activity.messagecenter.view.SaleActivityFrag;
import com.urovo.activity.messagecenter.view.SaleNewsFra;
import com.urovo.activity.messagecenter.view.SysMsgFra;
import com.urovo.activity.messagecenter.view.TodayTaskFra;
import com.urovo.wugumofang.R;

import java.util.HashMap;

/**
 * Created by Sasuke on 2016/7/28.
 */
public class MsgActData{
    //完全可以直接在TabMenuActivity外面处理了
    //底栏消息总数
    int msgAmount = 0;
    //前一个处于激活态的标签
    int beforeActive = 0;
    //侧边栏 名字  消息数

    public LabelModel[] countModels = {new LabelModel("销售\n动态", SaleNewsFra.class, SaleNewsPresenter.class.getSimpleName(), R.drawable.msg_label_selector01),
            new LabelModel("系统\n消息", SysMsgFra.class, SysMsgPresenter.class.getSimpleName(),R.drawable.msg_label_selector02),
            new LabelModel("今日\n任务", TodayTaskFra.class, TodayTaskPresenter.class.getSimpleName(),R.drawable.msg_label_selector03),
            new LabelModel("促销\n活动", SaleActivityFrag.class, SaleActivityPresenter.class.getSimpleName(),R.drawable.msg_label_selector04),
            new LabelModel("通知\n公告", NoticeFra.class, NoticePresenter.class.getSimpleName(),R.drawable.msg_label_selector05),
            new LabelModel("在线\n学习", ELearningFra.class, ELearningPresenter.class.getSimpleName(),R.drawable.msg_label_selector06)};

    int [] array = new int[countModels.length];//用来载到intent上进行广播的

    public class LabelModel{
        public String labelName;//标签名字
        public int msgCount;//消息数量
        public boolean isChecked;//是否被选中
        public Class fraClass;//要生成的Fragment的Class
        public String preTag;//该对应Fragment的对应Presenter的tag（约定为presenter的getSimpleName()）
        public int drawableTopRid;//带的图标的资源id

        public LabelModel(String labelName, Class fraClass,String preTag,int drawableTopRid){
            this.labelName = labelName;
            this.msgCount = 0;
            this.isChecked = false;
            this.fraClass = fraClass;
            this.preTag = preTag;
            this.drawableTopRid = drawableTopRid;
        }

        public int getMsgCount() {
           return msgCount;
        }
    }


    /**
     * 激活标签卡
     * @param position
     */
    public void setChecked(int position){
        countModels[beforeActive].isChecked = false;
        countModels[position].isChecked = true;
        beforeActive = position;
    }

    public void setMsgCount(int position,int msgCount){
        countModels[position].msgCount = msgCount;
    }

    /**获取被选中的标签数字*/
    public int getCheckedNum(){
        int length = countModels.length;
        for(int i = 0; i < length;i++){
            if(countModels[i].isChecked){
                return i;
            }
        }
        return -1;
    }

    public void setMsgCounts(HashMap<String,Integer> countMap){
        for(LabelModel model : countModels){
            if(countMap.get(model.preTag) != null){
                model.msgCount = countMap.get(model.preTag);
            }
        }
    }

    /**把未读数转成一个单纯的整型数组*/
    public int [] getCountArray(){
        for(int i = 0; i < countModels.length; i++){
            array[i] = countModels[i].getMsgCount();
        }
        return array;
    }

    /**
     * 用来传入消息个数(一定要按照labelModels的顺序传进来)；决定了，msgAmount放在TabMenuActivity里面处理
     * @param numbers
    public void setNumberValues(List<Integer> numbers){
        int length = countModels.length;
        if(numbers.size() == length){//传来的数据长度都不对等，还做个鸡巴
            for(int i = 0;i < length ;i++){
                countModels[i].msgCount = numbers.get(i);
            }
        }
    }*/
}
