package com.urovo.activity.messagecenter.model;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wugumofang.data.DataMonthUtils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;

/**
 * Created by Sasuke on 2016/8/1.
 */
public class SaleActivityData implements MsgCenterContract.baseData{
    List<Model> models = new ArrayList<>();//从msgDbs映射出来的，可以直接在Adapter里用的
    int msgAmount = 0;

    public int loadMsgDbs(){
        int count = 0;
        models.clear();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date today = new Date();
        List<MsgDb> msgDbs = MsgOperate.selectBy(null);
        int size = msgDbs.size();
        if (size > 0) {
            for (int i = 0; i < size; i++) {

                MsgDb db = msgDbs.get(i);
                Model cell = new Model();

                cell.mIsNew = db.mInvalid == null;
                if ("3".equals(db.mType)) {
                    cell.mLabel = "促销活动";
                    cell.mID = db.mNo;
                    cell.mTitle = db.mTitle;
                    cell.mContent = "活动时间：" + db.mActStartTime + " 至 "
                            + db.mActEndTime + "\n\n" + "活动内容：" + db.mContent;
                    cell.mDate = db.mDate;
                    cell.mObject = db;
                    if (DataMonthUtils.getCompareDate(db.mActStartTime,
                            sdf.format(today)) < 0) {
                        // 开始时间大于今天， 未开始
                        cell.mImgState = "0";
                    } else if (DataMonthUtils.getCompareDate(db.mActStartTime,
                            sdf.format(today)) >= 0
                            && DataMonthUtils.getCompareDate(db.mActEndTime,
                            sdf.format(today)) <= 0) {
                        // 开始时间小于等于今天，结束时间大于等于今天，进行中
                        cell.mImgState = "1";
                    } else if (DataMonthUtils.getCompareDate(db.mActEndTime,
                            sdf.format(today)) > 30) {
                        // 结束时间小于今天30天，已过期
                        cell.mImgState = "3";
                        MsgOperate.deleteBy(" WHERE ENDTIME='" + db.mActEndTime
                                + "'");
                    } else if (DataMonthUtils.getCompareDate(db.mActEndTime,
                            sdf.format(today)) > 0) {
                        // 结束时间小于今天，已结束
                        cell.mImgState = "2";
                    }
                    if (cell.mImgState != "3" && cell.mImgState != "2") {
                        // 若已过期，不显示（后续需求要求 已结束 也不显示）
                        models.add(cell);
                        if(cell.mIsNew){
                            count++;
                        }
                        Collections.sort(models, new Comparator<Model>() {

                            @Override
                            public int compare(Model lhs, Model rhs) {
                                if(DataMonthUtils.getCompareDate(lhs.mDate,rhs.mDate) < 0){
                                    return -1;
                                }else if(DataMonthUtils.getCompareDate(lhs.mDate,rhs.mDate) > 0){
                                    return 1;
                                }else{
                                    return 0;
                                }
                               /* if (StringUtils.toInt(lhs.mImgState)
                                        - StringUtils.toInt(rhs.mImgState) < 0) {
                                    return -1;
                                } else if (lhs.mImgState.equals(rhs.mImgState)) {
                                    return 0;
                                } else {
                                    return 1;
                                }*/
                            }
                        });
                    }
                }
            }
        }
        return count;
    }

    public int getMsgAmount() {
        return msgAmount;
    }

    /**
     * 未读数自减
     */
    public void msgAmountMinus(){
        msgAmount--;
    }

    public void setMsgAmount(int msgAmount) {
        this.msgAmount = msgAmount;
    }

    public List<Model> getDataList() {
        return models;
    }

    public void setDataList(List<Model> models) {
        this.models = models;
    }

    public class Model {
        public boolean mIsNew;
        public boolean mIsOpen;
        public String mType_ID;
        public String mLabel;
        public String mID;
        public String mTitle;
        public String mContent;
        public String mImgState;//0未开始  1进行中  3 已过期  2已结束
        public String mDate;
        public Object mObject;
    }
}
