package com.urovo.activity.messagecenter.model;

import android.text.TextUtils;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.util.Date2DayUtil;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * Created by Sasuke on 2016/8/1.
 */
public class TodayTaskData implements MsgCenterContract.baseData{
    int msgAmount = 0;
    int pageNum = 1;//这个是将要发送给接口获取的下一页页码，而不是当前页的
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
    List<Model> models = new ArrayList<>();
    public TodayTaskData(){
        models.clear();
//        models.add(new Model(-1,"会员商品推荐","推荐顾客成功购买会员商品，门店将获得相应提成奖励，快快行动吧！",1,""
//                                                    ,null,null,null,null,null));
    }

    //把从网络获取的单元数据存到Data
    public void addModel(int type, String title, String content, int used, String timestamp
                                             ,String pid,String storeNos ,String url,String startTime,String endTime){
        models.add(new Model(type,title,content,used,timestamp,pid,storeNos,url,startTime,endTime));
    }

    public class Model{
        int type;//1：新客三响炮  2：积分到期  3：优惠券到期提醒
        public String title;//条目标题
        public String content;//条目正文提示内容：eg.“您今天有。。。。点击进入查看”
        public int used;//是否已读标记(0未读 1已读)
        public String timestamp;
        //public boolean hasNew;//今天是否有推送（只有在当天有收到推送的时候才显示对应的条目）
        //public boolean hasRead;//是否已读（关系到那个小红点是否显示）

        //以下是新字段（用于“后台可配置”，即type == 9时使用）
        public String pid;
        public String storeNos;
        public String url;//可跳外部链接也可跳内部界面。
        public String startTime;
        public String endTime;

        /**后台可配置的*/
        public Model(int type, String title, String content, int used, String timestamp
                                ,String pid,String storeNos ,String url,String startTime,String endTime) {
            this.type = type;//1：新客三响炮回访 2：积分到期提醒 3：优惠券到期提醒
            this.title = title;
            this.content = content;
            this.used = used;//0未读 1已读
            this.timestamp = timestamp;
            this.pid = pid;
            this.storeNos = storeNos;
            this.url = url;
            this.startTime = startTime;
            this.endTime = endTime;
        }

        /***把获取到的****-**-** **:**:**转换成   昨天 **:**的时间格式*/
        public String getShowTime(){
            return TextUtils.isEmpty(getTime())?"": Date2DayUtil.withDay(getTime());
        }

        /**根据type类型来取不同的时间*/
        public String getTime(){
            if(type == 9){
                return startTime;
            }else{
                return timestamp;
            }
        }

        //获取网络返回的时间
        public String getDate(){
            if(type == 9){
                return TextUtils.isEmpty(startTime)?"": startTime.substring(0,10);
            }else{
                return TextUtils.isEmpty(timestamp)?"": timestamp.substring(0,10);
            }
        }

        public String getTimestamp() {
            return timestamp;
        }

        public int getType() {
            return type;
        }


        public String getLastDate(){
            return TextUtils.isEmpty(getDateKey()) ? "": PreferHelper.getInstance().getString(getDateKey());
        }

        public void setLastDate(String date){
            PreferHelper.getInstance().setString(getDateKey(),date);
        }

        public int getUsed() {
            return used;
        }

        public void setUsed(int used) {
            this.used = used;
        }

        /**
         * 用来根据type来提供一个对应的Prefs的Key
         * @return
         */
        private String getDateKey(){
            String dateKey = "";
            switch (type){
                case 1://1新客三响炮回访
                    dateKey = AppConstants.PreKeys.MSG_SXP_DATE;
                    break;
                case 2://2积分到期提醒
                    dateKey = AppConstants.PreKeys.MSG_JIFEN_DATE;
                    break;
                case 3://3优惠券到期提醒
                    dateKey = AppConstants.PreKeys.MSG_YOUHUI_DATE;
                    break;
            }
            return dateKey;
        }
    }


    public void setPageNum(int pageNum) {
        this.pageNum = pageNum;
    }

    public int getPageNum() {
        return pageNum;
    }

    public void pageNumPlus(){
        pageNum++;
    }

    //通过pref来统计计算未读数
    public int getMsgAmount() {
        /*msgAmount = 0;
        for(Model model : models){
            //新来的推送更新pref后，如果最后一次更新为今天，并且是未读状态
            if( model.getLastDate().equals(sdf.format(new Date())) && model.getUsed() == 0){
                msgAmount++;
            }
        }*/
        return msgAmount;
    }

    @Override
    public void msgAmountMinus() {
        msgAmount--;
    }

    //写入收到推送的时间和未读标记（每次收到推送之后执行）
    public void refreshDate(String dateKey){
        PreferHelper.getInstance().setString(dateKey,sdf.format(new Date()));
      }

    @Override
    public void setMsgAmount(int msgAmount) {
        this.msgAmount = msgAmount;
    }

    public List<Model> getModels(){
        return models;
    }

    //清除列表（除了固定死的卡片 ）
    public void clearWithoutStatic(){
            Iterator<Model> it = models.iterator();
            while (it.hasNext()){
                if(it.next().getType() >= 0){
                    it.remove();
                }
            }
    }
}
