package com.urovo.activity.messagecenter.presenter;

import android.text.TextUtils;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.urovo.activity.messagecenter.model.SysMsgData;
import com.urovo.activity.messagecenter.net.ArticleModel;
import com.urovo.activity.messagecenter.net.CountRes;
import com.urovo.activity.messagecenter.net.SysMsgDataRes;
import com.urovo.activity.messagecenter.net.SysMsgModel;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.zsy.libcore.event.EventManager;
import com.zsy.libcore.event.MsgCount;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;

import okhttp3.Request;


/**
 * Created by Sasuke on 2016/8/17.
 */
public class SysMsgPresenter implements MsgCenterContract.detailPresenter {
    MsgCenterContract.view mView;
    MsgCenterContract.view mActivity;
    SysMsgData data;
    public SysMsgPresenter(MsgCenterContract.view mActivity, MsgCenterContract.view mView) {
        if(mView != null) {//在外面单独使用这个Presenter时可以传空mView
            this.mView = mView;
            this.mView.setPresenter(this);
            this.data = new SysMsgData();
        }
        this.mActivity = mActivity;
    }

    @Override
    public void refreshAll() {
        //请求内容的同时，请求未读数
        getMsgCount();

        Map<String,String> param = new HashMap<>();
        param.put("store_code", SystemHelper.LoginOrganId);
        param.put("opno", SystemHelper.LoginUserId);
//        if(BaseActivity.class.isAssignableFrom(context.getClass())){
//            new BaseMsgServiceTask("systemmsg_data", SysMsgDataRes.class,(BaseActivity) context,
//                    "正在获取系统消息列表...",false,"/shopmessage/getSystemMessage",param).execute("");
//        }else{
//            new BaseMsgServiceTask("systemmsg_data", SysMsgDataRes.class,(TabMenuActivity) context,
//                    "正在获取系统消息列表...",false,"/shopmessage/getSystemMessage",param).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.MSG_SERVICE.SYS_GET_MESSAGE,
                param,
                new OkHttpDominator.ResultCallback<SysMsgDataRes>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(SysMsgDataRes res) {
                        //sysMsgPresenter.getData().setMsgAmount(Integer.parseInt(res.msgInfo));
                        transData(res.getResultInfo());
                        notifyAdapter();
                    }
                });
    }

    public void uploadMsgCount(String type, String id){
        Map<String,String> param = new HashMap<>();
        param.put("store_code", SystemHelper.LoginOrganId);
        param.put("opno", SystemHelper.LoginUserId);
        param.put("type",type);
        if(! TextUtils.isEmpty(id)){
            param.put("id",id);
        }
//        if(BaseActivity.class.isAssignableFrom(context.getClass())) {
//            new BaseMsgServiceTask("systemmsg_upload_count", BaseOldResponse.class, (BaseActivity) context,
//                    "正在上传已读数...", false, "/shopmessage/updateShopMsg", param).execute("");
//        }else{
//            new BaseMsgServiceTask("systemmsg_upload_count", BaseOldResponse.class, (TabMenuActivity) context,
//                    "正在上传已读数...", false, "/shopmessage/updateShopMsg", param).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.MSG_SERVICE.SYS_MSG_COUNT_UPDATE,
                param,null);
    }

    /**新的获取未读数的接口*/
    public void getMsgCount(){
        Map<String,String> param = new HashMap<>();
        param.put("store_code", SystemHelper.LoginOrganId);
        param.put("opno", SystemHelper.LoginUserId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.MSG_SERVICE.SYS_MSG_COUNT, param,
                new OkHttpDominator.ResultCallback<CountRes>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(CountRes res) {
                        if(res == null){
                            return;
                        }
                        res.transToList();
                        int sysMsg = 0;
                        for (CountRes.Count count : res.getResultList()) {
                            switch (Integer.parseInt(count.getType())){
                                case 4://订货提醒
                                case 5: //盘点提醒
                                case 6://考勤提醒
                                case 7://养生文库
                                case 8://学习中心
                                case 10://线上订单
                                case 11://千店万群消息
                                    sysMsg += count.getCount();
                                    break;
                                    default:
                            }
//                            if (Integer.parseInt(count.getType()) > 3 && Integer.parseInt(count.getType()) < 9) {
//                            }
                        }
//                        getData().setMsgAmount(sysMsg);
                        EventManager.getInstance().postMsgCenterCount(new MsgCount(SysMsgPresenter.this.getClass().getSimpleName(),sysMsg));//先映射数据库的数据，再顺便把未读数给存到Data里
                        notifyAdapter();
                    }
                });
    }

    @Override
    public void loadMore() {

    }

    @Override
    public void notifyAdapter() {
        //加一个按时间排序吧（按时间排序，所以大的在上面）
        Collections.sort(getData().getModels(), new Comparator<SysMsgModel>() {
            @Override
            public int compare(SysMsgModel lhs, SysMsgModel rhs) {
                if(TextUtils.isEmpty(rhs.getTimestamp())){
                    return -1;
                }
                if(TextUtils.isEmpty(lhs.getTimestamp())){
                    return 1;
                }
                //日期相同的情况下比较已读未读，未读的放在前面。
                if(rhs.getTimestamp().compareTo(lhs.getTimestamp()) == 0){
                    if(rhs.getUsed() == 0){
                        return 1;
                    }
                    if(lhs.getUsed() == 0){
                        return -1;
                    }
                }
                return rhs.getTimestamp().compareTo(lhs.getTimestamp());
            }
        });
        if(mView != null){
            mView.notifyAdapter();
        }
    }



    @Override
    public void start() {

    }

    /**
     *  用来把网络传来的json转成正常json并把数据抠出来
     * @param array
     */
    public void transData(String [] array){
        if(array != null){
            getData().clearWithoutStatic();//清除列表数据（除了固定死的卡片）
            for( String json : array){
                JsonObject o = new JsonParser().parse(json).getAsJsonObject();
                int type = o.get("type").getAsInt();
                if(type == 7 || type == 8){//如果是文章更新
                    ArticleModel model = new Gson().fromJson(o,ArticleModel.class);
                   /* ArticleModel model = new ArticleModel();
                    model.setTitle(o.get("title").getAsString());
                    model.setType(type);
                    model.setUsed(o.get("used").getAsInt());
                    model.setCreate_time(o.get("create_time").getAsLong());*/
                    model.decodeContent();
                    getData().getModels().add(model);
                /*}else if(type == 6){//如果是考勤
                    AttendanceModel model = new Gson().fromJson(o,AttendanceModel.class);
                    getData().getModels().add(model);*/
                }else{//如果是订货、盘点
                    SysMsgModel model = new Gson().fromJson(o,SysMsgModel.class);
                    getData().getModels().add(model);
                }
            }
        }
    }

    public SysMsgData getData(){
        if(data == null){
            data = new SysMsgData();
        }
        return data;
    }
}
