package com.urovo.activity.messagecenter.presenter;

import android.text.TextUtils;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.urovo.activity.messagecenter.model.TodayTaskData;
import com.urovo.activity.messagecenter.net.CountRes;
import com.urovo.activity.messagecenter.net.TodayTaskDataRes;
import com.urovo.activity.messagecenter.net.TodayTaskJsonEntity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.zsy.libcore.event.EventManager;
import com.zsy.libcore.event.MsgCount;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;

import okhttp3.Request;

/**
 * Created by Sasuke on 2016/8/17.
 */
public class TodayTaskPresenter implements MsgCenterContract.detailPresenter {
    MsgCenterContract.view mView;
    MsgCenterContract.view mActivity;
    TodayTaskData data;
    public TodayTaskPresenter(MsgCenterContract.view mActivity, MsgCenterContract.view mView) {
        if(mView != null) {//在外面单独使用这个Presenter时可以传空mView
            this.mView = mView;
            this.mView.setPresenter(this);
            this.data = new TodayTaskData();
        }
        this.mActivity = mActivity;
    }

    @Override
    public void refreshAll() {
        //请求内容的同时，请求未读数
        getMsgCount();
        getData().setPageNum(0);
        getTodayTaskDetail(0);
    }

    public void getTodayTaskDetail(int pageNum){
        Map<String,String> param = new HashMap<>();
        param.put("storeNo", SystemHelper.LoginOrganId);
        param.put("opno", SystemHelper.LoginUserId);
        param.put("pageno", pageNum +"");
//        if(BaseActivity.class.isAssignableFrom(context.getClass()) ){
//            new BaseMsgServiceTask("todayTask_data", TodayTaskDataRes.class,(BaseActivity)context,
//                    "正在获取今日任务数据...",false,"/shopmessage/getMissionMsg",param).execute("");
//        }else{
//            new BaseMsgServiceTask("todayTask_data", TodayTaskDataRes.class,(TabMenuActivity) context,
//                    "正在获取今日任务数据...",false,"/shopmessage/getMissionMsg",param).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.MSG_SERVICE.TODAYTASK_GET_MESSAGE,
                param,
                new OkHttpDominator.ResultCallback<TodayTaskDataRes>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(TodayTaskDataRes res) {
                        //todayTaskPresenter.getData().setMsgAmount(Integer.parseInt(res.msgInfo));
                        transData(res.getResultInfo());
                        notifyAdapter();
                    }
                });
    }

    /**pid对应后台可配置类型，其它类型此字段传null即可*/
    public void uploadMsgCount(String type,String pid){
        Map<String,String> param = new HashMap<>();
        param.put("store_code", SystemHelper.LoginOrganId);
        param.put("opno", SystemHelper.LoginUserId);
        param.put("type",type);
        if(! TextUtils.isEmpty(pid)){//非后台配置版本时，无pid字段
            param.put("id",pid);
        }
//        if(BaseActivity.class.isAssignableFrom(context.getClass())) {
//            new BaseMsgServiceTask("todayTask_upload_count", BaseOldResponse.class, (BaseActivity) context,
//                    "正在上传已读数...", false, "/shopmessage/updateShopMsg", param).execute("");
//        }else{
//            new BaseMsgServiceTask("todayTask_upload_count", BaseOldResponse.class, (TabMenuActivity) context,
//                    "正在上传已读数...", false, "/shopmessage/updateShopMsg", param).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.MSG_SERVICE.SYS_MSG_COUNT_UPDATE,
                param,null);
    }

    /**新的获取未读数接口*/
    public void getMsgCount(){
        Map<String,String> param = new HashMap<>();
        param.put("store_code", SystemHelper.LoginOrganId);
        param.put("opno", SystemHelper.LoginUserId);
//        if(BaseActivity.class.isAssignableFrom(context.getClass())) {
//            new BaseMsgServiceTask("sys_today_count", CountRes.class, (BaseActivity) context,
//                    "正在上传已读数...", false, "/shopmessage/getUnreadMsgCount", param).execute("");
//        }else{
//            new BaseMsgServiceTask("sys_today_count", CountRes.class, (TabMenuActivity) context,
//                    "正在上传已读数...", false, "/shopmessage/getUnreadMsgCount", param).execute("");
//        }
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.MSG_SERVICE.SYS_MSG_COUNT, param,
                new OkHttpDominator.ResultCallback<CountRes>() {
                    @Override
                    public void onError(Request request, Exception e) {

                    }

                    @Override
                    public void onResponse(CountRes res) {
                        if(res == null){
                            return ;
                        }
                        res.transToList();
                        int todayTask = 0;
                        for(CountRes.Count count : res.getResultList()) {
                            //今日任务（9是特殊情况，代表后台可配置的今日任务）
                            switch (Integer.parseInt(count.getType())){
                                case 1://新客三响炮回访
                                case 2://积分到期提醒
                                case 3://优惠券到期提醒
                                case 9://今日任务
                                    todayTask += count.getCount();
                                    break;
                                    default:
                            }
//                            if ((Integer.parseInt(count.getType()) > 0 && Integer.parseInt(count.getType()) < 4)
//                                    || Integer.parseInt(count.getType()) == 9) {
//
//                            }
                        }
//                        getData().setMsgAmount(todayTask);
                        EventManager.getInstance().postMsgCenterCount(new MsgCount(TodayTaskPresenter.this.getClass().getSimpleName(),todayTask));//先映射数据库的数据，再顺便把未读数给存到Data里
                        notifyAdapter();
                    }
                });
    }

    @Override
    public void loadMore() {
        getTodayTaskDetail(getData().getPageNum());
    }

    @Override
    public void notifyAdapter() {
        //加一个按时间排序吧（按时间排序，所以大的在上面）
        Collections.sort(getData().getModels(), new Comparator<TodayTaskData.Model>() {
            @Override
            public int compare(TodayTaskData.Model lhs, TodayTaskData.Model rhs) {
               /* if(lhs.getType() < 0 || rhs.getType() < 0){//如果type为-1说明是固定死的最后一项
                    return rhs.getType() - lhs.getType();
                }

                if(TextUtils.isEmpty(rhs.getTime())){
                    return -1;
                }
                if(TextUtils.isEmpty(lhs.getTime())){
                    return 1;
                }
                //日期相同的情况下比较已读未读，未读的放在前面。
                if(rhs.getTime().compareTo(lhs.getTime()) == 0){
                    if(rhs.getUsed() == 0){
                        return 1;
                    }
                    if(lhs.getUsed() == 0){
                        return -1;
                    }
                }
                return rhs.getTime().compareTo(lhs.getTime());*/
                if(lhs.getType() < 0 || rhs.getType() < 0){//如果type为-1说明是固定死的最后一项
                    return rhs.getType() - lhs.getType();
                }else{
                    return 0;
                }
            }
        });
        if(mView != null){
            mView.notifyAdapter();
        }
    }



    @Override
    public void start() {

    }

    /**
     * 用来把网络传来的json转成正常json并把数据抠出来
     * @param array
     */
    public void transData(String [] array){
        if(array != null && array.length > 0){
            if(getData().getPageNum() == 0) {//如果是refreshAll时
                getData().clearWithoutStatic();//清除列表数据（除了固定死的卡片）
            }
            for(String json : array){
                JsonObject o = new JsonParser().parse(json).getAsJsonObject();
                TodayTaskJsonEntity entity = new Gson().fromJson(o, TodayTaskJsonEntity.class);
                getData().addModel(entity.getType()
                                               ,entity.getTitle()
                                               ,entity.getContent()
                                               ,entity.getUsed()
                                               ,entity.getTimestamp()
                                               ,entity.getPid()
                                               ,entity.getStoreNos()
                                               ,entity.getUrl()
                                               ,entity.getStartTime()
                                               ,entity.getEndTime());
            }
            getData().pageNumPlus();//分页页码自增
        }else if(getData().getPageNum() != 0 && mActivity != null){//array == null || array.length <= 0
            mActivity.showMsg("没有更多了");
        }
    }

    public TodayTaskData getData(){
        if(data == null){
            data = new TodayTaskData();
        }
        return data;
    }

}
