package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.messagecenter.model.ELearningData;
import com.urovo.activity.messagecenter.presenter.ELearningPresenter;
import com.urovo.activity.messagecenter.view.MsgDetailAct;
import com.urovo.wugumofang.R;

import java.text.SimpleDateFormat;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2017/9/20.
 */

public class ELearningAdapter extends BaseAdapter {
    Context context;
    ELearningPresenter mPresenter;
    List<ELearningData.Model> modelList;
    SimpleDateFormat sdf;
    SimpleDateFormat sdfTime;

    public ELearningAdapter(Context context, List<ELearningData.Model> modelList, ELearningPresenter mPresenter) {
        this.context = context;
        this.mPresenter = mPresenter;
        this.modelList = modelList;
        sdf = new SimpleDateFormat("yyyy-MM-dd");
        sdfTime = new SimpleDateFormat("yyyy-MM-dd HH:mm");
    }

    @Override
    public int getCount() {
        return modelList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ELearningAdapter.ViewHolder holder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_today_task, null);
            holder = new ELearningAdapter.ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ELearningAdapter.ViewHolder) convertView.getTag();
        }

        holder.noticeTitle.setText(modelList.get(position).title);
        holder.noticeContent.setText(modelList.get(position).content);

        String time = modelList.get(position).getShowTime();
        holder.noticeTime.setText(time);
        holder.noticeIsNew.setVisibility(modelList.get(position).getUsed() == 1 ? View.INVISIBLE : View.VISIBLE);

        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ELearningData.Model item = modelList.get(position);
                if (item.getUsed() == 0) {//只有在它是未读状态的时候，才上传已读记录
                    item.setUsed(1);//同步设置本地已读标记
                    mPresenter.uploadMsgCount(item.getType() + "", item.eId);//同步上传已读标记
                    mPresenter.getData().msgAmountMinus();//同步把侧边标签未读数减1
                }
                holder.noticeIsNew.setVisibility(View.INVISIBLE);

////                BaseCookiesWebFra.launch(context, new Intent(), NetParam.ELEARNING_URL, null, true);
//                Intent intent = new Intent(context, MsgDetailAct.class);
//                intent.putExtra("type",item.getType());
//                intent.putExtra("localType","ELearning");
//                ((BaseActivity)context).startActivity(intent);

                MsgDetailAct.launch(context, item.getType(), "在线学习", "ELearning");

            }
        });

        return convertView;
    }

    class ViewHolder {
        public ViewHolder(View view) {
            ButterKnife.bind(this, view);
        }

        @BindView(R.id.content_layout)
        LinearLayout contentLayout;//整个布局
        @BindView(R.id.task_isNew)
        ImageView noticeIsNew;//是否未读
        @BindView(R.id.text_task_content)
        TextView noticeContent;//卡片内容
        @BindView(R.id.text_task_title)
        TextView noticeTitle;//卡片标题
        @BindView(R.id.text_task_time)
        TextView noticeTime;//更新时间
    }
}
