package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.messagecenter.model.NoticeData;
import com.urovo.activity.messagecenter.presenter.NoticePresenter;
import com.urovo.activity.messagecenter.util.Date2DayUtil;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wgmf.notice.ZongBuTongZhiActivity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2016/8/12.
 */
public class NoticeAdapter extends BaseAdapter {
    Context context;
    NoticePresenter mPresenter;
    List<NoticeData.Model> dataList;

    public NoticeAdapter(Context context, List<NoticeData.Model> dataList, NoticePresenter presenter) {
        this.context = context;
        this.mPresenter = presenter;
        this.dataList = dataList;
    }

    @Override
    public int getCount() {
        return dataList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_msg_notice,null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder) convertView.getTag();
        }
        holder.noticeIsNew.setVisibility(dataList.get(position).mIsNew? View.VISIBLE: View.INVISIBLE);
        holder.noticeContent.setText(dataList.get(position).mContent);
        holder.noticeTime.setText(Date2DayUtil.withDay(dataList.get(position).mDate));
        holder.noticeTitle.setText(dataList.get(position).mTitle);

        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(dataList.get(position).mIsNew){//如果点击的是未读的
                    mPresenter.getData().msgAmountMinus();//未读数自减
                }
                dataList.get(position).mIsNew = false;
                MsgDb mode = (MsgDb) dataList.get(position).mObject;
                MsgOperate.update(mode);
                Intent intent = new Intent();
                intent.setClass(context,
                        ZongBuTongZhiActivity.class);
                intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_ISNEW,
                        dataList.get(position).mIsNew);
                intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_TITLE,
                        dataList.get(position).mTitle);
                intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_ID,
                        dataList.get(position).mID);
                intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_DATE,
                        dataList.get(position).mDate);
                intent.putExtra(
                        ZongBuTongZhiActivity.ZHONGBUTONGZHI_CONTENT,
                        dataList.get(position).mContent);
                context.startActivity(intent);
            }
        });
        return convertView;
    }

    class ViewHolder{
        public ViewHolder(View view) {
            ButterKnife.bind(this,view);
        }

        @BindView(R.id.notice_isNew)
        ImageView noticeIsNew;
        @BindView(R.id.text_notice_content)
        TextView noticeContent;
        @BindView(R.id.text_notice_title)
        TextView noticeTitle;
        @BindView(R.id.text_notice_time)
        TextView noticeTime;
    }
}
