package com.urovo.activity.messagecenter.ui;

import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.sanxiangpao.view.SanXiangPaoAct;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.view.baseWebViewAct.WebViewAct;
import com.urovo.activity.membergroup.JiFenDaoQiTiXing.view.JiFenDaoQiTiXingAct;
import com.urovo.activity.messagecenter.model.TodayTaskData;
import com.urovo.activity.messagecenter.presenter.TodayTaskPresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;

import java.text.SimpleDateFormat;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * Created by Sasuke on 2016/8/18.
 */
public class TodayTaskAdapter extends BaseAdapter {
    Context context;
    TodayTaskPresenter mPresenter;
    List<TodayTaskData.Model> modelList;
    SimpleDateFormat sdf;
    SimpleDateFormat sdfTime;

    public TodayTaskAdapter(Context context, List<TodayTaskData.Model> modelList, TodayTaskPresenter mPresenter) {
        this.context = context;
        this.mPresenter = mPresenter;
        this.modelList = modelList;
        sdf = new SimpleDateFormat("yyyy-MM-dd");
        sdfTime = new SimpleDateFormat("yyyy-MM-dd HH:mm");
    }

    @Override
    public int getCount() {
        return modelList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder holder;
        if (convertView == null) {
            convertView = (LinearLayout) LayoutInflater.from(context).inflate(R.layout.list_item_today_task, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder)convertView.getTag();
        }

        holder.noticeTitle.setText(modelList.get(position).title);
        holder.noticeContent.setText(modelList.get(position).content);

        String time = modelList.get(position).getShowTime();
        holder.noticeTime.setText(time);
        holder.noticeIsNew.setVisibility(modelList.get(position).getUsed() == 1? View.INVISIBLE : View.VISIBLE);

        //如果是最后一个万年不变的“会员商品推荐”，
        if(modelList.get(position).getType() < 0){
            holder.noticeIsNew.setVisibility(View.INVISIBLE);
            holder.noticeTime.setText("");//设成空就够了。。。如果设成invisible到组件复用的时候还要重新设回visible
            convertView.setOnClickListener(null);
            return convertView;
        }

        //如果从未收到过推送or收到过但最后一次日期小于今天（由西门在后台控制，今天如果没有那就直接不显示就行了嘛）
        /*String today = sdf.format(new Date());
        if(TextUtils.isEmpty(modelList.get(position).getLastDate()) ||
                modelList.get(position).getLastDate().compareTo(today) < 0){
            holder.contentLayout.setVisibility(View.GONE);//测试时可以改这里为VISIBLE
        }else{
            holder.contentLayout.setVisibility(View.VISIBLE);
        }*/

        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                TodayTaskData.Model item = modelList.get(position);
                if(item.getUsed() == 0){//只有在它是未读状态的时候，才上传已读记录
                    item.setUsed(1);//同步设置本地已读标记
                    mPresenter.uploadMsgCount(item.getType()+"",item.pid);//同步上传已读标记
                    mPresenter.getData().msgAmountMinus();//同步把侧边标签未读数减1
                }
                holder.noticeIsNew.setVisibility(View.INVISIBLE);

                switch (item.getType()){
                    case 1://新客三响炮回访
                        ((BaseActivity)context).startActivity(new Intent(context,SanXiangPaoAct.class));
                        break;
                    case 2://积分到期提醒
                        Intent intent = new Intent(context,JiFenDaoQiTiXingAct.class);
                        intent.putExtra(AppConstants.ExtraKeys.JIFENDAOQI_DEFAULT_LABEL,1);
                        ((BaseActivity)context).startActivity(intent);
                        break;
                    case 3://优惠券到期提醒
                        Intent intent1 = new Intent(context,JiFenDaoQiTiXingAct.class);
                        intent1.putExtra(AppConstants.ExtraKeys.JIFENDAOQI_DEFAULT_LABEL,2);
                        ((BaseActivity)context).startActivity(intent1);
                        break;
                    case 9://"根据后台配置的url来跳转
                        //如果是本地路径
                        if(TextUtils.isEmpty(item.url)){//如果链接为空，就不要有任何点击响应。
                            break;
                        }
                        if(item.url.startsWith(context.getPackageName())){
                            try {
                                ((BaseActivity)context).startActivity(new Intent(context,Class.forName(item.url)));
                            } catch (ClassNotFoundException e) {
                                ((BaseActivity)context).showMsg("找不到该本地页面");
                                e.printStackTrace();
                            }
                        //如果是网络路径
                        }else{
                            WebViewAct.launch(context,SystemHelper.LoginUserId,item.title,item.url,WebViewAct.SHARE_WEIXIN);
                        }
                        break;
                }

            }
        });

        return convertView;
    }

    class ViewHolder {
        public ViewHolder(View view) {
            ButterKnife.bind(this, view);
        }
        @BindView(R.id.content_layout)
        LinearLayout contentLayout;//整个布局
        @BindView(R.id.task_isNew)
        ImageView noticeIsNew;//是否未读
        @BindView(R.id.text_task_content)
        TextView noticeContent;//卡片内容
        @BindView(R.id.text_task_title)
        TextView noticeTitle;//卡片标题
        @BindView(R.id.text_task_time)
        TextView noticeTime;//更新时间
    }
}
