package com.urovo.activity.messagecenter.util;

import com.urovo.wugumofang.data.DateUtil;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Created by Sasuke on 2016/8/12.
 */
public class Date2DayUtil {
    /**
     * 把****-**-**  **:**型的日期转换成“昨天”，“前天”，原样照搬 等几种显示，传入格式一定要****-**-** **:**格式
     * @return
     */
    public static String withDay(String date){
        Date today = new Date();
        Date desDate = DateUtil.String2Date(date,"yyyy-MM-dd");
        int diffDate = DateUtil.diffDate(today,desDate);
        int length = 16;//date.length();
        switch (diffDate){//除了当天不显示日期，其余全员都自动加一个空格“ ”，这样就可以无忧无虑地加到时间前面了
            case 0:
                return date.length() < 16?"今天" : date.substring(11,length);
            case 1:
                return date.length() < 16?"昨天" : "昨天 "+ date.substring(11,length);
            case 2:
                return date.length() < 16 ? "前天" : "前天 " + date.substring(11,length);
            default:
                return date.substring(0,10);
        }
    }

    /**
     * 用于把long型日期转换成带昨天前天 的日期格式
     * @param time
     * @return
     */
    public static String withLong(long time){
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
            Date date= new Date(time);
            String result = sdf.format(date);
            return withDay(result);
    }

}
