package com.urovo.activity.messagecenter.view;

import android.os.Bundle;
import androidx.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.urovo.activity.messagecenter.presenter.ELearningPresenter;
import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.ui.ELearningAdapter;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2017/9/20.
 * 在线学习ELearning消息
 */

public class ELearningFra extends BaseRefreshFra implements MsgCenterContract.view{
    ELearningPresenter mPresenter;
    ELearningAdapter adapter;
    MsgCenterContract.view mActivity;

    @Override
    public MsgCenterContract.detailPresenter buildPre(MsgCenterContract.view mActivity) {
        if(mPresenter == null){
            mPresenter = new ELearningPresenter(mActivity,this);
            this.mActivity = mActivity;
        }
        return mPresenter;
    }


    @Override
    public MsgCenterContract.detailPresenter getPre() {
        return mPresenter;
    }

    public void refreshAll() {
        mPresenter.refreshAll();
    }

    @Override
    public void initUi() {

    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (RelativeLayout)inflater.inflate(R.layout.fra_msg_center,null,false);
        initPullListView(container);
        if(mPresenter == null){//有时候pre会报空！！
            mPresenter = new ELearningPresenter((MsgCenterContract.view)getActivity(),this);
        }
        adapter = new ELearningAdapter(getActivity(),mPresenter.getData().getModels(),mPresenter);
        mListView.setAdapter(adapter);
        setRefreshListener();
        loading.setVisibility(View.VISIBLE);
        setPullLoadEnabled(false);//重新设置一下使上拉加载不生效（通知公告不需要上拉加载）
        return container;
    }

    @Override
    public void notifyAdapter() {
//        if(adapter != null){
//            adapter.notifyDataSetChanged();
//            hideErrorText();
//        }
        if (adapter != null) {
            if(mPresenter.getData().getModels().size() == 0){//如果数据源为空了
                showNoData();
            }else{//如果有数据了
                hideErrorText();
                adapter.notifyDataSetChanged();
            }
        }
        completeRefresh(true);
    }


    @Override
    public void loadMore() {
        mPresenter.loadMore();
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (ELearningPresenter) presenter;
    }

//    @Override
//    public void onResume() {
//        super.onResume();
//        mPresenter.notifyAdapter();
//    }


    @Override
    public void showMsg(String msg) {
        mActivity.showMsg(msg);
    }
}