package com.urovo.activity.messagecenter.view;

import android.os.Bundle;
import androidx.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.presenter.SaleNewsPresenter;
import com.urovo.activity.messagecenter.ui.SaleNewsAdapter;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/7/25.
 */
public class SaleNewsFra extends BaseRefreshFra implements MsgCenterContract.view{
    SaleNewsPresenter mPresenter;
    SaleNewsAdapter adapter;
    MsgCenterContract.view mActivity;

    @Override
    public MsgCenterContract.detailPresenter buildPre(MsgCenterContract.view mActivity) {
        if(mPresenter == null){
            mPresenter = new SaleNewsPresenter(mActivity,this);
            this.mActivity = mActivity;
        }
        return mPresenter;
    }

    @Override
    public MsgCenterContract.detailPresenter getPre() {
        return mPresenter;
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (SaleNewsPresenter)presenter;
    }

    @Override
    public void initUi() {

    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (RelativeLayout)inflater.inflate(R.layout.fra_msg_center,null,false);
        initPullListView(container);
        if(mPresenter == null){//有时候pre会报空！！
            mPresenter = new SaleNewsPresenter((MsgCenterContract.view)getActivity(),this);
        }
        adapter = new SaleNewsAdapter(getActivity(),mPresenter.getData().getDetailList(),mPresenter);
        mListView.setAdapter(adapter);
        setRefreshListener();//挂双监听
        return container;
    }



    @Override
    public void notifyAdapter() {
        if(mPresenter.getData().getDetailList().size() == 0){//如果数据源为空了
            showNoData();
        }else{//如果有数据了
            hideErrorText();
            adapter.notifyDataSetChanged();
        }
        completeRefresh(true);
    }

    @Override
    public void refreshAll() {
        mPresenter.refreshAll();
    }

    @Override
    public void loadMore() {
        mPresenter.loadMore();
    }

    @Override
    public void onResume() {
        super.onResume();
        notifyAdapter();
    }

    @Override
    public void showMsg(String msg) {
        mActivity.showMsg(msg);
    }

}
