package com.urovo.activity.messagecenter.view;

import android.os.Bundle;
import androidx.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;

import com.urovo.activity.messagecenter.presenter.MsgCenterContract;
import com.urovo.activity.messagecenter.presenter.TodayTaskPresenter;
import com.urovo.activity.messagecenter.ui.TodayTaskAdapter;
import com.urovo.wugumofang.R;

/**
 * Created by Sasuke on 2016/8/17.
 */
public class TodayTaskFra extends BaseRefreshFra implements MsgCenterContract.view{
    TodayTaskPresenter mPresenter;
    TodayTaskAdapter adapter;
    MsgCenterContract.view mActivity;

    public void refreshAll() {
        mPresenter.refreshAll();
    }

    @Override
    public void initUi() {

    }

    @Override
    public MsgCenterContract.detailPresenter buildPre(MsgCenterContract.view mActivity) {
        if(mPresenter == null){
            mPresenter = new TodayTaskPresenter(mActivity,this);
            this.mActivity = mActivity;
        }
        return mPresenter;
    }

    @Override
    public MsgCenterContract.detailPresenter getPre() {
        return mPresenter;
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (RelativeLayout)inflater.inflate(R.layout.fra_msg_center,null,false);
        initPullListView(container);
        if(mPresenter == null){//有时候pre会报空！！
            mPresenter = new TodayTaskPresenter((MsgCenterContract.view)getActivity(),this);
        }
        adapter = new TodayTaskAdapter(getActivity(),mPresenter.getData().getModels(),mPresenter);
        mListView.setAdapter(adapter);
        setRefreshListener();
        loading.setVisibility(View.VISIBLE);
//        setPullLoadEnabled(false);//重新设置一下使上拉加载不生效（通知公告不需要上拉加载）
        return container;
    }

    @Override
    public void notifyAdapter() {
//        if(adapter != null){
//            adapter.notifyDataSetChanged();
//            hideErrorText();
//        }
        if (adapter != null) {
            if(mPresenter.getData().getModels().size() == 0){//如果数据源为空了
                showNoData();
            }else{//如果有数据了
                hideErrorText();
                adapter.notifyDataSetChanged();
            }
        }
        completeRefresh(true);
    }


    @Override
    public void loadMore() {
        mPresenter.loadMore();
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (TodayTaskPresenter)presenter;
    }

    @Override
    public void showMsg(String msg) {
        mActivity.showMsg(msg);
    }


    //    @Override
//    public void onResume() {
//        super.onResume();
//        mPresenter.notifyAdapter();
//    }
}
