package com.urovo.activity.nativemanager;

import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.system.PdaMsgConfig;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * 本机管理 门店模式 主菜单
 *
 * @author Administrator 数据下载 数据上传 数据清理
 */
public class MnativeMenu extends BaseActivity implements UpEndNotify {
    private ListView listview;
    private Integer[] mFunctionPics = {R.drawable.version_character, R.drawable.version_character, R.drawable.version_character};
    private String[] mFunctionName = {"数据下载", "数据上传", "数据清理"};
    private String[] mFunctionText = {"上次：03-15 09:31", "上次：03-15 09:31", "上次：03-15 09:31"};
    private ArrayList<HashMap<String, Object>> lsitArrayList;
    private TextView textView;// 未上传数量
    private SimpleAdapter simpleAdapter;
    private UpEndBroadcast broadcast = new UpEndBroadcast(this);
    private LinearLayout showNoUp;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.staff_menu_2);
        init();
        initTitle();
        titleTextView.setText("本机管理");
        IntentFilter intentFilter = new IntentFilter("com.urovo.wgmf.upend");
        registerReceiver(broadcast, intentFilter);
    }

    private void init() {

        listview = (ListView) findViewById(R.id.listview);
        textView = (TextView) findViewById(R.id.item_text);
        showNoUp = (LinearLayout) findViewById(R.id.show_no_up);
        mFunctionText[0] = PdaMsgConfig.getDownloadTime(MnativeMenu.this);
        mFunctionText[1] = PdaMsgConfig.getUpTime(MnativeMenu.this);
        mFunctionText[2] = PdaMsgConfig.getCleanTime(MnativeMenu.this);

        lsitArrayList = new ArrayList<HashMap<String, Object>>();
        for (int i = 0; i < mFunctionName.length; i++) {
            HashMap<String, Object> hashMap = new HashMap<String, Object>();
            // hashMap.put("image", mFunctionPics[i]);
            hashMap.put("text", mFunctionName[i]);
            hashMap.put("text2", mFunctionText[i]);
            lsitArrayList.add(hashMap);
        }

        simpleAdapter = new SimpleAdapter(this, lsitArrayList, R.layout.second_menu_item2, new String[]{"image", "text", "text2"}, new int[]{R.id.ItemImage, R.id.ItemText, R.id.item_text});
        listview.setAdapter(simpleAdapter);
        listview.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                click(position);
            }
        });

    }

    @Override
    protected void onResume() {

        super.onResume();
        int newCount = DalCommon.GetUnUploadCount(false);
        if (newCount == 0) {
            showNoUp.setVisibility(View.GONE);
        } else {
            showNoUp.setVisibility(View.VISIBLE);
            textView.setText(newCount + "单");
        }
        lsitArrayList.get(0).put("text2", PdaMsgConfig.getDownloadTime(MnativeMenu.this));
        lsitArrayList.get(1).put("text2", PdaMsgConfig.getUpTime(MnativeMenu.this));
        lsitArrayList.get(2).put("text2", PdaMsgConfig.getCleanTime(MnativeMenu.this));
        simpleAdapter.notifyDataSetChanged();
    }

    public void click(int position) {
        switch (position) {
            case 0:
                // String time1="上次：" +DateUtil.getDateTime2(new Date());
                // PdaMsgConfig.setDownloadTime(time1, MnativeMenu.this);
                // lsitArrayList.get(0).put("text2",time1);
                ToActivity.toActivity(this, UpAndDownDataDown.class);

                break;
            case 1:
                // String time2="上次：" +DateUtil.getDateTime2(new Date());
                // lsitArrayList.get(1).put("text2",time2);
                // PdaMsgConfig.setupTime(time2, MnativeMenu.this);
                ToActivity.toActivity(this, UpAndDownDataUp.class);
                break;
            case 2:
                // String time3="上次：" +DateUtil.getDateTime2(new Date());
                // PdaMsgConfig.setCleanTime(time3, MnativeMenu.this);
                // lsitArrayList.get(2).put("text2", time3);
                ToActivity.toActivity(this, UpAndDownDataClean.class);
                break;

            default:
                break;
        }

        // simpleAdapter.notifyDataSetChanged();

    }

    public void noHandle(View view) {
        ToActivity.toActivity(this, UntreatedOrder.class);
    }

    @Override
    public void notifyData() {

        int count = DalCommon.GetUnUploadCount(false);
        if (count == 0) {
            showNoUp.setVisibility(View.GONE);
        } else {
            showNoUp.setVisibility(View.VISIBLE);
            textView.setText(count + "");
        }
    }

    @Override
    protected void onDestroy() {

        super.onDestroy();
        unregisterReceiver(broadcast);
    }

}
