package com.urovo.activity.nativemanager;

import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.TextView;

import com.urovo.wgmf.AsyncTask.uploadcases.KaoqinUploadCase;
import com.urovo.wgmf.AsyncTask.uploadcases.ShichiUploadCase;
import com.urovo.wgmf.AsyncTask.uploadcases.UploadAfterCase;
import com.urovo.wgmf.AsyncTask.uploadcases.XiaoShouUploadCase;
import com.urovo.wgmf.constants.UploadParam;
import com.urovo.wgmf.db.dao.dao.CxykqDbOperate;
import com.urovo.wgmf.db.dao.dao.Djpd001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djsc001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.CommonTools;
import com.urovo.wugumofang.utils.TaskEnqueueDominator;

import java.util.ArrayList;
import java.util.List;

import kotlin.Unit;
import kotlin.jvm.functions.Function1;

/**
 * 数据上传
 *
 * @author Administrator
 */
public class UpAndDownDataUp extends BaseActivity implements OnClickListener, OnCheckedChangeListener {

    private CheckBox all;
    private Button uploaw;

    private CheckBox kaoqinup;
    private CheckBox shichiup;
    private CheckBox xiaoshouup;
    private TextView kaoqinup_num;
    private TextView shichiup_num;
    private TextView xiaoshouup_num;

    private List<String> tags;
    private Thread countThread;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.up_down_dataup);
        init();
        initTitle();
        tags = new ArrayList<String>();
        titleTextView.setText("数据上传");
    }

    private void init() {
        kaoqinup = (CheckBox) findViewById(R.id.kaoqinup);
        shichiup = (CheckBox) findViewById(R.id.shichiup);
        xiaoshouup = (CheckBox) findViewById(R.id.xiaoshouup);

        kaoqinup_num = (TextView) findViewById(R.id.kaoqinup_num);
        shichiup_num = (TextView) findViewById(R.id.shichiup_num);
        xiaoshouup_num = (TextView) findViewById(R.id.xiaoshouup_num);

        uploaw = (Button) findViewById(R.id.data_up);
        uploaw.setOnClickListener(this);

        all = (CheckBox) findViewById(R.id.all);
        all.setOnCheckedChangeListener(this);
        all.setChecked(true);

        /**开始计数分别有多少单未上传*/
        UnUploadCountTask countTask = new UnUploadCountTask();
        countThread = new Thread(countTask);
        countThread.start();
    }

    class UnUploadCountTask implements Runnable {
        @Override
        public void run() {
            showUnUploadCount(kaoqinup_num, CxykqDbOperate.GetUnUploadCount());
            showUnUploadCount(shichiup_num, Djsc001DbOperate.GetUnUploadCount());
            showUnUploadCount(xiaoshouup_num, Djxs001DbOperate.GetUnUploadCount());
        }
    }

    public void showUnUploadCount(final TextView tv, final int count) {
        if (count <= 0) {//如果没有未上传单，就跳过
            return;
        }
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                tv.setText(count + "单");
            }
        });
    }

    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        kaoqinup.setChecked(isChecked);
        shichiup.setChecked(isChecked);
        xiaoshouup.setChecked(isChecked);
    }

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.data_up:
                if (CommonTools.INSTANCE.isOneClick()) {
                    if (0 == CxykqDbOperate.GetUnUploadCount() + Djpd001DbOperate.GetUnUploadCount()
                            + Djsc001DbOperate.GetUnUploadCount() + Djxs001DbOperate.GetUnUploadCount()) {
                        showMsg("没有需上传的数据");
                        return;
                    }
                    upLoad();
                    uploaw.setBackgroundColor(Color.GRAY);
                }
                break;
            default:
                break;
        }

    }


    TaskEnqueueDominator enqueueDominator;

    private void upLoad() {
        if (kaoqinup.isChecked()) {
            tags.add(UploadParam.KAOQIN);
        }
        if (shichiup.isChecked()) {
            tags.add(UploadParam.SHICHI);
        }
        if (xiaoshouup.isChecked()) {
            tags.add(UploadParam.XIAOSHOU);
        }
        if (tags.size() <= 0) {
            showMsg("请选择上传项！");
            return;
        }
        ViewUtil.showProgress(this, "数据上传中...", "请稍等.....");

        enqueueDominator = new TaskEnqueueDominator();

        ShichiUploadCase shichiUploadCase;
        // 试吃上传
        if (tags.contains(UploadParam.SHICHI)) {
            shichiUploadCase = new ShichiUploadCase();
            enqueueDominator.addPauseCase(shichiUploadCase);
        }

        XiaoShouUploadCase xiaoShouUploadCase;
        // 销售上传
        if (tags.contains(UploadParam.XIAOSHOU)) {
            xiaoShouUploadCase = new XiaoShouUploadCase();
            enqueueDominator.addPauseCase(xiaoShouUploadCase);
        }

        KaoqinUploadCase kaoqinCase;
        // 考勤上传（涉及到七牛异步，最好放在后面，不过其实后来已经用semaphore处理了七牛异步问题了）
        if (tags.contains(UploadParam.KAOQIN)) {
            kaoqinCase = new KaoqinUploadCase(
                    this,
                    SystemHelper.LoginOrganId,
                    SystemHelper.LoginUserId,
                    !NetHelper.IsHaveInternet(this)
            );
            //加入队列
            enqueueDominator.addPauseCase(kaoqinCase);
        }

        //再加一个上传完之后的操作
        enqueueDominator.addCase(new UploadAfterCase(this, new Function1<BaseResponse, Unit>() {
            @Override
            public Unit invoke(BaseResponse baseResponse) {
                displayResult("UploadBusinessDataTask", baseResponse);
                return null;
            }
        }));
        //开始执行上传
        enqueueDominator.go();

    }

    @Override
    public void displayResult(String tag, BaseResponse response) {

        super.displayResult(tag, response);
        mUpLoadFlag = true;
        ViewUtil.dismissProgress();
        uploaw.setBackgroundColor(getResources().getColor(R.color.title_bg));
        if (response == null) {
            all.setChecked(false);
        }
    }

    @Override
    public void uploadFailed() {
        super.uploadFailed();
        mUpLoadFlag = true;
        showMsg("上传操作失败!");
        uploaw.setBackgroundColor(getResources().getColor(R.color.title_bg));
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (countThread != null) {
            countThread.interrupt();
            countThread = null;
        }
    }
}