package com.urovo.activity.newGuideAct.view;

import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AnimationUtils;
import android.view.animation.LayoutAnimationController;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.newGuideAct.presenter.NewGuideContract;
import com.urovo.activity.newGuideAct.presenter.NewGuidePresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.CountDownDominator;

import java.util.List;
import java.util.Timer;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * Created by Sasuke on 2017/5/25.
 * 职业宣言
 */

public class AdFra extends Fragment implements NewGuideContract.view {
    NewGuidePresenter pre;
    @BindView(R.id.title)
    TextView title;//标题
    @BindView(R.id.ad_text_container)
    LinearLayout container;//宣言内容
    @BindView(R.id.jumpBtn)
    Button jumpBtn;//跳过按钮
    private long eachTime;//每一段的动画延迟时间
    private final long TOTAL_TIME = 8;//总共需要的动画时间【秒】（间隔延时在flow_right_in_layout里改）
    private List<String> textList;
    private String titleText;
    CountDownDominator counter;
    Unbinder unbinder;

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        LinearLayout view = (LinearLayout) inflater.inflate(R.layout.ad_fra, container, false);
        unbinder = ButterKnife.bind(this, view);
        textList = pre.getData().declarationTexts;
        if (textList != null && !textList.isEmpty()) {
            titleText = textList.get(0);
            //第0个是title
            title.setText(titleText);
            //去掉标题
            textList.remove(0);
            //因为第0个是title
            eachTime = TOTAL_TIME / (textList.size() - 1);
        }
        //做个时间标记
        pre.saveAdOpenTime();
        return view;
    }

    @Override
    public void onStart() {
        super.onStart();
        //设置布局动画
        LayoutAnimationController lac = AnimationUtils.loadLayoutAnimation(getActivity(), R.anim.flow_right_in_layout);
        lac.setOrder(LayoutAnimationController.ORDER_NORMAL);
        lac.setDelay(eachTime + 1);
        container.setLayoutAnimation(lac);

        //一个个插入文字段落
        for (String s : textList) {
            TextView tv = new TextView(getActivity());
            tv.setText(s);
            tv.setTextColor(Color.parseColor("#4b2d0f"));
            tv.setTextSize(18);
            LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);
            lp.setMargins(0, 0, 0, 60);
            tv.setLayoutParams(lp);
            container.addView(tv);
        }

        //TOTAL_TIME秒后自动关闭
        counter = new CountDownDominator(getActivity(), new CountDownDominator.CountDownCallback() {
            @Override
            public void doWorkWhenTimeUp(int tag) {
                pre.showNextPage();
            }
        });
        counter.build(new Timer()).start(TOTAL_TIME * 1000);

//        new Handler().postDelayed(new Runnable() {
//            @Override
//            public void run() {
//                pre.showNextPage();
//            }
//        },TOTAL_TIME * 1000);

        //跳过按钮
        jumpBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                counter.cancel();
                pre.showNextPage();
            }
        });
    }

    @Override
    public void initUI() {

    }

    @Override
    public boolean showNextPage() {
        return false;
    }

    @Override
    public boolean isPartTimeStaff() {
        return false;
    }

    @Override
    public boolean isPartTimeSalesStaff() {
        return false;
    }

    @Override
    public void showMsg(String msg) {

    }

    @Override
    public void setPresenter(NewGuideContract.presenter presenter) {
        this.pre = (NewGuidePresenter) presenter;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }
}
