package com.urovo.activity.normalquestionact.ui

import android.content.Context
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.normalquestionact.net.QuestionRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.ui.TextColorDominator
import org.jetbrains.anko.find

/**
 * @author Sasuke on 2018/5/15.
 */
class QuestionAdapter(val context: Context,val dataList: List<QuestionRes.ResultInfo>?,val jump: (context: Context,itemData: QuestionRes.ResultInfo) -> Unit): RecyclerView.Adapter<QuestionAdapter.ViewHolder>() {
    var isHighLight: Boolean = false
    var key: String = ""

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(LayoutInflater.from(context).inflate(R.layout.ll_question_menu_item,parent,false))
    }

    override fun getItemCount(): Int {
        return if(dataList == null) 0 else dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolder, pos: Int) {
        val item =  dataList?.get(pos)
        if(item != null){
            holder.apply {
                titleTv.text = item.title
                if(isHighLight){//搜索结果高亮
                    val span = TextColorDominator.textColorChange( Color.parseColor("#4990D2"),0, item.title, key)
                    titleTv.setText(span)
                }
                itemLayout.setOnClickListener {
                        jump.invoke(context,item)
                }
            }
        }
    }

    class ViewHolder(view: View): RecyclerView.ViewHolder(view){
        var itemLayout: LinearLayout
        var titleTv: TextView

        init {
            itemLayout = view.find(R.id.questionItem)
            titleTv = view.find(R.id.questionTitle)
        }

    }

    /**
     * 设置是否关键字高亮
     */
    fun setIsHighLightText(isHighLight: Boolean,key: String){
        this.isHighLight = isHighLight
        this.key = key
    }
}