package com.urovo.activity.normalquestionact.view

import android.content.Context
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.normalquestionact.net.QuestionRes
import com.urovo.activity.normalquestionact.presenter.QuestionContract
import com.urovo.activity.normalquestionact.presenter.QuestionPre
import com.urovo.activity.normalquestionact.ui.QuestionAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.view.LoadWaitDominator
import com.urovo.wugumofang.view.baseWebViewAct.WebViewAct
import kotlinx.android.synthetic.main.ll_normal_question_act.*

/**
 * @author Sasuke on 2018/5/3.
 * 常见问题，没睡醒写成NormalQuestion“正常问题”了。。。。懒得改了。。。
 *
 * 常见问题 最外层入口，也就是第一层目录（其实也可以作二级目录，根据标记来判断吧，毕竟布局是一样的
 * 不过如果标记是最里面一层目录了，那就换一下布局，最里面的布局需要日期什么的）
 */

class NormalQuestionAct : BaseActivity(), QuestionContract.view {
    var pre: QuestionPre? = null
    var loadWait: LoadWaitDominator? = null

    companion object {
        /**
         * Intent传父目录的入口id和层级
         */
        const val INTENT_PARENT_ID = "INTENT_PARENT_ID"
        const val INTENT_PARENT_STAIR = "INTENT_PARENT_STAIR"
        const val INTENT_PARENT_URL = "INTENT_PARENT_URL"
        const val INTENT_PARENT_TITLE = "INTENT_PARENT_TITLE"

    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ll_normal_question_act)
        initTitle()
        titleTextView.text = intent.getStringExtra(INTENT_PARENT_TITLE) ?: "常见问题指引"

        QuestionPre(this).apply { start() }
    }

    override fun init() {
        loadWait = LoadWaitDominator(this, container)
        questionRv.apply { layoutManager = LinearLayoutManager(this@NormalQuestionAct) }
        fab.apply {
            attachToRecyclerView(questionRv)//悬浮按钮绑定
            setOnClickListener {
                startActivity(Intent(this@NormalQuestionAct, QuestionSearchAct::class.java).apply {
                    setFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION)
                })
            }
        }

        pre?.queryProblemData(
                intent.getStringExtra(INTENT_PARENT_STAIR) ?: "",
                intent.getStringExtra(INTENT_PARENT_ID) ?: "")
    }


    /**
     * 请求返回刷新UI
     */
    override fun refreshUI(dataList: List<QuestionRes.ResultInfo>) {
        questionRv.adapter = QuestionAdapter(this, dataList, this::jumpToNextPage)

    }

    /**
     * 如果后台给的url是空的，那就跳目录，否则跳文章
     */
    fun jumpToNextPage(context: Context, itemData: QuestionRes.ResultInfo) {
        if (itemData.url.isNullOrEmpty()) {
            startActivity(Intent(context, NormalQuestionAct::class.java).apply {
                putExtra(INTENT_PARENT_STAIR, itemData.stair)
                putExtra(INTENT_PARENT_ID, itemData.id)
                putExtra(INTENT_PARENT_TITLE, itemData.title)
            })
        } else {
            WebViewAct.launch(context,SystemHelper.LoginUserId,itemData.title,itemData.url,Intent(context,WebViewAct::class.java).apply {
                putExtra(WebViewAct.OPTION,WebViewAct.SHARE_BAR_NEW)//显示新版底栏
                putExtra(WebViewAct.PAGE_ID,itemData.id)//id要用来记数
            })

//            startActivity(Intent(this, LearningCenterDetailActivity::class.java).apply {
//                putExtra(INTENT_PARENT_URL, itemData.url?.takeUnless { "http" in it}.run { "http://" + itemData.url })
//                putExtra(INTENT_PARENT_TITLE, itemData.title)
//            })
        }
    }

    override fun showLoad() {
        loadWait?.show(LoadWaitDominator.LOADING)
    }

    override fun showNetError() {
        loadWait?.show(LoadWaitDominator.NET_ERROR)
    }

    override fun showNoData() {
        loadWait?.show(LoadWaitDominator.NO_DATA)
    }

    override fun dismissLoadWait() {
        loadWait?.dismissAll()
    }

    override fun setPresenter(pre: QuestionContract.pre?) {
        this.pre = pre as QuestionPre
    }
}