package com.urovo.activity.overduequeryactivity.ui

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.overduequeryactivity.net.OverDueQueryRes
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.OverdueQueryListItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019-6-5 0005.
 * 临期查询Adapter
 */
class OverDueQueryAdapter(val dataList: MutableList<OverDueQueryRes.ResultInfo.StockLq>?) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        return ViewHolderX(DataBindingUtil.inflate<OverdueQueryListItemBinding>(
                LayoutInflater.from(parent.context),
                R.layout.overdue_query_list_item,
                parent,
                false).root)
    }

    override fun getItemCount(): Int {
        return dataList?.size ?: 0
    }

    override fun onBindViewHolder(holder: ViewHolderX, position: Int) {
        val binding = DataBindingUtil.getBinding<OverdueQueryListItemBinding>(holder.view)
        binding?.data = dataList?.get(position)
    }

    /**设置数据表*/
    fun setDatas(newDatas: List<OverDueQueryRes.ResultInfo.StockLq>?) {
        if ( !newDatas.isNullOrEmpty()) {
            dataList?.clear()
            dataList?.addAll(newDatas)
            notifyDataSetChanged()
        }
    }
}