package com.urovo.activity.personalcenter.presenter.contract

import com.urovo.activity.personalcenter.model.MergeMemberEntity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.base.mvp.AbsView

/**
 * 会员合并 Contract
 * @author LW
 */
interface MergeMemberContract {

    interface IView : AbsView {

        /**
         * 会员信息
         */
        fun mergeMemberInfo(type: Int, mergeMemberBean: MergeMemberEntity?)

        /**
         * 合并会员信息状态
         */
        fun mergeMemberInfoExecuteStatus(status: Boolean)

    }

    interface IPresenter : BasePresenter {
        /**
         * 旧手机号获取会员信息
         * @param oldMobile:String 手机号
         * @param stopId:String 门店
         */
        fun requestMemberInfoOldMobile(oldMobile: String?, stopId: String?)

        /**
         * 新手机号获取会员信息
         * @param newMobile:String 手机号
         */
        fun requestMemberInfoNewMobile(newMobile: String?)

        /**
         * 合并会员信息
         * @param map:Map
         */
        fun requestMergeMemberInfoExecute(
            oldMobile: String?,
            oldCusId: String?,
            newMobile: String?,
            newCusId: String?,
            staffId: String?
        )
    }
}