package com.urovo.activity.personalcenter.response

import com.urovo.activity.personalcenter.MergeMemberApi
import com.urovo.activity.personalcenter.model.MergeMemberEntity
import com.urovo.activity.personalcenter.model.MergeMemberRequest
import com.urovo.wugumofang.net.RetrofitHelper
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 * 合并会员
 * @author LW
 */
class MergeMemberDepository {

    private val mNewApiService by lazy {
        RetrofitHelper.createNewApi(MergeMemberApi::class.java)
    }

    /**
     * 旧手机号获取会员信息
     * @param oldMobile:String 手机号
     * @param stopId:String 门店
     */
    fun requestMemberInfoOldMobile(
        oldMobile: String,
        stopId: String
    ): Call<RequestResult<MergeMemberEntity>> {
        return mNewApiService.mergeMemberInfoOldMobile(oldMobile, stopId)
    }

    /**
     * 新手机号获取会员信息
     * @param newMobile:String 手机号
     */
    fun requestMemberInfoNewMobile(newMobile: String): Call<RequestResult<MergeMemberEntity>> {
        return mNewApiService.mergeMemberInfoNewMobile(newMobile)
    }

    /**
     * 合并会员信息
     * @param map:Map
     */
    fun requestMergeMemberInfoExecute(
        request: MergeMemberRequest
    ): Call<RequestResult<Any>> {
        return mNewApiService.mergeMemberInfoExecute(request)
    }

}