package com.urovo.activity.personalcenter.ui;

import android.app.ProgressDialog;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.request.animation.GlideAnimation;
import com.bumptech.glide.request.target.SimpleTarget;
import com.google.gson.Gson;
import com.tencent.mm.sdk.openapi.IWXAPI;
import com.tencent.mm.sdk.openapi.WXAPIFactory;
import com.tencent.wework.api.model.WWMediaImage;
import com.umeng.socialize.Config;
import com.umeng.socialize.ShareAction;
import com.umeng.socialize.bean.SHARE_MEDIA;
import com.umeng.socialize.media.UMImage;
import com.urovo.activity.personalcenter.model.QrcodeTicketBean;
import com.urovo.activity.zhuanshu.QrCodeDominator;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.PictureUtil;
import com.urovo.wugumofang.ui.ViewUtil;

import okhttp3.Request;

import static com.urovo.wugumofang.system.BaseAppManager.iwwapi;

public class QueryTicketAct extends BaseActivity {

    TextView actionTitleTv;
    ImageView qrCodeImage;
    LinearLayout shareEnterpriseWxLl;
    LinearLayout shareWxLl;
    LinearLayout buttonSaveLl;
    private IWXAPI mApi;
    /**
     * 网络请求url图片地址
     */
    private String qrUrl = null;
    /**
     * 网络请求url图片地址
     */
    private Bitmap qrUrlImage = null;
    /**
     * 图片命名
     */
    private String mErWeiMaPictureJpg = SystemHelper.LoginUserId
            + "_ticket"
//            + new SimpleDateFormat("yyyyMMddHHmmss", Locale.CANADA).format(new Date())
            + ".jpg";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.query_ticket_act);
        initTitle();
        initView();
        setListeners();
        getQRCodeImage();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("优惠券查询");
    }

    public void initView() {
        actionTitleTv = (TextView) findViewById(R.id.actionTitleTv);
        qrCodeImage = (ImageView) findViewById(R.id.qrCodeImage);
        shareEnterpriseWxLl = (LinearLayout) findViewById(R.id.share_enterprise_weixin_ll);
        shareWxLl = (LinearLayout) findViewById(R.id.share_weixin_ll);
        buttonSaveLl = (LinearLayout) findViewById(R.id.button_save_ll);
    }

    private void setListeners() {
        mApi = WXAPIFactory.createWXAPI(this, NetParam.WXAPP_ID, false);
        shareEnterpriseWxLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (qrUrl == null) {
                    showMsg("请等待网络图片加载完成...");
                    return;
                }
                //分享到企业微信
                shareQYWX();
            }
        });
        shareWxLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (qrUrl == null) {
                    showMsg("请等待网络图片加载完成...");
                    return;
                }
                //分享到微信
                shareWeiXin(SHARE_MEDIA.WEIXIN);
            }
        });
        buttonSaveLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (qrUrl == null) {
                    showMsg("请等待网络图片加载完成...");
                    return;
                }
                if (qrUrlImage == null) {
                    showMsg("请等待网络图片加载完成...");
                    return;
                }
                //保存到本地
                PictureUtil.saveBitmapFile(qrUrlImage, Files.tempPicture, mErWeiMaPictureJpg);
                //插入到相册
                QrCodeDominator.saveQrCode(QueryTicketAct.this, Files.tempPicture, mErWeiMaPictureJpg);
                //删除本地临时图片
                PictureUtil.deleteFileIfExists(QueryTicketAct.this, Files.tempPicture, mErWeiMaPictureJpg);
            }
        });
    }

    private void shareQYWX() {
        if (!iwwapi.isWWAppInstalled()) {
            showMsg("未安装企业微信");
            return;
        }
        PictureUtil.saveBitmapFile(qrUrlImage, Files.tempPicture, mErWeiMaPictureJpg);
        WWMediaImage img = new WWMediaImage();
        img.fileName = mErWeiMaPictureJpg;
        img.filePath = Files.tempPicture + mErWeiMaPictureJpg;
        img.appPkg = BaseAppManager.PACKAGE_NAME;
        img.appName = BaseAppManager.getAppName();
        img.appId = NetParam.EW_APPID;
        img.agentId = NetParam.EW_AGENTID;
        iwwapi.sendMessage(img);
    }

    private void shareWeiXin(SHARE_MEDIA type) {
        if (!mApi.isWXAppInstalled()) {
            showMsg("未安装微信客户端");
            return;
        }
        showDialog();
        UMImage image = new UMImage(this, qrUrl);
        new ShareAction(this).setPlatform(type)
                .withMedia(image) // 本地图片作为分享缩略图
                .withTargetUrl(qrUrl)
                .share();
    }

    private void showDialog() {
        ProgressDialog dialog = new ProgressDialog(this);
        dialog.setTitle("启动分享中");
        dialog.setMessage("请稍等.....");
        Config.dialog = dialog;
    }

    public void getQRCodeImage() {
        ViewUtil.showProgress(QueryTicketAct.this, "", "请稍等.....");
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.GET_TICKET_URL, null,
                new OkHttpDominator.ResultCallback<String>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg("获取优惠券信息" + getString(R.string.request_data_fail));
                    }

                    @Override
                    public void onResponse(String json) {
                        ViewUtil.dismissProgress();
                        if (json == null || TextUtils.isEmpty(json)) {
                            showMsg("没有返回数据");
                            return;
                        }
                        QrcodeTicketBean mActQrcodeBean = new Gson().fromJson(json, QrcodeTicketBean.class);
                        if (null != mActQrcodeBean && mActQrcodeBean.msgCode == 0) {
                            if (null != mActQrcodeBean.getResultInfo()) {
                                setViewData(mActQrcodeBean);
                            }
                        } else {
                            showMsg("没有返回数据");
                        }
                    }
                });
    }

    private void setViewData(QrcodeTicketBean mActQrcodeBean) {
        if (mActQrcodeBean.getResultInfo() != null) {
            qrUrl = mActQrcodeBean.getResultInfo().getUrl();
            actionTitleTv.setText(mActQrcodeBean.getResultInfo().getTitle());
            Glide.with(this).load(!TextUtils.isEmpty(qrUrl) ? qrUrl : R.drawable.qr_ticket)
                    .asBitmap()
                    .centerCrop()
                    .dontAnimate()//防止设置placeholder导致第一次不显示网络图片,只显示默认图片的问题
                    .error(R.drawable.pop_hone_qgwsr_default)
                    .placeholder(R.drawable.pop_hone_qgwsr_default)
                    .into(new SimpleTarget<Bitmap>() {

                        @Override
                        public void onResourceReady(Bitmap resource, GlideAnimation<? super Bitmap> glideAnimation) {
                            qrUrlImage = resource;
                            qrCodeImage.setImageBitmap(qrUrlImage);
                        }
                    });
        }
    }
}