package com.urovo.activity.personalcenter.ui.voucher.adapter

import android.view.View
import android.widget.TextView
import androidx.core.content.ContextCompat
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.urovo.activity.personalcenter.model.CardCustomerInfo
import com.urovo.wugumofang.R

/**
 * 权益卡数据适配器
 * @author LW
 */
class VoucherCardDataAdapter(
    data: MutableList<CardCustomerInfo>,
    private var type: Int
) : BaseQuickAdapter<CardCustomerInfo, BaseViewHolder>(R.layout.voucher_card_list_item, data) {

    fun setType(type: Int) {
        this.type = type
    }

    override fun convert(helper: BaseViewHolder?, cardCustomerInfo: CardCustomerInfo?) {
        helper?.let {
            val consMoney: TextView = it.getView(R.id.consMoney)
            if (type == 1) {
                consMoney.visibility = View.GONE
            } else {
                consMoney.visibility = View.VISIBLE
            }

            it.setText(R.id.name, cardCustomerInfo?.name)
            it.setText(R.id.mobile, cardCustomerInfo?.mobile)
            it.setText(R.id.consMoney, cardCustomerInfo?.consMoney)
            if (cardCustomerInfo?.flag == "是") {
                it.setTextColor(
                    R.id.flag,
                    ContextCompat.getColor(mContext, R.color.orange_text_color)
                )
            }
            it.setText(R.id.flag, cardCustomerInfo?.flag)
        }
    }
}