package com.urovo.activity.qualityBackAct.model

import com.urovo.wugumofang.response.Base3Response
import java.io.Serializable

/**
 * allProSumAmount (number, optional):产品总金额 ,
allProSumQty (number, optional):产品总数量 ,
dispatchDate (string, optional):配送时间 ,
takeGoodDate (string, optional): 收货时间 ,
boxReceivedNum(integer,optional):实收箱数量,
boxUnreceivedNum(integer,optional): 未收箱数量,
dispatchDetailList (Array[DispatchDetail], optional):配送明细 ,
dispatchPerson (string, optional):制单人员 ,
waveNo (string, optional):配送波次号 ,
dispatchReason (string, optional):配送原因 ,
dispatchStatus (string, optional):配送查询标识,0:未收 1:待审核 2:已收货 ,
dispatchType (string, optional):配送类型
 */

/**
 * dispachePerson (string, optional):制单人员 ,
 * dispatchBill (string, optional):配送单号 ,
 * proCode (string, optional):产品编码 ,
 * proName (string, optional):产品名字 ,
 * proPrice (number, optional):产品价格 ,
 * proQty (number, optional):产品数量 ,
 * proSumAmount (number, optional):产品总价(产品的单价 * 产品的数量) ,
 * uomName (string, optional):单位
 */

data class DispatchProductEntity(
    var resultInfo: List<DispatchProductBean>?
) : Base3Response(), Serializable {

    data class DispatchProductBean(
        val allProSumAmount: String?,
        val allProSumQty: String?,
        val takeGoodDate: String?,
        val boxUnreceivedNum: String?,
        val boxReceivedNum: String?,
        val dispatchDate: String?,
        val dispatchDetailList: List<DispatchDetailBean>?,
        val waveNo: String?,
        val dispatchPerson: String?,
        val dispatchReason: String?,
        val dispatchStatus: String?,
        val dispatchType: String?,
        val pickingCode:String?
    ) : Serializable {
        data class DispatchDetailBean(
            var chooseStatus: Boolean = false,
            val dispachePerson: String?,
            val dispatchBill: String?,
            val proCode: String?,
            val proName: String?,
            val proPrice: String?,
            val proQty: String?,
            val proSumAmount: String?,
            val uomName: String?
        ) : Serializable {
            override fun toString(): String {
                return "DispatchDetailBean(chooseStatus=$chooseStatus, dispachePerson=$dispachePerson, dispatchBill=$dispatchBill, proCode=$proCode, proName=$proName, proPrice=$proPrice, proQty=$proQty, proSumAmount=$proSumAmount, uomName=$uomName)"
            }
        }

        override fun toString(): String {
            return "DispatchProductBean(allProSumAmount=$allProSumAmount, allProSumQty=$allProSumQty, dispatchDate=$dispatchDate, dispatchDetailList=$dispatchDetailList, waveNo=$waveNo, dispatchPerson=$dispatchPerson, dispatchReason=$dispatchReason, dispatchStatus=$dispatchStatus, dispatchType=$dispatchType)"
        }


    }

    override fun toString(): String {
        return "DispatchProductEntity(resultInfo=$resultInfo)"
    }


}

