package com.urovo.activity.qualityBackAct.model

import com.urovo.wgmf.db.dao.entitys.ProductEntity
import java.util.*

/**
 * Created by Sasuke on 2017/2/9.
 * 其实没什么卵用
 */

class ProductData {
    lateinit var product: ProductEntity

    /**
     * 限制输入内容
     */
    var inputRule = ArrayList(
            Arrays.asList(
                    Arrays.asList("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "无"),
                    Arrays.asList("1", "2")
            ))


    /**
     * 请选择类别 那一栏的下拉选择数据源（根据类型来决定不同数据源）
     */
    fun getSpinnerArrayByType(qtyp: QTYPE): Array<String> {
        return when (qtyp) {
            QTYPE.PACKAGE_BOX -> boxArray
            QTYPE.PACKAGE_BAG -> bagArray
            QTYPE.DATE_IDENTIFY -> dateArray
            QTYPE.SHORTAGE -> shortageArray
            QTYPE.FOREIGN -> foreignArray
            QTYPE.BUG ->bugArray
            QTYPE.SMELL ->smellArray
            QTYPE.LOOK_BAD ->lookBadArray
            QTYPE.STORE_REASON -> storeReasonArray
            QTYPE.NO_PRODUCT -> noProductArray
            QTYPE.OTHER -> otherArray
            else ->arrayOf()
        }
    }

    /**
     * 通过类型，来获取不同的详细说明输入框的提示文字
     */
    fun getReportHintByType(qtyp: QTYPE): String {
        return when (qtyp) {
            QTYPE.PACKAGE_BOX -> boxReport
            QTYPE.PACKAGE_BAG -> bagReport
            QTYPE.DATE_IDENTIFY -> dateReport
            QTYPE.SHORTAGE -> shortageReport
            QTYPE.FOREIGN -> foreignReport
            QTYPE.BUG ->bugReport
            QTYPE.SMELL ->smellReport
            QTYPE.LOOK_BAD ->lookBadReport
            QTYPE.STORE_REASON -> storeReport
            QTYPE.NO_PRODUCT ->noProductReport
            QTYPE.OTHER -> otherReport
            else ->"请填写描述（尽可能描述清楚问题导致的原因）"
        }
    }

    val boxReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "消费者弄坏\\门店老鼠咬坏等需选择质量类别为“门店原因”，" +
            "到货就发现外箱破损等物流原因需走到货误差流程，拍照请多角度" +
            "拍摄清楚破损位置(比如植八益生元破漏,需拆开外包装袋对里面益生" +
            "元盒子的具体破损部位进行拍摄)"

    val bagReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "消费者弄坏\\门店老鼠咬坏等需选择质量类别为“门店原因”，" +
            "到货就发现外箱破损等物流原因需走到货误差流程，拍照请多角度" +
            "拍摄清楚破损位置(中包袋或条包破损,需拆开外包装对里面小包装的破损部位进行拍摄)"

    val dateReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "如果日期模糊，请尽可能描述是收到货就发现日期模糊，" +
            "还是陈列久了被消费者擦掉日期"

    val shortageReport = "请填写描述，尽可能描述清楚问题导致的原因"

    val foreignReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "什么时候在什么位置发现异物，异物形状及大小，" +
            "请多角度拍摄清楚异物，并将异物留待通知是否寄回总部查看（头发不用保留）"

    val bugReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "什么时候在什么位置发现虫子，虫子类别/大小/死活，" +
            "包装有没有破损，开封多久长虫等，" +
            "请多角度拍摄清楚虫子，并将问题产品留待通知是否寄回总部查看"

    val smellReport = "请填写描述，尽可能描述清楚问题导致的原因" +
            "（产品变质导致的哈味/霉味/陈味，烤糊导致的焦味/苦味等），" +
            "并将问题产品留待通知是否寄回总部查看"

    val lookBadReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "并将问题产品留待通知是否寄回总部查看"

    val otherReport = "请填写描述，尽可能描述清楚问题导致的原因，" +
            "到货日期旧需要提供波次单号，物料质量问题请走物料质量问题反馈单"

    val storeReport = "请填写描述，尽可能描述清楚问题导致的原因"

    val noProductReport = "请填写描述，尽可能描述清楚报损的原因"

    /**给Spinner提供的数据源 */
    val boxArray = arrayOf("请选择",
            "盒子凹扁",
            "盒身破裂",
            "盖子破裂",
            "盒子脱胶",
            "盒子封口不良",
            "盒子易撕口开口",
            "盖扣扣不上",
            "包装膜破损",
            "包装脏污",
            "其它")

    val bagArray = arrayOf("请选择",
            "真空包装漏气",
            "端封不严",
            "中封不良",
            "袋身破口",
            "其它"
    )

    val dateArray = arrayOf("请选择",
            "没有生产日期",
            "生产日期模糊",
            "其它"
    )

    val shortageArray = arrayOf("请选择",
            "净含量不足",
            "空包\\袋\\盒",
            "少包\\袋\\盒",
            "其它"
    )

    val foreignArray = arrayOf("请选择",
            "沙石",
            "金属",
            "线绳",
            "头发",
            "塑料",
            "纸片",
            "秸杆",
            "其它"
    )

    val bugArray = arrayOf("请选择",
            "活虫",
            "死虫",
            "虫丝",
            "其它"
    )

    val smellArray = arrayOf("请选择",
            "哈味",
            "焦味",
            "苦味",
            "陈味",
            "霉味",
            "其它"
    )

    val lookBadArray = arrayOf("请选择",
            "山药/霉根黑片",
            "破碎/粉碎",
            "结团/结块",
            "色深/色浅",
            "口感口味问题",
            "其它"
    )

    val storeReasonArray = arrayOf("请选择",
            "门店老鼠咬坏",
            "消费者弄坏",
            "临期过期",
            "磨坏",
            "磨粉机坏",
            "门店漏水漏雨",
            "其它"
    )

    val noProductArray = arrayOf("请选择",
            "消费者不买单",
            "试吃",
            "陈列",
            "商场检查",
            "其它"
    )

    val otherArray = arrayOf("请选择",
            "到货日期旧",
            "包装印刷有问题",
            "包装错版",
            "其它"
    )
}
