package com.urovo.activity.qualityBackAct.presenter;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.TextUtils;

import androidx.fragment.app.Fragment;

import com.google.gson.Gson;
import com.urovo.activity.common.OrderGoodsChoseMonthActivity;
import com.urovo.activity.common.OrderGoodsChoseSingleActivity;
import com.urovo.activity.qualityBackAct.model.ArriveErrorData;
import com.urovo.activity.qualityBackAct.model.DispatchProductEntity;
import com.urovo.activity.qualityBackAct.model.ProductData;
import com.urovo.activity.qualityBackAct.model.QBackInput;
import com.urovo.activity.qualityBackAct.model.QTYPE;
import com.urovo.activity.qualityBackAct.model.SuggestionData;
import com.urovo.activity.qualityBackAct.net.ArrErrTextImgRes;
import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.net.LightQBackEntity;
import com.urovo.activity.qualityBackAct.net.QbackResponse;
import com.urovo.activity.qualityBackAct.view.ArriveErrorFra;
import com.urovo.activity.qualityBackAct.view.DispatchProductChooseActivity;
import com.urovo.activity.qualityBackAct.view.LightStateFra;
import com.urovo.activity.qualityBackAct.view.QBackInputAct;
import com.urovo.wgmf.tool.netUtil.QiNiuDominator;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.MyToast;

import java.util.HashMap;
import java.util.List;

import okhttp3.MediaType;
import okhttp3.Request;

import static com.urovo.activity.qualityBackAct.model.QBackInput.PHOTO_OVERDUE_MIN_NUM;
import static com.urovo.activity.qualityBackAct.model.QTYPE.ARRIVE_ERROR;
import static com.urovo.activity.qualityBackAct.model.QTYPE.CABINET;
import static com.urovo.activity.qualityBackAct.model.QTYPE.CPLN_WORKFLOW;
import static com.urovo.activity.qualityBackAct.model.QTYPE.MACHINE;
import static com.urovo.activity.qualityBackAct.model.QTYPE.MATERIAL;
import static com.urovo.activity.qualityBackAct.model.QTYPE.OVERDUE;
import static com.urovo.wugumofang.constants.NetParam.URL_MACHINE_QBACK;

/**
 * Created by Sasuke on 2017/1/20.
 */

public class QBackInputPresenter implements QBackContract.presenter {
    QBackContract.view mView;
    QBackInput data;
    QBackContract.view mFra;

    ArriveErrorData arriveErrorData;
    ProductData productData;
    SuggestionData suggestionData;

    public QBackInputPresenter(QBackContract.view mView) {
        this.mView = mView;
        this.data = new QBackInput();
    }

    /**
     * 生成唯一单号
     */
    public void makeOrderId() {
        //如果缓存里已经有这个类型了，那就直接拿已经生成过的单号，
        //避免无聊切换类型再切回来时，导致同一类型下的单号改变，后台就判断不出来重复单了。
        if (getData().orderIdCache.containsKey(
                getData().qtype)) {
            getData().setOrderId(getData().orderIdCache.get(getData().qtype));
        } else {
            getData().setOrderId(SystemHelper.makeBillCode());//生成新的唯一单号
            getData().orderIdCache.put(getData().qtype, getData().orderId);
        }
    }

    //==================getData专区==================
    public QBackInput getData() {
        if (data == null) {
            data = new QBackInput();
        }
        return data;
    }

    /**
     * 到货误差data
     */
    public ArriveErrorData arriveErrorData() {
        if (arriveErrorData == null) {
            return new ArriveErrorData();
        }
        return arriveErrorData;
    }

    /**
     * 产品质量问题data
     */
    public ProductData productData() {
        if (productData == null) {
            return new ProductData();
        }
        return productData;
    }

    /**
     * 意见与建议
     */
    public SuggestionData suggestionData() {
        if (suggestionData == null) {
            return new SuggestionData();
        }
        return suggestionData;
    }

    //==================getData专区==================
    public void setFragment(QBackContract.view mFra) {
        this.mFra = mFra;
        this.mFra.setPresenter(this);
    }

    @Override
    public void start() {
        mView.initUI();
        makeOrderId();//data的type都会在initUI里被赋值，所以makeOrderId()要在initUI()后再执行，否则type都还没被赋值，就生成单号缓存会出问题。
    }

    /**
     * 选择产品（各Fragment里的）
     */
    public void selectorGoods(Fragment fra) {
        if (getData().getParentType() == ARRIVE_ERROR) {//到货误差上报选择产品优化，根据最近30天的已收货单来选择产品
            Intent intent = new Intent(fra.getActivity(), OrderGoodsChoseMonthActivity.class);
            intent.putExtra("storeid", SystemHelper.LoginOrganId);
            intent.putExtra(OrderGoodsChoseSingleActivity.Search_type, OrderGoodsChoseMonthActivity.type_quality);
            fra.startActivityForResult(intent, QBackInput.SELECT_MONTH_GOODS);
        } else {
            Intent intent = new Intent(fra.getActivity(), OrderGoodsChoseSingleActivity.class);
            intent.putExtra("storeid", SystemHelper.LoginOrganId);
            intent.putExtra(OrderGoodsChoseSingleActivity.Search_type, OrderGoodsChoseSingleActivity.type_quality);
            fra.startActivityForResult(intent, QBackInput.SELECT_GOODS);
        }

    }

    /**
     * 选择配送单号
     *
     * @param dispatchProductEntity DispatchProductEntity
     * @param dispatchProductPos    Int
     * @param dispatchProductType   String
     */
    public void selectorDispatchProduct(Fragment fra, DispatchProductEntity dispatchProductEntity,
                                        int dispatchProductPos, String dispatchProductType) {

        Intent intent = new Intent(fra.getActivity(), DispatchProductChooseActivity.class);
        intent.putExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_DATA, dispatchProductEntity);
        intent.putExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_POS, dispatchProductPos);
        intent.putExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_TYPE, dispatchProductType);
        fra.startActivityForResult(intent, QBackInput.SELECT_MONTH_GOODS);
    }


    /**
     * 请求到货误差情况下的文字图片说明
     *
     * @param shopId  门店Id
     * @param staffId 用户Id
     */
    public void queryArrErrTextImg(String shopId, String staffId) {
        HashMap<String, String> param = new HashMap<>(2);
        param.put("shopId", shopId);
        param.put("staffId", staffId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.GET_ARRIVE_ERROR_PHOTO_TEXT,
                param, new OkHttpDominator.ResultCallback<ArrErrTextImgRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        MyToast.show(e.getMessage());
                    }

                    @Override
                    public void onResponse(ArrErrTextImgRes res) {
                        if (res == null) return;
                        if (res.msgCode != 0) {
                            MyToast.show(res.msgInfo);
                            return;
                        }
                        ((QBackInputAct) mView).refreshArrErrText(res.getResultInfo());
                    }
                });
    }

    /**
     * 到货误差配送单号产品
     *
     * @param storeNo 门店Id
     * @param userNo  用户Id
     */
    public void queryDispatchProduct(String storeNo, String userNo) {
        HashMap<String, String> param = new HashMap<>();
        param.put("storeNo", storeNo);
        param.put("userNo", userNo);
        mView.showProgressBar("正在加载数据", "请稍等......", false);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_DISPATCH_PRODUCT,
                param, new OkHttpDominator.ResultCallback<DispatchProductEntity>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        mView.dismissProgressBar();
                        mView.showMsg(e.getMessage());
                    }

                    @Override
                    public void onResponse(DispatchProductEntity data) {
                        mView.dismissProgressBar();
                        if (data != null) {
                            if (data.msgCode == AppConstants.Http.RESPONSE_SUCCESS) {
                                if (mFra instanceof ArriveErrorFra) {
                                    ((ArriveErrorFra) mFra).refreshDispatchProduct(data);
                                }
                            } else {
                                mView.showMsg(data.msgInfo);
                            }
                        } else {
                            mView.showMsg("暂无数据");
                        }
                    }
                });
    }

    /**
     * 提交按钮响应
     */
    public void submit() {
        //我要走流程  和  本机问题  和 亮灯情况上报 不需要强制添加图片，其它的才要强制验证。
        if (getData().getParentType() != CPLN_WORKFLOW &&
                getData().getParentType() != MACHINE &&
                getData().getParentType() != QTYPE.SUGGESTION &&
                getData().getParentType() != QTYPE.LIGHT) {
            if (getData().photoList.size() == 0) {//如果没有添加图片
                mView.showMsg("请添加图片吧");
                return;
            }
        }
        //临过期要求至少上传3张图片
        if (getData().getParentType() == OVERDUE && getData().photoList.size() < PHOTO_OVERDUE_MIN_NUM) {
            mView.showMsg("请至少上传" + PHOTO_OVERDUE_MIN_NUM + "张图片");
            return;
        }

        final BaseEntity entity = mFra.packData();//打包数据，里面会判断输入合法性，返回true才继续上传。

        //====return=====如果类型是”亮灯情况上报“，那就单独用Param形式传参，而不是打包Json。
        if (entity != null && getData().getParentType() == QTYPE.LIGHT) {
            //不过如果亮灯情况上报时，是“有灯不亮”，那就要强制添加图片了
            if (((LightQBackEntity) entity).getLampStatus() == LightStateFra.SOME_LIGHT_OFF
                    && getData().photoList.size() == 0) {
                mView.showMsg("请添加图片吧");
                return;
            }
            if (getData().photoList.size() > 0) {//有图的情况
                mView.showProgressBar("正在上传图片", "请稍等......", false);
                //在进行异步上传图片之前，都会在onPreExecute()对photoList进行一次clear的
                QiNiuDominator.uploadImages(getData().photoList, new QiNiuDominator.CompleteQiniu() {
                    @Override
                    public void uploadInfo(List<String> qiniuUrl) {//只有在全部图片上传7牛成功才做这一步
                        //先把图片地址加进去
                        entity.addAll2List(qiniuUrl);
                        uploadNotJson(ApiUrls.APPSALER.QBACK_LIGHT, entity.makeNetParam());//之所以传entity而不是json是为了重新组装url部分
                    }
                });
            } else {//没有图的情况
                uploadNotJson(ApiUrls.APPSALER.QBACK_LIGHT, entity.makeNetParam());
            }
            return;
        }


        //====return=====如果类型是“多点陈列“，那就单独用Param形式传参，而不是打包Json。
        if (entity != null && getData().getParentType() == QTYPE.CHINRETSU) {
            mView.showProgressBar("正在上传图片", "请稍等......", false);
            //在进行异步上传图片之前，都会在onPreExecute()对photoList进行一次clear的
            QiNiuDominator.uploadImages(getData().photoList, new QiNiuDominator.CompleteQiniu() {
                @Override
                public void uploadInfo(List<String> qiniuUrl) {//只有在全部图片上传7牛成功才做这一步
                    //先把图片地址加进去
                    entity.addAll2List(qiniuUrl);
                    uploadNotJson(ApiUrls.APP.QBACK_CHINRETSU, entity.makeNetParam());//之所以传entity而不是json是为了重新组装url部分
                }
            });
            return;
        }


        //=====return====如果是产品质量问题，需要添加弹窗提示：请保留该质量问题的产品/异物（虫害除外），必须客诉专员确认信息后再处理（不超过24小时）！点击“确定”按钮进行提交。
        if (entity != null && getData().getParentType() == QTYPE.PRODUCT) {
            new AlertDialog.Builder((Context) mView)
                    .setTitle("提示")
                    .setMessage("请保留该质量问题的产品/异物（虫害除外），必须客诉专员确认信息后再处理（不超过24小时）！")
                    .setNegativeButton("取消", null)
                    .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface, int i) {
                            mView.showProgressBar("正在上传图片", "请稍等......", false);
                            //在进行异步上传图片之前，都会在onPreExecute()对photoList进行一次clear的
                            QiNiuDominator.uploadImages(getData().photoList, new QiNiuDominator.CompleteQiniu() {
                                @Override
                                public void uploadInfo(List<String> qiniuUrl) {//只有在全部图片上传7牛成功才做这一步
                                    uploadJson(entity, qiniuUrl, getData().getParentType());//之所以传entity而不是json是为了重新组装url部分
                                }
                            });
                        }
                    }).show();
            return;
        }

        //====return===其它情况
        if (entity != null) {//为空或null都说明数据填写错误，不进行上传操作。
            if (getData().photoList.size() == 0) {//走流程  和  本机问题 可以不带图片直接上传表格。
                uploadJson(entity, null, getData().getParentType());
            } else {
                mView.showProgressBar("正在上传图片", "请稍等......", false);
                //在进行异步上传图片之前，都会在onPreExecute()对photoList进行一次clear的
                QiNiuDominator.uploadImages(getData().photoList, new QiNiuDominator.CompleteQiniu() {
                    @Override
                    public void uploadInfo(List<String> qiniuUrl) {//只有在全部图片上传7牛成功才做这一步
                        uploadJson(entity, qiniuUrl, getData().getParentType());//之所以传entity而不是json是为了重新组装url部分
                    }
                });
            }
        }
    }

    /**
     * 操，新的上传传参方式不是Json形式了，改成Param形式。。。。又要单独分情况。。。。呵呵。
     */
    public void uploadNotJson(String apiUrl, HashMap<String, String> params) {
        mView.showProgressBar("正在上传上报信息", "请稍等......", false);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + apiUrl, params, new OkHttpDominator.ResultCallback<QbackResponse>() {
            @Override
            public void onError(Request request, Exception e) {
                mView.dismissProgressBar();
                mView.showMsg(e.getMessage());
                e.printStackTrace();
            }

            @Override
            public void onResponse(QbackResponse response) {
                mView.dismissProgressBar();
                if (response != null) {
                    String msg = TextUtils.isEmpty(response.msgInfo) ? "成功" : response.msgInfo;//本机问题返回是没有提示信息的，所以自己写个
                    mView.showMsg(msg);//管你成功失败，都要弹提示Toast
                    switch (response.msgCode) {
                        case 0://如果上传成功，就关闭界面。
                            ((BaseActivity) mView).finish();
                            break;
                        case 2:
                            mView.showMsg(response.msgInfo);//后台会返回“数据重复提交”
                            break;
                        default:
                            break;
                    }
                }
            }
        });
    }

    /**
     * 根据类型来上传填写的数据
     */
    public void uploadJson(BaseEntity entity, List<String> qiniuUrl, QTYPE type) {
        StringBuffer url = new StringBuffer(NetParam.YINXIAOBU_SERVER);
        StringBuffer tail = new StringBuffer("");//临时加的字段啊啊啊啊啊。。。临时加啊临时加。。
        MediaType mediaType = OkHttpDominator.JSON;//默认用JSON类型（后来的新接口都是用的JSON类型。老接口还是表单类型）
        switch (type) {
            case PRODUCT://质量问题
                url.append(ApiUrls.APPSALER.OA_FB_WORKFLOW);
                break;
            case ARRIVE_ERROR://到货误差
                url.append(ApiUrls.APPSALER.AOG_ERR_WORKFLOW);
                mediaType = null;//禁用以JSON类型发请求。
                break;
            case CABINET_MATERIAL://柜子/物料质量问题
                url.append(ApiUrls.APPSALER.CABINET_WORKFLOW);
                if (getData().qtype == CABINET) {
                    tail.append("&type=0");// "0"是柜子问题，"2"是物料问题
                } else if (getData().qtype == MATERIAL) {
                    tail.append("&type=2");
                }
                break;
            case OVERDUE://临/过期货报损申请
                url.append(ApiUrls.APPSALER.OVERDUE_WORKFLOW);
                break;
            case CPLN_WORKFLOW://我要走流程投诉
                url.append(ApiUrls.APPSALER.COMPLAINT_WORKFLOW);
                break;
            case MACHINE://本机问题
                url.append(URL_MACHINE_QBACK);
                break;
            case SHOPPE://专柜图片上传。
                url.append(URL_MACHINE_QBACK);
                break;
            case SUGGESTION://意见与建议
                url.append(ApiUrls.APPSALER.SUGGESTION_WORKFLOW);//还没写好，等陈正写好了再改。
                break;
            default:
                break;
        }
        url.append("?orderId=" + getData().getOrderId() + "&staffid=" + SystemHelper.LoginUserId + "&shopId=" + SystemHelper.LoginOrganId + tail.toString());
        entity.addAll2List(qiniuUrl);

        String json = new Gson().toJson(entity);
        HashMap<String, String> params = new HashMap<>();
        params.put("json", json);//用application/json类型的，KEY为什么值都无所谓，但到货误差必须要用"json"为KEY
        mView.showProgressBar("正在上传上报信息", "请稍等......", false);
        OkHttpDominator.postAsynByType(url.toString(), mediaType, params, new OkHttpDominator.ResultCallback<QbackResponse>() {
            @Override
            public void onError(Request request, Exception e) {
                mView.dismissProgressBar();
                mView.showMsg(e.getMessage());
                e.printStackTrace();
            }

            @Override
            public void onResponse(QbackResponse response) {
                mView.dismissProgressBar();
                if (response != null) {
                    String msg = TextUtils.isEmpty(response.msgInfo) ? "成功" : response.msgInfo;//本机问题返回是没有提示信息的，所以自己写个
                    mView.showMsg(msg);//管你成功失败，都要弹提示Toast
                    switch (response.msgCode) {
                        case 0://如果上传成功，就关闭界面。
                            ((BaseActivity) mView).finish();
                            break;
                        case 2:
                            mView.showMsg(response.msgInfo);//后台会返回“数据重复提交”
                            break;
                        default:
                            break;
                    }
                }
            }
        });

    }

}
