package com.urovo.activity.qualityBackAct.presenter;

import android.content.Context;
import android.content.Intent;

import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.urovo.activity.qualityBackAct.model.MenuItem;
import com.urovo.activity.qualityBackAct.model.QBackMenu;
import com.urovo.activity.qualityBackAct.model.QTYPE;
import com.urovo.activity.qualityBackAct.view.ProductQBackListAct;
import com.urovo.activity.qualityBackAct.view.QBackInputAct;
import com.urovo.activity.report.TelLogisticsActivity;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;

/**
 * Created by Sasuke on 2016/11/28.
 */

public class QBackPresenter implements QBackContract.presenter{
    QBackContract.view mView;
    QBackMenu data;
    Context context;
    public QBackPresenter(QBackContract.view mView) {
        this.mView = mView;
        this.context = (Context)mView;
        this.mView.setPresenter(this);
        data = new QBackMenu();
    }

    public QBackMenu getData() {
        if(data == null){
            data = new QBackMenu();
        }
        return data;
    }

    @Override
    public void start() {
        mView.initUI();
    }

    /**根据点击的列表项的位置，来分别跳转到不同的Activity*/
    public void jumpToActivity(int groupPos,int childPos){
        MenuItem item = getData().getMainMenu()[groupPos];
        QTYPE qtype = item.childrenArray == null?item.qtype : item.childrenArray[childPos];

        switch(qtype){
            case PRODUCT://产品质量问题子列表
                context.startActivity(new Intent(context,ProductQBackListAct.class));
                break;
            case URGENT_EVENT://紧急突发事件处理
                BaseCookiesWebFra.launch(context, NetParam.PROBLEM_CALL,"产品质量问题",false);
                break;
            case ARRIVE_ERROR://到货误差问题
                jumpToInputAct(QTYPE.ARRIVE_ERROR);
                break;
            case CABINET://柜子质量问题
                jumpToInputAct(QTYPE.CABINET);
                break;
            case OVERDUE://临/过期货报损申请
                jumpToInputAct(QTYPE.OVERDUE);
                break;
            case MATERIAL://物料质量问题
                jumpToInputAct(QTYPE.MATERIAL);
                break;
            case LOGISTICS://物流紧急问题
                context.startActivity(new Intent(context,TelLogisticsActivity.class)); //直接跳转到物流人员列表；
                break;
            case SHOPPE://专柜陈列图片上传
                jumpToInputAct(QTYPE.SHOPPE);
                break;
            case CPLN_WORKFLOW://我要走流程投诉
                jumpToInputAct(QTYPE.CPLN_WORKFLOW);
                break;
            case CPLN_PHONE://我要打电话投诉
                BaseCookiesWebFra.launch(context, NetParam.TELEPHONE_COMPLAINT,"我要找督察",false);
                break;
            case CPLN_WECHAT://我要发微信投诉
                BaseCookiesWebFra.launch(context, NetParam.WEBCHAT_COMPLAINT,"我要找督察",false);
                break;
            case MACHINE://本机问题
                jumpToInputAct(QTYPE.MACHINE);
                break;
            case URGENT_ISSUE://紧急问题处理
                BaseCookiesWebFra.launch(context, NetParam.EMERGENCY_CALL,"本机问题",false);
                break;
            case SUGGESTION://意见与建议
                jumpToInputAct(QTYPE.SUGGESTION);
                break;
        }
    }

    /**直接跳转到填表界面 */
    private void jumpToInputAct(QTYPE qtype){
        Intent intent = new Intent(context,QBackInputAct.class);
        intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);//跳转的界面返回时是需要moveToBackground。
        intent.putExtra(AppConstants.PreKeys.QBACK_TYPE,qtype);//传的是一个枚举类型。
        context.startActivity(intent);
        ((BaseActivity)context).overridePendingTransition(R.anim.right_in,R.anim.left_out);
    }
}
