package com.urovo.activity.qualityBackAct.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.urovo.activity.qualityBackAct.model.DispatchDetail;
import com.urovo.activity.qualityBackAct.model.DispatchDetailCollect;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.view.MarqueeTextView;

import java.util.List;

/**
 * Created by xiep on 2020/6/3.
 */

public class OrderGoodsChooseMonthAdapter extends BaseExpandableListAdapter {

    private OnItemViewListener listener;
    private List<DispatchDetailCollect> dispatchDetailCollect;
    private Context context;

    public interface OnItemViewListener {
        void onViewListener(DispatchDetail mDispatchDetail);
    }

    public OrderGoodsChooseMonthAdapter(Context context, List<DispatchDetailCollect> dispatchDetailCollect, OnItemViewListener listener) {
        this.dispatchDetailCollect = dispatchDetailCollect;
        this.context = context;
        this.listener = listener;
    }

    @Override
    public int getGroupCount() {
        return dispatchDetailCollect.isEmpty() ? 0 : dispatchDetailCollect.size();
    }

    @Override
    public int getChildrenCount(int i) {
        return dispatchDetailCollect.get(i).getDispatchDetailList().isEmpty() ? 0 : dispatchDetailCollect.get(i).getDispatchDetailList().size();
    }

    @Override
    public Object getGroup(int i) {
        return null;
    }

    @Override
    public Object getChild(int i, int i1) {
        return null;
    }

    @Override
    public long getGroupId(int i) {
        return i;
    }

    @Override
    public long getChildId(int i, int i1) {
        return i1;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int i, boolean isExpanded, View view, ViewGroup viewGroup) {
        GroupHolder holder;
        if (view == null) {
            holder = new GroupHolder();
            view = LayoutInflater.from(context).inflate(R.layout.ll_month_exlist_group, null);
            holder.month_group_date = (TextView) view.findViewById(R.id.month_group_date);
            holder.month_group_person = (TextView) view.findViewById(R.id.month_group_person);
            holder.month_group_amount = (TextView) view.findViewById(R.id.month_group_amount);
            holder.month_group_number = (TextView) view.findViewById(R.id.month_group_number);
            holder.arrow = (ImageView) view.findViewById(R.id.list_group_arrow);
            view.setTag(holder);
        } else {
            holder = (GroupHolder) view.getTag();
        }
        //正文显示。
        holder.month_group_date.setText(context.getString(R.string.problem_escalation_delivery_date,
                dispatchDetailCollect.get(i).getDispatchDate()));
        holder.month_group_person.setText(context.getString(R.string.problem_escalation_delivery_bill,
                dispatchDetailCollect.get(i).getWaveNo()));
        holder.month_group_amount.setText(context.getString(R.string.problem_escalation_total_amount,
                dispatchDetailCollect.get(i).getAllProSumAmount()));
        holder.month_group_number.setText(context.getString(R.string.problem_escalation_total_number,
                dispatchDetailCollect.get(i).getAllProSumQty()));

        //箭头显示。
        if (getChildrenCount(i) > 0) {
            holder.arrow.setVisibility(View.VISIBLE);
            if (isExpanded) {
                holder.arrow.setImageResource(R.drawable.list_group_open);
            } else {
                holder.arrow.setImageResource(R.drawable.list_group_close);
            }
        } else {
            holder.arrow.setVisibility(View.INVISIBLE);
        }
        return view;
    }

    @Override
    public View getChildView(int i, int i1, boolean isLastChild, View view, ViewGroup viewGroup) {
        ChildHolder holder;
        if (view == null) {
            holder = new ChildHolder();
            view = LayoutInflater.from(context).inflate(R.layout.ll_month_exlist_child, null);
            holder.month_product_name = (MarqueeTextView) view.findViewById(R.id.month_product_name);
            holder.month_product_code = (TextView) view.findViewById(R.id.month_product_code);
            holder.month_product_bill = (TextView) view.findViewById(R.id.month_product_bill);
            holder.month_product_price = (TextView) view.findViewById(R.id.month_product_price);
            holder.month_product_num = (TextView) view.findViewById(R.id.month_product_num);
            holder.month_product_amount = (TextView) view.findViewById(R.id.month_product_amount);
            view.setTag(holder);
        } else {
            holder = (ChildHolder) view.getTag();
        }
        view.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onViewListener(dispatchDetailCollect.get(i).getDispatchDetailList().get(i1));
            }
        });
        holder.month_product_name.setText(dispatchDetailCollect.get(i).getDispatchDetailList().get(i1).getProName());
        holder.month_product_code.setText(dispatchDetailCollect.get(i).getDispatchDetailList().get(i1).getProCode());
        holder.month_product_bill.setText("单号：" + dispatchDetailCollect.get(i).getDispatchDetailList().get(i1).getDispatchBill());
        holder.month_product_price.setText("售价：" + dispatchDetailCollect.get(i).getDispatchDetailList().get(i1).getProPrice());
        holder.month_product_num.setText("数量：" + dispatchDetailCollect.get(i).getDispatchDetailList().get(i1).getProQty());
        holder.month_product_amount.setText("总价：" + dispatchDetailCollect.get(i).getDispatchDetailList().get(i1).getProSumAmount());
        return view;
    }

    @Override
    public boolean isChildSelectable(int i, int i1) {
        return true;
    }

    class GroupHolder {
        TextView month_group_date;
        TextView month_group_person;
        TextView month_group_amount;
        TextView month_group_number;
        ImageView arrow;//折叠箭头。
    }

    class ChildHolder {
        MarqueeTextView month_product_name;
        TextView month_product_code;
        TextView month_product_bill;
        TextView month_product_price;
        TextView month_product_num;
        TextView month_product_amount;
    }
}
