package com.urovo.activity.qualityBackAct.ui;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;

import com.urovo.activity.qualityBackAct.view.QualityBackActivity;
import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.BaseAppManager;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.ref.SoftReference;
import java.util.HashMap;
import java.util.List;

/**
 * Created by Sasuke on 2016/11/28.
 */

public class ReportPicAdapter extends BaseAdapter {
    private List<String> list;
    private QualityBackActivity context;
    public HashMap<String, SoftReference<Bitmap>> imageCache = new HashMap<String, SoftReference<Bitmap>>();

    public ReportPicAdapter(List<String> list, QualityBackActivity context) {
        this.list = list;
        this.context = context;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size() + 1;
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public int getItemViewType(int position) {

        if(position < list.size()) {
            return 0;
        }
        else {
            return 1;
        }
    }

    @Override
    public int getViewTypeCount() {

        return 2;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder viewHolder;
        int itemViewType = getItemViewType(position);
        if(convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.report_picture_listview_item, null);
            viewHolder = new ViewHolder();
            viewHolder.imageView = (ImageView) convertView.findViewById(R.id.report_pic_item);
            convertView.setTag(viewHolder);
        }
        else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        if(itemViewType == 0) {
            Bitmap bitmap;
            if(imageCache.get(list.get(position)) == null || imageCache.get(list.get(position)).get() == null) {
                bitmap = revitionImageSize(Files.photoPath + list.get(position));
                imageCache.put(list.get(position), new SoftReference<Bitmap>(bitmap));
            }
            else {
                bitmap = imageCache.get(list.get(position)).get();
            }
            viewHolder.imageView.setImageBitmap(bitmap);
        }
        else {
            viewHolder.imageView.setImageResource(R.drawable.add_picture);
        }
        return convertView;
    }

    class ViewHolder {
        ImageView imageView;
    }

    public static Bitmap revitionImageSize(String path) {
        Bitmap bitmap = null;
        try {
            BufferedInputStream in = new BufferedInputStream(new FileInputStream(new File(path)));
            BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeStream(in, null, options);
            in.close();
            int i = 0;
            bitmap = null;
            while (true) {
                if((options.outWidth >> i <= 1000) && (options.outHeight >> i <= 1000)) {
                    in = new BufferedInputStream(new FileInputStream(new File(path)));
                    options.inSampleSize = (int) Math.pow(2.0D, i);
                    options.inJustDecodeBounds = false;
                    bitmap = BitmapFactory.decodeStream(in, null, options);
                    break;
                }
                i += 1;
            }
            in.close();
        }
        catch (FileNotFoundException e) {
            e.printStackTrace();
            BaseAppManager.loger().info("FileNotFoundException from ReportPicAdapter.java:132");
        }
        catch (IOException e) {
            e.printStackTrace();
            BaseAppManager.loger().info("IOException from ReportPicAdapter.java:136");
        }
        return bitmap;
    }
}
