package com.urovo.activity.qualityBackAct.view;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.urovo.activity.qualityBackAct.model.QTYPE;
import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.net.CabinetEntity;
import com.urovo.activity.qualityBackAct.presenter.QBackContract;
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * Created by Sasuke on 2017/2/4.
 * 柜子质量问题
 */

public class CabinetFra extends Fragment implements QBackContract.view{
    QBackInputPresenter presenter;
    @BindView(R.id.cabinet_name) EditText cabinetName;//柜子名称
    @BindView(R.id.report_count) EditText reportCount;//破损数量
    @BindView(R.id.telephone) EditText telephone;//联系电话
    @BindView(R.id.report_edit) EditText reportEdit;//描述
    @BindView(R.id.shouhuo_person_show) EditText shouhuoPerson;//提交人
    @BindView(R.id.name_table) TextView nameTable;//表格文字

    final AndroidNextInputs inputs = new AndroidNextInputs();//校验框架

    @Override
    public void initUI() {
        shouhuoPerson.setText(SystemHelper.LoginUserName);
        telephone.setText(SystemHelper.LoginUserMobile);

        inputs.add(cabinetName, StaticScheme.Required());
        inputs.add(reportCount, StaticScheme.Required());
        inputs.add(shouhuoPerson, StaticScheme.Required());
        inputs.add(telephone, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(reportEdit, StaticScheme.Required());

        if (presenter.getData().qtype == QTYPE.MATERIAL){
            nameTable.setText("物料名称");
        }else if(presenter.getData().qtype == QTYPE.CABINET){
            nameTable.setText("柜子名称");
        }
    }

    @Override
    public void showMsg(String msg) {
        MyToast.show(msg);
    }
    Unbinder unbinder;

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (LinearLayout)inflater.inflate(R.layout.ll_layout_qback_cabinet,null,false);
        unbinder = ButterKnife.bind(this,container);
        initUI();
        return container;
    }

    @Override
    public void setPresenter(QBackContract.presenter presenter) {
        this.presenter = (QBackInputPresenter)presenter;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

    @Override
    public BaseEntity packData() {
        if(inputs.test()){
            // 校验通过，开始“读取数据”并“组建请求报文的Json”
            CabinetEntity json = new CabinetEntity();
//            json.setOrderId(presenter.getData().getOrderId());
            json.setCabinetName(cabinetName.getText().toString());
            json.setCount(reportCount.getText().toString());
            json.setSubmiter(shouhuoPerson.getText().toString());
            json.setMobile(telephone.getText().toString());
            json.setDescription(reportEdit.getText().toString());
            json.setShopName(SystemHelper.LoginOrganName);
            json.setTitle(presenter.getData().getParentType().showName);

            return json;
        }else{
            MyToast.show(getActivity(),"填写有误，请检查", Toast.LENGTH_SHORT);
            return null;
        }
    }

    @Override
    public void showProgressBar(String title, String msg, boolean cancelable) {

    }

    @Override
    public void dismissProgressBar() {
        ViewUtil.dismissProgress();
    }
}
