package com.urovo.activity.qualityBackAct.view;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.urovo.activity.qualityBackAct.model.QTYPE;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.view.DividerItemDecoration;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * @author Sasuke on 2019-5-24 0024.
 */
public class ComplainEntryAct extends BaseActivity {
    @BindView(R.id.orderGoodsEntryRv)
    RecyclerView orderGoodsEntryRv;

    Unbinder unbinder;

    List<String> names = new ArrayList<String>(Arrays.asList(
            "我要走流程投诉",
            "我要打电话投诉",
            "我要发微信投诉"));

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.complain_entry_act);
        unbinder = ButterKnife.bind(this);
        initTitle();
        titleTextView.setText("我要找督察");
        init();
    }

    public void init() {
        orderGoodsEntryRv.setLayoutManager(new LinearLayoutManager(this));
        orderGoodsEntryRv.addItemDecoration(new DividerItemDecoration(this, DividerItemDecoration.HORIZONTAL_LIST, 1, Color.parseColor("#E3E7EE")));
        orderGoodsEntryRv.setAdapter(new ComplainEntryAdapter(this, names));
    }

    class ComplainEntryAdapter extends RecyclerView.Adapter<OrderGoodsMenuHolder> {
        Context context;
        List<String> items;

        public ComplainEntryAdapter(Context context, List<String> items) {
            this.context = context;
            this.items = items;
        }

        @Override
        public OrderGoodsMenuHolder onCreateViewHolder(ViewGroup parent, int viewType) {
            return new OrderGoodsMenuHolder(LayoutInflater.from(context).inflate(R.layout.second_menu_item, parent, false));
        }

        @Override
        public void onBindViewHolder(OrderGoodsMenuHolder holder, final int position) {
            holder.itemName.setText(items.get(position));
            holder.dividerView.setVisibility(View.GONE);
            holder.root.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    switch (items.get(position)) {
                        case "我要走流程投诉":
                            Intent intent = new Intent(ComplainEntryAct.this,QBackInputAct.class);
                            intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
//                           intent.setFlags(Intent.FLAG_ACTIVITY_REORDER_TO_FRONT);
                            intent.putExtra(AppConstants.PreKeys.QBACK_TYPE, QTYPE.CPLN_WORKFLOW);
                            startActivity(intent);
                            break;
                        case "我要打电话投诉":
                            BaseCookiesWebFra.launch(context, NetParam.TELEPHONE_COMPLAINT,"我要找督察",false);
                            break;
                        case "我要发微信投诉":
                            BaseCookiesWebFra.launch(context, NetParam.WEBCHAT_COMPLAINT,"我要找督察",false);
                            break;
                    }
                }
            });
        }

        @Override
        public int getItemCount() {
            return items.size();
        }
    }

    class OrderGoodsMenuHolder extends RecyclerView.ViewHolder {
        TextView itemName;
        LinearLayout root;
        View dividerView;

        public OrderGoodsMenuHolder(View view) {
            super(view);
            root = view.findViewById(R.id.root);
            itemName = view.findViewById(R.id.ItemText);
            dividerView = view.findViewById(R.id.dividerView);
        }
    }


    @Override
    protected void onDestroy() {
        unbinder.unbind();
        super.onDestroy();
    }
}
