package com.urovo.activity.qualityBackAct.view;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.net.MachineEntity;
import com.urovo.activity.qualityBackAct.presenter.QBackContract;
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * Created by Sasuke on 2017/2/4.
 * 本机问题
 */

public class MachineFra extends Fragment implements QBackContract.view{
    QBackInputPresenter presenter;
    @BindView(R.id.report_edit) EditText reportEdit;

    final AndroidNextInputs inputs = new AndroidNextInputs();//校验框架

    @Override
    public void initUI() {
        inputs.add(reportEdit, StaticScheme.Required());
    }

    @Override
    public void showMsg(String msg) {
        MyToast.show(msg);
    }
    Unbinder unbinder;
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (LinearLayout)inflater.inflate(R.layout.ll_layout_qback_machine,null,false);
        unbinder = ButterKnife.bind(this,container);
        initUI();
        return container;
    }

    @Override
    public void setPresenter(QBackContract.presenter presenter) {
        this.presenter = (QBackInputPresenter)presenter;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

    @Override
    public BaseEntity packData() {
        if(inputs.test()){
            // 校验通过，开始“读取数据”并“组建请求报文的Json”
            MachineEntity json = new MachineEntity();
//            json.setOrderId(presenter.getData().getOrderId());//本机问题可以不用传单号，因为不走OA流程，本机问题反馈是给自己看的。
            json.setCode1(SystemHelper.LoginOrganId);
            json.setContent(reportEdit.getText().toString());
            json.setManagerUserId(SystemHelper.LoginUserId);
            json.setProblemType(presenter.getData().qtype.subType);//6
            json.setShopId(SystemHelper.LoginOrganId);
            return json;
        }else{
            MyToast.show(getActivity(),"填写有误，请检查", Toast.LENGTH_SHORT);
            return null;
        }
    }

    @Override
    public void showProgressBar(String title, String msg, boolean cancelable) {

    }

    @Override
    public void dismissProgressBar() {
        ViewUtil.dismissProgress();
    }
}
