package com.urovo.activity.qualityBackAct.view;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.urovo.activity.qualityBackAct.net.BaseEntity;
import com.urovo.activity.qualityBackAct.net.ShoppeEntity;
import com.urovo.activity.qualityBackAct.presenter.QBackContract;
import com.urovo.activity.qualityBackAct.presenter.QBackInputPresenter;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

import static com.urovo.wugumofang.R.id.zhuangui_leixing;

/**
 * Created by Sasuke on 2017/2/4.
 * 专柜陈列图片上传
 */

public class ShoppeFra extends Fragment implements QBackContract.view,View.OnClickListener{
    QBackInputPresenter presenter;
    @BindView(zhuangui_leixing) TextView zhuanguiLeixing;//专柜类型
    @BindView(R.id.kaiye_time) TextView kaiyeTime;//开业时间
    @BindView(R.id.huangui_time) TextView huanguiTime;//换柜时日期
    @BindView(R.id.weizhi_time) TextView weizhiTime;//换位置日期
    @BindView(R.id.report_edit) TextView reportEdit;//描述

    final AndroidNextInputs inputs = new AndroidNextInputs();//校验框架

    @Override
    public void initUI() {
        inputs.add(zhuanguiLeixing, StaticScheme.Required());
        inputs.add(kaiyeTime, StaticScheme.Required());
        inputs.add(huanguiTime, StaticScheme.Required());
        inputs.add(weizhiTime, StaticScheme.Required());
        inputs.add(reportEdit, StaticScheme.Required());
    }

    @Override
    public void showMsg(String msg) {
        MyToast.show(msg);
    }
    Unbinder unbinder;
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container  = (LinearLayout)inflater.inflate(R.layout.ll_qback_zhuangui_show,null,false);
        unbinder = ButterKnife.bind(this,container);
        initUI();
        return container;
    }

    @Override
    public void setPresenter(QBackContract.presenter presenter) {
        this.presenter = (QBackInputPresenter)presenter;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }


    @OnClick({R.id.zhuangui_leixing,R.id.kaiye_time,R.id.huangui_time,R.id.weizhi_time})
    public void onClick(View v) {
        switch (v.getId()){
            case zhuangui_leixing:
                selectLeiXing(v);
                break;
            case R.id.kaiye_time:
                DateUtil.pickDialog(getActivity(),kaiyeTime,"yyyy-MM-dd");
                break;
            case R.id.huangui_time:
                DateUtil.pickDialog(getActivity(),huanguiTime,"yyyy-MM-dd");
                break;
            case R.id.weizhi_time:
                DateUtil.pickDialog(getActivity(),weizhiTime,"yyyy-MM-dd");
                break;
        }
    }

    @Override
    public BaseEntity packData() {
        if(inputs.test()){
            // 校验通过，开始“读取数据”并“组建请求报文的Json”
            ShoppeEntity json = new ShoppeEntity();
//            json.setOrderId(presenter.getData().getOrderId());
            json.setProblemType(presenter.getData().qtype.subType);//21
            json.setShopId(SystemHelper.LoginOrganId);
            json.setManagerUserId(SystemHelper.LoginUserId);
            json.setContent(reportEdit.getText().toString());
            json.setCode1(SystemHelper.LoginOrganId);
            json.setHuanGuiDateStr(huanguiTime.getText().toString());
            json.setHuanWeiZhiDateStr(weizhiTime.getText().toString());
            json.setKaiYeDateStr(kaiyeTime.getText().toString());
            json.setZhuanGuiTypeId(zhuanguiLeixing.getTag().toString());

            return json;
        }else{
            MyToast.show(getActivity(),"填写有误，请检查", Toast.LENGTH_SHORT);
            return null;
        }
    }

    @Override
    public void showProgressBar(String title, String msg, boolean cancelable) {

    }

    @Override
    public void dismissProgressBar() {
        ViewUtil.dismissProgress();
    }

    /**选择专柜类型*/
    public void selectLeiXing(final View v) {
        final CharSequence[] items = {"一代柜", "二代柜", "三代柜", "四代柜"};
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setTitle("选择专柜类型").setItems(items, new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int pos) {
                ((TextView)v).setText(items[pos]);
                v.setTag(22+pos);
            }
        });
        AlertDialog alert = builder.create();
        alert.show();
    }
}
