package com.urovo.activity.receiveGoodsTabMenu.ui;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.PeiSongBillRes;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.R;

import java.util.List;

public class ReceiveGoodsTabMenuAda extends BaseAdapter {
	private List<PeiSongBillRes.itemBill> list;
	private BaseActivity context;

	public ReceiveGoodsTabMenuAda(List<PeiSongBillRes.itemBill> list, BaseActivity context) {
		this.list = list;
		this.context = context;
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		final ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_receivegoodsmenu_item, null);
			viewHolder = new ViewHolder();
			viewHolder.bill = (TextView) convertView.findViewById(R.id.receivegoods_dnum);
			viewHolder.type = (TextView) convertView.findViewById(R.id.receivegoods_type);
			viewHolder.count = (TextView) convertView.findViewById(R.id.receivegoods_xnum);
			viewHolder.date = (TextView) convertView.findViewById(R.id.receivegoods_date);
			viewHolder.factory = (TextView) convertView.findViewById(R.id.receivegoods_factory);
			viewHolder.maker = (TextView) convertView.findViewById(R.id.receivegoods_maker);
			viewHolder.reason = convertView.findViewById(R.id.receivegoods_reason);
			viewHolder.reasonTitleTv = convertView.findViewById(R.id.receivegoods_reason_titleTv);
			viewHolder.isSubmit = (TextView) convertView.findViewById(R.id.is_submit);
			viewHolder.brandTv = (TextView) convertView.findViewById(R.id.brandTv);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		PeiSongBillRes.itemBill ent = list.get(position);
		viewHolder.bill.setText(ent.getDispatchBill());
		viewHolder.type.setText(ent.getDispatchType());
		viewHolder.count.setText(StringUtils.formatDouble(ent.getBoxUnreceivedNum(), "0.##"));
		viewHolder.date.setText(ent.getDispatchDate());
		viewHolder.factory.setText(ent.getDispatchFactory());
		viewHolder.maker.setText(ent.getDispatchPerson());
		viewHolder.brandTv.setText(ent.getBrandName());
		viewHolder.reason.setText(ent.getDispatchReason());

		//只有 主动配送、配送返仓、配送红冲 的配送单才显示配送原因
		viewHolder.reason.setVisibility(ent.isShowDispatchReason()? View.VISIBLE : View.GONE);
		viewHolder.reasonTitleTv.setVisibility(ent.isShowDispatchReason()? View.VISIBLE : View.GONE);

//		if(ent.isSubmit) {
//			viewHolder.isSubmit.setText("已提交");
//			viewHolder.isSubmit.setTextColor(context.getResources().getColor(R.color.text_color_gray));
//		}
//		else {
			viewHolder.isSubmit.setText("收货");
			viewHolder.isSubmit.setTextColor(context.getResources().getColor(R.color.title_yellow_bg));
//		}
		return convertView;
	}

	class ViewHolder {
		TextView bill;
		TextView type;//配送类型
		TextView count;
		TextView date;
		TextView factory;
		TextView maker;
		TextView isSubmit;
		TextView brandTv;
		TextView reason;//配送原因
		TextView reasonTitleTv;//配送原因左标题

	}

}
