package com.urovo.activity.receiveGoodsTabMenu.view;

import android.app.DatePickerDialog;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager.LayoutParams;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.DatePicker;
import android.widget.ExpandableListView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.TextView;

import androidx.viewpager.widget.ViewPager;

import com.urovo.activity.common.SelectDatePop;
import com.urovo.activity.common.SelectDatePop.onDateSelectedListener;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.activity.receiveGoodsTabMenu.net.PeiSongDetailRes;
import com.urovo.activity.receiveGoodsTabMenu.ui.ReceiveGoodsDetailAda;
import com.urovo.activity.receiveGoodsTabMenu.ui.ReceiveGoodsTabMenuAda;
import com.urovo.wgmf.adapter.MyPagerAdapter;
import com.urovo.wgmf.db.dao.entitys.PeiSongBillRes;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivityTap;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.ui.ViewUtil;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import okhttp3.Request;

/***
 * 配送收货 根界面（顶上带两个标签的那个界面）
 */

public class ReceiveGoodsTabMenu extends BaseActivityTap {
    private ViewPager pager;
    private View pagerItem1;
    private View pagerItem2;
    private ArrayList<View> pagerList = new ArrayList<View>();

    private LinearLayout storeSelector;
    private TextView storequire;
    private TextView storetitle;
    private String storeid;
    private RadioButton tableft;
    private RadioButton tabright;
    private RadioGroup RadioGroup;
    private RadioGroup queryFilter;
    private ListView listview;

    private TextView datefrom;
    private TextView dateto;
    private String beginTime, endTime;
    private RadioButton haveGoods;
    private View showColor;
    private PopupWindow pw;
    private TextView storequire2;
    private TextView resaulttext;
    // private ListView resaultlist;
    private ExpandableListView resaultlist2;
    private boolean hasQuery = false;
    private TextView noDataText;
    private LinearLayout noNetLayout;
    private ReceiveGoodsTabMenuAda receiveGoodsTabAda;
//    private ReceiveGoodsBQCODEAdapter receiveGoodsBQCODEAdapter;
    private int intoPosition;
    //	private BQCODEPeiSongShouHuoResponse res;
    private PeiSongBillRes response;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.normal_tap_menu);
        initTitle();
        initPager();
        init();
        initPagerChild();
        initPagerChild2();
        initData();
    }

    private void initData() {
        //===========test==========
        PeiSongBillRes res = JsonDominator.loadFromSD("PeiSongBillRes", PeiSongBillRes.class);
        if (res != null) {
            //......do_anything
            if (res == null) {
                showMsg("返回异常");
                return;
            }
            if (res.msgCode != 0) {
                showMsg(res.msgInfo);
                return;
            }
            response = res;
            loadUI(res);
            return;
        }
        //===========test==========

//		new DownloadPeiSongShouHuoNewTask(ReceiveGoodsTabMenu.this, "正在下载配送收货数据...", true).execute("");
        ViewUtil.showProgress(this, "请稍等", "正在下载配送收货数据...");
        HashMap<String, String> param = new HashMap<>();
        param.put("storeNo", SystemHelper.LoginOrganId);
        param.put("userNo", SystemHelper.LoginUserId);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_CAN_RECEIVED_DISPATCHBILL,
                param,
                new OkHttpDominator.ResultCallback<PeiSongBillRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg(e.getMessage());
                    }

                    @Override
                    public void onResponse(PeiSongBillRes res) {
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            showMsg("返回异常");
                            return;
                        }
                        if (res.msgCode != 0) {
                            showMsg(res.msgInfo);
                            return;
                        }
                        response = res;
                        loadUI(res);
                    }
                });

    }

    private void init() {
        tableft = (RadioButton) findViewById(R.id.tap_button_left);
        tabright = (RadioButton) findViewById(R.id.tap_button_right);
        tableft.setText("配送收货");
        tabright.setText("查询");
        tableft.setTextColor(getResources().getColor(R.color.title_yellow_bg));
        RadioGroup = (RadioGroup) findViewById(R.id.tap_radio);
        RadioGroup.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                switch (checkedId) {
                    case R.id.tap_button_left:
                        pager.setCurrentItem(0);
                        tableft.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        tabright.setTextColor(getResources().getColor(R.color.white));
                        break;
                    case R.id.tap_button_right:
                        pager.setCurrentItem(1);
                        tableft.setTextColor(getResources().getColor(R.color.white));
                        tabright.setTextColor(getResources().getColor(R.color.title_yellow_bg));
                        break;
                }
            }
        });
    }

    private void initPager() {

        pager = (ViewPager) findViewById(R.id.viewpager);
        pagerItem1 = LayoutInflater.from(this).inflate(R.layout.receivegoods, null);
        pagerItem2 = LayoutInflater.from(this).inflate(R.layout.normal_quire_resault2, null);
        pagerList.add(pagerItem1);
        pagerList.add(pagerItem2);
        pager.setAdapter(new MyPagerAdapter(this, pagerList));
        pager.setOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageSelected(int arg0) {

                switch (arg0) {
                    case 0:
                        tableft.setChecked(true);
                        if (pw != null && pw.isShowing()) {
                            pw.dismiss();
                        }
                        break;
                    case 1:
                        tabright.setChecked(true);
                        if (pw == null || !hasQuery) {
                            showPopWindow();
                        }
                        break;
                    default:
                        break;
                }
            }

            @Override
            public void onPageScrollStateChanged(int arg0) {

            }

            @Override
            public void onPageScrolled(int arg0, float arg1, int arg2) {

            }

        });
    }

    private void initPagerChild() {

        storequire = (TextView) pagerItem1.findViewById(R.id.ordergoods_quire);
        storequire.setText("查询门店:" + SystemHelper.LoginOrganName);
        storeid = SystemHelper.LoginOrganId;
        listview = (ListView) pagerItem1.findViewById(R.id.listview_receivegoods);
    }

    private void initPagerChild2() {

        resaulttext = (TextView) pagerItem2.findViewById(R.id.result_tv);
        // resaultlist = (ListView)
        // pagerItem2.findViewById(R.id.listview_quire_resault);
        resaultlist2 = (ExpandableListView) pagerItem2.findViewById(R.id.listview_quire_resault2);
        noDataText = (TextView) pagerItem2.findViewById(R.id.no_data_text);
        noNetLayout = (LinearLayout) pagerItem2.findViewById(R.id.no_net_layout);
    }

    private void showPopWindow() {

        if (pw == null) {
            View v2 = getLayoutInflater().inflate(R.layout.peisong_goods_quire, null);
            queryFilter = (RadioGroup) v2.findViewById(R.id.peisong_type_filter);
            initWindow(v2);
            pw = new PopupWindow(v2, LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT, true);
            pw.setFocusable(false);
            pw.setBackgroundDrawable(new BitmapDrawable());
            pw.setOutsideTouchable(false);
            showColor.setOnClickListener(new OnClickListener() {

                @Override
                public void onClick(View v) {

                    if (!hasQuery) {
                        return;
                    }
                    if (pw != null && pw.isShowing()) {
                        pw.dismiss();
                    }
                }
            });
        } else if (hasQuery) {
            showColor.setBackgroundColor(ReceiveGoodsTabMenu.this.getResources().getColor(R.color.result_view));
        }
        pw.showAsDropDown(back);
    }

    private void initWindow(View v) {
        storequire2 = (TextView) v.findViewById(R.id.ordergoods_quire);
        storequire2.setText("查询门店:" + SystemHelper.LoginOrganName);
        datefrom = (TextView) v.findViewById(R.id.date_from);
        dateto = (TextView) v.findViewById(R.id.date_to);
        String date = DateUtil.getDate(new Date());
        beginTime = date;
        endTime = date;
        datefrom.setText(beginTime);
        dateto.setText(endTime);
        haveGoods = (RadioButton) v.findViewById(R.id.have_goods);
        haveGoods.setChecked(true);
        showColor = v.findViewById(R.id.out_view);

    }

    public void receiveQuire(View view) {
        query();
    }

    private void query() {
        final String filter;
        int id = queryFilter.getCheckedRadioButtonId();
        switch (id) {
            case R.id.have_goods://已收货
                filter = "2";
                break;
            case R.id.no_have_goods://未收货
                filter = "0";
                break;
//			case R.id.wait_check://待审核
//				filter = "1";
//				break;
            default:
                filter = "2";//以前版本就是默认查已收货
        }

        //===========test==========
        PeiSongDetailRes res = JsonDominator.loadFromSD("PeiSongDetailRes", PeiSongDetailRes.class);
        if (res != null) {
            initQueryValue(res, filter);
            //......do_anything
            return;
        }
        //===========test==========
        HashMap<String, String> param = new HashMap<>();
        param.put("storeNo", SystemHelper.LoginOrganId);
        param.put("beginDate", beginTime);
        param.put("endDate", endTime);
        ViewUtil.showProgress(this, "请稍等", "正在查询配送收货数据...");
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.QUERY_DISPATCH_DETAIL, param,
                new OkHttpDominator.ResultCallback<PeiSongDetailRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg(e.getMessage());
                    }

                    @Override
                    public void onResponse(PeiSongDetailRes res) {
                        ViewUtil.dismissProgress();
                        if (res != null && res.msgCode == 0) {

                            initQueryValue(res, filter);
                        } else {
                            showMsg(res == null ? "无数据" : res.msgInfo);
                        }
                    }
                });
    }

//	@Override
//	public void displayResult(String tag, BaseResponse response) {
//
//		super.displayResult(tag, response);
//		if(DownloadPeiSongShouHuoNewTask.TAG.equals(tag)) {
//			res = (BQCODEPeiSongShouHuoResponse) response;
//			if(res != null) {
//				loadUI(res);
//			}
//		}
////		else
////			if(QueryPeiSongTask.TAG.equals(tag)) {
////				initQueryValue(response);
////			}
//	}

    private void initQueryValue(PeiSongDetailRes res, String filter) {
        List<PeiSongDetailRes.ResultInfoBean> resultList = res.getResultInfo();
        hasQuery = true;
        if (pw != null && pw.isShowing()) {
            pw.dismiss();
        }
        //根据查询类型来过滤列表
        if (resultList != null && resultList.size() > 0) {
            Iterator<PeiSongDetailRes.ResultInfoBean> it = resultList.iterator();
            while (it.hasNext()) {
                if (!it.next().getDispatchStatus().equals(filter)) {
                    it.remove();
                }
            }
        }
        resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
        if (resultList == null || resultList.size() == 0) {
            showDataType(1);
            showMsg("无配送收货数据");
        } else {
            showDataType(0);
        }
        ReceiveGoodsDetailAda adapter = new ReceiveGoodsDetailAda(resultList, ReceiveGoodsTabMenu.this);
        resaultlist2.setAdapter(adapter);
//		List<PeiSongShouHuoEntity> list = res.getList();
//		List<QueryEntity> arrayList = new ArrayList<QueryEntity>();
//		if(list != null && list.size() > 0) {
//			for (PeiSongShouHuoEntity ent : list) {
//				List<ProductEntity> productDetails = ent.getProductDetails();
//				for (ProductEntity p : productDetails) {
//					if(!DalCommon.CanEditAmount(p.getItemId())) {
//						p.setAmount(Arith.mul(p.getPrice(), p.getTQTY()));
//					}
//					else {
//						p.setAmount(p.getPrice());
//					}
//					QueryEntity c = new QueryEntity();
//					c.ItemId = p.getItemId();
//					String name = Item001DbOperate.GetProductName(p.getItemId());
//					c.ItemName = name;
//					c.KCUom = p.getKCUom();
//					c.TQTY = StringUtils.formatDouble(p.getTQTY(), "0");
//					c.Price = StringUtils.formatDouble(p.getPrice(), "0.00");
//					c.Amount = StringUtils.formatDouble(p.getAmount(), "0.00");
//					c.WDate = ent.getWDate();
//					c.Bill = ent.getPS_Bill();
//					c.Lr_Name = ent.getLr_Name();
//					arrayList.add(c);
//				}
//			}
//		}
//		toSecondView(arrayList);
    }

//	private void toSecondView(List<QueryEntity> newList) {
//		hasQuery = true;
//		if(pw != null && pw.isShowing()) {
//			pw.dismiss();
//		}
//		resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
//		if(newList == null || newList.size() == 0) {
//			showDataType(1);
//			showMsg("无配送收货数据");
//		}
//		else {
//			showDataType(0);
//		}
//		ReceiveGoodsDetailAda adapter = new ReceiveGoodsDetailAda(newList, ReceiveGoodsTabMenu.this);
//		resaultlist2.setAdapter(adapter);
//	}

    public void storeSelector(View view) {
        ToActivity.toActivity(this, StoreSelectorActivity.class);
    }

    public void reQuire(View view) {
        showPopWindow();
    }

    private void loadUI(PeiSongBillRes res) {
        final List<PeiSongBillRes.itemBill> billList = res.getResultInfo();
        if (billList == null || billList.size() == 0) {
            showMsg("无配送收货数据");
            return;
        }

        receiveGoodsTabAda = new ReceiveGoodsTabMenuAda(billList, this);
        listview.setAdapter(receiveGoodsTabAda);
//		if(!"Y".equals(res.getYN_WLXSH())) {
//			if(res.getList() != null && res.getList().size() > 0) {
//				receiveGoodsTabAda = new ReceiveGoodsTabMenuAda(res.getList(), ReceiveGoodsTabMenu.this);
//				listview.setAdapter(receiveGoodsTabAda);
//			}
//			else {
//				showMsg("无配送收货数据");
//			}
//		}
//		else {
//			if(res.getBQCODEList() != null && res.getBQCODEList().size() > 0) {
//				receiveGoodsBQCODEAdapter = new ReceiveGoodsBQCODEAdapter(res.getBQCODEList(), ReceiveGoodsTabMenu.this);
//				listview.setAdapter(receiveGoodsBQCODEAdapter);
//			}
//			else {
//				showMsg("无配送收货数据");
//			}
//		}
        listview.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int pos, long id) {
                intoPosition = pos;
                String today = DateUtil.getDate(new Date());
                if (billList.get(pos).getDispatchDate().equals(today)) {
                    showMsg("当天配送的订单不可收货");
                    return;
                }
                //被动配送不为空，需求是只有被动配送用的老的处理，其它类型都跳新的界面。
                if ( ! billList.get(pos).isPassiveListNull()) {
                    Intent intent = new Intent(ReceiveGoodsTabMenu.this, ReceiveGoodsPassiveAct.class);
                    intent.putExtra("object", (Serializable) billList.get(pos));//把被动配送列表传过去
                    ReceiveGoodsTabMenu.this.startActivityForResult(intent, 2);
                    //被动配送为空，主动配送不为空的情况
                } else if (! billList.get(pos).isInitiativeListNull()) {
                    Intent intent = new Intent(ReceiveGoodsTabMenu.this, ReceiveGoodsAtiveAct.class);
                    intent.putExtra("object", (Serializable) billList.get(pos));//把被动配送列表传过去
                    ReceiveGoodsTabMenu.this.startActivityForResult(intent, 1);
                } else {//什么？两个都为空！！！！那肯定是异常了
                    showMsg("数据异常：主动配送与被动配送列表都为空！请检查后台！");
                }
//				if(!"Y".equals(res.getYN_WLXSH())) {
//					if(res.getList().get(position).isSubmit) {
//						return;
//					}
//					Intent intent = new Intent(ReceiveGoodsTabMenu.this, ReceiveGoodsAtiveAct.class);
//					intent.putExtra("object", (Serializable) billList.get(pos).get(pos));
//					ReceiveGoodsTabMenu.this.startActivityForResult(intent, 1);
//				}
//				else {
//					if(res.getBQCODEList().get(position).isSubmit) {
//						return;
//					}
//					Intent intent2 = new Intent(ReceiveGoodsTabMenu.this, ReceiveGoodsPassiveAct.class);
//					intent2.putExtra("object", (Serializable) res.getBQCODEList().get(position));
//					ReceiveGoodsTabMenu.this.startActivityForResult(intent2, 2);
//				}
            }
        });
    }

    public void datePick(View view) {
        View contentView = LayoutInflater.from(this).inflate(R.layout.peisong_goods_quire, null);
        new SelectDatePop(this, new onDateSelectedListener() {

            @Override
            public void onDateSelect(String startDay, String endDay) {

                datefrom.setText(startDay);
                beginTime = startDay;
                dateto.setText(endDay);
                endTime = endDay;
            }
        }).showWindow(contentView);
    }

    public void orderDatePickFrom(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                datefrom.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                beginTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    public void orderDatePickTo(View view) {
        Calendar c = Calendar.getInstance();
        new DatePickerDialog(this, new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {

                dateto.setText(String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth));
                endTime = String.format("%04d-%02d-%02d", year, monthOfYear + 1, dayOfMonth);
            }
        }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show();
    }

    private void showDataType(int type) {

        switch (type) {
            case 0:
                noDataText.setVisibility(View.INVISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 1:
                noDataText.setVisibility(View.VISIBLE);
                noNetLayout.setVisibility(View.INVISIBLE);
                break;
            case 2:
                noNetLayout.setVisibility(View.VISIBLE);
                break;
            default:
                break;
        }
    }

    @Override
    public void displayNoNet(String tag) {

        super.displayNoNet(tag);
//		if(QueryPeiSongTask.TAG.equals(tag)) {
//			if(pw != null && pw.isShowing()) {
//				pw.dismiss();
//			}
//			showDataType(2);
//			hasQuery = true;
//			resaulttext.setText(SystemHelper.LoginOrganName + "," + beginTime + "至" + endTime);
//		}
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
//        if(data == null ){
//            return;
//        }
        if (ReceiveGoodsAtiveAct.RESULTCODE == resultCode || ReceiveGoodsPassiveAct.RESULTCODE == resultCode) {
            // res.getList().get(intoPosition).isSubmit = true;
            response.getResultInfo().remove(intoPosition);
            receiveGoodsTabAda.notifyDataSetChanged();
        }
//		else
//			if(ReceiveGoodsPassiveAct.RESULTCODE == resultCode) {
//				// res.getBQCODEList().get(intoPosition).isSubmit = true;
//				response.getResultInfo().remove(intoPosition);
//				receiveGoodsTabAda.notifyDataSetChanged();
//			}
    }
}
