package com.urovo.activity.receiveraddress.ui

import android.content.Context
import android.os.Handler
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.memorderact.net.ReceiversInfosRes
import com.urovo.activity.receiveraddress.view.ReceiverAddrEditAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.databinding.ReceiverAddressItemBinding
import com.wgmf.trade.ui.ada.ViewHolderX

/**
 * @author Sasuke on 2019-7-22 0022.
 */
class ReceiverAddrAdapter(val context: Context, val dataList: ArrayList<ReceiversInfosRes.ResultInfo>,val customerTel: String?, val clickCallBack: (Int) -> Unit) : RecyclerView.Adapter<ViewHolderX>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderX {
        val binding = DataBindingUtil.inflate<ReceiverAddressItemBinding>(
                LayoutInflater.from(context),
                R.layout.receiver_address_item,
                parent,
                false)
        return ViewHolderX(binding.root)
    }

    override fun getItemCount(): Int {
        return dataList.size
    }

    override fun onBindViewHolder(holder: ViewHolderX, pos: Int) {
        val binding = DataBindingUtil.getBinding<ReceiverAddressItemBinding>(holder.view)
        binding?.apply {
            isCheckMode = true//在这个信息管理页面恒为true
            checkBox.isChecked = dataList[pos].isDefault
            receiverName = dataList[pos].receiverName
            receiverPhone = dataList[pos].receiverPhone
            receiveAddress = dataList[pos].getLongAddr()
//            addressItemLayout.tag = pos

            //需要点击整行有效
            addressItemLayout.setOnClickListener {
                //先把之前的默认项改成false
                val oldChecked = dataList.indexOfFirst { it.isDefault }
                dataList[oldChecked].isDefault = false
                //再把这次点击的设为默认项。
                dataList[pos].isDefault = true
                Handler().post {
                    notifyItemChanged(oldChecked)
                    notifyItemChanged(pos)
                }
                //再回调返回上一页面。
                clickCallBack.invoke(dataList[pos].id)
            }

            editBtn.setOnClickListener {
                ReceiverAddrEditAct.launch(context,customerTel,dataList[pos])
            }

//            checkBox.setOnCheckedChangeListener { buttonView, isChecked ->
//                if (isChecked) {
//                    //先把之前的默认项改成false
//                    val oldChecked = dataList.indexOfFirst { it.isDefault }
//                    dataList[oldChecked].isDefault = false
//                    Handler().post { notifyItemChanged(oldChecked) }
//                    //再把这次点击的设为默认项。
//                    dataList[addressItemLayout.tag as Int].isDefault = true
//                }
//            }
        }

    }
}