package com.urovo.activity.receiveraddress.view

import android.app.Activity
import android.content.Intent
import android.graphics.Color
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import com.urovo.activity.memorderact.net.ReceiversInfosRes
import com.urovo.activity.receiveraddress.ui.ReceiverAddrAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.view.DividerItemDecoration
import com.wgmf.trade.GlobalApp.context
import kotlinx.android.synthetic.main.receiver_addr_act.*

/**
 * @author Sasuke on 2019-7-22 0022.
 * 收货人地址信息管理
 */
class ReceiverAddrManageAct : BaseActivity() {
    companion object {
        const val ADDR_RESULT_CODE = 150
        const val ADDR_RESULT_DATA = "ADDR_RESULT_DATA"

        @JvmStatic
        fun launchForResult(act: Activity,customerTel: String?,addrs: ArrayList<ReceiversInfosRes.ResultInfo>,requestCode: Int ){
            act.startActivityForResult(Intent(context,ReceiverAddrManageAct::class.java).apply {
                putExtra("INTENT_ADDRS",addrs)
                putExtra("customerTel",customerTel)
            },requestCode)
        }
    }

    //上个页面传来的全部收货地址列表
    val addrs by lazy {
        intent.getSerializableExtra("INTENT_ADDRS") as ArrayList<ReceiversInfosRes.ResultInfo>
    }

    //这些收货地址的所有者客户手机号
    val customerTel by lazy {
        intent.getStringExtra("customerTel")
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.receiver_addr_act)
        initTitle()
        init()
    }

    fun init() {
        titleTextView.text = "收货人信息管理"
        rv.run {
            layoutManager = LinearLayoutManager(this@ReceiverAddrManageAct)
            addItemDecoration(DividerItemDecoration(this@ReceiverAddrManageAct, DividerItemDecoration.HORIZONTAL_LIST, 1, Color.parseColor("#E3E7EE")))
            adapter = ReceiverAddrAdapter(this@ReceiverAddrManageAct, addrs, customerTel) {
                //点击后就自动返回上一页
                setResult(ADDR_RESULT_CODE, Intent().apply {
                    putExtra(ADDR_RESULT_DATA, it)
                })
                finish()
            }
        }

        addBtn.setOnClickListener {
            ReceiverAddrEditAct.launch(this@ReceiverAddrManageAct, customerTel)
        }
    }
}