package com.urovo.activity.resetpassword.view;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.urovo.activity.login.view.LoginActivity;
import com.urovo.activity.resetpassword.model.PassData;
import com.urovo.activity.resetpassword.presenter.ResetPassContract;
import com.urovo.activity.resetpassword.presenter.ResetPassPresenter;
import com.urovo.activity.resetpassword.web.CheckCodeResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.PdaMsgConfig;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

/**
 * 重置密码
 * Created by Sasuke on 2016/6/14.
 */
public class ResetPasswordAct extends BaseActivity implements ResetPassContract.View,View.OnClickListener{
    ResetPassPresenter mPresenter;
    @BindView(R.id.first_password) EditText firstPassword;
    @BindView(R.id.second_password) EditText secondPassword;
    @BindView(R.id.btn_next_step) Button commit;
    Unbinder unbinder;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_reset_password);
        unbinder = ButterKnife.bind(this);
        initTitle();
        super.titleTextView.setText("重置密码");

        mPresenter = new ResetPassPresenter(this);
        mPresenter.setData((PassData)getIntent().getSerializableExtra("passData"));//包含用户输入的工号、手机
    }

    @OnClick(R.id.btn_next_step)
    public void onClick(View v) {
        int id = v.getId();
        switch (id){
            case R.id.btn_next_step:
                mPresenter.resetPassword(firstPassword.getText().toString().trim(),secondPassword.getText().toString().trim());
                break;
        }
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if(response == null){
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
            return ;
        }
        if(tag.equals("resetPassword")){//校验验证码
            CheckCodeResponse res = (CheckCodeResponse)response;
            if(!res.msgCode.equals("0")){
                showMsg(res.msgContent);
                return;
            }
            new AlertDialog.Builder(this).setTitle("成功")
                    .setMessage("您的密码修改成功，请重新登陆。")
                    .setCancelable(false)
                    .setPositiveButton("确定",
                            new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    PdaMsgConfig.setPassWord("",ResetPasswordAct.this);//清空缓存在本地的密码，使跳到登陆界面时密码为空。
                                    Intent intent = new Intent(ResetPasswordAct.this,LoginActivity.class);
                                    intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
                                    startActivity(intent);
                                }
                            }).create().show();
        }
    }

    @Override
    public String getIntentPass() {
        return null;
    }

    @Override
    public void setUserIdInput(String userId) {

    }

    @Override
    public void showCountDown(int countDown) {

    }

    @Override
    public void changeCountBtnState(boolean clickable) {

    }

    @Override
    public void setPresenter(Object presenter) {

    }



    @Override
    protected void onDestroy() {
        super.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }
}
