package com.urovo.activity.saleDatas.model;

import com.urovo.activity.saleDatas.net.SaleDataResponse;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.salelinechart.SaleLineChartCase;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Locale;

/**
 * Created by Sasuke on 2016/8/25.
 * ...
 */
@SuppressWarnings("all")
public class SaleData {
    SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM", Locale.CHINA);
    //默认显示--
    String salaryBase = "--";//基础薪资
    String salaryCommission = "--";//提成部分
    String salaryAssess = "--";//考核项目
    String salaryTotal = "--";//合计

    String monthTask = "--";//任务
    String monthAmount = "--";//累计销量
    String shortAmount = "--";//差额
    String finishRate = "--";//完成率

    String merchCommission = "--";//会员商品提成
    String tipAmount = "--";//顾客打赏
    String flowerNum = "--";//鲜花数
    String goldenSpeedNum = "--";//金种子数
    List<SaleLineChartCase.loadItem> dataList = new ArrayList<>();//销量对比 - 今年（就是那个折线图
    List<SaleLineChartCase.loadItem> dataListLastYear= new ArrayList<>();//销量对比 - 去年

    //======================以下Getter和Setter==========================


    /**
     * 这里要把后台传来的“纯字符串”数据，转成一个String一个Float来用
     * （不要问我为什么拖这么长个类型名。。。发版猴急，好累，懒得改，谢谢）
     *
     * @param dataList
     */
    public void setDataList(SaleDataResponse.ResultInfoBean resBean) {
        dataList.clear();
        dataListLastYear.clear();
        if(resBean.getSaleCompare() != null){
            for (SaleDataResponse.ResultInfoBean.SaleCompareBean item : resBean.getSaleCompare()) {
                try {
                    String x = item.getMonth().substring(4, 6);//后台给的是201801这样的格式，而横轴只需要01这个月份就可以了。
                    float y = Float.parseFloat(item.getMoney());
                    dataList.add(new SaleLineChartCase.loadItem(x, y));
                } catch (NullPointerException e) {
                    e.printStackTrace();
                    MyToast.show("[saleCompare]当前日期格式化出错!");
                }
            }
        }


        //同比数据（其实就是去年数据）
        if (resBean.getSaleTBcompare() != null){
            for (SaleDataResponse.ResultInfoBean.SaleCompareBean item : resBean.getSaleTBcompare()) {
                try {
                    String x = item.getMonth().substring(4, 6);//后台给的是201801这样的格式，而横轴只需要01这个月份就可以了。
                    float y = Float.parseFloat(item.getMoney());
                    dataListLastYear.add(new SaleLineChartCase.loadItem(x, y));
                } catch (NullPointerException e) {
                    e.printStackTrace();
                    MyToast.show("[saleTBcompare]当前日期格式化出错!");
                }
            }
        }

    }

    public List<SaleLineChartCase.loadItem> getDataList() {
        return dataList;
    }

    public List<SaleLineChartCase.loadItem> getDataListLastYear() {
        return dataListLastYear;
    }

    /**
     * 返回格式为yyyyMM
     *
     * @return
     */
    public String getSalaryDate() {
        Calendar c = Calendar.getInstance();
        if (c.get(Calendar.DAY_OF_MONTH) < 21) {
            c.add(Calendar.MONTH, -1);//如果是21号之前，就查上个月的。
        }
        return sdf.format(c.getTime());
    }

    public String getSalaryBase() {
        return salaryBase;
    }

    public void setSalaryBase(String salaryBase) {
        this.salaryBase = salaryBase;
    }

    public String getSalaryCommission() {
        return salaryCommission;
    }

    public void setSalaryCommission(String salaryCommission) {
        this.salaryCommission = salaryCommission;
    }

    public String getSalaryAssess() {
        return salaryAssess;
    }

    public void setSalaryAssess(String salaryAssess) {
        this.salaryAssess = salaryAssess;
    }

    public String getSalaryTotal() {
        return salaryTotal;
    }

    public void setSalaryTotal(String salaryTotal) {
        this.salaryTotal = salaryTotal;
    }

    public String getMonthTask() {
        return monthTask;
    }

    public void setMonthTask(String monthTask) {
        this.monthTask = monthTask;
    }

    public String getMonthAmount() {
        if (monthAmount == null || monthAmount.equals("--")) {
            return "0.00";
        }
        return monthAmount;
    }

    public void setMonthAmount(String monthAmount) {
        this.monthAmount = monthAmount;
    }

    public String getShortAmount() {
        return shortAmount;
    }

    public void setShortAmount(String shortAmount) {
        this.shortAmount = shortAmount;
    }

    public String getFinishRate() {
        if (finishRate == null || finishRate.equals("--")) {
            return "0.00";
        }
        if (finishRate.contains("%")) {//去掉百分号
            finishRate = finishRate.replace("%", "");
        }
        if(finishRate.contains(".")){//不保留小数
            finishRate = finishRate.split("\\.")[0];
        }
        finishRate = String.format("%.2f", Float.valueOf(finishRate) / 100);//这里是为了直接转成小数形式好直接带入仪表盘里用。
        return finishRate;
    }

    public void setFinishRate(String finishRate) {
        this.finishRate = finishRate;
    }

    public String getMerchCommission() {
        return merchCommission;
    }

    public void setMerchCommission(String merchCommission) {
        this.merchCommission = merchCommission;
    }

    public String getTipAmount() {
        return tipAmount;
    }

    public void setTipAmount(String tipAmount) {
        this.tipAmount = tipAmount;
    }

    public String getFlowerNum() {
        return flowerNum;
    }

    public void setFlowerNum(String flowerNum) {
        this.flowerNum = flowerNum;
    }

    public String getGoldenSpeedNum() {
        return goldenSpeedNum;
    }

    public void setGoldenSpeedNum(String goldenSpeedNum) {
        this.goldenSpeedNum = goldenSpeedNum;
    }

    @Override
    public String toString() {
        return "SaleData{" +
                "sdf=" + sdf +
                ", salaryBase='" + salaryBase + '\'' +
                ", salaryCommission='" + salaryCommission + '\'' +
                ", salaryAssess='" + salaryAssess + '\'' +
                ", salaryTotal='" + salaryTotal + '\'' +
                ", monthTask='" + monthTask + '\'' +
                ", monthAmount='" + monthAmount + '\'' +
                ", shortAmount='" + shortAmount + '\'' +
                ", finishRate='" + finishRate + '\'' +
                ", merchCommission='" + merchCommission + '\'' +
                ", tipAmount='" + tipAmount + '\'' +
                ", flowerNum='" + flowerNum + '\'' +
                ", goldenSpeedNum='" + goldenSpeedNum + '\'' +
                '}';
    }
}
