package com.urovo.activity.saleDatas.view;

import android.animation.ValueAnimator;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.animation.LinearInterpolator;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.GridView;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;

import com.github.mikephil.charting.charts.LineChart;
import com.google.gson.Gson;
import com.urovo.activity.data.querysales.view.MonthSaleAct;
import com.urovo.activity.saleDatas.model.SaleMenuBean;
import com.urovo.activity.saleDatas.net.SalaryResponse;
import com.urovo.activity.saleDatas.net.SaleDataResponse;
import com.urovo.activity.saleDatas.presenter.SaleDataConstract;
import com.urovo.activity.saleDatas.presenter.SaleDataPresenter;
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate;
import com.urovo.wgmf.uirefresh.PullToRefreshBase;
import com.urovo.wgmf.uirefresh.PullToRefreshScrollView;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.view.NewCreditSesameView;
import com.urovo.wugumofang.view.baseWebViewAct.WebViewAct;
import com.urovo.wugumofang.view.salelinechart.SaleLineChartCase;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.wgmf.trade.GlobalApp;
import com.wgmf.trade.utils.AssetsUtil;
import com.wgmf.trade.utils.ImageLoader;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.ui.ada.helper.ViewHelper;
import com.zsy.libcore.ui.ada.quickadapter.QuickAdapter;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import de.hdodenhof.circleimageview.CircleImageView;

/**
 * Created by Sasuke on 2016/8/25.
 */
@SuppressWarnings("all")
public class SaleDataAct extends BaseActivity implements SaleDataConstract.view, View.OnClickListener {
    SaleDataPresenter mPresenter;
    public CheckBox hideBtn;//我的薪资  可见状态 切换按钮
    public Button salaryMore;//我的薪资  更多  按钮
    public Button storeSaleMore;//本月门店销量  更多  按钮
    //    public Button salesLocalBtn;//本机销售记录
//    public Button salesGoodsBtn;// 产品销售查询
//    public Button salesDetailsBtn;//销售明细查询
//    public Button salesMonthBtn;//月销量查询
//    public Button salesMonthGoodsBtn;//产品月销量查询
//    public Button salesGuestFolioBtn;//客单数查询
    //============我的薪资==========
    public TextView salaryBase;//基础薪资
    public TextView salaryCommission;//提成部分
    public TextView salaryAssess;//考核项目
    public TextView salaryTotal0;//合计(整数位)
    public TextView salaryTotal1;//合计小数数位)
    //============本月门店销量==========
    public LineChart saleLineChart;//销售曲线
    public NewCreditSesameView rateWatch;//销售完成率仪表盘
    public SaleLineChartCase chartCase;//用来给曲线做定制化配置的，相当于一个配置工具。（chartCase.loadData(List.....)）

    public TextView storeSaleAmount0;//销售总额
    public TextView storeSaleAmount1;
    private float currentSaleAmount = 0f;//用于数字动画时，记录起始数值
    //    public TextView storeSaleGoal;//任务
//    public TextView storeSaleAmount;//累计销量
//    public TextView storeSaleDiff;//差额
//    public TextView storeSaleComplete;//完成率
    //============本月门店奖赏==========
//    public TextView goodsReward;
//    public TextView customerGiveMoney;
//    public TextView flowerAmount;
//    public TextView seedAmount;
    ScrollView scrollView;

    /**
     * 本月门店销售
     */
    LinearLayout storeSaleContainer;

    /**
     * 本月预估薪资
     */
    LinearLayout salaryContainer;

    /**
     * 底栏菜单容器
     */
    LinearLayout salesMenu;

    /**
     * 菜单网格布局容器
     */
    GridView salesMenuGv;


    Timer timer;
    boolean isDone;//刷新是否完成
    @BindView(R.id.refresh_scroll_view)
    PullToRefreshScrollView refreshScroll;
    //    @BindView(R.id.empty_action_bar)
//    RelativeLayout mEmptyActionBar;
    Unbinder unbinder;
    @BindView(R.id.empty_view)
    TextView mEmptyViewTv;
    List<SaleMenuBean.ResultInfoBean> resultInfoBeans = new ArrayList<>();
    QuickAdapter quickAdapter;
    private List<SaleMenuBean.ResultInfoBean> mSaleList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_sale_data);
        unbinder = ButterKnife.bind(this);
        mPresenter = new SaleDataPresenter(this);
        mPresenter.start();
        setListeners();
        showData();//填充数据
        mPresenter.searchSalary();//查询工资
        mPresenter.searchSaleData();//查询汇总信息
        initPrivilege2VisibilityOrGone();
        loadModule();
    }

    /**
     * 权限控制各个模块是否显示,ps:目前是写死的,要通用,参考MemberAct/MoreIndexAct
     */
    private void loadModule() {
        // 本月门店销售
        setShow4Privilege(AppConstants.SalesPerformance.SALES_STORE_MONTH, storeSaleContainer);
        //本月预估薪资
        setShow4Privilege(AppConstants.SalesPerformance.SALES_FORECAST_MONTH, salaryContainer);
        //底栏菜单容器
        setShow4Privilege(AppConstants.SalesPerformance.SALES_DATA_QUERY, salesMenu);
    }

    /**
     * 没有权限就隐藏
     *
     * @param key 跟本地数据库权限名对应
     * @param v   显隐的view
     */
    private void setShow4Privilege(String key, View v) {
        SYLoger.print("setShow4Privilege-->" + key + ": " + PrivilegeDbOperate.checkUserPrivilege(key));
        if (!PrivilegeDbOperate.checkUserPrivilege(key)) {
            v.setVisibility(View.GONE);
        }
    }

    /**
     * 整个页面没有权限时显示的布局
     */
    private void initPrivilege2VisibilityOrGone() {
        if (!PrivilegeDbOperate.checkUserPrivilege(AppConstants.SalesPerformance.SALES_PERFORMANCE)) {
            refreshScroll.setVisibility(View.GONE);
            mEmptyViewTv.setText("暂无使用权限!");
        }
    }

    @Override
    protected void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        super.onDestroy();
    }

    /**
     * 图标资源
     */
    final Integer[] images = {
            R.mipmap.btn_sales_local,
            R.mipmap.btn_sales_goods,
            R.mipmap.btn_sales_details,
            R.mipmap.btn_sales_month,
            R.mipmap.btn_month_goods,
            R.mipmap.btn_guest_folio
    };

    @Override
    public void initUI() {
//        StatusBarUtils.setViewStatus(mEmptyActionBar);
//        refreshScroll = (PullToRefreshScrollView) findViewById(R.id.refresh_scroll_view);
        scrollView = refreshScroll.getRefreshableView();
        LinearLayout dataScrollLayout = (LinearLayout) LayoutInflater.from(this).inflate(R.layout.data_scroll, scrollView, false);
        scrollView.addView(dataScrollLayout);

        //本月门店销售
        storeSaleContainer = (LinearLayout) findViewById(R.id.store_sale_container);

        //本月预估薪资
        salaryContainer = (LinearLayout) findViewById(R.id.layout_salary_container);

        //显隐控制
        hideBtn = (CheckBox) findViewById(R.id.salary_hide_button);
        //工资更多
        salaryMore = (Button) findViewById(R.id.salary_more);
        salaryBase = (TextView) findViewById(R.id.salary_base);
        salaryCommission = (TextView) findViewById(R.id.salary_commision);
        salaryAssess = (TextView) findViewById(R.id.salary_assess);
        salaryTotal0 = (TextView) findViewById(R.id.salary_total_0);
        salaryTotal1 = (TextView) findViewById(R.id.salary_total_1);

        //销量更多
        storeSaleMore = (Button) findViewById(R.id.store_sale_more);
        saleLineChart = (LineChart) findViewById(R.id.saleLineChart);
        saleLineChart.setNoDataText("暂无数据");
        rateWatch = (NewCreditSesameView) findViewById(R.id.rateWatch);
        //用来做定制化配置的
        chartCase = new SaleLineChartCase(this, saleLineChart);

//        saleLineChart = (LineChart)findViewById(R.id.);
//        storeSaleGoal = (TextView) findViewById(R.id.store_sale_goal);
//        storeSaleAmount = (TextView) findViewById(R.id.store_sale_amount);
//        storeSaleDiff = (TextView) findViewById(R.id.store_sale_diff);
//        storeSaleComplete = (TextView) findViewById(R.id.store_sale_complete);
        storeSaleAmount0 = (TextView) findViewById(R.id.store_sale_amount_0);
        storeSaleAmount1 = (TextView) findViewById(R.id.store_sale_amount_1);

        //本月门店奖赏
//        goodsReward = (TextView) findViewById(R.id.goods_reward);
//        customerGiveMoney = (TextView) findViewById(R.id.customer_give_money);
//        flowerAmount = (TextView) findViewById(R.id.flower_amount);
//        seedAmount = (TextView) findViewById(R.id.seed_amount);

        //底栏菜单容器
        salesMenu = (LinearLayout) findViewById(R.id.sales_menu);
        salesMenuGv = (GridView) findViewById(R.id.sales_menu_gv);

        quickAdapter = new QuickAdapter<SaleMenuBean.ResultInfoBean>(R.layout.item_sale_menu, mSaleList) {
            @Override
            protected void onBindData(Context context, int position,
                                      ViewHelper viewHelper, int layoutId,
                                      final SaleMenuBean.ResultInfoBean resultInfoBean) {
                SYLoger.print("wgmf--sale typeId--> " + resultInfoBean.getTypeId());
                CircleImageView type_icon_iv = viewHelper.getView(R.id.type_icon_iv);
//                ImageLoader.loadImg(SaleDataAct.this, images[resultInfoBean.getTypeId()], type_icon_iv);
                ImageLoader.loadImg(SaleDataAct.this, resultInfoBean.getImageId(), type_icon_iv);

                String tempTypeName = resultInfoBean.getTypeName();
                viewHelper.setText(R.id.sale_tv, tempTypeName);

//                Icon 点击后执行跳转
                viewHelper.setOnClickListener(R.id.item_sale_menu, new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        try {
                            Intent intent = new Intent();
                            String tempLink = resultInfoBean.getAndroid().getLink();
                            if ("url".equals(resultInfoBean.getAndroid().getLinkType())) {//web网页情况
                                BaseCookiesWebFra.launch(SaleDataAct.this, new Intent(), tempLink, null, true);
                            } else {//native情况;
                                intent.setClass(SaleDataAct.this, Class.forName(tempLink));
                                startActivity(intent);
                            }
                        } catch (ClassNotFoundException e) {
                            e.printStackTrace();
                            showMsg("当前选项配置有问题");
                        }
                    }
                });
            }
        };
        salesMenuGv.setAdapter(quickAdapter);
        //加载本地数据
        loadDataFromOffline();

        //底栏六个按钮
//        salesLocalBtn = (Button) findViewById(R.id.btn_sales_local);
//        salesGoodsBtn = (Button) findViewById(R.id.btn_sales_goods);
//        salesDetailsBtn = (Button) findViewById(R.id.btn_sales_details);
//        salesMonthBtn = (Button) findViewById(R.id.btn_sales_month);
//        salesMonthGoodsBtn = (Button) findViewById(R.id.btn_sales_month_goods);
//        salesGuestFolioBtn = (Button) findViewById(R.id.btn_sales_guest_folio);
    }

    /**
     * 加载离线资源
     */
    private void loadDataFromOffline() {
        mSaleList.clear();
        String tempJson = AssetsUtil.getFromAssets(this, "sale_menu.json");
        resultInfoBeans = new Gson().fromJson(tempJson, SaleMenuBean.class).getResultInfo();
        for (int i = 0; i < resultInfoBeans.size(); i++) {
            SaleMenuBean.ResultInfoBean resultInfoBean = resultInfoBeans.get(i);
            resultInfoBean.setImageId(images[i]);
            if (PrivilegeDbOperate.checkUserPrivilege(resultInfoBean.getPrivaligeName())) {
                SYLoger.print("wgmf--业绩: " + resultInfoBean.getPrivaligeName());
                mSaleList.add(resultInfoBean);
            }
        }
        quickAdapter.replaceAll(mSaleList);
    }

    public void setListeners() {
        salaryMore.setOnClickListener(this);
        storeSaleMore.setOnClickListener(this);

//        salesLocalBtn.setOnClickListener(this);
//        salesGoodsBtn.setOnClickListener(this);
//        salesDetailsBtn.setOnClickListener(this);
//        salesMonthBtn.setOnClickListener(this);
//        salesMonthGoodsBtn.setOnClickListener(this);
//        salesGuestFolioBtn.setOnClickListener(this);
        //切换工资栏数据的显隐
        hideBtn.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    hideSalary();
                    PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.IS_SALARY_VISIBLE, false);
                } else {
                    showSalary();
                    PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.IS_SALARY_VISIBLE, true);
                }
            }
        });

        refreshScroll.setOnRefreshListener(new PullToRefreshBase.OnRefreshListener<ScrollView>() {
            @Override
            @SuppressWarnings("all")
            public void onPullDownToRefresh(PullToRefreshBase<ScrollView> refreshView) {
                isDone = false;//先设为false，成功了再改回true
                mPresenter.searchSalary();
                mPresenter.searchSaleData();
                timer = new Timer();
                timer.schedule(new TimerTask() {
                    @Override
                    public void run() {
                        if (!isDone) {
                            completeRefresh(false);
                        }
                    }
                }, GlobalApp.DEFAULT_TIME_OUT);
            }

            @Override
            public void onPullUpToRefresh(PullToRefreshBase<ScrollView> refreshView) {

            }
        });

    }

    public void completeRefresh(final boolean isSucceed) {
        if (SaleDataAct.this.isFinishing()) return;
        //没办法，Timer不肯跑
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                //停止下拉刷新
                refreshScroll.onPullDownRefreshComplete();
                //停止上拉加载
                refreshScroll.onPullUpRefreshComplete();
                if (isSucceed) {
                    String now = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINA).format(new Date());
                    //显示上次刷新时间（其实就是这次）
                    refreshScroll.setLastUpdatedLabel(now);
                } else {
                    showMsg("请求超时，请重试");
                }
                isDone = true;
            }
        });
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            //工资更多
            case R.id.salary_more:
              /*  BaseWebFra.build(SaleDataAct.this, String.format(NetParam.MONTH_SALARY_REALTIME_QUERY,
                        SystemHelper.LoginUserId,
                        SystemHelper.LoginUserName),"本月实时薪资",true);*/
                WebViewAct.launch(this, SystemHelper.LoginUserId, "本月实时薪资", String.format(NetParam.MONTH_SALARY_REALTIME_QUERY,
                        SystemHelper.LoginUserId,
                        SystemHelper.LoginUserName));
//                String page = "com.urovo.activity.login.view.LoginActivity";
//                try {
//                    Class  clazz = Class.forName(page);
//                    startActivity(new Intent(this,clazz));
//                } catch (ClassNotFoundException e) {
//                    e.printStackTrace();
//                }
                break;
            //销量更多
            case R.id.store_sale_more:
                startActivity(new Intent(this, MonthSaleAct.class));
//                Intent intent = new Intent(this,LearnSearchAct.class);
//                intent.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_TYPE,"2");
//                intent.putExtra(AppConstants.ExtraKeys.ARTICLE_SEARCH_ALREADY_STORES,new ArrayList<>());
//                intent.setFlags(Intent.FLAG_ACTIVITY_NO_ANIMATION);
//                    startActivity(intent);
                break;
//            //本机销售记录.
//            case R.id.btn_sales_local:
//                startActivity(new Intent(this, QuerySalesDetailNative.class));
//                break;
//            //产品销售查询
//            case R.id.btn_sales_goods:
//                startActivity(new Intent(this, QueryFinalProductSales.class));
//                break;
//            //销售明细查询
//            case R.id.btn_sales_details:
//                startActivity(new Intent(this, QuerySalesDetailNet.class));
//                break;
//            //月销量查询
//            case R.id.btn_sales_month:
//                startActivity(new Intent(this, MonthSaleAct.class));
//                break;
//            //产品月销量查询
//            case R.id.btn_sales_month_goods:
//                startActivity(new Intent(this, MonthSaleProductAct.class));
//                break;
//            //客单数查询
//            case R.id.btn_sales_guest_folio:
//                startActivity(new Intent(this, QueryGuestFolio.class));
//                break;
            default:
                break;
        }
    }

    @Override
    public void showData() {
        //=============我的薪资模块===============
        salaryBase.setText(mPresenter.getData().getSalaryDate());
        boolean isSalaryVisible = PreferHelper.getInstance().getBoolean(AppConstants.PreKeys.IS_SALARY_VISIBLE, true);
        if (isSalaryVisible) {
            hideBtn.setChecked(false);
            showSalary();
        } else {
            hideBtn.setChecked(true);
            hideSalary();
        }

        //=============本月门店销量===============
//        storeSaleGoal.setText(mPresenter.getData().getMonthTask());
//        storeSaleAmount.setText(mPresenter.getData().getMonthAmount());
//        storeSaleDiff.setText(mPresenter.getData().getShortAmount());
//        storeSaleComplete.setText(mPresenter.getData().getFinishRate());
        //跑数字
        ValueAnimator mNumAnim = ValueAnimator.ofFloat(currentSaleAmount, Float.valueOf(mPresenter.getData().getMonthAmount()));
        mNumAnim.setDuration(1000);
        mNumAnim.setInterpolator(new LinearInterpolator());
        mNumAnim.addUpdateListener(new ValueAnimator.AnimatorUpdateListener() {

            @Override
            public void onAnimationUpdate(ValueAnimator valueAnimator) {
                show2TwoTv(String.format(
                        Locale.CHINA, "%.2f",
                        (float) valueAnimator.getAnimatedValue()),
                        storeSaleAmount0,
                        storeSaleAmount1);
                currentSaleAmount = (float) valueAnimator.getAnimatedValue();
            }
        });
        mNumAnim.start();
        //跑表盘
        rateWatch.setRateValue(Float.valueOf(mPresenter.getData().getFinishRate()));
        //=============本月门店奖赏===============
//        goodsReward.setText(mPresenter.getData().getMerchCommission());
//        customerGiveMoney.setText(mPresenter.getData().getTipAmount());
//        flowerAmount.setText(mPresenter.getData().getFlowerNum());
//        seedAmount.setText(mPresenter.getData().getGoldenSpeedNum());
    }

    /**
     * 隐藏工资栏数据显示
     */
    public void hideSalary() {
        salaryBase.setText("****");
        salaryCommission.setText("****");
        salaryAssess.setText("****");
        salaryTotal0.setText("****");
        salaryTotal1.setText("");
    }

    /**
     * 显示工资栏数据
     */
    public void showSalary() {
        salaryBase.setText(mPresenter.getData().getSalaryBase());
        salaryCommission.setText(mPresenter.getData().getSalaryCommission());
        salaryAssess.setText(mPresenter.getData().getSalaryAssess());
//        salaryTotal.setText(mPresenter.getData().getSalaryTotal());
        show2TwoTv(mPresenter.getData().getSalaryTotal(), salaryTotal0, salaryTotal1);
    }


    /**
     * 把返回的钱数值分别显示到两个textView里面去(一个整数位，一个小数位)
     */
    @SuppressLint("SetTextI18n")
    @SuppressWarnings("all")
    public void show2TwoTv(String money, TextView tv0, TextView tv1) {
        if ("--".equals(money)) {
            tv0.setText("--");
            tv1.setText("");
            return;
        }
        //这里小数点必须用转义字符，否则会崩！
        if (money.contains(".")) {
            tv0.setText(money.split("\\.")[0]);
//            tv1.setText("." + money.split("\\.")[1]);
            tv1.setText(String.format(".%s", money.split("\\.")[1]));
        } else {
            tv0.setText(money);
            tv1.setText(".00");
        }
    }

    @Override
    @SuppressWarnings("all")
    protected void onResume() {
        timer = new Timer();
        super.onResume();
    }

    @Override
    public void onPause() {
        timer.cancel();
        super.onPause();
    }

    @Override
    public void setPresenter(SaleDataConstract.presenter presenter) {
        this.mPresenter = (SaleDataPresenter) presenter;
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        //停止刷新动画
        completeRefresh(true);
        if (null == response) {

            return;
        }
        //设定上次刷新时间
        setLastUpdateTime();
        if ("requestSale".equals(tag)) {
            SaleDataResponse res = (SaleDataResponse) response;
            //jsonDominator__test===============================
            SaleDataResponse resMock = JsonDominator.loadFromSD("SaleDataResponse", SaleDataResponse.class);
            if (resMock != null) {
                res = resMock;
            }
            //jsonDominator__test===============================
            SaleDataResponse.ResultInfoBean bean = res.getResultInfo();
            if (bean != null) {
                mPresenter.setSaleData(bean);
                showData();
            }
        }
        //算了
        else if ("requestSalary".equals(tag)) {
            SalaryResponse res = (SalaryResponse) response;
            //基础薪资
            mPresenter.getData().setSalaryBase(res.getBase());
            //提成部分
            mPresenter.getData().setSalaryCommission(res.getCommission());
            //考核项目
            mPresenter.getData().setSalaryAssess(res.getAssess());
            //合计
            mPresenter.getData().setSalaryTotal(res.getTotal());
            showData();
        }
    }

    @Override
    public void refreshLineChart() {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                chartCase.loadData(mPresenter.getData().getDataList(), mPresenter.getData().getDataListLastYear());
//                chartCase.loadData2nd(mPresenter.getData().getDataListLastYear());
            }
        });
    }

    private void setLastUpdateTime() {
        String text = DateUtil.format(new Date(), "yyyy-MM-dd HH:mm");
        refreshScroll.setLastUpdatedLabel(text);
    }
}
