package com.urovo.activity.salesmanager;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.BaseExpandableListAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.urovo.activity.common.OfficeStoreSelectorActivity;
import com.urovo.activity.common.StoreDateSelectorPop;
import com.urovo.activity.common.StoreSelectorActivity;
import com.urovo.activity.data.DataBaseActivity;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wgmf.AsyncTask.QueryMyMarkStoreTask;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.ShopEntity;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.db.dao.entitys.MyMarkStoreEntity;
import com.urovo.wgmf.db.dao.entitys.MyMarkStoreEntity.ManagerShops;
import com.urovo.wgmf.db.dao.entitys.MyMarkStoreEntity.OfficeShops;
import com.urovo.wgmf.db.dao.entitys.MyMarkStoreEntity.PkShops;
import com.urovo.wugumofang.data.DataMonthUtils;
import com.urovo.wugumofang.R;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MarkStoreActivity extends DataBaseActivity implements OnClickListener {
	private List<BaseModel> mBaseModel = new ArrayList<BaseModel>();
	private List<CommitBaseModel> mListUser = new ArrayList<CommitBaseModel>();
	private Map<String, String> params = new HashMap<String, String>();
	public static final int activityResultCode = 302;// 选择成功后返回的code
	private ArrayList<OfficeShops> officeShops;
	private ArrayList<ManagerShops> managerShops;
	private ShopEntity shopEntity; // 选择的门店信息
	private List<ShopEntity> mListStore;
	private String myShop, myShopName, myShopId;
	private TextView mystore, mystoreId, pkstoreId;

	private Boolean isfirst = true;

	@Override
	protected boolean isExpandableList() {
		return false;
	}

	@Override
	protected String getTitleText() {
		return "标杆门店管理";
	}

	@Override
	protected int getPopupWindowMode() {
		return StoreDateSelectorPop.STORE_DATE_MONTH;
	}

	@Override
	protected BaseAdapter newBaseAdapter() {
		return new MyAdapter(mBaseModel, this);
	}

	@Override
	protected BaseExpandableListAdapter newExpandableAdapter() {
		return null;
	}

	@Override
	protected void requestConnectTask() {
		new QueryMyMarkStoreTask(this, "正在查询...", true, params).execute("");
	}

	@Override
	protected void search(String id, String store, String user, String dateYearMonth, String dateFrom, String dateTo) {
		if(null == dateYearMonth)
			return;
		String mDateYearMonth = dateYearMonth + "-01";
		try {
			dateFrom = DataMonthUtils.getMinMonthDate(mDateYearMonth);
			dateTo = DataMonthUtils.getMaxMonthDate(mDateYearMonth);
		}
		catch (ParseException e1) {
			e1.printStackTrace();
		}
		mDateFrom = dateFrom;
		mDateMonth = dateYearMonth;
		params.put("yearMonth", dateYearMonth);
		params.put("code1", SystemHelper.LoginOrganId);
		params.put("empNo", SystemHelper.LoginUserId);
		requestConnectTask();
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		init();
		search(mStoreId, null, mUserID, mDateMonth, mDateFrom, mDateTo);
	}

	private void init() {
		mImageMore = (ImageView) findViewById(R.id.imageView1);
		mLinearLayoutMore = (LinearLayout) findViewById(R.id.linearLayout1);
		btnEdit.setOnClickListener(this);// 编辑按钮
		btnEditCancel.setOnClickListener(this);// 二次编辑取消按钮
		btnEditConfirm.setOnClickListener(this);// 二次编辑完成按钮
		List<ShopEntity> mListStore = Store001DbOprate.GetShopChoice();
		if(isfirst) {
			mStoreName = "全部";
		}
		else
			if(null != mListStore && mListStore.size() > 0) {
				mStoreId = mListStore.get(0).getShopId();
				mStoreName = mListStore.get(0).getShopName();
			}
		isfirst = !isfirst;
		mTextViewStore.setText(mStoreName);
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		switch (resultCode) {
		case StoreSelectorActivity.RESULTCODE:
			shopEntity = (ShopEntity) data.getSerializableExtra("store");
			break;
		case OfficeStoreSelectorActivity.RESULTCODE:
			myShopName = (String) data.getSerializableExtra("myShopNameBack");
			myShopId = (String) data.getSerializableExtra("myShopIdBack");
			myShop = (String) data.getSerializableExtra("myShop");
			shopEntity = (ShopEntity) data.getSerializableExtra("store");
			if(shopEntity != null) {
				for (int i = 0; i < managerShops.size(); i++) {
					BaseModel cell = new BaseModel();
					cell.mStore = myShopName;
					cell.mStoreId = myShopId;
					cell.mPkStore = shopEntity.getShopName();
					cell.mPkStoreId = shopEntity.getShopId();
					mBaseModel.remove(Integer.parseInt(myShop));
					mBaseModel.add(Integer.parseInt(myShop), cell);
				}
				listviewChange();
				mMyAdapter.notifyDataSetChanged();
			}
			break;
		default:
			break;
		}
	}

	@Override
	public void displayResult(String tag, BaseResponse response) {
		super.displayResult(tag, response);
		if("markStoresubmit".equals(tag) && null != response) {
			if("0".equals(response.sysCode)) {
				finish();
				showMsg("上传标杆门店成功！");
				//Toast.makeText(this, "上传标杆门店成功！", 1000).show();
			}
		}
		else
			if(!"0".equals(((BaseOldResponse)response).msgCode)) {
				return;
			}
			else
				if(null != response) {
					Date date = new Date();
					SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
					try {
						Date date1 = formatter.parse(DataMonthUtils.getMinMonthDate(formatter.format(date)));// 本月份的最小日期
						Date date2 = formatter.parse(formatter.format(date));// 今天
						Date date3 = formatter.parse(mDateFrom);// 选中的月份
						if(((DataMonthUtils.getCompareDate(date1, date2) < 1) && (DataMonthUtils.getCompareDate(date2, date3) < 0)) || (DataMonthUtils.getCompareDate(date1, date3) > 0)) {
							// 今天等于本月最小日期或者选中的日期大于本月最小日期并且今天大于选中的日期，可编辑
							mLinearLayoutEdit.setVisibility(View.VISIBLE);
							mLinearLayoutEditTwo.setVisibility(View.GONE);
						}
						else {
							mLinearLayoutEdit.setVisibility(View.GONE);
							mLinearLayoutEditTwo.setVisibility(View.GONE);
						}
					}
					catch (ParseException e) {
						Log.i("日期格式转换出错!", e+"");
					}
					// 主管管理门店解析
					MyMarkStoreEntity myStoreEntity = (MyMarkStoreEntity) response;
					managerShops = myStoreEntity.managerShops;
					mBaseModel.clear();
					if(null != managerShops && managerShops.size() > 0) {
						// PK门店数据解析
						List<PkShops> pkShops = myStoreEntity.pkShops;
						if(null != pkShops && pkShops.size() > 0) {

							for (int j = 0; j < managerShops.size(); j++) {// 对应门店已设置PK信息
								BaseModel cell = new BaseModel();
								for (int i = 0; i < pkShops.size(); i++) {
									String managerShopsId = managerShops.get(j).shop_id;
									String pkShopsId = pkShops.get(i).fa_qi_shop_id;

									if(managerShopsId.equals(pkShopsId)) {
										managerShops.get(j).shop_id = pkShops.get(i).fa_qi_shop_id;
										managerShops.get(j).shop_name = pkShops.get(i).fa_qi_shop_name;
										if(null == pkShops.get(i).pk_shop_name || "".equals(pkShops.get(i).pk_shop_name)) {
											managerShops.get(j).pkshop_name = "未设置";
											managerShops.get(j).pkshop_id = "";
										}
										else {
											managerShops.get(j).pkshop_name = pkShops.get(i).pk_shop_name;
											managerShops.get(j).pkshop_id = pkShops.get(i).pk_shop_id;
										}
									}
								}
								cell.mPkStore = managerShops.get(j).pkshop_name;
								cell.mPkStoreId = managerShops.get(j).pkshop_id;
								cell.mStore = managerShops.get(j).shop_name;
								cell.mStoreId = managerShops.get(j).shop_id;
								mBaseModel.add(cell);
							}
						}
						else {
							for (int i = 0; i < managerShops.size(); i++) {
								BaseModel cell = new BaseModel();
								cell.mStore = managerShops.get(i).shop_name;
								cell.mStoreId = managerShops.get(i).shop_id;
								cell.mPkStore = "未设置";
								cell.mPkStoreId = "";
								mBaseModel.add(cell);
							}
						}

						if((null != shopEntity) && !("全部".equals(mTextViewStore.getText().toString()))) {
							mListStore = new ArrayList<ShopEntity>();
							ShopEntity entitys = new ShopEntity();
							entitys.setShopId(shopEntity.getShopId());
							entitys.setShopName(shopEntity.getShopName());
							mListStore.add(0, entitys);

							for (int j = 0; j < mBaseModel.size(); j++) {
								for (int i = 0; i < mListStore.size(); i++) {
									ShopEntity entity = mListStore.get(i);
									BaseModel myentity = mBaseModel.get(j);
									String name1 = myentity.mStore;
									String name2 = entity.getShopName();
									if(name1.equals(name2)) {
										mBaseModel.clear();
										BaseModel cell = new BaseModel();
										cell.mStore = entity.getShopName();
										cell.mStoreId = entity.getShopId();
										cell.mPkStore = myentity.mPkStore;
										cell.mPkStoreId = myentity.mPkStoreId;
										mBaseModel.add(cell);
									}
								}
							}
						}
						// 办事处门店数据解析
						MyMarkStoreEntity myOfficeStoreEntity = (MyMarkStoreEntity) response;
						officeShops = myOfficeStoreEntity.officeShops;
					}
				}
		mMyAdapter.notifyDataSetChanged();
	}

	private class BaseModel {
		boolean isInvalid;
		String mStore;
		String mStoreId;
		String mPkStore;
		String mPkStoreId;
	}

	private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {

		public MyAdapter(List<BaseModel> lists, Context context) {
			super(lists, context);
		}

		@Override
		public View getView(final int position, View convertView, ViewGroup parent) {
			ViewHolder viewHolder;
			if(null == convertView) {
				convertView = getLayoutInflater().inflate(R.layout.listview_item_chaxun_markstore, null);
				viewHolder = new ViewHolder();
				viewHolder.mystore_name = (TextView) convertView.findViewById(R.id.textView1);
				viewHolder.pkstore_name = (Button) convertView.findViewById(R.id.markstore_btn1);
				mystore = (TextView) convertView.findViewById(R.id.textView1);
				mystoreId = (TextView) convertView.findViewById(R.id.tv_myshop_id);
				pkstoreId = (TextView) convertView.findViewById(R.id.tv_pkshop_id);
				convertView.setTag(viewHolder);
			}
			else {
				viewHolder = (ViewHolder) convertView.getTag();
			}
			final BaseModel cell = mBaseModel.get(position);
			viewHolder.mystore_name.setText(cell.mStore);
			viewHolder.pkstore_name.setText(cell.mPkStore);
			mystoreId.setText(cell.mStoreId);
			pkstoreId.setText(cell.mPkStoreId);

			if(!"未设置".equals(cell.mPkStore)) {
				cell.isInvalid = false;
				viewHolder.pkstore_name.setTextColor(getResources().getColor(R.color.black));
			}
			else {
				cell.isInvalid = true;
				viewHolder.pkstore_name.setTextColor(getResources().getColor(R.color.gray_background));
			}

			if(backFlag) {
				viewHolder.pkstore_name.setBackgroundResource(R.drawable.btn_manager_style);
			}
			else {
				viewHolder.pkstore_name.setBackgroundDrawable(null);
			}
			viewHolder.pkstore_name.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View view) {
					if(backFlag) {
						Intent intent = new Intent(MarkStoreActivity.this, OfficeStoreSelectorActivity.class);
						Bundle mBundle = new Bundle();
						mBundle.putSerializable("officeShops", (Serializable) officeShops);
						mBundle.putSerializable("managerShops", (Serializable) managerShops);
						mBundle.putSerializable("myShop", (Serializable) String.valueOf(position));
						mBundle.putString("myShopName", cell.mStore);
						mBundle.putString("myShopId", cell.mStoreId);
						intent.putExtras(mBundle);
						startActivityForResult(intent, activityResultCode);
					}
				}
			});

			return convertView;
		}
	}

	class ViewHolder {
		TextView mystore_name;
		Button pkstore_name;
	}

	/**
	 * 
	 * @Title: listviewChange
	 * @Description: 提交按钮变化
	 * @param 参数说明
	 * @return void 返回类型
	 * @throws
	 */
	public void listviewChange() {
		int invalidCount = 0;
		for (BaseModel p : mBaseModel) {
			if(p.isInvalid)
				invalidCount++;
		}
		// if (invalidCount > 0) {
		// btnEditConfirm.setEnabled(false);
		// btnEditConfirm.setText("请将信息填写完整再上传！");
		// } else {
		// if (!btnEditConfirm.isEnabled()) {
		// btnEditConfirm.setEnabled(true);
		// btnEditConfirm.setText("完成");
		// }
		// }
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.btn_edit:
			if(!backFlag) {
				setViewStatus(true, false, View.GONE, View.GONE, View.VISIBLE);
			}
			else {
				setViewStatus(false, true, View.VISIBLE, View.VISIBLE, View.GONE);
			}
			break;
		case R.id.btn_edit_cancel:
			setViewStatus(false, true, View.VISIBLE, View.VISIBLE, View.GONE);
			break;
		case R.id.btn_edit_confirm:
			setViewStatus(false, true, View.VISIBLE, View.VISIBLE, View.GONE);
			commitMarkStore();
			break;
		default:
			break;
		}
		listviewChange();
		mMyAdapter.notifyDataSetChanged();
	}

	private void setViewStatus(final boolean flag0, boolean flag1, int flag2, int flag3, int flag4) {
		backFlag = flag0;
		mLinearLayoutMore.setClickable(flag1);
		mImageMore.setVisibility(flag2);
		mLinearLayoutEdit.setVisibility(flag3);
		mLinearLayoutEditTwo.setVisibility(flag4);
	}

	private class CommitBaseModel {
		String fa_qi_shop_id;// 发起Pk的门店的编号
		String pk_shop_id;// 被作为标杆的门店的编号
		String yearMonth;// 给哪一个月份做设置
		String emp_no;// 当前设置标杆门店的这个人的工号

		@Override
		public String toString() {
			return "CommitBaseModel [fa_qi_shop_id=" + fa_qi_shop_id + ", pk_shop_id=" + pk_shop_id + ", yearMonth=" + yearMonth + ", emp_no=" + emp_no + "]";
		}
	}

	/**
	 * 
	 * @Title: commitDayTask
	 * @Description: 提交上传日目标
	 * @param 参数说明
	 * @return void 返回类型
	 * @throws
	 */
	private void commitMarkStore() {
		mListUser.clear();
		for (BaseModel cell : mBaseModel) {
			CommitBaseModel t = new CommitBaseModel();
			t.fa_qi_shop_id = TextUtils.isEmpty(cell.mStoreId) ? "" : cell.mStoreId;
			t.pk_shop_id = TextUtils.isEmpty(cell.mPkStoreId) ? "" : cell.mPkStoreId;
			t.yearMonth = mDateMonth;
			t.emp_no = SystemHelper.LoginUserId;// 工号
			mListUser.add(t);
		}
		Map<String, String> params = new HashMap<String, String>();
		params.put("json", new Gson().toJson(mListUser));
		new BaseAppServerTask("markStoresubmit", BaseOldResponse.class, MarkStoreActivity.this, "正在上传标杆门店数据...", true, "/pkShop/add", params).execute("");
	}
}
