package com.urovo.activity.salesmanager;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.urovo.activity.goodsReturn.net.GoodsReturnRecordRes;
import com.urovo.activity.goodsReturn.view.storeManagerCancelDetail;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.ui.EditTextDecimal;
import com.urovo.wugumofang.ui.ViewUtil;

import java.io.Serializable;
import java.text.MessageFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import okhttp3.Request;

/**
 * 产品退货
 *
 * @author Administrator
 */
public class storeManagerCancel extends BaseActivity implements OnClickListener {
    private Unbinder unbinder;
    /**
     * 查询按钮
     */
    @BindView(R.id.sale_back_query)
    Button query;
    /**
     * 退货日期
     */
    @BindView(R.id.sale_back_date)
    TextView backDate;
    /**
     * 原销售日期
     */
    @BindView(R.id.sale_date)
    TextView saleDate;
    //    TextView store;
    //    ShopEntity shopEntity; // 选择的门店信息
//    String storeId;
//    @BindView(R.id.storeSelector)
//    LinearLayout storeSelector;
//    @BindView(R.id.storetitle)
//    TextView storetitle;
    /**
     * 所属门店信息
     */
    @BindView(R.id.ordergoods_quire)
    TextView storequire;
    /**
     * 手机号码
     */
    @BindView(R.id.phone)
    EditText phone;
    /**
     * 销售金额
     */
    @BindView(R.id.jine)
    EditTextDecimal jine;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.store_manager_cancel);
        unbinder = ButterKnife.bind(this);
        initTitle();
        init();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }

    void init() {
//        storeSelector = (LinearLayout) findViewById(R.id.storeSelector);
//        if (SystemHelper.IsAdmin) {
//            storeSelector.setVisibility(View.VISIBLE);
//            storetitle = (TextView) findViewById(R.id.storetitle);
//            storetitle.setText("所属门店");
//            store = (TextView) findViewById(R.id.sotre_selector);
//        } else {
//        storequire = (TextView) findViewById(R.id.ordergoods_quire);
        storequire.setText(MessageFormat.format("所属门店:{0}", SystemHelper.LoginOrganName));
//        }
        titleTextView.setText("产品退货");
//        query = (Button) findViewById(R.id.sale_back_query);
//        phone = (EditText) findViewById(R.id.phone);
//        jine = (EditText) findViewById(R.id.jine);
//        backDate = (TextView) findViewById(R.id.sale_back_date);
//        saleDate = (TextView) findViewById(R.id.sale_date);
        Date newDate = new Date();
        backDate.setText(DateUtil.getDate(newDate));
        saleDate.setText(DateUtil.getDate(newDate));
        query.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        query();
    }

    /**
     * 查询请求
     */
    private void query() {
//        if (!SystemHelper.IsAdmin) {
//            storeId = SystemHelper.LoginOrganId;
//        }
//        else {
//            if (shopEntity == null) {
//                DialogHelper.Alert(this, "提示", "请选择一个门店!", null, null);
//                return;
//            }
//            storeId = shopEntity.getShopId();
//            if (TextUtils.isEmpty(storeId)) {
//                DialogHelper.Alert(this, "提示", "请选择一个门店!", null, null);
//                return;
//            }
//        }
//        if (!TextUtils.isEmpty(storeId)) {
//			String date = backDate.getText().toString();
//			String sql = " where s.stores_no = '" + storeId + "' and to_char(saledate  + interval '8 hour','yyyy-MM-dd') = '" + date + "' and yn_hd ='1' ";
//			new DownStoreRXS001Task(this, "正在检测门店销量审核状态...", true, sql, date).execute("");

        //===========test==========
        GoodsReturnRecordRes res = JsonDominator.loadFromSD("GoodsReturnRecordRes", GoodsReturnRecordRes.class);
        if (res != null) {
            //......do_anything
            List<GoodsReturnRecordRes.Result> list = res.getResult();
            Intent intent = new Intent(storeManagerCancel.this, storeManagerCancelDetail.class);
            intent.putExtra("PHONE", phone.getText().toString().trim());
            intent.putExtra("JINE", jine.getText().toString().trim());
            intent.putExtra("INFO", new String[]{SystemHelper.LoginOrganName, backDate.getText().toString(), saleDate.getText().toString()});
            intent.putExtra("LIST", (Serializable) list);
            startActivity(intent);
            return;
        }
        //===========test==========
        ViewUtil.showProgress(storeManagerCancel.this, "请稍等", "正在下载销售记录...");
        HashMap<String, String> param = new HashMap<>(3);
        //登录门店号
        param.put("storeNo", SystemHelper.LoginOrganId);
        //退货日期
        param.put("returnDate", backDate.getText().toString());
        //原销售日期
        param.put("saleDate", saleDate.getText().toString());

        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SALE_RECORD, param,
                new OkHttpDominator.ResultCallback<GoodsReturnRecordRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        showMsg("网络异常，获取下载销售记录失败");
                    }

                    @Override
                    public void onResponse(GoodsReturnRecordRes res) {
                        ViewUtil.dismissProgress();
                        if (res == null) {
                            showMsg("后台返回空");
                            return;
                        }
                        if (res.msgCode != 0) {
                            showMsg(res.msgInfo);
                            return;
                        }
                        List<GoodsReturnRecordRes.Result> list = res.getResult();
                        Intent intent = new Intent(storeManagerCancel.this, storeManagerCancelDetail.class);
                        intent.putExtra("PHONE", phone.getText().toString().trim());
                        intent.putExtra("JINE", jine.getText().toString().trim());
                        intent.putExtra("INFO", new String[]{SystemHelper.LoginOrganName, backDate.getText().toString(), saleDate.getText().toString()});
                        intent.putExtra("LIST", (Serializable) list);
                        startActivity(intent);
                    }
                });
//        }
    }

    /**
     * 退货日期的日历
     *
     * @param view ...
     */
    public void backDatePick(View view) {
        DialogHelper.alertDatePicker(this, backDate);
    }

    /**
     * 原销售日期的日历
     *
     * @param view ...
     */
    public void saleDatePick(View view) {
        DialogHelper.alertDatePicker(this, saleDate);
    }

//    public void storeSelector(View view) {
//        Intent intent = new Intent(storeManagerCancel.this, StoreSelectorActivity.class);
//        startActivityForResult(intent, 200);
//    }

//    @Override
//    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
//
//        super.onActivityResult(requestCode, resultCode, data);
//        switch (resultCode) {
//            case StoreSelectorActivity.RESULTCODE:
//                shopEntity = (ShopEntity) data.getSerializableExtra("store");
//                if (shopEntity != null) {
//                    store.setText(shopEntity.getShopName());
//                }
//                break;
//            default:
//                break;
//        }
//    }

//    @Override
//    public void displayResult(String tag, BaseResponse response) {
//
//        super.displayResult(tag, response);
//        if (DownStoreRXS001Task.TAG.equals(tag)) {
//            StoreRXS001Response res = (StoreRXS001Response) response;
//            if (null == res || null == res.getList()) {
//                showMsg("服务器返回数据为空，请重新查询！");
//                //Toast.makeText(this, "服务器返回数据为空，请重新查询！", 1000).show();
//                return;
//            }
//            if (res.getList().size() == 0) {
//
//                DialogHelper.Alert(this, "提示", SystemHelper.LoginOrganName + "\r\n未审核,可以退货!", null, new DialogInterface.OnClickListener() {
//
//                    @Override
//                    public void onClick(DialogInterface dialog, int which) {
////						String date2 = saleDate.getText().toString();
////						String sql2 = " where shop.stores_no = '" + storeId + "' and to_char(s.sale_date  + interval '8 hour','yyyy-MM-dd') = '" + date2 + "' ";
////						new DownloadXiaoShouTask(storeManagerCancel.this, "正在下载销售记录...", true, sql2).execute("");
//
////						//===========test==========
////						GoodsReturnRecordRes res = JsonDominator.loadFromSD("GoodsReturnRecordRes",GoodsReturnRecordRes.class);
////						if(res != null){
////							//......do_anything
////							List<GoodsReturnRecordRes.Result> list = res.getResult();
////							Intent intent = new Intent(storeManagerCancel.this, storeManagerCancelDetail.class);
////							intent.putExtra("PHONE", phone.getText().toString().trim());
////							intent.putExtra("JINE", jine.getText().toString().trim());
////							intent.putExtra("INFO", new String[]{ SystemHelper.LoginOrganName, backDate.getText().toString(), saleDate.getText().toString() });
////							intent.putExtra("LIST", (Serializable) list);
////							startActivity(intent);
////							return;
////						}
////						//===========test==========
////						ViewUtil.showProgress(storeManagerCancel.this,"请稍等","正在下载销售记录...");
////						HashMap<String,String> param = new HashMap<String, String>();
////						param.put("storeNo",SystemHelper.LoginOrganId);
////						param.put("returnDate", backDate.getText().toString());//退货日期
////						param.put("saleDate",saleDate.getText().toString());//原销售日期
////						OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SALE_RECORD, param,
////								new OkHttpDominator.ResultCallback<GoodsReturnRecordRes>() {
////									@Override
////									public void onError(Request request, Exception e) {
////										ViewUtil.dismissProgress();
////										showMsg("网络异常，获取下载销售记录失败");
////									}
////
////									@Override
////									public void onResponse(GoodsReturnRecordRes res) {
////										ViewUtil.dismissProgress();
////
////										List<GoodsReturnRecordRes.Result> list = res.getResult();
////										Intent intent = new Intent(storeManagerCancel.this, storeManagerCancelDetail.class);
////										intent.putExtra("PHONE", phone.getText().toString().trim());
////										intent.putExtra("JINE", jine.getText().toString().trim());
////										intent.putExtra("INFO", new String[]{ SystemHelper.LoginOrganName, backDate.getText().toString(), saleDate.getText().toString() });
////										intent.putExtra("LIST", (Serializable) list);
////										startActivity(intent);
////									}
////								});
//                    }
//                });
//            } else {
//                DialogHelper.Alert(this, "提示", SystemHelper.LoginOrganName + "\r\n已审核,不允许退货!", null, null);
//            }
//        }
//		if(DownloadXiaoShouTask.TAG.equals(tag)) {
//			DJXS001Response res2 = (DJXS001Response) response;
//			List<XiaoShouEntity> list = res2.getList();
//			Intent intent2 = new Intent(storeManagerCancel.this, storeManagerCancelDetail.class);
//			intent2.putExtra("PHONE", phone.getText().toString().trim());
//			intent2.putExtra("JINE", jine.getText().toString().trim());
//			intent2.putExtra("INFO", new String[]{ SystemHelper.LoginOrganName, backDate.getText().toString(), saleDate.getText().toString() });
//			intent2.putExtra("LIST", (Serializable) list);
//			startActivity(intent2);
//		}
//    }
}
