package com.urovo.activity.sanxiangpao.view;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.MemberProfile.view.MemberProfileAct;
import com.urovo.activity.sanxiangpao.model.SanXiangPaoListEntity;
import com.urovo.wugumofang.R;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.List;

import androidx.fragment.app.Fragment;

/**
 * 用于显示客户列表
 *
 * @author Sasuke
 * @date 2016/3/17
 */
public class SanXiangPaoListFrag extends Fragment {
    //    private List<XinKeSanXiangPaoGuanHuaiEntity> mList;
    private List<SanXiangPaoListEntity> mSanXiangPaoList;

    private ListView mLv;
    private MyAdapter myAdapter;
    private TextView youhuiquanTitle;
    private int mType;//1表示5天，2是15天，3是45天;

    class ViewHolder {
        TextView customerName;//客户名
        TextView customerMobile;//手机号
        ImageView huifangIcon;//是否回访
        //ImageView toupiaoIcon;//微信投票
//        TextView hasYouhuiquan;//是否有“以老带新”的优惠券，以及它的使用状态
    }

//    XinKeSanXiangPaoGuanHuaiResponse res;

    private class MyAdapter extends BaseAdapter {

        @Override
        public int getCount() {
//            return mList.size();
            return mSanXiangPaoList.size();
        }

        @Override
        public Object getItem(int position) {

            return position;
        }

        @Override
        public long getItemId(int position) {

            return position;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            ViewHolder holder = new ViewHolder();
            if (convertView == null) {
                LayoutInflater inflater = getActivity().getLayoutInflater();
                convertView = inflater.inflate(R.layout.sanxiangpao_list_item, parent, false);
                holder.customerName = convertView.findViewById(R.id.customerName);
                holder.customerMobile = convertView.findViewById(R.id.customerMobile);
                holder.huifangIcon = convertView.findViewById(R.id.is_huifang);
                // holder.toupiaoIcon =  convertView.findViewById(R.id.is_toupiao);
//                holder.hasYouhuiquan =  convertView.findViewById(R.id.has_youhuiquan);
                convertView.setTag(holder);
            } else {
                holder = (ViewHolder) convertView.getTag();
            }

//            XinKeSanXiangPaoGuanHuaiEntity cell = mList.get(position);
            final SanXiangPaoListEntity cell = mSanXiangPaoList.get(position);
//            String customerName = cell.customerName;
            String customerName = cell.getCustomerName();
            //设置会员名
            holder.customerName.setText(TextUtils.isEmpty(customerName) ? "会员" : customerName);
            //设置会员手机号
            holder.customerMobile.setText(transMobile(TextUtils.isEmpty(cell.getCustomerMobile()) ? "" : cell.getCustomerMobile()));
            //设置回访标识
//            if (cell.careFlag != null && "1".equals(cell.careFlag)) {
            if (cell.getHasCommunication() != null && "1".equals(cell.getHasCommunication())) {
                holder.huifangIcon.setImageResource(R.drawable.mark_callback_ed);
            } else {
                holder.huifangIcon.setImageResource(R.drawable.mark_callback_not);
            }
            /*//设置微信投票标识
            if (cell.isInteractive.equals("1")) {//1是已互动（已投票）
                holder.toupiaoIcon.setImageResource(R.drawable.print_ok);
            } else if (cell.isInteractive.equals("0")) {//0是未互动（未投票）
                holder.toupiaoIcon.setImageResource(R.drawable.print_fail2);
            }*/

            //设置“以老带新”优惠券的使用状态
//            if (mType == 3) {//1表示5天，2是15天，3是45天;
//                holder.hasYouhuiquan.setVisibility(View.VISIBLE);
//               /* if(cell.getCodestatus().equals("0")){//优惠券，0未使用  1已使用
//                    holder.hasYouhuiquan.setText("未使用");
//                }else if(cell.getCodestatus().equals("1")){
//                    holder.hasYouhuiquan.setText("已使用");
//                }*/
//                holder.hasYouhuiquan.setText(cell.getCodestatus());
//            } else {
//                holder.hasYouhuiquan.setVisibility(View.GONE);
//            }
            /*Toast.makeText(getActivity(),cell.isInteractive,1000).show();*/
            return convertView;
        }

    }

    /*public SanXiangPaoListFrag() {
        super();
        //mList = SanXiangPaoAct.mList;

    }*/


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        final Bundle bundle = getArguments();
        mType = bundle.getInt("mType");
//        res = (XinKeSanXiangPaoGuanHuaiResponse) bundle.get("mList");
        RequestResult<List<SanXiangPaoListEntity>> mList = (RequestResult<List<SanXiangPaoListEntity>>) bundle.get("mList");
        if (mList != null && mList.resultInfo != null && !mList.resultInfo.isEmpty()) {
            SYLoger.print("lemmonade3 --" + mList.resultInfo.get(0));
            mSanXiangPaoList = mList.resultInfo;
        }
//        this.mList = res.getList();
        View view = inflater.inflate(R.layout.sanxiangpao_list, container, false);
        mLv = view.findViewById(R.id.xinke_list);
//        youhuiquanTitle = (TextView) view.findViewById(R.id.youhuiquan_title);

//        if (mType == 3) {//1表示5天，2是15天，3是45天;
//            youhuiquanTitle.setVisibility(View.VISIBLE);
//        } else {
//            youhuiquanTitle.setVisibility(View.GONE);
//        }

        if (mSanXiangPaoList != null) {
            mLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    Intent intent = new Intent(getActivity(), MemberProfileAct.class);
//                    intent.putExtra("phone", ((XinKeSanXiangPaoGuanHuaiEntity) SanXiangPaoListFrag.this.mList.get(position)).customerMobile);
                    intent.putExtra("phone", mSanXiangPaoList.get(position).getCustomerMobile());
                    intent.putExtra("mType", mType);//告诉它这条新客记录是从哪个档来的，3天？还是7天还是15天？
//                    intent.putExtra("entity", SanXiangPaoListFrag.this.mList.get(position));//只用传对应会员的Entity就行了
                    intent.putExtra("entity", mSanXiangPaoList.get(position));//只用传对应会员的Entity就行了
                    intent.putExtra("careType", "1");//关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
                    intent.putExtra("position", position);
                    startActivityForResult(intent, 1);
                }

            });
            myAdapter = new MyAdapter();
            mLv.setAdapter(myAdapter);
        }


        return view;
    }

    /**
     * 把手机号码转换成带分隔线的字符串
     *
     * @param customerMobile 原手机号字符串
     * @return 转换后生成的手机号
     */
    private String transMobile(String customerMobile) {
        StringBuilder sb = new StringBuilder(customerMobile);
        sb.replace(3, 7, "****");
        return sb.toString();
    }

    /**
     * 主要用于关闭新客详情Activity后，对本页面的列表状态标识进行刷新
     *
     * @param requestCode ...
     * @param resultCode  ...
     * @param data        ...
     */
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        int position = data.getIntExtra("position", -1);
        if (position != -1 && resultCode == 1) {//如果回访信息上传成功
//            XinKeSanXiangPaoGuanHuaiEntity cell = (XinKeSanXiangPaoGuanHuaiEntity) data.getSerializableExtra("entity");
            SanXiangPaoListEntity cell = (SanXiangPaoListEntity) data.getSerializableExtra("entity");
//            mList.set(position, cell);//把该position上的元素给覆盖掉
            mSanXiangPaoList.set(position, cell);//把该position上的元素给覆盖掉
            myAdapter.notifyDataSetChanged();
        }
    }
}
