package com.urovo.activity.sanxiangpaoData.model;

import com.urovo.activity.sanxiangpaoData.web.SXPRnListEntity;
import com.urovo.wgmf.db.dao.entitys.HuiYuanXiaoFeiXinXiEntity;
import com.urovo.wugumofang.data.DateUtil;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * Created by Sasuke on 2016/6/7.
 */
public class SXPRnData {
    String endToDate = "";//截止到日期
    private String dateBegin = "";//起始查询日期
    private String dateEnd = "";//终结查询日期

    List<ExListItem> exList;//ExpandableList数据源
    //List<SXPRnListEntity> SXPRnList;//60天回访详情 一级菜单
    public static class ExListItem{
        public SXPRnListEntity entity;//ExpandableList的一级元素
        public List<SaleDetail> list;//ExpandableList点开后的二级列表
    }

    //每个子列表项所要展示的部分
    public static class SaleDetail{
        public String saleDateStr;//销售日期
        public String productName;//产品名
        public String productNum;//产品购买个数
        public String amount;//该产品购买总价
    }

    //存入一级菜单数据源
    public void setExListGroups(List<SXPRnListEntity> list){
         if(exList == null){
             exList = new ArrayList<>();
         }
        exList.clear();
        int listSize = list.size();
        for(int i = 0;i < listSize ; i++){
            ExListItem item = new ExListItem();
            item.entity = list.get(i);
            item.list = new ArrayList<>();
            exList.add(item);
        }
    }

    //重新构建新的二级菜单数据源集合，方便后期处理
    public void setExListChilds(List<HuiYuanXiaoFeiXinXiEntity.XiaoFeiXinXiEntity> list, int groupPosition){
        List<SaleDetail> mList = new ArrayList<>();
        for(HuiYuanXiaoFeiXinXiEntity.XiaoFeiXinXiEntity entity : list){
            for(HuiYuanXiaoFeiXinXiEntity.XiaoFeiXinXiEntity.XinXiEntiry entity2 : entity.saleProductList){
                SaleDetail item = new SaleDetail();
                String saleDateStr = new StringBuffer(entity.saleDateStr).insert(4,"-").insert(7,"-").toString();
                item.saleDateStr = saleDateStr;//由上把20160614这种日期转换成2016-06-14格式，而且一定要设中间变量saleDateStr,否则魅族会坑。
                item.amount = entity2.amount;
                item.productName = entity2.productName;
                item.productNum = entity2.productNum;
                mList.add(item);
            }
        }
        //按购买日期由小到大排个序
        Collections.sort(mList, new Comparator<SaleDetail>() {
            @Override
            public int compare(SaleDetail lhs, SaleDetail rhs) {
                return lhs.saleDateStr.compareTo(rhs.saleDateStr);
            }
        });
        //该做的都做完了，可以安心放到数据集合里去了
        exList.get(groupPosition).list = mList;
    }

    public List<ExListItem> getExList() {
        return exList;
    }

    public String getEndToDate() {
        return endToDate;
    }

    public void setEndToDate(String endToDate) {
        this.endToDate = endToDate;
    }

    /**
     * @return 返回 年-月-日 汉字版截止日期
     */
    public String getEndToRiqi(){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日");
        return sdf.format(DateUtil.parseDate(endToDate));
    }

   /* public void setSXPRnList(List<SXPRnListEntity> list){
        this.SXPRnList = list;
    }

    public List<SXPRnListEntity> getSXPRnList() {
        return SXPRnList;
    }*/

    public void setDateBegin(String dateBegin) {
        this.dateBegin = dateBegin;
    }

    public void setDateEnd(String dateEnd) {
        this.dateEnd = dateEnd;
    }

    public String getDateBegin(){
        return dateBegin;
    }

    public String getDateEnd(){
        return dateEnd;
    }
}
