package com.urovo.activity.sanxiangpaoData.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.activity.sanxiangpaoData.model.SXPRnData;
import com.urovo.wugumofang.R;

import java.util.List;

/**
 * Created by Sasuke on 2016/6/7.
 */
public class SXPRnExpanListAdapter extends BaseExpandableListAdapter {
    Context context;
    List<SXPRnData.ExListItem> exList;
    public SXPRnExpanListAdapter(Context context,List<SXPRnData.ExListItem> exList) {
        this.context = context;
        this.exList = exList;
    }

    @Override
    public int getGroupCount() {
        return exList.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        return exList.get(groupPosition).list.size();
    }

    @Override
    public Object getGroup(int groupPosition) {
        return null;
    }

    @Override
    public Object getChild(int groupPosition, int childPosition) {
        return null;
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
        GroupHolder holder;
        if(convertView == null){
            LayoutInflater inflater= LayoutInflater.from(context);
            convertView = inflater.inflate(R.layout.ll_sanxiangpao_rn_list_group_item,null);
            holder = new GroupHolder();
            holder.customerMobile = convertView.findViewById(R.id.telephone);
            holder.customerName = convertView.findViewById(R.id.member_name);
            holder.secondBuyDate = convertView.findViewById(R.id.back_first_time);
            holder.totalNum = convertView.findViewById(R.id.money);
            holder.arrow = convertView.findViewById(R.id.list_group_arrow);
            convertView.setTag(holder);
        }else{
            holder = (GroupHolder)convertView.getTag();
        }

        holder.customerMobile.setText(exList.get(groupPosition).entity.getCustomerMobile());
        holder.customerName.setText(exList.get(groupPosition).entity.getCustomerName());
        String secondBuyDate = exList.get(groupPosition).entity.getSecondBuyDate().substring(0,10);
        holder.secondBuyDate.setText(secondBuyDate);
        holder.totalNum.setText(exList.get(groupPosition).entity.getTotalNum());
        if(isExpanded) {
            holder.arrow.setImageResource(R.drawable.list_group_close);
        }else{
            holder.arrow.setImageResource(R.drawable.list_group_open);
        }

        holder.customerMobile.setOnClickListener(null);
        holder.customerName.setOnClickListener(null);
        holder.secondBuyDate.setOnClickListener(null);
        //holder.totalNum.setOnClickListener(null);
        return convertView;
    }

    @Override
    public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        ChildHolder holder;
        if(convertView == null){
            LayoutInflater inflater= LayoutInflater.from(context);
            convertView = inflater.inflate(R.layout.ll_sanxiangpao_rn_list_child_item,null);
            holder = new ChildHolder();
            holder.newIcon = convertView.findViewById(R.id.newIcon);
            holder.saleDateStr = convertView.findViewById(R.id.saleDateStr);
            holder.productName = convertView.findViewById(R.id.productName);
            holder.consNum = convertView.findViewById(R.id.consNum);
            holder.consAmount = convertView.findViewById(R.id.consAmount);
            holder.loadingLayout = convertView.findViewById(R.id.loading_layout);
            convertView.setTag(holder);
        }else{
            holder = (ChildHolder) convertView.getTag();
        }


        if(exList.get(groupPosition).list!= null && exList.get(groupPosition).list.size() != 0){//若数据源集合存在列表数据
            holder.loadingLayout.setVisibility(View.GONE);
            if(childPosition == 0){
                holder.newIcon.setVisibility(View.VISIBLE);
            }else{
                holder.newIcon.setVisibility(View.INVISIBLE);
            }
            List<SXPRnData.SaleDetail> childList = exList.get(groupPosition).list;//子列表数据源
            if(childPosition != 0 && //如果不是首元素并且与前一元素日期相同，就不显示日期
                    childList.get(childPosition - 1).saleDateStr.equals(childList.get(childPosition).saleDateStr)){
                holder.saleDateStr.setText("");
            }else{
                holder.saleDateStr.setText(childList.get(childPosition).saleDateStr);
            }
            holder.consAmount.setText(childList.get(childPosition).amount);
            holder.consNum.setText(childList.get(childPosition).productNum);
            holder.productName.setText(childList.get(childPosition).productName);
        }else if(childPosition == 0){//如果没有数据（展开的时候会激发RnListFra里的OnGroupExpandListener监听器的，这里不用管）
            holder.loadingLayout.setVisibility(View.VISIBLE);
        }else{
            holder.loadingLayout.setVisibility(View.GONE);
        }

        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return false;
    }

    class GroupHolder{
        TextView customerName;
        TextView customerMobile;
        TextView secondBuyDate;
        TextView totalNum;
        ImageView arrow;
    }

    class ChildHolder{
        TextView newIcon;//"新"图标
        TextView saleDateStr;//交易时间
        TextView productName;//产品名称
        TextView consNum;//消费个数
        TextView consAmount;//总金额
        LinearLayout loadingLayout;//正在加载。。。界面
    }

}
