package com.urovo.activity.sanxiangpaoData.view;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.activity.sanxiangpaoData.presenter.SXPBackListPresenter;
import com.urovo.activity.sanxiangpaoData.presenter.SanXiangPaoDataContract;
import com.urovo.activity.sanxiangpaoData.ui.SXPBackListAdapter;
import com.urovo.activity.sanxiangpaoData.web.SXPBackListEntity;
import com.urovo.wugumofang.R;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * Created by Sasuke on 2016/6/8.
 */
public class SanXiangPaoBackListFra extends Fragment implements SanXiangPaoDataContract.View{
    SXPBackListPresenter mPresenter;
    SXPBackListAdapter adapter;
    @BindView(R.id.list_back_data) ListView dataList;
    TextView rn60Percent;
    Unbinder unbinder;
    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        container = (LinearLayout)inflater.inflate(R.layout.fra_sanxiangpao_list,null);
        unbinder = ButterKnife.bind(this,container);
        initUI();
        return container;
    }

    @Override
    public void notifyAdapter() {
        adapter.notifyDataSetChanged();
    }

    @Override
    public void initUI() {
        if(adapter == null) {
            adapter = new SXPBackListAdapter(getActivity(), mPresenter.getData().getSXPBackList(),mPresenter);
            View view = LayoutInflater.from(getActivity()).inflate(R.layout.sxp_back_list_foot,null);
            rn60Percent = view.findViewById(R.id.percent);
            dataList.addFooterView(view);
            dataList.setAdapter(adapter);//setAdapter要在addFooter后面执行，否则在4.X系统上跑不出来，但在6.0.1系统上挺正常
        }else{
            adapter.notifyDataSetChanged();
        }

        float average = 0;//Rn60回头百分比平均值
        for(SXPBackListEntity entity : mPresenter.getData().getSXPBackList()){
            average += Float.parseFloat(entity.getBackRate().replace("%",""));
        }
        average = average / mPresenter.getData().getSXPBackList().size();
        String percentStr = String.format("%.1f", average);
        rn60Percent.setText(percentStr+"%");
    }

    @Override
    public void setPresenter(Object presenter) {
        this.mPresenter = (SXPBackListPresenter)presenter;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
//        ButterKnife.unbind(this);
        unbinder.unbind();
    }

}
