package com.urovo.activity.sanxiangpaoData.view;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

import com.urovo.activity.sanxiangpaoData.model.SXPRnData;
import com.urovo.activity.sanxiangpaoData.presenter.SXPRnListPresenter;
import com.urovo.activity.sanxiangpaoData.web.SXPRnListResponse;
import com.urovo.activity.slidemenu.NoDataFrag;
import com.urovo.wgmf.entity.response.HuiYuanXiaoFeiXinXiResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

/**
 * 90天回头详情
 *
 * @author Sasuke
 * @date 2016/6/7
 */
public class SanXiangPaoRnListAct extends BaseActivity {
    @BindView(R.id.text_title)
    TextView title;

    /**
     * 截止到的日期
     */
    @BindView(R.id.end_to_date)
    TextView endToDate;

    /**
     * 门店
     */
    @BindView(R.id.store_name)
    TextView storeName;

    private SXPRnListPresenter mPresenter;
    private SanXiangPaoRnListFra listFra;
    private Unbinder unbinder;
    private SXPRnData mData;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_sanxiangpao_rn_detail);
        unbinder = ButterKnife.bind(this);

        listFra = new SanXiangPaoRnListFra();
        mPresenter = new SXPRnListPresenter(this, listFra);
        mData = mPresenter.getData();

        initUI();
        query();
    }

    @OnClick(R.id.back)
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.back:
                finish();
                break;
            default:
                break;
        }
    }

    @SuppressLint("SetTextI18n")
    public void initUI() {
        title.setText("90天回头详情");
        if (mData != null) {
            mData.setEndToDate(
                    getIntent().getStringExtra("statisticsDate"));
            mData.setDateBegin(
                    getIntent().getStringExtra("dateBegin"));
            mData.setDateEnd(
                    getIntent().getStringExtra("dateEnd"));

            endToDate.setText("截止" +
                    mData.getEndToRiqi());
            storeName.setText(SystemHelper.LoginOrganName);
            //先显示“暂无数据”
            getSupportFragmentManager().beginTransaction().
                    replace(R.id.rn_list_fra_container, new NoDataFrag()).commit();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }

    public void query() {
        mPresenter.search();
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if (response == null) {
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
            return;
        }
        //获取60天回头详情1级列表
        if ("listDetail".equals(tag)) {
            SXPRnListResponse res = (SXPRnListResponse) response;
            if (null != mData && null != res.getReturnBean() && res.getReturnBean().size() > 0) {
                mData.setExListGroups(res.getReturnBean());
                getSupportFragmentManager().beginTransaction().replace(R.id.rn_list_fra_container, listFra).commit();
            } else {//显示暂无数据
                getSupportFragmentManager().beginTransaction().replace(R.id.rn_list_fra_container, new NoDataFrag()).commit();
            }
        }
        //点开列表单独项后打开的二级列表
        else if (tag.startsWith("saleDetail")) {
            //把从标签带过来的groupPosition读出来
            int groupPosition = Integer.parseInt(tag.replaceAll("saleDetail", ""));
            HuiYuanXiaoFeiXinXiResponse res = (HuiYuanXiaoFeiXinXiResponse) response;
            if (res.getList().returnList != null && res.getList().returnList.size() != 0) {
                mPresenter.dealAndSaveList(res.getList().returnList, groupPosition);
            }
        }
    }
}
