package com.urovo.activity.sell;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.MoneyUtils;
import com.urovo.wugumofang.data.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class BillDetailActivity extends BaseActivity {

    private ImageButton goback;
    private TextView tv_zongjine;
    private TextView tv_shixiaojine;
    private ListView lv_bill_detail;
    private ListView lv_cuxiao_detail;
    private LinearLayout ll_cuxiao_detail;

    private final List<ProductEntity> saleList = new ArrayList<>();
    private final List<ProductEntity> cuxiaoList = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.bill_detail);

        goback = findViewById(R.id.goback);
        titleTextView = findViewById(R.id.text_title);
        titleTextView.setText("购买详情");
        goback.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                finish();
            }
        });

        Intent intent = getIntent();
        List<ProductEntity> bill = (List<ProductEntity>) intent.getSerializableExtra("bill");
        List<ProductEntity> productForPrintTemp = (List<ProductEntity>) intent.getSerializableExtra("bill4Printer");
        double actualPrice = intent.getDoubleExtra("actualPrice", 0);

        tv_zongjine = findViewById(R.id.tv_zongjine);
        tv_shixiaojine = findViewById(R.id.tv_shixiaojine);
        lv_bill_detail = findViewById(R.id.lv_bill_detail);
        lv_cuxiao_detail = findViewById(R.id.lv_cuxiao_detail);
        ll_cuxiao_detail = findViewById(R.id.ll_cuxiao_detail);

        double total = 0;
        double actual = 0;
        //算总价
        for (ProductEntity p : bill) {
            if (!p.getItemId().equals("9.8888") && p.getAmount() != 0){
                total = Arith.add(total,p.getAmount());
            }
        }
        //再提取商品信息，用于显示列表
        for (ProductEntity p : productForPrintTemp) {
            if (p.getItemId().equals("9.8888")) {
                cuxiaoList.add(p);
                continue;
            }
            if (p.getAmount() == 0) {
                cuxiaoList.add(p);
            } else {
                saleList.add(p);
            }
        }
        tv_shixiaojine.setText(MoneyUtils.twolastDF(actualPrice));
        tv_zongjine.setText(MoneyUtils.twolastDF(total));

        if (saleList != null && saleList.size() > 0) {
            lv_bill_detail.setAdapter(new SaleAdapter(this, saleList));
        }
        if (cuxiaoList != null && cuxiaoList.size() > 0) {
            ll_cuxiao_detail.setVisibility(View.VISIBLE);
            lv_cuxiao_detail.setAdapter(new CuxiaoAdapter(this, cuxiaoList));
        } else {
            ll_cuxiao_detail.setVisibility(View.GONE);
        }
    }

    private class SaleAdapter extends MyBaseAdapter<ProductEntity, ListView> {

        public SaleAdapter(Context context, List<ProductEntity> list) {
            super(list, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            View view = View.inflate(context, R.layout.listview_item_bill_detail, null);
            TextView tv_bill_name = view.findViewById(R.id.tv_bill_name);
            TextView tv_bill_num = view.findViewById(R.id.tv_bill_num);
            TextView tv_bill_price = view.findViewById(R.id.tv_bill_price);
            ProductEntity p = lists.get(position);
            tv_bill_name.setText(p.getItemName() + "(" + p.getKCUom() + ")");
            //五谷磨房品牌的数量是int，鲜稻研品牌的数量是double
            tv_bill_num.setText("×" + StringUtils.formatDouble(p.getTQTY(),"0.##"));
            tv_bill_price.setText(MoneyUtils.twolastDF(p.getAmount()));
            return view;
        }

    }

    private class CuxiaoAdapter extends MyBaseAdapter<ProductEntity, ListView> {

        public CuxiaoAdapter(Context context, List<ProductEntity> list) {
            super(list, context);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            View view = View.inflate(context, R.layout.listview_item_bill_detail, null);
            TextView tv_bill_name = view.findViewById(R.id.tv_bill_name);
            TextView tv_bill_num = view.findViewById(R.id.tv_bill_num);
            TextView tv_bill_price = view.findViewById(R.id.tv_bill_price);
            ProductEntity p = lists.get(position);
            if (p.getItemId().equals("9.8888")) {
                StringBuilder sb = new StringBuilder();
                if (p.getItemType().equals("ZLZK_BL") || p.getItemType().equals("MZHPZK_BL")) {
                    sb.append("打" + p.getProductState() + "折");
                } else if (p.getItemType().equals("ZLZK_JE") || p.getItemType().equals("MZHPZK_JE")) {
                    sb.append("减" + p.getProductState() + "元");
                }
                tv_bill_name.setText(sb.toString());
                tv_bill_price.setText(MoneyUtils.twolastDF(lists.get(position).getAmount()));
            } else {
                tv_bill_name.setText(p.getItemName() + "(" + p.getKCUom() + ")");
                tv_bill_num.setText("X" + (int) p.getTQTY() + "");
                tv_bill_price.setText(MoneyUtils.twolastDF(p.getAmount()));
            }
            return view;
        }

    }
}
