package com.urovo.activity.sell;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Spannable;
import android.text.SpannableStringBuilder;
import android.text.Spanned;
import android.text.method.LinkMovementMethod;
import android.text.style.ClickableSpan;
import android.text.style.ForegroundColorSpan;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.urovo.activity.data.QuerySalesDetailNative;
import com.urovo.activity.tabMenu.home.act.BaseSubmitOrderAct;
import com.urovo.activity.tabMenu.home.pre.SubmitOrderPre;
import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.ToActivity;
import com.urovo.wugumofang.utils.CommonTools;
import com.wgmf.trade.model.bean.FirstShopGiftBean;

import org.greenrobot.eventbus.EventBus;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * @author chenji
 * @date 2018/6/20
 */
public class SaveFailureActivity extends BaseSubmitOrderAct implements View.OnClickListener {
    private Unbinder unbinder;
    @BindView(R.id.save_fail_tips)
    TextView mSaveFailTips;
    @BindView(R.id.btn_reSave)
    Button mReSaveBtn;
    private SubmitOrderPre mSubmitOrderPre;
    String phone;
//    String brand;

    /**
     * 新价格比例,默认比例为1
     */
//    private double newPricePercentage = 1;
    private double actualPrice;
    private double totalPrice;
    private List<ProductEntity> bill = new ArrayList<>();
    /**
     * 销售单号
     */
    private String billCode;
    boolean isScanPage;

    @SuppressWarnings("all")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.save_failure);
        unbinder = ButterKnife.bind(this);
        initTitle();

        Intent intent = getIntent();
        phone = intent.getStringExtra("huiyuan");
//        brand = intent.getStringExtra("brand");
        actualPrice = intent.getDoubleExtra("actualPrice", 0);
        totalPrice = intent.getDoubleExtra("totalPrice", 0);
        bill = (List<ProductEntity>) intent.getSerializableExtra("bill");
        billCode = intent.getStringExtra("billCode");
        isScanPage = intent.getBooleanExtra("isScanPage", true);
//        newPricePercentage = intent.getDoubleExtra(NEW_PRICE_PERCENTAGE, 0);

        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                gotoHomeTab(TabMenuActivity.class);
                //发送消息到主页，让它在后台默默重传一次。
                EventBus.getDefault().post(new SubmitOrderPre.SubmitOrderEvent());
            }
        });
        mReSaveBtn.setOnClickListener(this);
        //文字颜色、下划线、点击事件设置
        setSaveFailTipsInfo();

        mSubmitOrderPre = new SubmitOrderPre(this, phone == null ? "" : phone) {
            @Override
            public void skipToOrderResult() {
                //不是扫码页面(手动录单页面)，返回false，是扫码页面（自动录单页面），默认true。
                if (isScanPage) {
                    ToActivity.toActivity(SaveFailureActivity.this, ScanSaveSuccessAct.class);
                } else {
                    skipToSuccessPage(SaveSuccessActivity.class);
                }
                finish();
            }
        };
    }

    private void skipToSuccessPage(Class<?> clz) {
        Intent intent = new Intent(this, clz);
        //传到SaveSuccessAct界面用这个标记来判断是否显示打印按钮，鲜稻研不需要打印按钮的！
//        intent.putExtra("brand", brand);
        intent.putExtra("actualPrice", actualPrice);
        intent.putExtra("totalPrice", totalPrice);
        // 结果页面处理特价条码打印
        intent.putExtra("bill", (Serializable) bill);
        intent.putExtra("huiyuan", phone);
        //只有常规销售才传这个billCode，用来区分销售补录。
        intent.putExtra("billCode", billCode);
//        intent.putExtra(NEW_PRICE_PERCENTAGE, newPricePercentage);
        startActivity(intent);
    }

    private void setSaveFailTipsInfo() {
        SpannableStringBuilder builder = new SpannableStringBuilder();

        //设置文字
        builder.append("多次重试仍失败，可以稍后前往本机销售记录查看后再上传！");

        //设置部分文字点击事件（里面就包括了下划线，就不需要重复加了）
        ClickableSpan clickableSpan = new ClickableSpan() {
            @Override
            public void onClick(View widget) {
                EventBus.getDefault().post(new SubmitOrderPre.SubmitOrderEvent());
                ToActivity.toActivity(SaveFailureActivity.this, QuerySalesDetailNative.class, "gotoHomeTab", true);
            }
        };
        builder.setSpan(clickableSpan, 14, 20, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);

        //设置部分文字颜色必须在点击事件下面，否则文字颜色设置无效
        ForegroundColorSpan colorSpan = new ForegroundColorSpan(Color.parseColor("#FFA019"));
        builder.setSpan(colorSpan, 14, 20, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);

        mSaveFailTips.setText(builder);
        mSaveFailTips.setMovementMethod(LinkMovementMethod.getInstance());
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (event.getAction() == 0) {
            switch (keyCode) {
                case KeyEvent.KEYCODE_BACK:
                    gotoHomeTab(TabMenuActivity.class);
                    //发送消息到主页，让它在后台默默重传一次。
                    EventBus.getDefault().post(new SubmitOrderPre.SubmitOrderEvent());
                    return true;
                default:
                    break;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("保存结果");
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btn_reSave:
                if (CommonTools.INSTANCE.isOneClick()) {
                    mSubmitOrderPre.submitOrder(SaveFailureActivity.this);
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void onSubmitFailure() {
        mSubmitOrderPre.onSubmitFailure(2000);
    }

    @Override
    public void onSubmitSuccess() {
        mSubmitOrderPre.onSubmitSuccess();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (unbinder != null) {
            unbinder.unbind();
        }
    }
}
