package com.urovo.activity.sell;

import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.KeyEvent;
import android.widget.TextView;

import com.urovo.activity.tabMenu.view.TabMenuActivity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;

/**
 * @author ...
 */
public class ScanSaveSuccessAct extends BaseActivity {
    private CountDownTimer counter;

    /**
     * 倒计时自动关闭
     */
    private TextView autoClosedTips;

    @Override
    protected String getName() {
        return "保存成功";
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("保存结果");
        autoClosedTips = findViewById(R.id.autoClosedTips);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (event.getAction() == 0) {
            switch (keyCode) {
                case KeyEvent.KEYCODE_BACK:
                    gotoHomeTab(TabMenuActivity.class);
                    return true;
                default:
                    break;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.scan_save_success);
        initTitle();
        back.setOnClickListener(v -> gotoHomeTab(TabMenuActivity.class));
        //开启倒计时5秒
        countDown();
    }

    @Override
    protected void onDestroy() {
        if (counter != null) {
            counter.cancel();
        }
        super.onDestroy();
    }

    /**
     * 倒计时5秒
     */
    public static final int COUNT_TIME = 5 * 1000;

    protected void countDown() {
        counter = new CountDownTimer(COUNT_TIME, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
                autoClosedTips.setText(String.format("%s", (millisUntilFinished / 1000) + "秒后自动关闭页面！"));
            }

            @Override
            public void onFinish() {
                gotoHomeTab(TabMenuActivity.class);
            }
        }.start();
    }
}
