package com.urovo.activity.sell;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.dao.XbzpfDbOperate;
import com.urovo.wgmf.db.dao.entitys.XBZPFEntity;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.R;

import java.util.List;

public class ShiFangDetailActivity extends BaseActivity {

	private TextView tv_shifang_name;
	private ListView lv_detail;
	private ImageButton goback;
	// @ViewInject(R.id.text_title)
	// private TextView text_title;
	// @ViewInject(R.id.tv_shifang_name)
	// private TextView tv_shifang_name;
	// @ViewInject(R.id.lv_detail)
	// private ListView lv_detail;

	private DetailAdapter adapter;
	private List<XBZPFEntity> detail;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.shifang_detail);
		// ViewUtils.inject(this);
		titleTextView = findViewById(R.id.text_title);
		tv_shifang_name = findViewById(R.id.tv_shifang_name);
		lv_detail = findViewById(R.id.lv_detail);
		goback = findViewById(R.id.goback);

		titleTextView.setText("十方详情");
		goback.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finish();
			}
		});

		Intent intent = getIntent();
		final String zuhebianma = intent.getStringExtra("zuhebianma");
		ViewUtil.showProgress(ShiFangDetailActivity.this, "提示", "正在查询十方详情");
		new Thread(new Runnable() {

			@Override
			public void run() {

				if(!TextUtils.isEmpty(zuhebianma)) {
					// detail=new ArrayList<XBZPFEntity>();
					detail = null;
					detail = XbzpfDbOperate.GetShiFangDetail(zuhebianma);
					if(detail != null) {
						handler.sendEmptyMessage(0);
					}
				}
				// ViewUtil.dismissProgress();
			}
		}).start();

	}

	private Handler handler = new Handler() {
		public void handleMessage(android.os.Message msg) {
			ViewUtil.dismissProgress();
			adapter = new DetailAdapter(ShiFangDetailActivity.this, detail);
			tv_shifang_name.setText(detail.get(0).ITEMNAME);
			lv_detail.setAdapter(adapter);
		}
	};

	private class DetailAdapter extends MyBaseAdapter<XBZPFEntity, ListView> {

		public DetailAdapter(Context context, List<XBZPFEntity> product) {
			super(product, context);
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			View view;
			final ViewHolder holder;
			if(convertView == null) {
				view = View.inflate(context, R.layout.listview_shifang_detail, null);
				holder = new ViewHolder();
				holder.tv_pro_name = view.findViewById(R.id.tv_det_name);
				holder.tv_pro_number = view.findViewById(R.id.tv_det_num);
				holder.tv_pro_weight = view.findViewById(R.id.tv_det_weight);
				holder.tv_det_bzprice = view.findViewById(R.id.tv_det_bzprice);
				holder.tv_det_count = view.findViewById(R.id.tv_det_count);
				holder.tv_det_standard = view.findViewById(R.id.tv_det_standard);
				holder.tv_det_sjprice = view.findViewById(R.id.tv_det_sjprice);

				view.setTag(holder);
			}
			else {
				view = convertView;
				holder = (ViewHolder) view.getTag();
			}

			holder.tv_pro_name.setText(lists.get(position).XBZNAME);
			holder.tv_pro_number.setText(lists.get(position).XBZID + "");
			holder.tv_pro_weight.setText(lists.get(position).WEIGHT + "");
			holder.tv_det_bzprice.setText(lists.get(position).BZPRICE + "");
			holder.tv_det_count.setText(lists.get(position).BZQTY + "");
			holder.tv_det_standard.setText(lists.get(position).SJQTY + "");
			holder.tv_det_sjprice.setText(lists.get(position).SJPRICE + "");
			return view;
		}
	}

	static class ViewHolder {
		public TextView tv_pro_name;
		public TextView tv_pro_number;
		public TextView tv_pro_weight;
		public TextView tv_det_bzprice;
		public TextView tv_det_count;
		public TextView tv_det_standard;
		public TextView tv_det_sjprice;
	}
}
