package com.urovo.activity.slidemenu;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.dao.Czyda001DbOperate;
import com.urovo.wgmf.db.dao.entitys.Czyda001Db;
import com.urovo.wugumofang.R;

public class GuWenSelectorActivity extends BaseActivity {

	private ListView lv_select_guwen;
	private String storeid = "";
	private List<Czyda001Db> guwens;
	private boolean[] choice;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.select_guwen);
		ImageButton goback = (ImageButton) findViewById(R.id.goback);
		goback.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finish();
			}
		});
		TextView tv = (TextView) findViewById(R.id.text_title);
		tv.setText("选择营养顾问");
		lv_select_guwen = (ListView) findViewById(R.id.lv_select_guwen);
		Intent intent = getIntent();
		storeid = intent.getStringExtra("storeid");

		guwens = new ArrayList<Czyda001Db>();
		guwens = Czyda001DbOperate.selectBy(" where storeid='" + storeid + "' and STATUS = '0' ");

		choice = new boolean[guwens.size()];
		int i = intent.getIntExtra("choice", -1);
		if(i != -1) {
			for (boolean b : choice) {
				b = false;
			}
			choice[i] = true;
		}

		lv_select_guwen.setAdapter(new GuWenAdapter(this, guwens));
		lv_select_guwen.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				for (int i = 0; i < choice.length; i++) {
					choice[i] = false;
				}
				choice[position] = true;

				Intent data = new Intent();
				data.putExtra("guwen", (Serializable) guwens.get(position));
				data.putExtra("choice", position);
				setResult(350, data);
				finish();
			}
		});

	}

	private class GuWenAdapter extends MyBaseAdapter<Czyda001Db, ListView> {

		public GuWenAdapter(Context context, List<Czyda001Db> product) {
			super(product, context);
		}

		@Override
		public View getView(final int position, View convertView, ViewGroup parent) {
			View view;
			if(convertView == null) {
				view = View.inflate(context, R.layout.store_list_item, null);
				TextView store_item_text = (TextView) view.findViewById(R.id.store_item_text);
				ImageView store_item_checked = (ImageView) view.findViewById(R.id.store_item_checked);
				store_item_text.setText(lists.get(position).getOpername());
				store_item_checked.setVisibility(choice[position] ? View.VISIBLE : View.GONE);
			}
			else {
				view = convertView;
			}
			return view;
		}
	}
}
