package com.urovo.activity.slidemenu;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wgmf.AsyncTask.QueryCuXiaoInfoTask;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.entity.response.CuXiaoItemNameResponse;
import com.urovo.wgmf.db.dao.entitys.CuXiaoItemInfoEntity;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HuoDongActivity extends BaseActivity {
	private ListView lv_huodong;
	private TextView tv_huodong_none;
	private List<CuXiaoItemInfoEntity> hdlist = new ArrayList<CuXiaoItemInfoEntity>();
	private HuodongAdapter adapter;
	private String storeId;
	private CuXiaoItemNameResponse cxinResponse;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.huodong);

		titleTextView = (TextView) findViewById(R.id.text_title);
		ImageButton goback = (ImageButton) findViewById(R.id.goback);

		titleTextView.setText("活动信息");
		goback.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finish();
			}
		});
		lv_huodong = (ListView) findViewById(R.id.lv_huodong);
		tv_huodong_none = (TextView) findViewById(R.id.tv_huodong_none);

		Intent intent = getIntent();
		storeId = intent.getStringExtra("storeId");
		Date date = new Date();
		String curDate = DateUtil.formatDate(date);
		new QueryCuXiaoInfoTask(HuoDongActivity.this, "正在查询活动信息", true, storeId + ";" + curDate + ";").execute("");
	}

	private class HuodongAdapter extends MyBaseAdapter<CuXiaoItemInfoEntity, ListView> {

		public HuodongAdapter(Context context, List<CuXiaoItemInfoEntity> detail) {
			super(detail, context);
		}

		@Override
		public View getView(final int position, View convertView, ViewGroup parent) {
			View view;
			final ViewHolder holder;
			if(convertView == null) {
				view = View.inflate(context, R.layout.listview_item_huodong, null);
				holder = new ViewHolder();
				holder.tv_huodong_name = (TextView) view.findViewById(R.id.tv_huodong_name);
				holder.tv_huodong_content = (TextView) view.findViewById(R.id.tv_huodong_content);

				view.setTag(holder);
			}
			else {
				view = convertView;
				holder = (ViewHolder) view.getTag();
			}

			String cxmode = lists.get(position).getDJCXType();
			String title = "";
			if("MZCX".equals(cxmode) || "MZCCXX".equals(cxmode)) {
				title = "买赠";
			}
			else
				if("MZHPZK_BL".equals(cxmode)) {
					title = "买减";
				}
				else
					if("MZHPZK_JE".equals(cxmode)) {
						title = "买折";
					}
					else
						if("ZLZK_BL".equals(cxmode)) {
							title = "满减";
						}
						else
							if("ZLZK_JE".equals(cxmode)) {
								title = "满折";
							}
							else
								if("ZLCX".equals(cxmode)) {
									title = "满赠";
								}
								else
									if("ZLCX_DHM".equals(cxmode)) {
										title = "验证码兑换活动";
									}

			holder.tv_huodong_name.setText(title);
			holder.tv_huodong_content.setText("时间：\n" + lists.get(position).getBeginDate() + "至" + lists.get(position).getEndDate() + "\n内容：\n" + lists.get(position).getDJCXInfo());
			return view;
		}
	}

	@Override
	public void displayResult(String tag, BaseResponse response) {
		super.displayResult(tag, response);
		cxinResponse = (CuXiaoItemNameResponse) response;
		hdlist = cxinResponse.getList();
		if(hdlist != null && hdlist.size() > 0) {
			tv_huodong_none.setVisibility(View.GONE);
			lv_huodong.setVisibility(View.VISIBLE);
			if(adapter == null) {
				adapter = new HuodongAdapter(HuoDongActivity.this, hdlist);
				lv_huodong.setAdapter(adapter);
			}
			else {
				adapter.notifyDataSetChanged();
			}
		}
		else {
			tv_huodong_none.setVisibility(View.VISIBLE);
			lv_huodong.setVisibility(View.GONE);
		}
	}

	static class ViewHolder {
		public TextView tv_huodong_name;
		public TextView tv_huodong_content;
	}
}
