package com.urovo.activity.slidemenu;

import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.wgmf.AsyncTask.BaseAppSalerServerTask;
import com.urovo.wgmf.AsyncTask.BaseAppServerTask;
import com.urovo.wgmf.entity.response.GuWenZhangHuResponse;
import com.urovo.wgmf.db.dao.entitys.GuWenZhangHuEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class JifenEWaiActivity extends BaseActivity {

	private ImageButton goback;
	private RelativeLayout layout_title;
	private TextView tv_jifen_zengsong;
	private TextView tv_jifen_yizengsong;
	private TextView tv_jifen_zengsong_shengyu;
	private TextView tv_jifen_zengsong_shoujihao;
	private Button btn_jifen_zengsong;

	private String huiyuan;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_jifenewai);

		titleTextView = (TextView) findViewById(R.id.text_title);
		goback = (ImageButton) findViewById(R.id.goback);
		layout_title = (RelativeLayout) findViewById(R.id.layout_title);

		huiyuan = getIntent().getStringExtra("huiyuan");

		btn_jifen_zengsong = (Button) findViewById(R.id.buttonZengSong);
		tv_jifen_zengsong = (TextView) findViewById(R.id.tv_jifen_zengsong);
		tv_jifen_yizengsong = (TextView) findViewById(R.id.tv_jifen_yizengsong);
		tv_jifen_zengsong_shengyu = (TextView) findViewById(R.id.tv_jifen_zengsong_shengyu);
		tv_jifen_zengsong_shoujihao = (TextView) findViewById(R.id.tv_jifen_zengsong_shoujihao);
		tv_jifen_zengsong_shoujihao.setText(huiyuan);
		btn_jifen_zengsong.setEnabled(false);

		titleTextView.setText("积分赠送");
		goback.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				finish();
			}
		});

		btn_jifen_zengsong.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				try {
					final int validPoint = Integer.parseInt(tv_jifen_zengsong_shengyu.getText().toString());
					if(validPoint > 0) {
						Builder builder = new Builder(JifenEWaiActivity.this);
						View content = LayoutInflater.from(JifenEWaiActivity.this).inflate(R.layout.jifenewai_dialog,null);
						final EditText et = (EditText)content.findViewById(R.id.jifen_input);
						TextView jifen = (TextView)content.findViewById(R.id.dialog_content);
						jifen.setText(jifen.getText().toString().replace("--",validPoint+""));//显示积分
						builder.setView(content);

						builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {

							@Override
							public void onClick(DialogInterface dialog, int which) {
								String code = et.getText().toString().trim();
								if(TextUtils.isEmpty(code)) {
									showMsg("您未输入任何有效积分");
								}
								else {
									try {
										int p = Integer.parseInt(code);
										if(p <= 0) {
											showMsg("您不可赠送负积分或零积分,请重新输入!");
										}
										else
											if(p > validPoint) {
												showMsg("您要赠送的积分大于剩余可送积分,请重新输入!");
											}
											else {
												SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
												Map<String, Object> param = new HashMap<String, Object>();
												param.put("mobile", "'" + huiyuan + "'");
												param.put("pts", p);
												param.put("opno", "'" + SystemHelper.LoginUserId + "'");
												param.put("storeid", "'" + SystemHelper.LoginOrganId + "'");
												param.put("ptsreson", "'1'");
												param.put("ptstime", "'" + sdf.format(new Date()) + "'");

												Map<String, String> param2 = new HashMap<String, String>();
												param2.put("content", param.toString());
												new BaseAppServerTask("zengsong_request", BaseOldResponse.class, JifenEWaiActivity.this, "正在查询可赠送积分...", true, "/user/adjustpts", param2).execute("");
											}
									}
									catch (Exception e) {
										showMsg("请输入有效积分额度！");
										BaseAppManager.loger().info(e);
									}

								}
							}
						});
						builder.setNegativeButton("取消", null).create().show();
					}
				}
				catch (Exception e) {
					showMsg("可赠送积分无效或不足！");
					BaseAppManager.loger().info(e);
				}

			}
		});
		request();
	}

	private void request() {
		Map<String, String> p = new HashMap<String, String>();
		Date date = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		p.put("userId", SystemHelper.LoginUserId);
		p.put("startTimeStr", sdf.format(date));
		p.put("endTimeStr", sdf.format(date));
		new BaseAppSalerServerTask("zengsong_query", GuWenZhangHuResponse.class, this, "正在查询可赠送积分...", true, "/information/getConsultantAcount", p).execute("");
	}

	@Override
	public void displayResult(String tag, BaseResponse response) {
		super.displayResult(tag, response);

		if("zengsong_query".equals(tag)) {
			GuWenZhangHuResponse res = (GuWenZhangHuResponse) response;
			List<GuWenZhangHuEntity> list = res.getList();
			if(null != list && list.size() > 0) {
				tv_jifen_zengsong.setText(list.get(0).validPoint);
				tv_jifen_yizengsong.setText(list.get(0).usedPoint);
				try {
					tv_jifen_zengsong_shengyu.setText("" + (Integer.parseInt(list.get(0).totalPoint) - Integer.parseInt(list.get(0).usedPoint)));
				}
				catch (Exception e) {
					tv_jifen_zengsong_shengyu.setText("--");
					BaseAppManager.loger().info(e);
				}
				int validPoint = Integer.parseInt(list.get(0).validPoint);
				if(validPoint > 0)
					btn_jifen_zengsong.setEnabled(true);
				else
					btn_jifen_zengsong.setEnabled(false);
			}
		}
		else
			if("zengsong_request".equals(tag)) {
				if("0".equals(response.ret)) {
					request();
				}
				showMsg(response.retInfo);
			}
	}

}
