package com.urovo.activity.slidemenu

import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.slidemenu.adapter.XiaoFeiDetailAdapter
import com.urovo.activity.slidemenu.presenter.XiaoFeiPresenter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.net.CommonController
import com.urovo.wugumofang.response.CommonEntity
import com.urovo.wugumofang.ui.ViewUtil
import kotlinx.android.synthetic.main.xiaofei_detail.*

/**
 * @author Sasuke on 2018/2/7.
 * 购买明细
 */
class XiaoFeiActivity : BaseActivity(), CommonController.XiaoFeiView {
    var mPre: XiaoFeiPresenter? = null
    var mMemberID: String? = null

    companion object{
        const val MEMBER_ID = "member_id"
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.xiaofei_detail)
        mPre = XiaoFeiPresenter(this)
        mPre?.start()

    }

    override fun init() {
        mMemberID = intent.getStringExtra(MEMBER_ID)
        initTitle()
        refreshLayout.setOnRefreshListener { mPre?.queryAllData(mMemberID) }
        refreshLayout.setOnLoadMoreListener {  mPre?.queryMoreData(mMemberID) }
        detailRv.apply {
            layoutManager = LinearLayoutManager(this@XiaoFeiActivity, RecyclerView.VERTICAL, false)
            adapter = XiaoFeiDetailAdapter(this@XiaoFeiActivity,mPre?.dataList)
        }
        mPre?.queryAllData(mMemberID)
    }

    override fun initTitle() {
        super.initTitle()
        titleTextView.setText("购买明细")
    }

    override fun refreshShow() {
        detailRv.adapter?.notifyDataSetChanged()
    }

    override fun showProgressBar(msg: String?) {
        if(detailRv.adapter?.itemCount != 0){//只有第一次进来数据为空时才显示
            ViewUtil.showProgress(this,"请稍等",msg)
        }
    }

    override fun refreshFinished() {
        ViewUtil.dismissProgress()
        refreshLayout.finishRefresh()
        refreshLayout.finishLoadMore()
    }

    /**
     * 请求返回数据为空的时候执行
     */
    override fun resetNoMoreData(pageNo: Int) {
        refreshLayout.resetNoMoreData()
        showMsg(if(pageNo == 1) "没有数据" else "没有更多数据")
    }

    override fun onResponseSuccess(resultInfo: CommonEntity<*>?) {
    }

    override fun onFailure(failInfo: String?) {
    }

}