package com.urovo.activity.slidemenu.adapter;

import android.content.Context;
import android.text.Html;
import android.text.TextUtils;
import android.view.View;
import android.widget.Toast;

import com.chad.library.adapter.base.BaseMultiItemQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.chad.library.adapter.base.entity.MultiItemEntity;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.urovo.activity.slidemenu.model.Level0Item;
import com.urovo.activity.slidemenu.model.Level1Item;
import com.urovo.activity.slidemenu.model.Level2Item;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.ApiUrls;

import java.text.MessageFormat;
import java.util.List;

/**
 * @author chenji
 * @date 2017/12/19
 */
public class ExpandableItemAdapter extends BaseMultiItemQuickAdapter<MultiItemEntity, BaseViewHolder> {
    public static final int TYPE_LEVEL_0 = 0;
    public static final int TYPE_LEVEL_1 = 1;
    public static final int TYPE_LEVEL_2 = 2;
    private Context mContext;

    /**
     * Same as QuickAdapter#QuickAdapter(Context,int) but with
     * some initialization data.
     *
     * @param data A new list is created out of this one to avoid mutable list
     */
    public ExpandableItemAdapter(Context context, List<MultiItemEntity> data) {
        super(data);
        this.mContext = context;
        addItemType(TYPE_LEVEL_0, R.layout.item_expandable_lv0);
        addItemType(TYPE_LEVEL_1, R.layout.item_expandable_lv1);
        addItemType(TYPE_LEVEL_2, R.layout.item_expandable_lv2);
    }

    @Override
    protected void convert(final BaseViewHolder holder, final MultiItemEntity item) {
        switch (holder.getItemViewType()) {
            case TYPE_LEVEL_0:
                final Level0Item lv0 = (Level0Item) item;
                holder.setText(R.id.tv_buy_time, Html.fromHtml("购买时间：<font color='#000000'>" + lv0.buyTime + "</font>"));
                holder.setText(R.id.tv_order_belong, Html.fromHtml("链接转发：<font color='#000000'>" + lv0.orderBelong + "</font>"+"\n（最终订单归属以BI数据为准）"));
//                holder.setText(R.id.tv_buy_time, Html.fromHtml("购买时间：<font color='#000000'><small>" + lv0.buyTime + "</small></font>"));
//                holder.setText(R.id.tv_order_belong, Html.fromHtml("订单归属：<font color='#000000'><small>" + lv0.orderBelong + "</small></font>"));

                holder.getView(R.id.ib_query_logistics).setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        if (!TextUtils.isEmpty(lv0.shipmentCode)) {
                            // 查看物流 跳转到指定页面
                            final String logisticsUrl = MessageFormat.format("{0}type={1}&postid={2}", ApiUrls.WeiXin.LOGISTICS_QUERY_URL, lv0.deliveryPartyName, lv0.shipmentCode);
//                        WebViewAct.launch(mContext, "物流详情", MessageFormat.format("{0}type={1}&postid={2}", ApiUrls.LogisticsQuery.LOGISTICS_QUERY_URL, lv0.deliveryPartyName, lv0.shipmentCode));
                            BaseCookiesWebFra.launch(mContext, logisticsUrl, "物流详情", true);
                            /*http://m.kuaidi100.com/index_all.html?type=${item4.deliveryPartyName}&postid=${item4.shipmentCode}*/
                        } else {
                            MyToast.show(mContext, "没有获取到当前订单的快递信息", Toast.LENGTH_SHORT);
                        }
                    }
                });
                break;

            case TYPE_LEVEL_1:
                final Level1Item lv1 = (Level1Item) item;
                holder.setText(R.id.tv_pro_name, lv1.proName)
                        .setText(R.id.tv_pro_num, "× " + lv1.proNum);
                break;

            case TYPE_LEVEL_2:
                final Level2Item lv2 = (Level2Item) item;
                holder.setText(R.id.tv_order_status, lv2.orderStatus);
                holder.setText(R.id.tv_order_number, Html.fromHtml("订单号：<font color='#8E8E8E'>" + lv2.orderNumber + "</font>"));
                break;
            default:
                break;
        }
    }
}
