package com.urovo.activity.slidemenu.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.SaleProductList;
import com.urovo.wgmf.db.dao.entitys.SalesDetialsEntity.ProductsreturnList;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.ViewHolder;

import java.util.ArrayList;
import java.util.List;

public class GouMaiJiLuAdapter extends BaseExpandableListAdapter {

    @SuppressWarnings("all")
    private boolean onlyShow = false;
    @SuppressWarnings("all")
    private boolean nativeUppoad = false;
    private List<ProductsreturnList> parentslist = new ArrayList<>();
    private List<SaleProductList> childrenlist = new ArrayList<>();
    private Context context;
    private int type;//1线下 2会员商品

    private OnItemViewListener listener;

    public interface OnItemViewListener {
        void onViewListener(int groupPosition, String consId);
    }

    public GouMaiJiLuAdapter(int type, OnItemViewListener listener, List<ProductsreturnList> parentslist, List<SaleProductList> childrenlist, Context cxt, boolean show, boolean nUpload) {
        this.type = type;
        this.listener = listener;
        this.parentslist = parentslist;
        this.childrenlist = childrenlist;
        onlyShow = show;
        nativeUppoad = nUpload;
        context = cxt;
    }

    @Override
    public void notifyDataSetInvalidated() {
        super.notifyDataSetInvalidated();
    }

    @Override
    public void notifyDataSetChanged() {
        super.notifyDataSetChanged();
    }

    public List<SaleProductList> getBackList() {
        return childrenlist;
    }

    @Override
    public int getGroupCount() {
        return parentslist.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        if (childrenlist == null) {
            return 0;
        } else {
            return childrenlist.size();
        }
    }

    @Override
    public Object getGroup(int groupPosition) {
        return parentslist.get(groupPosition);
    }

    @Override
    public Object getChild(int groupPosition, int childPosition) {
        return childrenlist.get(groupPosition);
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {

        ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.listview_item_goumaijilu_zu, null);
        }
        RelativeLayout buyLl = (RelativeLayout) convertView.findViewById(R.id.buy_ll);
        TextView name = (TextView) convertView.findViewById(R.id.textName);
        TextView store = (TextView) convertView.findViewById(R.id.store_name);
        TextView jine = (TextView) convertView.findViewById(R.id.textViewJinE);
        TextView time = (TextView) convertView.findViewById(R.id.textViewTime);
        TextView saler = (TextView) convertView.findViewById(R.id.saler_name);
        ImageView image = (ImageView) convertView.findViewById(R.id.imageViewUpload);
        ProductsreturnList ent = parentslist.get(groupPosition);
        store.setText("购买门店:" + ent.storeName);
        jine.setText("销售额:" + ent.consAmount);
        time.setText("销售日期:" + ent.saleDateStr.substring(0, 10));
        saler.setText("经办人:" + ent.salerName);
        if (isExpanded) {
            image.setImageResource(R.drawable.list_group_open);
        } else {
            image.setImageResource(R.drawable.list_group_close);
        }
        buyLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onViewListener(groupPosition, ent.consId);
            }
        });
        return convertView;
    }

    @Override
    public View getChildView(final int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.listview_item_goumaijilu_zi, null);
        }
        ImageView zengpin = (ImageView) convertView.findViewById(R.id.imageViewZengPin);
        TextView name = (TextView) convertView.findViewById(R.id.textViewName);
        TextView count = (TextView) convertView.findViewById(R.id.textViewCount);
        TextView price = (TextView) convertView.findViewById(R.id.textViewPrice);
        SaleProductList entsun = childrenlist.get(childPosition);
        //请求明细数据
        try {
            if (0 == Integer.parseInt(entsun.amount)) {
                zengpin.setVisibility(View.VISIBLE);
            } else {
                zengpin.setVisibility(View.INVISIBLE);
            }
        } catch (NumberFormatException e) {
            zengpin.setVisibility(View.INVISIBLE);
        }
        name.setText(entsun.productName + "(" + entsun.unitName + ")");
        count.setText(entsun.productNum);
        price.setText(entsun.amount);
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return true;
    }
}
