package com.urovo.activity.slidemenu.adapter

import android.content.Context
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.ListView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.wgmf.adapter.MyBaseAdapter
import com.urovo.wgmf.db.dao.entitys.XiaoFeiRes
import com.urovo.wugumofang.R

/**
 * @author Sasuke on 2018/2/7.
 */
class XiaoFeiDetailAdapter(
    val context: Context,
    val dataList: MutableList<XiaoFeiRes.ResultInfo>?
) : RecyclerView.Adapter<ViewHolderXiaoFei>() {
    override fun onBindViewHolder(holder: ViewHolderXiaoFei, position: Int) {
        holder.apply {
            val cell = dataList?.get(position)

            tv_xiaofei_date.setText(cell?.saleDate)// 销售时间
            saler_name_layout.visibility =
                if (cell?.salerName.isNullOrEmpty()) View.GONE else View.VISIBLE
            // 销售员（如果这个字段为空，说明是“会员商城订单”，在门店字段会显示为“会员商城订单”，销售员则隐藏）
            cell?.salerName?.let { tv_xiaofei_saler.text = it }
            tv_xiaofei_store_name.text = cell?.storeName//门店（如果salerName为空，那这个字段约定会传一个“会员商城订单”）
            tv_xiaofei_money.setText(cell?.saleAmount)// 金额
            tv_xiaofei_type.text = "消费"
            tv_xiaofei_type.setTextColor(Color.rgb(54, 183, 9))// 消费
            if (java.lang.Double.parseDouble(cell?.saleAmount) < 0) {
                tv_xiaofei_type.setTextColor(Color.rgb(255, 84, 0))// 退货
                tv_xiaofei_type.text = "退货"
            }
            activitySignal.text = if (cell?.isActOrder == 0) "" else "活动订单，活动ID：${cell?.actId}"

            lv_pro_detail.adapter = XiaoFeiProAdapter(context, cell?.saleProductList)
//            if (null != cell?.saleProductList && cell?.saleProductList.size > 0) {
//                val count = cell?.saleProductList.size
//                val dm = context.getResources().getDisplayMetrics()
//                lv_pro_detail.layoutParams.height = (count.toFloat() * 35f * dm.density).toInt()
//            } else {
            lv_pro_detail.layoutParams.height = ViewGroup.LayoutParams.WRAP_CONTENT
//            }
        }
    }

    override fun getItemCount(): Int {
        return if (dataList == null) 0 else dataList.size
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolderXiaoFei {
        return ViewHolderXiaoFei(
            LayoutInflater.from(context)
                .inflate(R.layout.listview_item_xiaofei_detail, parent, false)
        )
    }
}

class ViewHolderXiaoFei(view: View) : RecyclerView.ViewHolder(view) {
    var tv_xiaofei_date: TextView
    var tv_xiaofei_saler: TextView
    var tv_xiaofei_type: TextView
    var tv_xiaofei_money: TextView
    var tv_xiaofei_store_name: TextView
    var saler_name_layout: LinearLayout
    var lv_pro_detail: ListView
    var activitySignal: TextView


    init {
        tv_xiaofei_date = view.findViewById(R.id.tv_xiaofei_date) as TextView
        tv_xiaofei_saler = view.findViewById(R.id.tv_xiaofei_saler) as TextView
        tv_xiaofei_type = view.findViewById(R.id.tv_xiaofei_type) as TextView
        tv_xiaofei_money = view.findViewById(R.id.tv_xiaofei_money) as TextView
        tv_xiaofei_store_name = view.findViewById(R.id.tv_xiaofei_store_name) as TextView
        saler_name_layout = view.findViewById(R.id.saler_name_layout) as LinearLayout
        lv_pro_detail = view.findViewById(R.id.lv_pro_detail) as ListView
        activitySignal = view.findViewById(R.id.activitySignal) as TextView
    }
}

private class XiaoFeiProAdapter(
    context: Context,
    product: List<XiaoFeiRes.ResultInfo.SaleProductList>?
) : MyBaseAdapter<XiaoFeiRes.ResultInfo.SaleProductList, ListView>(product, context) {

    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {
        var convertView = convertView
        if (convertView == null) {
            convertView =
                View.inflate(context, R.layout.listview_item_xiaofei_detail_item_pro, null)
        }
        val cell = lists[position]
        convertView?.let {
            it.findViewById<TextView>(R.id.tv_item_product_name).text = cell.productName// 商品名称
            it.findViewById<TextView>(R.id.tv_item_product_count).text = "x"+cell.productNum// 数量
            it.findViewById<TextView>(R.id.tv_item_product_price).text = cell.amount// 金额

            it.findViewById<TextView>(R.id.tv_item_giveaway).visibility=if (cell.isgift == "1") View.VISIBLE else View.GONE
        }
        return convertView!!
    }
}