package com.urovo.activity.slidemenu.presenter

import com.urovo.wgmf.db.dao.entitys.XiaoFeiRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.CommonController
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.CommonEntity
import okhttp3.Request

/**
 * @author Sasuke on 2018/2/7.
 */
class XiaoFeiPresenter(val mView: CommonController.XiaoFeiView): CommonController.XiaoFeiPre {
    val dataList: MutableList<XiaoFeiRes.ResultInfo> = mutableListOf()
    var pageNo: Int = 1//页码,从1开始
    val pageSize = 10//页容量

    fun start(){
        mView.init()
    }

    /**
     * 下拉全局刷新
     */
    fun queryAllData(mobile: String?){
        pageNo = 1
        queryMoreData(mobile)
    }

    /**
     * 上拉加载更多
     */
    fun queryMoreData(mobile: String?){
        val param = hashMapOf("mobile" to (mobile ?: ""),
                                                "pageNo" to pageNo.toString(),
                                                "pageSize" to pageSize.toString())
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.CUS_SALE_DETAIL,param,
                object : OkHttpDominator.ResultCallback<XiaoFeiRes>() {
                    override fun onError(request: Request?, e: Exception?) {
                        mView.refreshFinished()
                        mView.showMsg(e.toString())
                    }

                    override fun onResponse(res: XiaoFeiRes?) {
                        mView.refreshFinished()
                        if (res != null && res.resultInfo != null) {
                            if (pageNo == 1) {//如果是全局刷新
                                dataList.clear()
                            }
                            dataList.addAll(res.resultInfo)
                            mView.refreshShow()
                            //如果没有数据，就提示，并且不要再让pageNo自增了
                            if(res.resultInfo.size == 0){
                                mView.resetNoMoreData(pageNo)
                                return
                            }
                            pageNo++
                        }
                    }
                }
        )
    }



    override fun onStart2requestData(params: MutableMap<Any?, Any?>?) {
    }

    override fun onResponseSuccess(resultInfo: CommonEntity<*>?) {
    }

    override fun onFailure(failInfo: String?) {
    }
}