package com.urovo.activity.slidemenu.response

import com.urovo.activity.slidemenu.SlideMenuApi
import com.urovo.activity.slidemenu.model.FreeDeliveryQueryBean
import com.urovo.activity.slidemenu.presenter.contract.FreeDeliveryQueryContract
import com.urovo.wugumofang.net.RetrofitHelper
import com.urovo.wugumofang.view.LoadWaitDominator
import com.zsy.libcore.model.bean.RequestResult
import com.zsy.libcore.model.bean.ResultCallback
import retrofit2.Call

/**
 * 免费送直接兑换记录查询数据仓库
 * @author LW
 */
class FreeDeliveryQueryResponse(
    private val view: FreeDeliveryQueryContract.View?,
    private val api: SlideMenuApi = RetrofitHelper.createApi(SlideMenuApi::class.java)
) {

    /**
     * 请求网络获取免费送直接兑换记录查询数据
     */
    fun requestActivityExchageDetail(mobile: String) {
        view?.showIsLoading()
        api.getActivityExchageDetail(mobile)
            .enqueue(object : ResultCallback<List<FreeDeliveryQueryBean>>() {

                override fun onResponseSuccess(responseBody: RequestResult<List<FreeDeliveryQueryBean>>?) {
                    super.onResponseSuccess(responseBody)
                    view?.dismissLoading()
                    responseBody?.resultInfo?.let {
                        if (it.isNotEmpty()) {
                            view?.onResponseSuccess(it)
                        } else {
                            view?.showState(LoadWaitDominator.NO_DATA)
                        }
                    }
                }

                override fun onFailure(
                    call: Call<RequestResult<List<FreeDeliveryQueryBean>>>,
                    t: Throwable
                ) {
                    super.onFailure(call, t)
                    t.message?.let {
                        view?.onFailure(it)
                        view?.showError(it)
                    }
                }
            })

    }
}