package com.urovo.activity.slidemenu.response

import com.urovo.activity.slidemenu.SlideMenuApi
import com.urovo.activity.slidemenu.presenter.contract.UploadShoppingReceiptContract
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wugumofang.R
import com.urovo.wugumofang.net.RetrofitHelper
import com.zsy.libcore.model.bean.RequestResult
import retrofit2.Call

/**
 * 免费送直接兑换记录查询数据仓库
 * @author LW
 */
class UploadShoppingReceiptResponse(
    private val view: UploadShoppingReceiptContract.IView?,
    private val api: SlideMenuApi = RetrofitHelper.createApi(SlideMenuApi::class.java)
) {
    /**
     * 上传图片
     */
    fun requestSubmitPhotosToQinIu(photoPaths: MutableList<String>) {
        view?.submitPhotosLoading()

        QiNiuDominator.uploadImages(
            photoPaths,
            { qiniuUrl ->
                var packUrls = ""
                qiniuUrl.forEach { packUrls += "${it}," }
                if (packUrls.isNotEmpty()) packUrls = packUrls.substring(0, packUrls.length - 1)
                view?.submitPhotosSuccess(packUrls)
            },
            { str ->
                view?.showToast(str)
                view?.submitPhotosFailed(str)
            }, false
        )
    }

    /**
     * 提交小票
     * @param shopId shopId
     * @param mobile  手机号
     * @param staffId  staffId
     * @param certificateUrl 图片
     */
    fun requestUploadCertificate(
        shopId: String?,
        mobile: String?,
        staffId: String?,
        certificateUrl: String?
    ): Call<RequestResult<Any>> {
        return api.uploadCertificate(shopId, mobile, staffId, certificateUrl)
    }
}