package com.urovo.activity.slidemenu.ui

import android.content.Context
import android.content.Intent
import com.urovo.activity.slidemenu.model.VoucherCardQrCodeBean
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import com.wgmf.trade.utils.ImageLoader
import kotlinx.android.synthetic.main.act_voucher_card_qr_code.*
import okhttp3.MediaType
import okhttp3.Request
import org.json.JSONObject

/**
 * 权益卡二维码
 * @author LW
 */
class VoucherCardQrCodeActivity : BaseActivity() {

    override fun addRootLayoutId(): Int = R.layout.act_voucher_card_qr_code

    companion object {
        @JvmStatic
        fun launch(context: Context, phoneNumber: String) {
            context.startActivity(Intent(context, VoucherCardQrCodeActivity::class.java).apply {
                putExtra(AppConstants.ExtraKeys.PHONE_NUM, phoneNumber)
            })
        }
    }

    private val mPhone: String by lazy {
        intent.getStringExtra(AppConstants.ExtraKeys.PHONE_NUM)
    }

    override fun initTitle() {
        super.initTitle()
        titleTextView.text = getString(R.string.voucher_card_title)
    }

    override fun initViewNew() {
        initTitle()
    }

    override fun initDataNew() {
        requestQrcodeData()
    }

    /**
     * 请求权益卡二维码
     */
    private fun requestQrcodeData() {
        val value = JSONObject(
            mapOf(
                "mobile" to mPhone
            )
        )
        OkHttpDominator.postAsynByType(
            NetParam.YINXIAOBU_API_SERVER + ApiUrls.SYGJ.VOUCHERCARD_OFFLINE_PURCHASE_QRCODE,
            MediaType.parse("application/json; charset=utf-8"),

            mapOf(
                "key" to value.toString()
            ), object : OkHttpDominator.ResultCallback<VoucherCardQrCodeBean>() {

                override fun onError(request: Request?, error: Exception?) {
                    showToast(error?.message)
                    mQrCodeIv.setImageResource(R.mipmap.icon_prompt_1)
                }

                override fun onResponse(response: VoucherCardQrCodeBean?) {
                    if (isFinishing) return
                    response?.let {
                        if (it.code == AppConstants.Http.RESPONSE_SUCCESS) {
                            ImageLoader.loadImg(
                                mContext, it.payload, mQrCodeIv,
                                R.drawable.progress_animation_small, R.mipmap.icon_prompt_1
                            )
                        } else {
                            mQrCodeIv.setImageResource(R.mipmap.icon_prompt_1)
                            showToast(it.message)
                        }
                    }
                }
            })
    }
}