package com.urovo.activity.slidemenu.ui

import com.urovo.activity.slidemenu.presenter.UploadShoppingReceiptPresenter
import com.urovo.activity.slidemenu.presenter.contract.UploadShoppingReceiptContract
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.base.BasePresenter
import com.urovo.wugumofang.constants.AppConstants
import kotlinx.android.synthetic.main.act_voucher_card_sales.*

/**
 * 权益卡销售
 * @author LW
 */
class VoucherCardSalesActivity : BaseActivity(), UploadShoppingReceiptContract.IView {

    private var mUploadShoppingReceiptPresenter: UploadShoppingReceiptPresenter? = null

    override fun addRootLayoutId(): Int = R.layout.act_voucher_card_sales

    private val mPhone: String by lazy {
        intent.getStringExtra(AppConstants.ExtraKeys.PHONE_NUM)
    }

    private val mConfirmContent: String by lazy {
        intent.getStringExtra(AppConstants.ExtraKeys.CONFIRM_CONTENT)
    }

    override fun initTitle() {
        super.initTitle()
        titleTextView.text = getString(R.string.voucher_card_title)
    }

    override fun initViewNew() {
        initTitle()
        mContentTv.text = mConfirmContent

        mNextBtn.setOnClickListener {
            mUploadShoppingReceiptPresenter?.apply {
                requestUploadCertificate(mPhone)
            }
        }

    }

    override fun addPresenter(): BasePresenter {
        mUploadShoppingReceiptPresenter = UploadShoppingReceiptPresenter(this)
        return mUploadShoppingReceiptPresenter!!
    }

    override fun submitPhotosLoading() {

    }

    override fun submitPhotosSuccess(photos: String) {
    }

    override fun submitPhotosFailed(error: String) {
    }

    override fun submitionStatus(isSuccess: Boolean) {
        if (isSuccess) {
            VoucherCardQrCodeActivity.launch(mContext, mPhone)
            finish()
        }
    }
}