package com.urovo.activity.tabMenu.home

import android.app.Activity
import android.app.ActivityManager
import android.app.AlertDialog
import android.app.Dialog
import android.content.Context
import android.content.Intent
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.graphics.Color
import android.graphics.drawable.BitmapDrawable
import android.net.Uri
import android.os.Bundle
import android.provider.MediaStore
import android.text.Html
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager.widget.ViewPager
import com.chad.library.adapter.base.BaseQuickAdapter
import com.urovo.activity.home.SearchMemberActivity
import com.urovo.activity.memorderact.view.MemOrderAct
import com.urovo.activity.salesmanager.storeManagerCancel
import com.urovo.activity.tabMenu.home.act.ShortcutMenuAct
import com.urovo.activity.tabMenu.home.ada.MultipleItemAdapter
import com.urovo.activity.tabMenu.home.ent.*
import com.urovo.activity.tabMenu.home.pre.HomeContract
import com.urovo.activity.tabMenu.home.pre.HomePre
import com.urovo.activity.tabMenu.home.utils.ACache
import com.urovo.activity.tabMenu.home.utils.GlideImageLoader
import com.urovo.activity.tabMenu.home.utils.RxDisposeManager
import com.urovo.activity.zhuanshu.QrCodeDominator
import com.urovo.wgmf.PosBaseActivity
import com.urovo.wgmf.adapter.MyPagerAdapter
import com.urovo.wgmf.db.dao.dao.Czyda001DbOperate
import com.urovo.wgmf.db.dao.dao.PrivilegeDbOperate
import com.urovo.wgmf.db.dao.dao.Store001DbOprate
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wgmf.zxing.CaptureActivity
import com.urovo.wgmf.zxing.Preferences
import com.urovo.wugumofang.R
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.data.FileCache
import com.urovo.wugumofang.data.PreferHelper
import com.urovo.wugumofang.manager.ThreadManager
import com.urovo.wugumofang.net.CommonController
import com.urovo.wugumofang.response.CommonEntity
import com.urovo.wugumofang.system.*
import com.urovo.wugumofang.ui.DialogHelper
import com.urovo.wugumofang.ui.PictureUtil
import com.urovo.wugumofang.utils.CommonTools
import com.urovo.wugumofang.utils.FuckGoogleAdaptUtil
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.utils.isNotNullOrSize
import com.urovo.wugumofang.view.CustomPopupWindow
import com.urovo.wugumofang.view.LoadWaitDominator
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra
import com.wgmf.trade.utils.ImageLoader
import com.youth.banner.Banner
import com.zsy.libcore.common.android.log.SYLoger
import com.zsy.libcore.ui.act.SYActManager
import kotlinx.android.synthetic.main.home2.*
import kotlinx.android.synthetic.main.home_sale_rate_ll2.*
import kotlinx.android.synthetic.main.toolbar_head.*
import kotlinx.android.synthetic.main.toolbar_search2.*
import kotlinx.android.synthetic.main.toolbar_search_layout.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import org.jetbrains.anko.find
import java.io.File
import java.util.*

/**
 * @author Sasuke on 2019-02-25 0025.
 */

class HomeActivity : PosBaseActivity(), HomeContract.homeView,
    CommonController.BaseView<HomeCarouselEntity> {
    companion object {
        const val NOTUPLOAD = 0

        /**sd路径*/
        private val path = Files.photoPath

        /**临时保存图片的文件夹*/
        private val tempPath = Files.tempPicture
    }

    private var mDialog: Dialog? = null
    var mPre: HomePre? = null
    private var isPaused = false

    // 头像Bitmap
    private var head: Bitmap? = null
    var mLocationTool: LocationTool? = null

    //中间那个可以左右滑动的表（接口就是这么命名的，懒得想了）
    var data1Pager: View? = null
    var table1: RecyclerView? = null
    var table2Parent: LinearLayout? = null

    var data2Pager: View? = null
    var pagerList = mutableListOf<View>()
    var loadWait: LoadWaitDominator? = null//表1的
    var loadWait2: LoadWaitDominator? = null//表2的
    private var isRefreshMemGoodsCount = false//是否刷新会员商品未完成订单数


    //企业二维码弹窗
    val codePop: CustomPopupWindow by lazy {
        CustomPopupWindow.Builder(this)
            .setContentView(R.layout.home_code_pop_layout)
            .setFouse(true)
            .setOutSideCancel(false)
//                .setAnimationStyle(R.style.dropmenu_anim_style)
            .setBackgroundDrawable(BitmapDrawable())
            .setwidth(ViewGroup.LayoutParams.MATCH_PARENT)
            .setheight(ViewGroup.LayoutParams.MATCH_PARENT)
            .builder()
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.home2)
        HomePre(this).start()
    }

    override fun init() {
        if (!EventBus.getDefault().isRegistered(this)) {
            EventBus.getDefault().register(this)
        }
        initPrivilege2VisibilityOrGone()//权限控制
        showBanner(listOf())//先加载个空List进去 ，使显示点位符
        setListeners()
        initBasicData()//从数据库查询基本姓名店名信息
        initRecyle()//自定义目录
        initTables()//滑动表格
        refresh()//请求一大堆接口

        //加载首页嵌套H5，并监听加载完成时计算内容高度
//        stableWebView.setWebChromeClient(object : WebChromeClient() {
//            override fun onProgressChanged(view: WebView, progress: Int) {
//                if (progress == 100) {
//                    stableWebView.visibility = View.VISIBLE
//                    stableWebView.measure(0, 0)
//                    val measuredHeight = stableWebView.measuredHeight
//                    stableWebView.layoutParams = stableWebView.layoutParams.apply { height = stableWebView.measuredHeight }
//                }
//            }
//        })
//        stableWebView.loadMessageUrl("https://akiba-souken.com", SystemHelper.LoginUserId)

    }

    /**
     * 挂各种监听器
     */
    fun setListeners() {
        //会员商品未完成订单入口
        memOrderCountLayout.setOnClickListener {
            isRefreshMemGoodsCount = true//使返回之后重新刷新订单数
            startActivity(Intent(this@HomeActivity, MemOrderAct::class.java))
        }

        //扫描按钮
        arrayOf(imageViewMessage, imageViewMessage1).forEach {
            it.setOnClickListener {
                mPre?.preScan()
                //默认是兼容各种码模式，这里设置只支持条形一维码
                start2Scan()
            }
        }

        //营养顾问企业微信二维码
//        userQrCodeBtn.setOnClickListener {
//            codePop.showAtLocation(swipe_refresh, Gravity.CENTER, 0, 0)
//            codePop.getItemView(R.id.dismissBtn).setOnClickListener { codePop.dismiss() }
//            //保存到相册
//            codePop.getItemView(R.id.buttonSave).setOnClickListener {
//                QrCodeDominator.saveQrCode(this@HomeActivity, Files.tempPicture, SystemHelper.LoginUserId + "_" + "workWX.jpg")
//            }
//            //打印二维码
//            codePop.getItemView(R.id.buttonPrint).setOnClickListener {
//                QrCodeDominator.qrCodePrint(this@HomeActivity,
//                        Files.tempPicture,
//                        SystemHelper.LoginUserId + "_" + "workWX.bmp",
//                        SystemHelper.LoginUserName,
//                        "企业微信专属二维码")
//            }
//
//            mPre?.getUserQrCode(SystemHelper.LoginUserId)
//        }

        //录单搜索栏
        arrayOf(our_catalogue_toSearch2, our_catalogue_toSearch1).forEach {
            it.setOnClickListener {
                isRefreshMemGoodsCount = true//使返回之后重新刷新订单数
                ToActivity.toActivity(this@HomeActivity, SearchMemberActivity::class.java)
            }
        }
        //头像
        rl_head_info.visibility = View.VISIBLE
        //设置头像
        member_icon_iv.setOnClickListener {
            setHeadPicture()
        }
        //下拉刷新
        swipe_refresh.setOnRefreshListener { refresh() }

        //退货按钮点击
        findViewById<LinearLayout>(R.id.toolbar_search).find<Button>(R.id.refresh_btn)
            .setOnClickListener {
                ToActivity.toActivity(
                    this@HomeActivity,
                    storeManagerCancel::class.java
                )
            }
        findViewById<LinearLayout>(R.id.toolbar_search2).find<Button>(R.id.refresh_btn2)
            .setOnClickListener {
                ToActivity.toActivity(
                    this@HomeActivity,
                    storeManagerCancel::class.java
                )
            }
        toolbar_search.alpha = 0f

        //解决：先将ScrollView 向上滑动一部分,然后松手.然后再向下滑动,此时应该是先触发滑动事件,
        // 当ScrollView到顶部以后才触发刷新时间.但是此时会出现先触发swipeRefreshLayout的问题。
        swipe_refresh.viewTreeObserver.addOnScrollChangedListener {
            swipe_refresh.isEnabled = scrollView.scrollY == 0//下拉刷新，避免跟NestedScrollView滑动冲突
            imageViewMessage1.isClickable = scrollView.scrollY != 0//上层扫描按钮
            our_catalogue_toSearch1.isClickable = scrollView.scrollY != 0//上层录单入口按钮
            refresh_btn.isClickable = scrollView.scrollY != 0//上层退货按钮
        }
    }

    /**
     * 请求营养顾问企业微信二维码后的回调
     */
    override fun showQrCodePop(url: String) {
        if (url.startsWith("http")) {//如果获取成功
            codePop.getItemView(R.id.qrCodeImage).visibility = View.VISIBLE
            codePop.getItemView(R.id.alertMsgTv).visibility = View.GONE
            (codePop.getItemView(R.id.qrCodeImage) as ImageView).setImageResource(R.drawable.progress_animation_small)

            QrCodeDominator.qrCodeShowAndSave(
                this@HomeActivity,
                url,
                Files.tempPicture,
                SystemHelper.LoginUserId + "_" + "workWX.jpg",
                codePop.getItemView(R.id.qrCodeImage) as ImageView
            )
//            Picasso.with(this@HomeActivity).load(url)
//                    .placeholder(R.drawable.progress_animation_small)
//                    .into(codePop.getItemView(R.id.qrCodeImage) as ImageView)
        } else {//如果获取失败
            codePop.getItemView(R.id.qrCodeImage).visibility = View.GONE
            codePop.getItemView(R.id.alertMsgTv).visibility = View.VISIBLE
            (codePop.getItemView(R.id.alertMsgTv) as TextView).text = url
        }

    }

    /**
     * 刷新两个接口
     */
    private fun refresh() {
        //头像请求
        mPre?.getUserPic(SystemHelper.LoginUserId)
        //旋转木马(轮播图)
        mPre?.start2HomeCarouselTask()
        // 菜单离线文件
        mPre?.loadDataFromOffline()
        mPre?.start2HomeMenuTask()
        //广告位
        mPre?.onStart2requestData4Ad()
        //表格1查询
        mPre?.queryTable1(SystemHelper.LoginOrganId, mPre?.table1Type ?: 0)
        //查询有多少个未完成的会员商品订单数。
        mPre?.queryMemOrderCount()

        //表格2查询（如果表2父容器为空，并且当前viewpager处在表2，才请求）
        if (table2Parent?.childCount == 0 && (viewpager.adapter as MyPagerAdapter).primaryItem == data2Pager) {
            mPre?.queryTable2(SystemHelper.LoginOrganId, SystemHelper.LoginUserId)
        }
        //上传地理位置
        mLocationTool = LocationTool(
            this,
            LocationTool.OnCallback { longitude, latitude, address, code, error ->
                if (!TextUtils.isEmpty(address)) {
                    mPre?.uploadLocation(mLocationTool)
                }
            })
    }

    //=================广告位返回=================
    override fun onResponseSuccess4Ad(resultInfo: CommonEntity<List<HomeAdEntity>>) {
        swipe_refresh?.isRefreshing = false
        val mPicUrls = resultInfo.entity.map { it.androidImgUrl }
        showBanner(mPicUrls)
    }

    /**
     *  初始化广告位
     */
    fun showBanner(mPicUrls: List<String>) {
        if (isFinishing) return
        homeAdLayout.find<Banner>(R.id.home_item_ad)
            .setImages(if (mPicUrls.isEmpty()) mutableListOf(R.drawable.banner_0_default) else mPicUrls)
            .setDelayTime(5000)
            .setImageLoader(GlideImageLoader())
            .setOnBannerListener { position -> mPre?.onBannerClick(position) }
            .start()
    }

    override fun onFailure4Ad(failInfo: String) {
        swipe_refresh?.isRefreshing = false
    }

    //首页菜单请求返回错误
    override fun onFailure4Menu(failInfo: String?) {
        //BaseAppManager.loger().error(failInfo)
        mPre?.let { it.saveListData(it.menuEntity, false) }

        //启动入口,去组装成菜单item,返回一个集合mMenuList
        mPre?.lodeMineChannelsRequest(1)
        //把旋转木马和菜单的集合再次组装成一套
        //mTotalList = getTotalList(mHomeCarouselEntity, mMenuList, mHomeAdEntity)

        swipe_refresh?.isRefreshing = false
        multipleItemAdapter?.notifyDataSetChanged()
    }

    //首页菜单请求返回
    override fun onResponseSuccess4Menu(resultInfo: CommonEntity<List<List<HomeMenuOnlineBean.ResultInfoBean>>>?) {
        //每次在线拿到数据后清空ACache的本地缓存,保证在线请求拿到的都是最新的数据.
        ACache.get(BaseAppManager.appContext()).remove(AppConstants.Home.CHANNEL_MINE)
        ACache.get(BaseAppManager.appContext()).remove(AppConstants.Home.CHANNEL_MORE)

        if (resultInfo?.entity.isNotNullOrSize()) {
            PreferHelper.getInstance().remove(AppConstants.Home.ONLINE_MINE)
            PreferHelper.getInstance().remove(AppConstants.Home.ONLINE_MORE)
            PreferHelper.getInstance().remove(AppConstants.Home.IS_SAVE_DATA)

            if (mPre?.menuEntity.isNotNullOrSize()) {
                mPre?.menuEntity?.clear()
            }
            mPre?.menuEntity?.addAll(resultInfo?.entity!!)
            mPre?.let { it.saveListData(it.menuEntity, true) }
        } else {
            //离线
            mPre?.loadDataFromOffline()
        }

        //启动入口,去组装成菜单item,返回一个集合mMenuList
        mPre?.lodeMineChannelsRequest(1)
        //把旋转木马和菜单的集合再次组装成一套
        //mTotalList = getTotalList(mHomeCarouselEntity, mMenuList, mHomeAdEntity)
        swipe_refresh?.isRefreshing = false
        multipleItemAdapter?.notifyDataSetChanged()
    }

    override fun returnCurrentFunctionList(data: List<MultipleItem<*>>) {
        if (isFinishing) return
        mPre?.mMenuList?.clear()
        data.let { mPre?.mMenuList?.addAll(it) }
        //mTotalList = getTotalList(mHomeCarouselEntity, mMenuList, mHomeAdEntity)
        mPre?.mMenuList?.add(
            MultipleItem<Any>(
                MultipleItem.IMAGE_TEXT_CUSTOM,
                1,
                "自定义",
                R.mipmap.btn_home_user_defined
            )
        )
        multipleItemAdapter?.notifyDataSetChanged()
    }

    /**
    //     * 自定义按钮-->添加跳转到快捷菜单的界面
    //     */
//    private fun addAllChannel() {
//        mPre?.mMenuList?.add(MultipleItem(MultipleItem.IMAGE_TEXT_CUSTOM, 1, "自定义", R.mipmap.btn_home_user_defined))
////        if (mTotalList != null) {
////            val entity = MultipleItem(MultipleItem.IMAGE_TEXT_CUSTOM, 1, "自定义", R.mipmap.btn_home_user_defined)
////            mTotalList.add(entity)
////        }
//    }


    /**
     * 超时处理刷新状态
     *
     * @param delayTime
     */
    override fun refreshPostDelayed(delayTime: Long) {
        CommonTools.postDelayed(delayTime, Runnable {
            //            if (multipleItemAdapter != null) {
//                multipleItemAdapter.setEnableLoadMore(true)
//            }
            swipe_refresh?.isRefreshing = false
        })
    }

    /**
     * 从数据库查询基本姓名店名信息
     */
    fun initBasicData() {
        var name = Czyda001DbOperate.GetOperateName(SystemHelper.LoginUserId)
        if ("未知" == name) {
            mDialog = DialogHelper.AlertNotCanceable(this, "提示", "门店数据异常，需重新登录", null
            ) { dialog, which ->
                //要杀掉第二进程
                (getSystemService(Context.ACTIVITY_SERVICE) as ActivityManager).killBackgroundProcesses(
                    BasePackageUtil.getAppPackageName(this)
                )
                SYActManager.getInstance().AppExit()
            }
            return
        }
        if (TextUtils.isEmpty(name)) {
            name = "--"
        }
        ll_guwen.visibility = View.VISIBLE
        tv_name.text = name
        var store = Store001DbOprate.GetStoreName(SystemHelper.LoginOrganId)
        if (TextUtils.isEmpty(store)) {
            store = "--"
        }
        tv_store.text = store
    }

    /**
     * 整个页面没有权限时显示的布局
     */
    private fun initPrivilege2VisibilityOrGone() {
        if (!PrivilegeDbOperate.checkUserPrivilege(AppConstants.Home.HOME)) {
            swipe_refresh.isEnabled = false
            empty_root.visibility = View.VISIBLE
            empty_root.find<TextView>(R.id.empty_view).text = "暂无使用权限!"
        }
    }

    /**
     * 设置头像
     */
    fun setHeadPicture() {
        val items = arrayOf<CharSequence>("拍照", "从相册选取", "取消")
        val builder = AlertDialog.Builder(this@HomeActivity)
        builder.setTitle("更换头像").setItems(items) { dialog, item ->
            when (item) {
                // 调用相机拍照
                0 -> {
                    val intent1 = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                    val file = File(tempPath, SystemHelper.LoginUserId + ".jpg")
                    var uri =
                        FuckGoogleAdaptUtil.android7AdaptUri(this, Files.fileProviderAuth, file)
                    intent1.putExtra(MediaStore.EXTRA_OUTPUT, uri)
                    intent1.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                    intent1.addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)
                    startActivityForResult(intent1, 1)// 采用ForResult打开
                }
                // 从相册里面取照片
                1 -> {
                    val intent2 = Intent(Intent.ACTION_PICK, null)
                    intent2.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, "image/*")
                    intent2.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                    intent2.addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)
                    startActivityForResult(intent2, 2)
                }
                else -> {
                }
            }
        }
        val alert = builder.create()
        alert.show()
    }

    /**
     * 显示会员商品未完成订单入口&&订单数
     */
    override fun showMemGoodsOrderEntry(count: Int) {
        memOrderCountLayout?.visibility = if (count == 0) View.GONE else View.VISIBLE
        memOrderCount?.text = "${count}单"
    }

    override fun setPresenter(presenter: HomeContract.homePre?) {
        this.mPre = presenter as HomePre
    }

    private fun start2Scan() {
        PreferHelper.getInstance().run {
            //            setBoolean(Preferences.KEY_DECODE_1D, true)//不要单独设置，如果不设置，就会默认支持所有码的类型。你设成1维码了，那二维码就扫不了了。
//            setString(Preferences.SCAN_TOP, "将当前顾客购买的全部产品扫描完成后，点击完成")
            setString(
                Preferences.SCAN_TOP, "1.散装条码扫描时，将当前顾客购买的全部产品扫描完成后，点击右上角“完成”按钮；\n" +
                        "2.公众号线下活动核销时，扫描二维码后会自动进行识别；"
            )
            setString(Preferences.SCAN_BOTTOM, "将二维码/条码放入框内，即可自动扫描")
            setBoolean(Preferences.IS_CLOSE_PAGE, false)
        }
        startActivityForResult(Intent(this, CaptureActivity::class.java), 2018)
    }

    override fun onDestroy() {
        mDialog?.dismiss()
        RxDisposeManager.get().cancel("newschannel")
        EventBus.getDefault().unregister(this)
        super.onDestroy()
    }

    override fun onPause() {
        super.onPause()
        isPaused = true
    }

    override fun onResume() {
        super.onResume()
        isPaused = false
        if (isRefreshMemGoodsCount) {
            isRefreshMemGoodsCount = false
            //查询有多少个未完成的会员商品订单数。
            mPre?.queryMemOrderCount()
        }
    }

    /**
     * 从快捷菜单编辑页更新数据到主页面的快捷菜单列表中
     *
     * @param event ...
     */
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onShortcutMenuEvent(event: ShortcutMenuBean) {
        returnCurrentFunctionList(event.list)
    }

    override fun onScaned(barcode: String?) {
        if (!isPaused && barcode != null) {//只有在不是onPause状态时，才执行扫码处理。因为如果进入到打卡界面，也有个扫码，不禁用这个的话，会跟那个冲突。
            ThreadManager.getThreadPool().execute {
                mPre?.checkHasCode(barcode)
                start2Scan()
            }
        }
    }

    override fun showMsg(msg: String) {
//        super.showMsg(msg)
        if (isFinishing) return
        runOnUiThread {
            MyToast.show(msg)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            // 调用相机拍照
            1 -> if (resultCode == Activity.RESULT_OK) {
                PictureUtil.saveImageToGallery(
                    this@HomeActivity,
                    tempPath,
                    SystemHelper.LoginUserId + ".jpg"
                )
                val temp = File(tempPath + SystemHelper.LoginUserId + ".jpg")
//                cropPhoto(Uri.fromFile(temp))// 裁剪图片
//                cropPhoto(FileProvider.getUriForFile(this,Files.fileProviderAuth,temp))//裁剪图片
                cropPhoto(
                    FuckGoogleAdaptUtil.android7AdaptUri(
                        this,
                        Files.fileProviderAuth,
                        temp
                    )
                )//裁剪图片
            }
            // 从相册里面取照片
            2 -> if (resultCode == Activity.RESULT_OK) {
//                FileCache.copyFile(imgPath, mPhotoDir + picName)
                // 裁剪图片
                cropPhoto(data!!.data)

            }
            //剪裁
            3 -> if (data != null /*&& data.extras != null*/) {
                if (data.extras != null) {
                    head = data.extras!!.get("data") as Bitmap?
                }
                if (head == null && data.data != null) {
                    head = BitmapFactory.decodeStream(contentResolver.openInputStream(data.data!!))
                }
//                val extras = data.extras
//                head = extras!!.getParcelable<Bitmap>("data")
                if (head != null) {
                    FileCache.saveBitmap(head, tempPath + SystemHelper.LoginUserId + ".jpg")
//                    QiNiuTokenTask(this, "正在上传数据", true).execute("")
                    QiNiuDominator.uploadImages(
                        mutableListOf(tempPath + SystemHelper.LoginUserId + ".jpg"),
                        QiNiuDominator.CompleteQiniu {
                            mPre?.uploadUserPic(SystemHelper.LoginUserId, it[0])
                        })
                }
            }
            2018 -> if (data != null) {
                val code = data.getStringExtra("code")
                SYLoger.print("扫描成功： $code")
                //核销情况 =================
                if (!code.isNullOrBlank() && code.startsWith("Coupons")) {
                    //因为核销有四个数据，会有3个逗号来分隔；失就算有3个逗号，有数据缺也不行
                    //eg.  Coupons,15112608286,6664,7781851
                    if (code.count { it == ',' } != 3 || code.split(",").any { it.isEmpty() }) {
                        MyToast.show("二维码信息有误")
                        return
                    }
                    code.split(",").run {
                        //请求活动
                        mPre?.queryActByActivityId(
                            get(1),
                            get(2),
                            get(3),
                            SystemHelper.LoginOrganId
                        )
                    }
                    return
                }
                //普通扫码情况=================
                ThreadManager.getThreadPool().execute {
                    mPre?.checkHasCode(code ?: "")
                    start2Scan()
                }
            }
            else -> {
            }
        }
    }

    /**
     * 调用系统的裁剪
     *
     * @param uri ...
     */
    fun cropPhoto(uri: Uri?) {
        val intent = Intent("com.android.camera.action.CROP").apply {
            setDataAndType(uri, "image/*")
            putExtra("crop", "true")
            // aspectX aspectY 是宽高的比例
            putExtra("aspectX", 1)
            putExtra("aspectY", 1)
            // outputX outputY 是裁剪图片宽高
            putExtra("outputX", 100)
            putExtra("outputY", 100)
            putExtra("return-data", true)
            addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
            addFlags(Intent.FLAG_GRANT_WRITE_URI_PERMISSION)
        }
        startActivityForResult(intent, 3)
    }


    override fun showUserPic(picUrl: String) {
        showUserUploadState(true, picUrl)
    }

    override fun showUserPicFailure(failInfo: String, t: Throwable) {
        BaseAppManager.loger().error(failInfo)
    }

    override fun showUserUploadState(isSuccess: Boolean, qnPicUrl: String) {
        if (isSuccess && !isFinishing) {
            ImageLoader.loadCircleImg(
                this,
                qnPicUrl,
                member_icon_iv,
                R.drawable.head,
                R.drawable.head
            )
        }
    }


    private var multipleItemAdapter: MultipleItemAdapter? = null

    /**
     * 初始化 viewpager 的表格。
     */
    private fun initTables() {
        data1Pager = LayoutInflater.from(this).inflate(R.layout.home_table1, null)
            .apply { pagerList.add(this) }
        loadWait = LoadWaitDominator(
            this,
            data1Pager?.find(R.id.table1Container)
        ).apply { setBackgroundColor(R.color.color_common_card_bg_one) }
        data2Pager = LayoutInflater.from(this).inflate(R.layout.home_table2_salary, null)
            .apply { pagerList.add(this) }
        loadWait2 = LoadWaitDominator(
            this,
            data2Pager?.find(R.id.table2Container)
        ).apply { setBackgroundColor(R.color.color_common_card_bg_one) }
        table2Parent = data2Pager?.find(R.id.table2ParentLayout)

        //初始化ViewPager的第一个表格=============
        table1 = data1Pager?.find(R.id.table1)!!
        table1?.apply {
            adapter = Table1Adapter(this@HomeActivity, mPre?.table1ListMonth)
            layoutManager =
                GridLayoutManager(this@HomeActivity, 5, RecyclerView.VERTICAL, false).apply {
                    isSmoothScrollbarEnabled = true//防止NestedScrollView嵌套RecyclerView滑动卡顿
                    isAutoMeasureEnabled = true//防止NestedScrollView嵌套RecyclerView滑动卡顿
                }
            setHasFixedSize(true)//防止NestedScrollView嵌套RecyclerView滑动卡顿
            isNestedScrollingEnabled = false//防止NestedScrollView嵌套RecyclerView滑动卡顿
        }
        //点击按钮 切换 按月 按周
        data1Pager?.find<Button>(R.id.tableTypeBtn)?.setOnClickListener {
            when (mPre?.table1Type) {
                0 -> {//原来按月查，点击后切换成按周查
                    mPre?.table1Type = 1
                    (it as Button).text =
                        "按月"; data1Pager?.find<TextView>(R.id.table1TitleTv)?.text = "本月销售数据"
                }
                1 -> {//原来按周查，(ry
                    mPre?.table1Type = 0
                    (it as Button).text =
                        "按周";data1Pager?.find<TextView>(R.id.table1TitleTv)?.text = "月度销售数据"
                }
            }
            loadWait?.show(LoadWaitDominator.LOADING)
            mPre?.queryTable1(SystemHelper.LoginOrganId, mPre?.table1Type ?: 0)
        }

        //初始化ViewPager的第二个表格=============

        //配置指示器
        viewpager.adapter = MyPagerAdapter(this, ArrayList(pagerList))
        viewpager.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrollStateChanged(state: Int) {}
            override fun onPageScrolled(
                position: Int,
                positionOffset: Float,
                positionOffsetPixels: Int
            ) {
            }

            override fun onPageSelected(position: Int) {
                if (position == 1 && table2Parent?.childCount == 0) {//在滑动到第二个界面，并子View数为0时，才请求。
                    mPre?.queryTable2(SystemHelper.LoginOrganId, SystemHelper.LoginUserId)
                    loadWait2?.show(LoadWaitDominator.LOADING)
                }
            }
        })
        vpIndicator.setViewPager(viewpager)
    }

    /**刷新表格1*/
    override fun notifyTable1() {
        table1?.adapter?.notifyDataSetChanged()
    }

    /**刷新表格2*/
    override fun notifyTable2(datas: List<HomeTable2Res.ResultInfo.Datas>, type: Int) {
        table2Parent?.removeAllViews()
        data2Pager?.find<TextView>(R.id.table2TitleTv)?.text = when (type) {
            0 -> "本月工资预估"
            1 -> "本月门店利润"
            else -> ""
        }
        //填充组件
        datas.forEachIndexed { index1, data1 ->
            //一级数据（一级标题）
            //绘制一级标题
            val titleView1 = LayoutInflater.from(this)
                .inflate(R.layout.text_view_half_border_layout, table2Parent, false)
            titleView1.find<TextView>(R.id.borderTv).apply {
                setTextColor(Color.parseColor("#858585")); text = data1.title; maxLines = 1
            }
            table2Parent?.addView(titleView1)
            if (/*type == 0 &&*/ index1 == 0) {//这种情况是 本月工资预估 情况，此情况下原型上说不显示第一个一级标题
                table2Parent?.removeView(titleView1)
            }

            //绘制一级标题下的二级内容（二级内容包括 二级标题 + 二级内容）
            val rowLayout = LinearLayout(this).apply {
                orientation = LinearLayout.HORIZONTAL
                layoutParams = LinearLayout.LayoutParams(
                    LinearLayout.LayoutParams.MATCH_PARENT,
                    LinearLayout.LayoutParams.WRAP_CONTENT
                )
            }
            data1.data.forEach { data2 ->
                //二级数据
                val titleView2 = LayoutInflater.from(this)
                    .inflate(R.layout.home_table2_item, table2Parent, false).apply {
                        layoutParams =
                            LinearLayout.LayoutParams(0, LinearLayout.LayoutParams.WRAP_CONTENT, 1f)
                    }
                titleView2.find<TextView>(R.id.table2ItemTitle)
                    .run { maxLines = 1; text = data2.subhead }
                titleView2.find<TextView>(R.id.table2ItemContent)
                    .run { maxLines = 1; text = data2.value }
                rowLayout.addView(titleView2)
            }
            table2Parent?.addView(rowLayout)
        }


    }

    override fun loadWaitNoData(containerId: Int) {
        when (containerId) {
            R.id.table1Container -> {
                loadWait?.show(LoadWaitDominator.NO_DATA)
            }
            R.id.table2Container -> {
                loadWait2?.show(LoadWaitDominator.NO_DATA)
            }
        }
    }


    override fun loadWaitNetError(containerId: Int, msgInfo: String?) {
        when (containerId) {
            R.id.table1Container -> {
                if (msgInfo.isNullOrEmpty()) {
                    loadWait?.show(LoadWaitDominator.NET_ERROR)
                } else {
                    loadWait?.show(msgInfo)
                }
            }
            R.id.table2Container -> {
                if (msgInfo.isNullOrEmpty()) {
                    loadWait2?.show(LoadWaitDominator.NET_ERROR)
                } else {
                    loadWait2?.show(msgInfo)
                }
            }
        }
    }

    override fun loadWaitDismiss(containerId: Int) {
        when (containerId) {
            R.id.table1Container -> {
                loadWait?.dismissAll()
            }
            R.id.table2Container -> {
                loadWait2?.dismissAll()
            }
        }
    }

    /**
     * 首页目录
     */
    private fun initRecyle() {
        multipleItemAdapter = MultipleItemAdapter(this, mPre?.mMenuList)
        multipleItemAdapter?.openLoadAnimation()
        multipleItemAdapter?.isFirstOnly(false)//设置后重复执行动画,默认只执行一次
        recyclerView.layoutManager = GridLayoutManager(this, 4)
        // 每个Item占用整行的空间大小
        multipleItemAdapter?.setSpanSizeLookup({ gridLayoutManager, position ->
            this@HomeActivity.mPre?.mMenuList?.get(position)?.spanSize ?: 0
        })
        multipleItemAdapter?.onItemChildClickListener =
            BaseQuickAdapter.OnItemChildClickListener { baseQuickAdapter, view, position ->
                when (view.id) {
                    //菜单项点击跳转
                    R.id.menu_icon -> {
                        //保证点击物流查询子菜单项跳转页面后不会启动默认查询
                        PreferHelper.getInstance().setBoolean(AppConstants.LOGISTICS_QUERY, false)
                        val multipleItem = baseQuickAdapter.data[position] as MultipleItem<*>
                            ?: return@OnItemChildClickListener
                        /*数据从MenuTableManager中传过来的*/
                        val strArray = multipleItem.strArray
                        if (strArray.size >= 4) {
                            val getLinkType = strArray[2]
                            val getLink = strArray[3]
                            val getParam = strArray[4]

                            try {
                                if (!TextUtils.isEmpty(getLinkType) && !TextUtils.isEmpty(getLink)) {
                                    //web网页情况
                                    if ("url" == getLinkType) {
                                        //                        if (typeId == 15) { // 学习系统 e-learning
                                        BaseCookiesWebFra.launch(
                                            this@HomeActivity,
                                            Intent(),
                                            getLink,
                                            null,
                                            true
                                        )
                                        //                        } else {
                                        //                            if (tempLink.contains("staffId")) {
                                        //                                tempLink = tempLink.replace("{staffId}", SystemHelper.LoginUserId);
                                        //                            }
                                        //                            if (tempLink.contains("name")) {
                                        //                                tempLink = tempLink.replace("{name}", SystemHelper.LoginUserName);
                                        //                            }
                                        //                            BaseCookiesWebFra.launch(MoreIndexAct.this, intent,
                                        //                                    NetParam.YINXIAOBU_SERVER.replace("https://", "http://") + "/" + tempLink,
                                        //                                    null, true);
                                        //                        }
                                    } /*else if ("2" == getParam) {
                                    //养生文库情况得传递参数;
                                    ToActivity.toActivity(this@HomeActivity, Class.forName(getLink), AppConstants.ExtraKeys.ACTIVITY_TYPE, "2")
                                }*/ else {
                                        ToActivity.toActivity(
                                            this@HomeActivity, Class.forName(getLink),
                                            SystemHelper.LoginOrganId,
                                            SystemHelper.LoginUserName,
                                            SystemHelper.LoginUserId,
                                            getParam
                                        )
                                    }//本地native情况（新进程下的打卡SignInAndOut需要传Intent，注意一下）
                                    //后台配置param的值为"2"就行了
                                }
                            } catch (e: ClassNotFoundException) {
                                e.printStackTrace()
                                BaseAppManager.loger().error("当前选项配置有问题:$e")
                                showMsg("当前选项配置有问题")
                            }

                        }
                    }
                    else -> {
                    }
                }
            }
        multipleItemAdapter?.setOnItemClickListener({ adapter, view, position ->
            val name = mPre?.mMenuList?.get(position)?.content
            if (name != null && name.contains("自定义")) {
                ShortcutMenuAct.start(this@HomeActivity)
            }
        })
        recyclerView.adapter = multipleItemAdapter
        multipleItemAdapter?.bindToRecyclerView(recyclerView)
    }


    /**首页原旋转木马返回*/
    override fun onResponseSuccess(resultInfo: CommonEntity<HomeCarouselEntity>?) {
        if (isFinishing) return
        swipe_refresh?.isRefreshing = false
        val entity = resultInfo?.entity

        curSaleAmountTv.text = htmlShow("磨粉销量", entity?.curSaleAmount ?: "--")
        curSaleBaseTargetTv.text = htmlShow("销售目标", entity?.curSaleBaseTarget ?: "--")
        curSaleBaseBateTv.text = htmlShow("完成率", entity?.curSaleBaseBate ?: "--")
        curSaleEquityCardTv.text = htmlShow("权益卡销量", entity?.cardSaleNum ?: "--")

        monthSaleAmountTv.text = htmlShow("磨粉销量", entity?.monthSaleAmount ?: "--")
        monthSaleBaseTargetTv.text = htmlShow("销售目标", entity?.monthSaleBaseTarget ?: "--")
        monthSaleBaseBateTv.text = htmlShow("完成率", entity?.monthSaleBaseBate ?: "--")

        monthOffLineSaleAmountTv.text = htmlShow("线下", entity?.monthOffLineSaleAmount ?: "--")
        //monthOnLineSaleAmountTv.text = htmlShow("天掉馅饼", entity?.monthOnLineSaleAmount ?: "--")
        monthEquityCardTv.text = htmlShow("权益卡销量", entity?.monthCardSaleNum ?: "--")
        monthArriveHomeSaleAmount.text = htmlShow("周末经济", entity?.monthWeekEndSaleAmount ?: "--")

        yeNewAddNumTv.text = htmlShow(
            "新客人数",
            "${entity?.yesterdayNewCus ?: "--"} | ${entity?.monthNewCusNum ?: "--"}"
        )
        yeNewAddPondNumTv.text = htmlShow(
            "新客进塘人数",
            "${entity?.yesterdayAddEqwFriendsNum ?: "--"} | ${entity?.addEqwFriendsNum ?: "--"}"
        )
        yePondEntryRateTv.text = htmlShow(
            "进塘率",
            "${entity?.yesterdayAddEqwRate ?: "--"} | ${entity?.addEqwFriendsFinishingRate ?: "--"}"
        )

        joinGroupNumTv.text = htmlShow(
            "入群人数",
            "${entity?.yesterdayJoinGroupNum ?: "--"} | ${entity?.monthJoinGroupNum ?: "--"}"
        )
        joinGroupRateTv.text = htmlShow(
            "入群率",
            "${entity?.yesterdayJoinGroupRate ?: "--"} | ${entity?.monthJoinGroupRate ?: "--"}"
        )
        counterSalesAmountTv.text = htmlShow(
            "专柜同款<br />销售金额",
            "${entity?.yesterdaySameProSale ?: "--"} | ${entity?.monthSameProSale ?: "--"}"
        )
        notCounterSalesAmountTv.text = htmlShow(
            "非专柜同款<br />销售金额",
            "${entity?.yesterdayNotSameProSale ?: "--"} | ${entity?.monthNotSameProSale ?: "--"}"
        )
    }

    /**兼容*/
    private fun htmlShow(title: String, content: String) =
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.N) {
            Html.fromHtml(
                "$title<br /><font color='#000000'>$content</font>",
                Html.FROM_HTML_MODE_LEGACY
            )
        } else {
            Html.fromHtml("$title<br><font color='#000000'>$content</font>")
        }


    /**首页原旋转木马返回*/
    override fun onFailure(failInfo: String?) {
        swipe_refresh?.isRefreshing = false
    }
}