package com.urovo.activity.tabMenu.home

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.urovo.activity.tabMenu.home.ent.HomeTable1Res
import com.urovo.wugumofang.R


/**
 * @author Sasuke on 2019-03-05 0005.
 */
class Table1Adapter(val context: Context,val datas: List<String?>?): RecyclerView.Adapter<Table1Adapter.TableViewHolder>() {
    companion object {
        @JvmStatic
        fun convert(res: HomeTable1Res?): List<String>{
            val result = res?.resultInfo
            //创建大表
            val bigTable = mutableListOf<String>()
            result?.run {
                //创建横标题
                bigTable.addAll(mutableListOf("").apply { addAll(horizontalTitles) })
                //依次创建每一行的数据（标题也是数据）
                verticalTitles.forEachIndexed { index, str ->
                    val titleText = str.split(",")?.get(0)
                    val titleKey = str.split(",")?.get(1)
                    var rowList = mutableListOf(titleText)//建立一行 + 一行的标题
                    rowList.addAll(datas.map { it[titleKey] ?:"--" })//提取并填充一行的数据
                    bigTable.addAll(rowList)//把一行加入大表
                }
            }


            return bigTable
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): TableViewHolder {
        return TableViewHolder(LayoutInflater.from(context).inflate(R.layout.text_view_half_border_layout, parent,false))
    }

    override fun getItemCount(): Int {
        return datas?.size ?: 0
    }

    override fun onBindViewHolder(holder: TableViewHolder, position: Int) {
        holder?.apply {
            setIsRecyclable(false)
            tv?.text = datas?.get(position)
        }
    }

    class TableViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        var tv: TextView

        init {
            this.tv = view.findViewById(R.id.borderTv)
        }
    }

}