package com.urovo.activity.tabMenu.home.menu;


import com.urovo.activity.tabMenu.home.ent.MultipleItem;
import com.urovo.activity.tabMenu.home.ent.MenuTableManager;
import com.urovo.activity.tabMenu.home.utils.ACache;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.BaseAppManager;

import java.io.Serializable;
import java.util.List;

import io.reactivex.Observable;
import io.reactivex.ObservableEmitter;
import io.reactivex.ObservableOnSubscribe;
import io.reactivex.ObservableSource;
import io.reactivex.ObservableTransformer;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.schedulers.Schedulers;

/**
 * @author lvr
 * @date 2017/2/14
 */

public class HomeChannelModelImpl implements HomeChannelModel {

    @SuppressWarnings("unchecked")
    @Override
    public Observable<List<MultipleItem>> lodeMoreHomeChannels(final int spanSize) {
        return Observable.create(new ObservableOnSubscribe<List<MultipleItem>>() {
            @Override
            public void subscribe(ObservableEmitter<List<MultipleItem>> e) throws Exception {
                List<MultipleItem> multipleItemList = (List<MultipleItem>) ACache.get(BaseAppManager.appContext()).getAsObject(AppConstants.Home.CHANNEL_MORE);
                if (multipleItemList == null) {
                    multipleItemList = MenuTableManager.loadNewsChannelsMore(spanSize);
//                    ACache.get(BaseAppManager.appContext()).put(AppConstants.Home.CHANNEL_MORE, (Serializable) multipleItemList);
                }
                e.onNext(multipleItemList);
                e.onComplete();
            }

        }).compose(schedulersTransformer);
    }

    @SuppressWarnings("unchecked")
    @Override
    public Observable<String> swapDb(final List<MultipleItem> multipleItemList) {
        return Observable.create(new ObservableOnSubscribe<String>() {
            @Override
            public void subscribe(ObservableEmitter<String> e) throws Exception {
                //交换过的列表进行缓存
                ACache.get(BaseAppManager.appContext()).put(AppConstants.Home.CHANNEL_MINE, (Serializable) multipleItemList);
                e.onNext("");
                e.onComplete();
            }
        }).compose(schedulersTransformer);
    }

    @SuppressWarnings("unchecked")
    @Override
    public Observable<String> updateDb(final List<MultipleItem> mineChannelTableList, final List<MultipleItem> moreChannelTableList) {
        return Observable.create(new ObservableOnSubscribe<String>() {
            @Override
            public void subscribe(ObservableEmitter<String> e) throws Exception {
                ACache.get(BaseAppManager.appContext()).put(AppConstants.Home.CHANNEL_MINE, (Serializable) mineChannelTableList);
                ACache.get(BaseAppManager.appContext()).put(AppConstants.Home.CHANNEL_MORE, (Serializable) moreChannelTableList);
                e.onNext("");
                e.onComplete();
            }
        }).compose(schedulersTransformer);
    }

    //处理线程调度的变换
    private ObservableTransformer schedulersTransformer = new ObservableTransformer() {
        @Override
        public ObservableSource apply(Observable upstream) {
            return ((Observable) upstream).subscribeOn(Schedulers.io())
                    .unsubscribeOn(Schedulers.io())
                    .observeOn(AndroidSchedulers.mainThread());
        }
    };
}
