package com.urovo.activity.tabMenu.home.pre

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.widget.Toast
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import com.urovo.activity.tabMenu.home.Table1Adapter
import com.urovo.activity.tabMenu.home.ent.*
import com.urovo.activity.tabMenu.home.net.HomeNet
import com.urovo.activity.tabMenu.home.net.IHomeNet
import com.urovo.activity.tabMenu.home.utils.RxDisposeManager
import com.urovo.activity.tabMenu.util.JPush.ActivityTypeDominator
import com.urovo.wgmf.AsyncTask.BaseAppManageServerTask
import com.urovo.wgmf.db.dao.dao.BarcodeScanDbOperate
import com.urovo.wgmf.db.dao.entitys.BarcodeScanDb
import com.urovo.wgmf.entity.response.SyncTimeResponse
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.data.PreferHelper
import com.urovo.wugumofang.net.CommonController
import com.urovo.wugumofang.net.CookieDominator
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.net.RetrofitHelper
import com.urovo.wugumofang.response.Base3Response
import com.urovo.wugumofang.response.CommonEntity
import com.urovo.wugumofang.system.LocationTool
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.utils.MyToast
import com.urovo.wugumofang.utils.notNullAndEmpty
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra
import com.wgmf.trade.model.bean.MemberAction
import com.wgmf.trade.model.bean.UserHeadResBean
import com.wgmf.trade.model.data.net.IndexDataNet
import com.wgmf.trade.ui.fra.index.MemberSalesFra
import com.wgmf.trade.utils.AssetsUtil
import com.zsy.libcore.LibCoreApp
import com.zsy.libcore.common.android.log.SYLoger
import io.reactivex.Observer
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import okhttp3.Request
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.net.SocketTimeoutException
import java.util.*
import kotlin.collections.HashMap

/**
 * @author Sasuke on 2019-02-25 0025.
 */
class HomePre(val mView: HomeContract.homeView) : HomeContract.homePre,
    CommonController.BasePre<HomeCarouselEntity>,
    CommonController.HomeAdPre<List<HomeAdEntity>>,
    CommonController.HomeMenuPre<List<List<HomeMenuOnlineBean.ResultInfoBean>>> {

    private var indexDataNet: IndexDataNet? = null
    private var mHomeNet: HomeNet? = null
    private var mIHomeNet: IHomeNet
    private var homeAdLinks = mutableListOf<String>()//广告位点击跳转链接
    private var homeAdEntitiesCache = mutableListOf<HomeAdEntity>()//网络返回缓存

    var mMenuList: MutableList<MultipleItem<*>> = mutableListOf()

    //首页表格的数据
    val table1ListMonth = mutableListOf<String>()
    val table1ListWeek = mutableListOf<List<String>>()


    init {
        mView.setPresenter(this)
        indexDataNet = RetrofitHelper.createApi(IndexDataNet::class.java)
        mIHomeNet = RetrofitHelper.createApi(IHomeNet::class.java)
        mHomeNet = HomeNet()
    }

    fun start() {
        mView.init()
    }


    /**
     * 查询会员商品未完成订单数
     */
    fun queryMemOrderCount() {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.QUERY_MEM_ORDER_COUNT,
            mapOf("userNo" to SystemHelper.LoginUserId), object : OkHttpDominator.ResultCallback<MemGoodsCountBean>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    //不用处理。
                }

                override fun onResponse(res: MemGoodsCountBean) {
                    if (res.msgCode == 0) {
                        if (res.resultInfo > 0) {//显示会员商品未完成订单入口。
                            mView.showMemGoodsOrderEntry(res.resultInfo)
                        } else {//未完成订单数为0的时候，不显示入口 。
                            mView.showMemGoodsOrderEntry(0)
                        }
                    }
                }
            })
    }


    /**
     * 请求首页表格1
     * type: 0按月 1按周
     */
    var table1Type: Int = 1

    fun queryTable1(shopId: String, type: Int) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.HOMEPAGE_1_DATA,
            mapOf("shopId" to shopId, "type" to type.toString()), object : OkHttpDominator.ResultCallback<HomeTable1Res>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    e?.printStackTrace()
                    //如果网络异常
                    mView.loadWaitNetError(R.id.table1Container, "")
                }

                override fun onResponse(res: HomeTable1Res?) {
                    res?.run {
                        if (msgCode != 0) {
                            mView.loadWaitNetError(R.id.table1Container, msgInfo)
//                        mView.showMsg("表格1接口：$msgInfo")
                            return
                        }
                        val newList = Table1Adapter.convert(res)
                        //如果没有数据
                        if (newList.size == 0) {
                            mView.loadWaitNoData(R.id.table1Container)
                            return
                        }
                        //如果有数据
                        table1ListMonth.run {
                            clear();addAll(newList)
                        }
                        mView.notifyTable1()
                        mView.loadWaitDismiss(R.id.table1Container)
                    }

                }
            })
    }


    /**请求首页表格2*/
    fun queryTable2(shopId: String, staffId: String) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.HOMEPAGE_2_DATA,
            mapOf("shopId" to shopId, "staffId" to staffId), object : OkHttpDominator.ResultCallback<HomeTable2Res>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    e?.printStackTrace()
                    mView.loadWaitNetError(R.id.table2Container, "")
                }

                override fun onResponse(res: HomeTable2Res) {
                    res?.run {
                        if (msgCode != 0) {
                            mView.loadWaitNetError(R.id.table2Container, msgInfo)
//                        mView.showMsg("表格2接口：$msgInfo")
                            return
                        }
                    }
                    val datas = res.resultInfo.datas
                    if (datas.size == 0) {
                        mView.loadWaitNoData(R.id.table2Container)
                        return
                    }
                    mView.notifyTable2(datas, res.resultInfo.type)
                    mView.loadWaitDismiss(R.id.table2Container)
                }
            })

    }


    //=====================首页原旋转木马=============
    //===============================

    /**
     * 正在查询首页旋转木马(轮播图)信息
     */
    fun start2HomeCarouselTask() {
        mView.refreshPostDelayed(10000)
        val params = HashMap<String, String>(2)
        params["staffId"] = SystemHelper.LoginUserId
        params["shopId"] = SystemHelper.LoginOrganId
        onStart2requestData(params)
    }

    /**请求首页原旋转木马*/
    override fun onStart2requestData(params: Map<String, String>) {
        mHomeNet?.start2request4carousel(this, params)

    }

    /**首页原旋转木马返回*/
    override fun onResponseSuccess(resultInfo: CommonEntity<HomeCarouselEntity>?) {
        mView?.onResponseSuccess(resultInfo)
    }

    /**首页原旋转木马返回错误*/
    override fun onFailure(failInfo: String?) {
        mView?.onFailure(failInfo);
    }
    //========================
    //===============首页原旋转木马==================


    //================广告位===========
    //======================
    /**
     * 广告位
     */
    override fun onStart2requestData4Ad() {
        mHomeNet?.start2request4Ad(this)
    }

    override fun onResponseSuccess4Ad(resultInfo: CommonEntity<List<HomeAdEntity>>) {
        homeAdLinks.run {
            clear()
            resultInfo.entity.forEach {
                add(if ("url" in it.linkType) CookieDominator.transURL(it.url) else it.androidLink)
            }
        }
        homeAdEntitiesCache.run {
            clear()
            addAll(resultInfo.entity)
        }
        mView?.onResponseSuccess4Ad(resultInfo)
    }

    override fun onFailure4Ad(failInfo: String?) {

    }


    /**
     * 广告位点击回调
     */
    fun onBannerClick(position: Int) {
        if (homeAdLinks.isEmpty() || homeAdLinks[position].isEmpty()) return
        // h5链接就判断是否包含http请求头
        if (homeAdLinks[position].startsWith("http")) {
            BaseCookiesWebFra.launchWithShare(mView as Context, Intent(), homeAdLinks[position], "", homeAdEntitiesCache[position].shareable == 1)
        } else {
            ActivityTypeDominator.jumpNative(mView as Context, homeAdLinks[position]) {
                MyToast.show(mView as Context, "当前广告配置有问题", Toast.LENGTH_SHORT)
            }
//            var realLink = homeAdLinks[position].run { if ( "@" in this ) this.split("@")[0] else this }
//            var param =  homeAdLinks[position].run { if ( "@" in this ) this.split("@")[1] else "" }
//            try {
//                ToActivity.toActivity( mView as Context, Class.forName(realLink),
//                        SystemHelper.LoginOrganId,
//                        SystemHelper.LoginUserName,
//                        SystemHelper.LoginUserId,
//                        param)
//                ToActivity.toActivity(mView as Context, Class.forName(realLink))
//            } catch (e: ClassNotFoundException) {
//                e.printStackTrace()
//                MyToast.show(mView as Context, "当前广告配置有问题", Toast.LENGTH_SHORT)
//            }
        }
    }

    //=====================
    //==============广告位=============


    //==============首页菜单=============
    //=====================
    /**
     * 正在查询首页菜单信息
     */
    fun start2HomeMenuTask() {
        mView?.refreshPostDelayed(10000)
        val params = HashMap<String, String>(2)
        params["userNo"] = SystemHelper.LoginUserId
        params["type"] = AppConstants.TabActState.HOME_STATE
        mHomeNet?.start2request4Menu(this, params)
    }

    override fun onResponseSuccess4Menu(resultInfo: CommonEntity<List<List<HomeMenuOnlineBean.ResultInfoBean>>>?) {
        mView?.onResponseSuccess4Menu(resultInfo)
    }

    override fun onStart2requestData4Menu(params: MutableMap<String, String>?) {
        //都没人调用，就老的 HomeActivity0 里面有调用，写不写感觉都无所谓。
//        mHomeNet?.start2request4Menu(this, params)
    }

    override fun onFailure4Menu(failInfo: String?) {
        mView?.onFailure4Menu(failInfo)
    }

    //=====================
    //==============首页菜单=============


    internal var offlineEntity: MutableList<List<HomeMenuOnlineBean.ResultInfoBean>> = ArrayList(ArrayList())
    var menuEntity: MutableList<List<HomeMenuOnlineBean.ResultInfoBean>>? = mutableListOf()

    /**
     * 加载离线资源
     */
    fun loadDataFromOffline() {
        offlineEntity.clear()
        val onlineMine = PreferHelper.getInstance().getString(AppConstants.Home.ONLINE_MINE)
        val onlineMore = PreferHelper.getInstance().getString(AppConstants.Home.ONLINE_MORE)
        if (onlineMine.notNullAndEmpty() && onlineMore.notNullAndEmpty()) {
            val onlineMineList: List<HomeMenuOnlineBean.ResultInfoBean> = Gson().fromJson(onlineMine, object : TypeToken<List<HomeMenuOnlineBean.ResultInfoBean>>() {}.type)
            val onlineMoreList: List<HomeMenuOnlineBean.ResultInfoBean> = Gson().fromJson(onlineMore, object : TypeToken<List<HomeMenuOnlineBean.ResultInfoBean>>() {}.type)
            offlineEntity.add(onlineMineList)
            offlineEntity.add(onlineMoreList)
            menuEntity = offlineEntity
        } else {
            val tempJson = AssetsUtil.getFromAssets(mView as Context, "home_menu.json")
            val homeMenuOfflineBean = Gson().fromJson(tempJson, HomeMenuOnlineBean::class.java)
            menuEntity = homeMenuOfflineBean.resultInfo
        }
        saveListData(menuEntity, false)
    }

    fun lodeMineChannelsRequest(spanSize: Int) {
        val observable = HomeModelImpl().requestHomeChannels(spanSize)
        observable.observeOn(AndroidSchedulers.mainThread())
            .subscribe(object : Observer<List<MultipleItem<*>>> {
                override fun onSubscribe(d: Disposable) {
                    RxDisposeManager.get().add("Homechannel", d)
                }

                override fun onNext(tables: List<MultipleItem<*>>) {
                    mView.returnCurrentFunctionList(tables)
                }

                override fun onError(e: Throwable) {}

                override fun onComplete() {

                }
            })
    }

    /**
     * 保存数据
     *
     * @param menuEntity     菜单的集合
     * @param isSaveDataFlag ...
     * 第一次安装App登录走离线读json文件,在线就保存到本地,
     * 下一次离线读在线上次保存的数据
     */
    fun saveListData(menuEntity: List<List<HomeMenuOnlineBean.ResultInfoBean>>?, isSaveDataFlag: Boolean) {
        if (menuEntity != null && menuEntity.size > 1) {
            val onlineMineList = menuEntity[0]
            val onlineMoreList = menuEntity[1]
            val onlineMine = Gson().toJson(onlineMineList)
            val onlineMore = Gson().toJson(onlineMoreList)
            PreferHelper.getInstance().setString(AppConstants.Home.ONLINE_MINE, onlineMine)
            PreferHelper.getInstance().setString(AppConstants.Home.ONLINE_MORE, onlineMore)
            PreferHelper.getInstance().setBoolean(AppConstants.Home.IS_SAVE_DATA, isSaveDataFlag)
        }
    }


    /**
     * 扫描前准备
     */
    fun preScan() {
        ScanCodeListUtil.getInstance().clearAll()
        if (!ScanCodeListUtil.getInstance().list.isEmpty()) {
            PreferHelper.getInstance().setBoolean("isClear", true)
        }
    }

    /**
     * 请求头像
     */
    fun getUserPic(staffId: String) {
        val call = indexDataNet?.getUserPic(staffId)
        call?.enqueue(object : Callback<UserHeadResBean> {
            override fun onResponse(call: Call<UserHeadResBean>, response: Response<UserHeadResBean>) {
                if (response.isSuccessful) {
                    val responseBody = response.body()
                    if (responseBody!!.ret == "0") {
                        if (mView != null) {
                            mView.showUserPic(responseBody.result.headpicurl)
                        }
                    } else {
                        //this.onFailure(call, new Throwable(responseBody.retInfo));
                        //                        Toast.makeText(LibCoreApp.getInstance(), responseBody.retInfo, Toast.LENGTH_SHORT).show();
                        SYLoger.print("wgmf--HomeActivity--头像" + responseBody.retInfo)
                    }
                } else {
                    this.onFailure(call, Throwable(response.errorBody()!!.toString()))
                }
            }

            override fun onFailure(call: Call<UserHeadResBean>, t: Throwable) {
                var msgTips = "网络访问异常"
                if (t is SocketTimeoutException) {
                    msgTips = "网络请求超时"
                }
                mView.showUserPicFailure(msgTips, t)
                Toast.makeText(LibCoreApp.getInstance(), msgTips, Toast.LENGTH_SHORT).show()
            }
        })
    }


    /**
     * 上传头像（已传到七牛，这里是把七牛返回的地址上传到我们的服务器）
     */
    fun uploadUserPic(staffId: String, url: String) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.USER_UPLOAD,
            mapOf("staffId" to staffId, "url" to url), object : OkHttpDominator.ResultCallback<Base3Response>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    e?.printStackTrace()
                }

                override fun onResponse(res: Base3Response) {
                    getUserPic(staffId)
                }
            })
    }

    /**
     * 获取营养顾问企业微信二维码
     */
    fun getUserQrCode(userId: String) {
        OkHttpDominator.postAsyn(NetParam.WEIXIN_SERVER + ApiUrls.WeiXinEnterprise.GET_USER_QR_CODE,
            mapOf("userId" to userId, "shopId" to SystemHelper.LoginOrganId), object : OkHttpDominator.ResultCallback<UserQrCodeRes?>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    e?.printStackTrace()
                    mView.showQrCodePop("获取二维码失败")
                }

                override fun onResponse(res: UserQrCodeRes?) {
                    res?.let {
                        if (it.data?.qrCode.isNullOrBlank()) {
                            mView.showQrCodePop("获取二维码失败")
                        } else {
                            it.data?.qrCode?.let { mView.showQrCodePop(it) }
                        }
                    }
                }
            })
    }

    /**（核销）请求活动详情
     * 手机号
     * 活动id
     * 核销码
     * */
    fun queryActByActivityId(phoneNum: String, activityId: String, checkCode: String, shopId: String) {
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.PROMOTION.QUERY_ACTION_BY_ACTIVITY_ID,
            mapOf("activityId" to activityId, "shopId" to shopId), object : OkHttpDominator.ResultCallback<ActionByIdRes>() {
                override fun onError(request: Request?, e: java.lang.Exception?) {
                    MyToast.show("网络异常")
                    e?.printStackTrace()
                }

                override fun onResponse(res: ActionByIdRes?) {
                    if (res == null) {
                        MyToast.show("返回为空")
                        return
                    }
                    if (res.msgCode != 0) {
                        MyToast.show(res.msgInfo)
                        return
                    }
                    //相当于点击活动列表跳转销售界面的操作。
                    MemberSalesFra.launchForExchangeCode(mView as Activity,
                        phoneNum,
                        res.resultInfo,
                        res.resultInfo.startTime,
                        checkCode,
                        actionBrand(res.resultInfo))
                }
            })
    }

    /***
     * 从 MemberActionListFra.java line:232 拷过来的
     */
    private fun actionBrand(action: MemberAction): String {
        var brandType = ""
        if (action.brandType == AppConstants.BRAND.WGMF) {
            brandType = SystemHelper.WgmfBrand
        } else if (action.brandType == AppConstants.BRAND.XDY) {
            brandType = SystemHelper.XdyBrand
        }
        return brandType
    }


    fun checkHasCode(code: String) {
        var code = code
        val firstScanRule = BarcodeScanDbOperate.getFirstScanRule()
        val printRule = firstScanRule.split("[;,]".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
        if (printRule == null || printRule.size == 0) {
            mView.showMsg("获取的条码长度和后台规则不一致,请联系主管")
            return
        }
        try {
            //解析规则
            val barcode = code.substring(0, Integer.parseInt(printRule[0]))
            //通过产品id去获得对应的规则
            val scanRuleInfo = BarcodeScanDbOperate.getScanRuleInfo(barcode)
            val scanRule = scanRuleInfo!!.scanRule
            val scanRuleArray = scanRule.split(";".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
            if (scanRuleInfo.barcodelens != code.trim { it <= ' ' }.length.toString() + "") {
                mView.showMsg("条形码长度有误！")
            }

            //========Sasuke解析=========
            code = code.substring(Integer.parseInt(scanRuleArray[0]), code.length)//把第一个坑位截掉。
            //规则第二坑位
            val subLength2 = loadValue(code, scanRuleArray[1], scanRuleInfo)
            code = code.substring(subLength2, code.length)//截断，使下面的操作继续从0位开始
            //规则第三坑位
            val subLength3 = loadValue(code, scanRuleArray[2], scanRuleInfo)
            code = code.substring(subLength3, code.length)//截断，使下面的操作继续从0位开始

            //校验一下如果哪一位是空的未赋值，就手动把它算出来。
            if (scanRuleInfo.totalAmount <= 0) {
                scanRuleInfo.totalAmount = scanRuleInfo.totalNumOrWeight * java.lang.Double.parseDouble(scanRuleInfo.price)
                scanRuleInfo.amount = String.format(Locale.CHINA, "%." + scanRuleInfo.totalAmountAccuracy + "f", scanRuleInfo.totalAmount)
            }
            if (scanRuleInfo.totalNumOrWeight <= 0) {
                scanRuleInfo.totalNumOrWeight = scanRuleInfo.totalAmount / java.lang.Double.parseDouble(scanRuleInfo.price)
                scanRuleInfo.numOrWeight = String.format(Locale.CHINA, "%." + scanRuleInfo.totalNumOrWeightAccuracy + "f", scanRuleInfo.totalNumOrWeight)
            }

            //遍历集合条码标签产品itemID相同就认为扫了相同的产品，金额和数量叠加
            val scanRuleInfoList = ScanCodeListUtil.getInstance().list
            var isHave = false
            for (i in scanRuleInfoList!!.indices) {
                if (scanRuleInfo.itemId == scanRuleInfoList[i].itemId) {
                    isHave = true
                    scanRuleInfoList[i].amount = String.format(Locale.CHINA, "%." + scanRuleInfo.totalAmountAccuracy + "f",
                        scanRuleInfoList[i].amount.toDouble() + scanRuleInfo.totalAmount)
                    scanRuleInfoList[i].numOrWeight = String.format(Locale.CHINA, "%." + scanRuleInfo.totalNumOrWeightAccuracy + "f",
                        scanRuleInfoList[i].numOrWeight.toDouble() + scanRuleInfo.totalNumOrWeight)
                }
            }
            if (!isHave) {
                //遍历结束都没有相同的itemID就添加产品
                scanRuleInfoList.add(scanRuleInfo)
            }

            if (scanRuleInfoList != null && !scanRuleInfoList.isEmpty()) {
                //取最新的数据
                val barcodeScanDb = scanRuleInfoList[scanRuleInfoList.size - 1]
                val itemName = scanRuleInfo.itemName//barcodeScanDb.getItemName();
                mView.showMsg(itemName + "扫描成功，继续扫描下一个")
            } else {
                mView.showMsg("当前条码无法识别，请手动录单")
            }
        } catch (e: Exception) {
            mView.showMsg("当前条码无法识别，请手动录单")
        }

    }

    /**
     * 解析出M 金额 或N 数量 （传入code之前请先把该位之前的码都截取舍去，也就是说，使M码在cdoe的零位）
     * @param code 扫出来的码
     * @param subRule 子规则
     * @return
     */
    private fun loadValue(code: String, subRule: String, scanRuleInfo: BarcodeScanDb): Int {
        //M码和N码都可能为空，如果为空，那就返回0，让后面的操作截断0位。
        if (TextUtils.isEmpty(subRule)) {
            return 0
        }
        val subRules = subRule.split(",".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()//分割出子规则
        val ruleLength = Integer.parseInt(subRules[1])//总长度
        val accuracy = Integer.parseInt(subRules[2])//小数位（精确度）

        val valueRaw = java.lang.Double.parseDouble(code.substring(0, ruleLength))
        val realValue = valueRaw / Math.pow(10.0, accuracy.toDouble())
        if (subRule.contains("M")) {
            scanRuleInfo.totalAmount = realValue
            //赋值数量/重量保留小数点数目，为了后面结果页面动态计算数量/重量
            scanRuleInfo.totalAmountAccuracy = accuracy
            scanRuleInfo.amount = String.format(Locale.CHINA, "%." + scanRuleInfo.totalAmountAccuracy + "f", scanRuleInfo.totalAmount)
        } else if (subRule.contains("N")) {
            scanRuleInfo.totalNumOrWeight = realValue
            //金额保留的小数点数目
            scanRuleInfo.totalNumOrWeightAccuracy = accuracy
            scanRuleInfo.numOrWeight = String.format(Locale.CHINA, "%." + scanRuleInfo.totalNumOrWeightAccuracy + "f", scanRuleInfo.totalNumOrWeight)
        }
        return ruleLength//返回该段数据长度用于截断，然后留给后面的操作
    }

    internal fun uploadLocation(mLocationTool: LocationTool?) {
        val params = HashMap<String, String>(7)
        params["IMEI"] = SystemHelper.Imei
        params["MAC"] = SystemHelper.Mac
        params["staffNo"] = SystemHelper.LoginUserId
        params["lat"] = mLocationTool?.mLatitude ?: ""//SystemHelper.Latitude);
        params["lon"] = mLocationTool?.mLongitude ?: ""//SystemHelper.Longitude);
        params["address"] = mLocationTool?.mAddress ?: ""//SystemHelper.Address);
        params["storeId"] = SystemHelper.LoginOrganId
        BaseAppManageServerTask("uploadLocation", SyncTimeResponse::class.java,
            mView as BaseActivity, "上传GPS地址信息...", false, "/app/location", params)
            .execute("")
    }
}