package com.urovo.activity.tabMenu.home.view;

import android.os.Handler;
import android.os.Message;

/**
 * loopHandler 发送
 *
 * @author ...
 */

public abstract class BaseLoopRotarySwitchViewHandler implements Handler.Callback {
    private Handler handler = new Handler(this);
    /**
     * 是否要发送
     */
    private boolean loop = false;

    /**
     * 时间间隔
     */
    @SuppressWarnings("all")
    public long loopTime = 3000;

    @SuppressWarnings("all")
    public static final int MSG_ID = 1000;

    /**
     * 构造方法
     *
     * @param time ...
     */
    @SuppressWarnings("all")
    public BaseLoopRotarySwitchViewHandler(int time) {
        this.loopTime = time;
    }

    /**
     * handler处理
     *
     * @param msg ...
     */
    @Override
    public boolean handleMessage(Message msg) {
        switch (msg.what = MSG_ID) {
            case MSG_ID:
                if (loop) {
                    doScroll();
                    sendMsg();
                }
                break;
            default:
                break;
        }
        return false;
    }

    /**
     * 设置是否要发送
     *
     * @param loop ...
     */
    @SuppressWarnings("all")
    public void setLoop(boolean loop) {
        this.loop = loop;
        if (loop) {
            sendMsg();
        } else {
            handler.removeMessages(MSG_ID);
        }
    }

    /**
     * 发送message
     */
    private void sendMsg() {
        handler.removeMessages(MSG_ID);
        handler.sendMessageDelayed(createMsg(), loopTime);
    }

    /**
     * 创建message
     *
     * @return ...
     */
    @SuppressWarnings("all")
    public Message createMsg() {
        Message msg = new Message();
        msg.what = MSG_ID;
        return msg;
    }

    public void removeMessages(int what) {
        handler.removeMessages(what);
    }

    public void sendEmptyMessageDelayed(int what, long delay) {
        handler.removeMessages(what, delay);
    }

    /**
     * 设置时间
     *
     * @param loopTime ...
     */
    @SuppressWarnings("all")
    public void setLoopTime(long loopTime) {
        this.loopTime = loopTime;
    }

    @SuppressWarnings("unused")
    public long getLoopTime() {
        return loopTime;
    }

    /**
     * 返回是否可以发送
     *
     * @return ...
     */
    @SuppressWarnings("unused")
    public boolean isLoop() {
        return loop;
    }

    /**
     * 自动滚动
     */
    public abstract void doScroll();
}
