package com.urovo.activity.tabMenu.web;

import android.text.TextUtils;

import com.urovo.wugumofang.response.BaseOldResponse;

import java.util.List;

/**
 * 下拉刷新或上拉加载的时候，获取到销售动态的response
 * Created by Sasuke on 2016/8/4.
 */
public class NewSaleDetailResponse extends BaseOldResponse {
    ResultBean returnBean;

    class ResultBean {
        String extra = "";//当前已读最大id
        List<SaleMessage> returnList;
    }

    public class SaleMessage{
        public String addDate = "";//消息时间
        public int pid;//消息id
        public String saleAmount = "0";//销售金额
        public String shopName = "";//门店名称
        public String seedNum = "0";//种子数
        public String flowerNum = "0";//鲜花数
        public int isGiven = 0;//是否已送鲜花（不可以重复送花）大于0则表示已送过鲜花
        public int isFirstOrder;//是否第一单，1是，0不是

        public int getIsFirstOrder() {
            return isFirstOrder;
        }

        public int getPid() {
            return pid;
        }

        public String getShopName(){
            return shopName;
        }

        public String getAddDate(){
            return addDate;
        }

        public String getSaleAmount(){
            return TextUtils.isEmpty(saleAmount)?"0" : saleAmount;
        }

        public String getFlowerNum(){
            return TextUtils.isEmpty(flowerNum)? "0" : flowerNum;
        }

        //鲜花数加1
        public void FlowerNumPlus(){
            flowerNum = (Integer.parseInt(getFlowerNum()) + 1)+"";
        }

        public String getSeedNum(){
            return TextUtils.isEmpty(seedNum)?"0" : seedNum;
        }

        public int hasGiveFlower(){//是否已献花
            return isGiven ;
        }
    }

    public String getExtra() {
            return returnBean.extra;
    }

    public List<SaleMessage> getReturnList() {
        if(returnBean != null){
            return returnBean.returnList;
        }
        return null;
    }

    //按日期逆序排序，即新的排在前面
  /*  public void sortList(List<SaleMessage> list){
        Collections.sort(list, new Comparator<SaleMessage>() {
            @Override
            public int compare(SaleMessage lhs, SaleMessage rhs) {
                return rhs.addDate.compareTo(lhs.addDate);
            }
        });
    }*/
}
