package com.urovo.activity.user;

import android.graphics.Color;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.LinearInterpolator;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.activity.user.bean.FlowSalesPersonCompletionHeadEntity;
import com.urovo.activity.user.bean.FlowSalesPersonCompletionListEntity;
import com.urovo.activity.user.presenter.FlowSalesPersonCompletionPre;
import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.adapter.CommonAdapter;
import com.urovo.wgmf.net.CommonNet;
import com.urovo.wgmf.viewholder.ViewHolder;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.CommonTools;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.CommonEntity;
import com.zsy.libext.widgets.refresh.pulltorefresh.PullableUtil;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.OrientationHelper;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;


/**
 * 流动顾问销售完成情况
 *
 * @author chenji
 * @date 2017/11/2
 */
public class FlowSalesPersonCompletionFra extends BackHandledFragment implements View.OnClickListener, CommonController.FlowSalesPersonView {
    /**
     * 头部门店信息和日期查询控件
     */
    @BindView(R.id.head_store_data_query)
    LinearLayout mHeadStoreDataQuery;
    /**
     * 用户名、地区名
     */
    @BindView(R.id.textViewStore)
    TextView mTextViewStore;
    /**
     * 前一月按钮
     */
    @BindView(R.id.last_month)
    LinearLayout mLastMonthBtn;
    /**
     * 后一月按钮
     */
    @BindView(R.id.next_month)
    LinearLayout mNextMonthBtn;
    /**
     * 前一月
     */
    @BindView(R.id.tv_last_month)
    TextView mTvLastMonth;
    /**
     * 后一月
     */
    @BindView(R.id.tv_next_month)
    TextView mTvNextMonth;
    /**
     * 当前选择的月份按钮
     */
    @BindView(R.id.calendar_date)
    LinearLayout mCurrentDateBtn;
    /**
     * 当前选择的月份
     */
    @BindView(R.id.tv_current_date)
    TextView mCurrentDate;
    /**
     * 当前月份增减的临时变量
     */
    private String tempCurrentDate;
    @BindView(R.id.flow_sales_person_completion_container)
    LinearLayout mFlowSalesPersonCompletionContainer;
    @BindView(R.id.take_up)
    ImageView mArrowImage;
    /**
     * 月总的数据
     */
    @BindView(R.id.data_month_list)
    LinearLayout mDataMonthList;

    /**
     * 目标
     */
    @BindView(R.id.total_goal)
    TextView mTotalGoal;
    /**
     * 销量
     */
    @BindView(R.id.total_sales)
    TextView mTotalSales;
    /**
     * 完成率
     */
    @BindView(R.id.total_completion)
    TextView mTotalCompletion;
    /**
     * 收缩箭头
     */
    @BindView(R.id.rl_container)
    RelativeLayout mArrowBtn;

    private RecyclerView mRvFlowSales;
    private CommonAdapter<FlowSalesPersonCompletionListEntity> mFlowSalesAdapter;
    private List<FlowSalesPersonCompletionListEntity> mRequestResultList;
//    private TextView mNetErrorText;
//    private TextView mNoDataText;

    private Unbinder unSuperBinder;
    private final String specifiedDateFormat = "yyyy-MM";
    public final int mLastMonth = -1;
    public final int mCurrentMonth = 0;
    public final int mNextMonth = 1;
    private String mDateMonth;
    private FlowSalesPersonCompletionPre mFlowSalesPersonCompletionPre;
    private Animation mUpRotateAnim;
    private Animation mDownRotateAnim;
    private FlowSalesPersonCompletionHeadEntity mHeadEntity;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        onInitHeadInfo();
        View view = inflater.inflate(R.layout.fra_user_flow_sales_completion, container, false);
        mRvFlowSales = (RecyclerView) view.findViewById(R.id.rv_flow_sales);
//        mNetErrorText = (TextView) view.findViewById(R.id.net_error_text);
//        mNoDataText = (TextView) view.findViewById(R.id.no_data_text);
        mFlowSalesPersonCompletionPre = new FlowSalesPersonCompletionPre(this, new CommonNet());
        selfCenterListPresenter = new UserPresenter(this);
        selfCenterListPresenter.start();
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        return view;
    }

    /**
     * 初始化头部信息
     */
    public void onInitHeadInfo() {
        // 绑定fra依附的act，绑定那个就能用它的内部的东西
        unSuperBinder = ButterKnife.bind(this, getActivity());
        mHeadStoreDataQuery.setVisibility(View.VISIBLE);
        mFlowSalesPersonCompletionContainer.setVisibility(View.VISIBLE);
        mTextViewStore.setSelected(true);
        //初始化设置为登陆人姓名
        mTextViewStore.setText(SystemHelper.LoginUserName);
        tempCurrentDate = mDateMonth = DateUtil.getSpecifiedMonth(new Date(), mCurrentMonth, specifiedDateFormat, Locale.CANADA);
        mCurrentDate.setText(tempCurrentDate);
        //去掉箭头图片
        mCurrentDate.setCompoundDrawables(null, null, null, null);
        // 初始化上下月按钮显示状态
        setMonthColor(false, false);
        mLastMonthBtn.setOnClickListener(this);
        mNextMonthBtn.setOnClickListener(this);
        mCurrentDateBtn.setOnClickListener(this);
        mArrowBtn.setOnClickListener(this);
        //箭头动画
        mUpRotateAnim = AnimationUtils.loadAnimation(getActivity(), R.anim.image_up_rotate);
        mDownRotateAnim = AnimationUtils.loadAnimation(getActivity(), R.anim.image_down_rotate);
        //设置匀速旋转，在xml文件中设置会出现卡顿
        LinearInterpolator interpolator = new LinearInterpolator();
        mUpRotateAnim.setInterpolator(interpolator);
        mDownRotateAnim.setInterpolator(interpolator);
    }

    @Override
    public void init() {
        //角标动画 angleAnimation
        angleAnimation(false);
        clear();
        // 网络请求——流动顾问销售头部信息
        start2RequestNet(tempCurrentDate, AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD);
    }

    /**
     * 发起请求
     *
     * @param type 0-->获取月统计数据(头部信息) 1-->获取详情数据（列表）
     */
    private void start2RequestNet(String currentDate, String type) {
        if (NetHelper.IsHaveInternet(getActivity())) {
            Map<String, String> params = new HashMap<>(3);
            //工号
            params.put("staffId", SystemHelper.LoginUserId);
            //当前的日期
            params.put("ym", currentDate);
            //类型：0-->获取月统计数据(头部信息) 1-->获取详情数据（列表）
            params.put("type", type);
            //延时5秒任务--主要是防止请求时服务器挂掉没有回调的意外情况造成的弹窗不消失
            mFlowSalesPersonCompletionPre.postDelayed(6000);
            ViewUtil.showProgress(getActivity(), "正在加载...", "请稍后...", false);
            mFlowSalesPersonCompletionPre.onStart2requestData(params);
        } else {
            mArrowBtn.setClickable(false);
            showMsg("网络连接超时，请检查您的网络状态，稍后重试！");
            showNetError();
        }
    }

    @Override
    public void refresh(String tag, BaseResponse response) {
    }

    @Override
    protected boolean onBackPressed() {
        //清空缓存数据
        clear();
        return false;
    }

    @Override
    public void onDestroyView() {
        if (mHeadStoreDataQuery != null) {
            mHeadStoreDataQuery.setVisibility(View.GONE);
        }
        if (unSuperBinder != null) {
            unSuperBinder.unbind();
        }
        if (mArrowImage != null) {
            mArrowImage.clearAnimation();
        }
        super.onDestroyView();
    }

    private boolean isShowData = true;

    @Override
    public void onClick(View v) {
        final int id = v.getId();
        final int dateValue;
        switch (id) {
            // 月份减一
            case R.id.last_month:
                String lastMonth = DateUtil.getSpecifiedMonth(tempCurrentDate, mLastMonth, specifiedDateFormat);
                //日期期限判断
                dateValue = mFlowSalesPersonCompletionPre.timeLimit(lastMonth, mDateMonth);
                //dateValue ==1,不去请求,按钮不可以点
                if (dateValue == 1) {
                    mTvLastMonth.setFocusable(false);
                    mTvLastMonth.setEnabled(false);
                }
                break;
            case R.id.calendar_date:
//                new DatePickerYearMonthDialog(getActivity(), new DatePickerYearMonthDialog.OnDateSetListener() {
//                    @Override
//                    public void onDateSet(int year, int monthOfYear) {
//                        String calendarDate = String.format(Locale.CHINA, "%04d-%02d", year, monthOfYear + 1);
//                        final int calendarDateValue = mFlowSalesPersonCompletionPre.timeLimit(calendarDate, mDateMonth);
//                        //result ==1,超过当前月都不去请求
//                        if (calendarDateValue == 1) {
//                            mTvLastMonth.setEnabled(false);
//                            mTvNextMonth.setEnabled(false);
////                    nextMonth();//act页面回调，请求在act做
//                        }
//                    }
//                }).show();
                break;

            // 月份加一
            case R.id.next_month:
                String nextMonth = DateUtil.getSpecifiedMonth(tempCurrentDate, mNextMonth, specifiedDateFormat);
                //日期期限判断
                dateValue = mFlowSalesPersonCompletionPre.timeLimit(nextMonth, mDateMonth);
                //dateValue ==1,不去请求,按钮不可以点
                if (dateValue == 1) {
                    mTvNextMonth.setFocusable(false);
                    mTvNextMonth.setEnabled(false);
                }
                break;
            // 收起
            case R.id.rl_container:
//         网络请求 --- 流动顾问销售完成情况列表请求,点击请求展示列表
                start2RequestListNet();
                break;
            default:
                break;
        }
    }

    /**
     * 流动顾问销售完成情况列表请求
     */
    private void start2RequestListNet() {
        if (isShowData) {
            start2RequestNet(tempCurrentDate, AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_LIST);
            //因为是放在开关里面，可能会有点冲突，必须设置写死。
            angleAnimation(true);
        } else {// 清空列表
            clearList();
        }
        isShowData = !isShowData;
    }

    /**
     * 清空所有缓存数据
     */
    private void clear() {
        //清除头部信息
        if (mHeadEntity != null) {
//            mTextViewStore.setText("--");
            try {
                mTotalGoal.setText("--");
                mTotalSales.setText("--");
                mTotalCompletion.setText("--");
                //如果请求是头部信息的接口，成功回调就显示箭头向下
                angleAnimation(false);
                //箭头不可点击
                mArrowBtn.setClickable(false);
            } catch (NullPointerException e) {
                e.printStackTrace();
                MyToast.show("流动顾问销售数据为空!");

            }
        }
        //清空列表
        clearList();
    }

    /**
     * 清空列表
     */
    private void clearList() {
        //清空列表
        if (mRequestResultList != null && !mRequestResultList.isEmpty()) {
            mRequestResultList.clear();
            mFlowSalesAdapter.notifyDataSetChanged();
            //因为是放在开关里面，可能会有点冲突，必须设置写死。
            angleAnimation(false);
            showNoData();
        }
    }

    /**
     * 箭头角标动画
     *
     * @param isUp true:向上动画; false:向下动画
     */
    private void angleAnimation(boolean isUp) {
        mArrowBtn.setPadding(
                PullableUtil.dip2px(getActivity(), isUp ? 2 : -1),
                PullableUtil.dip2px(getActivity(), isUp ? 2 : -1),
                PullableUtil.dip2px(getActivity(), isUp ? 2 : -1),
                PullableUtil.dip2px(getActivity(), isUp ? 2 : -1)
        );
        if (mUpRotateAnim != null && isUp) {
            //开始向上动画
            mArrowImage.startAnimation(mUpRotateAnim);
        } else {
            //开始向下动画
            mArrowImage.startAnimation(mDownRotateAnim);
        }
//        mArrowImage.setImageBitmap(BitmapFactory.decodeResource(getResources(),
//                isShow ? R.drawable.btn_take_up_pressed : R.drawable.btn_down_pressed));
    }

    /**
     * 是否要改变月份颜色状态
     *
     * @param isMonth   字体颜色，true:灰色 ； false：黑色
     * @param arrawFlag 图片颜色，true:灰色 ； false：黑色
     *                  都为true ,上个月都为灰色，下个月都为黑色
     */
    private void setMonthColor(boolean isMonth, boolean arrawFlag) {
        //上下月的箭头和字体要取反
        mTvLastMonth.setTextColor(isMonth ? Color.parseColor("#55636263") : Color.BLACK);
        mTvNextMonth.setTextColor(!isMonth ? Color.parseColor("#55636263") : Color.BLACK);
        CommonTools.INSTANCE.setShowArrow(getActivity(), mTvLastMonth, CommonTools.ShowArrowDirection.left, arrawFlag, R.drawable.go_left, R.drawable.go_left_press);
        CommonTools.INSTANCE.setShowArrow(getActivity(), mTvNextMonth, CommonTools.ShowArrowDirection.right, !arrawFlag, R.drawable.go, R.drawable.go_press);
    }

    @SuppressWarnings("unchecked")
    @Override
    public void onResponseSuccess(String tag, CommonEntity resultInfo) {
        ViewUtil.dismissProgress();
        hideErrorText();
//      如果请求是头部信息的接口，成功回调就显示箭头向下
        angleAnimation(!AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD.equals(tag));
        //箭头可点击
        mArrowBtn.setClickable(true);
        onSetHeadInfo(tag, resultInfo);
        onSetRecyclerView(tag, resultInfo);
    }

    /**
     * 请求失败回调
     *
     * @param failInfo ...
     */
    @Override
    public void onFailure(String failInfo) {
        ViewUtil.dismissProgress();
        angleAnimation(false);
        mArrowBtn.setClickable(false);
        showNoData();
    }

    /**
     * 点击按钮选择的月份是当月的操作
     *
     * @param currentMonth ...
     */
    @Override
    public void currentMonthSelected(String currentMonth) {
        //当前月字体角标颜色设置
        setMonthColor(false, false);
        //显示选择的年月
        mCurrentDate.setText(tempCurrentDate = currentMonth);
        clear();
        //网络请求--当前日期的头部信息接口请求（后面会继续请求点击按钮后当前日期的列表接口）
        start2RequestNet(tempCurrentDate, AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD);
    }

    /**
     * 点击按钮选择的月份是上一个月的操作
     *
     * @param lastMonth ...
     */
    @Override
    public void lastMonthSelected(String lastMonth) {
        setMonthColor(true, true);
        mCurrentDate.setText(tempCurrentDate = lastMonth);
        clear();
        start2RequestNet(tempCurrentDate, AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD);
    }

    /**
     * @param msg ...
     */
    @Override
    public void showToast(String msg) {
        showMsg(msg);
    }

    /**
     * 配置头部信息（用户名 店门所在地区 总的月销售信息）
     *
     * @param resultInfoBean ...
     */
    private void onSetHeadInfo(String tag, CommonEntity resultInfoBean) {

        //标志为流动顾问销售月总数据头部信息
        if (AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD.equals(tag)) {

            // 头部信息请求完成成功回调后，列表请求前需要加个无数据显示状态
            showNoData();
            //保证列表请求前开关都是true，true代表可以请求列表数据.
            isShowData = true;

            //回调获取流动顾问销售月总数据头部信息
            mHeadEntity = resultInfoBean.flowSalesPersonCompletionHeadEntity;
            if (mHeadEntity != null) {
                // 员工名，地区
                mTextViewStore.setText(TextUtils.isEmpty(mHeadEntity.getHeadInfo()) ? SystemHelper.LoginUserName : mHeadEntity.getHeadInfo());

                // 月总目标
                mTotalGoal.setText(TextUtils.isEmpty(mHeadEntity.getGoal()) ? "--" : mHeadEntity.getGoal());

                // 月总销量
                mTotalSales.setText(TextUtils.isEmpty(mHeadEntity.getSales()) ? "--" : mHeadEntity.getSales());

                // 月总完成率
                mTotalCompletion.setText(TextUtils.isEmpty(mHeadEntity.getCompletion()) ? "--" : mHeadEntity.getCompletion());

                // 如果头部信息没有数据，就不需要再查询了
                if (TextUtils.isEmpty(mHeadEntity.getHeadInfo())
                        || TextUtils.isEmpty(mHeadEntity.getGoal())
                        || TextUtils.isEmpty(mHeadEntity.getSales())
                        || TextUtils.isEmpty(mHeadEntity.getCompletion())
                        ) {
                    //如果请求是头部信息的接口，成功回调就显示箭头向下
                    angleAnimation(false);
                    //箭头不可点击
                    mArrowBtn.setClickable(false);
                }
            }
        }
    }

    /**
     * 配置RecycleView列表
     *
     * @param resultInfoBean ...
     */
    private void onSetRecyclerView(String tag, CommonEntity<List<FlowSalesPersonCompletionListEntity>> resultInfoBean) {

        //标志为流动顾问销售列表
        if (AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_LIST.equals(tag)) {

            //获取请求返回的数据列表
            mRequestResultList = resultInfoBean.t;

            //布局管理器--线性布局
            mRvFlowSales.setLayoutManager(new LinearLayoutManager(getActivity(), OrientationHelper.VERTICAL, false));

            // 设置适配器
            if (mRequestResultList != null) {
                mFlowSalesAdapter = new CommonAdapter<FlowSalesPersonCompletionListEntity>(getActivity(), R.layout.fra_user_flow_sales_completion_item, mRequestResultList) {

                    @Override
                    public void convert(ViewHolder holder, FlowSalesPersonCompletionListEntity flowSalesPersonCompletionListEntity) {
                        if (flowSalesPersonCompletionListEntity != null) {
                            //日期
                            final TextView flowSalesDate = holder.getView(R.id.flow_sales_date);
                            flowSalesDate.setText(flowSalesPersonCompletionListEntity.getYmd());
//
//                        //每月目标
                            final TextView goal = holder.getView(R.id.goal);
                            goal.setText(flowSalesPersonCompletionListEntity.getGoal());
//
//                        //每月销售量
                            final TextView sales = holder.getView(R.id.sales);
                            sales.setText(flowSalesPersonCompletionListEntity.getSales());
//
//                        //每月完成率
                            final TextView completion = holder.getView(R.id.completion);
                            completion.setText(flowSalesPersonCompletionListEntity.getCompletion());
                        }
                    }
                };
            }
            mRvFlowSales.setAdapter(mFlowSalesAdapter);
        }
    }

    /**
     * 显示无数据
     */
    private void showNoData() {
//        CommonTools.INSTANCE.setVisibility(mRvFlowSales, View.GONE);
//        CommonTools.INSTANCE.setVisibility(mNoDataText, View.VISIBLE);
//        CommonTools.INSTANCE.setVisibility(mNetErrorText, View.GONE);
    }

    /**
     * 显示网络错误
     */
    private void showNetError() {
//        CommonTools.INSTANCE.setVisibility(mRvFlowSales, View.GONE);
//        CommonTools.INSTANCE.setVisibility(mNoDataText, View.GONE);
//        CommonTools.INSTANCE.setVisibility(mNetErrorText, View.VISIBLE);
    }

    /**
     * 恢复原来设置
     */
    private void hideErrorText() {
//        CommonTools.INSTANCE.setVisibility(mRvFlowSales, View.VISIBLE);
//        CommonTools.INSTANCE.setVisibility(mNoDataText, View.GONE);
//        CommonTools.INSTANCE.setVisibility(mNetErrorText, View.GONE);
    }
}
