package com.urovo.activity.user;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.InputType;
import android.text.TextUtils;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.urovo.activity.login.net.LoginOnlineRes;
import com.urovo.activity.user.adapter.UserInfoAdapter;
import com.urovo.wgmf.db.dao.dao.Czyda001DbOperate;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.DeviceHelper;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.baseWebViewAct.WebViewAct;

import java.lang.ref.WeakReference;
import java.util.HashMap;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;
import okhttp3.Request;


/**
 * 该类已改名为薪资查询
 *
 * @author ...
 */
public class UserActivity extends BaseActivity implements AdapterView.OnItemClickListener, UserContract.view, BackHandledInterface {
    private static final String SELF_CENTER_TITLE = "薪资查询";
    @BindView(R.id.empty_view_container)
    View mEmptyView;

    @BindView(R.id.self_center_lv)
    ListView mSelfCenterLv;
    UserInfoAdapter mSelfCenterAdapter;//mSelfCenterLv专用Adapter
    @BindView(R.id.confirm)
    Button confirmBtn;//标题栏右上按钮
    private UserPresenter selfCenterListPresenter;
    private BackHandledFragment mBackHandedFragment;
    //    private AnnualVacationAct nianJiaFragment;
    private XinZiFragment xinZiFragment;
//    private WenTiFragment wenTiFragment;
//    private WenTiSearchFragment wenTiSearchFragment;

    private List<UserPresenter.FunItem> functions;
    /*private Handler handler = new Handler() {
       public void handleMessage(Message msg) {
           Bundle bundle = msg.getData();
           boolean b = bundle.getBoolean("isPass");
           if (b) {
               ViewUtil.dismissProgress();
               xinZiFragment = new XinZiFragment();
               loadTitle("薪资查询", View.VISIBLE, View.VISIBLE, View.GONE);
               loadFragment("xinZiFragment", xinZiFragment);
           } else {
               if (!SystemHelper.IsAdmin) {
//                    String info = bundle.getString("info");
//                    new LoginOnlineTask(UserActivity.this, "密码错误，正在进行远程验证", true, info).execute("");
                   HashMap<String, String> params = new HashMap<>();
                   params.put("storeNo", SystemHelper.LoginOrganId);
                   params.put("userNo", bundle.getString("userId"));
                   params.put("passWord", DeviceHelper.getMD5Str(bundle.getString("password")));
                   new BaseAppManageServerTask("LoginOnlineTask", LoginOnlineRes.class, UserActivity.this, "密码错误，正在进行远程验证...", true,
                           "/information/loginOnLine", params).execute("");
               } else {
                   showMsg("密码错误");
               }
           }
       }
   };*/
    private final Handler handler = new UserHandler(this);

    private static class UserHandler extends Handler {
        private final WeakReference<UserActivity> mActivity;

        private UserHandler(UserActivity activity) {
            mActivity = new WeakReference<>(activity);
        }

        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            final UserActivity userActivity = mActivity.get();
            if (userActivity != null) {
                Bundle bundle = msg.getData();
                boolean b = bundle.getBoolean("isPass");
                if (b) {
                    ViewUtil.dismissProgress();
                    userActivity.xinZiFragment = new XinZiFragment();
                    userActivity.loadTitle("正式薪资查询", View.VISIBLE, View.VISIBLE, View.GONE);
                    userActivity.loadFragment("xinZiFragment", userActivity.xinZiFragment);
                } else {
                    if (!SystemHelper.IsAdmin) {
//                    String info = bundle.getString("info");
//                    new LoginOnlineTask(UserActivity.this, "密码错误，正在进行远程验证", true, info).execute("");
                        HashMap<String, String> params = new HashMap<>();
                        params.put("storeNo", SystemHelper.LoginOrganId);
                        params.put("userNo", bundle.getString("userId"));
                        params.put("passWord", DeviceHelper.getMD5Str(bundle.getString("password")));
//                        new BaseAppManageServerTask("LoginOnlineTask", LoginOnlineRes.class, userActivity, "密码错误，正在进行远程验证...", true,
//                                "/information/loginOnLine", params).execute("");
                        ViewUtil.showProgress(userActivity,"提示","密码错误，正在进行远程验证...");
                        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPMANAGE.LOGIN_ONLINE,
                                params,
                                new OkHttpDominator.ResultCallback<LoginOnlineRes>() {
                                    @Override
                                    public void onError(Request request, Exception e) {
                                        ViewUtil.dismissProgress();
                                        e.printStackTrace();
                                        MyToast.show("网络异常: "+ e.toString());
                                    }

                                    @Override
                                    public void onResponse(LoginOnlineRes res) {
                                        ViewUtil.dismissProgress();
                                        if (res != null) {
                                            if ("0".equals(res.msgCode)) {
                                                userActivity.setXinZiFragment(new XinZiFragment());
                                                userActivity.loadFragment("xinZiFragment", userActivity.xinZiFragment);
                                            } else {
                                                userActivity.showMsg(res.msgInfo);
                                            }
                                        } else {
                                            userActivity.showMsg("远程验证失败");
                                        }

                                    }
                                });
                    } else {
                        userActivity.showMsg("密码错误");
                    }
                }
            }
        }
    }

    Unbinder unbinder;

    public void setXinZiFragment(XinZiFragment xinZiFragment){
        this.xinZiFragment = xinZiFragment;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user);
        unbinder = ButterKnife.bind(this);
        initTitle();
        selfCenterListPresenter = new UserPresenter(this);
        selfCenterListPresenter.start();

//		//验证是不是石家庄的门店，是，才给显示实时薪资查询，并做个Pre标记
//		checkIsShowNowXinZi();

        dealIntent();
    }

    //发送请求看是否显示实时薪资
//	public void checkIsShowNowXinZi(){
//		if(!SystemHelper.LoginOrganId.equals(
//							PreferHelper.getInstance().getString(AppConstants.PreKeys.SHOW_XINZI_STORE))){
//			Map<String,String > param = new HashMap<>();
//			param.put("storeId",SystemHelper.LoginOrganId);
//			new BaseAppServerTask("isShowNowXinZi",CheckIsShowXinZiRes.class,UserActivity.this,
//					"正在校验门店号...",true,"/frontDisplay/salary",param).execute("");
//		}else{
//			mLinearLayoutNowXinzi.setVisibility(View.VISIBLE);
//		}
//	}

    /**
     * 极光推送跳转到指定页面。
     */
    private void dealIntent() {
        Intent intent = getIntent();
        if (null != intent) {
            int message = intent.getIntExtra(AppConstants.ExtraKeys.PERSONAL_INFO_CONFIRM_TYPE_TAG, -1);
            if (message == 4) {
                launchFragment(selfCenterListPresenter.functionNames[4].funName);
            }
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText(SELF_CENTER_TITLE);
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if ("LoginOnlineTask".equals(tag)) {//其实这里已经没用了，不会调用了，因为上面已经改用OkhttpDominator回调了，不会走这里了。
            if (response != null) {
                LoginOnlineRes res = (LoginOnlineRes) response;
                if ("0".equals(res.msgCode)) {
                    xinZiFragment = new XinZiFragment();
                    loadFragment("xinZiFragment", xinZiFragment);
                } else {
                    showMsg("远程验证密码错误");
                }
            } else {
                showMsg("远程验证失败");
            }
        }
//        else if ("isShowNowXinZi".equals(tag)) {
//            if (response != null) {
//                CheckIsShowXinZiRes res = (CheckIsShowXinZiRes) response;
//                if (res.isResultInfo()) {//后台判断该门店是否显示实时薪资查询入口
//					mLinearLayoutNowXinzi.setVisibility(View.VISIBLE);
//                    PreferHelper.getInstance().setString(AppConstants.PreKeys.SHOW_XINZI_STORE, SystemHelper.LoginOrganId);
//                } else {
//					mLinearLayoutNowXinzi.setVisibility(View.GONE);
//                    PreferHelper.getInstance().setString(AppConstants.PreKeys.SHOW_XINZI_STORE, "");
//                }
//            }
//        }
        else {
            if (response != null) {
                selfCenterListPresenter.setRefresh(tag, response);
            }
        }
    }

    @Override
    public void init() {
        functions = selfCenterListPresenter.getFunctions();
//        SimpleAdapter simpleAdapter = new SimpleAdapter(UserActivity.this, functions,
//                R.layout.second_menu_item, new String[]{"text"}, new int[]{R.id.ItemText});
        //getFunctions中处理item权限，集合没有数据，就是所有item都没有权限，数据都手动加的，不存在有权限没有数据的情况。
        if (functions.size() == 0) {
            mEmptyView.setVisibility(View.VISIBLE);
            ((TextView) mEmptyView.findViewById(R.id.empty_view)).setText("暂无权限！");
        } else {
            mEmptyView.setVisibility(View.GONE);
            mSelfCenterAdapter = new UserInfoAdapter(this, functions);
            mSelfCenterLv.setAdapter(mSelfCenterAdapter);
            mSelfCenterLv.setOnItemClickListener(this);
            selfCenterListPresenter.checkIsShowShopData();//后台判断是否显示门店利润
        }
    }

    @Override
    public void refresh(String tag, BaseResponse response) {
//        if (("nianjia".equals(tag))) {
//            nianJiaFragment.refresh(tag, response);
//        } else if (("xinzi".equals(tag))) {
//            xinZiFragment.refresh(tag, response);
//        } else if ((QueryWenTiTask.TAG.equals(tag))) {
//            wenTiFragment.refresh(tag, response);
//        } else if ((QueryWenTiSerchTask.TAG.equals(tag))) {
//            wenTiSearchFragment.refresh(tag, response);
//        }
        if (("xinzi".equals(tag))) {
            xinZiFragment.refresh(tag, response);
        } else if ("functions".equals(tag) && mSelfCenterAdapter != null) {//刷新整个主功能表，即菜单入口
            mSelfCenterAdapter.notifyDataSetChanged();
        }
    }

    @Override
    public void setPresenter(UserContract.presenter presenter) {
        selfCenterListPresenter = (UserPresenter) presenter;
    }

    @Override
    public void onDestroy() {
        selfCenterListPresenter.onDestroy();
//        ButterKnife.unbind(this);
        unbinder.unbind();
        super.onDestroy();
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        String itemName = ((TextView)view.findViewById(R.id.ItemText)).getText().toString();
        launchFragment(itemName);
    }

    private void launchFragment(String itemName) {
//        final String title = functions.get(position).funName;
        //正式薪资查询
        if (itemName.equals(selfCenterListPresenter.functionNames[0].funName)){
            querySalaryDialog();

        //本月薪资预估
        }else if (itemName.equals(selfCenterListPresenter.functionNames[1].funName)){
            WebViewAct.launch(UserActivity.this,
                    SystemHelper.LoginUserId,
                    "本月薪资预估",
                    String.format(NetParam.MONTH_SALARY_REALTIME_QUERY,
                            SystemHelper.LoginUserId,
                            SystemHelper.LoginUserName));

        //薪资计算器
        }else if (itemName.equals(selfCenterListPresenter.functionNames[2].funName)){
            Intent intent = new Intent();
//                intent.putExtra(WebViewAct.SHOW_RIGHT_BUTTON, "重新计算");//显示右上按钮
            intent.putExtra(WebViewAct.LOAD_NO_CACHE, true);
            WebViewAct.launch(UserActivity.this,
                    SystemHelper.LoginUserId,
                    "薪资计算器",
                    String.format(NetParam.SALARY_CALCULATOR,
                            SystemHelper.LoginUserId,
                            SystemHelper.LoginUserName),
                    intent);

        //流动顾问销售完成情况
        }else if (itemName.equals(selfCenterListPresenter.functionNames[3].funName)){
            mSelfCenterLv.setVisibility(View.INVISIBLE);
            FlowSalesPersonCompletionFra flowSalesPersonCompletionFra = new FlowSalesPersonCompletionFra();
            loadTitle(itemName, View.VISIBLE, View.VISIBLE, View.GONE);
            loadFragment("flowSalesPersonCompletionFra", flowSalesPersonCompletionFra);

        //年终奖查询
        }else if (itemName.equals(selfCenterListPresenter.functionNames[4].funName)){
            mSelfCenterLv.setVisibility(View.INVISIBLE);
            final YearAwardFra yearAwardFra = new YearAwardFra();
            loadTitle(itemName, View.VISIBLE, View.VISIBLE, View.GONE);
            loadFragment("YearAwardFra", yearAwardFra);
            confirmBtn.setVisibility(View.VISIBLE);
            confirmBtn.setText("说明");
            confirmBtn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if ("年终奖查询".equals(titleTextView.getText().toString())) {
                        YearAwardHintAct.launch(UserActivity.this, yearAwardFra.getCopywriter());
//                            startActivity(new Intent(UserActivity.this, YearAwardHintAct.class));
                    }
                }
            });

        //门店利润查询
        }else if (itemName.equals(selfCenterListPresenter.functionNames[5].funName)){
            WebViewAct.launch(UserActivity.this,
                    SystemHelper.LoginUserId,
                    "门店利润查询",
                    String.format(NetParam.MEMBER_STORE_PROFIT,
                            SystemHelper.LoginOrganName,
                            SystemHelper.LoginUserId,
                            SystemHelper.LoginUserName,
                            SystemHelper.LoginOrganId));

        //联营门店利润查询
        }else if (itemName.equals(selfCenterListPresenter.functionNames[6].funName)){
            if (selfCenterListPresenter != null && selfCenterListPresenter.shopDataRes != null
                    && selfCenterListPresenter.shopDataRes.getResultInfo() != null
                    && selfCenterListPresenter.shopDataRes.getResultInfo().getUnionOperationUrl() != null){
                WebViewAct.launch(UserActivity.this,
                        SystemHelper.LoginUserId,
                        "联营门店利润报表",
                        String.format(selfCenterListPresenter.shopDataRes.getResultInfo().getUnionOperationUrl(),
//                                    SystemHelper.LoginOrganName,
//                                    SystemHelper.LoginUserId,
//                                    SystemHelper.LoginUserName,
                                SystemHelper.LoginOrganId));
            }
        }


//        switch (position) {
//            case 0:
//                querySalaryDialog();
//                break;
//            case 1:
//                WebViewAct.launch(UserActivity.this,
//                        SystemHelper.LoginUserId,
//                        "本月薪资预估",
//                        String.format(NetParam.MONTH_SALARY_REALTIME_QUERY,
//                                SystemHelper.LoginUserId,
//                                SystemHelper.LoginUserName));
//
//                break;
//            case 2:
//                Intent intent = new Intent();
////                intent.putExtra(WebViewAct.SHOW_RIGHT_BUTTON, "重新计算");//显示右上按钮
//                intent.putExtra(WebViewAct.LOAD_NO_CACHE, true);
//                WebViewAct.launch(UserActivity.this,
//                        SystemHelper.LoginUserId,
//                        "薪资计算器",
//                        String.format(NetParam.SALARY_CALCULATOR,
//                                SystemHelper.LoginUserId,
//                                SystemHelper.LoginUserName),
//                        intent);
//                break;
//
//            //流动顾问销售完成情况
//            case 3:
//                mSelfCenterLv.setVisibility(View.INVISIBLE);
//                FlowSalesPersonCompletionFra flowSalesPersonCompletionFra = new FlowSalesPersonCompletionFra();
//                loadTitle(title, View.VISIBLE, View.VISIBLE, View.GONE);
//                loadFragment("flowSalesPersonCompletionFra", flowSalesPersonCompletionFra);
//                break;
//            //年终奖查询
//            case 4:
//                mSelfCenterLv.setVisibility(View.INVISIBLE);
//                final YearAwardFra yearAwardFra = new YearAwardFra();
//                loadTitle(title, View.VISIBLE, View.VISIBLE, View.GONE);
//                loadFragment("YearAwardFra", yearAwardFra);
//                confirmBtn.setVisibility(View.VISIBLE);
//                confirmBtn.setText("说明");
//                confirmBtn.setOnClickListener(new View.OnClickListener() {
//                    @Override
//                    public void onClick(View v) {
//                        if ("年终奖查询".equals(titleTextView.getText().toString())) {
//                            YearAwardHintAct.launch(UserActivity.this, yearAwardFra.getCopywriter());
////                            startActivity(new Intent(UserActivity.this, YearAwardHintAct.class));
//                        }
//                    }
//                });
//                break;
//            case 5:
//                WebViewAct.launch(UserActivity.this,
//                        SystemHelper.LoginUserId,
//                        "门店利润查询",
//                        String.format(NetParam.MEMBER_STORE_PROFIT,
//                                SystemHelper.LoginOrganName,
//                                SystemHelper.LoginUserId,
//                                SystemHelper.LoginUserName,
//                                SystemHelper.LoginOrganId));
//                break;
//            case 6:
//                if (selfCenterListPresenter != null && selfCenterListPresenter.shopDataRes != null
//                        && selfCenterListPresenter.shopDataRes.getResultInfo() != null
//                        && selfCenterListPresenter.shopDataRes.getResultInfo().getUnionOperationUrl() != null){
//                    WebViewAct.launch(UserActivity.this,
//                            SystemHelper.LoginUserId,
//                            "联营门店利润报表",
//                            String.format(selfCenterListPresenter.shopDataRes.getResultInfo().getUnionOperationUrl(),
////                                    SystemHelper.LoginOrganName,
////                                    SystemHelper.LoginUserId,
////                                    SystemHelper.LoginUserName,
//                                    SystemHelper.LoginOrganId));
//                }
//                break;
////            case 4:
////                nianJiaFragment = new AnnualVacationAct();
////                loadTitle(title, View.VISIBLE, View.VISIBLE, View.GONE);
////                loadFragment("nianJiaFragment", nianJiaFragment);
////                break;
////            case 5:
////                PersonalFragment personalFragment = new PersonalFragment();
////                loadTitle(title, View.VISIBLE, View.VISIBLE, View.GONE);
////                loadFragment("personalFragment", personalFragment);
////                break;
////            case 6:
////                LeaveApplicationFormFragment leaveApplicationFormFragment = new LeaveApplicationFormFragment();
////                loadTitle(title, View.VISIBLE, View.VISIBLE, View.GONE);
////                loadFragment("leaveApplicationFormFragment", leaveApplicationFormFragment);
////                break;
////            case 7:
////                LeaveApplicationQueryFragment leaveApplicationQueryFragment = new LeaveApplicationQueryFragment();
////                loadTitle(title, View.VISIBLE, View.VISIBLE, View.GONE);
////                loadFragment("leaveApplicationQueryFragment", leaveApplicationQueryFragment);
////                break;
////            case 6:
////                wenTiFragment = new WenTiFragment();
////                loadTitle(title, View.VISIBLE, View.VISIBLE, View.VISIBLE);
////                loadFragment("wenTiFragment", wenTiFragment);
////                settinButton.setImageResource(R.drawable.wenti_sousuo);
////                settinButton.setVisibility(View.VISIBLE);
////                settinButton.setOnClickListener(new View.OnClickListener() {
////
////                    @Override
////                    public void onClick(View v) {
////                        wenTiSearchFragment = new WenTiSearchFragment();
////                        loadFragment("wenTiSearchFragment", wenTiSearchFragment);
////                        loadTitle(title, View.GONE, View.VISIBLE, View.GONE);
////                    }
////                });
////                break;
//            default:
//                break;
//        }
    }

    private void querySalaryDialog() {
        AlertDialog.Builder builder = new AlertDialog.Builder(UserActivity.this);
        final EditText et = new EditText(UserActivity.this);
        et.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_VARIATION_PASSWORD);
        builder.setTitle("请输入登陆密码").setView(et).setNegativeButton("取消", null).setPositiveButton("确定", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                final String password = et.getText().toString().trim();
                if (TextUtils.isEmpty(password)) {
                    showMsg("请输入密码");
                } else {
                    dialog.dismiss();
                    ViewUtil.showProgress(UserActivity.this, "提示", "正在验证密码");
                    ThreadManager.getThreadPool().execute(new Runnable() {
                        @Override
                        public void run() {
                            boolean b;
//                            if (SystemHelper.IsAdmin) {
//                                b = Czyda001DbOperate.LoginCheckBanShiChi(SystemHelper.LoginOrganId, SystemHelper.LoginUserId, password);
//                            } else {
                            b = Czyda001DbOperate.LoginCheck(SystemHelper.LoginOrganId, SystemHelper.LoginUserId, password);
//                            }
                            Message msg = Message.obtain();
//                            String info = " where u.login='" + SystemHelper.LoginUserId + "' and password='" + password + "'";
                            Bundle bundle = new Bundle();
//                            bundle.putString("info", info);
                            bundle.putString("userId", SystemHelper.LoginUserId);
                            bundle.putString("password", password);
                            bundle.putBoolean("isPass", b);
                            msg.setData(bundle);
                            handler.sendMessage(msg);
                        }
                    });
                }
            }

        }).create().show();
    }

    /**
     * 加载标题
     *
     * @param title            标题文字
     * @param bgVisibility     标题是否显示
     * @param backVisibility   返回按钮是否显示
     * @param settinVisibility 设置按钮是否显示
     */

    public void loadTitle(String title, int bgVisibility, int backVisibility, int settinVisibility) {
        titleTextView.setText(title);
        titile_bg.setVisibility(bgVisibility);
        back.setVisibility(backVisibility);
        settinButton.setVisibility(settinVisibility);
    }

    /**
     * 加载内容
     *
     * @param tag      标签
     * @param fragment 内容
     */
    public void loadFragment(String tag, BackHandledFragment fragment) {
        FragmentManager fm = getSupportFragmentManager();
        FragmentTransaction ft = fm.beginTransaction();
        ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
        ft.replace(R.id.self_center_content_frg, fragment);
        ft.addToBackStack(tag);
        ft.commit();
    }

    @Override
    public void setSelectedFragment(BackHandledFragment selectedFragment) {
        this.mBackHandedFragment = selectedFragment;
    }

    @Override
    public void onBackPressed() {
        if (mBackHandedFragment == null || !mBackHandedFragment.onBackPressed()) {
//            if ("常见问题解答".equals(titleTextView.getText().toString())) {
//                loadTitle(titleTextView.getText().toString(), View.VISIBLE, View.VISIBLE, View.VISIBLE);
//            }
//            if ("流动顾问销售完成情况".equals(titleTextView.getText().toString())) {
            mSelfCenterLv.setVisibility(View.VISIBLE);
            if ("年终奖查询".equals(titleTextView.getText().toString())) {
                confirmBtn.setVisibility(View.GONE);
            }
//            }
            if (getFragmentManager().getBackStackEntryCount() == 0) {
                super.onBackPressed();
            } else {
                if (getFragmentManager().getBackStackEntryCount() == 1) {
                    loadTitle(SELF_CENTER_TITLE, View.VISIBLE, View.VISIBLE, View.GONE);
                }
                getFragmentManager().popBackStack();
            }
        }
    }

    @Override
    protected void back() {
        //使Fragment界面一级级返回
        onBackPressed();
    }
}
