package com.urovo.activity.user;

import android.content.Context;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;
import com.umeng.socialize.utils.BitmapUtils;
import com.urovo.wgmf.AsyncTask.QueryWenTiTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.dao.QuOperate;
import com.urovo.wgmf.db.dao.entitys.ChangJianWenTiEntity;
import com.urovo.wgmf.db.dao.entitys.QuDb;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.data.PrefTool;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.Prefs;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 作者：xiep on 2017/3/2 14:48
 * 邮箱：2975837870@qq.com
 */

public class WenTiFragment extends BackHandledFragment implements AdapterView.OnItemClickListener {

    @BindView(R.id.lv_user_wenti_content)
    ListView lvUserWentiContent;
    private MyAdapter adapter;
    private List<BaseModel> mBaseModel = new ArrayList<>();
    private List<ChangJianWenTiEntity.ChangJianWenTiReturnList> tempList = new ArrayList<>();
    private int mPage = 1;
    private BitmapUtils bitmapUtils;
    Date date = new Date();
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    private List<QuDb> list = QuOperate.selectBy(null);
    Unbinder unbinder;
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.activity_user_wenti, container, false);
        unbinder = ButterKnife.bind(this, view);
        selfCenterListPresenter = new UserPresenter(this);
        selfCenterListPresenter.start();
        return view;
    }

    @Override
    public void init() {// 先从缓存中读取数据并展示
        String cache = PrefTool.getStringPerferences(getActivity(), Prefs.WENTI_FIND_HISTORY, "");
        if (null != list && list.size() > 0 && cache.equals(sdf.format(date))) {
            mBaseModel.clear();
            mPage = 0;
            for (int i = 0; i < list.size(); i++) {
                QuDb db = list.get(i);
                BaseModel cell = new BaseModel();
                cell.question_id = db.mId;
                cell.question_title = db.mTitle;
                cell.question_content = db.mContent;
                cell.question_imagePath = db.mImagePath;
                cell.question_releaseTime = db.mReleaseTime;
                cell.question_problemId = db.mProblemId;
                mBaseModel.add(cell);
            }
        } else {
            requestWentiTask(mPage);
        }
        adapter = new MyAdapter(mBaseModel, getActivity());
        lvUserWentiContent.setAdapter(adapter);

        lvUserWentiContent.setOnScrollListener(new AbsListView.OnScrollListener() {

            @Override
            public void onScrollStateChanged(AbsListView view, int scrollState) {
                if (scrollState == AbsListView.OnScrollListener.SCROLL_STATE_IDLE) {
                    if (view.getLastVisiblePosition() == view.getCount() - 1) {
                        mPage = mPage + 1;
                        requestWentiTask(mPage);
                    }
                }
            }

            @Override
            public void onScroll(AbsListView arg0, int arg1, int arg2, int arg3) {

            }
        });
        lvUserWentiContent.setOnItemClickListener(this);
    }

    private void requestWentiTask(int page) {
        Map<String, String> params = new HashMap<String, String>();
        params.put("pageNo", String.valueOf(page));
        new QueryWenTiTask((UserActivity) getActivity(), "正在加载...", true, params).execute("");
    }

    private class BaseModel {
        String question_id;
        String question_title;
        String question_content;
        String question_releaseTime;
        String question_problemId;
        String question_imagePath;
    }

    class ViewHolder {
        TextView tv_question_title;
        TextView tv_question_content;
        ImageView iv_question_imagepath;
        ImageView iv_question_imagepathgo;
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        private int mLastPosition = -1;

        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
//            bitmapUtils = new BitmapUtils(context);
            /**
             * 按照问题录入的时间排序，先录的显示在后面
             */
            Collections.sort(lists, new Comparator<BaseModel>() {

                @Override
                public int compare(BaseModel lhs, BaseModel rhs) {

                    if (StringUtils.toLong(lhs.question_releaseTime) > StringUtils.toLong(rhs.question_releaseTime)) {
                        return -1;
                    } else if (lhs.question_releaseTime.equals(rhs.question_releaseTime)) {
                        return 0;
                    } else {
                        return 1;
                    }
                }
            });
        }

        @Override
        public View getView(final int position, View convertView, ViewGroup parent) {
            final ViewHolder viewHolder;
            if (convertView == null) {
                convertView = LayoutInflater.from(context).inflate(R.layout.listview_user_wenti_item, null);
                viewHolder = new ViewHolder();
                viewHolder.tv_question_title = (TextView) convertView.findViewById(R.id.textViewTitle);
                viewHolder.tv_question_content = (TextView) convertView.findViewById(R.id.textViewContent);
                viewHolder.iv_question_imagepath = (ImageView) convertView.findViewById(R.id.imageViewContent);
                viewHolder.iv_question_imagepathgo = (ImageView) convertView.findViewById(R.id.imageViewButton);
                convertView.setTag(viewHolder);
            } else {
                viewHolder = (ViewHolder) convertView.getTag();
            }
            final BaseModel cell = mBaseModel.get(position);
            viewHolder.tv_question_title.setText(cell.question_title);
            viewHolder.tv_question_content.setText(cell.question_content);

            //先统一隐藏起来，再根据位置来判断是否显示
            viewHolder.tv_question_content.setVisibility(View.GONE);
            viewHolder.iv_question_imagepath.setVisibility(View.GONE);
            viewHolder.iv_question_imagepathgo.setImageResource(R.drawable.list_group_open);

            //如果是当前点击的位置
            if (position == mLastPosition) {
                if (null != cell.question_imagePath) {
                    Picasso.with(context).load(cell.question_imagePath).placeholder(R.drawable.wenti_default_img).into(viewHolder.iv_question_imagepath);
                    viewHolder.iv_question_imagepath.setVisibility(View.VISIBLE);
                }
                if(!TextUtils.isEmpty(cell.question_content)){
                    viewHolder.tv_question_content.setVisibility(View.VISIBLE);
                }
                viewHolder.iv_question_imagepathgo.setImageResource(R.drawable.list_group_close);
            }
            return convertView;
        }

        void changeImageVisable(int position) {
            if (position != mLastPosition) {
                mLastPosition = position;
            } else {
                mLastPosition = -1;
            }
            notifyDataSetChanged();
        }
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        adapter.changeImageVisable(position);
    }

    @Override
    public void refresh(String tag, BaseResponse response) {
        if (null != response) {
            ChangJianWenTiEntity changJianWenTiEntity = (ChangJianWenTiEntity) response;
            List<ChangJianWenTiEntity.ChangJianWenTiReturnList> entitys = changJianWenTiEntity.resultList;
            mBaseModel.clear();
            if (null != entitys && entitys.size() > 0) {
                for (ChangJianWenTiEntity.ChangJianWenTiReturnList mLists : entitys) {
                    tempList.add(mLists);
                }
            }
            if (entitys.size() < 10) {
                showMsg("加载完毕,无更多数据");
            }
        }
        processData(tempList);
        adapter.notifyDataSetChanged();
    }

    @Override
    protected boolean onBackPressed() {
        return false;
    }

    /**
     * 解析数据
     */
    private void processData(List<ChangJianWenTiEntity.ChangJianWenTiReturnList> entitys) {
        for (int j = 0; j < entitys.size(); j++) {
            BaseModel cell = new BaseModel();
            cell.question_id = entitys.get(j).id;
            cell.question_title = entitys.get(j).title;
            cell.question_content = entitys.get(j).content;
            cell.question_releaseTime = entitys.get(j).releaseTime;
            cell.question_problemId = entitys.get(j).problemId;
            cell.question_imagePath = entitys.get(j).imagePath;
            mBaseModel.add(cell);
            QuDb cells = new QuDb();
            cells.mId = entitys.get(j).id;
            cells.mTitle = entitys.get(j).title;
            cells.mContent = entitys.get(j).content;
            cells.mReleaseTime = entitys.get(j).releaseTime;
            cells.mProblemId = entitys.get(j).problemId;
            cells.mImagePath = entitys.get(j).imagePath;
            QuOperate.Insert(cells);
            PrefTool.setStringsave(getActivity(), Prefs.WENTI_FIND_HISTORY, sdf.format(date));
        }
    }


    @Override
    public void onDestroyView() {
//        ButterKnife.unbind(this);
        unbinder.unbind();
        super.onDestroyView();
    }
}
