package com.urovo.activity.user;

import android.content.Context;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;
import com.urovo.wgmf.AsyncTask.QueryWenTiSerchTask;
import com.urovo.wgmf.adapter.MyBaseAdapter;
import com.urovo.wgmf.db.dao.entitys.ChangJianWenTiEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.data.PrefTool;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.Prefs;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 作者：xiep on 2017/3/2 14:48
 * 邮箱：2975837870@qq.com
 */

public class WenTiSearchFragment extends BackHandledFragment implements AdapterView.OnItemClickListener, View.OnClickListener {

    @BindView(R.id.bt_search)
    Button btSearch;
    @BindView(R.id.iv_search_logo)
    ImageView ivSearchLogo;
    @BindView(R.id.et_search_number)
    EditText etSearchNumber;
    @BindView(R.id.lv_search_history)
    ListView lvSearchHistory;
    @BindView(R.id.lv_search_result)
    ListView lvSearchResult;
    @BindView(R.id.bt_back)
    ImageButton btBack;

    private String[] newArrays;
    private ArrayAdapter<String> arr_adapter;
    private MyAdapter ret_adapter;
    private List<BaseModel> mBaseModel = new ArrayList<>();
    Unbinder unbinder;
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.activity_user_search, container, false);
        unbinder = ButterKnife.bind(this, view);
        selfCenterListPresenter = new UserPresenter(this);
        selfCenterListPresenter.start();
        view.setClickable(true);// 防止点击穿透，底层的fragment响应上层点击触摸事件
        return view;
    }

    @Override
    public void init() {
        btSearch.setOnClickListener(this);
        btBack.setOnClickListener(this);
        String history = PrefTool.getStringPerferences(getActivity(), Prefs.SEARCH_WENTI_HISTORY, "");
        if (!"".equals(history)) {
            // 用逗号分割内容返回数组
            String[] history_arr = history.split(",");
            newArrays = new String[20];
            // 保留前20条数据
            if (history_arr.length > 20) {
                // 实现数组之间的复制
                System.arraycopy(history_arr, 0, newArrays, 0, 20);
            } else {
                newArrays = history_arr;
            }
        } else {
            newArrays = new String[0];
        }

        View v = View.inflate(getActivity(), R.layout.history_foot_view, null);
        lvSearchHistory.addFooterView(v);
        TextView tv = (TextView) v.findViewById(R.id.texthistory);
        if (!"".equals(history)) {
            tv.setText("清除历史记录");
        } else {
            tv.setText("无历史记录");
        }

        arr_adapter = new ArrayAdapter<>(getActivity(), R.layout.simple_dropdown_item_1line, newArrays);
        ret_adapter = new MyAdapter(mBaseModel, getActivity());
        lvSearchResult.setAdapter(ret_adapter);
        lvSearchResult.setOnItemClickListener(this);
        // 设置适配器
        lvSearchHistory.setAdapter(arr_adapter);

        v.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                PrefTool.deleteSPByName(getActivity(), Prefs.SEARCH_WENTI_HISTORY);
                TextView tv = (TextView) v.findViewById(R.id.texthistory);
                showMsg("清除成功");
                tv.setText("无历史记录");
                newArrays = new String[0];
                arr_adapter = new ArrayAdapter<>(getActivity(), R.layout.simple_dropdown_item_1line, newArrays);
                // 设置适配器
                lvSearchHistory.setAdapter(arr_adapter);
            }
        });

        historyLvSetData();

        etSearchNumber.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (newArrays != null) {
                    String str = etSearchNumber.getText().toString().trim();
                    List<String> alist = new ArrayList<>();
                    String[] ne2 = new String[20];
                    ne2 = newArrays;
                    for (int i = 0; i < newArrays.length; i++) {
                        if (newArrays[i].startsWith(str)) {
                            alist.add(newArrays[i]);
                        }
                    }
                    String results[] = new String[alist.size()];
                    newArrays = alist.toArray(results);
                    updateListView();
                    newArrays = ne2;
                }
            }
        });
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bt_search:
                String searchtext = etSearchNumber.getText().toString().trim();
                searchKey(searchtext);
                break;
            case R.id.bt_back:
                ((UserActivity) getActivity()).back();
                break;
            default:
                break;
        }
    }

    private class MyAdapter extends MyBaseAdapter<BaseModel, ListView> {
        private int mLastPosition = -1;

        public MyAdapter(List<BaseModel> lists, Context context) {
            super(lists, context);
            /**
             * 按照问题录入的时间排序，先录的显示在后面
             */
            Collections.sort(lists, new Comparator<BaseModel>() {

                @Override
                public int compare(BaseModel lhs, BaseModel rhs) {

                    if (StringUtils.toLong(lhs.question_releaseTime) > StringUtils.toLong(rhs.question_releaseTime)) {
                        return -1;
                    } else if (lhs.question_releaseTime.equals(rhs.question_releaseTime)) {
                        return 0;
                    } else {
                        return 1;
                    }
                }
            });
        }

        @Override
        public View getView(final int position, View convertView, ViewGroup parent) {
            final ViewHolder viewHolder;
            if (convertView == null) {
                convertView = LayoutInflater.from(context).inflate(R.layout.listview_user_wenti_item, null);
                viewHolder = new ViewHolder();
                viewHolder.tv_question_title = (TextView) convertView.findViewById(R.id.textViewTitle);
                viewHolder.tv_question_content = (TextView) convertView.findViewById(R.id.textViewContent);
                viewHolder.iv_question_imagepath = (ImageView) convertView.findViewById(R.id.imageViewContent);
                viewHolder.iv_question_imagepathgo = (ImageView) convertView.findViewById(R.id.imageViewButton);
                convertView.setTag(viewHolder);
            } else {
                viewHolder = (ViewHolder) convertView.getTag();
            }
            final BaseModel cell = mBaseModel.get(position);
            viewHolder.tv_question_title.setText(cell.question_title);
            viewHolder.tv_question_content.setText(cell.question_content);
            if (position == mLastPosition) {
                if (null != cell.question_imagePath) {
                    viewHolder.iv_question_imagepath.setImageResource(R.drawable.wenti_default_img);
                    viewHolder.iv_question_imagepath.setVisibility(View.VISIBLE);
//                    bitmapUtils.display(viewHolder.iv_question_imagepath, cell.question_imagePath);
                    Picasso.with(context).load(cell.question_imagePath).into(viewHolder.iv_question_imagepath);
                } else {
                    viewHolder.tv_question_content.setVisibility(View.VISIBLE);
                    viewHolder.iv_question_imagepath.setVisibility(View.GONE);
                }
                viewHolder.iv_question_imagepathgo.setImageResource(R.drawable.list_group_close);
            } else {
                viewHolder.iv_question_imagepathgo.setImageResource(R.drawable.list_group_open);
                viewHolder.tv_question_content.setVisibility(View.GONE);
                viewHolder.iv_question_imagepath.setVisibility(View.GONE);
            }
            return convertView;
        }

        void changeImageVisable(int position) {
            if (position != mLastPosition) {
                mLastPosition = position;
            } else {
                mLastPosition = -1;
            }
            notifyDataSetChanged();
        }
    }

    private class BaseModel {
        String question_id;
        String question_title;
        String question_content;
        String question_releaseTime;
        String question_problemId;
        String question_imagePath;
    }

    class ViewHolder {
        TextView tv_question_title;
        TextView tv_question_content;
        ImageView iv_question_imagepath;
        ImageView iv_question_imagepathgo;
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        ret_adapter.changeImageVisable(position);
    }

    private void updateListView() {
        arr_adapter = new ArrayAdapter<>(getActivity(), R.layout.simple_dropdown_item_1line, newArrays);
        // 设置适配器
        lvSearchHistory.setAdapter(arr_adapter);
        lvSearchHistory.setVisibility(View.VISIBLE);
        lvSearchResult.setVisibility(View.GONE);
        historyLvSetData();
    }

    private void historyLvSetData() {
        lvSearchHistory.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                TextView tv = (TextView) view.findViewById(R.id.text1);
                String key;
                try {
                    key = tv.getText().toString();
                    etSearchNumber.setText(key);
                    etSearchNumber.setSelection(etSearchNumber.getText().length());
                    searchKey(key);
                } catch (Exception e) {
                    BaseAppManager.loger().info(e);
                }
            }
        });
    }

    public void searchKey(String text) {
        if (TextUtils.isEmpty(text)) {
            showMsg("请输入关键词！");
            // ToSerchQuestion(text);
        } else {
            String old_text = PrefTool.getStringPerferences(getActivity(), Prefs.SEARCH_WENTI_HISTORY, "");
            String[] history_arr = old_text.split(",");
            StringBuilder builder = new StringBuilder();
            builder.append(text + ",");
            for (int i = 0; i < 19 && i < history_arr.length; i++) {
                if (!text.equals(history_arr[i])) {
                    builder.append(history_arr[i] + ",");
                }
            }
            PrefTool.setStringsave(getActivity(), Prefs.SEARCH_WENTI_HISTORY, builder.toString());
            ToSerchQuestion(text);
        }
    }

    /**
     * 根据关键词搜索常见问题
     *
     * @param text 关键词
     */
    private void ToSerchQuestion(String text) {
        etSearchNumber.clearFocus();
        InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(etSearchNumber.getWindowToken(), 0);

        Map<String, String> params = new HashMap<>();
        params.put("key", text);// 关键词
        new QueryWenTiSerchTask((UserActivity) getActivity(), "正在搜索...", true, params).execute("");

    }

    @Override
    public void refresh(String tag, BaseResponse response) {
        if (null != response) {
            ChangJianWenTiEntity changJianWenTiEntity = (ChangJianWenTiEntity) response;
            List<ChangJianWenTiEntity.ChangJianWenTiReturnList> entitys = changJianWenTiEntity.resultList;
            mBaseModel.clear();
            if (null != entitys && entitys.size() > 0) {
                lvSearchResult.setVisibility(View.VISIBLE);
                lvSearchHistory.setVisibility(View.GONE);
                for (int j = 0; j < entitys.size(); j++) {
                    BaseModel cell = new BaseModel();
                    cell.question_id = entitys.get(j).id;
                    cell.question_title = entitys.get(j).title;
                    cell.question_content = entitys.get(j).content;
                    cell.question_releaseTime = entitys.get(j).releaseTime;
                    cell.question_problemId = entitys.get(j).problemId;
                    cell.question_imagePath = entitys.get(j).imagePath;
                    mBaseModel.add(cell);
                }
            } else {
                showMsg("抱歉，未找到结果");
                return;
            }
        }
        ret_adapter.notifyDataSetChanged();
    }

    @Override
    protected boolean onBackPressed() {
        return false;
    }

    @Override
    public void onDestroyView() {
//        ButterKnife.unbind(this);
        unbinder.unbind();
        super.onDestroyView();
    }
}
