package com.urovo.activity.user.adapter;

import android.annotation.SuppressLint;
import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;

import com.urovo.activity.user.bean.LeaveApplicationBean;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import androidx.recyclerview.widget.RecyclerView;

/**
 * Created by chenji on 2017/8/8.
 * 离职申请 Adapter
 */

public class LeaveApplicationFormAdapter extends RecyclerView.Adapter<LeaveApplicationFormAdapter.ItemViewHolder> {
    private Context context;
    private boolean mCommitFlag = true;
    @SuppressLint("UseSparseArrays")
    private Map<Integer, Boolean> map = new HashMap<>();
    @SuppressLint("UseSparseArrays")
    private Map<Integer, Integer> isShow = new HashMap<>();
    private List<LeaveApplicationBean.LeavingReasonBean> datas;
    private List<LeaveApplicationBean.LeavingReasonBean> seletorString = new ArrayList<>();
    private OnChangeBackGroundListener mOnChangeBackGroundListener;// 提交按钮的监听器

    public LeaveApplicationFormAdapter(Context context, List<LeaveApplicationBean.LeavingReasonBean> datas) {
        this.datas = datas;
        this.context = context;
    }

    @SuppressWarnings("unused")
    public void addData(LeaveApplicationBean.LeavingReasonBean str) {
        datas.add(datas.size(), str);
        notifyItemInserted(datas.size());
    }

    @SuppressWarnings("unused")
    public void addDatas(List<LeaveApplicationBean.LeavingReasonBean> strs) {
        datas.addAll(datas.size(), strs);
        //方法一
        notifyItemInserted(datas.size());
        //方法二
//        notifyItemRangeInserted(datas.size(),strs.size());
    }

    @Override
    public ItemViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.leave_layout_item, parent, false);
        return new ItemViewHolder(view);
    }

    @Override
    public void onBindViewHolder(final ItemViewHolder holder, @SuppressLint("RecyclerView") final int position) {
        //强制关闭复用
//        holder.setIsRecyclable(false);
        holder.tv.setText(datas.get(position).getName());

        if (holder.et.getTag() instanceof TextWatcher) {
            holder.et.removeTextChangedListener((TextWatcher) holder.et.getTag());
        }
        holder.tv.setTag(position);
        if (isShow.containsKey(position)) {
            holder.et.setVisibility(isShow.get(position) == View.VISIBLE ? View.VISIBLE : View.GONE);
        } else {
            holder.et.setVisibility(View.GONE);
        }
        holder.tv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (holder.et.isShown()) {
                    holder.et.setVisibility(View.GONE);
                    isShow.put(position, View.GONE);

                    //===========隐藏CheckBox=============
                    holder.cb.setChecked(false);
                    map.put(position, false);
                    seletorString.remove(datas.get(position));
                    //===========隐藏CheckBox============
                } else {
                    holder.et.setVisibility(View.VISIBLE);
                    isShow.put(position, View.VISIBLE);

                    // ============显示CheckBox=========
                    holder.cb.setChecked(true);
                    map.put(position, true);
                    seletorString.add(datas.get(position));
                    // ============显示CheckBox============
                }
                checkLeaveInfo();
            }
        });

        holder.et.setText(datas.get(position).getReason());//显示离职理由

        //checkbox  复用问题
        holder.cb.setTag(position);
        if (map.containsKey(position)) {
            holder.cb.setChecked(map.get(position));
        } else {
            holder.cb.setChecked(false);
        }

//      如果发生未知bug,recycleview滑动时触发复用机制，会重新当前方法，并执行以下
        if (seletorString.size() == 0) {// 提交按钮颜色变化监听
            mOnChangeBackGroundListener.onChageBackGround(false);
        }

        holder.cb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (holder.cb.isChecked()) {

//               =================显示edittext===============
                    holder.et.setVisibility(View.VISIBLE);
                    isShow.put(position, View.VISIBLE);
//               =================显示edittext===============

                    map.put(position, true);
                    seletorString.add(datas.get(position));
//                    SYLoger.print("add: " + seletorString);
                } else {
//                 =================隐藏edittext===============
                    holder.et.setVisibility(View.GONE);
                    isShow.put(position, View.GONE);
//                 =================隐藏edittext===============

                    map.put(position, false);//checkbox 隐藏
                    if (seletorString.size() != 0) { // 删除上传数据
                        seletorString.remove(datas.get(position));
//                        SYLoger.print("remove: " + seletorString);
                    }
                }
                checkLeaveInfo();
            }


        });
        TextWatcher textWatcher = new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                datas.get(position).setReason(holder.et.getText().toString().trim());
//                SYLoger.print("edittext 有内容: " + holder.et.getText().toString().trim());
                mCommitFlag = !holder.et.getText().toString().trim().equals("");
            }
        };
        holder.et.addTextChangedListener(textWatcher);
        holder.et.setTag(textWatcher);
    }

    /**
     * 选择离职信息的规则和提交按钮的颜色变化监听器。
     */
    private void checkLeaveInfo() {
        if (seletorString != null) {
            // 提交按钮颜色变化监听 (mCommitCheckBtn)
            if (seletorString.size() != 0) {
//                        SYLoger.print("seletorString.size() != 0: " + seletorString);
                mOnChangeBackGroundListener.onChageBackGround(true);
            } else {
//                        SYLoger.print("seletorString.size() == 0: " + seletorString);
                mOnChangeBackGroundListener.onChageBackGround(false);
            }
//            for (int i = 1; i < datas.size(); i++) {
//                if (seletorString.size() == i) {
//                    executeChecked();
//                }
//            }

            // 寻找“其他”选项
            switch (seletorString.size()) {
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                    executeChecked();
                    break;
                default:
                    break;
            }
//                    if (seletorString.size() == 1) {
//                        mCommitFlag = !seletorString.get(0).getName().equals("其他") || !seletorString.get(0).getReason().equals("");
////                        SYLoger.print("one: " + seletorString);
//                    }
////                    if (seletorString.size()==0){
//////                        nothing
////                    }
//                    if (seletorString.size() == 2) {
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
//////                            if (mCommitFlag){
//////                               SYLoger.print( "第一个其他 有内容");
//////                            }else {
//////                               SYLoger.print( "第一个其他 没有内容");
//////                            }
////                        } else {
////                            mCommitFlag = !seletorString.get(1).getName().equals("其他") || !seletorString.get(1).getLeaveReason().equals("");
//////                            if (mCommitFlag){
//////                               SYLoger.print( "第二个其他 有内容");
//////                            }else {
//////                               SYLoger.print( "第二个其他 没有内容");
//////                            }
////                        }
//                        executeChecked();
////                        SYLoger.print("two: " + seletorString);
//                        // 以上是思路整理
//                    }
//
//                    if (seletorString.size() == 3) {
//
//                        executeChecked();
//
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(2).getName().equals("其他") || !seletorString.get(2).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("three: " + seletorString);
//                        // 以上是思路整理
//                    }
//                    if (seletorString.size() == 4) {
//                        executeChecked();
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else if (seletorString.get(2).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(2).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(3).getName().equals("其他")
////                                    || !seletorString.get(3).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("four: " + seletorString);
//                        // 以上是思路整理
//                    }
//                    if (seletorString.size() == 5) {
//                        executeChecked();
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else if (seletorString.get(2).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(2).getLeaveReason().equals("");
////                        } else if (seletorString.get(3).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(3).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(4).getName().equals("其他")
////                                    || !seletorString.get(4).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("five: " + seletorString);
//                        // 以上是思路整理
//                    }
//                    if (seletorString.size() == 6) {
//                        executeChecked();
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else if (seletorString.get(2).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(2).getLeaveReason().equals("");
////                        } else if (seletorString.get(3).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(3).getLeaveReason().equals("");
////                        } else if (seletorString.get(4).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(4).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(5).getName().equals("其他")
////                                    || !seletorString.get(5).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("six: " + seletorString);
//                        // 以上是思路整理
//                    }
//                    if (seletorString.size() == 7) {
//                        executeChecked();
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else if (seletorString.get(2).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(2).getLeaveReason().equals("");
////                        } else if (seletorString.get(3).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(3).getLeaveReason().equals("");
////                        } else if (seletorString.get(4).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(4).getLeaveReason().equals("");
////                        } else if (seletorString.get(5).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(5).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(6).getName().equals("其他")
////                                    || !seletorString.get(6).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("seven: " + seletorString);
//                        // 以上是思路整理
//                    }
//                    if (seletorString.size() == 8) {
//                        executeChecked();
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else if (seletorString.get(2).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(2).getLeaveReason().equals("");
////                        } else if (seletorString.get(3).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(3).getLeaveReason().equals("");
////                        } else if (seletorString.get(4).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(4).getLeaveReason().equals("");
////                        } else if (seletorString.get(5).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(5).getLeaveReason().equals("");
////                        } else if (seletorString.get(6).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(6).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(7).getName().equals("其他")
////                                    || !seletorString.get(7).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("eight: " + seletorString);
//                        // 以上是思路整理
//                    }
//                    if (seletorString.size() == 9) {
//                        executeChecked();
//                        // 以下是思路整理
////                        if (seletorString.get(0).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(0).getLeaveReason().equals("");
////                        } else if (seletorString.get(1).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(1).getLeaveReason().equals("");
////                        } else if (seletorString.get(2).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(2).getLeaveReason().equals("");
////                        } else if (seletorString.get(3).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(3).getLeaveReason().equals("");
////                        } else if (seletorString.get(4).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(4).getLeaveReason().equals("");
////                        } else if (seletorString.get(5).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(5).getLeaveReason().equals("");
////                        } else if (seletorString.get(6).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(6).getLeaveReason().equals("");
////                        } else if (seletorString.get(7).getName().equals("其他")) {
////                            mCommitFlag = !seletorString.get(7).getLeaveReason().equals("");
////                        } else {
////                            mCommitFlag = !seletorString.get(8).getName().equals("其他")
////                                    || !seletorString.get(8).getLeaveReason().equals("");
////                        }
////                        SYLoger.print("nine: " + seletorString);
//                        // 以上是思路整理
//                    }
        }
    }
    /**
     * 清空所有数据
     */
    public void clearAll() {
//        清空EditText 的内容
        if (datas != null) {
            for (LeaveApplicationBean.LeavingReasonBean leavingReasonBean : datas) {
                leavingReasonBean.setReason("");
            }
        }
//        隐藏EditText
        if (isShow != null) {
            isShow.clear();
        }
//        隐藏checkbox
        if (map != null) {
            map.clear();
        }
//       清空提交的数据，防止没勾选也能提交
        if (seletorString != null) {
            seletorString.clear();
        }
        notifyDataSetChanged();
        mOnChangeBackGroundListener.onChageBackGround(false);
    }

    /**
     * 选择其他选项时，必须填写的规则
     */
    private void executeChecked() {
        for (int i = 0; i < seletorString.size(); i++) {
            if (seletorString.get(i).getName().equals("其他")) {
                mCommitFlag = !seletorString.get(i).getReason().equals("");
                return;//只要找到其他就不再循环
            } else {//没有勾选"其他"
                if (i == seletorString.size() - 1) {
                    mCommitFlag = true;
                }
            }
        }
    }

    /**
     * 获取选中数据源
     */
    public List<LeaveApplicationBean.LeavingReasonBean> getSeletorData() {
        return seletorString;
    }

    public boolean isCommitFlag() {
        return mCommitFlag;
    }

    @SuppressWarnings("unused")
    public void setCommitFlag(boolean mCommitFlag) {
        this.mCommitFlag = mCommitFlag;
    }

    @Override
    public int getItemCount() {
        return datas.size();
    }


    class ItemViewHolder extends RecyclerView.ViewHolder {
        private CheckBox cb;
        private TextView tv;
        private EditText et;

        private ItemViewHolder(View itemView) {
            super(itemView);
            cb = (CheckBox) itemView.findViewById(R.id.item_cb);
            tv = (TextView) itemView.findViewById(R.id.item_tv);
            et = (EditText) itemView.findViewById(R.id.item_et);
        }
    }

    public void setOnChangeBackGroundListener(OnChangeBackGroundListener onChangeBackGroundListener) {
        this.mOnChangeBackGroundListener = onChangeBackGroundListener;
    }

    public interface OnChangeBackGroundListener {
        void onChageBackGround(boolean flag);
    }
}

