package com.urovo.activity.wechatqrcode.view

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import com.bumptech.glide.Glide
import com.urovo.activity.home.EnterpriseWxCodeAct
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.view.webview.FraContainerAct
import com.wgmf.trade.ui.fra.index.MemberHomeFra
import com.zsy.libcore.ui.fra.FragmentArgs
import kotlinx.android.synthetic.main.wechat_qrcode_entry_act.*

/**
 * @author Sasuke on 2020-4-22 0022.
 * 扫码加粉里 个人微信二维码入口
 */
class WeChatQrCodeEntryAct: BaseActivity() {
    //个人二维码url
    val personalWechatUrl by lazy { intent.getStringExtra("url") }

    //是否有加企业微信好友
    val hasAddEnWx by lazy { intent.getBooleanExtra("hasAddEnWx",false) }

    //客户手机号
    val phone by lazy { intent.getStringExtra("phone") }

    //是否有个人二维码标记
    var hasPersonalQrCode = false;
    //企业微信二维码
//    val enterpriseWxCode by lazy { intent.getStringExtra("EnterpriseWxCode") }

    companion object {
        @JvmStatic
        fun launch(context: Context, phone: String ,personalWechatUrl: String?,enterpriseWxCode: String,hasAddEnWx: Boolean){
            context.startActivity(Intent(context,WeChatQrCodeEntryAct::class.java).apply {
                putExtra("phone",phone)//客户手机号
                putExtra("url",personalWechatUrl)//个人微信二维码
                putExtra("hasAddEnWx",hasAddEnWx)//是否有加企业微信好友
                putExtra("enterpriseWxCode",enterpriseWxCode)//企业微信二维码
            })
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.wechat_qrcode_entry_act)
        initTitle()
        init()
    }

    fun init(){
        titleTextView.text = "加微信好友"
        if (personalWechatUrl.isNullOrBlank()){//如果没有上传个人二维码
            hasPersonalQrCode = false
            switchViewStates(false)
        }else{
            hasPersonalQrCode = true
            switchViewStates(true)
            Glide.with(this@WeChatQrCodeEntryAct)
                    .load(personalWechatUrl)
                    .placeholder(R.drawable.progress_animation_small)
                    .into(qrCodeImage2)
        }


        //点击 立即去上传
        goToUploadBtn.setOnClickListener {
            startActivityForResult(Intent(this,WeChatQrcodeActivity::class.java),0)
        }

        //点击 下一步
        goNextBtn2.setOnClickListener {
            //如果已经有加过企业微信好友 或 存在个人二维码，就直接跳活动页
            if (hasPersonalQrCode){
                FraContainerAct.launch(this@WeChatQrCodeEntryAct, MemberHomeFra::class.java, FragmentArgs().apply {
                    //手机号一定存在，需求说如果没填手机号的话，就不需要跳转到这个企业微信关注页面了。
                    add(AppConstants.ExtraKeys.PHONE_NUM, phone)
                }, false)
                return@setOnClickListener
            }
            //没有个人微信二维码，就走老逻辑
            EnterpriseWxCodeAct.launch(this,phone,"",0)
        }
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when(resultCode){
            Activity.RESULT_OK -> {
                hasPersonalQrCode = true
                switchViewStates(true)
                Glide.with(this@WeChatQrCodeEntryAct)
                        .load(data?.getStringExtra("url"))
                        .placeholder(R.drawable.progress_animation_small)
                        .into(qrCodeImage2)
            }
        }

    }

    /***
     * 修改View们的显隐
     */
    fun switchViewStates(hasQrCode: Boolean){
        noCodeAlert.visibility = if (hasQrCode) View.GONE else View.VISIBLE
        goToUploadBtn.visibility = if (hasQrCode) View.GONE else View.VISIBLE

        qrCodeImage2.visibility = if (hasQrCode) View.VISIBLE else View.GONE
        promptText2.visibility = if (hasQrCode) View.VISIBLE else View.GONE
    }
}