package com.urovo.activity.wxfriendsres.model

import androidx.databinding.ObservableField
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.urovo.activity.wxfriendsres.net.WxFriendsMaterialRes
import com.urovo.activity.wxfriendsres.repo.WxFriendsResRepo
import com.urovo.wugumofang.utils.MyToast
import kotlinx.coroutines.launch

/**
 * @author HUANGSHI-PC on 2020-03-06 0006.
 */
class WxFriendsResModel(val repo: WxFriendsResRepo): ViewModel() {
    var hasContent: ObservableField<Boolean> = ObservableField(true)

    var dataList: MutableLiveData<List<WxFriendsMaterialRes.ResultInfo>> = MutableLiveData()
    /***
     *请求数据
     */
    fun queryList(date: String,userNo: String) = viewModelScope.launch {
        try{
            dataList.value = repo.queryFriendsCircleMaterial(date,userNo).apply { get(0).isExpanded = true }//默认第一项展开
            hasContent.set(true)
        }catch (e: Exception){
            MyToast.show(e.message)
            hasContent.set(false)
        }
    }

}