package com.urovo.activity.wxfriendsres.repo

import com.urovo.activity.wxfriendsres.net.WxFriendsMaterialRes
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.net.OkHttpDominator
import okhttp3.Request
import kotlin.coroutines.resume
import kotlin.coroutines.resumeWithException
import kotlin.coroutines.suspendCoroutine

/**
 * @author HUANGSHI-PC on 2020-03-06 0006.
 */
class WxFriendsResRepo {
    /**获取朋友圈素材库*/
    suspend fun queryFriendsCircleMaterial(date: String, userNo: String) = suspendCoroutine<List<WxFriendsMaterialRes.ResultInfo>> { conti ->
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.FRIEND_CIRCLE_MATERIAL,
                mapOf("date" to date,"userNo" to userNo),object : OkHttpDominator.ResultCallback<WxFriendsMaterialRes>(){
            override fun onError(request: Request?, e: Exception?) {
                e?.printStackTrace()
                e?.let { conti.resumeWithException(it) }
            }

            override fun onResponse(res: WxFriendsMaterialRes) {
                if (res.resultInfo.isNullOrEmpty()){
                    conti.resumeWithException(Exception(res.msgInfo ?: "无数据"))
                    return
                }
                conti.resume(res.resultInfo)
            }
        })
    }

}