package com.urovo.activity.wxfriendsres.view

import android.os.Bundle
import androidx.databinding.DataBindingUtil
import androidx.lifecycle.ViewModelProviders
import androidx.recyclerview.widget.LinearLayoutManager
import com.alibaba.android.arouter.facade.annotation.Route
import com.urovo.activity.wxfriendsres.model.WxFriendsResModel
import com.urovo.activity.wxfriendsres.repo.WxFriendsResModelFactory
import com.urovo.activity.wxfriendsres.repo.WxFriendsResRepo
import com.urovo.activity.wxfriendsres.ui.WxFriendsResAdapter
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.RouterParams
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.databinding.WxFriendsResActBinding
import com.urovo.wugumofang.system.SystemHelper
import java.util.*

/***
 * 朋友圈素材
 */
@Route(path = RouterParams.Member.WX_FRIENDS_RES)
class WxFriendsResActivity : BaseActivity() {

    val binding by lazy {
        DataBindingUtil.setContentView<WxFriendsResActBinding>(
                this,
                R.layout.wx_friends_res_act)
    }

    val wxFriendsModel by lazy {
        ViewModelProviders.of(
                this,
                WxFriendsResModelFactory(WxFriendsResRepo())).get(WxFriendsResModel::class.java)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
//        window.setBackgroundDrawable(null)
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) window.addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
        super.onCreate(savedInstanceState)
        bind()
        initTitle()
        setListener()
        query()
    }

    fun bind() {
        binding.apply {
            titleText = "朋友圈素材库"
            hasContent = wxFriendsModel.hasContent//先设为有内容状态
            wxResRv.layoutManager = LinearLayoutManager(this@WxFriendsResActivity)
        }
    }

    fun setListener(){
        wxFriendsModel.dataList.observe(this,androidx.lifecycle.Observer {
            binding.wxResRv.adapter = WxFriendsResAdapter(this@WxFriendsResActivity,it)
        })
    }

    fun query() {
        wxFriendsModel.queryList(DateUtil.getDate(Date()), SystemHelper.LoginUserId)
    }
}
