package com.urovo.activity.zhuanshu;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.urovo.wgmf.entity.response.ZhuanShuErWeiMaResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.manager.ThreadManager;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.utils.FuckGoogleAdaptUtil;
import com.urovo.wugumofang.utils.MyToast;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import okhttp3.Request;

/**
 * @author ...专属二维码
 */
public class QrCode extends BaseActivity {
    private TextView mTextViewName;
    private TextView mTextViewId;
    private ImageView mImageViewErWeiMa;
    private Button mButtonPrint;
    private Button mButtonSave;
    private String mErWeiMaPictureJpg;
    private String mErWeiMaPictureBmp;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_zhuanshu);
        initTitle();
        mTextViewName = (TextView) findViewById(R.id.textViewName);
        mTextViewId = (TextView) findViewById(R.id.textViewId);
        mImageViewErWeiMa = (ImageView) findViewById(R.id.imageViewErWeiMa);
        mButtonPrint = (Button) findViewById(R.id.buttonPrint);
        mButtonSave = (Button) findViewById(R.id.buttonSave);

        mTextViewName.setText(SystemHelper.LoginUserName);
        mTextViewId.setText(SystemHelper.LoginUserId);

        mErWeiMaPictureJpg = SystemHelper.LoginUserId + "_" + "zhuanshu.jpg";
        mErWeiMaPictureBmp = SystemHelper.LoginUserId + "_" + "zhuanshu.bmp";
        File pictureFile = new File(Files.tempPicture + mErWeiMaPictureJpg);
        File pictureFileBmp = new File(Files.tempPicture + mErWeiMaPictureBmp);
        if (pictureFile.exists() && pictureFileBmp.exists()) {
            mImageViewErWeiMa.setImageURI(FuckGoogleAdaptUtil.android7AdaptUri(this, Files.fileProviderAuth, pictureFile)/*FileProvider.getUriForFile(this,Files.fileProviderAuth,pictureFile)*/);
        } /*else {
            request();
        }*/
        request();
        mButtonPrint.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
//                File pictureFile = new File(Files.tempPicture + mErWeiMaPictureBmp);
                QrCodeDominator.qrCodePrint(QrCode.this,
                Files.tempPicture,
                        mErWeiMaPictureBmp,
                        SystemHelper.LoginUserName,
                        "企业微信专属二维码");
//                if (pictureFile.exists()) {
//                    new PrinterTool(QrCode.this, null).printBmp(80, 10, Files.tempPicture, mErWeiMaPictureBmp);
//                } else {
//                    showMsg("无有效二维码可供打印！");
//                }
            }
        });
        mButtonSave.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                QrCodeDominator.saveQrCode(QrCode.this, Files.tempPicture, mErWeiMaPictureJpg);
//                File pictureFile = new File(Files.tempPicture + mErWeiMaPictureJpg);
//                if (pictureFile.exists()) {
//                    boolean resatult = PictureUtil.saveImageToGallery(QrCode.this, Files.tempPicture, mErWeiMaPictureJpg);
//                    if (resatult) {
//                        showMsg("保存成功！");
//                    } else {
//                        showMsg("保存失败！");
//                    }
//                } else {
//                    showMsg("无有效二维码可供打印！");
//                }
            }
        });
    }

    @Override
    public void initTitle() {

        super.initTitle();
        titleTextView.setText("专属二维码");

    }

    private void request() {
        Map<String, String> params = new HashMap<>(2);
//        params.put("staffQrcode", null);
        params.put("staffNo", SystemHelper.LoginUserId);
        params.put("staffName", SystemHelper.LoginUserName);
//        BaseActivityTask task = new BaseWeiXinServerTask("huoquerweima", ZhuanShuErWeiMaResponse.class, QrCode.this, "正在查询...", false, "", params);
//        task.execute("");
        OkHttpDominator.postAsyn(NetParam.WEIXIN_SERVER + ApiUrls.WeiXin.QUERY_QRCODE_IMAGE_URL,
                params, new OkHttpDominator.ResultCallback<ZhuanShuErWeiMaResponse>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        MyToast.show(e.getMessage());
                    }

                    @Override
                    public void onResponse(ZhuanShuErWeiMaResponse res) {
                            if (null != res && !TextUtils.isEmpty(res.data)) {
                                ThreadManager.getThreadPool().execute(new Runnable() {
                                    @Override
                                    public void run() {
                                        try {
                                            QrCodeDominator.qrCodeShowAndSave(
                                                    QrCode.this,
                                                    res.data,//图片url
                                                    Files.tempPicture,//缓存图片路径
                                                    mErWeiMaPictureJpg,//图片名
                                                    mImageViewErWeiMa);//显示图片的组件
                                        } catch (Exception e) {
                                            BaseAppManager.loger().info(e);
                                        }
                                    }
                                });
                            }
                    }
                }
        );
    }

    @Override
    public void displayResult(String tag, BaseResponse response) {
        super.displayResult(tag, response);
        if ("huoquerweima".equals(tag) && null != response) {
            final ZhuanShuErWeiMaResponse res = (ZhuanShuErWeiMaResponse) response;
            if (!TextUtils.isEmpty(res.data)) {
                ThreadManager.getThreadPool().execute(new Runnable() {
                    @Override
                    public void run() {
                        try {
//                            URL picUrl = new URL(res.url);
                            QrCodeDominator.qrCodeShowAndSave(
                                    QrCode.this,
                                    res.data,//图片url
                                    Files.tempPicture,//缓存图片路径
                                    mErWeiMaPictureJpg,//图片名
                                    mImageViewErWeiMa);//显示图片的组件
//                            final Bitmap bmp = BitmapFactory.decodeStream(picUrl.openStream());
//                            mImageViewErWeiMa.post(new Runnable() {
//                                @Override
//                                public void run() {
//                                    mImageViewErWeiMa.setImageBitmap(bmp);
//                                    PictureUtil.saveBitmapFile(bmp, Files.tempPicture, mErWeiMaPictureJpg);
//                                    Bitmap temp = BitmapUtil.scale(bmp, (float) 172 / (bmp.getWidth()));
//                                    BitmapUtil.saveBmp1(temp, Files.tempPicture, mErWeiMaPictureBmp);
//                                }
//                            });
                        } catch (Exception e) {

                            BaseAppManager.loger().info(e);
                        }
                    }
                });
            }
        }
    }

}
