package com.urovo.activity.zhuanshu

import android.app.Activity
import android.content.Context
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.widget.ImageView
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.printermodule.PrinterTool
import com.urovo.wugumofang.ui.BitmapUtil
import com.urovo.wugumofang.ui.PictureUtil
import com.urovo.wugumofang.utils.FuckGoogleAdaptUtil
import com.urovo.wugumofang.utils.MyToast
import org.jetbrains.anko.doAsync
import org.jetbrains.anko.uiThread
import java.io.File
import java.io.IOException
import java.net.URL


/**
 * @author Sasuke on 2019-9-20 0020.
 * 二维码的打印与保存的封装
 */
class QrCodeDominator {
    companion object {
        /**保存二维码到本地*/
        @JvmStatic
        fun qrCodeShowAndSave(context: Context, imgUrl: String, dirPath: String, fileName: String, iv: ImageView) {
            doAsync {
                try {
                    //如果本地存在，就先显示本地的
                    File(dirPath,fileName)?.takeIf { it.exists() }?.run {
                        uiThread { iv.setImageURI(FuckGoogleAdaptUtil.android7AdaptUri(context, Files.fileProviderAuth,this)) }
                    }
                    //通过流来下载图片
                    var bmp = BitmapFactory.decodeStream(URL(imgUrl).openStream())
                    uiThread { iv.setImageBitmap(bmp) }

                    //转存本地
                    PictureUtil.saveBitmapFile(bmp, dirPath, fileName)
                    val temp = BitmapUtil.scale(bmp, 172.toFloat() / bmp.width)
                    BitmapUtil.saveBmp1(temp, dirPath, fileName.replace(".jpg", ".bmp"))
                } catch (e: IOException) {
                    e.printStackTrace()
                }
            }
        }

        /**根据给的String生成二维码&&显示出来*/
        @JvmStatic
        fun qrCodeCreateAndShow(context: Context, bmp: Bitmap, dirPath: String, fileName: String, iv: ImageView) {
            doAsync {
                try {
                    //如果本地存在，就先显示本地的
//                    File(dirPath,fileName)?.takeIf { it.exists() }?.run {
//                        uiThread { iv.setImageURI(FuckGoogleAdaptUtil.android7AdaptUri(context, Files.fileProviderAuth,this)) }
//                    }
                    //通过流来下载图片
//                    var bmp = BitmapFactory.decodeStream(URL(imgUrl).openStream())
                    uiThread { iv.setImageBitmap(bmp) }

                    //转存本地
                    PictureUtil.saveBitmapFile(bmp, dirPath, fileName)
                    val temp = BitmapUtil.scale(bmp, 172.toFloat() / bmp.width)
                    BitmapUtil.saveBmp1(temp, dirPath, fileName.replace(".jpg", ".bmp"))
                } catch (e: IOException) {
                    e.printStackTrace()
                }
            }
        }


        /**打印二维码*/
        @JvmStatic
        fun qrCodePrint(act: Activity, dirPath: String, fileName: String, titleText: String,bottomText: String ) {
            if (File(dirPath + fileName).exists()) {
                PrinterTool(act, null).printBmp(80, 10, dirPath, fileName,titleText,bottomText)
            } else {
                MyToast.show("无有效二维码可供打印！")
            }
        }

        /**保存二维码*/
        @JvmStatic
        fun saveQrCode(context: Context, dirPath: String, fileName: String) {
            if (File(dirPath + fileName).exists()) {
                val result = PictureUtil.saveImageToGallery(context, dirPath, fileName)
                if (result) {
                    MyToast.show("保存成功！")
                } else {
                    MyToast.show("保存失败！")
                }
            } else {
                MyToast.show("无有效二维码！")
            }
        }

    }
}