package com.urovo.wgmf

import android.os.Bundle
import com.urovo.activity.zhuanshu.QrCodeDominator
import com.urovo.wgmf.entity.response.HuoDongErWeiMaResponse
import com.urovo.wgmf.zxing.ZxingCodeTool
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.ApiUrls
import com.urovo.wugumofang.constants.Files
import com.urovo.wugumofang.constants.NetParam
import com.urovo.wugumofang.manager.ThreadManager
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.system.BaseAppManager
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.utils.MyToast
import com.wgmf.trade.GlobalApp.context
import com.zsy.libcore.common.other.DensityUtil
import kotlinx.android.synthetic.main.actions_qrcode_act.*
import okhttp3.Request

/**
 * @author Sasuke on 2019-10-15 0015.
 * 活动二维码
 */
class ActionsQrCodeAct : BaseActivity() {
    var mErWeiMaPictureJpg = SystemHelper.LoginUserId + "_" + "huodong.jpg"


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.actions_qrcode_act)
        initTitle()
        init()
        query()
    }

    fun init() {
        titleTextView.text = "活动二维码"
        //保存到相册
        buttonSave.setOnClickListener {
            QrCodeDominator.saveQrCode(this@ActionsQrCodeAct, Files.tempPicture, mErWeiMaPictureJpg)
        }
        //打印二维码（不需要打印文字，这个二维码是直接贴在门店上的）
        buttonPrint.setOnClickListener {
//            val pictureFile = File(Files.tempPicture + mErWeiMaPictureJpg.replace(".jpg",".bmp"))
            QrCodeDominator.qrCodePrint(this@ActionsQrCodeAct,
                    Files.tempPicture,
                    mErWeiMaPictureJpg.replace(".jpg",".bmp"),
                    "",
                    "")

//            if (pictureFile.exists()) {
//                PrinterTool(this@ActionsQrCodeAct, null).printBmp(80, 10, Files.tempPicture, mErWeiMaPictureJpg.replace(".jpg",".bmp"),"","")
//            } else {
//                showMsg("无有效二维码可供打印！")
//            }
        }
    }



    fun query(){
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.GET_ACT_QRCODE_URL,
                null,object : OkHttpDominator.ResultCallback<HuoDongErWeiMaResponse>(){
            override fun onError(request: Request?, e: Exception?) {
                MyToast.show(e?.message)
            }

            override fun onResponse(res: HuoDongErWeiMaResponse?) {
                if (null != res && res.resultInfo != null && res.resultInfo?.url != null) {
                    actionTitleTv.text = res.resultInfo?.title
                    ThreadManager.getThreadPool().execute {
                        try {
                            val bmp = ZxingCodeTool.create2DCode("${res.resultInfo?.url}&shopId=${SystemHelper.LoginOrganId}",
                                    DensityUtil.dip2px(context, 350f), DensityUtil.dip2px(context, 350f))
                            val bmpWhiteBg = ZxingCodeTool.setWhiteBackground(bmp,DensityUtil.dip2px(context, 15f))
                            QrCodeDominator.qrCodeCreateAndShow(
                                    this@ActionsQrCodeAct,
                                    bmpWhiteBg, //由url生成的bmp
                                    Files.tempPicture, //缓存图片路径
                                    mErWeiMaPictureJpg, //图片名
                                    qrCodeImage)//显示图片的组件
                        } catch (e: Exception) {
                            BaseAppManager.loger().info(e)
                        }
                    }
                }
            }
        })
    }
}