package com.urovo.wgmf.AsyncTask;

import android.util.Log;

import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.ZipToFile;
import com.urovo.wugumofang.net.HttpUtil;
import com.urovo.wugumofang.system.BaseAppManager;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;

public class DownDataForOrgTask extends BaseActivityTask {
	private String resultStr;
	private String sqlFileName;
	public final static String TAG = "DownDataForOrgTask";
	String files = "data/data/com.urovo.wugumofang/files";

	public DownDataForOrgTask(BaseActivity context, String message, boolean toShowProgressBar, String sqlFileName) {
		super(context, message, toShowProgressBar);
		
		this.sqlFileName = sqlFileName;
		// files=DeviceHelper.getSDPath()+"/files";

	}

	@Override
	public void dealTask() throws Exception {

		super.dealTask();
		// e90b6942-1abf-4cc5-8da2-91b58ff1b437
		String downloadUrl = dUrl + "/Initialize/" + sqlFileName + ".zip";
		if(downloadFile(downloadUrl)) {
			DalCommon.DeleteBaseData(); // 清理基础数据
			DalCommon.DeleteBusinessData(); // 清理业务数据

			String zipFilePath = files + "/sql.zip";
			String sqlFilePath = files + "/sql.sql";
			ZipToFile.upZipFile(zipFilePath, sqlFilePath);
			InputStream ins;
			ins = new FileInputStream(new File(sqlFilePath));
			InputStreamReader reader = new InputStreamReader(ins, "utf-8");
			BufferedReader bufferedReader = new BufferedReader(reader);
			String line = null;
			BaseAppManager.database().beginTransaction();
			while ((line = bufferedReader.readLine()) != null) {
				try {
					BaseAppManager.database().execSQL(line);
					Log.d("DownDataTask", "execSQL:" + line);
				}
				catch (Exception e) {

					BaseAppManager.loger().info("基础数据写入" + line + "\n" + e);
					Log.d("DownDataTask", "基础数据写入" + line + "\n" + e);

				}
			}
			BaseAppManager.database().setTransactionSuccessful();
			BaseAppManager.database().endTransaction();
			reader.close();
			ins.close();

			errMsg = null;
		}
		else {
			errMsg = "数据保存失败！";
		}

	}

	@Override
	public void afterTask() {

		super.afterTask();
		if(errMsg == null) {
			context.displayResult(TAG, null);
		}

	}

	private boolean downloadFile(String downloadUrl) {
		try {

			File file = new File(files);
			String cmd = "chmod 777" + file.getAbsolutePath();
			Runtime.getRuntime().exec(cmd);
			if(!file.exists()) {
				file.mkdirs();
			}
			String zipFilePath = files + "/sql.zip";
			HttpUtil.downloadFile(downloadUrl, zipFilePath, null);
			/*
			 * File ZipFile = new File(zipFilePath); // 是否已下载更新文件 if
			 * (ZipFile.exists()) { ZipFile.delete(); } FileOutputStream fos =
			 * new FileOutputStream(ZipFile); URL url = new URL(downloadUrl);
			 * HttpURLConnection conn = (HttpURLConnection)
			 * url.openConnection(); conn.connect(); InputStream is =
			 * conn.getInputStream(); byte buf[] = new byte[1024]; do { int
			 * numread = is.read(buf); if (numread <= 0) { break; }
			 * fos.write(buf, 0, numread); } while (true);// 点击取消就停止下载
			 * fos.close(); is.close();
			 */
			return true;
		}
		catch (Exception e) {
			BaseAppManager.loger().info("[BaseDownloadTask.dealResult]" + e);
			return false;
		}
	}
}
