package com.urovo.wgmf.AsyncTask;

import com.urovo.wgmf.BaseFragmentActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.entity.response.StoreRXS001Response;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

/**
 * 处理门店销量审核业务的类（在试吃管理 和 退货管理 用了）
 *
 * @author Administrator
 *
 */
public class DownStoreRXS001Task extends BaseActivityTask {
	private String resultStr;
	private String sql;
	private String date;
	private StoreRXS001Response response;
	public static final String TAG = "DownStoreRXS001Task";

	public DownStoreRXS001Task(BaseActivity context, String message, boolean toShowProgressBar, String sql, String date) {
		super(context, message, toShowProgressBar);

		this.sql = sql;
		this.date = date;
	}

	public DownStoreRXS001Task(BaseFragmentActivity context, String message, boolean toShowProgressBar, String sql, String date) {
		super(context, message, toShowProgressBar);

		this.sql = sql;
		this.date = date;
	}

	@Override
	public void dealTask() throws Exception {

		super.dealTask();
		String action = NetParam.Action_RequestDownload;
		String method = NetParam.RequestDown_StoreRXS001;
		String content;
		if(SystemHelper.IsAdmin) {
			content = SystemHelper.LoginOrganId + ";" + date + ";" + sql;
		}
		else {
			String id = Store001DbOprate.GetDeptcsidByStoreId(SystemHelper.LoginOrganId);
			content = id + ";" + date + ";" + sql;
		}
		resultStr = ResultTool.access(Url, action, method, content);
		response = checkResult(resultStr, StoreRXS001Response.class);

	}

	@Override
	public void afterTask() {

		super.afterTask();
		if(errMsg != null) {
			showMessage(errMsg);
			BaseAppManager.loger().info(TAG + ":" + errMsg);
		}
		else {
			if(context != null) {
				context.displayResult(TAG, response);
			}
			if(fcontext != null) {
				fcontext.displayResult(TAG, response);
			}
		}
	}

}
