package com.urovo.wgmf.AsyncTask;

import com.urovo.wgmf.BaseFragmentActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wgmf.entity.response.VipResponse;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.ui.ViewUtil;

/**
 * 下载会员资料
 * 
 * @author Administrator
 *
 */
public class DownVipTask extends BaseActivityTask {
	private String resultStr;
	private VipResponse response;
	private boolean hasInternet;
	public static final String TAG = "DownVipTask";
	private String vip;

	public DownVipTask(BaseActivity context, String message, boolean toShowProgressBar, String vip) {
		super(context, message, toShowProgressBar);
		
		this.vip = vip;
	}

	public DownVipTask(BaseFragmentActivity context, String message, boolean toShowProgressBar, String vip) {
		super(context, message, toShowProgressBar);
		
		this.vip = vip;
	}

	@Override
	public void dealTask() throws Exception {

		super.dealTask();
		String action = NetParam.Action_RequestDownload;
		// String action = NetParam.Action_RequestQuery;
		String method = NetParam.RequestDown_Vip;
		String content = vip;

		resultStr = ResultTool.access(Url, action, method, content);
		response = checkResult(resultStr, VipResponse.class);
	}

	@Override
	public void afterTask() {

		super.afterTask();
		// if (resultStr == null) {
		// showMessage("访问服务异常");
		// } else {
		// dealResult(resultStr);
		// }
		// if (resultStr == null)
		// {
		// showMessage("访问服务异常");
		// }
		dealResult(resultStr);
	}

	private void dealResult(String result) {
		// if (errMsg != null) {
		// showMessage(errMsg);
		// BaseAppManager.loger().info(TAG+":"+errMsg);
		// } else {
		// context.displayResult(TAG, response);
		// }
		if(errMsg != null) {
			showMessage(errMsg);
			BaseAppManager.loger().info(TAG + ":" + errMsg);
		}

		if(context != null) {
			context.displayResult(TAG, response);
		}
		if(fcontext != null) {
			fcontext.displayResult(TAG, response);
		}
	}

	/**
	 * 后台执行任务
	 */
	@Override
	protected String doInBackground(String... params) {
		if(context != null) {
			hasInternet = NetHelper.IsHaveInternet(context);
		}
		if(fcontext != null) {
			hasInternet = NetHelper.IsHaveInternet(fcontext);
		}
		try {
			dealTask();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("DownVipTask.doInBackground" + e);

		}
		return null;
	}

	/**
	 * 执行完后，doInBackground返回的结果，作为此方法的参数，在主ui上跟新
	 */
	@Override
	protected void onPostExecute(String result) {
		try {
			if(toShowProgressBar)
				ViewUtil.dismissProgress();
			// if (hasInternet) {
			// afterTask();
			// } else {
			// showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			// afterTask();
			// }
			if(!hasInternet) {
				showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			}
			afterTask();

		}
		catch (Exception e) {

			BaseAppManager.loger().info("DownVipTask.onPostExecute" + e);
		}
	}

}
