package com.urovo.wgmf.AsyncTask;

import android.content.Context;

import com.google.gson.Gson;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wgmf.entity.response.JPushBindResponse;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.data.PrefTool;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.util.Map;

/**
 * 把别名绑定到公司服务器
 * Created by Sasuke on 2016/6/13.
 */

public class JPushYinXiaoBindTask implements Runnable {
    private String mResultStr;
    private JPushBindResponse mRsponse;
    private Map<String, String> mParams;
    private String mPath;
    String UrlHuiYuan = NetParam.YINXIAOBU_SERVER + NetParam.BASE_DATA_SERVICE_PATH;
    Context context;
    protected String errMsg;
    JPushYinXiaoBindCallback callback;

    public JPushYinXiaoBindTask(Context context, String path, Map<String, String> param,JPushYinXiaoBindCallback callback) {
        this.context = context;
        mPath = path;
        mParams = param;
        this.callback = callback;
    }

    @Override
    public void run() {
        mResultStr = ResultTool.access(UrlHuiYuan + mPath, mParams);
        mRsponse = (JPushBindResponse) checkResult(mResultStr, JPushBindResponse.class);
        if(mRsponse == null || !mRsponse.getRetInfo().equals("上传成功")){//极光绑定失败
            callback.retry();
            BaseAppManager.loger().info("JPushYinXiao绑定失败");
            PrefTool.setStringsave(context,"JPushYinXiaoBind", "");
        }else{
            BaseAppManager.loger().info("JPushYinXiao绑定成功");
            PrefTool.setStringsave(context,"JPushYinXiaoBind", SystemHelper.LoginUserId);
        }
    }



    protected <T> T checkResult(String resultStr, Class<T> cls) {
        if(context != null) {
            if(resultStr == null) {
                errMsg = context.getString(R.string.ser_access_err);
                return null;
            }
            Gson gson = new Gson();
            T t = gson.fromJson(resultStr, cls);
            if(t == null) {
                errMsg = context.getString(R.string.ser_black_err);
                return null;
            }
            errMsg = null;
            if(resultStr.endsWith("'MESSAGE':'暂时没有待下载的数据'}")) {
                errMsg = context.getString(R.string.ser_black_err);
                return null;
            }
            BaseAppManager.loger().info("JPush响应报文："+t);
            return t;
        }
        return null;
    }
}
