package com.urovo.wgmf.AsyncTask;

import android.text.TextUtils;

import com.urovo.wgmf.BaseFragmentActivity;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.HashMap;
import java.util.Map;

/**
 * 验证兑换码
 * 
 * @author Administrator
 *
 */
public class QueryYanZhengTask extends BaseActivityTask {
	private String resultStr;
	public static final String TAG = "QueryYanZhengTask";
	private String promid = "";
	private String exchcode = "";
	private String mobile = "";
	private BaseResponse response;
	private boolean hasInternet;

	public QueryYanZhengTask(BaseActivity context, String message, boolean toShowProgressBar, String promid, String exchcode, String mobile) {
		super(context, message, toShowProgressBar);
		
		this.promid = promid;
		this.exchcode = exchcode;
		this.mobile = mobile;
	}

	public QueryYanZhengTask(BaseFragmentActivity context, String message, boolean toShowProgressBar, String promid, String exchcode, String mobile) {
		super(context, message, toShowProgressBar);
		
		this.promid = promid;
		this.exchcode = exchcode;
		this.mobile = mobile;
	}

	@Override
	public void dealTask() throws Exception {

		super.dealTask();
		if(!TextUtils.isEmpty(promid) && !TextUtils.isEmpty(exchcode)) {
			Map<String, String> params = new HashMap<String, String>();
			params.put("promid", promid);
			params.put("exchcode", exchcode);
			params.put("mobile", mobile);
			resultStr = ResultTool.access(UrlBaseAppService + "/appactivity/exchcodecheck", params);
			response = checkResult(resultStr, BaseOldResponse.class);
		}
	}

	@Override
	public void afterTask() {

		super.afterTask();

		dealResult(resultStr);
	}

	private void dealResult(String result) {
		if(errMsg != null) {
			showMessage(errMsg);
			BaseAppManager.loger().info(TAG + ":" + errMsg);
		}
		else {
			if(context != null) {
				context.displayResult(TAG, response);
			}
			if(fcontext != null) {
				fcontext.displayResult(TAG, response);
			}
		}
		// else
		// {
		// showMessage("上传失败");
		// BaseAppManager.loger().info(TAG + ":" + errMsg);
		// }
	}

	/**
	 * 后台执行任务
	 */
	@Override
	protected String doInBackground(String... params) {
		if(context != null) {
			hasInternet = NetHelper.IsHaveInternet(context);
		}
		if(fcontext != null) {
			hasInternet = NetHelper.IsHaveInternet(fcontext);
		}
		try {
			dealTask();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("BaseActivityTask.doInBackground" + e);

		}
		return null;
	}

	/**
	 * 执行完后，doInBackground返回的结果，作为此方法的参数，在主ui上跟新
	 */
	@Override
	protected void onPostExecute(String result) {
		try {
			if(toShowProgressBar)
				ViewUtil.dismissProgress();
			// if (hasInternet) {
			// afterTask();
			// } else {
			// showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			// afterTask();
			// }
			if(!hasInternet) {
				showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			}
			afterTask();

		}
		catch (Exception e) {

			BaseAppManager.loger().info("BaseActivityTask.onPostExecute" + e);
		}
	}

}
