package com.urovo.wgmf.AsyncTask;

import android.text.TextUtils;

import com.urovo.wgmf.BaseFragmentActivity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wgmf.entity.response.HuoDongListResponse;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.PrefTool;
import com.urovo.wugumofang.net.NetHelper;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.Prefs;
import com.urovo.wugumofang.ui.ViewUtil;

import java.util.HashMap;
import java.util.Map;

public class RequestQuanChangHuoDongListTask extends BaseActivityTask {
	private String resultStr;
	private boolean hasInternet;
	private String storeid;
	private String saledate;
	public static final String TAG = "RequestQuanChangHuoDongListTask";
	private HuoDongListResponse response;

	public RequestQuanChangHuoDongListTask(BaseActivity context, String message, boolean toShowProgressBar, String storeid) {
		super(context, message, toShowProgressBar);
		this.storeid = storeid;

	}

	public RequestQuanChangHuoDongListTask(BaseFragmentActivity fcontext, String message, boolean toShowProgressBar, String storeid, String date) {
		super(fcontext, message, toShowProgressBar);
		this.storeid = storeid;
		this.saledate = date;

	}

	@Override
	public void dealTask() throws Exception {

		super.dealTask();
		Map<String, String> params = new HashMap<String, String>();
		params.put("storeid", storeid);
		if(!TextUtils.isEmpty(this.saledate)) {
			params.put("saledate", saledate.replace("-", ""));
		}
		Url = UrlBaseAppService + NetParam.QuanChangHuoDong;
		// Url="http://192.168.5.57:8888/crmserver"+NetParam.QuanChangHuoDong;
		resultStr = ResultTool.access(Url, params);
		response = checkResult(resultStr, HuoDongListResponse.class);

	}

	@Override
	public void afterTask() {

		super.afterTask();
		if(errMsg != null) {
			showMessage(errMsg);
			BaseAppManager.loger().info(TAG + ":" + errMsg);
		}
		else {
			if(!TextUtils.isEmpty(resultStr) && response != null) {
				if(context != null) {
					PrefTool.setStringsave(context, Prefs.QUANCHANGHUODONG, resultStr);
				}
				if(fcontext != null) {
					PrefTool.setStringsave(fcontext, Prefs.QUANCHANGHUODONG, resultStr);
				}
			}
			dealResult(resultStr);
		}
	}

	private void dealResult(String result) {
		// if (errMsg != null) {
		// showMessage(errMsg);
		// BaseAppManager.loger().info(TAG+":"+errMsg);
		// } else {
		// context.displayResult(TAG, response);
		// }

		if(context != null) {
			context.displayResult(TAG, response);
		}
		if(fcontext != null) {
			fcontext.displayResult(TAG, response);
		}
	}

	/**
	 * 后台执行任务
	 */
	@Override
	protected String doInBackground(String... params) {
		if(context != null) {
			hasInternet = NetHelper.IsHaveInternet(context);
		}
		if(fcontext != null) {
			hasInternet = NetHelper.IsHaveInternet(fcontext);
		}
		try {
			dealTask();
		}
		catch (Exception e) {

			BaseAppManager.loger().info("RequestQuanChangHuoDongListTask.doInBackground" + e);

		}
		return null;
	}

	/**
	 * 执行完后，doInBackground返回的结果，作为此方法的参数，在主ui上跟新
	 */
	@Override
	protected void onPostExecute(String result) {
		try {
			if(toShowProgressBar)
				ViewUtil.dismissProgress();
			// if (hasInternet) {
			// afterTask();
			// } else {
			// showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			// afterTask();
			// }
			if(!hasInternet) {
				showMessage("网络连接超时，请检查您的网络状态，稍后重试！");
			}
			afterTask();

		}
		catch (Exception e) {

			BaseAppManager.loger().info("RequestQuanChangHuoDongListTask.onPostExecute" + e);
		}
	}

}
