package com.urovo.wgmf.AsyncTask;

import android.app.NotificationManager;
import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;

import androidx.core.app.NotificationCompat;

import com.google.gson.Gson;
import com.urovo.activity.attendancemanagement.SignInAndOutActivity;
import com.urovo.activity.tabMenu.view.GlobalDialogBridgeAct;
import com.urovo.wgmf.constants.UploadParam;
import com.urovo.wgmf.db.dao.dao.CheckDetailDbOperate;
import com.urovo.wgmf.db.dao.dao.CxykqDbOperate;
import com.urovo.wgmf.db.dao.dao.Djpd001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djsc001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djsc002DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs001DbOperate;
import com.urovo.wgmf.db.dao.dao.Djxs002DbOperate;
import com.urovo.wgmf.db.dao.entitys.CXYKQEntity;
import com.urovo.wgmf.db.dao.entitys.CanCheckRes;
import com.urovo.wgmf.db.dao.entitys.OrderReqBean;
import com.urovo.wgmf.db.dao.entitys.PanDianEntity;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.ShiChiEntity;
import com.urovo.wgmf.db.dao.entitys.ShiChiUploadEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.wgmf.trade.presenter.SaveSuccessPre;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 业务数据上传
 *
 * @author Administrator
 */
public class UploadBusinessDataTask0 extends BaseActivityTask {
    public static final String TAG = "UploadBusinessDataTask";
    private String resultStr;
    private BaseResponse baseResponse;
    private boolean isValues = false;
    private boolean toNotify = false;
    private int resault;

    public UploadBusinessDataTask0(BaseActivity context, String message, boolean toShowProgressBar) {
        super(context, message, toShowProgressBar);
    }

    public UploadBusinessDataTask0(BaseActivity context, String message, boolean toShowProgressBar,
                                   List<String> tags) {
        super(context, message, toShowProgressBar, tags);
    }

    public UploadBusinessDataTask0(BaseActivity context, String message, boolean toShowProgressBar,
                                   List<String> tags, boolean toNotify) {
        super(context, message, toShowProgressBar, tags);
        this.toNotify = toNotify;
    }

    @Override
    public void dealTask() throws Exception {
        super.dealTask();
        context.mUpLoadFlag = false;
        upLoad();
    }

    @Override
    protected void noNetAfter() {
        super.noNetAfter();
        Intent intent = new Intent();
        intent.setAction("com.urovo.wgmf.upend");
        context.sendBroadcast(intent);
    }

    @Override
    public void afterTask() {
        super.afterTask();
        if (!isValues) {
//    showMessage("无可上传上传数据");
            context.displayResult(TAG, null);
            return;
        }
        if (1 == resault) {
            showMessage("出现产品金额与产品单价X产品数量不符的异常的销售单！");
        } else if (2 == resault) {
            showMessage("出现产品重复的异常的销售单！");
        }

        String msg;
        if ("".equals(resultStr)) {
            msg = "上传成功";
            showMessage(msg);
            context.displayResult(TAG, new BaseResponse());//瞎传一个实例，反正只要不是null就能激发回调里的操作了。
        } else {
            baseResponse = checkResult(resultStr, BaseOldResponse.class);
            if (baseResponse != null) {
                if ("0".equals(baseResponse.ret)
                        || ("0".equals(baseResponse.sysCode)
                        && "0".equals(((BaseOldResponse) baseResponse).msgCode))) {
                    msg = "上传成功";
                    showMessage(msg);
                    if (resultStr.contains("打卡成功")/* && !SystemHelper.IsAdmin*/) {//只有在上传签到成功的时候才弹出窗口，并记录最后一次签到日期
//                        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
//                        String today = sdf.format(new Date());
//                        String signInLastTime = PreferHelper.getInstance().getString(AppConstants.PreKeys.SIGN_IN_LAST_TIME + "_" + SystemHelper.LoginUserId);
//                        if (TextUtils.isEmpty(signInLastTime) || today.compareTo(signInLastTime) > 0) {//新的一天（当天第一次签到才显示提成弹窗）
//                            //记下当前签到成功的日期，并弹出会员商品提成的弹窗
//                            PreferHelper.getInstance().setString(AppConstants.PreKeys.SIGN_IN_LAST_TIME + "_" + SystemHelper.LoginUserId, today);//更新签到最后时间
//                            showBenefitDialog();
//                        }
                    }
                } else if ("1036".equals(baseResponse.ret) && !TextUtils.isEmpty(baseResponse.retInfo)) {
                    msg = baseResponse.retInfo;
                    showMessage(msg);
                }else if ("1001".equals(((BaseOldResponse)baseResponse).msgCode) && !TextUtils.isEmpty(baseResponse.msgContent)){
                    msg = baseResponse.msgContent;
//                    DialogHelper.Alert(context, "提示： ", msg,null,null);
                    Intent intent = new Intent(context,GlobalDialogBridgeAct.class);//全局弹窗，避免手动上传时，上传完后自动关闭当前界面导致弹窗也被关闭的问题。
                    intent.putExtra(GlobalDialogBridgeAct.INTENT_EXTRA, new GlobalDialogBridgeAct.RemindExtra(GlobalDialogBridgeAct.TYPE_REMIND_SIGNIN, "提示", msg));
                    context.startActivity(intent);
                }else {
                    if (!TextUtils.isEmpty(baseResponse.retInfo)) {
                        msg = check(UploadParam.KAOQIN) ?
                                "本次离线打卡保存成功，网络正常时系统会自动上传！"
                                : "上传失败:" + baseResponse.retInfo;
                    } else {
                        msg = check(UploadParam.KAOQIN) ?
                                "本次离线打卡保存成功，网络正常时系统会自动上传！"
                                : ("上传失败:" + ("0".equals(baseResponse.sysCode)
                                ? baseResponse.msgContent : baseResponse.sysContent));
                    }
                    offlineModeSave();
                    context.uploadFailed();
                    showMessage(msg);
                    return;
                }
            } else {
                if (null == resultStr) {
                    msg = check(UploadParam.KAOQIN) ?
                            "本次离线打卡保存成功，网络正常时系统会自动上传！"
                            : "上传失败:返回null";
                } else {
                    msg = check(UploadParam.KAOQIN) ?
                            "本次离线打卡保存成功，网络正常时系统会自动上传！"
                            : "上传失败:返回" + resultStr + " 解析成null";
                }
                offlineModeSave();
                context.uploadFailed();
                showMessage(msg);
                return;
            }
            context.displayResult(TAG, new BaseOldResponse());
        }
//        showMessage(msg);
        if (toShowProgressBar) {
            if ("".equals(resultStr)) {
                context.displayResult(TAG, new BaseOldResponse());
            }
        }
        if (toNotify) {
            NotificationManager nNotificaitonMan =
                    (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
            //nNotificaitonMan.cancel(0);
            //Notification notification = new Notification(R.drawable.icon, msg, System.currentTimeMillis());
            //notification.defaults |= Notification.DEFAULT_SOUND;
            //notification.defaults |= Notification.DEFAULT_VIBRATE;
            //notification.flags |= Notification.FLAG_AUTO_CANCEL;
            //notification.setLatestEventInfo(context, msg, "", null);
            //nNotificaitonMan.notify(0, notification);

            NotificationCompat.Builder builder = new NotificationCompat.Builder(context, AppConstants.NOTI_CHANNEL_ID.HIGH);
            builder.setContentTitle(msg)
                    .setContentText("")
                    //.setSound(Notification.DEFAULT_SOUND)
                    //.setVibrate(Notification.DEFAULT_VIBRATE)
                    .setAutoCancel(true)
                    .setSmallIcon(R.drawable.icon);
            nNotificaitonMan.notify(0, builder.build());
            Intent intent = new Intent();
            intent.setAction("com.urovo.wgmf.upend");
            context.sendBroadcast(intent);
        }
    }

    /**
     * 离线模式 -->跳转静默上传
     */
    private void offlineModeSave() {
//        PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_LOAD_FLAG, true);
//        ARouter.getInstance().build(RouterParams.ORIGIN.TABMENUACTIVITY).navigation();
        if (context instanceof SignInAndOutActivity) {
            context.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    context.afterSignInAndOut();
                }
            });
        }
    }

    public void upLoad() {
//        String action = NetParam.Action_RequestUpload;
        // 考勤上传
        if (check(UploadParam.KAOQIN)) {
            if (CxykqDbOperate.GetUnUploadCount() > 0) {
                isValues = true;
//                String method = NetParam.RequestUpload_APPKaoQin;
//                List<CXYKQEntity> newlist = new ArrayList<CXYKQEntity>();
                List<CXYKQEntity> list = CxykqDbOperate.GetUnUpload();
                for (CXYKQEntity ent : list) {
//                    newlist.clear();
//                    newlist.add(ent);

//signTime=2017-05-16 07:24:20& address=广东省深圳市南山区大冲路靠近招商银行(科技园支行)& userId=690& signImage=["http://7xqiu3.com1.z0.glb.clouddn.com/sygj_0110074_690_20170516152416_6541","http://7xqiu3.com1.z0.glb.clouddn.com/sygj_0110074_690_20170516152417_4952","http://7xqiu3.com1.z0.glb.clouddn.com/sygj_0110074_690_20170516152417_6318"]& lng=113.955721& requestType=2& machine=1& type=1& storeId=0110074& lat=22.540614& userType=2

                    Map<String, String> p = new HashMap<>();
                    p.clear();
                    p.put("userId", ent.SKYID);
                    p.put("storeId", ent.STOREID);
                    p.put("requestType", "2");
                    p.put("lng", ent.LONGITUDE);
                    p.put("lat", ent.LATITUDE);
                    p.put("userType", SystemHelper.IsAdmin ? "3" : "2");
                    p.put("address", ent.Address);
                    p.put("type", ent.KQTYPE);
                    p.put("machine", "1");
                    p.put("signTime", ent.KQDATE);
                    // 多张图片json串
                    p.put("signImage", ent.MoreImageUrl);
                    //离线打卡记录是否需要标注过期标签， "0":不需要  "1":需要
                    p.put("isOfflineData", CxykqDbOperate.upLoadInvalidDate(ent.KQDATE) ? "1" : "0");

                    resultStr = ResultTool.access(UrlBaseAppSalerService + "/information/signInOrOut", p);
                    baseResponse = checkResult(resultStr, BaseOldResponse.class);
//                    SYLoger.print("baseResponse -- " + baseResponse + "--" + baseResponse.msgContent + "--" + baseResponse.msgInfo);
                    if (null != baseResponse && "打卡成功".equals(baseResponse.msgContent)) {
                        // 如果上传成功，更新单据上传状态字段，同时获取剩余未上传单据记录
                        CxykqDbOperate.UpdateBillState(ent.BILL);
//                        NotificationCenterManager.notificationCancle(AppConstants.PreKeys.KAOQIN_TYPE);//如果考勤上传成功，通知栏取消
//                        PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_LOAD_FLAG, false);// 考勤上传成功，后台自动上传关闭。
                    } else if (null != baseResponse && "1001".equals(((BaseOldResponse) baseResponse).msgCode)){//msgCode为1001时，不继续上传
                        CxykqDbOperate.UpdateBillState(ent.BILL,2);
//                        PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_LOAD_FLAG, true);
                    }else{//常规失败，则启动自动上传
//                        PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_LOAD_FLAG, true);
                    }
//                    ARouter.getInstance().build(RouterParams.ORIGIN.TABMENUACTIVITY).navigation();
                    //返回1001的时候不弹打卡弹窗
                    if (context instanceof SignInAndOutActivity && null != baseResponse && !"1001".equals(((BaseOldResponse) baseResponse).msgCode)) {
                        context.runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                context.afterSignInAndOut();
                            }
                        });
                    }
                    context.mUpLoadFlag = true;
                }
            }
        }

        // 盘点上传
        if (check(UploadParam.PANDIAN)) {
            if (Djpd001DbOperate.GetUnUploadCount() > 0) {
                isValues = true;
                List<PanDianEntity> list = Djpd001DbOperate.GetAllUnUpload();
                for (PanDianEntity ent : list) {
                    List<CanCheckRes.Product> productDetails = CheckDetailDbOperate.GetBillDetail(ent.getBill());
                    final String bill = ent.getBill();
                    HashMap<String, String> param = new HashMap<>();
                    if(!TextUtils.isEmpty(ent.getRemark())) {
                        param.put("remark", ent.getRemark());
                    }
                    if(!TextUtils.isEmpty(ent.getUrl())) {
                        param.put("url", ent.getUrl());
                    }
                    param.put("detailList", new Gson().toJson(productDetails));
                    BaseSimpleResponse res = (BaseSimpleResponse) OkHttpDominator.postSynByType(
                            NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SUBMIT_TRANSFER_CHECK,
                            OkHttpDominator.JSON,
                            BaseSimpleResponse.class, param);
                    if (res != null && res.msgCode == 0) {
                        Djpd001DbOperate.UpdateBillState(bill);// 如果上传成功，更新单据上传状态字段
                        resultStr = "";
                    } else {
                        resultStr = new Gson().toJson(res);
                        context.uploadFailed();
                    }
                    context.mUpLoadFlag = true;
                }
            }
        }

        //配送单上传
//        if (check(UploadParam.PSTABLE)) {
//            if (PSTableDbOperate.GetUnUploadCount() > 0) {
//                isValues = true;
//                //从数据库里读出好多isUp=0的单。
//                List<PSTableDb> itemBills = PSTableDbOperate.GetAllUnUpload();
//                for (PSTableDb db : itemBills) {
//                    HashMap<String, String> param = new HashMap<String, String>();
//                    param.put("dispatch", db.getDataStr());
//                    BaseSimpleResponse res = (BaseSimpleResponse) OkHttpDominator.postSynByType(
//                            NetParam.YINXIAOBU_SERVER + ApiUrls.APP.SAVE_DISPATCHBILL,
//                            OkHttpDominator.JSON,
//                            BaseSimpleResponse.class,
//                            param);
//                    if (res != null && res.msgCode == 0) {
//                        PSTableDbOperate.UpdateBillState(db.getBill());// 如果上传成功，更新单据上传状态字段
//                        resultStr = "";
//                    } else {
//                        resultStr = new Gson().toJson(res);
////                        SYLoger.print("配送单上传------" + errMsg + "--resultStr--" + resultStr);
//                        context.uploadFailed();
//                    }
//                    context.mUpLoadFlag = true;
//                }
//            }
//        }

        // 试吃上传
        if (check(UploadParam.SHICHI)) {
            if (Djsc001DbOperate.GetUnUploadCount() > 0) {
                isValues = true;
//                String method = NetParam.RequestUpload_ShiChi;
//                List<ShiChiEntity> newlist = new ArrayList<ShiChiEntity>();
                List<ShiChiEntity> list = Djsc001DbOperate.GetAllUnUpload();
                for (ShiChiEntity ent : list) {
                    ProductEntity[] array =
                            Djsc002DbOperate.GetBillDetail(ent.getBill()).toArray(new ProductEntity[]{});
                    ent.setProductDetails(array);

                    ShiChiUploadEntity bean = new ShiChiUploadEntity();
                    bean.setProCode(ent.getBill());
                    bean.setProId("186");//默认传186就对了，别管为什么
                    bean.setStoreNo(ent.getStoreId());
                    bean.setTasteDate(ent.getWDate());
                    bean.setTasteQty((int) ent.getProductDetails()[0].getTQTY());
                    bean.setTasteUserNo(ent.getOper_Lr());

                    //以下这些字段不需要传
//                    bean.setProName(ent.getProductDetails()[0].getItemName());
//                    bean.setStoreName(SystemHelper.LoginOrganName);
//                    bean.setTasteUserName(ent.getLr_Name());
                    String storeForetaste = new Gson().toJson(bean);

                    HashMap<String, String> param = new HashMap<>();
                    param.put("storeForetaste", storeForetaste);
                    BaseSimpleResponse res = (BaseSimpleResponse) OkHttpDominator.postSynByType(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.EAT_MANAGER_SAVE,
                            OkHttpDominator.JSON,
                            BaseSimpleResponse.class,
                            param);

//                    newlist.clear();
//                    newlist.add(ent);
//                    Gson gson = new Gson();
//                    String content = gson.toJson(newlist);
//                    resultStr = ResultTool.access(Url, action, method, content);
                    // baseResponse = checkResult(resultStr,
                    // BaseResponse.class);
                    if (res != null && res.msgCode == 0) {
                        // 如果上传成功，更新单据上传状态字段，同时获取剩余未上传单据记录ccc
                        // for (ShiChiEntity ent : list)
                        resultStr = "";//上传成功要把resultStr这个标记改为“”最后才能判断为上传成功的。
                        Djsc001DbOperate.UpdateBillState(ent.getBill());
                    } else {
//                        SYLoger.print("试吃上传------" + errMsg);
                        context.uploadFailed();
                    }
                    context.mUpLoadFlag = true;
                }
            }
        }

        // 销售上传
        if (check(UploadParam.XIAOSHOU)) {
            if (Djxs001DbOperate.GetUnUploadCount() > 0) {
                isValues = true;
                int failCount = 0;
                String resText = "";//专门用来存返回的response，如果多个单有一个失败，其它都成功，那失败的resultStr就会被成功的""给盖掉，为了防止这一点。
                List<OrderReqBean> orderRequestBeans = Djxs001DbOperate.selectUnUploadOrder();
                SaveSuccessPre saveSuccessPre = new SaveSuccessPre();
                for (OrderReqBean orderRequestBeanTemp : orderRequestBeans) {
                    List<OrderReqBean.ProductDetailsBean> productDetailsBeans = Djxs002DbOperate.selectOrderDetail(orderRequestBeanTemp.getBill());
                    orderRequestBeanTemp.setProductDetails(productDetailsBeans);
                    resultStr = saveSuccessPre.submitOrderSyn(orderRequestBeanTemp);
                    if (!resultStr.equals("")) {//防止多单中，一单失败，其它成功，导致失败的返回被盖住
                        failCount++;
                        resText = resultStr;
                    }//注意这里要用同步.
                }

                if (failCount > 0) {
                    resultStr = resText;
                }

    /*    isValues = true;
                resault = 0;
        String method = NetParam.RequestUpload_XiaoShou;
        List<XiaoShouEntity> newlist = new ArrayList<XiaoShouEntity>();
        List<XiaoShouEntity> list = Djxs001DbOperate.GetAllUnUpload();
        // 未上传单据集合
        for (XiaoShouEntity xse : list) {
                  boolean saleBack = ("2".equals(xse.getXSTYPE()));
                  String path = saleBack ? "/user/pointexcancel" : "/user/pointex";

                  List<ProductEntity> l = Djxs002DbOperate.QueryXiaoShouDetail(xse.getBill(), saleBack);
                  for (ProductEntity p : l) {
                     if (Arith.mul(p.getPrice(), p.getTQTY()) != p.getAmount()) {
                        resault = 1;
                        break;
                     }
                     int a = l.indexOf(p);
                     if (l.get(a).getPrice() <= 0) continue;
                     int b = l.lastIndexOf(p);
                     if (l.get(b).getPrice() <= 0) continue;
                     if (a != b) {
                        resault = 2;
                        break;
                     }
                  }
                  if (1 == resault) {
                     Djxs001DbOperate.UpdateBillState(xse.getBill(), 2, "前端自查：总价与明细累加不符");// 异常单
                     continue;
                  } else if (2 == resault) {
                     Djxs001DbOperate.UpdateBillState(xse.getBill(), 3, "前端自查：一个销售单内有两个相同产品");// 重复单
                     continue;
                  }

                  ProductEntity[] array = l.toArray(new ProductEntity[] {});
                  xse.setProductDetails(array);
                  newlist.clear();
                  newlist.add(xse);
                  Gson gson = new Gson();
                  String content = gson.toJson(newlist);
                  Map<String, String> map = new HashMap<String, String>();
                  map.put("action", action);
                  map.put("method", method);
                  map.put("content", content);
                  resultStr = ResultTool.access(UrlBaseAppService + path, map);
                  baseResponse = checkResult(resultStr, BaseResponse.class);
                  if (null != baseResponse) {
                     if ("0".equals(baseResponse.ret)) {
                        Djxs001DbOperate.UpdateBillState(xse.getBill(), 1, "服务器反馈：" + baseResponse.retInfo);
                     } else if ("1036".equals(baseResponse.ret))// 该单号已存在，操作失败
                     {
                        Djxs001DbOperate.UpdateBillState(xse.getBill(), 1, "服务器反馈：" + baseResponse.retInfo);
                     } else {
                        Djxs001DbOperate.UpdateBillState(xse.getBill(), 2, "服务器反馈：" + baseResponse.retInfo);
                     }
                  }
        }*/
            }
//            else{
////                SYLoger.print("销售上传------" + errMsg);
//                context.uploadFailed();
//            }
            context.mUpLoadFlag = true;
        }

//        // 赠送上传
//        if (check(UploadParam.ZENGSONG)) {
//            if (Djzs001DbOperate.GetUnUploadCount() > 0) {
//                isValues = true;
//                String method = NetParam.RequestUpload_ZengSong;
//                List<Djzs001Db> newlist = new ArrayList<Djzs001Db>();
//                List<Djzs001Db> list = Djzs001DbOperate.GetUnUpload();
//                for (Djzs001Db ent : list) {
//                    newlist.clear();
//                    newlist.add(ent);
//
//                    Gson gson = new Gson();
//                    String content = gson.toJson(newlist);
//
//                    resultStr = ResultTool.access(Url, action, method, content);
//                    baseResponse = checkResult(resultStr, BaseOldResponse.class);
//                    if (baseResponse.isSTATUS()) {
//                        // 如果上传成功，更新单据上传状态字段，同时获取剩余未上传单据记录ccc
//                        // for (Djzs001Db ent : list)
//                        Djzs001DbOperate.UpdateBillState(ent.getBill());
//                    }
//                }
//            }
//        }
        // 订货审核

//        if (check(UploadParam.DINGHUOSHENHE)) {
//            if (DalDingHuoExamine.GetUnUploadCount() > 0) {
//                isValues = true;
//                String method = NetParam.RequestUpload_DingHuoExamine;
//                List<DingHuoExamineEntity> newlist = new ArrayList<DingHuoExamineEntity>();
//                List<DingHuoExamineEntity> list = DalDingHuoExamine.GetUnUpload();
//                for (DingHuoExamineEntity ent : list) {
//                    DingHuoExamineDetailEntity[] array = DalDingHuoExamine.GetBillDetail(ent.getBill())
//                            .toArray(new DingHuoExamineDetailEntity[]{});
//                    ent.setProductDetails(array);
//
//                    newlist.clear();
//                    newlist.add(ent);
//
//                    Gson gson = new Gson();
//                    String content = gson.toJson(list);
//                    resultStr = ResultTool.access(Url, action, method, content);
//                    // baseResponse = checkResult(resultStr,
//                    // BaseResponse.class);
//                    if ("".equals(resultStr)) {
//                        // 如果上传成功，更新单据上传状态字段，同时获取剩余未上传单据记录ccc
//                        // for (DingHuoExamineEntity ent : list)
//                        DalDingHuoExamine.UpdateBillState(ent.getBill());
//                    }
//                }
//            }
//        }

//    放在外面处理
//    // 上报反馈
//    if (check(UploadParam.ZHILIANJIANDU)) {
//    if (Zhxx001DbOperate.GetUnUploadCount() > 0) {
//        isValues = true;
//        String method = NetParam.RequestUpload_ZHXX;
//        List<ZHXX001Entity> list = Zhxx001DbOperate.GetUnUploadALL(null);
//        for (ZHXX001Entity ent : list) {
//                  if (ent != null) {
//                     ZHXX002Entity[] array =
//                           Zhxx002DbOperate.GetBillDetail(ent.getBillId()).toArray(new ZHXX002Entity[] {});
//                     ent.setZHXX002Details(array);
//
//                     Gson gson = new Gson();
//                     String content = gson.toJson(ent);
//                     // String
//                     // url="http://192.168.1.26:8080/crmserver/user/feedbackupload";
//                     String url = NetParam.YINXIAOBU_SERVER + NetParam.YINXIAOBU_SERVER_PATH
//                           + NetParam.YINXIAOBU_FEEDBACK_PATH;
//                     // resultStr = ResultTool.access(Url, action, method,
//                     // content);
//                     resultStr = ResultTool.access(url, "", "", content);
//                     if (!TextUtils.isEmpty(resultStr)) {
//                        baseResponse = checkResult(resultStr, BaseResponse.class);
//                     }
//                     if (baseResponse != null) {
//                        if ("0".equals(baseResponse.ret)) {
//                           // 如果上传成功，更新单据上传状态字段，同时获取剩余未上传单据记录ccc
//                           // for (ZHXX001Entity ent : list)
//                           Zhxx001DbOperate.UpdateBillState(ent.getBillId());
//                        }
//                     }
//                  }
//        }
//    }
//    }
    }

    /**
     * 检测是否改类型是否要更新
     */
    private boolean check(String tag) {
        boolean isTrue = false;
        if (tags.contains(tag)) {
            isTrue = true;
        }
        return isTrue;
    }

    //在每天第一次签到成功之后，弹出会员商品提成信息弹窗
//    private void showBenefitDialog() {
//        //以下会员商品提成情况弹窗
//        String endTimeStr = DateUtil.getDayBefore2(new Date()).substring(0, 10);//【需求】取今天的前一天作为查询时间
//        HashMap<String, String> params = new HashMap<>();
//        params.put("storeId", SystemHelper.LoginOrganId);
//        params.put("userId", SystemHelper.LoginUserId);
//        params.put("startTimeStr", endTimeStr);
//        params.put("endTimeStr", endTimeStr);
//        new BaseAppServerTask(UploadParam.KAOQIN, MemberProductSaleDateResponse.class, context, "正在获取会员商品销售情况...", true,
//                NetParam.MEMBER_PRODUCT_SALE_DATA, params).execute("");
//    }
}
