package com.urovo.wgmf.AsyncTask;

import com.google.gson.Gson;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.dao.Zhxx001DbOperate;
import com.urovo.wugumofang.response.BaseOldResponse;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wgmf.db.dao.entitys.ProblemsUploadEntity;
import com.urovo.wgmf.db.dao.entitys.ZHXX001Entity;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.ResultTool;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.PreferHelper;

import java.util.ArrayList;
import java.util.List;


/**
 * 上传反馈信息
 *
 * @author Administrator
 */
public class UploadFanKuiTask extends BaseActivityTask {
    private String resultStr;
    private BaseResponse baseResponse;
    public static final String TAG = UploadFanKuiTask.class.getSimpleName();
    private List<String> mUrls;

    public UploadFanKuiTask(BaseActivity context, String message, boolean toShowProgressBar, ArrayList<String> urls) {
        super(context, message, toShowProgressBar);
        this.mUrls = urls;
    }

    @Override
    public void dealTask() throws Exception {

        super.dealTask();
        List<ZHXX001Entity> list = Zhxx001DbOperate.GetUnUploadALL(PreferHelper.getInstance().getString(AppConstants.PreKeys.QUALITY_BACK_BUILD_ID));
        for (ZHXX001Entity ent : list) {
            if (ent != null) {
                ProblemsUploadEntity mProblemsUploadEntity = new ProblemsUploadEntity();
                mProblemsUploadEntity.setCode1(ent.getStoreId());

                mProblemsUploadEntity.setContent(ent.getReportInfo());
                mProblemsUploadEntity.setManagerUserId(ent.getOper_Lr());

                mProblemsUploadEntity.setProblemType(Integer.parseInt(ent.getXXLX()));

                if(ent.getXXLX().equals("1")){//产品质量反馈
                    mProblemsUploadEntity.setProblemQualityProductDateStr(ent.getPDate());
                    mProblemsUploadEntity.setProblemQualityProductId(ent.getItemID());
                    mProblemsUploadEntity.setProblemQualityAmount(ent.getQty()+"");
                    mProblemsUploadEntity.setProblemQualityTypeId(Integer.parseInt(ent.getProblemSubtype()));
                }else if(ent.getXXLX().equals("6")){//本机问题反馈

                }else if(ent.getXXLX().equals("2")){//物流问题反馈

                }else if(ent.getXXLX().equals("21")){//专柜成列图片上传
                    mProblemsUploadEntity.setHuanGuiDateStr(ent.getHGRQ());
                    mProblemsUploadEntity.setHuanWeiZhiDateStr(ent.getHWZRQ());
                    mProblemsUploadEntity.setKaiYeDateStr(ent.getKYSJ());
                    mProblemsUploadEntity.setZhuanGuiTypeId(ent.getZGLX());
                }

                mProblemsUploadEntity.setShopId(ent.getStoreId());

                if (null != mUrls)
                    mProblemsUploadEntity.setUrls(mUrls);

                Gson gson = new Gson();
                String content = gson.toJson(mProblemsUploadEntity);

                resultStr = ResultTool.accessForType(NetParam.URL_PRODUCT_LIST, content);
                baseResponse = checkResult(resultStr, BaseOldResponse.class);
                if (baseResponse != null) {
                    if ("0".equals(((BaseOldResponse)baseResponse).msgCode)) {
                        Zhxx001DbOperate.UpdateBillState(ent.getBillId());
                    }
                }
            }
        }
    }

    @Override
    public void afterTask() {
        super.afterTask();
        if (resultStr == null) {
            showMessage("访问服务异常");
        }
        context.displayResult(TAG, baseResponse);
    }

}
