package com.urovo.wgmf.AsyncTask.uploadcases

import android.app.Activity
import android.app.AlertDialog
import android.content.Intent
import com.alibaba.android.arouter.launcher.ARouter
import com.amap.api.location.AMapLocation
import com.google.gson.Gson
import com.urovo.activity.attendancemanagement.SignInAndOutActivity
import com.urovo.activity.tabMenu.view.GlobalDialogBridgeAct
import com.urovo.wgmf.db.dao.dao.CxykqDbOperate
import com.urovo.wgmf.db.dao.entitys.CXYKQEntity
import com.urovo.wgmf.tool.netUtil.QiNiuDominator
import com.urovo.wugumofang.constants.*
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.data.PreferHelper
import com.urovo.wugumofang.net.NetHelper
import com.urovo.wugumofang.net.OkHttpDominator
import com.urovo.wugumofang.response.BaseOldResponse
import com.urovo.wugumofang.system.PdaMsgConfig
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.DialogHelper
import com.wgmf.trade.GlobalApp.context
import com.zsy.libcore.common.android.log.Log
import org.jetbrains.anko.doAsync
import java.io.File
import java.util.*
import java.util.concurrent.Semaphore

/**
 * @author Sasuke on 2020-02-14 0014.
 * 考勤上传Case
 *
 * @param isOfflineMode 是否是离线模式（是否有网会自己判断，这里传入的离线模式主要是手动设的标记，比如定位失败之类的）
 *
 * @param newPhotosPaths 这里的地址List就是以前的 data.photoList ，存的是图片本地地址。
 *
 * @param isFromDB 是否用现成数据库里的数据进行提交；
 *                              一般为：离线上传等则为true，实时打卡则为false，毕竟实时打卡是生成新数据
 *
 *  @see SignInAndOutActivity
 *
 */
class KaoqinUploadCase(val activity: Activity,
                       var isFromDB: Boolean,//是否是从数据库里读数据（离线打卡）
                       var signType: String,//打卡类型，上班 or 下班
                       val storeNo: String,//门店号
                       val userId: String,//用户工号
                       var newPhotosPaths: MutableList<String>? = null,
                       var location: AMapLocation? = null,//定位信息
//                                       val longitude: String,//经度
//                                       val latitude: String,//纬度
//                                       val address: String,//地址
                       var isBadLocation: Boolean = false) : UploadBaseCase() {

    /***
     * 离线上传Case专用（离线上传数据库里的单，很多参就不需要传了）
     */
    constructor( activity: Activity,
                 storeNo: String,
                 userId: String,
                 isBadLocation: Boolean): this(activity,true,"",storeNo,userId,null,null,isBadLocation)


    //卡住七牛上传
    val semaphoreQiNiu by lazy{
        Semaphore(1)
    }
    //卡住数据库上传
    val semaphoreDb by lazy{
        Semaphore(1)
    }
    //用于主干的卡住go()方法
//    var goCountdown: CountDownLatch? = null

//    //待上传的单数计数器，计到0了，就可以继续队列了
//    @Volatile var unUploadCount = 0

    override fun dowork() {
        doAsync {
            //上传现成的（离线打卡）=====================
            if (isFromDB) {
                if (!isHaveInternet()) {//手动上传没网？那传个球
                    enqueDominator?.go()
                    return@doAsync
                }
                //如果是POS机，就只用上传数据 ，不用传照片
                if (isPda()) {
                    semaphoreDb.acquire()
                    uploadDbData("")
                    doAsync { semaphoreDb.acquire();enqueDominator?.go() }//拦住先，上传完了再go()
                    return@doAsync
                }
                //如果不是POS机，那就带图上传 ( 先看未上传数，大于0才传，小于0继续走任务队列 )
                if (CxykqDbOperate.GetUnUploadCount() <= 0) {
                    enqueDominator?.go()
                    return@doAsync
                }
                val list = CxykqDbOperate.GetUnUpload()
//            goCountdown = CountDownLatch(list.size)
                for (ent in list) {
                    Log.i("SasukeLog", "0")
//                unUploadCount = fileList.size
                    semaphoreQiNiu.acquire()//卡循环，用于每单排队上传
                    semaphoreDb.acquire()//卡循环，用于每单排队上传
                    Log.i("SasukeLog", "7")
                    val fileList = Files.getSignInAndOutPhotoCache(ent.BILL).map { it.absolutePath }
                    upLoadPhoto2QiNiu(fileList, ent.BILL)//这里传入BILL单号，传完图之后就会自动更改数据库
                    Log.i("SasukeLog", "8")
//                goCountdown?.countDown()//卡后面的go()
                }
                doAsync {
                    //                goCountdown?.await()
                    Log.i("SasukeLog", "4")
                    semaphoreDb.acquire()
                    Log.i("SasukeLog", "5")
                    enqueDominator?.go()
                }
                return@doAsync
            }
            //实时打卡=====================
            semaphoreDb.acquire()//先拦住
            if (!isHaveInternet() || isPda()) {//没网 or 是POS机
                createAndUpload("")
                doAsync { semaphoreDb.acquire();enqueDominator?.go() }//如果是有网，但是是POS机情况，那还是会走uploadDb()，所以这里还是要拦一下

            } else {
                // 照片上传七牛后再上传考勤到服务器
                upLoadPhoto2QiNiu(newPhotosPaths)
                doAsync { semaphoreDb.acquire();enqueDominator?.go() }
            }
        }
    }


    /**修改离线打卡数据（照片URL）*/
    fun editSignAndUpload(billNo: String, moreImageUrl: String) {
        CxykqDbOperate.UpdateImageUrl(billNo,userId, moreImageUrl)
        uploadDbData(billNo)
    }
    /***
     *
     * 这个是上传图片到七牛之后的上传操作（POS机不需要上传图片所以可以直接执行这一步）
     */
    fun createAndUpload( moreImageUrl: String) {
//        activity.runOnUiThread { ViewUtil.showProgress(activity,"正在上传考勤信息","") }
        if (isHaveInternet()) {//在线上传（如果是上传数据库数据，那就直接走在线上传，不用走离线）
            val billNo = save2DataBase( moreImageUrl)
            uploadDbData(billNo)//直接上传该新建的单，（做好该做的事，失败单在外面去处理！）
        } else {//离线上传（这个showOfflineDialog()已经包含了save2DataBase了，所以上面就不用写了）
            showOfflineDialog(moreImageUrl)
        }
    }

    /***
     * 数据保存到数据库，后面上传的时候再拿出来
     */
    fun save2DataBase( moreImageUrl: String): String {
        val date = Date()
        val ent = CXYKQEntity().apply {
            BILL = storeNo + DateUtil.format(date, "yyMMddHHmmss")
            SKYID = userId
            STOREID = storeNo
            KQDATE = DateUtil.getDateByFormat(date, "yyyy-MM-dd HH:mm:ss")
            // ent.KQDATE = DateUtil.getDateBefore8Hours(date, "yyyy-MM-dd");
            // ent.KQTIME = DateUtil.getDateBefore8Hours(date, "HH:mm:ss");
            KQTYPE = signType // "0" 上班 ,"1" 下班 新版 "1" 上班（签到） ,"2" 下班（签退）
            LONGITUDE = location?.longitude?.toString() ?: ""//SystemHelper.Longitude;
            LATITUDE = location?.latitude?.toString() ?: ""//SystemHelper.Latitude;
            Position_Valid = Position_Valid ?: ""
            Address = location?.address ?: ""
            ImageUrl = ""
            MoreImageUrl = moreImageUrl
        }

        //把每个名字没有加tag的图片都加上此次打卡的单号，形成关联。
        newPhotosPaths?.forEachIndexed { index, srcPath ->
            val srcFile = File(srcPath)
            val destFile = File(srcFile.parentFile,"${ent.BILL}${srcFile.name}")
            srcFile.renameTo(destFile)
            newPhotosPaths?.set(index,destFile.absolutePath)
        }
//        Files.getSignInAndOutPhotoCache("_")?.forEachIndexed { index, it ->
//            it.renameTo(File(it.parentFile, "${ent.BILL}${it.name}"))
//            newPhotosPaths?.set(index,it.absolutePath)//把list里缓存的路径也加上单号
//        }
        CxykqDbOperate.SaveKaoQin(ent)
        return ent.BILL
    }

    /**
     * 从数据库拿数据，上传
     *
     * @param billNo 如果传入了单号，说明是离线上传；如果没传单号，说明是实时打卡上传
     * */
    fun uploadDbData(billNo: String) {
        doAsync {
            if (CxykqDbOperate.GetUnUploadCount() > 0) {
                var list =  CxykqDbOperate.GetUnUpload()
//                unUploadCount = list.size
                if (billNo.isNotBlank()) list = list.filter { it.BILL == billNo }//过滤，只留下billNo对应的单
                for (ent in list) {
                    val param = mapOf(
                        "userId" to ent.SKYID,
                        "storeId" to ent.STOREID,
                        "requestType" to "2",
                        "lng" to ent.LONGITUDE,
                        "lat" to ent.LATITUDE,
                        "userType" to if (SystemHelper.IsAdmin) "3" else "2",
                        "address" to ent.Address,
                        "type" to ent.KQTYPE,
                        "machine" to if (PdaMsgConfig.isPDA(activity)) "3" else "1",//打卡机型：1 android, 2 iOS，3 POS机
                        "signTime" to ent.KQDATE,
                        // 多张图片json串
                        "signImage" to ent.MoreImageUrl,
                        //离线打卡记录是否需要标注过期标签， "0":不需要  "1":需要
                        "isOfflineData" to if (CxykqDbOperate.upLoadInvalidDate(ent.KQDATE)) "1" else "0"
                    )
                    //开始上传
                    val res = OkHttpDominator.postSyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APPSALER.SIGN_IN_OR_OUT_MSG,
                        BaseOldResponse::class.java,
                        param) as BaseOldResponse

                    //上传处理
                    if (null != res && "打卡成功" == res.msgContent) {
                        // 如果上传成功，更新单据上传状态字段，同时获取剩余未上传单据记录
                        CxykqDbOperate.UpdateBillState(ent.BILL)
                        Files.getSignInAndOutPhotoCache(ent.BILL).forEach { it.delete() }//上传成功，删除关联照片
                    } else if (null != res && "1001" == res.msgCode) {//msgCode为1001时，不继续上传
                        CxykqDbOperate.UpdateBillState(ent.BILL, 2)
                        if (!(activity is SignInAndOutActivity)){//如果是更多页面手动上传
                            val intent = Intent(context, GlobalDialogBridgeAct::class.java)//全局弹窗，避免手动上传时，上传完后自动关闭当前界面导致弹窗也被关闭的问题。
                            intent.putExtra(GlobalDialogBridgeAct.INTENT_EXTRA, GlobalDialogBridgeAct.RemindExtra(GlobalDialogBridgeAct.TYPE_REMIND_SIGNIN, "提示", res.msgContent))
                        }
                    } else {//常规失败，则启动自动上传
                        resultStr = if (res.sysCode == "0")  res.msgContent else res.sysContent
                        if (res.ret == "1036" && res.retInfo.isNotBlank()) resultStr = "打卡上传失败: ${res.retInfo}"
                    }
                    //返回1001的时候不弹打卡弹窗
                    if (activity is SignInAndOutActivity && "1001" != res.msgCode && !isFromDB) {//!isFromDB表示实时打卡, 就算Activity是SignInAndout,也会一起提交离线打卡数据，所以要区分
                        activity.runOnUiThread({ activity.afterSignInAndOut() })
                    }
                }
            }
            semaphoreDb.release()
//            unUploadCount--
//            if (unUploadCount <= 0) enqueDominator?.go()
        }
    }


    @Volatile var isUploadCanceled = false//是否取消七牛上传图片
    internal var uploadTimer: TimerTask? = null
    /**
     * @param billNo 如果不为“”，则说明该次上传是要关联某个打卡单的
     * */
    private fun upLoadPhoto2QiNiu(photoList: List<String>?, billNo: String = "") {
        if (photoList?.size != 0) {
            // 执行到七牛图片上传时发生网络连接不通，去掉吐司提示的标志，进入离线模式
            PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_TOAST_FLAG, false)
            //多张图片上传成功后回调的图片url
//            activity.runOnUiThread { ViewUtil.showProgress(activity, "请稍等", "正在上传...", false) }
            //由于七牛个垃圾超时机制，好像并没有控制超时？？？
            //所以这里自己写一个定时器，上传图片请给老子10秒钟内上传完，没传完不管你，直接给你取消掉！
            //然后转向离线打卡。

            uploadTimer = object : TimerTask() {
                override fun run() {
                    isUploadCanceled = true
                    PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_TOAST_FLAG, true)
//                    isBadLocation = true
                    // 加载失败，离线模式
                    if (!isFromDB) {
                        showOfflineDialog("")
//                        save2DataBase( "")
                    }
                }
            }
            Timer().schedule(uploadTimer, 10_000)

            QiNiuDominator.uploadImages(photoList, QiNiuDominator.CompleteQiniu { qiniuUrl ->
                uploadTimer?.cancel()
                if (isUploadCanceled) return@CompleteQiniu
                //                    progressDialog.dismiss();
                //多张照片上传七牛后返回的Uri json串,用于缓存数据库的
                val mMoreImageUrl = Gson().toJson(qiniuUrl)
//                isBadLocation = false
                //上传七牛后缓存到本地数据库，并作（网络）上传处理
                if (!isFromDB) {
                    createAndUpload( mMoreImageUrl)
                } else {//离线上传
                    editSignAndUpload(billNo, mMoreImageUrl)
                    semaphoreQiNiu.release()
                }
            }, QiNiuDominator.FailureQiniu {
                uploadTimer?.cancel()
                if (isUploadCanceled) return@FailureQiniu
                // 关闭后执行到这里就恢复可以吐司
                PreferHelper.getInstance().setBoolean(AppConstants.PreKeys.KAOQIN_IS_TOAST_FLAG, true)
//                isBadLocation = true
                //实时打卡，保存数据库
                if (!isFromDB) {
//                    save2DataBase( "")
                    showOfflineDialog("")
                }else{//离线打卡
                    semaphoreQiNiu.release()
                    semaphoreDb.release()//图片都上传失败了，还想屁吃？直接算作数据库上传成功，然后进行下一步任务队列吧。
                }
            }, true)
        }
    }

    /**
     * 是否联网 或者 是否离线模式（注：在定位地理位置失败时，切入离线模式
     */
    fun isHaveInternet(): Boolean {
        return NetHelper.IsHaveInternet(activity) && !isBadLocation//非坏定位，则有网
    }

    /**判断是否是 Pos机*/
    fun isPda() = PdaMsgConfig.isPDA(activity)

    /**通过一个实时打卡Case生成离线打卡Case*/
    fun createFromDbCase() =KaoqinUploadCase(
        activity,
        true,
        "",
        storeNo,
        userId)


    /**提示离线打卡弹窗*/
    fun showOfflineDialog(moreImageUrl: String) {
        if (!(activity is SignInAndOutActivity && !isFromDB)) return//只有实时打卡的界面才显示弹窗 &&不能是离线打卡
        activity.runOnUiThread {
            val msg = if ("1" == signType) "签到" else "签退"
//            ViewUtil.dismissProgress()
            DialogHelper.baseAlert2(activity, "提示", "是否要$msg?", null,
                { dialog, which ->
                    save2DataBase(moreImageUrl)//这里的moreImageUrl不要写死成""，因为可能有网但定位失败的情况，还是要传图片地址的
                    AlertDialog.Builder(activity).setMessage("本次离线打卡保存成功，网络正常时系统会自动上传！")
                        .setPositiveButton("确定", { dialog, which ->
                            ARouter.getInstance().build(RouterParams.ORIGIN.TABMENUACTIVITY).navigation()
                        }).create().show()
                    // 离线模式下把控制自动上传请求的开关打开
                }, false)
            enqueDominator?.go()
        }
    }
}