package com.urovo.wgmf;

import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.umeng.analytics.MobclickAgent;
import com.urovo.activity.nativemanager.UntreatedOrder;
import com.urovo.activity.nativemanager.UpEndBroadcast;
import com.urovo.activity.nativemanager.UpEndNotify;
import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.dao.MsgOperate;
import com.urovo.wgmf.db.dao.entitys.MsgDb;
import com.urovo.wgmf.notice.CuXiaoHuoDongActivity;
import com.urovo.wgmf.notice.XiaoShouMiJiActivity;
import com.urovo.wgmf.notice.ZongBuTongZhiActivity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.DataMonthUtils;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * @ClassName: MessageActivity
 * @Description: 消息列表界面
 */
public class MessageActivity extends BaseActivity implements OnClickListener,
		UpEndNotify {
	private static String XIAOSHOUMIJI = "销售秘籍";
	private static String DAIBANSHIXIANG = "待办事项";
	public static String ZONGBUTONGZHI = "总部通知";
	private static String CUXIAOHUODONG = "促销活动";
	private boolean mIsAdmin;
	private int mMessageSalesCounts, mMessageBooksCounts, mMessageNoticeCounts;
	private boolean isOpen = false;
	private ListView mListView;
	private MyAdapter mMyAdapter;
	private static boolean isVisible = false;
	private static Object lock = new Object();
	private List<Model> mList = new ArrayList<Model>();
	private LinearLayout mMessageSales;// 促销活动
	private LinearLayout mMessageSchedule;// 待办事项
	private LinearLayout mMessageBooks;// 销售秘籍
	private LinearLayout mMessageNotice;// 公告通知
	private TextView mMessageSalesCount;
	private TextView mMessageScheduleCount;
	private TextView mMessageBooksCount;
	private TextView mMessageNoticeCount;
	private String mSql;
	private List<MsgDb> list = MsgOperate.selectBy(null);
	Date date = new Date();
	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

	public interface MessageClickListener {
		void onMessageItemClick(Model model);

		void onMessageItemOpen(View v, Model model);
	}

	/**
	 * 声明标题栏的tab
	 */
	private TextView mMessageSalesTxt, mMessageScheduleTxt, mMessageBooksTxt,
			mMessageNoticeTxt;
	/**
	 * 标题栏的下标
	 */
	private ImageView mMessageSalesImg, mMessageScheduleImg, mMessageBooksImg,
			mMessageNoticeImg;
	/**
	 * 下标集合
	 */
	private List<TextView> textViews;

	/**
	 * tab集合
	 */
	private List<ImageView> imageViews;

	// 待办事项广播
	private UpEndBroadcast broadcast = new UpEndBroadcast(this);

	public static boolean isVisible() {
		synchronized (lock) {
			return isVisible;
		}
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.message);
		initTitle();
		initHeader();
		initContent();
		initListView(list);
	}

	/**
	 * 
	 * @Title: initMsgCount
	 * @Description: 通知分类计数
	 * @param 参数说明
	 * @return void 返回类型
	 * @throws
	 */
	private void initMsgCount() {
		mMessageSalesCounts = 0;
		mMessageBooksCounts = 0;
		mMessageNoticeCounts = 0;
		List<MsgDb> list = MsgOperate.selectValid();
		for (int i = 0; i < list.size(); i++) {
			MsgDb db = list.get(i);
			if ("1".equals(db.mType)) {
				mMessageNoticeCounts++;
			} else if ("2".equals(db.mType)) {
				mMessageBooksCounts++;
			} else if ("3".equals(db.mType)) {
				mMessageSalesCounts++;
			}
		}
		// 公告通知数据条目数
		NoticeCounts(mMessageNoticeCount, mMessageNoticeCounts);
		// 销售秘籍数据条目数
		NoticeCounts(mMessageBooksCount, mMessageBooksCounts);
		// 促销活动数据条目数
		NoticeCounts(mMessageSalesCount, mMessageSalesCounts);
	}

	/**
	 * 
	 * @Title: NoticeCounts
	 * @Description: 通知计数显示方法
	 * @param @param textview
	 * @param @param counts 参数说明
	 * @return void 返回类型
	 * @throws
	 */
	private void NoticeCounts(TextView textview, int counts) {
		if (counts > 0) {
			textview.setVisibility(View.VISIBLE);
			if (counts < 100) {
				textview.setText("" + counts);
			} else {
				textview.setText("99+");
			}
		} else {
			textview.setVisibility(View.INVISIBLE);
		}
	}

	@Override
    protected void onResume() {

		super.onResume();
		initMsgCount();// 显示时刷新计数
		synchronized (lock) {
			isVisible = true;
		}
		super.onResume();
		int newCount = DalCommon.GetUnUploadCount(false);
		if (newCount == 0) {
			mMessageScheduleCount.setVisibility(View.GONE);
		} else {
			mMessageScheduleCount.setVisibility(View.VISIBLE);
			if (newCount < 100) {
				mMessageScheduleCount.setText(newCount + "");
			} else {
				mMessageScheduleCount.setText("99+");
			}
		}
		try {
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			Date nowDate = new Date();
			HashMap<String, String> map = new HashMap<String, String>();
			map.put("store_id", SystemHelper.LoginOrganId);
			map.put("store_name", SystemHelper.LoginOrganName);
			map.put("user_id", SystemHelper.LoginUserId);
			map.put("user_name", SystemHelper.LoginUserName);
			map.put("time", sdf.format(nowDate));
			MobclickAgent.onEvent(this, "id_login", map);
		} catch (Exception e) {
			BaseAppManager.loger().info(e);

		}
		mMyAdapter.notifyDataSetChanged();
	}

	@Override
	public void displayResult(String tag, BaseResponse response) {

		super.displayResult(tag, response);

	}

	@Override
	public void initTitle() {

		super.initTitle();
		titleTextView.setText("通知");
	}

	private void initHeader() {

	}

	private void initContent() {
		mMessageSales = (LinearLayout) findViewById(R.id.ll_message_sales);
		mMessageSchedule = (LinearLayout) findViewById(R.id.ll_message_schedule);
		mMessageBooks = (LinearLayout) findViewById(R.id.ll_message_books);
		mMessageNotice = (LinearLayout) findViewById(R.id.ll_message_notice);
		mMessageSalesCount = (TextView) findViewById(R.id.message_sales_count);
		mMessageScheduleCount = (TextView) findViewById(R.id.message_schedule_count);
		mMessageBooksCount = (TextView) findViewById(R.id.message_books_count);
		mMessageNoticeCount = (TextView) findViewById(R.id.message_notice_count);
		IntentFilter intentFilter = new IntentFilter("com.urovo.wgmf.upend");
		registerReceiver(broadcast, intentFilter);
		mMessageSalesTxt = (TextView) findViewById(R.id.message_sales_txt);
		mMessageScheduleTxt = (TextView) findViewById(R.id.message_schedule_txt);
		mMessageBooksTxt = (TextView) findViewById(R.id.message_books_txt);
		mMessageNoticeTxt = (TextView) findViewById(R.id.message_notice_txt);

		mMessageSalesImg = (ImageView) findViewById(R.id.message_sales_img);
		mMessageScheduleImg = (ImageView) findViewById(R.id.message_schedule_img);
		mMessageBooksImg = (ImageView) findViewById(R.id.message_books_img);
		mMessageNoticeImg = (ImageView) findViewById(R.id.message_notice_img);
		mMessageSales.setOnClickListener(this);
		mMessageSchedule.setOnClickListener(this);
		mMessageBooks.setOnClickListener(this);
		mMessageNotice.setOnClickListener(this);
		// 装载控件到集合
		textViews = new ArrayList<TextView>();
		textViews.add(mMessageSalesTxt);
		textViews.add(mMessageScheduleTxt);
		textViews.add(mMessageBooksTxt);
		textViews.add(mMessageNoticeTxt);
		imageViews = new ArrayList<ImageView>();
		imageViews.add(mMessageSalesImg);
		imageViews.add(mMessageScheduleImg);
		imageViews.add(mMessageBooksImg);
		imageViews.add(mMessageNoticeImg);
		// 初始化发现页面的背景
		textViews.get(0).setTextColor(
				getResources().getColor(R.color.blue_text_color));
		imageViews.get(0).setImageResource(R.drawable.msged);

		mMyAdapter = new MyAdapter();
		// 实现接口回调方法（此处未实现操作）
		mMyAdapter.setListener(new MessageClickListener() {

			@Override
			public void onMessageItemOpen(View v, Model model) {

				if (!isOpen) {
					isOpen = true;
					model.mIsOpen = true;

				} else {
					// 全行显示
					isOpen = false;
					model.mIsOpen = false;

				}
				mListView.setAdapter(mMyAdapter);
			}

			@Override
			public void onMessageItemClick(Model model) {
				if (DAIBANSHIXIANG.equals(model.mLabel)) {
					model.mIsNew = false;
					toActivity(UntreatedOrder.class);
				} else if (ZONGBUTONGZHI.equals(model.mLabel)) {
					model.mIsNew = false;
					MsgDb mode = (MsgDb) model.mObject;
					MsgOperate.update(mode);
					Intent intent = new Intent();
					intent.setClass(MessageActivity.this,
							ZongBuTongZhiActivity.class);
					intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_ISNEW,
							model.mIsNew);
					intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_TITLE,
							model.mTitle);
					intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_ID,
							model.mID);
					intent.putExtra(ZongBuTongZhiActivity.ZHONGBUTONGZHI_DATE,
							model.mDate);
					intent.putExtra(
							ZongBuTongZhiActivity.ZHONGBUTONGZHI_CONTENT,
							model.mContent);
					startActivity(intent);
				} else if (XIAOSHOUMIJI.equals(model.mLabel)) {
					model.mIsNew = false;
					MsgDb mode = (MsgDb) model.mObject;
					MsgOperate.update(mode);
					Intent intent = new Intent();
					intent.setClass(MessageActivity.this,
							XiaoShouMiJiActivity.class);
					Bundle b = new Bundle();
					b.putBoolean("isnew", model.mIsNew);
					b.putString("miji", model.mContent);
					b.putString("title", model.mTitle);
					b.putString("id", model.mID);
					b.putString("date", model.mDate);
					b.putString("bsc", "");
					b.putString("store", "");
					intent.putExtra("bundle", b);
					startActivity(intent);
				} else if (CUXIAOHUODONG.equals(model.mLabel)) {
					model.mIsNew = false;
					MsgDb mode = (MsgDb) model.mObject;
					MsgOperate.update(mode);
					Intent intent = new Intent(MessageActivity.this,
							CuXiaoHuoDongActivity.class);
					Bundle b = new Bundle();
					b.putBoolean("isnew", model.mIsNew);
					b.putString("cuxiao", model.mContent);
					b.putString("title", model.mTitle);
					b.putString("id", model.mID);
					b.putString("state", model.mImgState);
					b.putString("date", model.mDate);
					b.putString("update", model.mDate);
					intent.putExtra("bundle", b);
					intent.putExtra("storeId", SystemHelper.LoginOrganId);
					startActivity(intent);
				}
			}
		});
		mListView = (ListView) findViewById(R.id.listView1);
		mListView.setAdapter(mMyAdapter);
	}

	private void toActivity(Class<?> class1) {
		Intent intent = new Intent();
		intent.setClass(this, class1);
		startActivity(intent);
	}

	private class Model {
		boolean mIsNew;
		boolean mIsOpen;//妈蛋！这个东西到底有什么用啊？？？？？
		String mType_ID;
		String mLabel;
		String mID;
		String mTitle;
		String mContent;
		String mImgState;
		String mDate;
		Object mObject;

		@Override
		public String toString() {
			return "Model [mIsNew=" + mIsNew + ", mIsOpen=" + mIsOpen
					+ ", mType_ID=" + mType_ID + ", mLabel=" + mLabel
					+ ", mID=" + mID + ", mTitle=" + mTitle + ", mContent="
					+ mContent + ", mImgState=" + mImgState + ", mDate="
					+ mDate + ", mObject=" + mObject + "]";
		}
	}

	private class ViewHolder {
		ImageView mImageViewNew;
		TextView mTextViewLabel;
		TextView mTextViewTitle;
		TextView mTextViewContent;
		ImageView mImgState;
		TextView mTextViewDate;
		Button mBtnMore;
	}

	class MyAdapter extends BaseAdapter {
		private MessageClickListener listener;
		ViewHolder holder;

		@Override
		public int getCount() {

			return mList.size();
		}

		@Override
		public Object getItem(int position) {

			return mList.get(position);
		}

		@Override
		public long getItemId(int position) {

			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {

			if (null == convertView) {
				convertView = LayoutInflater.from(MessageActivity.this)
						.inflate(R.layout.listview_item_message, null);
				holder = new ViewHolder();
				holder.mImageViewNew = (ImageView) convertView
						.findViewById(R.id.imageViewNew);
				holder.mTextViewLabel = (TextView) convertView
						.findViewById(R.id.textViewLabel);
				holder.mTextViewTitle = (TextView) convertView
						.findViewById(R.id.textViewTitle);
				holder.mTextViewContent = (TextView) convertView
						.findViewById(R.id.textViewContent);
				holder.mImgState = (ImageView) convertView
						.findViewById(R.id.ivActiveState);
				holder.mTextViewDate = (TextView) convertView
						.findViewById(R.id.textViewDate);
				holder.mBtnMore = (Button) convertView
						.findViewById(R.id.bt_more);
				convertView.setTag(holder);
			}
			holder = (ViewHolder) convertView.getTag();
			final Model cell = mList.get(position);
			if (cell.mIsNew) {
				holder.mImageViewNew.setVisibility(View.VISIBLE);
			} else {
				holder.mImageViewNew.setVisibility(View.INVISIBLE);
			}
			if ("0".equals(cell.mImgState)) {// 活动未开始
				holder.mImgState.setVisibility(View.VISIBLE);
				holder.mImgState.setImageResource(R.drawable.act_state_1);
			} else if ("1".equals(cell.mImgState)) {// 活动进行中
				holder.mImgState.setVisibility(View.VISIBLE);
				holder.mImgState.setImageResource(R.drawable.act_state_2);
			} else if ("2".equals(cell.mImgState)) {// 活动已结束
				holder.mImgState.setVisibility(View.VISIBLE);
				holder.mImgState.setImageResource(R.drawable.act_state_3);
			} else {
				holder.mImgState.setVisibility(View.GONE);
			}
			holder.mTextViewLabel.setText(cell.mLabel);
			holder.mTextViewTitle.setText(cell.mTitle);
			holder.mTextViewContent.setText(cell.mContent);
			holder.mTextViewDate.setText(cell.mDate);
			holder.mBtnMore.setVisibility(View.GONE);
			// 给列表条目设置点击事件
			convertView.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View view) {
					if (null != listener) {
						listener.onMessageItemClick(cell);
					}
				}
			});
			// 给列表条目子控件设置点击事件
			final View mview = convertView;
			holder.mBtnMore.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View view) {
					if (null != listener) {

						listener.onMessageItemOpen(mview, cell);
					}
				}
			});
			return convertView;
		}

		public void setListener(MessageClickListener listener) {
			this.listener = listener;
		}
	}

	/**
	 * 列表页签点击事件
	 */
	@Override
	public void onClick(View view) {
		int position = -1;

		switch (view.getId()) {

		case R.id.ll_message_sales:
			position = 0;
			this.setSelectedItem(position);
			initListView(list);
			break;
		case R.id.ll_message_schedule:
			position = 1;
			this.setSelectedItem(position);
			mList.clear();
			// mMessageScheduleCount.setVisibility(View.GONE);
			int daiban = DalCommon.GetUnUploadCount(false);
			if (daiban > 0) {
				Model cell = new Model();
				cell.mIsNew = true;
				cell.mLabel = DAIBANSHIXIANG;
				cell.mTitle = "未处理单据";
				cell.mContent = "您有" + daiban + "条待办事项";
				cell.mDate = sdf.format(date);
				mList.add(cell);
			}
			mListView.setAdapter(mMyAdapter);
			break;
		case R.id.ll_message_books:
			position = 2;
			this.setSelectedItem(position);
			mList.clear();
			// mMessageBooksCount.setVisibility(View.GONE);
			if (null != list && list.size() > 0) {
				for (int i = 0; i < list.size(); i++) {
					MsgDb db = list.get(i);
					Model cell = new Model();
					cell.mIsNew = db.mInvalid == null ? true : false;
					if ("2".equals(db.mType)) {
						cell.mLabel = XIAOSHOUMIJI;
						cell.mID = db.mNo;
						cell.mTitle = db.mTitle;
						cell.mContent = db.mContent;
						cell.mDate = db.mDate;
						cell.mObject = db;
						mList.add(cell);
						SortMsgDate();
					}
				}
			}
			mListView.setAdapter(mMyAdapter);
			break;
		case R.id.ll_message_notice:
			position = 3;
			this.setSelectedItem(position);

			mList.clear();
			// mMessageNoticeCount.setVisibility(View.GONE);
			if (null != list && list.size() > 0) {
				for (int i = 0; i < list.size(); i++) {
					MsgDb db = list.get(i);
					Model cell = new Model();
					cell.mIsNew = db.mInvalid == null ? true : false;

					if ("1".equals(db.mType)) {
						cell.mLabel = ZONGBUTONGZHI;
						cell.mID = db.mNo;
						cell.mTitle = db.mTitle;
						cell.mContent = db.mContent;
						cell.mDate = db.mDate;
						cell.mObject = db;
						mList.add(cell);
						SortMsgDate();
					}
				}
			}
			mListView.setAdapter(mMyAdapter);
			break;
		default:
			break;
		}
	}

	/**
	 * 
	 * @Title: SortMsgDate
	 * @Description: 通知按发布时间靠后的先显示
	 * @param 参数说明
	 * @return void 返回类型
	 * @throws
	 */
	private void SortMsgDate() {
		Collections.sort(mList, new Comparator<Model>() {

			@Override
			public int compare(Model lhs, Model rhs) {

				if (DataMonthUtils.getCompareDate(lhs.mDate, rhs.mDate) < 0) {
					return -1;
				} else if (lhs.mDate.equals(rhs.mDate)) {
					return 0;
				} else {
					return 1;
				}
			}
		});
	}

	private void initListView(List<MsgDb> list) {
		mList.clear();
		// mMessageSalesCount.setVisibility(View.GONE);
		if (null != list && list.size() > 0) {
			for (int i = 0; i < list.size(); i++) {

				MsgDb db = list.get(i);
				Model cell = new Model();

				cell.mIsNew = db.mInvalid == null ? true : false;
				if ("3".equals(db.mType)) {
					cell.mLabel = CUXIAOHUODONG;
					cell.mID = db.mNo;
					cell.mTitle = "活动主题：" + db.mTitle;
					cell.mContent = "活动时间：" + db.mActStartTime + " 至 "
							+ db.mActEndTime + "\n" + "活动内容：" + db.mContent;
					cell.mDate = db.mDate;
					cell.mObject = db;
					if (DataMonthUtils.getCompareDate(db.mActStartTime,
							sdf.format(date)) < 0) {
						// 开始时间大于今天， 未开始
						cell.mImgState = "0";
					} else if (DataMonthUtils.getCompareDate(db.mActStartTime,
							sdf.format(date)) >= 0
							&& DataMonthUtils.getCompareDate(db.mActEndTime,
									sdf.format(date)) <= 0) {
						// 开始时间小于等于今天，结束时间大于等于今天，进行中
						cell.mImgState = "1";
					} else if (DataMonthUtils.getCompareDate(db.mActEndTime,
							sdf.format(date)) > 30) {
						// 结束时间小于今天30天，已过期
						cell.mImgState = "3";
						MsgOperate.deleteBy(" WHERE ENDTIME='" + db.mActEndTime
								+ "'");
					} else if (DataMonthUtils.getCompareDate(db.mActEndTime,
							sdf.format(date)) > 0) {
						// 结束时间小于今天，已结束
						cell.mImgState = "2";
					}
					if (cell.mImgState != "3" && cell.mImgState != "2") {
						// 若已过期，不显示（后续需求要求 已结束 也不显示）
						mList.add(cell);
						Collections.sort(mList, new Comparator<Model>() {

							@Override
							public int compare(Model lhs, Model rhs) {

								if (StringUtils.toInt(lhs.mImgState)
										- StringUtils.toInt(rhs.mImgState) < 0) {
									return -1;
								} else if (lhs.mImgState.equals(rhs.mImgState)) {
									return 0;
								} else {
									return 1;
								}
							}
						});
					}
				}
			}
		}
		mListView.setAdapter(mMyAdapter);
	}

	/**
	 * 
	 * @Title: setSelectedItem
	 * @Description: tab标签的选择
	 * @param @param position 参数说明
	 * @return void 返回类型
	 * @throws
	 */
	private void setSelectedItem(int position) {
		for (int i = 0; i < imageViews.size(); i++) {
			// imageViews.get(i).setBackgroundColor(
			// getResources().getColor(R.color.black));
			imageViews.get(i).setImageResource(R.drawable.msg);
			textViews.get(i).setTextColor(
					getResources().getColor(R.color.black));
		}
		imageViews.get(position).setImageResource(R.drawable.msged);
		textViews.get(position).setTextColor(
				getResources().getColor(R.color.blue_text_color));
		textViews.get(position).getPaint().setFakeBoldText(true);
	}

	@Override
	public void notifyData() {
		// 未上传数据条目数
		int count = DalCommon.GetUnUploadCount(false);
		if (count == 0) {
			mMessageScheduleCount.setVisibility(View.GONE);
		} else {
			mMessageScheduleCount.setVisibility(View.VISIBLE);
			mMessageScheduleCount.setText(count + "");
		}
	}

	@Override
	protected void onStop() {

		super.onStop();
		synchronized (lock) {
			isVisible = false;
		}
	}

	@Override
	protected void onPause() {

		super.onPause();
		synchronized (lock) {
			isVisible = false;
		}
	}

	@Override
	protected void onDestroy() {

		super.onDestroy();
		unregisterReceiver(broadcast);
	}
}
