package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.ZCDA002Entity;
import com.urovo.wgmf.db.dao.entitys.ZCDB002Entity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.StringUtils;

import java.util.List;

public class AssetDiaoChuAdapter extends BaseAdapter {
	private List<ZCDB002Entity> list;
	private BaseActivity context;
	private List<ZCDA002Entity> KClist;

	public AssetDiaoChuAdapter(List<ZCDB002Entity> list, BaseActivity context, List<ZCDA002Entity> KClist) {
		this.list = list;
		this.context = context;
		this.KClist = KClist;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		final ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_materialstransferout_item, null);
			viewHolder = new ViewHolder();
			viewHolder.check = (CheckBox) convertView.findViewById(R.id.transferout_checkBox);
			viewHolder.name = (TextView) convertView.findViewById(R.id.transferout_name);
			viewHolder.subtract = (ImageButton) convertView.findViewById(R.id.goods_decrease);
			viewHolder.add = (ImageButton) convertView.findViewById(R.id.goods_plus);
			viewHolder.count = (TextView) convertView.findViewById(R.id.transferout_count);
			viewHolder.kcoum = (TextView) convertView.findViewById(R.id.kcuom);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		final ZCDB002Entity ent = list.get(position);
		viewHolder.name.setText(ent.ZCNAME);
		viewHolder.kcoum.setText("单位:" + " " + ent.KCUOMName);
		// viewHolder.count.setText(StringUtils.formatDouble(ent.TQTY,"0"));
		viewHolder.check.setChecked(ent.isCheck);
		if(ent.isCheck) {
			viewHolder.count.setText(StringUtils.formatDouble(ent.TQTY, "0.##"));
			viewHolder.subtract.setVisibility(View.VISIBLE);
			viewHolder.add.setVisibility(View.VISIBLE);
		}
		else {
			viewHolder.count.setText(StringUtils.formatDouble(KClist.get(position).KCQTY, "0.##"));
			viewHolder.subtract.setVisibility(View.GONE);
			viewHolder.add.setVisibility(View.INVISIBLE);
		}
		if(ent.TQTY <= 0) {
			viewHolder.subtract.setEnabled(false);
		}
		else {
			viewHolder.subtract.setEnabled(true);
		}
		if(ent.TQTY == KClist.get(position).KCQTY) {
			viewHolder.add.setEnabled(false);
		}
		else {
			viewHolder.add.setEnabled(true);
		}
		// viewHolder.check.setOnClickListener(new OnClickListener() {
		//
		// @Override
		// public void onClick(View v) {
		//
		// if(!ent.isCheck){
		// viewHolder.subtract.setVisibility(View.VISIBLE);
		// viewHolder.add.setVisibility(View.VISIBLE);
		// viewHolder.check.setChecked(true);
		// ent.isCheck = true;
		// }else{
		// viewHolder.subtract.setVisibility(View.GONE);
		// viewHolder.add.setVisibility(View.INVISIBLE);
		// viewHolder.check.setChecked(false);
		// ent.isCheck = false;
		// }
		//
		// }
		// });
		viewHolder.subtract.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				double newCount = Double.parseDouble(viewHolder.count.getText().toString());
				newCount = Arith.sub(newCount, 1);
				ent.TQTY = newCount;
				ent.HAMT = Arith.mul(ent.TQTY, ent.HCOST);
				viewHolder.count.setText(StringUtils.formatDouble(newCount, "0.##"));
				if(ent.TQTY == 0) {
					viewHolder.subtract.setEnabled(false);
				}
				if(ent.TQTY < KClist.get(position).KCQTY) {
					viewHolder.add.setEnabled(true);
				}
			}
		});
		viewHolder.add.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				double newCount2 = Double.parseDouble(viewHolder.count.getText().toString());
				newCount2 = Arith.add(newCount2, 1);
				ent.TQTY = newCount2;
				ent.HAMT = Arith.mul(ent.TQTY, ent.HCOST);
				viewHolder.count.setText(StringUtils.formatDouble(newCount2, "0.##"));
				if(ent.TQTY > 0) {
					viewHolder.subtract.setEnabled(true);
				}
				if(ent.TQTY == KClist.get(position).KCQTY) {
					viewHolder.add.setEnabled(false);
				}
			}
		});
		return convertView;
	}

	class ViewHolder {
		CheckBox check;
		TextView name;
		ImageButton subtract;
		ImageButton add;
		TextView count;
		TextView kcoum;

	}

}
