package com.urovo.wgmf.adapter;

import java.util.List;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ZCPD001Entity;
import com.urovo.wugumofang.R;

public class AssetInventtoryAdapter extends BaseAdapter {
	private List<ZCPD001Entity> list;
	private BaseActivity context;

	public AssetInventtoryAdapter(List<ZCPD001Entity> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_materialscheck_item, null);
			viewHolder = new ViewHolder();
			viewHolder.text1 = (TextView) convertView.findViewById(R.id.check_dnum);
			viewHolder.text2 = (TextView) convertView.findViewById(R.id.check_date);
			viewHolder.text3 = (TextView) convertView.findViewById(R.id.check_maker);
			viewHolder.text4 = (TextView) convertView.findViewById(R.id.check_store);
			viewHolder.text5 = (TextView) convertView.findViewById(R.id.status);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		ZCPD001Entity ent = list.get(position);
		viewHolder.text1.setText(ent.BILL);
		viewHolder.text2.setText(ent.WDATE);
		viewHolder.text3.setText(ent.LR_NAME);
		viewHolder.text4.setText(ent.STOREName);
		String typeString = "1".equals(ent.SPSTATUS) ? "已盘点" : "未盘点";
		viewHolder.text5.setText(typeString);
		return convertView;
	}

	class ViewHolder {
		TextView text1;
		TextView text2;
		TextView text3;
		TextView text4;
		TextView text5;

	}

}
