package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ZCPD002Entity;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.R;

import java.util.List;

public class AssetInventtoryDetailAdapter extends BaseAdapter {
    private List<ZCPD002Entity> list;
    private BaseActivity context;

    public AssetInventtoryDetailAdapter(List<ZCPD002Entity> list, BaseActivity context) {
        this.list = list;
        this.context = context;

    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_checkgoodsmenu_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView.findViewById(R.id.check_name);
            viewHolder.count = (TextView) convertView.findViewById(R.id.count);
            viewHolder.kcuom = (TextView) convertView.findViewById(R.id.kcuom);
            viewHolder.price = (TextView) convertView.findViewById(R.id.price);
            viewHolder.amount = (TextView) convertView.findViewById(R.id.amount);
            viewHolder.pdCount = (TextView) convertView.findViewById(R.id.pd_count);
            viewHolder.isPD = (LinearLayout) convertView.findViewById(R.id.is_pandian);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final ZCPD002Entity ent = list.get(position);
        viewHolder.name.setText(ent.ZCNAME);
        viewHolder.kcuom.setText("(" + ent.KCUOMName + ")");
        viewHolder.price.setText(StringUtils.formatDouble(ent.HCOST, "0.00"));
        if (!ent.isPanDian) {
            ent.SPQTY = 0;
            ent.HAMT = 0;
            viewHolder.pdCount.setText("点击盘点");
            viewHolder.pdCount.setTextColor(context.getResources().getColor(R.color.red_text_color));
            viewHolder.isPD.setVisibility(View.GONE);
        } else {
            viewHolder.pdCount.setText(StringUtils.formatDouble(ent.SPQTY, "0.##"));
            viewHolder.pdCount.setTextColor(context.getResources().getColor(R.color.blue_text_color));
            viewHolder.isPD.setVisibility(View.VISIBLE);
        }
        viewHolder.count.setText(StringUtils.formatDouble(ent.SPQTY, "0.##"));
        viewHolder.amount.setText(StringUtils.formatDouble(ent.HAMT, "0.00"));
        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView count;
        TextView kcuom;
        TextView price;
        TextView amount;
        TextView pdCount;
        LinearLayout isPD;
    }

}
