package com.urovo.wgmf.adapter;

import java.util.List;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.ZCPS001Entity;
import com.urovo.wugumofang.R;

public class AssetPeiRuAdapter extends BaseAdapter {
	private List<ZCPS001Entity> list;
	private BaseActivity context;

	public AssetPeiRuAdapter(List<ZCPS001Entity> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_materialsmixing_item, null);
			viewHolder = new ViewHolder();
			viewHolder.text1 = (TextView) convertView.findViewById(R.id.mixing_dnum);
			viewHolder.text2 = (TextView) convertView.findViewById(R.id.mixing_xnum);
			viewHolder.text3 = (TextView) convertView.findViewById(R.id.mixing_date);
			viewHolder.text4 = (TextView) convertView.findViewById(R.id.mixing_store);
			viewHolder.text5 = (TextView) convertView.findViewById(R.id.mixing_factory);
			viewHolder.text6 = (TextView) convertView.findViewById(R.id.mixing_maker);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		viewHolder.text1.setText(list.get(position).BILL);
		String type = null;
		if("1".equals(list.get(position).PSTYPE)) {
			type = "配送";
		}
		else
			if("2".equals(list.get(position).PSTYPE)) {
				type = "红冲";
			}
			else
				if("3".equals(list.get(position).PSTYPE)) {
					type = "返仓";
				}
				else {
					type = "未知";
				}
		viewHolder.text2.setText(type);
		viewHolder.text3.setText(list.get(position).WDATE);
		String stroeName = Store001DbOprate.GetStoreName(list.get(position).TSTOREID);
		viewHolder.text4.setText(stroeName);
		viewHolder.text5.setText(list.get(position).STOREName);
		viewHolder.text6.setText(list.get(position).LR_NAME);
		return convertView;
	}

	class ViewHolder {
		TextView text1;
		TextView text2;
		TextView text3;
		TextView text4;
		TextView text5;
		TextView text6;

	}

}
