package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.constraintlayout.widget.ConstraintLayout;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.entity.response.DingHuoQueryNewRes;
import com.urovo.wgmf.db.dao.entitys.Group;
import com.urovo.wgmf.db.dao.entitys.QueryEntity;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.List;

public class DingHuoQueryAdapter2 extends BaseExpandableListAdapter {

    private final BaseActivity context;
    private final ArrayList<DingHuoQueryNewRes.DinghuoEntity> dataList = new ArrayList<>();
    private List<Group> group;
    private List<List<QueryEntity>> child;

    public DingHuoQueryAdapter2(List<DingHuoQueryNewRes.DinghuoEntity> list, BaseActivity context) {
        this.context = context;
//		group = new ArrayList<Group>();
//		child = new ArrayList<List<QueryEntity>>();
        if (list != null && list.size() > 0) {
            dataList.clear();
            dataList.addAll(list);
//			group.add(new Group(list.get(0).WDate, list.get(0).Bill, 0, 0));
//			// group.add(new Group(list.get(0).WDate,0,0));
//			for (QueryEntity a : list) {
//				if(!group.contains(new Group(a.WDate, a.Bill, 0, 0)))
//				// if (!group.contains(new Group(a.WDate,0,0)))
//				{
//					group.add(new Group(a.WDate, a.Bill, 0, 0));
//					// group.add(new Group(a.WDate,0,0));
//				}
//			}
//			for (Group g : group) {
//				ArrayList<QueryEntity> childItem = new ArrayList<QueryEntity>();
//				double amount = 0;
//				double count = 0;
//				for (QueryEntity a : list) {
//					if(a.Bill.equals(g.bill))
//					// if (a.WDate.equals(g.date))
//					{
//						childItem.add(a);
//						amount = Arith.add(amount, Double.parseDouble(a.Amount));
//						count = Arith.add(count, Double.parseDouble(a.TQTY));
//					}
//				}
//				g.amount = amount;
//				if(count - (int) count == 0) {
//					g.count = (int) count;
//				}
//				else {
//					g.count = count;
//				}
//				child.add(childItem);
//			}
        }
    }

    @Override
    public int getGroupCount() {
        return dataList.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        return dataList.get(groupPosition).getGoodDetailList() == null ? 0 : dataList.get(groupPosition).getGoodDetailList().size();
    }


    @Override
    public DingHuoQueryNewRes.DinghuoEntity getGroup(int groupPosition) {
        return dataList.get(groupPosition);
    }

    @Override
    public DingHuoQueryNewRes.DinghuoEntity.GoodDetailListBean getChild(int groupPosition, int childPosition) {
        return dataList.get(groupPosition).getGoodDetailList().get(childPosition);
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.ordergoods_query_list_item, null);
        }

        DingHuoQueryNewRes.DinghuoEntity dinghuoEntity = getGroup(groupPosition);
        ConstraintLayout clItemContent = convertView.findViewById(R.id.clItemContent);
        TextView tvOrderId = convertView.findViewById(R.id.tvOrderId);
        TextView tvDate = convertView.findViewById(R.id.tvDate);
        TextView tvBrand = convertView.findViewById(R.id.tvBrand);
        TextView tvTotalCount = convertView.findViewById(R.id.tvTotalCount);
        TextView tvMakingPeople = convertView.findViewById(R.id.tvMakingPeople);
        TextView tvTotalAmount = convertView.findViewById(R.id.tvTotalAmount);
        ImageView ivArrow = convertView.findViewById(R.id.ivArrow);

        if (dinghuoEntity != null) {
            tvOrderId.setText(String.format(context.getString(R.string.input_order_id),
                    dinghuoEntity.getOrderGoodBill()));
            tvDate.setText(String.format(context.getString(R.string.input_time),
                    dinghuoEntity.getOrderDate()));
            tvMakingPeople.setText(String.format(context.getString(R.string.input_making_people),
                    dinghuoEntity.getOrdererName()));
            tvBrand.setText(String.format(context.getString(R.string.input_brand),
                    dinghuoEntity.getBrandName()));
            tvTotalCount.setText(String.format(context.getString(R.string.input_total_count),
                    String.valueOf(dinghuoEntity.getTotalQty())));
            tvTotalAmount.setText(String.format(context.getString(R.string.input_total_amount),
                    String.valueOf(dinghuoEntity.getTotalAmount())));
        }
        if (isExpanded) {
            ivArrow.setImageResource(R.mipmap.ic_arrow_up);
            clItemContent.setBackgroundResource(R.drawable.shape_white_round_top_6);
        } else {
            ivArrow.setImageResource(R.mipmap.ic_arrow_down);
            clItemContent.setBackgroundResource(R.drawable.shape_white_round_6);
        }
        return convertView;
    }

    @Override
    public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.order_goods_query_new_item, null);
            viewHolder = new ViewHolder();
            viewHolder.llItemTitle = convertView.findViewById(R.id.llItemTitle);
            viewHolder.llItemContent = convertView.findViewById(R.id.llItemContent);
            viewHolder.tvProductName = convertView.findViewById(R.id.tvProductName);
            viewHolder.tvProductCode = convertView.findViewById(R.id.tvProductCode);
            viewHolder.tvPrice = convertView.findViewById(R.id.tvPrice);
            viewHolder.tvCount = convertView.findViewById(R.id.tvCount);
            viewHolder.tvTotalPrice = convertView.findViewById(R.id.tvTotalPrice);
            viewHolder.vLine = convertView.findViewById(R.id.vLine);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        DingHuoQueryNewRes.DinghuoEntity.GoodDetailListBean ent = getChild(groupPosition, childPosition);
        viewHolder.tvProductName.setText(ent.getGoodName());
        viewHolder.tvProductCode.setText(String.format(context.getString(R.string.parentheses_number), ent.getGoodCode()));
        viewHolder.tvPrice.setText(String.valueOf(ent.getGoodPrice()));
        viewHolder.tvCount.setText(String.valueOf(ent.getGoodQty()));
        viewHolder.tvTotalPrice.setText(String.valueOf(ent.getGoodAmount()));
        if (childPosition == 0) {
            viewHolder.llItemTitle.setVisibility(View.VISIBLE);
        } else {
            viewHolder.llItemTitle.setVisibility(View.GONE);
        }

        if (isLastChild) {
            viewHolder.llItemContent.setBackgroundResource(R.drawable.shape_f8f6f3_round_bottom_6);
            viewHolder.vLine.setVisibility(View.VISIBLE);
        } else {
            viewHolder.llItemContent.setBackgroundResource(R.drawable.shape_f8f6f3_solid);
            viewHolder.vLine.setVisibility(View.GONE);
        }
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return true;
    }

    class ViewHolder {
        LinearLayout llItemTitle;
        LinearLayout llItemContent;
        TextView tvProductName;
        TextView tvProductCode;
        TextView tvPrice;
        TextView tvCount;
        TextView tvTotalPrice;
        View vLine;

    }
}
