package com.urovo.wgmf.adapter;

import java.util.HashMap;
import java.util.List;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.R;

public class EatInAdapter extends BaseAdapter {
	private List<HashMap<String, String>> list;
	private BaseActivity context;

	public EatInAdapter(List<HashMap<String, String>> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		final ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.eatmanager_listview, null);
			viewHolder = new ViewHolder();
			viewHolder.date = (TextView) convertView.findViewById(R.id.eat_ltv_dttm);
			viewHolder.count = (TextView) convertView.findViewById(R.id.eat_ltv_num);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		HashMap<String, String> ent = list.get(position);
		viewHolder.date.setText(ent.get("time"));
		viewHolder.count.setText(ent.get("count"));

		return convertView;
	}

	class ViewHolder {
		TextView date;
		TextView count;

	}

}
