package com.urovo.wgmf.adapter;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.StoreOrderProduct;
import com.urovo.wugumofang.R;

/**
 * 商品查询
 * 
 * @author Administrator
 * 
 */
public class GoodsChoseAdapter extends BaseAdapter {
	private Context context;
	private List<StoreOrderProduct> list;

	public GoodsChoseAdapter(Context context) {
		this.context = context;
	}

	public void setList(List<StoreOrderProduct> list) {
		this.list = list;
		notifyDataSetChanged();
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public StoreOrderProduct getItem(int position) {

		if(position >= list.size())
			return null;
		else
			return list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return 0;
	}

	class ViewHolder {
		TextView name, no;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup arg2) {

		final ViewHolder holder;
		if(convertView == null) {
			holder = new ViewHolder();
			convertView = LayoutInflater.from(context).inflate(R.layout.second_addmenu_item, null);
			holder.name = (TextView) convertView.findViewById(R.id.goods_names);
			holder.no = (TextView) convertView.findViewById(R.id.goods_nums);
			convertView.setTag(holder);
		}
		else {
			holder = (ViewHolder) convertView.getTag();
		}
		StoreOrderProduct data = list.get(position);
		holder.name.setText(data.getItemName());
		holder.no.setText(data.getItemId());
		return convertView;
	}
}
