package com.urovo.wgmf.adapter;

import android.content.Context;
import android.widget.BaseAdapter;

import java.util.List;

/**
 * listview的适配器，传入
 *
 * @param <T> listview条目所属类的集合
 * @param <V> 直接写成ListView
 * @author admni
 */
public abstract class MyBaseAdapter<T, V> extends BaseAdapter {

    public List<T> lists;
    public V v;
    public Context context;

    public MyBaseAdapter(List<T> lists, Context context) {
        super();
        this.lists = lists;
        this.context = context;
    }

    public MyBaseAdapter(List<T> lists, V v, Context context) {
        super();
        this.lists = lists;
        this.v = v;
        this.context = context;
    }

    public void setList(List<T> list) {
        lists = list;
    }

    @Override
    public int getCount() {
        return lists == null ? 0 : lists.size();
    }

    @Override
    public Object getItem(int position) {
        return lists.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

}
