package com.urovo.wgmf.adapter;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.Djbh002Db;
import com.urovo.wugumofang.data.DateUtil;
import com.urovo.wugumofang.R;

/**
 * 门店订货
 * 
 * @author Administrator
 * 
 */
public class OrderGoodsAdapter extends BaseAdapter {
	private Context context;
	private List<Djbh002Db> list = new ArrayList<Djbh002Db>();
	String billNo;

	public OrderGoodsAdapter(Context context) {
		this.context = context;
	}

	public void setList(List<Djbh002Db> list) {
		this.list = list;
		notifyDataSetChanged();
	}

	public void add(Djbh002Db op) {
		if(list == null) {
			list = new ArrayList<Djbh002Db>();
		}
		if(list.size() == 0) {// 第一个商品的时候初始化订单值
			billNo = DateUtil.getDateTime1(new Date());
		}
		boolean isExist = false;
		for (Djbh002Db data : list) {
			if(data.getItemID().equals(op.getItemID())) {
				isExist = true;
				data.setBhqty(data.getBhqty() + op.getBhqty());
			}
		}
		if(!isExist) {
			op.setBill(billNo);
			list.add(op);
		}

		notifyDataSetChanged();
	}

	public List<Djbh002Db> getList() {
		List<Djbh002Db> usefullData = new ArrayList<Djbh002Db>();
		for (Djbh002Db data : list) {
			if(data.getBhqty() != 0.0) {
				usefullData.add(data);
			}
		}
		return usefullData;
	}

	public String getBill() {
		return billNo;
	}

	public void clear() {
		if(list != null) {
			list.clear();
			notifyDataSetChanged();
			billNo = null;
		}
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Djbh002Db getItem(int position) {

		if(position >= list.size())
			return null;
		else
			return list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return 0;
	}

	class ViewHolder {
		TextView name, no, unit, price, totMon, count;
		ImageButton add, reduce;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup arg2) {

		final ViewHolder holder;
		if(convertView == null) {
			holder = new ViewHolder();
			convertView = LayoutInflater.from(context).inflate(R.layout.second_ordergoodsmenu_item, null);
			holder.name = (TextView) convertView.findViewById(R.id.goods_name);
			holder.no = (TextView) convertView.findViewById(R.id.goods_num);
			holder.unit = (TextView) convertView.findViewById(R.id.goods_unit);
			holder.price = (TextView) convertView.findViewById(R.id.goods_price);
			holder.totMon = (TextView) convertView.findViewById(R.id.goods_countprice);
			holder.count = (TextView) convertView.findViewById(R.id.goods_count);

			holder.add = (ImageButton) convertView.findViewById(R.id.goods_plus);
			holder.reduce = (ImageButton) convertView.findViewById(R.id.goods_decrease);
			convertView.setTag(holder);
		}
		else {
			holder = (ViewHolder) convertView.getTag();
		}
		final Djbh002Db data = list.get(position);
		holder.name.setText(data.getItemName());
		holder.no.setText(data.getItemID());
		holder.unit.setText("单位：" + data.getUnit());
		holder.price.setText(data.getPrice() + "");
		holder.count.setText(data.getBhqty() + "");
		holder.totMon.setText(data.getPrice() * data.getBhqty() + "");

		holder.add.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				data.setBhqty(data.getBhqty() + data.getDpPack());
				holder.count.setText(data.getBhqty() + "");
				holder.totMon.setText(data.getPrice() * data.getBhqty() + "");
			}
		});
		holder.reduce.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {

				if(data.getBhqty() > 0) {
					data.setBhqty(data.getBhqty() - data.getDpPack());
					holder.count.setText(data.getBhqty() + "");
					holder.totMon.setText(data.getPrice() * data.getBhqty() + "");
				}
			}
		});
		return convertView;
	}
}
