package com.urovo.wgmf.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.entitys.CanCheckRes3;
import com.urovo.wugumofang.R;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * 用来显示盘点差异列表的adapter
 * Created by Sasuke on 2016/6/21.
 */
public class PanDianDiffAdapter extends BaseAdapter{
    List<Diff> diffList = new ArrayList<>();//手动盘点出来的列表
    Context context;
    public PanDianDiffAdapter(Context context, List<Diff> diffList) {
        this.context = context;
        this.diffList.clear();
        this.diffList.addAll(diffList);
    }

    @Override
    public int getCount() {
        return diffList.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView == null){
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_pandian_diff,null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder)convertView.getTag();
        }

        holder.itemName.setText(diffList.get(position).entity.getProName());
        holder.itemId.setText(diffList.get(position).entity.getProCode());
        holder.price.setText("零售价："+diffList.get(position).entity.getProPrice());

        double currQty = Double.parseDouble(diffList.get(position).currQty);
        holder.currQty.setText("账面库存："+diffList.get(position).currQty);//查询上个月盘点所得出的账目

        double num = diffList.get(position).entity.getPdQty();
        holder.pandianNum.setText("盘点数量："+num);//实盘个数

        String pandianAmount = String.format("%.2f",num * diffList.get(position).entity.getProPrice());
        holder.pandianAmount.setText("盘点金额："+pandianAmount);

        double diffNum = num - currQty;
        holder.diffNum.setText("差异数量："+diffNum);

        String diffAmount = String.format("%.2f",diffNum * diffList.get(position).entity.getProPrice());
        holder.diffAmount.setText("差异金额："+diffAmount);

        return convertView;
    }

    class ViewHolder{
        public ViewHolder(View view){
            ButterKnife.bind(this,view);
        }
        @BindView(R.id.item_name) TextView itemName;//产品名称
        @BindView(R.id.item_id) TextView itemId;//产品id
        @BindView(R.id.price) TextView price;//零售价
        @BindView(R.id.curr_qty) TextView currQty;//账面库存
        @BindView(R.id.pandian_num) TextView pandianNum;//盘点数量
        @BindView(R.id.pandian_amount) TextView pandianAmount;//盘点金额
        @BindView(R.id.diff_num) TextView diffNum;//差异数量
        @BindView(R.id.diff_amount) TextView diffAmount;//差异金额
    }

    public static class Diff {
        public CanCheckRes3.ResultInfo.DetailList entity;
        public String currQty;//当前账面库存
    }
}
