package com.urovo.wgmf.adapter;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.dao.Store001DbOprate;
import com.urovo.wgmf.db.dao.entitys.DingHuoExamineEntity;
import com.urovo.wugumofang.data.StringUtils;
import com.urovo.wugumofang.R;

public class QueryDingHuoExamineAdapter extends BaseAdapter {
	private List<DingHuoExamineEntity> list;
	private BaseActivity context;

	public QueryDingHuoExamineAdapter(List<DingHuoExamineEntity> list, BaseActivity context) {
		this.list = list;
		this.context = context;
		/**
		 * 制单日期(精确到秒)靠近今天的排列在前
		 */

		Collections.sort(list, new Comparator<DingHuoExamineEntity>() {

			@Override
			public int compare(DingHuoExamineEntity lhs, DingHuoExamineEntity rhs) {

				if(StringUtils.toLong(lhs.getBill()) > StringUtils.toLong(rhs.getBill())) {
					return -1;
				}
				else
					if(lhs.getBill().equals(rhs.getBill())) {
						return 0;
					}
					else {
						return 1;
					}
			}
		});
	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		final ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.second_auditinggoods_item, null);
			viewHolder = new ViewHolder();
			viewHolder.store = (TextView) convertView.findViewById(R.id.auditing_store);
			viewHolder.itemCount = (TextView) convertView.findViewById(R.id.pingxiang_dnum);
			viewHolder.amount = (TextView) convertView.findViewById(R.id.auditing_price);
			viewHolder.last_sales = (TextView) convertView.findViewById(R.id.last_sales);
			viewHolder.date = (TextView) convertView.findViewById(R.id.auditing_date);
			viewHolder.condition = (TextView) convertView.findViewById(R.id.auditing_condition);
			viewHolder.bill = (TextView) convertView.findViewById(R.id.auditing_num);
			viewHolder.isExamine = (TextView) convertView.findViewById(R.id.is_examine);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		DingHuoExamineEntity ent = list.get(position);
		String name = Store001DbOprate.GetStoreName(ent.getStoreId());
		viewHolder.store.setText(name);
		viewHolder.itemCount.setText(ent.getItemCount() + "");
		viewHolder.last_sales.setText(StringUtils.formatDouble(ent.getSale_opl_amount(), "0.00"));// 近30天销售
		viewHolder.amount.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
		viewHolder.date.setText(ent.getWDate());
		viewHolder.condition.setText(ent.getState());
		viewHolder.bill.setText(ent.getBill());
		if(ent.isExamine) {
			viewHolder.isExamine.setText("已审核");
			viewHolder.isExamine.setTextColor(context.getResources().getColor(R.color.red_text_color));
		}
		else {
			viewHolder.isExamine.setText("审核");
			viewHolder.isExamine.setTextColor(context.getResources().getColor(R.color.blue_text_color));
		}
		return convertView;
	}

	class ViewHolder {
		TextView store;
		TextView itemCount;
		TextView amount;
		TextView last_sales;
		TextView date;
		TextView condition;
		TextView bill;
		TextView isExamine;
	}
}
