package com.urovo.wgmf.adapter;

import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;
import android.text.TextUtils;
import android.text.method.DigitsKeyListener;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;

import com.urovo.wgmf.db.dao.bill.DalCommon;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.urovo.wgmf.db.dao.entitys.XiaoShouEntity;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.StringUtils;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * @author ...
 */
public class SaleBackAdapter extends BaseExpandableListAdapter {
    private boolean onlyShow = false;
    private boolean nativeUppoad = false;
    private List<XiaoShouEntity> parentslist;
    private List<List<ProductEntity>> childrenlist;
    private List<List<ProductEntity>> oldchildrenlist;
    private Context context;

    public SaleBackAdapter(List<XiaoShouEntity> list, Context cxt, boolean show, boolean nUpload) {
        onlyShow = show;
        nativeUppoad = nUpload;
        parentslist = list;
        context = cxt;
        Iterator<XiaoShouEntity> itr = list.iterator();
        while (itr.hasNext()) {
            XiaoShouEntity element = itr.next();
            if (null == element.getProductDetails() || 0 == element.getProductDetails().length) {
                itr.remove();
            }
        }
        for (XiaoShouEntity x : parentslist) {
            ProductEntity[] productDetails = x.getProductDetails();
            for (ProductEntity p : productDetails) {
                p.orgTQTY = p.getTQTY();
            }
        }

        Collections.sort(parentslist, new Comparator<XiaoShouEntity>() {
            @Override
            public int compare(XiaoShouEntity lhs, XiaoShouEntity rhs) {

                return (rhs.getSaleDate() + rhs.getSaleTime()).compareTo(lhs.getSaleDate() + lhs.getSaleTime());
            }
        });

        initList();
    }

    private void initList() {
        childrenlist = new ArrayList<List<ProductEntity>>();
        oldchildrenlist = new ArrayList<List<ProductEntity>>();
        for (XiaoShouEntity x : parentslist) {
            ProductEntity[] productDetails = x.getProductDetails();
            ArrayList<ProductEntity> oldlistItem = new ArrayList<ProductEntity>();
            List<ProductEntity> listItem = Arrays.asList(productDetails);
            ;

            Collections.sort(listItem, new Comparator<ProductEntity>() {

                @Override
                public int compare(ProductEntity lhs, ProductEntity rhs) {

                    if (lhs.getAmount() > rhs.getAmount()) {
                        return -1;
                    } else if (lhs.getAmount() == rhs.getAmount()) {
                        return 0;
                    } else {
                        return 1;
                    }
                }
            });
            double countAmount = 0.0;
            for (ProductEntity p : productDetails) {
                Item001DbOperate.GetProductDetail(p);
                ProductEntity p1 = new ProductEntity();
                if (onlyShow) {
                    countAmount = Arith.add(countAmount, p.getAmount());
                } else if (p.getAmount() > 0) {
                    countAmount = Arith.add(countAmount, p.getAmount());
                }
                p1.setAmount(p.getAmount());
                double num = p.getTQTY();
                for (ProductEntity c : productDetails) {
                    if (p != c && p.getItemId().equals(c.getItemId()) && c.getAmount() != 0) {
                        num += c.getTQTY();
                    }
                }
                p1.setTQTY(num);
                // if (onlyShow)
                // {
                // p.setTQTY(num);
                // }
                // p1.setTQTY(p.getTQTY());
                oldlistItem.add(p1);
                // p.setTQTY(1.0);
                if (p.getTQTY() > 0 && p.getAmount() > 0) {
                    p.isEnable = true;
                    // p.setAmount(p.getPrice());
                } else {
                    p.isEnable = false;
                    // p.setAmount(-p.getPrice());
                }
            }
            // x.setTNET(countAmount);
            // if (onlyShow)
            // {
            // Iterator<ProductEntity> itr = listItem.iterator();
            // while (itr.hasNext())
            // {
            // ProductEntity element = itr.next();
            // if(element.getAmount()<0)itr.remove();
            // }
            // Iterator<ProductEntity> itr2 = oldlistItem.iterator();
            // while (itr2.hasNext())
            // {
            // ProductEntity element = itr2.next();
            // if(element.getAmount()<0)itr2.remove();
            // }
            // }
            childrenlist.add(listItem);
            oldchildrenlist.add(oldlistItem);
        }
    }

    @Override
    public void notifyDataSetInvalidated() {

        // initList();
        super.notifyDataSetInvalidated();
    }

    @Override
    public void notifyDataSetChanged() {

        // initList();
        super.notifyDataSetChanged();
    }

    public List<List<ProductEntity>> getBackList() {
        return childrenlist;
    }

    @Override
    public int getGroupCount() {

        if (null == parentslist || parentslist.size() == 0) {
            return 0;
        }
        return parentslist.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {

        if (childrenlist.size() == 0 || childrenlist.get(groupPosition) == null) {
            return 0;
        }
        return childrenlist.get(groupPosition).size();
    }

    @Override
    public Object getGroup(int groupPosition) {

        return parentslist.get(groupPosition);
    }

    @Override
    public Object getChild(int groupPosition, int childPosition) {

        return childrenlist.get(groupPosition).get(childPosition);
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {

        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {

        ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.sale_back_list_item, parent, false);
            viewHolder = new ViewHolder();
            viewHolder.number = (TextView) convertView.findViewById(R.id.vip_number);
            viewHolder.time = (TextView) convertView.findViewById(R.id.sale_time);
            viewHolder.upload = (ImageView) convertView.findViewById(R.id.imageViewUpload);
            viewHolder.amount = (TextView) convertView.findViewById(R.id.amount);
            viewHolder.failReason = (TextView) convertView.findViewById(R.id.textViewFailReason);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        viewHolder.failReason.setVisibility(View.GONE);
        XiaoShouEntity ent = parentslist.get(groupPosition);
        if (nativeUppoad) {
            viewHolder.upload.setVisibility(View.VISIBLE);
            if (0 == ent.isUp) {
                viewHolder.upload.setImageResource(R.drawable.weishangchuan);
            } else if (1 == ent.isUp) {
                viewHolder.upload.setImageResource(R.drawable.yishangchuan);
            } else {
                viewHolder.upload.setImageResource(R.drawable.yichangdan);
                viewHolder.failReason.setText(ent.getFailSeason());
                viewHolder.failReason.setVisibility(View.VISIBLE);
            }
        } else {
            viewHolder.upload.setVisibility(View.INVISIBLE);
        }
        if (TextUtils.isEmpty(ent.getCUSTID()) || ent.getCUSTID().startsWith("400-")) {
            viewHolder.number.setText("非会员");
        } else {
            viewHolder.number.setText(ent.getCUSTID());
        }
        // viewHolder.number.setText(TextUtils.isEmpty(ent.getCUSTID()) ? "非会员"
        // : ent.getCUSTID());
        if (nativeUppoad) {
            StringBuffer sb = new StringBuffer(ent.getSaleTime());
            sb.insert(2, ":");
            sb.insert(5, ":");
            viewHolder.time.setText((ent.getSaleDate().length() > 10 ? ent.getSaleDate().substring(0, 10) : ent.getSaleDate()) + " " + sb.toString());
        } else {
            StringBuffer sb = new StringBuffer(ent.getSaleTime());
            sb.insert(2, ":");
            sb.insert(5, ":");
            viewHolder.time.setText(ent.getSaleDate() + " " + sb.toString());
        }
        viewHolder.amount.setText(StringUtils.formatDouble(ent.getSKTNET(), "0.00"));
        SYLoger.print("条码打印 保存页面： " + StringUtils.formatDouble(ent.getSKTNET(), "0.00"));
        // //是否展开
        // if(isExpanded){
        // context.showSubmit(ent.checkCount > 0? true : false);
        // }else{
        // context.showSubmit(false);
        // }
        if (isExpanded) {
            Drawable drawable = context.getResources().getDrawable(R.drawable.list_group_open);
            drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            viewHolder.amount.setCompoundDrawables(null, null, drawable, null);
        } else {
            Drawable drawable = context.getResources().getDrawable(R.drawable.list_group_close);
            drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            viewHolder.amount.setCompoundDrawables(null, null, drawable, null);
        }
        return convertView;
    }

    @Override
    public View getChildView(final int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        final ViewHolder holder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.sale_back_submit_list_item, parent, false);
            holder = new ViewHolder();
            holder.check = (CheckBox) convertView.findViewById(R.id.sale_back_check);
            holder.salereturn = (ImageView) convertView.findViewById(R.id.imageViewReturn);
            holder.name = (TextView) convertView.findViewById(R.id.sale_goods_name);
            holder.count = (TextView) convertView.findViewById(R.id.sale_goods_count_or_weight);
            holder.kcoum = (TextView) convertView.findViewById(R.id.sale_goods_kcuom);
            holder.subtract = (ImageButton) convertView.findViewById(R.id.sale_goods_subtract);
            holder.add = (ImageButton) convertView.findViewById(R.id.sale_goods_add);
            holder.price = (TextView) convertView.findViewById(R.id.sale_goods_price);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final ProductEntity ent = childrenlist.get(groupPosition).get(childPosition);
        final ProductEntity entOld = oldchildrenlist.get(groupPosition).get(childPosition);

        // if (ent.getTQTY() <= 1)
        // {
        // holder.subtract.setEnabled(false);
        // }
        // else
        // {
        // holder.subtract.setEnabled(true);
        // }
        // if (ent.getTQTY() >= entOld.getTQTY())
        // {
        // holder.add.setEnabled(false);
        // }
        // else
        // {
        // holder.add.setEnabled(true);
        // }
        holder.name.setText(ent.getItemName());
        holder.count.setText(StringUtils.formatDouble(ent.getTQTY(), "0.##"));
        holder.kcoum.setText("(" + ent.getKCUom() + ")");
        holder.price.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
        holder.check.setChecked(ent.isBack);
        // Log.e("test",
        // "getChildView:groupPosition:"+groupPosition+" childPosition:"+childPosition+" ent.isBack:"+ent.isBack);
        if (ent.isBack) {
            holder.subtract.setVisibility(View.VISIBLE);
            holder.add.setVisibility(View.VISIBLE);
            if (ent.getTQTY() >= 1 && ent.getTQTY() <= entOld.getTQTY()) {
                holder.count.setText(StringUtils.formatDouble(ent.getTQTY(), "0.##"));
            } else {
                holder.count.setText(StringUtils.formatDouble(entOld.getTQTY(), "0.##"));
                ent.setTQTY(entOld.getTQTY());
            }
            if (ent.getTQTY() <= 1)
                holder.subtract.setEnabled(false);
            else
                holder.subtract.setEnabled(true);
            if (ent.getTQTY() >= entOld.getTQTY())
                holder.add.setEnabled(false);
            else
                holder.add.setEnabled(true);
        } else {
            holder.subtract.setVisibility(View.INVISIBLE);
            holder.add.setVisibility(View.INVISIBLE);
            holder.count.setText(StringUtils.formatDouble(ent.orgTQTY, "0.##"));
        }
        if (ent.isEnable) {
            holder.salereturn.setVisibility(View.INVISIBLE);
            // convertView.setBackgroundColor(0xFFF0F0F0);
            holder.check.setVisibility(View.VISIBLE);
        } else {
            if (ent.getTQTY() > 0 && ent.getAmount() <= 0) {
                holder.salereturn.setImageResource(R.drawable.salegift);
            } else {
                holder.salereturn.setImageResource(R.drawable.salereturn);
            }
            holder.salereturn.setVisibility(View.VISIBLE);
            // convertView.setBackgroundColor(0xFF606060);
            holder.check.setVisibility(View.INVISIBLE);
            holder.subtract.setVisibility(View.INVISIBLE);
            holder.add.setVisibility(View.INVISIBLE);
        }
        // holder.check.setOnClickListener(new OnClickListener() {
        //
        // @Override
        // public void onClick(View v) {
        //
        // if(!holder.check.isChecked()){
        // holder.subtract.setVisibility(View.INVISIBLE);
        // holder.add.setVisibility(View.INVISIBLE);
        // ent.isBack = false;
        // parentslist.get(groupPosition).checkCount--;
        // }else{
        // holder.subtract.setVisibility(View.VISIBLE);
        // holder.add.setVisibility(View.VISIBLE);
        // ent.isBack = true;
        // parentslist.get(groupPosition).checkCount++;
        // }
        // context.showSubmit((parentslist.get(groupPosition).checkCount > 0) ?
        // true : false);
        // }
        // });
        holder.subtract.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                double newCount = Double.parseDouble(holder.count.getText().toString());
                if (newCount > 1) {
                    newCount = Arith.sub(newCount, 1);
                    ent.setTQTY(newCount);
                    ent.setAmount(Arith.mul(newCount, ent.getPrice()));
                    holder.price.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
                    holder.count.setText(StringUtils.formatDouble(newCount, "0.##"));
                    if (ent.getTQTY() <= 1) {
                        holder.subtract.setEnabled(false);
                    }
                    if (ent.getTQTY() < entOld.getTQTY()) {
                        holder.add.setEnabled(true);
                    }
                }
            }
        });
        holder.add.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                double newCount2 = Double.parseDouble(holder.count.getText().toString());
                // double max = Arith.sub(list.get(position).getTQTY(),1);
                if (newCount2 < entOld.getTQTY()) {
                    newCount2 = Arith.add(newCount2, 1);
                    ent.setTQTY(newCount2);
                    ent.setAmount(Arith.mul(newCount2, ent.getPrice()));
                    holder.price.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
                    holder.count.setText(StringUtils.formatDouble(newCount2, "0.##"));
                    if (ent.getTQTY() > 1) {
                        holder.subtract.setEnabled(true);
                    }
                    if (ent.getTQTY() >= entOld.getTQTY()) {
                        holder.add.setEnabled(false);
                    }
                }
            }
        });
        holder.price.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {

                if (DalCommon.CanEditAmount(ent.getItemId())) {
                    Builder builder = new Builder(context);
                    builder.setTitle("请输入修改的金额");
                    final EditText editText = new EditText(context);
                    editText.setKeyListener(new DigitsKeyListener(false, true));
                    editText.setText(StringUtils.formatDouble(ent.getAmount(), "0.00"));
                    builder.setView(editText);
                    builder.setNegativeButton("取消", null);
                    builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            dialog.dismiss();
                            String num = editText.getText().toString().trim();
                            if (!TextUtils.isEmpty(num)) {
                                double amout = Math.abs(Double.parseDouble(num));
                                if (amout > (Math.abs(entOld.getAmount()))) {
                                    ((BaseActivity) context).showMsg("不能大于原金额!");
                                } else {
                                    String formatPrice = StringUtils.formatDouble(amout, "0.00");
                                    holder.price.setText(formatPrice);
                                    ent.setAmount(Double.parseDouble(formatPrice));
                                }
                            }
                        }

                    });
                    builder.create().show();
                }
            }
        });
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {

        return true;
    }

    class ViewHolder {
        TextView number;
        TextView time;
        ImageView upload;
        TextView amount;
        TextView name;
        TextView count;
        TextView kcoum;
        TextView price;
        CheckBox check;
        ImageView salereturn;
        ImageButton subtract;
        ImageButton add;
        TextView failReason;
    }

}
