package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.constants.UploadParam;
import com.urovo.wgmf.db.dao.entitys.UntreatedOrderDetailEntity;
import com.urovo.wugumofang.R;

import java.util.List;

public class UnUpDetailQueryAdapter extends BaseAdapter {
	private List<UntreatedOrderDetailEntity> list;
	private BaseActivity context;

	public UnUpDetailQueryAdapter(List<UntreatedOrderDetailEntity> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.listview_item_untreated_order_detail, null);
			viewHolder = new ViewHolder();
			viewHolder.bill = (TextView) convertView.findViewById(R.id.bill);
			viewHolder.text1 = (TextView) convertView.findViewById(R.id.text1);
			viewHolder.text2 = (TextView) convertView.findViewById(R.id.text2);
			viewHolder.text3 = (TextView) convertView.findViewById(R.id.text3);
			viewHolder.text4 = (TextView) convertView.findViewById(R.id.text4);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		UntreatedOrderDetailEntity ent = list.get(position);
		viewHolder.bill.setText(ent.bill);
		viewHolder.text1.setText(ent.info1);
		viewHolder.text2.setText(ent.info2);
		viewHolder.text3.setText(ent.info3);
		viewHolder.text4.setText(ent.info4);
		if(UploadParam.ZHILIANJIANDU.equals(ent.type)) {
			viewHolder.text4.setVisibility(View.GONE);
		}
		return convertView;
	}

	class ViewHolder {
		TextView bill;
		TextView text1;
		TextView text2;
		TextView text3;
		TextView text4;

	}

}
