package com.urovo.wgmf.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.UntreatedOrderEntity;
import com.urovo.wugumofang.R;

import java.util.List;

public class UntreatedOrderAdapter extends BaseAdapter {
    private List<UntreatedOrderEntity> list;
    private BaseActivity context;

    public UntreatedOrderAdapter(List<UntreatedOrderEntity> list, BaseActivity context) {
        this.list = list;
        this.context = context;

    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.untreated_order_listview_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView.findViewById(R.id.order_name);
            viewHolder.count = (TextView) convertView.findViewById(R.id.count);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        UntreatedOrderEntity ent = list.get(position);
        viewHolder.name.setText(ent.oderType);
        viewHolder.count.setText(ent.count + "");

        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView count;

    }

}
