package com.urovo.wgmf.adapter;

import java.util.List;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wgmf.db.dao.entitys.ZXXJMainEntity;
import com.urovo.wugumofang.R;

public class ZXXJAdapter extends BaseAdapter {
	private List<ZXXJMainEntity> list;
	private BaseActivity context;

	public ZXXJAdapter(List<ZXXJMainEntity> list, BaseActivity context) {
		this.list = list;
		this.context = context;

	}

	@Override
	public int getCount() {

		return list == null ? 0 : list.size();
	}

	@Override
	public Object getItem(int position) {

		return list == null ? null : list.get(position);
	}

	@Override
	public long getItemId(int position) {

		return position;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder viewHolder;
		if(convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.zxxj_list_item, null);
			viewHolder = new ViewHolder();
			viewHolder.text1 = (TextView) convertView.findViewById(R.id.text1);
			viewHolder.text2 = (TextView) convertView.findViewById(R.id.text2);
			viewHolder.text3 = (TextView) convertView.findViewById(R.id.text3);
			viewHolder.text4 = (TextView) convertView.findViewById(R.id.text4);
			convertView.setTag(viewHolder);
		}
		else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		viewHolder.text1.setText(list.get(position).STOREID);
		viewHolder.text2.setText(list.get(position).ZXDESC);
		String type = ("Y".equals(list.get(position).XJYN)) ? "已巡检" : "未巡检";
		viewHolder.text3.setText(type);
		viewHolder.text4.setText(list.get(position).BILL);
		return convertView;
	}

	class ViewHolder {
		TextView text1;
		TextView text2;
		TextView text3;
		TextView text4;

	}

}
