package com.urovo.wgmf.more.net;

import com.urovo.wgmf.more.ent.MoreContractBean;
import com.urovo.wgmf.more.ent.MoreOnlineBean;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.response.Base3Response;
import com.zsy.libcore.model.bean.RequestResult;

import java.util.Map;

import io.reactivex.Observable;
import retrofit2.Call;
import retrofit2.http.FieldMap;
import retrofit2.http.FormUrlEncoded;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 * @author chenji
 * @date 2018/1/2
 */
public interface IMoreNet {
    /**
     * 更多页面的各个板块的菜单列表
     *
     * @param map userNo 员工号; type:状态，0首页 1更多
     * @return 返回菜单列表
     */
    @FormUrlEncoded
    @POST(ApiUrls.APPSALER.MORE_PAGES)
    Observable<MoreOnlineBean> getMoreList(@FieldMap Map<String, String> map);

    /**
     * 合同弹窗
     *
     * @param staffId
     * @return
     */
    @POST(ApiUrls.APP.MORE_INDEX_CONTRACT_DIALOG)
    Call<RequestResult<MoreContractBean>> queryContractDialog(@Query("shopId") String shopId, @Query("staffId") String staffId);

    /**
     * 提交合同弹窗已读状态
     *
     * @param staffId
     * @return
     */
    @POST(ApiUrls.APP.MORE_INDEX_CONTRACT_READ)
    Call<Base3Response> submitContractRead(@Query("staffId") String staffId);

}
