package com.urovo.wgmf.net;


import com.urovo.activity.data.querymyweivip.model.SweepCodeDetailListEntity;
import com.urovo.activity.data.queryproductsales.model.MonthSaleProductEntity;
import com.urovo.activity.data.querysales.model.MonthSaleEntity;
import com.urovo.activity.sanxiangpao.model.SanXiangPaoCountEntity;
import com.urovo.activity.sanxiangpao.model.SanXiangPaoListEntity;
import com.urovo.activity.slidemenu.model.OrderEntity;
import com.urovo.activity.user.bean.FlowSalesPersonCompletionHeadEntity;
import com.urovo.activity.user.bean.FlowSalesPersonCompletionListEntity;
import com.urovo.wgmf.CommonController;
import com.urovo.wgmf.db.dao.dao.CxykqDbOperate;
import com.urovo.wgmf.db.dao.entitys.StockGoodsDetailEntity;
import com.urovo.wgmf.db.dao.entitys.StockSearchEntity;
import com.urovo.wgmf.entity.response.FirstPageQueryResponse;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.wgmf.trade.model.bean.CommonEntity;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.Request2Result;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.Result2Callback;
import com.zsy.libcore.model.bean.ResultCallback;

import java.util.List;
import java.util.Map;

import okhttp3.Request;
import retrofit2.Call;
import retrofit2.Response;

/**
 * 网络请求的具体逻辑处理
 *
 * @author chenji
 */
public class CommonNet implements CommonController.Net {
    private ICommonNet mCommonNet;

    /**
     * retrofit的配置
     */
    public CommonNet() {
        mCommonNet = RetrofitHelper.createApi(ICommonNet.class);
    }

    /**
     * 新客微会员网络请求
     *
     * @param presenter 监听数据请求的成功和失败，再回调到p层，接口定义在p层，不用另外定义监听器。
     * @param mParams   ...
     */
    @Override
    public void start2requestData(final CommonController.Presenter presenter, Map<String, String> mParams) {

        String staffId = mParams.get("staffId");
        String shopId = mParams.get("shopId");
        String date = mParams.get("ymd");
        Call<RequestResult<SweepCodeDetailListEntity>> call =
                mCommonNet.getSweepCodeDetailListData(staffId, shopId, date);
        call.enqueue(new ResultCallback<SweepCodeDetailListEntity>() {
            @Override
            protected void onResponseSuccess(
                    RequestResult<SweepCodeDetailListEntity> responseBody) {
                super.onResponseSuccess(responseBody);
                if (responseBody.msgCode == 0) {
                    presenter.onResponseSuccess(new CommonEntity(responseBody.resultInfo));//回传成功请求后的数据给p 层
                } else {
                    presenter.onFailure("新客微会员的接口数据异常！");
                }
            }

            @Override
            public void onFailure(Call<RequestResult<SweepCodeDetailListEntity>> call, Throwable t) {
//                super.onFailure(call, t);
                presenter.onFailure("网络访问异常！请求新客进塘数据失败！");
            }
        });
    }

    /**
     * 物流查询--会员商城订单列表
     *
     * @param presenter ...
     * @param params    ...
     */
    public void start2requestMemberOrderData(final CommonController.BasePre<OrderEntity> presenter, Map<String, String> params) {
//        OkHttpDominator.getAsyn("http://test.wgmf.com/" + ApiUrls.WeiXin.MEMBER_STORE_ORDER_LIST,
        OkHttpDominator.getAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.WeiXin.MEMBER_STORE_ORDER_LIST,
                params, new OkHttpDominator.ResultCallback<OrderEntity>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        presenter.onFailure("会员商城订单列表查询异常: " + e);
                    }

                    @Override
                    public void onResponse(OrderEntity response) {
                        if (null != response) {
                            presenter.onResponseSuccess(new CommonEntity<>(response));
                        }
                    }
                });
    }

    /**
     * 销售业绩----月销量查询
     *
     * @param presenter 监听数据请求的成功和失败，再回调到p层，接口定义在p层，不用另外定义监听器。
     * @param mParams   ...
     */
    public void start2requestMonthSaleData(final CommonController.Presenter presenter, Map<String, String> mParams) {
        String shopId = mParams.get("shopId");
        String date = mParams.get("ym");
        String staffId = mParams.get("staffId");
        Call<RequestResult<MonthSaleEntity>> call =
                mCommonNet.getMonthSaleData(shopId, date, staffId);
        call.enqueue(new ResultCallback<MonthSaleEntity>() {

            @Override
            public void onResponse(Call<RequestResult<MonthSaleEntity>> call, Response<RequestResult<MonthSaleEntity>> response) {
//                super.onResponse(call, response);
                if (response.code() == 200) {
                    RequestResult<MonthSaleEntity> responseBody = response.body();
                    int flag = responseBody.msgCode;
                    if (flag != 0) {//请求失败
                        presenter.onFailure("月销量查询的接口数据异常！");
                    } else {//请求成功
                        presenter.onResponseSuccess(new CommonEntity(responseBody.resultInfo));//回传成功请求后的数据给p 层
                    }
                } else {
                    presenter.onFailure("网络访问异常！月销量查询数据失败！");
                }
            }
        });
    }

    /**
     * 销售业绩----产品月销量查询
     *
     * @param presenter 监听数据请求的成功和失败，再回调到p层，接口定义在p层，不用另外定义监听器。
     * @param mParams   ...
     */
    public void start2requestMonthSaleProductData(final CommonController.Pre presenter, Map<String, String> mParams) {
        String shopId = mParams.get("shopId");
        String date = mParams.get("ym");
        String staffId = mParams.get("staffId");

        Call<RequestResult<MonthSaleProductEntity>> call =
                mCommonNet.getMonthSaleProductDetailData(shopId, date, staffId);
        call.enqueue(new ResultCallback<MonthSaleProductEntity>() {
            @Override
            public void onResponse(Call<RequestResult<MonthSaleProductEntity>> call, Response<RequestResult<MonthSaleProductEntity>> response) {
                if (response.code() == 200) {
                    RequestResult<MonthSaleProductEntity> responseBody = response.body();
                    //请求失败
                    if (responseBody != null) {
                        if (responseBody.msgCode != 0) {
                            presenter.onFailure("产品月销量查询的接口数据异常！");
                        } else {//请求成功
//                        SYLoger.print("wgmf--产品月销量查询--start2requestMonthSaleProductData" + responseBody.resultInfo);
                            //回传成功请求后的数据给p 层
                            presenter.onResponseSuccess(new CommonEntity(responseBody.resultInfo));
                        }
                    } else {
                        presenter.onFailure("网络访问异常！产品月销量查询数据失败！");
                    }
                }
            }
        });
    }

    /**
     * 流动顾问销售完成情况
     *
     * @param presenter ...
     * @param params    ...
     */
    public void onStart2requestData(final CommonController.FlowSalesPersonPre presenter, Map<String, String> params) {
        //参数有三个，但是需要根据type参数值来判断是月统计数据头部信息还是详情数据列表
        final String type = params.get("type");
        if (AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD.equals(type)) {
            Call<RequestResult<FlowSalesPersonCompletionHeadEntity>> call = mCommonNet.getFlowSalesPersonCompletionHeadData(params);
            call.enqueue(new ResultCallback<FlowSalesPersonCompletionHeadEntity>() {
                @Override
                public void onResponse(Call<RequestResult<FlowSalesPersonCompletionHeadEntity>> call, Response<RequestResult<FlowSalesPersonCompletionHeadEntity>> response) {
                    if (response.code() == 200) {
                        RequestResult<FlowSalesPersonCompletionHeadEntity> responseBody = response.body();
                        //请求失败
                        if (responseBody.msgCode != 0) {
                            presenter.onFailure("流动顾问销售完成情况的月统计数据接口异常！");
                        } else {//请求成功
                            SYLoger.print("successful --" + responseBody.resultInfo);
                            presenter.onResponseSuccess(type, new CommonEntity(responseBody.resultInfo));
                        }
                    } else {
                        presenter.onFailure("网络异常！请求流动顾问销售完成情况月统计数据接口失败！");
                    }
                }
            });
        } else {
            final Call<RequestResult<List<FlowSalesPersonCompletionListEntity>>> call = mCommonNet.getFlowSalesPersonCompletionListData(params);
            call.enqueue(new ResultCallback<List<FlowSalesPersonCompletionListEntity>>() {
                @Override
                public void onResponse(Call<RequestResult<List<FlowSalesPersonCompletionListEntity>>> call, Response<RequestResult<List<FlowSalesPersonCompletionListEntity>>> response) {
                    if (response.code() == 200) {
                        RequestResult<List<FlowSalesPersonCompletionListEntity>> responseBody = response.body();
                        //请求失败
                        if (responseBody.msgCode != 0) {
                            presenter.onFailure("流动顾问销售完成情况的详情数据接口异常！");
                        } else {//请求成功
                            SYLoger.print("successful --" + responseBody.resultInfo);
                            final CommonEntity<List<FlowSalesPersonCompletionListEntity>> listCommonEntity = new CommonEntity<>(responseBody.resultInfo);
                            presenter.onResponseSuccess(type, listCommonEntity);
                        }
                    } else {
                        SYLoger.print("chenji--" + type);
                        presenter.onFailure("网络异常！请求流动顾问销售完成情况详情数据接口失败！");
                    }
                }
            });
        }

//        伪造数据接口测试
//        easyMockTestRequest(presenter, tag, params);
    }

    /**
     * 库存查询
     *
     * @param presenter ...
     * @param mParams   ...
     */
    public void start2requestStockSearch(final CommonController.StockSearchPre<StockSearchEntity> presenter, Map<String, String> mParams) {
        String storeNo = mParams.get("storeNo");
        Call<RequestResult<StockSearchEntity>> call = mCommonNet.getStockSearchData(storeNo);
        call.enqueue(new ResultCallback<StockSearchEntity>() {
            @Override
            protected void onResponseSuccess(
                    RequestResult<StockSearchEntity> responseBody) {
                super.onResponseSuccess(responseBody);
                if (responseBody.msgCode == 0) {
                    presenter.onResponseSuccess(new CommonEntity<>(responseBody.resultInfo));
                    SYLoger.print("lemmonade --" + responseBody.resultInfo.toString());
                } else {
                    presenter.onFailure("库存查询接口数据异常！");
                }
            }

            @Override
            public void onFailure(Call<RequestResult<StockSearchEntity>> call, Throwable t) {
//                super.onFailure(call, t);
                presenter.onFailure("库存查询数据失败！" + t);
            }
        });
    }

    /**
     * 库存明细查询
     *
     * @param presenter ...
     * @param mParams   ...
     */
    public void start2requestStockGoodsDetail(final CommonController.StockSearchPre<StockGoodsDetailEntity> presenter, Map<String, String> mParams) {
        String storeNo = mParams.get("storeNo");
        Call<RequestResult<StockGoodsDetailEntity>> call = mCommonNet.getStockGoodsDetailData(storeNo);
        call.enqueue(new ResultCallback<StockGoodsDetailEntity>() {
            @Override
            protected void onResponseSuccess(RequestResult<StockGoodsDetailEntity> responseBody) {
                super.onResponseSuccess(responseBody);
                if (responseBody.msgCode == 0) {
                    presenter.onResponseSuccess(new CommonEntity(responseBody.resultInfo));
                    SYLoger.print("lemmonade --" + responseBody.resultInfo.toString());
                } else {
                    presenter.onFailure("库存查询明细接口数据异常！");
                }
            }

            @Override
            public void onFailure(Call<RequestResult<StockGoodsDetailEntity>> call, Throwable t) {
//                super.onFailure(call, t);
                presenter.onFailure("库存明细查询数据异常！" + t);
            }
        });
    }

    /**
     * 三响炮关怀
     *
     * @param presenter ...
     * @param tag       ...
     * @param params    ...
     */
    public void start2RequestSanXiangPaoData(final CommonController.SanXiangPaoInfoPre presenter, String tag, Map<String, String> params) {
        if (AppConstants.SanXiangPao.QUERY_COUNT.equals(tag)) {//会员关怀人数标志
            final Call<RequestResult<SanXiangPaoCountEntity>> call = mCommonNet.getSanXiangPaoQueryCount(params);
            call.enqueue(new ResultCallback<SanXiangPaoCountEntity>() {
                @Override
                public void onResponse(Call<RequestResult<SanXiangPaoCountEntity>> call, Response<RequestResult<SanXiangPaoCountEntity>> response) {
                    if (response.code() == 200) {
                        RequestResult<SanXiangPaoCountEntity> responseBody = response.body();
                        if (responseBody.msgCode != 0) {//请求失败
                            presenter.onFailure(AppConstants.SanXiangPao.QUERY_COUNT, "会员关怀人数接口数据异常！");
                        } else {//请求成功
                            presenter.onResponseSuccess(AppConstants.SanXiangPao.QUERY_COUNT, new CommonEntity(responseBody.resultInfo));//回传成功请求后的数据给p 层
                        }
                    } else {
                        presenter.onFailure(AppConstants.SanXiangPao.QUERY_COUNT, "网络访问异常！会员关怀人数查询数据失败！");
                    }
                }
            });
        } else if (AppConstants.SanXiangPao.QUERY_LIST.equals(tag)) {//会员关怀列表标志
            final Call<RequestResult<List<SanXiangPaoListEntity>>> call = mCommonNet.getSanXiangPaoQueryList(params);
            call.enqueue(new ResultCallback<List<SanXiangPaoListEntity>>() {
                @Override
                public void onResponse(Call<RequestResult<List<SanXiangPaoListEntity>>> call, Response<RequestResult<List<SanXiangPaoListEntity>>> response) {
                    if (response.code() == 200) {
                        RequestResult<List<SanXiangPaoListEntity>> responseBody = response.body();
                        if (responseBody.msgCode != 0) {//请求失败
                            presenter.onFailure(AppConstants.SanXiangPao.QUERY_LIST, "会员关怀列表接口数据异常！");
                        } else {//请求成功
                            presenter.onResponseSuccess(AppConstants.SanXiangPao.QUERY_LIST, new CommonEntity(responseBody));//回传成功请求后的数据给p 层
                        }
                    } else {
                        presenter.onFailure(AppConstants.SanXiangPao.QUERY_LIST, "网络访问异常！会员关怀列表查询数据失败！");
                    }
                }
            });
        }
    }

    /**
     * 首页的网络请求
     *
     * @param presenter ...
     * @param mParams   ...
     */
    public final void start2requestStoreInfo(final CommonController.Presenter presenter, Map<String, String> mParams) {
        String userId = mParams.get("userId");
        String storeId = mParams.get("storeId");

        Call<Request2Result<FirstPageQueryResponse.InnerClass>> call =
                mCommonNet.getStoreTaskInfo(userId, storeId);
        call.enqueue(new Result2Callback<FirstPageQueryResponse.InnerClass>() {
            @Override
            protected void onResponseSuccess(
                    Request2Result<FirstPageQueryResponse.InnerClass> responseBody) {
                super.onResponseSuccess(responseBody);
                if (responseBody.sysCode == 0) {
                    presenter.onResponseSuccess(new CommonEntity(responseBody.returnBean));
                } else {
                    presenter.onFailure("首页网络接口数据异常！");
                }
            }

            @Override
            public void onFailure(Call<Request2Result<FirstPageQueryResponse.InnerClass>> call, Throwable t) {
//                super.onFailure(call, t);
                presenter.onFailure("网络异常！请求首页网络接口失败！" + t);
            }
        });
    }

    /**
     * 考勤异常单静默上传
     */
    public void start2requestUpLoadData(final CommonController.UpLoadOrderPre presenter, Map<String, String> params, final String bill) {
        Call<Request2Result<Object>> call = mCommonNet.getUpLoadSignInOrOutData(params);
        call.enqueue(new Result2Callback<Object>() {

            @Override
            public void onResponse(Call<Request2Result<Object>> call, Response<Request2Result<Object>> response) {
                if (response.code() == 200) {
                    Request2Result<Object> responseBody = response.body();
                    if (responseBody != null) {
                        int flag = responseBody.msgCode;

                        //请求失败
                        if (flag != 0 && flag != 1001) {
                            presenter.onFailure("接口数据异常，考勤上传失败！");
                        } else if (flag == 1001) {
                            CxykqDbOperate.UpdateBillState(bill, 2);//更新上传考勤状态
                            presenter.onFailure(responseBody.msgContent);
                        } else { //请求成功
                            SYLoger.print("是否有过期的打卡记录： " + responseBody.msgContent);
                            presenter.onResponseSuccess(bill);
                        }
                    }
                } else {
                    presenter.onFailure("网络异常！");
                }
            }
        });
    }

    /**
     * easyMockTest
     */
    private void easyMockTestRequest(final CommonController.FlowSalesPersonPre presenter, final String tag, Map<String, String> params) {
//        if (AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_HEAD.equals(tag)) {
//            OkHttpDominator.postAsyn(ApiUrls.EasyMockTest.FLOW_SALES_PERSON_COMPLETION_HEAD, params, new OkHttpDominator.ResultCallback<FlowSalesPersonCompletionHeadEntity>() {
//                @Override
//                public void onError(com.squareup.okhttp.Request request, Exception e) {
//                    presenter.onFailure("网络异常！");
//                    SYLoger.print("successful --" + "网络异常!");
//                }
//
//                @Override
//                public void onResponse(FlowSalesPersonCompletionHeadEntity response) {
//                    if (null != response) {
//                        presenter.onResponseSuccess(tag, new CommonEntity(response));
//                    }
//                }
//            });
//        } else if (AppConstants.FlowSalesPersonCompletion.FLOW_SALES_PERSON_COMPLETION_LIST.equals(tag)) {
//            OkHttpDominator.postAsyn(ApiUrls.EasyMockTest.FLOW_SALES_PERSON_COMPLETION_LIST, params, new OkHttpDominator.ResultCallback<FlowSalesPersonCompletionHeadEntity>() {
//                @Override
//                public void onError(com.squareup.okhttp.Request request, Exception e) {
//                    presenter.onFailure("网络异常！");
//                    SYLoger.print("successful --" + "网络异常!");
//                }
//
//                @Override
//                public void onResponse(FlowSalesPersonCompletionHeadEntity response) {
//                    if (null != response) {
//                        presenter.onResponseSuccess(tag, new CommonEntity(response));
//                    }
//                }
//            });
//        }
    }
}
