package com.urovo.wgmf.tool

import android.widget.ImageView
import androidx.databinding.BindingAdapter
import com.bumptech.glide.Glide
import com.urovo.wugumofang.R
import com.wgmf.trade.utils.ImageLoader

/**
 * @author Sasuke on 2019/5/4.
 * 用于Databinding的自定义属性
 */
class DatabindingAdapterDominator {
    //试了一下，把imageUrl改个名也行，这个@BindingAdapter("sasukeUrl")写成@BindingAdapter("bind:sasukeUrl")也行
    //结果好像就是(View,String)两个参数和 sasukeUrl 名字在起作用。
    companion object {
        @JvmStatic
        @BindingAdapter("sasukeUrl")
        fun loadImage(iv: ImageView, imageUrl: String?) {
            imageUrl?.let {
                Glide.with(iv.context).load(imageUrl)
                        .fitCenter()
                        .error(R.drawable.pop_hone_qgwsr_default)
                        .placeholder(R.drawable.pop_hone_qgwsr_default)
                        .into(iv)
            }
        }

        @JvmStatic
        @BindingAdapter("headPicUrl")
        fun loadHeadPicImage(iv: ImageView, imageUrl: String?) {
            imageUrl?.let {
                ImageLoader.loadCircleImg(iv.context, imageUrl, iv, R.drawable.head, R.drawable.head)
            }
        }
    }
}

