package com.urovo.wgmf.tool

import android.content.Context
import android.widget.TextView
import xp.timepicker.com.widget.DatePickDialog
import xp.timepicker.com.widget.bean.DateType
import java.text.SimpleDateFormat

object TimeHelper {

    /**
     * 日期，时间选择控件
     *
     * @param context
     * @param type     类型
     * TYPE_ALL("yyyy-MM-dd E hh:mm"),
     * TYPE_YMDHM("yyyy-MM-dd hh:mm"),
     * TYPE_YMDH("yyyy-MM-dd hh"),
     * TYPE_YMD("yyyy-MM-dd"),
     * TYPE_YM("yyyy-MM"),
     * TYPE_Y("yyyy"),
     * TYPE_M("MM"),
     * TYPE_HN("hh:mm"),
     * TYPE_H("hh"),
     * TYPE_N("mm"),
     * @param textView 回显控件
     */
    fun showDatePickDialog(context: Context, type: DateType, textView: TextView) {
        val dialog = DatePickDialog(context)
        //设置上下年分限制
        dialog.setYearLimt(100)
        //设置标题
        dialog.setTitle("选择时间")
        //设置类型
        dialog.setType(type)
        //设置消息体的显示格式，日期格式
        dialog.setMessageFormat(type.format)
        //设置选择回调
        dialog.setOnChangeLisener(null)
        //设置点击确定按钮回调
        dialog.setOnSureLisener { date ->
            var messge: String? = ""
            try {
                messge = SimpleDateFormat(type.format).format(date)
            } catch (e: Exception) {
                e.printStackTrace()
            }
            textView.text = messge
        }
        dialog.show()
    }


    /**
     * 日期，时间选择控件
     *
     * @param context
     * @param type     类型
     * TYPE_ALL("yyyy-MM-dd E hh:mm"),
     * TYPE_YMDHM("yyyy-MM-dd hh:mm"),
     * TYPE_YMDH("yyyy-MM-dd hh"),
     * TYPE_YMD("yyyy-MM-dd"),
     * TYPE_YM("yyyy-MM"),
     * TYPE_Y("yyyy"),
     * TYPE_M("MM"),
     * TYPE_HN("hh:mm"),
     * TYPE_H("hh"),
     * TYPE_N("mm"),
     */
    fun showDatePickDialog(context: Context, type: DateType): DatePickDialog {
        val dialog = DatePickDialog(context)
        //设置上下年分限制
        dialog.setYearLimt(100)
        //设置标题
        dialog.setTitle("选择时间")
        //设置类型
        dialog.setType(type)
        //设置消息体的显示格式，日期格式
        dialog.setMessageFormat(type.format)
        return dialog
    }

}