package com.wgmf.trade.model.bean;

/**
 * 会员基础资料
 * Created by samy on 16/9/12.
 */
public class MemberInfo {
    /**
     * address (string, optional):
     地址 ,

     ageGroup (string, optional):
     年龄群组 1中 2青 3老 ,

     buyReason (string, optional):
     最后一次购买理由 ,

     city (string, optional):
     市 ,

     consultantId (string, optional):
     发展会员的营养顾问工号 ,

     consultantName (string, optional):
     发展会员的营养顾问姓名 ,

     county (string, optional):
     县 ,

     cusPosi (string, optional):
     职业 ,

     customerBirthday (string, optional):
     会员生日 ,

     customerFrom (integer, optional):
     0:系统、crm 1：openerp 2：ehd（post系统） 3：微信 4：淘宝 5：京东6：手机录入 7天猫 8：官方商城 9,生意管家 10:微商城 ,

     customerGrade (string, optional):
     会员等级 ,

     customerId (string, optional):
     会员id ,

     customerMobile (string, optional):
     会员手机号 ,

     customerName (string, optional):
     会员名称 ,

     customerSex (string, optional):
     客户性别 1男 2女 0保密 ,

     customerStatus (integer, optional):
     状态 ,

     firstStoreId (integer, optional):
     首次购买的门店id ,

     firstStoreName (string, optional):
     首次购买门店名称 ,

     isMember (string, optional):
     是否是会员 0是 1不是 ,

     isNewMember (string, optional):
     是否是新会员 0是 1不是 ,

     isSendSMS (integer, optional):
     是否发送短信 0 发送 1不发送 ,

     isWechartmember (string, optional):
     是否是微信会员 0是 1不是 ,

     lastBuyTime (string, optional):
     最后一次购买时间 ,

     onlineVipGoodsDisConsDay (string, optional):
     距离最近一次的购买会员商品的时间 ,

     onlineVipGoodsName (string, optional):
     最近一次的购买会员商品名称 ,

     nickName (string, optional):
     昵称 ,

     openId (string, optional):
     openid ,

     operateTime (string, optional):
     操作时间 ,

     postCode (integer, optional):
     邮编 ,

     province (string, optional):
     省 ,

     showOnlineVipGoods (integer, optional):
     是否显示会员商品标签，0:不显示，1:显示 ,

     storeId (string, optional):
     员工登录的当前门店 ,

     storeName (string, optional):
     发展会员的门店名称 ,

     userId (string, optional):
     员工工号 ,

     validPoint (integer, optional):
     有效积分 ,

     weType (integer, optional):
     0没关注，1扫描关注，2老会员已关注,3老会员未关注 ,

     wechartNo (string, optional)
     }
     */

    /**
     * address : string
     * ageGroup : string
     * buyReason : string
     * city : string
     * consultantId : string
     * consultantName : string
     * county : string
     * cusPosi : string
     * customerBirthday : string
     * customerFrom : 0
     * customerGrade : string
     * customerId : string
     * customerMobile : string
     * customerName : string
     * customerSex : string
     * customerStatus : 0
     * firstStoreId : 0
     * firstStoreName : string
     * isMember : string
     * isNewMember : string
     * isSendSMS : 0
     * isWechartmember : string
     * lastBuyTime : string
     * nickName : string
     * onlineVipGoodsDisConsDay : string
     * onlineVipGoodsName : string
     * openId : string
     * operateTime : string
     * postCode : 0
     * province : string
     * showOnlineVipGoods : integer
     * storeId : string
     * storeName : string
     * userId : string
     * validPoint : 0
     * weType : 0
     * wechartNo : string
     */

    public String address;
    public String ageGroup;
    public String buyReason;
    public String city;
    public String consultantId;
    public String consultantName;
    public String county;
    public String cusPosi;
    public String customerBirthday;
    public int customerFrom;
    public String customerGrade;
    public String customerId;
    public String customerMobile;
    public String customerName;
    /**
     * 默认为男，不处理保密的情况
     */
    public String customerSex;
    public int customerStatus;
    public int firstStoreId;
    public String firstStoreName;
    public String isMember;
    public String isNewMember;
    public String inPand;//是否进塘，0:否，1:是
    public int isSendSMS;
    public String isWechartmember;

    public String nickName;
    /**
     * 距离最近一次的购买会员商品的时间
     */
    public String onlineVipGoodsDisConsDay;
    /**
     * 最近一次的购买会员商品名称
     */
    public String onlineVipGoodsName;
    public String openId;
    public String operateTime;
    public int postCode;
    public String province;
    /**
     * 是否显示会员商品标签，0:不显示，1:显示
     */
    public int showOnlineVipGoods;
    public String storeId;
    public String storeName;
    public String userId;
    public int validPoint;
    public int weType;
    public String wechartNo;
    /**
     * 微信头像链接
     */
    public String headImgUrl;
    /**
     * 最近购买的时间
     */
    public String lastBuyTime;
    /**
     * 最近购买的商品
     */
    public String lastBuyProduct;
    /**
     * 最近购买的天数
     */
    public String distanceConsDay;
    /**
     * 是否买过八珍  0:没买过，1:买过
     */
    public int hasBuyBazhen;
    /**
     * 是否买过新八珍（植物益生元八珍）  0:没买过，1:买过
     */
    public int hasBuyNewBazhen;
    /**
     * 有线上消费，0:无，1:有
     */
    public int hasOnlineConsumption;
    /**
     * 是否入群，0:否，1:是
     */
    public int inGroup;

    /**
     * 加群二维码
     */
    public String groupUrl;

    /**
     * 开启弹窗 0:否，1:是
     */
    public int showSwitch;

    @Override
    public String toString() {
        return "MemberInfo{" +
                "address='" + address + '\'' +
                ", ageGroup='" + ageGroup + '\'' +
                ", buyReason='" + buyReason + '\'' +
                ", city='" + city + '\'' +
                ", consultantId='" + consultantId + '\'' +
                ", consultantName='" + consultantName + '\'' +
                ", county='" + county + '\'' +
                ", cusPosi='" + cusPosi + '\'' +
                ", customerBirthday='" + customerBirthday + '\'' +
                ", customerFrom=" + customerFrom +
                ", customerGrade='" + customerGrade + '\'' +
                ", customerId='" + customerId + '\'' +
                ", customerMobile='" + customerMobile + '\'' +
                ", customerName='" + customerName + '\'' +
                ", customerSex='" + customerSex + '\'' +
                ", customerStatus=" + customerStatus +
                ", firstStoreId=" + firstStoreId +
                ", firstStoreName='" + firstStoreName + '\'' +
                ", isMember='" + isMember + '\'' +
                ", isNewMember='" + isNewMember + '\'' +
                ", inPand='" + inPand + '\'' +
                ", isSendSMS=" + isSendSMS +
                ", isWechartmember='" + isWechartmember + '\'' +
                ", nickName='" + nickName + '\'' +
                ", onlineVipGoodsDisConsDay='" + onlineVipGoodsDisConsDay + '\'' +
                ", onlineVipGoodsName='" + onlineVipGoodsName + '\'' +
                ", openId='" + openId + '\'' +
                ", operateTime='" + operateTime + '\'' +
                ", postCode=" + postCode +
                ", province='" + province + '\'' +
                ", showOnlineVipGoods=" + showOnlineVipGoods +
                ", storeId='" + storeId + '\'' +
                ", storeName='" + storeName + '\'' +
                ", userId='" + userId + '\'' +
                ", validPoint=" + validPoint +
                ", weType=" + weType +
                ", wechartNo='" + wechartNo + '\'' +
                ", headImgUrl='" + headImgUrl + '\'' +
                ", lastBuyTime='" + lastBuyTime + '\'' +
                ", lastBuyProduct='" + lastBuyProduct + '\'' +
                ", distanceConsDay='" + distanceConsDay + '\'' +
                ", hasBuyBazhen=" + hasBuyBazhen +
                ", hasBuyNewBazhen=" + hasBuyNewBazhen +
                ", hasOnlineConsumption=" + hasOnlineConsumption +
                ", inGroup=" + inGroup +
                ", groupUrl='" + groupUrl + '\'' +
                ", showSwitch=" + showSwitch +
                '}';
    }
}
