package com.wgmf.trade.model.bean;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * 商品组合
 *
 * @author samy
 * @date 16/9/23
 */
public class ProGroupInfoBean implements Serializable {
    /**
     * 名称
     */
    public String name;
    /**
     * 数量
     */
    public String num;
    /**
     * 新加的字段，支持到金额规则，规则为“大于等于该money金额
     */
    public String money;
    /**
     * 组合Id
     */
    public int groupId;
    /**
     * 产品
     */
    public ArrayList<ProductInfoBean> product;
    /**
     * 这是个产品组合的外层特价，如果这个特价字段不为0或空，则把它分配到该组合下的每个产品 。
     */
    public double specialPrice;

    /**
     * 比例关系
     */
    public int proportRelation;

    /**
     * 倍数关系
     */
    public double multipleRelation;

    /**
     * 提示
     */
    public String curTip;

    @Override
    public String toString() {
        return "ProGroupInfoBean{" +
                "name='" + name + '\'' +
                ", num='" + num + '\'' +
                ", money='" + money + '\'' +
                ", groupId=" + groupId +
                ", product=" + product +
                ", specialPrice=" + specialPrice +
                ", proportRelation=" + proportRelation +
                ", multipleRelation=" + multipleRelation +
                ", curTip='" + curTip + '\'' +
                '}';
    }
}
