package com.wgmf.trade.model.bean;

import android.text.TextUtils;

import com.urovo.wgmf.db.dao.dao.Cpbill002DbOperate;
import com.urovo.wgmf.db.dao.dao.Item001DbOperate;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.system.SystemHelper;
import com.wgmf.trade.utils.ArithUtil;
import com.zsy.libcore.ui.ada.quickadapter.ISelectable;

import java.io.Serializable;

import kotlin.jvm.Transient;

/**
 * @author ...
 */
public class ProductInfoBean
        implements Serializable, ISelectable {
    public String code;
    public String name;

    /**
     * 数量规则
     */
    public String num;

    private double price;
    public double specialPrice;

    /**
     * 因公用ProductInfoBean问题;得于区分;
     * 因遍历原因。Adapter不同,只做0&1判断;
     * proType类型,
     * 0:商品;(默认)
     * 1:组合商品;
     * 2:继续添加过来的老数据model;
     * <p>
     * 赠品;0
     * 组合赠品;1
     */
    private int proType;

    /**
     * 一般默认情况下为num
     */
    private double proNum;


    /**
     * 以下字段为了提交订单采用到；
     * 通过code从基础资料的数据库拿到；
     */
    /**
     * 产品角色：P-普通产品（输入数量：罐装、盒装单位） C-大类码（散装类，输入金额）
     */
    public String ItemMode = "P";
    /**
     * 库存单位
     */
    public String KCUom = "";

    /**
     * 当前库存【为会员商品新增的，请求库存后返回存到这里，用来限制输入数量】
     */
    public String StockQty = "";

    /**
     * 箱装数
     */
    public double Unit = 1;
    /**
     * 总金额
     */
    public double Amount = 0;
    /**
     * 产品条码
     */
    public String Barcode;
    /**
     * 品牌（五谷磨房 或 鲜稻研）
     */
    private String brand;
    //是否是特殊BOM产品，y:是
    public String BOMSPEC;

    public String getBOMSPEC() {
        return BOMSPEC;
    }

    public void setBOMSPEC(String BOMSPEC) {
        this.BOMSPEC = BOMSPEC;
    }
    /**
     * Classid，用于下单界面对产品表的分类
     */
    public String classid = "";
    /**
     * 标签classid的优先级（数字越低优先级越高，越排在前面）
     */
    public int classidorder;

    /**
     * 梯度折扣组合Id
     */
    public int groupId;
    /**
     * 梯度折扣关系
     */
    public int proportRelation;

    private boolean isDecimal = true;//数据是否支持小数（一般是2位）

    public boolean isDecimal() {
        if(isDecimal) {//因为isDecimal默认就是true，所以为了避免因为未赋值而采用的默认值，所以需要再进行一次数据库查询来保险。
            isDecimal = Cpbill002DbOperate.isDecimalById(code);
        }
        return  isDecimal;
    }

    public void setStockQty(String stockQty) {
        StockQty = stockQty;
    }

    public String getStockQty() {
        return TextUtils.isEmpty(StockQty)? "0" : StockQty;
    }

    /**输入的【会员商品数量】是否超过了库存*/
    public boolean isOverMemStock(Double inputQty){
        return SystemHelper.MemGoodsBrand.equals(brand)
                && inputQty > Double.parseDouble(getStockQty());
    }

    public void setDecimal(boolean decimal) {
        isDecimal = decimal;
    }

    public void setClassidorder(int classidorder) {
        this.classidorder = classidorder;
    }

    public void setClassid(String classid) {
        this.classid = classid;
    }

    public void setBrand(String brand) {
        this.brand = brand;
    }

    public String getBrand() {
        //小心有时候活动传来的产品信息不带品牌，做个防空！
        if (brand == null) {
            brand = Item001DbOperate.getBrandById(code);
        }
        return brand;
    }

    public double getProNum() {
        double tempNum = proNum;
        //防止默认请求(proType=0)下,
        if (tempNum == 0 && proType == 0) {
            try { //规则里面有数字,用规则里面的,无的用默认的;
                //tempNum = getProNumFormNum(num);
                tempNum = getProNumMinAndMax(num)[0];
                //拿值并赋值；
                this.proNum = tempNum;
            } catch (Exception e) {

            }
        }
        return tempNum;
    }

    public void setProNum(double proNum) {
        this.proNum = proNum;
    }


    /**
     * 从规则里面获取数量
     * 跟Verifyutil对应上；compareNum
     *
     * @param num
     * @return 数组第一个是最小值和数组第二个是最大值
     */
    public double[] getProNumMinAndMax(String num) {
        double[] ruleArr = new double[3];
        //最小默认值；数组第一个
        double proNum = 0;
        //最大默认值；数组第二个
        double maxNum = AppConstants.Printer.maxCount;
        //标志是否可用，0可以操作，1不可操作；用于判断不能操作加减,但可手动输入操作;以上的情况；数组第三个（最后一个）
        int flagOper = 0;
        //字符串规则不为空是，修改；为空时，显示组装默认的数据；
        if (!TextUtils.isEmpty(num)) {
            if (num.contains("+")) {
                proNum = Double.parseDouble(num.replace("+", ""));
            } else if (num.contains("-")) {
                String[] array = num.split("-");
                proNum = Double.parseDouble(array[0]);
                maxNum = Double.parseDouble(array[1]);
            } else if (num.contains(",")) {
                String[] array = num.split(",");
                proNum = Double.parseDouble(array[0]);
                maxNum = Double.parseDouble(array[array.length - 1]);
                flagOper = 1;
            } else {
                proNum = Double.parseDouble(num);
                maxNum = proNum;
                flagOper = 1;
            }
        }
        //最小值
        ruleArr[0] = proNum;
        //最大值
        ruleArr[1] = maxNum;
        //标志是否可用，0可以操作，1不可操作；
        ruleArr[2] = flagOper;
        return ruleArr;
    }

    public double getPrice() {
        if (specialPrice != 0){
            return specialPrice;
        }else{
            return price;
        }
    }

    public void setPrice(double price) {
        this.price = price;
    }

    /**
     * 这个方法之用于算钱时用
     */
    public double getPriceOriginal() {
        return price;
    }

    /**打折后的价格
     * 缓存在这里，提交订单时不需要传它*/
    @Transient
    public double discountedPrice;


    public int getProType() {
        return proType;
    }

    public void setProType(int proType) {
        this.proType = proType;
    }

    @Override
    public boolean isISelected() {
        return false;
    }

    @Override
    public void setISelected(boolean b) {

    }

    public String getItemMode() {
        return ItemMode;
    }

    public void setItemMode(String itemMode) {
        ItemMode = itemMode;
    }

    public String getKCUom() {
        return KCUom;
    }

    public void setKCUom(String KCUom) {
        this.KCUom = KCUom;
    }

    public double getUnit() {
        return Unit;
    }

    public void setUnit(double unit) {
        Unit = unit;
    }

    /**
     * 单个商品实际总价格
     */
    public double getAmountActual() {
        return ArithUtil.mul(getPrice(),getProNum());
    }

    public int getGroupId() {
        return groupId;
    }

    public void setGroupId(int groupId) {
        this.groupId = groupId;
    }

    public int getProportRelation() {
        return proportRelation;
    }

    public void setProportRelation(int proportRelation) {
        this.proportRelation = proportRelation;
    }

    /**
     * 获取总价
     * 如果是鲜稻研，那就直接获取原生字段；
     * 如果是五谷磨房，那就需要考虑那些特价什么的，计算得到实际价格，不能取原生字段。
     *
     * 新：获取总价还是要按照isDecimal来判断，例如：食补集不属于 五谷磨房品牌，但isDecimal却是false，那这里就应该按数量X【原价】来算了。
     *
     * @return ...
     */
    public double getAmount() {
        if (isDecimal()) {
            return Amount;
        } else {
            return Arith.mul(getPriceOriginal(), getProNum());
        }
    }

    public String getBarcode() {
        if ("9.8888".equals(code)) {
            Barcode = "t";
        }
        return Barcode;
    }

    public void setBarcode(String barcode) {
        Barcode = barcode;
    }

    @Override
    public String toString() {
        return "ProductInfoBean{" +
                "code='" + code + '\'' +
                ", name='" + name + '\'' +
                ", isDecimal=" + isDecimal +
                ", num='" + num + '\'' +
                ", price=" + price +
                ", specialPrice=" + specialPrice +
                ", proType=" + proType +
                ", proNum=" + proNum +
                ", ItemMode='" + ItemMode + '\'' +
                ", KCUom='" + KCUom + '\'' +
                ", Unit=" + Unit +
                ", Amount=" + Amount +
                ", Barcode='" + Barcode + '\'' +
                ", brand='" + brand + '\'' +
                ", classid='" + classid + '\'' +
                ", classidorder=" + classidorder +
                '}';
    }

    @SuppressWarnings("all")
    @Override
    public boolean equals(Object obj) {
        ProductInfoBean pc = (ProductInfoBean) obj;
        return code.equals(pc.code) && (proType == pc.getProType());
    }
}