package com.wgmf.trade.model.data.net.interactor.impl;

import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.system.EnvironmentHelper;
import com.wgmf.trade.model.data.net.interactor.EnvironmentSwitchInt;
import com.urovo.wugumofang.data.PreferHelper;

/**
 * Created by samy on 16/4/11.
 */
public class EnvironmentSwitchIntImpl implements EnvironmentSwitchInt {

    @Override
    public int getEnvStatus() {
        int tempEnv;
        try {
            tempEnv = PreferHelper.getInstance().getInt(AppConstants.APIEnvironment.APP_ENVIRONMENT, 0);

        } catch (Exception e) {
            e.printStackTrace();
            tempEnv = 0;
        }
        return tempEnv;
    }


    @Override
    public void setEnvStatus(int checkEnv) {
        PreferHelper.getInstance().setInt(AppConstants.APIEnvironment.APP_ENVIRONMENT, checkEnv);
    }


    @Override
    public String getEnvServer(int envStatus) {
        return EnvironmentHelper.getInstance().getEnvServer(envStatus);
    }

    @Override
    public String getEnvApiServer(int envStatus) {
        return EnvironmentHelper.getInstance().getEnvApiServer(envStatus);
    }

    @Override
    public String getWxServer(int envStatus) {
        return EnvironmentHelper.getInstance().getWXServer(envStatus);
    }

    @Override
    public String getEnvPort(int envStatus) {
        return EnvironmentHelper.getInstance().getEnvPort(envStatus);

    }

    @Override
    public String showEnvName(int envStatus, boolean isDefault) {
        String tempEnvName = null;
        switch (envStatus) {
            case EnvironmentHelper.ENV_DEFAULT:
            case EnvironmentHelper.ENV_RELEASE:
                tempEnvName = String.format("%1s环境为：%2s", isDefault ? "当前" : "切换", "正式环境");
                break;
            case EnvironmentHelper.ENV_BETA:
                tempEnvName = String.format("%1s环境为：%2s", isDefault ? "当前" : "切换", "灰度环境");
                break;
            case EnvironmentHelper.ENV_TEST:
                tempEnvName = String.format("%1s环境为：%2s", isDefault ? "当前" : "切换", "测试环境");
                break;
        }
        return tempEnvName;
    }

}
