package com.wgmf.trade.presenter;

import androidx.annotation.NonNull;

import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.response.BaseSimpleResponse;
import com.urovo.wugumofang.system.SystemHelper;
import com.wgmf.trade.GlobalApp;
import com.urovo.wugumofang.constants.ApiConstants;
import com.wgmf.trade.model.data.net.AdditionalRecordDataNet;
import com.wgmf.trade.ui.fra.index.AdditionalRecordFra;
import com.wgmf.trade.view.AdditionalRecordCon;
import com.zsy.libcore.config.LibCoreConfig;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;
import com.zsy.libcore.view.BaseView;
import com.zsy.libext.widgets.tips.ToastMsg;

import org.jetbrains.annotations.NotNull;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * 销售补录
 * Created by samy on 16/10/20.
 */
public class AdditionalRecordPre extends BasePresenterImpl implements AdditionalRecordCon.Pre {
  private AdditionalRecordDataNet additionalRecordDataNet;

  public AdditionalRecordPre(@NonNull BaseView mMvpView) {
    super(mMvpView);
    additionalRecordDataNet = RetrofitHelper.createApi(AdditionalRecordDataNet.class);
  }

  @Override public void getStoreCheckState(String storeId,String recordDate) {
    Call<BaseSimpleResponse> call =
        additionalRecordDataNet.getStoreCheckState(SystemHelper.LoginOrganId,recordDate);
    call.enqueue(new Callback<BaseSimpleResponse>() {
      @Override
      public void onResponse(@NotNull Call<BaseSimpleResponse> call, @NotNull Response<BaseSimpleResponse> res) {
        if (res.isSuccessful()){
            if (res.body()!=null&&res.body().resultInfo.equals("0")){//0表示未审核false，1表示已审核true
               if (getMvpView().isActive()) {
                 ((AdditionalRecordCon.View)getMvpView()).showChangeState(false);
              }
            }else {
              ((AdditionalRecordCon.View)getMvpView()).showChangeState(true);
            }
          }else {
            onFailure(call,null);
          }
      }

      @Override
      public void onFailure(@NotNull Call<BaseSimpleResponse> call, @NotNull Throwable t) {
        ToastMsg.showToastMsg(GlobalApp.getInstance(), "网络数据异常，请稍后查询");
      }
    });

//    call.enqueue(new Callback<ReviewSalesStatusBean>() {
//      @Override public void onResponse(Call<BaseSimpleResponse> call,
//          Response<BaseSimpleResponse> response) {
//          if (response.isSuccessful()){
//            if (response.body().List!=null && response.body().List.size()>0 && response.body().List.get(0).YN_HD.equals("0")){
//               if (getMvpView().isActive()) {
//                 ((AdditionalRecordCon.View)getMvpView()).showChangeState(false);
//              }
//            }else {
//              ((AdditionalRecordCon.View)getMvpView()).showChangeState(true);
//            }
//          }else {
//            onFailure(call,null);
//          }
//      }
//
//      @Override public void onFailure(Call<ReviewSalesStatusBean> call, Throwable t) {
//        ToastMsg.showToastMsg(GlobalApp.getInstance(), "网络数据异常，请稍后查询");
//      }
//    });
  }

  @Override public void start() {

  }

  public static void main(String[] args) {
    LibCoreConfig.API_URL = ApiConstants.testEnvServer;
    AdditionalRecordPre additionalRecordPre = new AdditionalRecordPre(new AdditionalRecordFra());
    additionalRecordPre.getStoreCheckState("0110074", "2016-11-17");
  }

}
