package com.wgmf.trade.presenter;

import com.urovo.wugumofang.response.BaseResponse;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.wgmf.trade.model.bean.ExchangeUndoBean;
import com.wgmf.trade.model.data.net.ExchangeUndoDataNet;
import com.wgmf.trade.view.ExchangeUndoCon;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultBaseCallback;
import com.zsy.libcore.model.bean.ResultCallback;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;
import com.zsy.libcore.view.BaseView;

import java.util.List;

import retrofit2.Call;
import retrofit2.Response;

/**
 * Created by samy on 2017/2/14.
 */

public class ExchangeUndoPre extends BasePresenterImpl implements ExchangeUndoCon.Pre  {
  ExchangeUndoDataNet exchangeUndoDataNet;

  public ExchangeUndoPre(BaseView mMvpView) {
    super(mMvpView);
    exchangeUndoDataNet = RetrofitHelper.createApi(ExchangeUndoDataNet.class);
  }

  @Override public void getExchangeUndoList(String mobile, String shopId,int pages) {
    if (getMvpView()!=null){
      getMvpView().showLoading("");
    }
    Call<RequestResult<List<ExchangeUndoBean>>> call =  exchangeUndoDataNet.getExchangeUndoList(mobile,shopId,pages,10);
    call.enqueue(new ResultCallback<List<ExchangeUndoBean>>(){
      @Override protected void onResponseSuccess(RequestResult<List<ExchangeUndoBean>> responseBody) {
          if (getMvpView()!=null){
            getMvpView().hideLoading();
            super.onResponseSuccess(responseBody);
            if (responseBody.resultInfo!=null){
              ((ExchangeUndoCon.View)getMvpView()).showExchangeUndoList(responseBody.resultInfo);
           }
        }
      }

      @Override
      public void onFailure(Call<RequestResult<List<ExchangeUndoBean>>> call, Throwable t) {
        super.onFailure(call, t);
        if (getMvpView()!=null){
         getMvpView().hideLoading();
        }
      }
    });
  }

  @Override public void pointExchangeCancel(String exchid, String opno, String remark) {
    Call<BaseResponse> call =  exchangeUndoDataNet.pointExchangeCancel(exchid,opno,remark);
    getMvpView().showLoading("正在撤销兑换......");
    call.enqueue(new ResultBaseCallback<BaseResponse>(){
      @Override public void onResponse(Call<BaseResponse> call, Response<BaseResponse> response) {
        super.onResponse(call, response);
        getMvpView().hideLoading();
        if (response.isSuccessful()){
          this.toastNetTips(response.body().retInfo);
          String temp =response.body().ret;
          if (temp.equals("0")){
            if (getMvpView()!=null){
              ((ExchangeUndoCon.View)getMvpView()).showPointExchangeCancel(true);
            }
          }
        }
      }
    });
  }

  @Override public void start() {

  }
}



