package com.wgmf.trade.presenter;

import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.wgmf.trade.model.bean.GoodsInOutStockBean;
import com.wgmf.trade.model.bean.GoodsInOutStockItemDetailBean;
import com.wgmf.trade.model.data.net.GoodsInoutStockDataNet;
import com.wgmf.trade.view.GoodsInOutStockCon;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.Response;

/**
 * Created by samy on 2017/2/20.
 */

public class GoodsInOutStockPre implements GoodsInOutStockCon.Pre {
    private GoodsInoutStockDataNet goodsInoutStockDataNet;
    private GoodsInOutStockCon.View view;

//    static {
////        LibCoreConfig.API_URL = "https://app.wgmf.com/";
//        LibCoreConfig.API_URL = "http://test.wgmf.com/";
//    }

    public GoodsInOutStockPre(GoodsInOutStockCon.View view) {
        this.view = view;
        goodsInoutStockDataNet = RetrofitHelper.createApi(GoodsInoutStockDataNet.class);
    }

    @Override
    public void getDataList(String storeNo, String productNo, String month, String endDate) {
//        SYLoger.print("LibCoreConfig.API_URL-->" + LibCoreConfig.API_URL);
//        SYLoger.print("storeNo: " + storeNo + ", productNo: " + productNo + ", beginDate: " + beginDate + ", endDate: " + endDate);
        Call<RequestResult<GoodsInOutStockBean>> call = goodsInoutStockDataNet.getDataList(
                storeNo,
                productNo,
                month
        );
        call.enqueue(new ResultCallback<GoodsInOutStockBean>() {
            @Override
            protected void onResponseSuccess(RequestResult<GoodsInOutStockBean> responseBody) {
//                super.onResponseSuccess(responseBody);
                if (responseBody.resultInfo != null) {
                    if (view != null) {
                        view.showDataList(responseBody.resultInfo);
                    }
                }
                ViewUtil.dismissProgress();
            }

            @Override
            public void onFailure(Call<RequestResult<GoodsInOutStockBean>> call, Throwable t) {
                super.onFailure(call, t);
                ViewUtil.dismissProgress();
            }

            @Override
            public void onResponse(Call<RequestResult<GoodsInOutStockBean>> call, Response<RequestResult<GoodsInOutStockBean>> response) {
//                super.onResponse(call, response);
                if (response.code() == 200) {
                    RequestResult<GoodsInOutStockBean> responseBody = response.body();
                    int flag = responseBody.msgCode;
                    if (flag != 0) {//请求失败
                        this.toastNetTips(responseBody.msgInfo);
                        ViewUtil.dismissProgress();
                    } else {//请求成功
                        this.onResponseSuccess(responseBody);
                    }
                } else {
                    this.onFailure(call, new Throwable(response.errorBody().toString()));
                }
            }
        });
    }

    @Override
    public void getItemDetail(String storeNo, String productNo, String month, String endDate,
                              String inOutType) {
//        SYLoger.print("storeNo: " + storeNo + ", productNo: " + productNo + ", beginDate: " + beginDate + ", endDate: " + endDate+", inOutType: "+inOutType);

        Call<RequestResult<ArrayList<GoodsInOutStockItemDetailBean>>> call = goodsInoutStockDataNet.getItemDetail(
                storeNo,
                productNo,
                month,
                inOutType
        );
        call.enqueue(new ResultCallback<ArrayList<GoodsInOutStockItemDetailBean>>() {
            @Override
            protected void onResponseSuccess(RequestResult<ArrayList<GoodsInOutStockItemDetailBean>> responseBody) {
//                super.onResponseSuccess(responseBody);
                if (responseBody.resultInfo != null) {
                    if (view != null) {
                        view.showItemDetail(responseBody.resultInfo);
                    }
                }
                ViewUtil.dismissProgress();
            }

            @Override
            public void onFailure(Call<RequestResult<ArrayList<GoodsInOutStockItemDetailBean>>> call, Throwable t) {
                super.onFailure(call, t);
                ViewUtil.dismissProgress();
            }

            @Override
            public void onResponse(Call<RequestResult<ArrayList<GoodsInOutStockItemDetailBean>>> call, Response<RequestResult<ArrayList<GoodsInOutStockItemDetailBean>>> response) {
//                super.onResponse(call, response);
                if (response.code() == 200) {
                    RequestResult<ArrayList<GoodsInOutStockItemDetailBean>> responseBody = response.body();
                    int flag = responseBody.msgCode;
                    if (flag != 0) {//请求失败
                        this.toastNetTips(responseBody.msgInfo);
                        ViewUtil.dismissProgress();
                    } else {//请求成功
                        this.onResponseSuccess(responseBody);
                    }
                } else {
                    this.onFailure(call, new Throwable(response.errorBody().toString()));
                }
            }
        });
    }
}
