package com.wgmf.trade.presenter;

import android.widget.Toast;

import com.urovo.wugumofang.constants.ApiConstants;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.wgmf.trade.model.bean.UserHeadResBean;
import com.wgmf.trade.model.data.net.IndexDataNet;
import com.wgmf.trade.view.IndexCon;
import com.zsy.libcore.LibCoreApp;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.config.LibCoreConfig;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;

import java.net.SocketTimeoutException;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * Created by samy on 16/12/16.
 */
public class IndexPre implements IndexCon.Pre {
    private IndexDataNet indexDataNet;
    private IndexCon.View indexView;

    public IndexPre(IndexCon.View view) {
        //public IndexPre() {
        indexView = view;
        indexDataNet = RetrofitHelper.createApi(IndexDataNet.class);
    }

    @Override
    public void getUserPic(String staffId) {
        Call<UserHeadResBean> call = indexDataNet.getUserPic(staffId);
        call.enqueue(new Callback<UserHeadResBean>() {
            @Override
            public void onResponse(Call<UserHeadResBean> call, Response<UserHeadResBean> response) {
                if (response.isSuccessful()) {
                    UserHeadResBean responseBody = response.body();
                    if (responseBody.ret.equals("0")) {
                        if (indexView != null) {
                            indexView.showUserPic(responseBody.result.headpicurl);
                        }
                    } else {
                        //this.onFailure(call, new Throwable(responseBody.retInfo));
//                        Toast.makeText(LibCoreApp.getInstance(), responseBody.retInfo, Toast.LENGTH_SHORT).show();
                        SYLoger.print("wgmf--HomeActivity--头像" + responseBody.retInfo);
                    }
                } else {
                    this.onFailure(call, new Throwable(response.errorBody().toString()));
                }
            }

            @Override
            public void onFailure(Call<UserHeadResBean> call, Throwable t) {
                String msgTips = "网络访问异常";
                if (t instanceof SocketTimeoutException) {
                    msgTips = "网络请求超时";
                }
                indexView.showUserPicFailure(msgTips, t);
                Toast.makeText(LibCoreApp.getInstance(), msgTips, Toast.LENGTH_SHORT).show();
            }
        });
    }


    @Override
    public void getUserUpload(String staffId, final String picUrl) {
        Call<RequestResult<String>> call = indexDataNet.getUserUpload(staffId, picUrl);
        call.enqueue(new ResultCallback<String>() {
            @Override
            protected void onResponseSuccess(RequestResult<String> responseBody) {
                super.onResponseSuccess(responseBody);
                if (indexView != null) {
                    indexView.showUserUploadState(true, picUrl);
                }
            }
        });
    }


    public static void main(String[] args) {
        LibCoreConfig.API_URL = ApiConstants.testEnvServer;
        //IndexPre indexPre = new IndexPre();
        //indexPre.getUserPic("692");
        //indexPre.getUserUpload("691","http://7xqiu3.com1.z0.glb.clouddn.com/sygj_iOS_0110074_692_20161216153932_260761");
    }
}
