package com.wgmf.trade.presenter;

import android.text.TextUtils;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.urovo.wgmf.db.dao.entitys.ActionFreshBtnBean;
import com.urovo.wgmf.db.dao.entitys.Show2HomeBean;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.data.PreferHelper;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.wgmf.trade.model.bean.MemActionDominator;
import com.wgmf.trade.model.bean.MemberAction;
import com.wgmf.trade.model.data.net.MemberActionListDataNet;
import com.wgmf.trade.view.MemberActionListCon;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;
import com.zsy.libext.widgets.tips.ToastMsg;

import org.greenrobot.eventbus.EventBus;

import java.util.ArrayList;
import java.util.List;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 会员主页>活动列表
 *
 * @author samy
 * @date 16/9/6
 */
@SuppressWarnings("all")
public class MemberActionListPre extends BasePresenterImpl implements MemberActionListCon.Pre {
    private MemberActionListDataNet memberActionListDataNet;

    private boolean isFormMain;


    public MemberActionListPre(MemberActionListCon.View view) {
        super(view);
        memberActionListDataNet = RetrofitHelper.createApi(MemberActionListDataNet.class);
    }

    public MemberActionListPre(boolean isFormMain) {
        super(null);
        this.isFormMain = isFormMain;
        memberActionListDataNet = RetrofitHelper.createApi(MemberActionListDataNet.class);
    }

    @Override
    public void start() {

    }

    /***
     * 是否显示到家销售按钮
     */
    public void canHave2HomeBiz(String storeNo){
        memberActionListDataNet.canHave2HomeBiz(storeNo).enqueue(new ResultCallback<Boolean>(){
            @Override
            public void onResponse(Call<RequestResult<Boolean>> call, Response<RequestResult<Boolean>> res) {
                super.onResponse(call, res);

            }

            @Override
            protected void onResponseSuccess(RequestResult<Boolean> responseBody) {
                super.onResponseSuccess(responseBody);
                boolean isShow = responseBody.resultInfo;

                Show2HomeBean bean = new Show2HomeBean();
                bean.setShowBtn(isShow);
                EventBus.getDefault().post(bean);
            }
        });
    }


    @Override
    public void getActionList(boolean isVip, String storeId, String phoneNum, String selectTime, boolean isAdditionalRecord) {
//    if (!NetHelper.IsHaveInternet(GlobalApp.getInstance())){
//        if (!isVip){
//          List<MemberAction> memberActions = new Gson().fromJson(PreferHelper.getInstance().getString(AppConstants.PreKeys.OFFLINE_COMMON_ACTION_LIST), new TypeToken<List<MemberAction>>() {
//          }.getType());
//          if (memberActions==null){
//            ToastMsg.showToastMsg(GlobalApp.getInstance(),"当前无网络且没有离线数据!");
//            return;
//          }
//          if (memberActions!=null&&memberActions.size()>=0){
//            if (!isFormMain&&getMvpView().isActive()){
//              ((MemberActionListCon.View)getMvpView()).showActionList(isVip,memberActions,isAdditionalRecord,selectTime);
//            }
//          }
//        }
//      return;
//    }

        Call<RequestResult<List<MemberAction>>> call;
        if (isVip && !TextUtils.isEmpty(phoneNum)) {
            //专享活动列表(不可离线)
            call = memberActionListDataNet.offlineVipActionList(storeId, phoneNum, selectTime,SystemHelper.LoginUserBrandList);
        } else {
            //全场活动列表(可离线)
            call = memberActionListDataNet.offlineCommonActionList(storeId, selectTime,SystemHelper.LoginUserBrandList);
        }
        dealWithShow(isVip, call, isAdditionalRecord, selectTime);
    }

    /**
     * 存五谷磨房活动数据
     */
    List<MemberAction> wgmfmemberActions = new ArrayList<>();
    /**
     * 存鲜稻研活动数据
     */
    List<MemberAction> xdymemberActions = new ArrayList<>();
    /**
     * 所有品牌数据(按品牌排序)
     */
    List<MemberAction> memberActions = new ArrayList<>();

    private void dealWithShow(final boolean isVip, Call<RequestResult<List<MemberAction>>> call,
                              final boolean isAdditionalRecord, final String selectTime) {
        call.enqueue(new ResultCallback<List<MemberAction>>() {
            @Override
            protected void onResponseSuccess(RequestResult<List<MemberAction>> responseBody) {
                super.onResponseSuccess(responseBody);
//                List<MemberAction> memberActions = responseBody.resultInfo;
                List<MemberAction> memberActionList;
                //假数据===================
                List<MemberAction> mockActions = JsonDominator.loadFromSD("MemberActionList",new TypeToken<List<MemberAction>>() { }.getType() );
                if (mockActions != null && !isVip){//对全场活动做假数据
                    memberActionList = sortAction(mockActions);
                }else{//真实数据
                    memberActionList = sortAction(responseBody.resultInfo);
                }
                //把外层特价都分配到组合里的各个产品
                MemActionDominator.dealProGroupSpecialPrice(memberActionList);

                SYLoger.print("wgmf--MemberAction: " + memberActions);
                //设置自定义属性
                if (memberActions != null && memberActions.size() >= 0) {
                    //全场活动情况下，做离线处理；
                    if (!isVip) {
//                        PreferHelper.getInstance().setString(AppConstants.PreKeys.OFFLINE_COMMON_ACTION_LIST, new Gson().toJson(responseBody.resultInfo));
                        PreferHelper.getInstance().setString(AppConstants.PreKeys.OFFLINE_COMMON_ACTION_LIST, new Gson().toJson(memberActionList));

                        isDiscountOrNot(memberActionList);
                    }
                    if (!isFormMain && getMvpView().isActive()) {
                        ((MemberActionListCon.View) getMvpView()).showActionList(isVip, memberActions, isAdditionalRecord, selectTime);
                    }
                }
            }

            /**
             * 是否是全场折扣活动
             * @param memberActionList
             *
             *  temp 做累加，如果为0，就是没有全场折扣标志，大于0 就有全场折扣
             *  mBrandTypeList 存储 品牌名标志，作为区别哪个品牌有全场折扣这类型活动。
             */
            private List<Integer> mBrandTypeList = new ArrayList<>();

            private void isDiscountOrNot(List<MemberAction> memberActionList) {
                int temp = 0;
                mBrandTypeList.clear();
                for (MemberAction memberAction : memberActionList) {
                    if (memberAction.allDiscountOrNot == AppConstants.PreKeys.IS_ALL_DISCOUNT) {
                        temp += 1;
                        mBrandTypeList.add(memberAction.brandType);
                    }
                }
                EventBus.getDefault().post(new ActionFreshBtnBean(temp == 0, mBrandTypeList));
            }

            @Override
            public void onFailure(Call<RequestResult<List<MemberAction>>> call, Throwable t) {
                super.onFailure(call, t);
                if (!isVip) {
                    List<MemberAction> memberActions = new Gson().fromJson(PreferHelper.getInstance().getString(AppConstants.PreKeys.OFFLINE_COMMON_ACTION_LIST), new TypeToken<List<MemberAction>>() {
                    }.getType());

//                    sortAction(memberActions);

                    if (memberActions == null) {
                        ToastMsg.showToastMsg(BaseAppManager.appContext(), "当前无网络且没有离线数据!");
                        return;
                    }
                    if (memberActions != null && memberActions.size() >= 0) {
                        if (!isFormMain && getMvpView().isActive()) {
                            isDiscountOrNot(memberActions);
                            ((MemberActionListCon.View) getMvpView()).showActionList(isVip, memberActions, isAdditionalRecord, selectTime);
                        }
                    }
                }
            }
        });
    }

    /**
     * 按品牌排序
     *
     * @param memberActionList 活动列表
     */
    private List<MemberAction> sortAction(List<MemberAction> memberActionList) {
        wgmfmemberActions.clear();
        xdymemberActions.clear();
        memberActions.clear();
        for (MemberAction memberAction : memberActionList) {
            if (memberAction.brandType == AppConstants.BRAND.WGMF) {
                wgmfmemberActions.add(memberAction);
            } else/* if (memberAction.brandType == AppConstants.BRAND.XDY)*/ {
                xdymemberActions.add(memberAction);
            }
        }
        memberActions.addAll(wgmfmemberActions);
        memberActions.addAll(xdymemberActions);
        return memberActions;
    }


    /**
     * 查询剩余积分
     *
     * @param rulePoint ...
     * @param phoneNum  会员手机号
     */
    @Override
    public void remainsPoints(final float rulePoint, String phoneNum) {
        Call<RequestResult<Float>> call = memberActionListDataNet.remainsPoints(phoneNum);
        call.enqueue(new ResultCallback<Float>() {
            @Override
            protected void onResponseSuccess(RequestResult<Float> responseBody) {
                super.onResponseSuccess(responseBody);
                if (getMvpView().isActive()) {
                    ((MemberActionListCon.View) getMvpView()).showRemainsPoints(rulePoint, responseBody.resultInfo);
                }
            }
        });
    }


//            public static void main(String[] args) {
//                LibCoreConfig.API_URL = ApiConstants.testEnvServer;
//                MemberActionListPre memberActionListPre = new MemberActionListPre(new MemberActionListFra());
//                memberActionListPre.getActionList(false, "0110074", null, "", false);
//                memberActionListPre.getActionList(true, "0110074", "18123710721", "", false);
//                memberActionListPre.remainsPoints(2000, "18123710721");
//            }
}
