package com.wgmf.trade.presenter;


import com.urovo.wugumofang.base.AbstractFailureConsumer;
import com.urovo.wugumofang.base.AbstractSuccessfulConsumer;
import com.urovo.wugumofang.base.mvp.AbsPresenter;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.response.CommonEntity;
import com.urovo.wugumofang.utils.Transformer;
import com.wgmf.trade.model.bean.MemberDaySubscribeBean;
import com.wgmf.trade.net.CommonNet;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import io.reactivex.disposables.Disposable;

/**
 * @author chenji
 * @date 2018/5/18
 */
public class MemberDaySubscribePre extends AbsPresenter implements CommonController.CommonBasePre {
    private CommonController.BaseView<List<MemberDaySubscribeBean.ResultInfoBean>> mMemberDaySubscribeView;
    private CommonNet mMemberDaySubscribeNet;

    public MemberDaySubscribePre(CommonController.BaseView<List<MemberDaySubscribeBean.ResultInfoBean>> memberDaySubscribeView) {
        mMemberDaySubscribeView = memberDaySubscribeView;
        mMemberDaySubscribeNet = new CommonNet();
    }

    @Override
    public void onStart2RequestTask(Map<String, String> params) {
        Disposable disposable = mMemberDaySubscribeNet.getMemberDaySubscribeList(params)
                .map(new io.reactivex.functions.Function<MemberDaySubscribeBean, List<MemberDaySubscribeBean.ResultInfoBean>>() {
                    @Override
                    public List<MemberDaySubscribeBean.ResultInfoBean> apply(MemberDaySubscribeBean memberDaySubscribeBean) throws Exception {
                        if (memberDaySubscribeBean != null) {
                            if (memberDaySubscribeBean.msgCode == 0) {
                                return memberDaySubscribeBean.getResultInfo();
                            } else {
                                mMemberDaySubscribeView.onFailure(memberDaySubscribeBean.msgInfo);
                            }
                        }
                        return new ArrayList<>();
                    }
                })
                .compose(Transformer.<List<MemberDaySubscribeBean.ResultInfoBean>>switchSchedulers())
                .subscribe(new AbstractSuccessfulConsumer<List<MemberDaySubscribeBean.ResultInfoBean>>() {
                    @Override
                    protected void onSuccess(List<MemberDaySubscribeBean.ResultInfoBean> resultInfoBeans) throws Exception {
                        if (!resultInfoBeans.isEmpty()) {
                            mMemberDaySubscribeView.onResponseSuccess(new CommonEntity<>(resultInfoBeans));
                        }
                        SYLoger.print("wgmf--accept onResponseSuccess: " + resultInfoBeans);
                    }
                }, new AbstractFailureConsumer<Throwable>() {
                    @Override
                    protected void onFailure(String errorMsg) throws Exception {
                        mMemberDaySubscribeView.onFailure(errorMsg);
                        SYLoger.print("wgmf--accept onFailure: " + errorMsg);
                    }
                });
        addDisposable(disposable);
    }
}
