package com.wgmf.trade.presenter;

import android.widget.Toast;

import com.urovo.wgmf.db.dao.entitys.DingHuoOplQtyEntity;
import com.urovo.wgmf.entity.response.DingHuoQueryNewRes;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.ApiUrls;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.JsonDominator;
import com.urovo.wugumofang.net.OkHttpDominator;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.OrderSubmitReqBean;
import com.wgmf.trade.model.data.net.OrderGoodDataNet;
import com.wgmf.trade.view.OrderGoodCon;
import com.zsy.libcore.LibCoreApp;
import com.zsy.libcore.model.bean.RequestResult;
import com.zsy.libcore.model.bean.ResultCallback;

import org.jetbrains.annotations.NotNull;

import java.net.SocketTimeoutException;
import java.util.HashMap;

import okhttp3.Request;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * Created by samy on 16/12/22.
 */
public class OrderGoodPre implements OrderGoodCon.Pre {
    OrderGoodDataNet orderGoodDataNet;
    OrderGoodCon.View view;

    public OrderGoodPre(OrderGoodCon.View view) {
        this.orderGoodDataNet = RetrofitHelper.createApi(OrderGoodDataNet.class);
        this.view = view;
    }

    @Override
    public void selectOrderedList(String storeId, String beginTime, String endTime) {
//    String content = " where s.stores_no='" + storeId + "' "
//        + "  and to_char(p.wdate + interval '8 hour','yyyy-MM-dd') >= '" + beginTime
//        + "' and to_char(p.wdate + interval '8 hour','yyyy-MM-dd') <= '" + endTime
//        + "' and p.state <>'3'";
//    Call<DingHuoQueryResponse> call =
//        orderGoodDataNet.selectOrderedList(ApiUrls.MINISTRY.ActionType.QUERY_DATA,
//            ApiUrls.MINISTRY.MethodType.REQUEST_QUERY__DING_HUO, content);
//    call.enqueue(new Callback<DingHuoQueryResponse>() {
//      @Override
//      public void onResponse(Call<DingHuoQueryResponse> call,
//          Response<DingHuoQueryResponse> response) {
//        if (response.isSuccessful()) {
//          DingHuoQueryResponse dingHuoQueryResponse = response.body();
//          if (dingHuoQueryResponse.getList() != null
//              && dingHuoQueryResponse.getList().size() >= 0) {
//            if (view != null) {
//                view.showOrderedList(dingHuoQueryResponse);
//            }
//          }
//        }
//      }
//      @Override public void onFailure(Call<DingHuoQueryResponse> call, Throwable t) {
//
//      }
//    });


        //===========test==========
        ViewUtil.showProgress((BaseActivity) view, "请稍等", "正在查询订货数据...");
        DingHuoQueryNewRes res = JsonDominator.loadFromSD("DingHuoQueryNewRes", DingHuoQueryNewRes.class);
        if (res != null) {
            ViewUtil.dismissProgress();
            //......do_anything
            if (res.msgCode != 0) {
                MyToast.show(res.msgInfo);
                return;
            }
            if (res.getResultInfo() != null) {
                res.getResultInfo().size();
                if (view != null) {
                    view.showOrderedList(res);
                }
            }
            return;
        }
        ViewUtil.dismissProgress();
        ViewUtil.showProgress((BaseActivity) view, "请稍等", "正在查询订货数据...");
        HashMap<String, String> param = new HashMap<>();
        param.put("storeNo", storeId);
        param.put("beginDate", beginTime);
        param.put("endDate", endTime);
        OkHttpDominator.postAsyn(NetParam.YINXIAOBU_SERVER + ApiUrls.APP.GET_ORDER_GOODS_DETAIL, param,
                new OkHttpDominator.ResultCallback<DingHuoQueryNewRes>() {
                    @Override
                    public void onError(Request request, Exception e) {
                        ViewUtil.dismissProgress();
                        ((BaseActivity) view).showMsg(e.getMessage());
                    }

                    @Override
                    public void onResponse(DingHuoQueryNewRes response) {
                        ViewUtil.dismissProgress();
                        if (response == null) {
                            return;
                        }
                        if (response.msgCode != 0) {
                            MyToast.show(response.msgInfo);
                            view.showOrderedList(null);
                            return;
                        }
                        if (response.getResultInfo() != null
                                && response.getResultInfo().size() >= 0) {
                            if (view != null) {
                                view.showOrderedList(response);
                            }
                        }
                    }
                });


    }


    @Override
    public void isCanOrdering(final String storeId, final String userId, final boolean isSubmitOrder) {
        Call<RequestResult<String>> call = orderGoodDataNet.isCanOrdering(storeId, userId);
        call.enqueue(new Callback<RequestResult<String>>() {
            @Override
            public void onResponse(@NotNull Call<RequestResult<String>> call, @NotNull Response<RequestResult<String>> response) {
                if (response.isSuccessful()) {
                    view.showDismissAll();
                    RequestResult<String> res = response.body();
                    //Mock！！！
                    RequestResult resMock = JsonDominator.loadFromSD("isCanOrdering", RequestResult.class);
                    if (resMock != null) {
                        res = resMock;
                    }
                    //Mock End！！！
                    int msgCode = res.msgCode;
                    if (msgCode >= 0) {//进入下一步操作
                        if (isSubmitOrder) {//提交订单情况下；
                            if (view != null) {
                                view.showCanOrdering(msgCode, res.msgInfo, isSubmitOrder);
                            }
                        } else {
                            if (msgCode == 0) {
                                getOrderList(storeId, userId, SystemHelper.LoginUserBrandList);
                            } else {
                                if (view != null) {
                                    view.showCanOrdering(msgCode, res.msgInfo, isSubmitOrder);
                                }
                            }
                        }
                    } else {//弹框提示；
                        if (view != null) {
                            view.showCanOrdering(msgCode, res.msgInfo, isSubmitOrder);
                        }
                    }
                } else {
                    this.onFailure(call, new Throwable(response.errorBody().toString()));
                    view.showError(response.errorBody().toString());
                }
            }

            @Override
            public void onFailure(Call<RequestResult<String>> call, Throwable t) {
                String msgTips = "网络访问异常";
                if (t instanceof SocketTimeoutException) {
                    msgTips = "网络请求超时";
                }
                Toast.makeText(LibCoreApp.getInstance(), msgTips, Toast.LENGTH_SHORT).show();
                view.showError(msgTips);
            }
        });
    }

    @Override
    public void getOrderList(String storeId, String staffId, String brands) {
        //Mock！！！
        DingHuoOplQtyEntity mock = JsonDominator.loadFromSD(DingHuoOplQtyEntity.class);
        if (mock != null && null != view) {
            view.showOrderList(mock.resultInfo);
            return;
        }
        //Mock End！！！
        Call<RequestResult<DingHuoOplQtyEntity.ResultInfo>> call = orderGoodDataNet.getOrderList(storeId, staffId, brands);
        call.enqueue(new ResultCallback<DingHuoOplQtyEntity.ResultInfo>() {
            @Override
            protected void onResponseSuccess(RequestResult<DingHuoOplQtyEntity.ResultInfo> responseBody) {
                super.onResponseSuccess(responseBody);
                if (null != view) {
                    DingHuoOplQtyEntity.ResultInfo resultInfo = responseBody.resultInfo;
                    view.showOrderList(resultInfo);
                }
            }
        });
    }

    @Override
    public void orderSubmit(OrderSubmitReqBean orderSubmitReqBean) {
        Call<RequestResult<String>> call = orderGoodDataNet.orderSubmit(orderSubmitReqBean);
        call.enqueue(new ResultCallback<String>() {
//      @Override protected void onResponseSuccess(RequestResult<String> responseBody) {
//        super.onResponseSuccess(responseBody);
//        Toast.makeText(LibCoreApp.getInstance(), responseBody.msgInfo, Toast.LENGTH_SHORT).show();
//        if (null!=view){
//          view.showOrderSubmit();
//        }
//      }

            @Override
            public void onResponse(Call<RequestResult<String>> call, Response<RequestResult<String>> response) {
                super.onResponse(call, response);
                if (response.isSuccessful()) {
                    ViewUtil.dismissProgress();
                    RequestResult<String> res = response.body();
                    if (res != null) {
                        int msgCode = res.msgCode;
                        if (msgCode == 0) {
                            if (view != null) {
                                view.submitSuccess(res.msgInfo);
                            }
                        } else {//弹框提示；
                            if (view != null) {
                                view.showCanOrdering(msgCode, res.msgInfo, true);
                            }
                        }
                    }
                }
            }

            @Override
            public void onFailure(Call<RequestResult<String>> call, Throwable t) {
                super.onFailure(call, t);
                ViewUtil.dismissProgress();
                if (null != view) {
                    view.submitFailed("网络异常，提交失败");
                }
//        if (null!=view){
//          view.showOrderSubmit();
//        }
            }
        });
    }
}
