package com.wgmf.trade.presenter.impl;

import android.content.Context;
import android.graphics.Bitmap;
import android.view.View;
import android.widget.ImageView;

import com.nostra13.universalimageloader.core.assist.FailReason;
import com.nostra13.universalimageloader.core.listener.ImageLoadingListener;
import com.urovo.wugumofang.net.RetrofitHelper;
import com.wgmf.trade.GlobalApp;
import com.wgmf.trade.model.data.net.interactor.WXQRCodePayInt;
import com.wgmf.trade.model.data.net.interactor.impl.WXQRCodePayIntImpl;
import com.wgmf.trade.presenter.WXQRCodePayPre;
import com.wgmf.trade.view.WXBarcodePayView;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.model.bean.ResultBaseCallback;
import com.zsy.libcore.model.img.ImageLoaderHelper;
import com.zsy.libcore.presenter.impl.BasePresenterImpl;
import com.zsy.libext.widgets.tips.ToastMsg;

import java.util.HashMap;

import retrofit2.Call;
import retrofit2.Response;

/**
 * 微信二维码支付
 * Created by samy on 16/4/12.
 */
public class WXQRCodePayPreImpl extends BasePresenterImpl implements WXQRCodePayPre {
    private WXQRCodePayInt wxqrCodePayInt;
    private WXQRCodePayIntImpl wxqrCodePayIntImpl;
    private Context mContext;

    public WXQRCodePayPreImpl(Context context,WXBarcodePayView wxBarcodePayView) {
        super(wxBarcodePayView);
        this.mContext = context;
        wxqrCodePayInt = RetrofitHelper.createApi(WXQRCodePayInt.class);
        wxqrCodePayIntImpl = new WXQRCodePayIntImpl();
    }


    @Override
    public void getQRCode(final String orderNo, final ImageView imageView) {
        String temp = wxqrCodePayIntImpl.getQRCode(orderNo);
        ImageLoaderHelper.getInstance(mContext).displayImage(temp, imageView, null, new ImageLoadingListener() {
            @Override
            public void onLoadingStarted(String s, View view) {
                getMvpView().showLoading("");
            }

            @Override
            public void onLoadingFailed(String s, View view, FailReason failReason) {
                showPresenterError("网络出错啦，请点击屏幕重新加载", new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        getQRCode(orderNo,imageView);
                    }
                });
            }

            @Override
            public void onLoadingComplete(String s, View view, Bitmap bitmap) {
                getMvpView().hideLoading();
                imageView.setImageBitmap(bitmap);
            }

            @Override
            public void onLoadingCancelled(String s, View view) {

            }
        });
    }

    @Override
    public void getPayStatus(String orderNo) {
        Call<HashMap<String, String>> call = wxqrCodePayInt.getPayStatus("ofl" + orderNo);
        SYLoger.print("请求报文:URL:"+call.request().url());
        call.enqueue(new ResultBaseCallback<HashMap<String, String>>() {
            @Override
            public void onResponse(Call<HashMap<String, String>> call, Response<HashMap<String, String>> response) {
                super.onResponse(call, response);
                ToastMsg.showToastMsg(GlobalApp.getInstance(), response.body().get("desc"));
            }
        });
    }

  @Override public void start() {

  }

  public static void main(String[] args) {
    //LibCoreConfig.API_URL = ApiConstants.testEnvServer;
 /*   LibCoreConfig.API_URL = ApiConstants.releaseEnvServer;
    WXQRCodePayPreImpl wxqrCodePayPre = new Wx
    wxqrCodePayPre.getPayStatus();*/
  }
}
