package com.wgmf.trade.ui.act.index;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.urovo.activity.MemberList.model.MemberListEntity;
import com.urovo.activity.MemberProfile.view.MemberProfileAct;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.base.BaseActivity;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.net.CommonController;
import com.urovo.wugumofang.response.CommonEntity;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.ViewUtil;
import com.urovo.wugumofang.utils.MyToast;
import com.wgmf.trade.model.bean.MemberDaySubscribeBean;
import com.wgmf.trade.presenter.MemberDaySubscribePre;
import com.wgmf.trade.ui.ada.MemberDaySubscribeAda;
import com.wgmf.trade.ui.ada.MemberDaySubscribeBookAda;
import com.zsy.libcore.common.android.log.SYLoger;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;


/**
 * @author chenji
 * @date 2018/5/18
 * 预约会员日查询页面
 */
@Route(path = RouterParams.Member.MEMBER_DAY_SUBSCRIBE)
public class MemberDaySubscribeAct extends BaseActivity implements CommonController.BaseView<List<MemberDaySubscribeBean.ResultInfoBean>> {
    /**
     * 预约日期和会员人数列表
     */
    @BindView(R.id.member_day)
    RecyclerView mMemberDayRv;

    /**
     * 会员详情信息列表
     */
    @BindView(R.id.member_day_book)
    RecyclerView mMemberDayBookRv;

    /**
     * 无数据布局
     */
    @BindView(R.id.empty_root)
    View mEmptyView;

    /**
     * 左标签List的容器布局
     */
    @BindView(R.id.subLabelLayout)
    LinearLayout subLabelLayout;

    private MemberDaySubscribeAda mMemberDaySubscribeAda;
    private MemberDaySubscribeBookAda mMemberDaySubscribeBookAda;
    private Unbinder unbinder;
    private int ITEM_NUM = 7;//7个元素

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.member_day_subscribe);
        unbinder = ButterKnife.bind(this);
        //标题初始化
        initTitle();

        //先根据屏幕高度来计算每个元素的高度
        makeItemHeight();
        //初始化
        initView();
        //请求
        start2Task();
    }

    /**
     * 根据屏幕来计算每个元素的高度
     */
    private void makeItemHeight(){
        subLabelLayout.getViewTreeObserver().addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
            //默认调用两次，这里只让它执行一次回调
            boolean isFirst = true;

            @Override
            public void onGlobalLayout() {
                if (isFirst) {
                    isFirst = false;
                    int itemHeight = subLabelLayout.getMeasuredHeight() / ITEM_NUM ;//计算每个元素高度
                    mMemberDaySubscribeAda = new MemberDaySubscribeAda(MemberDaySubscribeAct.this, itemHeight,null);
                    initRv(mMemberDayRv,mMemberDaySubscribeAda);
                    mMemberDaySubscribeAda.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
                        @Override
                        public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
                            //设置左边列表text的颜色
                            mMemberDaySubscribeAda.setItemSel(position);
                            MemberDaySubscribeBean.ResultInfoBean resultInfoBean = (MemberDaySubscribeBean.ResultInfoBean) baseQuickAdapter.getData().get(position);
                            if (resultInfoBean.getBookList() == null || resultInfoBean.getBookList().isEmpty()) {
                                View notDataView = getLayoutInflater().inflate(R.layout.layout_empty_date_view, (ViewGroup) mMemberDayBookRv.getParent(), false);
                                ((TextView) notDataView.findViewById(R.id.empty_view)).setText("暂无预约会员名单！");
                                mMemberDaySubscribeBookAda.setEmptyView(notDataView);
                                mMemberDaySubscribeBookAda.replaceData(new ArrayList<MemberDaySubscribeBean.ResultInfoBean.BookListBean>());
                            } else {
                                mMemberDaySubscribeBookAda.replaceData(resultInfoBean.getBookList());
                            }
                        }
                    });
                }
            }
        });
    }

    private void initView() {
        //列表初始化
//        initRv(mMemberDayRv, mMemberDaySubscribeAda = new MemberDaySubscribeAda(this, null));
        initRv(mMemberDayBookRv, mMemberDaySubscribeBookAda = new MemberDaySubscribeBookAda(null));

//        mMemberDaySubscribeAda.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
//            @Override
//            public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
//                //设置左边列表text的颜色
//                mMemberDaySubscribeAda.setItemSel(position);
//                MemberDaySubscribeBean.ResultInfoBean resultInfoBean = (MemberDaySubscribeBean.ResultInfoBean) baseQuickAdapter.getData().get(position);
//                if (resultInfoBean.getBookList() == null || resultInfoBean.getBookList().isEmpty()) {
//                    View notDataView = getLayoutInflater().inflate(R.layout.layout_empty_date_view, (ViewGroup) mMemberDayBookRv.getParent(), false);
//                    ((TextView) notDataView.findViewById(R.id.empty_view)).setText("暂无预约会员名单！");
//                    mMemberDaySubscribeBookAda.setEmptyView(notDataView);
//                    mMemberDaySubscribeBookAda.replaceData(new ArrayList<MemberDaySubscribeBean.ResultInfoBean.BookListBean>());
//                } else {
//                    mMemberDaySubscribeBookAda.replaceData(resultInfoBean.getBookList());
//                }
//            }
//        });

        mMemberDaySubscribeBookAda.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter baseQuickAdapter, View view, int position) {
//                MyToast.show("mMemberDaySubscribeBookAda onItemChildClick");
                MemberDaySubscribeBean.ResultInfoBean.BookListBean bookListBean = (MemberDaySubscribeBean.ResultInfoBean.BookListBean) baseQuickAdapter.getData().get(position);

                Intent intent = new Intent(MemberDaySubscribeAct.this, MemberProfileAct.class);
                MemberListEntity entity = new MemberListEntity();
                entity.buyDate = bookListBean.getLastBuyDate();
                entity.customerMobile = bookListBean.getMobile();

                entity.customerName = "--";//后台都没传
                entity.hasCommunication = "0";
                entity.phoneCare = "0";
                entity.shareCare = "0";
                entity.smsCare = "0";
                entity.wechatCare = "0";
                entity.type = "1";//默认传1获取全部数据


                intent.putExtra("phone", bookListBean.getMobile());
                intent.putExtra("position", position);
                intent.putExtra("entity", entity);
                intent.putExtra("careType", "3");//关怀类型 默认1新客三响炮 2积分到期提醒 3砖石会员
                intent.putExtra("isShowCareTools",false);//底栏关怀工具栏，不让它显示，因为这里不需要关怀
//                startActivityForResult(intent, 1);
                startActivity(intent);
//                ToActivity.toActivity(MemberDaySubscribeAct.this,MemberProfileAct.class);
            }
        });
    }

    private void start2Task() {
        ViewUtil.showProgress(this, "正在玩命加载...", "请稍等...");
        MemberDaySubscribePre memberDaySubscribePre = new MemberDaySubscribePre(this);
        Map<String, String> params = new HashMap<>(1);
        params.put("shopId", SystemHelper.LoginOrganId);
        memberDaySubscribePre.onStart2RequestTask(params);
    }

    private void initRv(RecyclerView rv, BaseQuickAdapter ada) {
        rv.setHasFixedSize(true);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this, LinearLayoutManager.VERTICAL, false);
        rv.setLayoutManager(layoutManager);
        rv.setAdapter(ada);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        titleTextView.setText("会员日预约名单");
    }

    @Override
    protected void onDestroy() {
        if (unbinder != null) {
            unbinder.unbind();
        }
        super.onDestroy();
    }

    @Override
    public void onResponseSuccess(CommonEntity<List<MemberDaySubscribeBean.ResultInfoBean>> resultInfo) {
        SYLoger.print(resultInfo.entity.toString());
        ViewUtil.dismissProgress();
        if (resultInfo.entity == null || resultInfo.entity.isEmpty()) {
            mEmptyView.setVisibility(View.VISIBLE);
        } else {
            //左边列表第一次加载数据
            mEmptyView.setVisibility(View.GONE);
            mMemberDaySubscribeAda.replaceData(resultInfo.entity);
        }

        //右边列表默认加载第一个
        if (resultInfo.entity.get(0) == null || resultInfo.entity.get(0).getBookList() == null || resultInfo.entity.get(0).getBookList().isEmpty()) {
            View notDataView = getLayoutInflater().inflate(R.layout.layout_empty_date_view, (ViewGroup) mMemberDayBookRv.getParent(), false);
            ((TextView) notDataView.findViewById(R.id.empty_view)).setText("暂无预约会员名单！");
            mMemberDaySubscribeBookAda.setEmptyView(notDataView);
            //因为默认初始是没有数据的,如果走到这里的逻辑,不需要去replaceDate(new ArrayList<MemberDaySubscribeBean.ResultInfoBean.BookListBean>())
        } else {
            mMemberDaySubscribeBookAda.replaceData(resultInfo.entity.get(0).getBookList());
        }
    }

    @Override
    public void onFailure(String failInfo) {
        ViewUtil.dismissProgress();
        SYLoger.print(failInfo);
        MyToast.show(failInfo);
    }
}
