package com.wgmf.trade.ui.ada;

import android.annotation.SuppressLint;
import android.content.Context;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.appcompat.app.AlertDialog;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.data.Arith;
import com.urovo.wugumofang.data.MoneyUtils;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.EditTextDecimal;
import com.wgmf.trade.model.bean.ProductInfoBean;
import com.wgmf.trade.utils.VerifyUtil;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libcore.ui.ada.ViewHolder;

import java.util.List;
import java.util.Locale;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * 活动主页中；操作选择的Item；（鲜稻研品牌专用 ）现在是两个品牌共用了
 * 其实是从MemberSalesAda.java抄过来改的。。
 *
 * @author Sasuke on 2017/12/13.
 */

public class MemberSalesXdyAda extends BaseMemberSalesAda {
    private BaseMemberSalesAda.SaleAdaCallBack saleAdaCallBack;
    private List<ProductInfoBean> dataSet;
    private Context context;

    public MemberSalesXdyAda(Context context, List<ProductInfoBean> dataSet, BaseMemberSalesAda.SaleAdaCallBack saleAdaCallBack) {
        super(context, dataSet, 0);
        this.context = context;
        this.saleAdaCallBack = saleAdaCallBack;
        this.dataSet = dataSet;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        //先判断是不是五谷磨房产品。
//        if(dataSet.get(position).getBrand() == SystemHelper.WgmfBrand){
         if(!dataSet.get(position).isDecimal()){
             //如果是会员商品。

             if (dataSet.get(position).getBrand().equals(SystemHelper.MemGoodsBrand)){
                 convertView = LayoutInflater.from(mContext).inflate(R.layout.item_pro_selected_memgoods, null);
             }else{//如果不是会员商品，而是正常的五谷磨房产品。
                 // （注：为了跟上面的memgoods的布局保持一致，毕竟用的同一个Holder，所以这里也加了一个gone的stockTv）
                 convertView = LayoutInflater.from(mContext).inflate(R.layout.item_pro_selected, null);
             }
            ViewHolderZero holder = new ViewHolderZero(convertView);
            setItemDataZero(holder, getItem(position));
        }
        //保留小数点
        else {
            convertView = LayoutInflater.from(mContext).inflate(R.layout.item_pro_selected_xdy, null);
            ViewHolderTwo holder = new ViewHolderTwo(convertView);
            setItemDataTwo(holder, getItem(position));
        }
        return convertView;
    }

    /**
     * 因公用性,不在这里处理；
     *
     * @param viewHolder      ...
     * @param productInfoBean ...
     */
    @Override
    public void bindDataToItemView(ViewHolder viewHolder, ProductInfoBean productInfoBean) {

    }

    private void setItemDataZero(final ViewHolderZero holder, final ProductInfoBean productInfoBean){
        SYLoger.print("条码打印 活动：productInfoBean.num: "+productInfoBean.num);
        final double[]  ruleArr = productInfoBean.getProNumMinAndMax(productInfoBean.num);
        holder.proNameTv.setText(productInfoBean.name);
        //初始化显示数据
        holder.proOptEt.setText(String.format("%s", (int) productInfoBean.getProNum()));
        //赠品时，没有价格
        holder.proPriceTv.setText(String.format("￥%s", MoneyUtils.twolastDF(productInfoBean.getAmountActual())));
        //库存
        holder.stockTv.setText("库存:" + productInfoBean.getStockQty());
//        holder.proSelectedLl.setOnClickListener(new View.OnClickListener() {
////            @Override public void onClick(View v) {
////                //现在通过点击重新选择的按钮了，不需要点击item了
//////                saleAdaCallBack.itemClick(productInfoBean);
////            }
////        });
        holder.proOptSubIb.setOnClickListener(new View.OnClickListener() {
            @Override public void onClick(View v) {
                double tempEditBuyNum = Double.parseDouble(holder.proOptEt.getText().toString());
                tempEditBuyNum--;
                holder.proOptEt.setText(MoneyUtils.nolastDF( tempEditBuyNum));

            }
        });
        holder.proOptAddIb.setOnClickListener(new View.OnClickListener() {
            @Override public void onClick(View v) {
                double tempEditBuyNum = Double.parseDouble(holder.proOptEt.getText().toString());
                tempEditBuyNum++;
                holder.proOptEt.setText(MoneyUtils.nolastDF( tempEditBuyNum));

            }
        });
        //holder.proOptEt.selectAll();
        holder.proOptEt.addTextChangedListener(new TextWatcher() {
            @Override public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override public void afterTextChanged(Editable s) {
                itemOperShowZero(s.toString(), holder,productInfoBean ,ruleArr);
            }
        });

        checkInputOperate(holder, productInfoBean, ruleArr);
    }

    private void itemOperShowZero(String temp, ViewHolderZero holder, ProductInfoBean productInfoBean, double[] ruleArr) {
        double minCount = ruleArr[0];
        double maxCount = ruleArr[1];
        double tempEditBuyNum=0;
        setEnable(holder.proOptEt,true);
        if (!TextUtils.isEmpty(temp)){
            tempEditBuyNum = Double.parseDouble(temp.toString());
            if (tempEditBuyNum < minCount) {
                tempEditBuyNum = minCount;
                holder.proOptEt.setText(MoneyUtils.nolastDF( tempEditBuyNum));
                setEnable(holder.proOptSubIb,false);
                setEnable(holder.proOptAddIb,true);
            } else if (tempEditBuyNum == minCount) {
                setEnable(holder.proOptSubIb,false);
                setEnable(holder.proOptAddIb,true);
            } else if (tempEditBuyNum > maxCount) {
                tempEditBuyNum = maxCount;
                holder.proOptEt.setText(MoneyUtils.nolastDF(tempEditBuyNum));
                setEnable(holder.proOptSubIb,true);
                setEnable(holder.proOptAddIb,false);
            } else if (tempEditBuyNum == maxCount) {
                setEnable(holder.proOptSubIb,true);
                setEnable(holder.proOptAddIb,false);
            } else if (productInfoBean.isOverMemStock(tempEditBuyNum)) {//如果输入的数量大于库存
                holder.proOptEt.setText(MoneyUtils.nolastDF(Double.parseDouble(productInfoBean.getStockQty())));//还原
                setEnable(holder.proOptSubIb,true);
                setEnable(holder.proOptAddIb,false);
                //会员商品录入数量不允许超过库存数量
                new AlertDialog.Builder(context)
                        .setMessage("录入数量不允许超过库存数量")
                        .setPositiveButton("我知道了",null)
                        .show();
            } else {
                //表示有，和数字情况下；再去校验；
                if (ruleArr[2]==1){
                    //不符合规则直接最大值；
                    if(!VerifyUtil.compareNum(productInfoBean.num,tempEditBuyNum)){
                        tempEditBuyNum = minCount;
                        holder.proOptEt.setText(MoneyUtils.nolastDF( tempEditBuyNum));
                    }
                }
                setEnable(holder.proOptSubIb,true);
                setEnable(holder.proOptAddIb,true);
            }
        }else {
            holder.proOptEt.setText(MoneyUtils.nolastDF( minCount));
        }
        //更新内存数据;方便提交数据判断用; 这里千万不能用final修饰的处理；
        productInfoBean.setProNum(Double.parseDouble(holder.proOptEt.getText().toString()));
        saleAdaCallBack.updatePriceData();
//        checkInputOperate(holder, productInfoBean, ruleArr);
        //赠品时，没有价格
        holder.proPriceTv.setText(String.format("￥%s", MoneyUtils.twolastDF(productInfoBean.getAmountActual())));
    }



    private void checkInputOperate(BaseViewHolder holder, ProductInfoBean productInfoBean, double[] ruleArr) {
        //组合商品+规则
        if (productInfoBean.getProType() == 1 || ruleArr[2] == 1) {
            setEnable(holder.proOptEt, true);
            setEnable(holder.proOptSubIb, false);
            setEnable(holder.proOptAddIb, false);
            if (productInfoBean.getProType() == 1) {
                setEnable(holder.proOptEt, false);
            }
        }
    }

    private void checkInputXdyOperate(ViewHolderTwo holder, ProductInfoBean productInfoBean, double[] ruleArr) {
        //组合商品+规则
//        if (productInfoBean.getProType() == 1 || ruleArr[2] == 1) {
//            setEnable(holder.proOptEt, true);
//            setEnable(holder.proOptSubIb, false);
//            setEnable(holder.proOptAddIb, false);
            if (productInfoBean.getProType() == 1) {
                holder.proAmountEdit.setFocusable(false);
            }
//        }
    }


    @SuppressLint("SetTextI18n")
    private void setItemDataTwo(final MemberSalesXdyAda.ViewHolderTwo holder, final ProductInfoBean productInfoBean) {
        final double[]  ruleArr = productInfoBean.getProNumMinAndMax(productInfoBean.num);
        holder.proNameXdyTv.setText(productInfoBean.name);
        holder.tvPricePerKgTv.setText(String.format("%s元/" + productInfoBean.getKCUom(), MoneyUtils.twolastDF(productInfoBean.getPrice())));
        //这个地方kg数需要重新计算，要保证Amount是用户输入的精确值，而不是计算得到的，计算后会产生误差
        holder.kgTv.setText(String.format("×%s", MoneyUtils.twolastDF(Arith.div(productInfoBean.getAmount(), productInfoBean.getPrice()))));
        holder.proAmountEdit.setText(MoneyUtils.twolastDF(productInfoBean.getAmount()));
//        holder.proAmountEdit.setOnTouchListener(new View.OnTouchListener() {
//            @Override //造成点击穿透，使编辑失效，并激起proSelectedXdyLI的整个布局的点击事件，从而直接跳转。
//            public boolean onTouch(View v, MotionEvent event) {
//                if (event.getAction() == MotionEvent.ACTION_UP){
//                    holder.proSelectedXdyLl.performClick();
//                }
//                return true;
//            }
//        });
        holder.proAmountEdit.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                //刷新item显示
                itemOderShowTwo(s.toString(), holder, productInfoBean, holder.proAmountEdit);
            }
        });
        holder.proSelectedXdyLl.setOnClickListener(new View.OnClickListener() {
            @Override public void onClick(View v) {
                saleAdaCallBack.itemClick(productInfoBean);
            }
        });
        checkInputXdyOperate(holder, productInfoBean, ruleArr);
    }

    private void itemOderShowTwo(String amountStr, MemberSalesXdyAda.ViewHolderTwo holder, ProductInfoBean productInfoBean, EditText amountEdit) {
        //现在这里不是数量，而是金额，金额是用来输入的
        Double price = productInfoBean.getPrice();

        Double kg = 0.00;
        Double amount = 0.0;

        if (!TextUtils.isEmpty(amountStr) && !amountStr.equals(".")) {
            //获得金额
            amount = Double.parseDouble(amountStr);
        } else {
            amount = 0.00;
        }

        //通过以上的限制，把amount回复到规定范围，变化完成，接下来改变金额
        //保留啥小数保留，不保留不保留，就显示的时候保留一下，就把一大串的kg数丢给后台
        kg = Arith.div(amount, price);
        productInfoBean.setProNum(kg);
        productInfoBean.Amount = amount;
        //下面这两位一起改变数值
        //重量
        holder.kgTv.setText(String.format("×%s", String.format(Locale.CHINA, "%.2f", kg)));
        saleAdaCallBack.updatePriceData();
    }

    static class BaseViewHolder {
        @BindView(R.id.pro_opt_et) EditText proOptEt;
        @BindView(R.id.pro_opt_sub_ib)  ImageButton proOptSubIb;
        @BindView(R.id.pro_opt_add_ib) ImageButton proOptAddIb;

        BaseViewHolder(View view) {
            ButterKnife.bind(this, view);
        }
    }

    static class ViewHolderOne extends BaseViewHolder {
        @BindView(R.id.pro_selected_mix_ll) LinearLayout proSelectedLl;
        @BindView(R.id.pro_name_tv) TextView proNameTv;
        @BindView(R.id.pro_opt_ll) LinearLayout proOptLl;
        @BindView(R.id.tv_price_per_kg) TextView tvPricePerKgTv;
        @BindView(R.id.tv_num) TextView numTv;

        ViewHolderOne(View view) {
            super(view);
            ButterKnife.bind(this, view);
        }
    }

    static class ViewHolderTwo {
        /**
         * 鲜稻研用的 item父布局
         */
        @BindView(R.id.pro_selected_xdy_ll)
        LinearLayout proSelectedXdyLl;
        /**
         * 鲜稻研用的 产品名称
         */
        @BindView(R.id.pro_name_xdy_tv)
        TextView proNameXdyTv;
        /**
         * 鲜稻研用的 单价
         */
        @BindView(R.id.tv_price_per_kg)
        TextView tvPricePerKgTv;
        /**
         * 鲜稻研用的 产品重量
         */
        @BindView(R.id.tv_kg)
        TextView kgTv;
        /**
         * 鲜稻研用的可输入的总价格
         */
        @BindView(R.id.pro_opt_xdy_et)
        EditTextDecimal proAmountEdit;

        ViewHolderTwo(View view) {
            ButterKnife.bind(this, view);
        }
    }

    static class ViewHolderZero extends BaseViewHolder  {
        @BindView(R.id.pro_selected_ll) LinearLayout proSelectedLl;
        @BindView(R.id.pro_name_tv) TextView proNameTv;
        @BindView(R.id.pro_opt_ll) LinearLayout proOptLl;
        @BindView(R.id.pro_price_tv) TextView proPriceTv;
        @BindView(R.id.stockTv) TextView stockTv;//库存

        ViewHolderZero(View view) {
            super(view);
            ButterKnife.bind(this, view);
        }
    }

    private void setEnable(View v, Boolean isEnable) {
        v.setEnabled(isEnable);
        v.setClickable(isEnable);
    }
}
