package com.wgmf.trade.ui.ada.base;

import com.zsy.libext.ui.fra.BaseFra;

import java.util.List;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentPagerAdapter;

/**
 * 处理多个不同Fragment情况滑动
 */
public class ContainerPagerAda extends FragmentPagerAdapter {
  private List<BaseFra> mFragments;
  private List<String> mFragmentTitles;

  public ContainerPagerAda(FragmentManager fm, List<BaseFra> fragments, List<String> titles) {
    super(fm);
    this.mFragments = fragments;
    this.mFragmentTitles = titles;
  }

  @Override public Fragment getItem(int position) {
    if (mFragments != null && position > -1 && position < mFragments.size()) {
      return mFragments.get(position);
    } else {
      return null;
    }
  }

  @Override public int getCount() {
    return null != mFragments ? mFragments.size() : 0;
  }

  @Override public CharSequence getPageTitle(int position) {
    return mFragmentTitles.get(position);
  }
}
