package com.wgmf.trade.ui.fra.index;

import android.app.DatePickerDialog;
import android.view.View;
import android.widget.DatePicker;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.system.SystemHelper;
import com.wgmf.trade.view.AdditionalRecordCon;
import com.zsy.libext.ui.fra.BaseFra;
import com.zsy.libext.widgets.tips.ToastMsg;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

import androidx.annotation.NonNull;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;

/**
 * 销售补录
 * Created by samy on 16/10/19.
 */
public class AdditionalRecordFra extends BaseFra<AdditionalRecordCon.Pre>
        implements AdditionalRecordCon.View {
    @BindView(R.id.selected_time_tv)
    TextView selectedTimeTv;
    @BindView(R.id.select_time_rl)
    RelativeLayout selectTimeRl;
    String selectTime;

    private AdditionalRecordCon.Pre additionalRecordPre;

    private SelectTimeCallback selectTimeCallback;

    public static AdditionalRecordFra newInstance() {
        return new AdditionalRecordFra();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    Unbinder unbinder;
    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this,view);
        baseAct.commonToolbar.setTitle("销售补录");

        Calendar ca = Calendar.getInstance();
        int day = ca.get(Calendar.DATE);
        ca.set(Calendar.DATE, day - 1);
        Date d = ca.getTime();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA);
        selectTime = sdf.format(d);
        selectedTimeTv.setText(selectTime);
        additionalRecordPre.getStoreCheckState(SystemHelper.LoginUserId, selectTime);
    }

    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_additional_record;
    }

    @Override
    public void showLoading(String s) {
        //super.showLoading(s);
    }

    @Override
    public void showError(String msg, View.OnClickListener onClickListener) {
        //super.showError(msg, onClickListener);

    }

    @OnClick(R.id.select_time_rl)
    public void selectTimeRl() {
        Calendar ca = Calendar.getInstance();
        int day = ca.get(Calendar.DATE);
        ca.set(Calendar.DATE, day - 1);
        DatePickerDialog datePicker =
                new DatePickerDialog(getActivity(), new DatePickerDialog.OnDateSetListener() {
                    @Override
                    public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
                        String month;
                        String day;
                        if (monthOfYear + 1 < 10) {
                            month = "0" + (monthOfYear + 1);
                        } else {
                            month = "" + (monthOfYear + 1);
                        }
                        if (dayOfMonth < 10) {
                            day = "0" + dayOfMonth;
                        } else {
                            day = "" + dayOfMonth;
                        }
                        selectTime = year + "-" + month + "-" + day;
                        selectedTimeTv.setText(selectTime);
                        try {
                            Date date = new Date();
                            Date dateNow = new Date(date.getYear() + 1900, date.getMonth(), date.getDate());
                            Date dateBuLu = new Date(year, monthOfYear, dayOfMonth);
                            if (dateBuLu.compareTo(dateNow) >= 0) {
                                selectedTimeTv.setText(String.format("%s(您选择的时间不允许补录！)", selectTime));
                                showChangeState(true);
                                return;
                            }
                        } catch (Exception e) {
                            BaseAppManager.loger().info(e);
                        }
                        additionalRecordPre.getStoreCheckState(SystemHelper.LoginOrganId, selectTime);
                    }
                }, ca.get(Calendar.YEAR), ca.get(Calendar.MONTH), ca.get(Calendar.DAY_OF_MONTH));
        datePicker.show();
    }

    @Override
    public void setPresenter(@NonNull AdditionalRecordCon.Pre pre) {
        additionalRecordPre = pre;
    }

    @Override
    public void showChangeState(boolean isHideListAndBtnUnable) {
        ToastMsg.showToastMsg(mContext, isHideListAndBtnUnable ? "所选日期已审核,不允许补录" : "所选日期未审核,可以补录");
        //selectTimeCallback.changeListShowAndBtnAble(selectTime,isHideListAndBtnUnable);
        selectTimeCallback.changeListShowAndBtnAble(selectTime.replace("-", ""), isHideListAndBtnUnable);
    }

    public void setSelectTimeCallback(SelectTimeCallback selectTimeCallbackTemp) {
        this.selectTimeCallback = selectTimeCallbackTemp;
    }


    interface SelectTimeCallback {
        void changeListShowAndBtnAble(String selectTime, boolean isHideListAndBtnUnable);
    }

}
