package com.wgmf.trade.ui.fra.index

import android.app.AlertDialog
import android.app.DatePickerDialog
import android.os.Bundle
import android.widget.DatePicker
import android.widget.TextView
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.data.DateUtil
import com.urovo.wugumofang.system.SystemHelper
import com.urovo.wugumofang.ui.ViewUtil
import com.urovo.wugumofang.ui.setTextAlpha
import com.urovo.wugumofang.utils.NumberUtil
import com.wgmf.trade.presenter.ExchangeReasonPre
import com.wgmf.trade.view.ExchangeReasonCon
import kotlinx.android.synthetic.main.ll_exchange_reason.*
import java.text.SimpleDateFormat
import java.util.*

/**
 * Created by Sasuke on 2017/7/4.
 * 积分兑换撤销  理由界面
 */

class ExchangeReasonAct : BaseActivity() ,ExchangeReasonCon.View{
    companion object  {
        @JvmStatic
        val INTENT_DATE = "INTENT_DATE"
        @JvmStatic
        val INTENT_EXCHID = "INTENT_EXCHID"
    }

    lateinit var pre: ExchangeReasonPre
    val billNo = "C"+ SystemHelper.LoginOrganId+ DateUtil.format(Date(), "yyMMddHHmmss")+NumberUtil.generateRandom(4)

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ll_exchange_reason)
        initTitle()
        titleTextView.text = "兑换撤销"
        pre = ExchangeReasonPre(this)
        pre.start()
    }

    override fun init() {
        reasonPicker.text = intent.getStringExtra(INTENT_DATE)
        val c: Calendar = Calendar.getInstance()
        checkDate(reasonPicker.text.toString())

        reasonPicker.setOnClickListener {
            v ->DatePickerDialog(this, object : DatePickerDialog.OnDateSetListener {
                        internal val mDate = Date()
                        override fun onDateSet(view: DatePicker, year: Int, monthOfYear: Int, dayOfMonth: Int) {
                            mDate.year = year - 1900
                            mDate.month = monthOfYear
                            mDate.date = dayOfMonth
                            (v as TextView).text = "正在校验...."
                            checkDate( SimpleDateFormat("yyyy-MM-dd").format(mDate))
                }
            }, c.get(Calendar.YEAR), c.get(Calendar.MONTH), c.get(Calendar.DAY_OF_MONTH)).show()
        }

        submitReason.setOnClickListener{
            when(reasonInput.text.toString()){
                     ""   -> showMsg("请输入撤销兑换原因！")
                    else -> pre.pointExchangeCancel(intent.getStringExtra(INTENT_EXCHID)?:"",
                                                                        reasonPicker.text.toString(),
                                                                        billNo,
                                                                        SystemHelper.LoginUserId,reasonInput.text.toString())
        }

        }
    }

    override fun showAlert(msg: String) {
        if (!isFinishing){
            AlertDialog.Builder(this).setTitle("注意")
                    .setMessage(msg)
                    .setPositiveButton("确定",null)
                    .create().show();
        }
    }

    /**
     * 恢复到当天日期
     */
    override fun showDate(date: String) {
        if(!this.isFinishing) {
            setTextAlpha(reasonPicker,date)
            reasonPicker.isClickable = true
            submitReason.isEnabled = true
        }
    }

    /**
     * 联网验证日期是否可撤销兑换
     */
    fun checkDate(date: String){
        if(!this.isFinishing) {
            reasonPicker.text = "正在校验...."
            reasonPicker.isClickable = false
            submitReason.isEnabled = false
            pre.queryIsChecked(date)
        }
    }

    override fun successAndFinish(){
        if(!this.isFinishing){
            showMsg("撤销成功")
            finish()
        }
    }

    override fun showProgress(msg: String) {
        ViewUtil.showProgress(this,"请稍等",msg, false)
    }

    override fun dismissProgress() {
        ViewUtil.dismissProgress()
    }

    override fun setPresenter(presenter: ExchangeReasonCon.Pre?) {
        this.pre = presenter as ExchangeReasonPre
    }
}
