package com.wgmf.trade.ui.fra.index;

import android.content.Intent;
import android.graphics.Paint;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.text.Html;
import android.text.TextUtils;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.urovo.activity.customerlabel.CustomerLabelActivity;
import com.urovo.activity.customerlabel.model.CustomerLabelDetailEntity;
import com.urovo.activity.home.EditDetailActivity;
import com.urovo.activity.slidemenu.JifenMingXiActivity;
import com.urovo.activity.slidemenu.XiaoFeiActivity;
import com.urovo.wgmf.entity.response.WeiXinJiaFenResponse;
import com.urovo.wgmf.view.PublicPictureDialog;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.urovo.wugumofang.constants.AppRetCodeMap;
import com.urovo.wugumofang.constants.NetParam;
import com.urovo.wugumofang.data.PrefHistoryUtil;
import com.urovo.wugumofang.system.SystemHelper;
import com.urovo.wugumofang.ui.DialogHelper;
import com.urovo.wugumofang.view.webview.BaseCookiesWebFra;
import com.wgmf.trade.model.bean.MemberInfo;
import com.wgmf.trade.utils.ImageLoader;
import com.wgmf.trade.utils.IntentUtil;
import com.wgmf.trade.view.MemberDetailCon;
import com.zsy.libcore.common.android.log.SYLoger;
import com.zsy.libext.ui.fra.BaseFra;
import com.zsy.libext.widgets.tips.ToastMsg;

import java.text.MessageFormat;
import java.util.List;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

import static com.urovo.wugumofang.R.id.customer_grade_tv;

/**
 * 会员主页 头部  会员详情
 *
 * @author samy
 * @date 16/9/7
 * ps: 会员主页优化
 * ps:  1.1--> http://test.wgmf.com/app/information/getCustomerInfo?customerMobile=15710758608
 * ps:  1.2--> http://192.168.5.221/project/zhaoxz-sheng-yi-guan-jia/us/1818?milestone=85
 * ps:  原型图:https://pro.modao.cc/app/7e94e542e6a9ecd14a85e9e5b10bddfa84f8a4c5#screen=sB208A809101517215748006
 */
public class MemberDetailFra extends BaseFra<MemberDetailCon.Pre> implements MemberDetailCon.View {
    @BindView(R.id.customer_grade_tv)
    TextView customerGradeTv;
    @BindView(R.id.member_icon_iv)
    ImageView memberIconIv;
    @BindView(R.id.member_labels)
    TextView mMemberLabels;
    @BindView(R.id.customer_name_rl)
    RelativeLayout customerNameRl;
    @BindView(R.id.customer_name_tv)
    TextView customerNameTv;
    @BindView(R.id.update_tv)
    TextView updateTv;
    @BindView(R.id.phone_num_tv)
    TextView phoneNumTv;
    @BindView(R.id.valid_point_tv)
    TextView validPointTv;
    @BindView(R.id.is_new_wemember_tv)
    TextView isNewWeMember;//是否是新客微会员
    @BindView(R.id.join_group_tv)
    TextView joinGroupTv;
    @BindView(R.id.join_group_btn)
    TextView joinGroupBtn;
    @BindView(R.id.last_buy_product_tv)
    TextView lastBuyProductTv;
    @BindView(R.id.member_last_buy_product_tv)
    TextView mMemberLastBuyProductTv;
    @BindView(R.id.last_buy_datetime_tv)
    TextView lastBuyDatetimeTv;
    @BindView(R.id.member_last_buy_datetime_tv)
    TextView mMemberLastBuyDatetimeTv;
    @BindView(R.id.user_feature_tv)
    TextView userFeatureTv;
    @BindView(R.id.buy_use_tv)
    TextView bugUseTv;
    @BindView(R.id.last_buy_ll)
    LinearLayout lastBuyLl;
    @BindView(R.id.member_last_buy_ll)
    LinearLayout mMemberLastBuyLl;
    @BindView(R.id.customer_label_info_ll)
    LinearLayout customerLableInfoLl;
    @BindView(R.id.customer_label_ll)
    LinearLayout customerLabelLl;
    /**
     * 顾客标签数据
     */
    private CustomerLabelDetailEntity mCustomerLabelDetailEntity = null;
    /**
     * 手机号
     */
    private String phoneNum;
    /**
     * 加群地址
     */
    private String mGroupUrl;
    /**
     * 是否显示距离上次购买
     */
    private boolean isLastBuyShow;
    /**
     * 是否显示顾客标签
     */
    private boolean isCustomerLabelShow;

    private MemberDetailCon.Pre memberDetailPre;

    private boolean isDialogStatus = false;

//    private MemberInfo memberInfo;

//  private int hasBuyBazhen = 0;//是否买过八珍（默认没买过）
//  private int hasBuyNewBazhen = 0;//是否买过新八珍（植物益生元八珍）

    public static MemberDetailFra newInstance(String phoneNum, boolean isLastBuyShow, boolean isCustomerLabelShow, boolean isDialogStatus) {
        Bundle arguments = new Bundle();
        arguments.putString(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
        arguments.putBoolean("isLastBuyShow", isLastBuyShow);
        arguments.putBoolean("isCustomerLabelShow", isCustomerLabelShow);
        arguments.putBoolean("isDialogStatus", isDialogStatus);
        MemberDetailFra fragment = new MemberDetailFra();
        fragment.setArguments(arguments);
        return fragment;
    }

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        phoneNum = extras.getString(AppConstants.ExtraKeys.PHONE_NUM);
        isLastBuyShow = extras.getBoolean("isLastBuyShow", true);
        isCustomerLabelShow = extras.getBoolean("isCustomerLabelShow", false);
        isDialogStatus = extras.getBoolean("isDialogStatus", true);
    }

    Unbinder unbinder;

    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this, view);
        lastBuyLl.setVisibility(isLastBuyShow ? View.VISIBLE : View.GONE);
        if (isCustomerLabelShow) {
            customerLableInfoLl.setOnClickListener(this);
            customerLabelLl.setOnClickListener(this);
            customerLableInfoLl.setVisibility(View.VISIBLE);
            customerLabelLl.setVisibility(View.VISIBLE);
        } else {
            customerLableInfoLl.setVisibility(View.GONE);
            customerLabelLl.setVisibility(View.GONE);
        }
        lastBuyLl.setOnClickListener(this);
        mMemberLastBuyLl.setOnClickListener(this);
        customerGradeTv.setOnClickListener(this);
        customerNameRl.setOnClickListener(this);
        phoneNumTv.setOnClickListener(this);
        validPointTv.setOnClickListener(this);
        joinGroupBtn.setOnClickListener(this);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        //        底部加横线：
        updateTv.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG);
        //        中间加横线
//        updateTv .getPaint().setFlags(Paint. STRIKE_THRU_TEXT_FLAG );

    }

    @Override
    public void onResume() {
        super.onResume();
        //修改资料后，还得更新数据；其实也可以把值带过来
        if (!TextUtils.isEmpty(phoneNum)) {
            memberDetailPre.getMemberInfo(SystemHelper.LoginUserId, SystemHelper.LoginOrganId, phoneNum);
            //获得TA是不是新客微会员
            //memberDetailPre.getWeiXibJiaFen(""
            //        , phoneNum
            //        , SystemHelper.LoginUserId
            //        , SystemHelper.LoginOrganId);

            if (isCustomerLabelShow) {
                //获取标签数据
                memberDetailPre.getLabelListDetail(phoneNum);
            }
        }
    }

    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.fra_member_detail;
    }

    @Override
    public void showIsWeMember(WeiXinJiaFenResponse.InnerClass weInfo) {
        refreshIsNewWeMember(weInfo);
    }

    @Override
    public void showLabelListDetail(CustomerLabelDetailEntity entity) {
        if (entity != null) {
            this.mCustomerLabelDetailEntity = entity;
            List<CustomerLabelDetailEntity.LabelBean> characteristicsLabelDetailList = entity.component2();
            if (characteristicsLabelDetailList != null) {
                StringBuilder label = new StringBuilder();
                for (CustomerLabelDetailEntity.LabelBean bean : characteristicsLabelDetailList) {
                    label.append(bean.getLabelName()).append("，");
                }
                label.delete(label.lastIndexOf("，"), label.length());
                userFeatureTv.setText(label);
            }else{
                userFeatureTv.setText("--");
            }

            List<CustomerLabelDetailEntity.LabelBean> purposeLabelDetailList = entity.component3();
            if (purposeLabelDetailList != null) {
                StringBuilder label = new StringBuilder();
                for (CustomerLabelDetailEntity.LabelBean bean : purposeLabelDetailList) {
                    label.append(bean.getLabelName()).append("，");
                }
                label.delete(label.lastIndexOf("，"), label.length());
                bugUseTv.setText(label);
            }else{
                bugUseTv.setText("--");
            }
        }
    }

    @Override
    public void showMemberInfo(MemberInfo memberInfo) {
        SYLoger.print("wgmf--showMemberInfo: " + memberInfo.customerGrade);
        customerGradeTv.setText(memberInfo.customerGrade);
        //默认隐藏,只有请求成功才显示出来
        customerGradeTv.setVisibility(TextUtils.isEmpty(memberInfo.customerGrade) ? View.GONE : View.VISIBLE);
        // "有线上消费，0:无，1:有"
        mMemberLabels.setVisibility(memberInfo.hasOnlineConsumption == 1 ? View.VISIBLE : View.GONE);
        // "是否显示会员商品标签，0:不显示，1:显示"
        mMemberLastBuyLl.setVisibility(isLastBuyShow && memberInfo.showOnlineVipGoods == 1 ? View.VISIBLE : View.GONE);
        customerNameTv.setText(memberInfo.customerName);
        phoneNumTv.setText(memberInfo.customerMobile);
        validPointTv.setText(Html.fromHtml("有效积分\t\t" + "<font color='#ffa019' >" + memberInfo.validPoint + "</font>"));

        isNewWeMember.setText(Html.fromHtml("进塘\t\t\t\t\t\t\t" + "<font color='#ffa019' >" + ("1".equals(memberInfo.inPand) ? "已进塘" : "未进塘") + "</font>"));
        isNewWeMember.setVisibility(View.VISIBLE);

        mGroupUrl = memberInfo.groupUrl;
        joinGroupTv.setText(Html.fromHtml("入群\t\t\t\t\t\t\t" + "<font color='#ffa019' >" + (1 == memberInfo.inGroup ? "已入群" : "未入群") + "</font>"));

        lastBuyProductTv.setText(memberInfo.lastBuyProduct);
        //最近一次的购买会员商品名称
        mMemberLastBuyProductTv.setText(memberInfo.onlineVipGoodsName);
        lastBuyDatetimeTv.setText(MessageFormat.format("{0}天", memberInfo.distanceConsDay));
        //距离最近一次的购买会员商品的时间
        mMemberLastBuyDatetimeTv.setText(MessageFormat.format("{0}天", memberInfo.onlineVipGoodsDisConsDay));
        ImageLoader.loadImgRes(mContext, memberInfo.headImgUrl, memberIconIv);
        Drawable drawable;
        if ("2".equals(memberInfo.customerSex)) {
            drawable = getResources().getDrawable(R.drawable.female);
        } else {
            drawable = getResources().getDrawable(R.drawable.male);
        }
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        customerNameTv.setCompoundDrawables(null, null, drawable, null);

        //以下关于环保装的标记
        if (memberInfo.hasBuyBazhen == 1) {
            //如果买过八珍
            PrefHistoryUtil.saveHistory(AppConstants.ExtraKeys.HAS_BUY_BAZHEN, phoneNum, 1);
        } else {
            PrefHistoryUtil.deleteHistory(AppConstants.ExtraKeys.HAS_BUY_BAZHEN, phoneNum);
        }

        if (memberInfo.hasBuyNewBazhen == 1) {
            //如果买过新八珍
            PrefHistoryUtil.saveHistory(AppConstants.ExtraKeys.HAS_BUY_NEW_BAZHEN, phoneNum, 1);
        } else {
            PrefHistoryUtil.deleteHistory(AppConstants.ExtraKeys.HAS_BUY_NEW_BAZHEN, phoneNum);
        }
        //判断会员状态
        if ((1 == memberInfo.customerStatus || 2 == memberInfo.customerStatus) && !isDialogStatus) {
            isDialogStatus = true;
            String content = AppRetCodeMap.statusDbMap("4002", "该会员已被禁用，无法获得或使用积分，如有疑问请咨询400客服解禁！");
            DialogHelper.AlertNotCanceable(baseAct, "提示",
                    content, null, (dialog, which) -> {
                        dialog.dismiss();
                    });
        }
    }

    /**
     * 刷新显示是否是 是否进塘，0:否，1:是
     *
     * @param weState
     */
    private void refreshIsNewWeMember(WeiXinJiaFenResponse.InnerClass weState) {
//        if(weState != null && weState.customerMobile.equals(phoneNum)){
//            isNewWeMember.setText(Html.fromHtml("新客微会员\t" + "<font color='#ffa019' >" + (weState.isNewWemember == 1? "是" : "否") + "</font>"));
//            isNewWeMember.setVisibility(View.VISIBLE);
//        }else{
//            isNewWeMember.setVisibility(View.GONE);
//        }
    }

    @Override
    public void setPresenter(@NonNull MemberDetailCon.Pre pre) {
        memberDetailPre = pre;
    }

    @Override
    public void widgetsClick(View v) {
        super.widgetsClick(v);
        if (TextUtils.isEmpty(phoneNum)) {
            ToastMsg.showToastMsg(mContext, "请输入手机号码操作!");
            return;
        }
        Bundle bundle = null;
        switch (v.getId()) {
            case customer_grade_tv:
                BaseCookiesWebFra.launch(getActivity(), NetParam.MEMBER_GRADE_DETAIL + phoneNum, "", false);
                break;
            case R.id.customer_name_rl:
                bundle = new Bundle();
                bundle.putString("huiyuan", phoneNum);
                baseAct.interfaceJump(EditDetailActivity.class, bundle, false);
                break;
            case R.id.phone_num_tv:
                if (!"S8-701w".equals(android.os.Build.MODEL)) {
                    IntentUtil.callPhone(phoneNum, mContext);
                } else {
                    ToastMsg.showToastMsg(mContext, "当前设备不支持此功能!");
                }
                break;
            case R.id.valid_point_tv:
                bundle = new Bundle();
                bundle.putString("huiyuan", phoneNum);
                baseAct.interfaceJump(JifenMingXiActivity.class, bundle, false);
                break;
            case R.id.is_new_wemember_tv:
                Intent intent = new Intent(getActivity(), WeMemberDetailAct.class);
                intent.putExtra("phone", phoneNum);
                startActivity(intent);
                break;
            //点击跳转购买明细
            case R.id.last_buy_ll:
            case R.id.member_last_buy_ll:
                bundle = new Bundle();
                bundle.putString(XiaoFeiActivity.MEMBER_ID, phoneNum);
                baseAct.interfaceJump(XiaoFeiActivity.class, bundle, false);
                break;
            case R.id.join_group_btn:
                //跳转到加入群
                showImageTipDialog(mGroupUrl);
                break;
            case R.id.customer_label_info_ll:
                bundle = new Bundle();
                bundle.putString(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                bundle.putSerializable(AppConstants.ExtraKeys.CUSTOMER_LABEL_DETAIL, mCustomerLabelDetailEntity);
                baseAct.interfaceJump(CustomerLabelActivity.class, bundle, false);
                break;
            case R.id.customer_label_ll:
                bundle = new Bundle();
                bundle.putBoolean(AppConstants.ExtraKeys.PAGE_EDIT_STATUS, true);
                bundle.putString(AppConstants.ExtraKeys.PHONE_NUM, phoneNum);
                bundle.putSerializable(AppConstants.ExtraKeys.CUSTOMER_LABEL_DETAIL, mCustomerLabelDetailEntity);
                baseAct.interfaceJump(CustomerLabelActivity.class, bundle, false);
                break;
            default:
                break;
        }
    }

    /**
     * 图片显示
     *
     * @param url 图片地址
     */
    protected void showImageTipDialog(String url) {
        PublicPictureDialog.Builder builder = new PublicPictureDialog.Builder(getActivity());
        builder.setCententLayoutId(R.layout.view_picture_one_dialog);
        builder.setUrl(url);
        builder.setPositiveButton(
                (dialog, which) -> dialog.dismiss());
        if (null != this && !getActivity().isFinishing()) {
            builder.create().show();
        }
    }
}
