package com.wgmf.trade.ui.fra.index

import android.os.Bundle
import com.google.gson.Gson
import com.urovo.wgmf.entity.response.WeiXinJiaFenResponse
import com.urovo.wugumofang.R
import com.urovo.wugumofang.base.BaseActivity
import com.urovo.wugumofang.constants.AppConstants
import com.urovo.wugumofang.data.PreferHelper
import kotlinx.android.synthetic.main.we_member_detail_ll.*

/**
 * @author Sasuke on 2018/6/12.
 */
class WeMemberDetailAct: BaseActivity() {
    var phone: String? = null
    var weMemberEntity: WeiXinJiaFenResponse.InnerClass? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.we_member_detail_ll)
        initTitle()
        init()
    }

    fun init(){
        phone = intent.getStringExtra("phone")
        titleTextView.text = phone
        weMemberEntity = Gson().fromJson(PreferHelper.getInstance().getString(AppConstants.PreKeys.WE_MEMBER_DETAIL), WeiXinJiaFenResponse.InnerClass::class.java)

        //如果缓存是空的，或者缓存里的手机号与传过来的不匹配，那就估计有未知错误了（不过一般不会出现）
        if( weMemberEntity == null || phone != weMemberEntity?.customerMobile){
            showMsg("当前手机号与缓存WE_MEMBER_DETAIL不匹配")
            finish()
        }

        weMember.text = if(weMemberEntity?.url.isNullOrEmpty()) "是" else "否（需扫码加粉）"
        newWeMember.text = if(weMemberEntity?.isNewWemember == 1) "是" else "否${weMemberEntity?.let { "（${it.weMemberDetail}）" }}"
        memberBelong.text = weMemberEntity?.adscription
        firstCodeTime.text = weMemberEntity?.firstScanTime?.takeIf { it.length >= 19 }?.substring(0,19)
        weName.text = weMemberEntity?.nickName

    }
}