package com.wgmf.trade.ui.fra.more.cases

import android.content.Intent
import android.view.View
import com.urovo.wgmf.zxing.CaptureActivity
import com.urovo.wgmf.zxing.Preferences
import com.urovo.wugumofang.data.PreferHelper
import com.urovo.wugumofang.utils.TaskEnqueueDominator
import com.wgmf.trade.ui.fra.index.MemberSalesFra
import com.zsy.libext.widgets.dialog.effectsdialog.EffectsAlertDialog
import com.zsy.libext.widgets.tips.ToastMsg




/**
 * @author Sasuke on 2019/12/3.
 * 到家业务输入订单号情况
 */
class Input2HomeOrderCase(val frag: MemberSalesFra,//这里需要传MemberSalesFra，因为 orderCode 会改变，并且后面组装订单要用
                          val effectsAlertDialog: EffectsAlertDialog,
                          val is2Home: Boolean) : TaskEnqueueDominator.BaseCase() {
    override fun dowork() {
        //如果不是到家情况
        if (!is2Home) {
            enqueDominator?.go()//继续执行队列
            return
        }
        //需要手动输入验证码
        effectsAlertDialog.withTitle("请输入到家业务的订单号！").withInputContent("手动输入或扫描条码", 0, 0).withInputMargin(5, 0, 0, 0).setRightButtonClick(
                View.OnClickListener {
                        var orderCode = effectsAlertDialog.inputStr
                        if (orderCode.isEmpty()) {
                            ToastMsg.showToastMsg(frag.activity, "请输入订单号!")
                            return@OnClickListener
                        }
                        frag.toHomeOrderCode = orderCode
                        enqueDominator?.go()//继续执行队列
                        effectsAlertDialog.dismiss()
                //扫码输入
                }).setScanBtnClick {
                    PreferHelper.getInstance().setBoolean(Preferences.FLAG_TRANSLUCENT_STATUS, true)
                    PreferHelper.getInstance().setString(Preferences.SCAN_BOTTOM, "请对准二维码或条形码,扫二维码时距离不能太近！")
                    frag.startActivityForResult(Intent(frag.activity, CaptureActivity::class.java), 200)
        }.show()
        return
    }
}