package com.wgmf.trade.ui.fra.more.productmanagement;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.AppConstants;
import com.wgmf.trade.model.bean.GoodsInOutStockBean;
import com.wgmf.trade.model.bean.GoodsInOutStockItemDetailBean;
import com.zsy.libcore.ui.ada.helper.ViewHelper;
import com.zsy.libcore.ui.ada.quickadapter.QuickAdapter;
import com.zsy.libext.ui.fra.BaseFra;

import java.util.ArrayList;
import java.util.List;

import androidx.annotation.NonNull;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.Unbinder;

/**
 * 产品出入库明细
 * Created by samy on 17/2/5.
 */
public class GoodsInOutStockDetailFra extends BaseFra {
    @BindView(R.id.list_detail_lv)
    ListView listDetailLv;

    @BindView(R.id.product_name_id_tv)
    TextView productNameIdTv;
    @BindView(R.id.product_uni_tv)
    TextView productUniTv;
    GoodsInOutStockBean goodsInOutStockBean;

    List<GoodsInOutStockItemDetailBean> goodsInOutStockBeanList = new ArrayList<>();

    @Override
    protected void getBundleExtras(Bundle extras) {
        super.getBundleExtras(extras);
        goodsInOutStockBean = (GoodsInOutStockBean) extras.getSerializable(AppConstants.ExtraKeys.GOODS_IN_OUT_STOCK_BEAN);
        goodsInOutStockBeanList = (List<GoodsInOutStockItemDetailBean>) extras.getSerializable(AppConstants.ExtraKeys.GOODS_IN_OUT_STOCK_BEAN_LIST);

    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.act_goods_in_out_stock_detail;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        unbinder.unbind();
    }

    Unbinder unbinder;
    @SuppressLint("SetTextI18n")
    @Override
    protected void initWidgetsAndEvents(View view) {
        unbinder = ButterKnife.bind(this,view);
        baseAct.commonToolbar.setTitle("产品出入库明细");
        listDetailLv.setAdapter(
                new QuickAdapter<GoodsInOutStockItemDetailBean>(R.layout.item_goods_in_out_stock_detail,
                        goodsInOutStockBeanList) {
                    @Override
                    protected void onBindData(Context context, int i, ViewHelper viewHelper, int i1,
                                              GoodsInOutStockItemDetailBean goodsInOutStockDetailBean) {
                        viewHelper.setText(R.id.time_tv, goodsInOutStockDetailBean.proDate);
                        viewHelper.setText(R.id.type_tv, goodsInOutStockDetailBean.proInOutType);
                        viewHelper.setText(R.id.num_tv, goodsInOutStockDetailBean.proInOutNum + "");
                    }
                });
        productNameIdTv.setText(goodsInOutStockBean.proName +"   "+ goodsInOutStockBean.proCode);
        productUniTv.setText("单位:" + goodsInOutStockBean.proUOM);

    }

    @Override
    protected View getLoadingTargetView() {
        return null;
    }

    @Override
    public void setPresenter(@NonNull Object o) {

    }

}
