package com.wgmf.trade.ui.fra.more.setting;

import android.app.Activity;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.urovo.wugumofang.R;
import com.urovo.wugumofang.constants.Files;
import com.urovo.wugumofang.constants.RouterParams;
import com.urovo.wugumofang.system.BaseAppManager;
import com.urovo.wugumofang.utils.MyToast;
import com.urovo.wugumofang.view.webview.FraContainerAct;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentTransaction;
import androidx.fragment.app.ListFragment;

/**
 * 开发者模式
 * 目前有的：
 * 1：应用数据到SD卡
 * 2: 环境切换
 * 3：日志打印开关
 * Created by samy on 16/4/8.
 */
@Route(path = RouterParams.ORIGIN.DEVELOPERMODEFRA)
public class DeveloperModeFra extends ListFragment {
    private ArrayAdapter<String> adapter;
    private List<String> data;
    private Activity activity;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        return super.onCreateView(inflater, container, savedInstanceState);
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        activity = getActivity();
        ((FraContainerAct) activity).commonToolbar.setTitle("调试信息");

        data = Arrays.asList(activity.getResources().getStringArray(R.array.dev_mode_type));

        adapter = new ArrayAdapter<String>(activity, android.R.layout.simple_list_item_1, data);
        setListAdapter(adapter);
    }

    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        super.onListItemClick(l, v, position, id);
        switch (position) {
            case 4://选择服务器
                showAlertDialog(new EnvironmentSwitchFra());
                break;
            case 5://应用数据到SD卡
                copyData();
                break;
             default:
                break;
        }
    }

    /**
     * 弹出对话框
     *
     * @param className
     */
    private void showAlertDialog(DialogFragment className) {
        FragmentTransaction ft = getFragmentManager().beginTransaction();
        Fragment fragment = getFragmentManager().findFragmentByTag(className.getTag());
        if (null != fragment) {
            ft.remove(fragment);
        }
        className.show(ft,className.getTag());
    }




    private void copyData(){
        MyToast.show(getActivity(), "正在复制应用数据到SD卡", Toast.LENGTH_SHORT);
       // Toast.makeText(getActivity(), "正在复制应用数据到SD卡", Toast.LENGTH_SHORT).show();
        try {
            copyFiles(Files.apkDataPath, Files.apkBakPath);
            MyToast.show(getActivity(), "复制文件完毕！", Toast.LENGTH_SHORT);
           // Toast.makeText(getActivity(), "复制文件完毕！", Toast.LENGTH_SHORT).show();
            return;
        }
        catch (Exception e) {

            BaseAppManager.loger().info(e);
            MyToast.show(getActivity(), "复制失败,再试一次！" + e.toString(), Toast.LENGTH_SHORT);
            //Toast.makeText(getActivity(), "复制失败,再试一次！" + e.toString(), Toast.LENGTH_SHORT).show();
        }

        try {
            copyFiles(Files.apkDataPath, Files.apkBakPath2);
            MyToast.show(getActivity(), "复制数据完毕！", Toast.LENGTH_SHORT);
           // Toast.makeText(getActivity(), "复制数据完毕！", Toast.LENGTH_SHORT).show();
        }
        catch (Exception e) {
            BaseAppManager.loger().info(e);
            MyToast.show(getActivity(), "复制失败！" + e.toString(), Toast.LENGTH_SHORT);
            //Toast.makeText(getActivity(), "复制失败！" + e.toString(), Toast.LENGTH_SHORT).show();
        }

    }

    /**
     * 拷贝整个文件夹的方法
     * @param path1
     * @param path2
     * @throws Exception
     */
    public void copyFiles(String path1, String path2) throws Exception {
        File file = new File(path1);
        if(file.isDirectory()) {
            File f = new File(path2);
            if(!f.exists())
                f.mkdir();
            File[] files = file.listFiles();
            for (File file2 : files) {
                copyFiles(file2.toString(), path2 + "/" + file2.getName());
            }

        }
        else {
            copy(path1, path2);
        }
    }

    /**
     * 拷贝单个文件的方法
     * @param path1
     * @param path2
     * @throws IOException
     */
    public void copy(String path1, String path2) throws IOException {
        DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(path1)));
        byte[] date = new byte[in.available()];
        in.read(date);
        DataOutputStream out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path2)));
        out.write(date);
        in.close();
        out.close();

    }
}
