package com.wgmf.trade.view;

import com.urovo.wgmf.db.dao.entitys.ProductEntity;
import com.wgmf.trade.model.bean.MemberAction;
import com.zsy.libcore.presenter.BasePresenter;
import com.zsy.libcore.view.BaseView;

import java.util.List;

/**
 * 会员主页>活动列表
 * 会员主页View和Pre
 * Created by samy on 16/9/7.
 */
public interface MemberActionListCon {

    interface Pre extends BasePresenter {
        /**
         * 获取活动列表(全场和专享)
         *
         * @param isVip    是否是专享
         * @param storeId  店id
         * @param phoneNum 会员手机号
         */
        void getActionList(boolean isVip, String storeId, String phoneNum, String selectTime, boolean isAdditionalRecord);

        /**
         * 查询剩余积分
         *
         * @param phoneNum 会员手机号
         */
        void remainsPoints(float rulePoint, String phoneNum);
    }

    interface View extends BaseView<Pre> {
        /**
         * 现实活动列表(全场，专享)
         *
         * @param isVip 是否专享
         * @return
         */
        void showActionList(boolean isVip, List<MemberAction> memberActions, boolean isAdditionalRecord, String selectTime);

        /**
         * 显示当前剩余积分
         *
         * @param remainsPoints 前剩余积分
         */
        void showRemainsPoints(float rulePoint, float remainsPoints);

    }
}
