package com.wgmf.trade.view;

import com.urovo.activity.customerlabel.model.CustomerLabelDetailEntity;
import com.urovo.activity.customerlabel.model.CustomerLabelEntity;
import com.urovo.wgmf.entity.response.WeiXinJiaFenResponse;
import com.wgmf.trade.model.bean.MemberInfo;
import com.zsy.libcore.presenter.BasePresenter;
import com.zsy.libcore.view.BaseView;

/**
 * 会员信息详情
 *
 * @author samy
 * @date 16/9/12
 */
public interface MemberDetailCon {

    interface View extends BaseView<Pre> {
        /**
         * 现实会员的基本信息
         *
         * @param memberInfo 信息
         */
        void showMemberInfo(MemberInfo memberInfo);

        /**
         * 是否是新客微会员 1是 0不是
         */
        void showIsWeMember(WeiXinJiaFenResponse.InnerClass weInfo);

        /**
         * 标签数据
         */
        void showLabelListDetail(CustomerLabelDetailEntity entity);
    }

    interface Pre extends BasePresenter {
        /**
         * 获取会员基本信息
         *
         * @param userId         顾问ID
         * @param customerMobile 会员手机号
         */
        void getMemberInfo(String userId, String shopId,String customerMobile);


        /**
         * ErWeiMaEntryActivity里的请求，
         * 用于在还没得到请求结果时，就跳到ErWeiMaEntryActivity的界面了，
         * 就再重新请求一下
         */
        void getWeiXibJiaFen(String qrcodeticket,String phoneNo,String staffNo,String storeId);

        /**
         * 获取标签数据
         */
        void getLabelListDetail(String mobile);

    }

}
