package com.wgmf.trade.view;

import com.wgmf.trade.model.bean.MemGoodsOrderBean;
import com.wgmf.trade.model.bean.MemberAction;
import com.wgmf.trade.model.bean.ProductInfoBean;
import com.zsy.libcore.presenter.BasePresenter;
import com.zsy.libcore.view.BaseView;

import java.util.List;

/**
 * 会员主页View和Pre
 * Created by samy on 16/9/7.
 */
public interface MemberSalesCon {

    interface Pre extends BasePresenter {
        /**
         * 验证规则并返回结果集(立享优惠)
         *
         * @param phoneNum   电话号码
         * @param activityId 参加活动Id
         * @param productInfoBeans  产品
         */
        //void enjoyDiscount(String phoneNum, String activityId, String exchangeCode,String orderContext);
        void validRuleResult(String phoneNum, String activityId,  List<ProductInfoBean> productInfoBeans);

        /**
         * 验证码校验
         *
         * @param phoneNum     电话号码
         * @param activityId   参加活动Id
         * @param exchangeCode 校验码
         */
        void checkVerifyCode(String phoneNum, String activityId, String exchangeCode);

        /**
         * 添加订单（现在改成在线提交会员商品订单算了，以前的代码也不知道为什么被注释掉了。）
         *
         */
        void submitMemberGoodsOrder(MemGoodsOrderBean bean,List<ProductInfoBean> proList);


    }

    interface View extends BaseView<Pre> {
        /**
         * 显示立享优惠的数据；
         *
         * @param giftRuleBean 赠品规则
         */
        void showEnjoyDiscount(MemberAction.GiftRuleBean giftRuleBean);

        /**
         * 现实验证码验证的状态
         *
         * @param isSuccess 验证是否成功
         */
        void showCheckCodeState(boolean isSuccess);

        /**
         * 订单提交状态
         *
         * @param wxPayNo 微信二维码支付订单号
         */
        void commitOrderState(String wxPayNo);

        /**
         * 会员商品提交成功
         */

        void memGoodsSumbitSuccess();
        /**
         * 会员商品提交失败
         */
        void memGoodsSumbitFailed(String msgInfo);


    }
}
