package com.wgmf.trade.wx;

import com.taobao.weex.InitConfig;
import com.taobao.weex.WXEnvironment;
import com.taobao.weex.WXSDKEngine;
import com.taobao.weex.common.WXException;
import com.urovo.wugumofang.BuildConfig;
import com.wgmf.trade.wx.ada.ImageAdapter;
import com.wgmf.trade.wx.ada.PlayDebugAdapter;
import com.wgmf.trade.wx.module.AppConfigModule;
import com.wgmf.trade.wx.module.CommonModule;
import com.wgmf.trade.wx.module.IntentModule;
import com.zsy.libext.LibExtApp;

/**
 * Created by samy on 16/8/8.
 * Weex基本类初始化
 */
public class WXApp extends LibExtApp {

  @Override public void onCreate() {
    super.onCreate();
    initWX();
  }

  private void initWX() {
    WXEnvironment.addCustomOptions("appName", BuildConfig.APPLICATION_ID);
    WXSDKEngine.initialize(this,
        new InitConfig.Builder()
            .setImgAdapter(new ImageAdapter())
            .setDebugAdapter(new PlayDebugAdapter())
            .build()
    );

    /**
     * 自定义组件部分注册
     */
    //WXSDKEngine.registerComponent("richtext", RichText.class);

    /**
     * 自定义module部分注册
     */
    try {
      WXSDKEngine.registerModule("commonModule", CommonModule.class);
      WXSDKEngine.registerModule("appConfigModule", AppConfigModule.class);
      WXSDKEngine.registerModule("intentModule", IntentModule.class);
      //WXSDKEngine.registerModule("systemSettingModule", SystemSettingModule.class);
      //WXSDKEngine.registerModule("userInfoModule", UserInfoModule.class);
      //WXSDKEngine.registerModule("experienceEquipmentModule", ExperienceEquipmentModule.class);
    } catch (WXException e) {
      e.printStackTrace();
    }
  }
}
