package com.wgmf.trade.wx.act;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.Uri;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.taobao.weex.WXRenderErrorCode;
import com.taobao.weex.WXSDKEngine;
import com.taobao.weex.WXSDKInstance;
import com.taobao.weex.utils.WXFileUtils;
import com.taobao.weex.utils.WXSoInstallMgrSdk;
import com.urovo.wugumofang.R;

import androidx.localbroadcastmanager.content.LocalBroadcastManager;

/**
 * @author samy
 * @date 16/8/8
 * WX容器加载类
 */
@SuppressWarnings("alll")
public class WXContainerAct extends BaseWXAct {
//    @BindView(R.id.js_container_fl)
    FrameLayout jsContainerFl;
//    @BindView(R.id.render_loading_pb)
    ProgressBar renderLoadingPb;
//    @BindView(R.id.not_support_render_tv)
    TextView notSupportRenderTv;
    private static final String DEFAULT_IP = "your_current_IP";
    //private static String CURRENT_IP = "192.168.0.2"; // your_current_IP
    private static String CURRENT_IP = "your_current_IP";
    private static final String WEEX_INDEX_URL =
            "http://" + CURRENT_IP + ":12580/examples/build/index.js";
    private BroadcastReceiver mReloadReceiver;
    /**
     * 子类WXPageAct不用，这个渲染逻辑；
     */
    protected boolean isWXContainer = true;

    @SuppressWarnings("unused")
    public boolean isWXPage() {
        return isWXPage;
    }

    public void setWXPage(boolean wxpage) {
        isWXPage = wxpage;
    }

    private boolean isWXPage;

    protected String setSelfTitle() {
        return "五谷磨房";
    }

    protected String setJSUrl() {
        return "index.js";
    }

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.act_wx_container;
    }

    @Override
    protected void initWidgetsAndEvents(Bundle bundle) {
        super.initWidgetsAndEvents(bundle);
        if (!TextUtils.isEmpty(setSelfTitle())) {
            baseAct.commonToolbar.setTitle(setSelfTitle());
        } else {
            baseAct.commonToolbar.setVisibility(View.GONE);
        }
        //ButterKnife在这个的基类Activity里不能用了，所以强行用findViewById
        jsContainerFl = findViewById(R.id.js_container_fl);
        renderLoadingPb = findViewById(R.id.render_loading_pb);
        notSupportRenderTv = findViewById(R.id.not_support_render_tv);
        loadRenderView();
    }

    protected void loadRenderView() {
        setContainer(jsContainerFl);

        if (renderLoadingPb != null ){
            renderLoadingPb.setVisibility(View.VISIBLE);
        }
        if (notSupportRenderTv != null){
            notSupportRenderTv.setVisibility(View.VISIBLE);
        }

        if (!WXSoInstallMgrSdk.isCPUSupport()) {
            renderLoadingPb.setVisibility(View.INVISIBLE);
            notSupportRenderTv.setText(R.string.cpu_not_support_tip);
            return;
        }
        if (!isWXPage) {
            if (isWXContainer) {
                if (TextUtils.equals(CURRENT_IP, DEFAULT_IP)) {
                    Uri url = Uri.parse(setJSUrl());
                    if (url != null) {
                        String path = "file".equals(url.getScheme()) ? assembleFilePath(url) : url.toString();
                        renderPage(WXFileUtils.loadAsset(path, this), url.toString());
                    }
                } else {
                    renderPageByURL(WEEX_INDEX_URL);
                }
            }
        }

        mReloadReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                createWeexInstance();
                if (TextUtils.equals(CURRENT_IP, DEFAULT_IP)) {
                    renderPage(WXFileUtils.loadAsset(setJSUrl(), baseAct), WEEX_INDEX_URL);
                } else {
                    renderPageByURL(WEEX_INDEX_URL);
                }
                renderLoadingPb.setVisibility(View.VISIBLE);
            }
        };

        LocalBroadcastManager.getInstance(this)
                .registerReceiver(mReloadReceiver, new IntentFilter(WXSDKEngine.JS_FRAMEWORK_RELOAD));
    }


    @Override
    public void onRenderSuccess(WXSDKInstance wxsdkInstance, int i, int i1) {
        //WXSDKInstance.setSize();
        renderLoadingPb.setVisibility(View.GONE);
        notSupportRenderTv.setVisibility(View.GONE);
    }

    @Override
    public void onException(WXSDKInstance wxsdkInstance, String s, String s1) {
        renderLoadingPb.setVisibility(View.GONE);
        notSupportRenderTv.setVisibility(View.VISIBLE);
        if (TextUtils.equals(s, WXRenderErrorCode.WX_NETWORK_ERROR)) {
            notSupportRenderTv.setText(R.string.index_tip);
        } else {
            notSupportRenderTv.setText(String.format("render error:%s", s1));
        }
    }

    @Override
    public void onDestroy() {
        LocalBroadcastManager.getInstance(this).unregisterReceiver(mReloadReceiver);
        super.onDestroy();
    }
}
