package com.wgmf.trade.wx.act;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Rect;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Toast;
import com.taobao.weex.WXSDKEngine;
import com.taobao.weex.WXSDKInstance;
import com.taobao.weex.appfram.navigator.IActivityNavBarSetter;
import com.taobao.weex.common.IWXDebugProxy;
import com.taobao.weex.utils.WXFileUtils;
import com.wgmf.trade.wx.config.Constants;
import com.wgmf.trade.wx.https.HotRefreshManager;
import com.wgmf.trade.wx.https.WXHttpManager;
import com.wgmf.trade.wx.https.WXHttpTask;
import com.wgmf.trade.wx.https.WXRequestListener;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;

/**
 * 跳转页面容器；（后期得自己定义规则）
 * Created by samy on 16/9/5.
 */
public class WXPageAct extends WXContainerAct implements android.os.Handler.Callback {
  private Uri mUri;
  private HashMap mConfigMap = new HashMap<String, Object>();
  private BroadcastReceiver mReceiver;
  private Handler mWXHandler;

  protected boolean isWXContainer = false;

  @Override protected String setJSUrl() {
//    return mUri.toString();
    return (mUri == null ? "" : mUri.toString());
  }

  @Override protected void getBundleExtras(Bundle extras) {
    super.getBundleExtras(extras);
    setWXPage(true);
    WXSDKEngine.setActivityNavBarSetter(new NavigatorAdapter());
    mUri = getIntent().getData();
    //目前本地处理;
    //mUri = Uri.parse(mUri.toString().substring(6));//http:/

    Bundle bundle = getIntent().getExtras();
    if (mUri == null && bundle == null) {
      mUri = Uri.parse(Constants.BUNDLE_URL + Constants.WEEX_SAMPLES_KEY);
    }
    if (bundle != null) {
      String bundleUrl = bundle.getString(WXSDKInstance.BUNDLE_URL);
      Log.e(TAG_LOG, "bundleUrl==" + bundleUrl);

      if (bundleUrl != null) {
        mConfigMap.put(WXSDKInstance.BUNDLE_URL, bundleUrl + Constants.WEEX_SAMPLES_KEY);
        mUri = Uri.parse(bundleUrl + Constants.WEEX_SAMPLES_KEY);

      }
    } else {
      mConfigMap.put(WXSDKInstance.BUNDLE_URL, mUri.toString() + Constants.WEEX_SAMPLES_KEY);
    }

    if (mUri == null) {
      Toast.makeText(this, "the uri is empty!", Toast.LENGTH_SHORT).show();
      finish();
      return;
    }
  }

  @Override protected void initWidgetsAndEvents(Bundle bundle) {
    super.initWidgetsAndEvents(bundle);
    //baseAct.commonToolbar.setTitle(mUri.toString().substring(mUri.toString().lastIndexOf(File.separator) + 1));
    baseAct.commonToolbar.setVisibility(View.GONE);

    mWXHandler = new Handler(this);
    HotRefreshManager.getInstance().setHandler(mWXHandler);

    if (TextUtils.equals("http", mUri.getScheme()) || TextUtils.equals("https", mUri.getScheme())) {
      String weexTpl = mUri.getQueryParameter(Constants.WEEX_TPL_KEY);
      String url = TextUtils.isEmpty(weexTpl) ? mUri.toString() : weexTpl;
      loadWXfromService(url);
      startHotRefresh();
    } else {
      loadWXfromLocal(false);
    }
    //mInstance.onActivityCreate();
    registerBroadcastReceiver();
  }

  @Override public void onDestroy() {
    super.onDestroy();
    unregisterBroadcastReceiver();
  }

  private void loadWXfromLocal(boolean reload) {
 /*   if (reload && mInstance != null) {
      mInstance.destroy();
      mInstance = null;
    }
    if (mInstance == null) {
      mInstance = new WXSDKInstance(this);
      //        mInstance.setImgLoaderAdapter(new ImageAdapter(this));
      mInstance.registerRenderListener(this);
    }*/
    if (reload){
      createWeexInstance();
    }

    mContainer.post(new Runnable() {
      @Override
      public void run() {
        Rect outRect = new Rect();
        getWindow().getDecorView().getWindowVisibleDisplayFrame(outRect);
        String path = mUri.getScheme().equals("file") ? assembleFilePath(mUri) : mUri.toString();
        renderPage(WXFileUtils.loadAsset(path, baseAct), mUri.toString());
     /*
        Rect outRect = new Rect();
        getWindow().getDecorView().getWindowVisibleDisplayFrame(outRect);
        mConfigMap.put("bundleUrl", mUri.toString());
        String path = mUri.getScheme().equals("file") ? assembleFilePath(mUri) : mUri.toString();
        mInstance.render(TAG, WXFileUtils.loadAsset(path, WXPageActivity.this),
            mConfigMap, null,
            ScreenUtil.getDisplayWidth(WXPageActivity.this), ScreenUtil
                .getDisplayHeight(WXPageActivity.this),
            WXRenderStrategy.APPEND_ASYNC);
      */
      }
    });
  }

  private void loadWXfromService(final String url) {
    renderLoadingPb.setVisibility(View.VISIBLE);
    /*
    if (mInstance != null) {
      mInstance.destroy();
    }

    mInstance = new WXSDKInstance(this);
    mInstance.registerRenderListener(this);
    */
    createWeexInstance();

    WXHttpTask httpTask = new WXHttpTask();
    httpTask.url = url;
    httpTask.requestListener = new WXRequestListener() {

      @Override
      public void onSuccess(WXHttpTask task) {
        Log.e(TAG_LOG, "into--[http:onSuccess] url:" + url);
        try {
          //如果是公用的话，这个configMap是没有必要的；
          mConfigMap.put(WXSDKInstance.BUNDLE_URL, url);

          //mInstance.render(TAG_LOG, new String(task.response.data, "utf-8"), mConfigMap, null, ScreenUtil.getDisplayWidth(WXPageActivity.this), ScreenUtil.getDisplayHeight(WXPageActivity.this), WXRenderStrategy.APPEND_ASYNC);
          renderPage(new String(task.response.data, "utf-8"),url);
        } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
        }
      }

      @Override
      public void onError(WXHttpTask task) {
        Log.e(TAG_LOG, "into--[http:onError]");
        renderLoadingPb.setVisibility(View.GONE);
        Toast.makeText(getApplicationContext(), "network error!", Toast.LENGTH_SHORT).show();
      }
    };

    WXHttpManager.getInstance().sendRequest(httpTask);
  }


  /**
   * hot refresh
   */
  private void startHotRefresh() {
    try {
      String host = new URL(mUri.toString()).getHost();
      String wsUrl = "ws://" + host + ":8082";
      mWXHandler.obtainMessage(Constants.HOT_REFRESH_CONNECT, 0, 0, wsUrl).sendToTarget();
    } catch (MalformedURLException e) {
      e.printStackTrace();
    }
  }



  @Override
  public boolean handleMessage(Message msg) {
    switch (msg.what) {
      case Constants.HOT_REFRESH_CONNECT:
        HotRefreshManager.getInstance().connect(msg.obj.toString());
        break;
      case Constants.HOT_REFRESH_DISCONNECT:
        HotRefreshManager.getInstance().disConnect();
        break;
      case Constants.HOT_REFRESH_REFRESH:
        loadWXfromService(mUri.toString());
        break;
      case Constants.HOT_REFRESH_CONNECT_ERROR:
        Toast.makeText(this, "hot refresh connect error!", Toast.LENGTH_SHORT).show();
        break;
    }

    return false;
  }

  public class RefreshBroadcastReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
      if (IWXDebugProxy.ACTION_DEBUG_INSTANCE_REFRESH.equals(intent.getAction())) {
        Log.v(TAG_LOG, "connect to debug server success");
        if (mUri != null) {
          if (TextUtils.equals(mUri.getScheme(), "http") || TextUtils.equals(mUri.getScheme(), "https")) {
            loadWXfromService(mUri.toString());
          } else {
            loadWXfromLocal(true);
          }
        }
      }
    }
  }


  private void registerBroadcastReceiver() {
    mReceiver = new RefreshBroadcastReceiver();
    IntentFilter filter = new IntentFilter();
    filter.addAction(IWXDebugProxy.ACTION_DEBUG_INSTANCE_REFRESH);
    registerReceiver(mReceiver, filter);
  }

  private void unregisterBroadcastReceiver() {
    if (mReceiver != null) {
      unregisterReceiver(mReceiver);
    }
  }


  private class NavigatorAdapter implements IActivityNavBarSetter {

    @Override
    public boolean push(String param) {
      return false;
    }

    @Override
    public boolean pop(String param) {
      return false;
    }

    @Override
    public boolean setNavBarRightItem(String param) {
      return false;
    }

    @Override
    public boolean clearNavBarRightItem(String param) {
      return false;
    }

    @Override
    public boolean setNavBarLeftItem(String param) {
      return false;
    }

    @Override
    public boolean clearNavBarLeftItem(String param) {
      return false;
    }

    @Override
    public boolean setNavBarMoreItem(String param) {
      return false;
    }

    @Override
    public boolean clearNavBarMoreItem(String param) {
      return false;
    }

    @Override
    public boolean setNavBarTitle(String param) {
      return false;
    }
  }
}
