//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.urovo.activity.user.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;

import com.zsy.libcore.ui.ada.helper.ViewHelper;

import java.util.ArrayList;
import java.util.List;

public abstract class QuickExpandListAdapter<Group, Child> extends BaseExpandableListAdapter {
    private List<IExpandListItem<Group, Child>> mItems;
    private int mGroupLayoutId;
    private int mChildLayoutId;

    public QuickExpandListAdapter(int groupLayoutId, int childLayoutId, List<IExpandListItem<Group, Child>> mItems) {
        this.mItems = mItems != null ? new ArrayList(mItems) : new ArrayList();
        if (groupLayoutId > 0 && childLayoutId > 0) {
            this.mGroupLayoutId = groupLayoutId;
            this.mChildLayoutId = childLayoutId;
        } else {
            throw new IllegalArgumentException();
        }
    }

    public int getGroupCount() {
//        SYLoger.print("chenji--" + "getGroupCount--" + this.mItems.size());
        return this.mItems.size();
    }

    public int getChildrenCount(int groupPosition) {
        List children = ((IExpandListItem) this.mItems.get(groupPosition)).getChildren();
//        SYLoger.print("chenji--" + "getChildrenCount--" + (children != null ? children.size() : 0));
        return children != null ? children.size() : 0;
    }

    public void setData(List<IExpandListItem<Group, Child>> mItems) {
        this.mItems = mItems;
        this.notifyDataSetChanged();
    }

    public Group getGroup(int groupPosition) {
        return this.mItems.get(groupPosition).getGroup();
    }

    public Child getChild(int groupPosition, int childPosition) {
        return (this.mItems.get(groupPosition)).getChildren().get(childPosition);
    }

    public long getGroupId(int groupPosition) {
        return (long) groupPosition;
    }

    public long getChildId(int groupPosition, int childPosition) {
        return (long) childPosition;
    }

    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
        Context context = parent.getContext();
        ViewHelper helper;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(this.mGroupLayoutId, parent, false);
            helper = new ViewHelper(convertView);
            convertView.setTag(helper);
        }

        helper = (ViewHelper) convertView.getTag();
        this.onBindGroupData(context, groupPosition, this.getGroup(groupPosition), isExpanded, helper);
        return convertView;
    }

    protected abstract void onBindGroupData(Context var1, int var2, Group var3, boolean var4, ViewHelper var5);

    public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        Context context = parent.getContext();
        ViewHelper helper;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(this.mChildLayoutId, parent, false);
            helper = new ViewHelper(convertView);
            convertView.setTag(helper);
        }

        helper = (ViewHelper) convertView.getTag();
        this.onBindChildData(context, groupPosition, childPosition, isLastChild, this.getChild(groupPosition, childPosition), helper);
        return convertView;
    }

    protected abstract void onBindChildData(Context var1, int var2, int var3, boolean var4, Child var5, ViewHelper var6);

    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return false;
    }

    public boolean hasStableIds() {
        return false;
    }

    public interface IExpandListItem<Group, Child> {
        List<Child> getChildren();

        Group getGroup();
    }
}
